/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * This is GNU Go, a Go program. Contact gnugo@gnu.org, or see       *
 * http://www.gnu.org/software/gnugo/ for more information.          *
 *                                                                   *
 * Copyright 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007,   *
 * 2008 and 2009 by the Free Software Foundation.                    *
 *                                                                   *
 * This program is free software; you can redistribute it and/or     *
 * modify it under the terms of the GNU General Public License as    *
 * published by the Free Software Foundation - version 3 or          *
 * (at your option) any later version.                               *
 *                                                                   *
 * This program is distributed in the hope that it will be useful,   *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
 * GNU General Public License in file COPYING for more details.      *
 *                                                                   *
 * You should have received a copy of the GNU General Public         *
 * License along with this program; if not, write to the Free        *
 * Software Foundation, Inc., 51 Franklin Street, Fifth Floor,       *
 * Boston, MA 02111, USA.                                            *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#include <stdio.h> /* for NULL */
#include "liberty.h"
#include "patterns.h"

static struct patval pat0[] = {
  {722,1},	{795,2},	{684,2},	{758,0},
  {759,0},	{796,0}
};

static struct patval pat1[] = {
  {649,1},	{684,1},	{685,2},	{611,2}
};

static struct patval pat2[] = {
  {722,1},	{648,1},	{686,2},	{684,2}
};

static struct patval pat3[] = {
  {759,1},	{685,1},	{723,2},	{684,2}
};

static struct patval pat4[] = {
  {758,1},	{684,1},	{722,2},	{757,0}
};

static struct patval pat5[] = {
  {684,1},	{685,2},	{758,2},	{721,2},
  {720,3},	{794,3},	{757,3},	{795,0},
  {759,0},	{796,0}
};

static struct patval pat6[] = {
  {685,1},	{721,1},	{684,2},	{759,0},
  {723,0}
};

static struct patval pat7[] = {
  {684,1},	{724,1},	{685,1},	{648,2},
  {612,2},	{686,2},	{722,3},	{723,0},
  {649,0}
};

static struct patval pat8[] = {
  {723,1},	{648,1},	{684,2},	{685,2},
  {686,0},	{649,0}
};

static struct patval pat9[] = {
  {758,1},	{686,1},	{684,2},	{759,0},
  {723,0},	{760,0}
};

static struct patval pat10[] = {
  {758,1},	{686,1},	{684,2},	{759,0},
  {723,0},	{760,0}
};

static struct patval pat11[] = {
  {684,1},	{649,1},	{685,2},	{610,4}
};

static struct patval pat12[] = {
  {649,1},	{684,1},	{611,2},	{686,2}
};

static struct patval pat13[] = {
  {686,1},	{722,1},	{723,2},	{684,2}
};

static struct patval pat14[] = {
  {686,1},	{722,1},	{723,2},	{684,2}
};

static struct patval pat15[] = {
  {649,1},	{684,2},	{724,2},	{687,2},
  {686,0},	{723,0}
};

static struct patval pat16[] = {
  {684,1},	{759,1},	{758,2},	{648,2}
};

static struct patval pat17[] = {
  {684,1},	{759,1},	{758,2},	{686,2},
  {723,3}
};

static struct patval pat18[] = {
  {684,1},	{759,1},	{758,2},	{649,2},
  {686,0}
};

static struct patval pat19[] = {
  {648,1},	{684,2},	{687,2},	{650,2},
  {649,0},	{686,0},	{723,0},	{724,0}
};

static struct patval pat20[] = {
  {760,1},	{684,2},	{724,2},	{649,0},
  {686,0},	{723,0},	{687,0}
};

static struct patval pat21[] = {
  {684,1},	{724,1},	{760,2},	{649,2},
  {759,2},	{686,0},	{723,0}
};

static struct patval pat22[] = {
  {759,1},	{649,1},	{724,2},	{684,2},
  {686,0},	{723,0},	{760,0},	{687,0}
};

static struct patval pat23[] = {
  {649,1},	{759,1},	{758,2},	{684,2},
  {724,2},	{686,0},	{723,0},	{760,0},
  {687,0}
};

static struct patval pat24[] = {
  {684,1},	{722,1},	{724,1},	{685,2},
  {760,2},	{759,2},	{649,2},	{686,0},
  {723,0}
};

static struct patval pat25[] = {
  {684,1},	{723,1},	{758,2},	{649,2},
  {760,2},	{759,0},	{686,0}
};

static struct patval pat26[] = {
  {684,1},	{723,1},	{760,2},	{649,2},
  {796,2},	{758,4},	{759,0},	{686,0}
};

static struct patval pat27[] = {
  {722,1},	{684,2},	{759,2},	{795,2},
  {758,0},	{757,0}
};

static struct patval pat28[] = {
  {686,1},	{795,1},	{684,2},	{799,2},
  {834,4},	{796,0},	{758,0},	{723,0},
  {760,0},	{797,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{759,0}
};

static struct patval pat29[] = {
  {611,1},	{684,2},	{612,2},	{649,0}
};

static struct patval pat30[] = {
  {648,1},	{686,2},	{684,2},	{722,2},
  {723,0}
};

static struct patval pat31[] = {
  {648,1},	{686,2},	{684,2},	{722,2},
  {723,0}
};

static struct patval pat32[] = {
  {684,1},	{686,1},	{722,1},	{648,2},
  {723,0}
};

static struct patval pat33[] = {
  {684,1},	{723,1},	{721,2},	{796,3},
  {759,0},	{758,0},	{686,0}
};

static struct patval pat34[] = {
  {759,1},	{795,2},	{684,2},	{794,0},
  {758,0},	{757,0}
};

static struct patval pat35[] = {
  {760,1},	{686,1},	{759,1},	{684,2},
  {724,2},	{723,0}
};

static struct patval pat36[] = {
  {723,1},	{684,2},	{724,2},	{722,2},
  {797,3},	{649,3},	{648,4},	{721,4},
  {686,0},	{760,0},	{687,0},	{759,0}
};

static struct patval pat37[] = {
  {759,1},	{723,1},	{684,2},	{724,2},
  {722,2},	{721,4},	{648,4},	{760,0},
  {687,0},	{686,0}
};

static struct patval pat38[] = {
  {723,1},	{761,1},	{724,2},	{684,2},
  {722,2},	{721,4},	{648,4},	{759,0},
  {760,0},	{687,0},	{686,0}
};

static struct patval pat39[] = {
  {685,1},	{686,2},	{684,2},	{723,0}
};

static struct patval pat40[] = {
  {685,1},	{759,1},	{648,1},	{686,2},
  {684,2},	{722,2},	{758,3},	{723,0}
};

static struct patval pat41[] = {
  {684,1},	{721,1},	{723,1},	{648,2},
  {759,2},	{649,4},	{686,0}
};

static struct patval pat42[] = {
  {758,1},	{760,1},	{684,2},	{834,2},
  {832,2},	{686,2},	{685,4},	{722,4},
  {796,4},	{833,4},	{759,0},	{723,0},
  {797,0},	{795,0}
};

static struct patval pat43[] = {
  {684,1},	{723,1},	{721,2},	{686,0}
};

static struct patval pat44[] = {
  {723,1},	{685,1},	{758,1},	{722,2},
  {684,2},	{759,0},	{760,0}
};

static struct patval pat45[] = {
  {722,1},	{759,1},	{795,1},	{796,2},
  {684,2},	{758,2},	{794,0},	{757,0}
};

static struct patval pat46[] = {
  {686,1},	{684,1},	{721,2},	{723,2},
  {649,2}
};

static struct patval pat47[] = {
  {685,1},	{574,1},	{684,1},	{649,2},
  {612,2},	{611,0},	{573,0},	{610,0}
};

static struct patval pat48[] = {
  {684,1},	{760,1},	{686,2},	{685,2},
  {759,0},	{758,0},	{723,0}
};

static struct patval pat49[] = {
  {612,1},	{684,1},	{574,2},	{611,0},
  {610,0},	{649,0},	{686,0}
};

static struct patval pat50[] = {
  {684,1},	{686,1},	{649,2},	{611,2},
  {612,4},	{610,4},	{723,0}
};

static struct patval pat51[] = {
  {722,1},	{759,2},	{684,2},	{795,2},
  {758,0}
};

static struct patval pat52[] = {
  {721,1},	{684,2},	{796,2},	{758,0},
  {759,0},	{795,0}
};

static struct patval pat53[] = {
  {721,1},	{684,2},	{796,2},	{797,4},
  {760,4},	{759,0},	{758,0},	{686,0},
  {723,0}
};

static struct patval pat54[] = {
  {684,1},	{721,1},	{760,1},	{685,2},
  {758,2},	{759,0}
};

static struct patval pat55[] = {
  {721,1},	{684,2},	{758,2},	{759,0},
  {723,0}
};

static struct patval pat56[] = {
  {684,1},	{758,1},	{721,2},	{759,0},
  {723,0}
};

static struct patval pat57[] = {
  {684,1},	{721,2},	{612,2},	{723,2},
  {759,4},	{611,0},	{649,0},	{686,0},
  {650,0},	{687,0}
};

static struct patval pat58[] = {
  {684,1},	{685,1},	{796,1},	{761,2},
  {722,2},	{759,0},	{795,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{687,0},
  {724,0},	{758,0},	{798,0}
};

static struct patval pat59[] = {
  {684,1},	{723,1},	{760,2},	{649,2},
  {759,2},	{686,0}
};

static struct patval pat60[] = {
  {684,1},	{686,1},	{723,1},	{722,2},
  {759,2},	{649,2},	{760,2}
};

static struct patval pat61[] = {
  {684,1},	{796,1},	{685,1},	{795,2},
  {758,2},	{759,0},	{686,0},	{723,0},
  {760,0}
};

static struct patval pat62[] = {
  {758,1},	{686,1},	{684,2},	{760,2},
  {759,0},	{723,0}
};

static struct patval pat63[] = {
  {723,1},	{648,1},	{684,2},	{685,2},
  {686,0},	{649,0}
};

static struct patval pat64[] = {
  {684,2},	{760,2},	{686,3},	{759,0},
  {758,0},	{723,0}
};

static struct patval pat65[] = {
  {684,1},	{612,1},	{686,2},	{613,3},
  {721,3},	{610,0},	{649,0},	{611,0}
};

static struct patval pat66[] = {
  {651,1},	{684,1},	{687,2},	{613,2},
  {611,2},	{610,0},	{612,0},	{649,0},
  {686,0},	{723,0},	{650,0},	{724,0}
};

static struct patval pat67[] = {
  {685,1},	{686,1},	{758,1},	{684,2},
  {760,2},	{759,0},	{723,0}
};

static struct patval pat68[] = {
  {686,1},	{759,1},	{761,2},	{684,2},
  {649,0},	{758,0},	{723,0},	{760,0},
  {650,0},	{687,0},	{724,0}
};

static struct patval pat69[] = {
  {721,1},	{723,1},	{760,2},	{758,2},
  {684,2},	{686,4},	{759,0}
};

static struct patval pat70[] = {
  {685,1},	{759,1},	{686,2},	{684,2},
  {758,3},	{723,0},	{760,0}
};

static struct patval pat71[] = {
  {685,1},	{759,1},	{686,2},	{684,2},
  {758,3},	{723,0},	{760,0}
};

static struct patval pat72[] = {
  {721,1},	{795,1},	{684,2},	{722,2},
  {757,0},	{758,0},	{794,0},	{759,0},
  {796,0},	{686,0},	{723,0},	{760,0}
};

static struct patval pat73[] = {
  {684,1},	{760,1},	{649,2},	{724,2},
  {759,2},	{648,4},	{723,0},	{686,0},
  {687,0}
};

static struct patval pat74[] = {
  {722,1},	{685,1},	{684,2},	{759,2},
  {648,2},	{758,0}
};

static struct patval pat75[] = {
  {722,1},	{685,1},	{684,2},	{759,2},
  {648,2},	{758,0}
};

static struct patval pat76[] = {
  {685,1},	{684,2},	{537,2},	{612,2},
  {573,0},	{574,0},	{611,0},	{536,0},
  {538,0},	{575,0},	{610,0}
};

static struct patval pat77[] = {
  {685,1},	{574,2},	{612,2},	{684,2},
  {610,0},	{611,0},	{573,0},	{575,0}
};

static struct patval pat78[] = {
  {684,1},	{723,1},	{722,2},	{686,0}
};

static struct patval pat79[] = {
  {721,1},	{649,1},	{684,2},	{722,2},
  {611,2},	{686,4},	{610,0}
};

static struct patval pat80[] = {
  {648,1},	{649,1},	{686,1},	{723,2},
  {684,2},	{685,2},	{758,3},	{795,3},
  {796,0},	{759,0},	{760,0},	{797,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {798,0}
};

static struct patval pat81[] = {
  {685,1},	{758,1},	{722,2},	{684,2}
};

static struct patval pat82[] = {
  {685,1},	{758,1},	{723,2},	{684,2},
  {722,2}
};

static struct patval pat83[] = {
  {758,1},	{648,1},	{721,1},	{684,2},
  {722,2},	{759,0},	{649,0},	{686,0},
  {723,0}
};

static struct patval pat84[] = {
  {723,1},	{685,1},	{797,2},	{684,2},
  {795,0},	{759,0},	{796,0},	{760,0},
  {758,0}
};

static struct patval pat85[] = {
  {684,1},	{798,1},	{721,2},	{761,2},
  {759,2},	{685,2},	{797,2},	{760,0},
  {723,0}
};

static struct patval pat86[] = {
  {684,1},	{724,1},	{761,1},	{687,1},
  {760,1},	{759,2},	{649,2},	{685,2},
  {721,2},	{723,0},	{686,0}
};

static struct patval pat87[] = {
  {796,1},	{684,1},	{795,2},	{685,2},
  {757,4},	{759,0},	{758,0},	{723,0}
};

static struct patval pat88[] = {
  {796,1},	{684,1},	{685,2},	{759,2},
  {795,2},	{757,4},	{758,0},	{723,0}
};

static struct patval pat89[] = {
  {722,1},	{649,1},	{724,2},	{684,2},
  {686,0},	{723,0},	{650,0},	{687,0}
};

static struct patval pat90[] = {
  {758,1},	{833,2},	{684,2},	{795,2},
  {759,0},	{796,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0}
};

static struct patval pat91[] = {
  {758,1},	{721,1},	{684,2},	{795,2},
  {685,2},	{833,2},	{759,0},	{796,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0}
};

static struct patval pat92[] = {
  {684,1},	{759,2},	{648,2},	{649,0},
  {686,0},	{723,0},	{760,0}
};

static struct patval pat93[] = {
  {759,1},	{648,1},	{684,2},	{649,0},
  {686,0},	{723,0},	{760,0}
};

static struct patval pat94[] = {
  {759,1},	{648,1},	{758,2},	{684,2},
  {649,0},	{686,0},	{723,0},	{760,0}
};

static struct patval pat95[] = {
  {648,1},	{758,1},	{684,2},	{759,0},
  {649,0},	{686,0},	{723,0},	{760,0}
};

static struct patval pat96[] = {
  {684,1},	{648,2},	{758,2},	{759,0},
  {649,0},	{686,0},	{723,0},	{760,0}
};

static struct patval pat97[] = {
  {759,1},	{723,2},	{684,2},	{833,2},
  {758,3},	{795,3},	{794,3},	{757,3},
  {796,0},	{686,0},	{760,0},	{797,0},
  {834,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{835,0}
};

static struct patval pat98[] = {
  {722,1},	{648,1},	{612,2},	{684,2},
  {649,0},	{686,0}
};

static struct patval pat99[] = {
  {721,1},	{684,2},	{797,2},	{798,2},
  {758,0},	{759,0},	{796,0},	{649,0},
  {686,0},	{723,0},	{760,0},	{650,0},
  {687,0},	{724,0},	{761,0}
};

static struct patval pat100[] = {
  {722,1},	{721,1},	{798,2},	{685,2},
  {684,2},	{797,2},	{758,0},	{759,0},
  {686,0},	{723,0},	{760,0},	{649,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {796,0}
};

static struct patval pat101[] = {
  {611,1},	{758,1},	{721,1},	{684,2},
  {796,3},	{759,3},	{610,0},	{612,0},
  {649,0},	{686,0},	{723,0},	{760,0}
};

static struct patval pat102[] = {
  {684,1},	{721,1},	{796,1},	{758,2},
  {722,2},	{759,0}
};

static struct patval pat103[] = {
  {611,1},	{684,2},	{612,2},	{722,2},
  {649,0},	{686,0},	{723,0}
};

static struct patval pat104[] = {
  {684,1},	{759,1},	{721,2},	{686,0},
  {723,0},	{760,0}
};

static struct patval pat105[] = {
  {686,1},	{723,1},	{722,1},	{684,2},
  {649,2},	{685,2},	{575,4},	{574,0},
  {612,0},	{611,0},	{610,0},	{576,0},
  {613,0},	{650,0},	{687,0},	{724,0}
};

static struct patval pat106[] = {
  {686,1},	{723,1},	{722,1},	{684,2},
  {649,2},	{685,2},	{575,4},	{574,0},
  {612,0},	{611,0},	{610,0},	{576,0},
  {613,0},	{650,0},	{687,0},	{724,0}
};

static struct patval pat107[] = {
  {759,1},	{721,2},	{723,2},	{760,2},
  {684,2},	{686,0}
};

static struct patval pat108[] = {
  {684,1},	{795,1},	{833,1},	{758,2},
  {796,3},	{759,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0}
};

static struct patval pat109[] = {
  {684,1},	{724,1},	{723,2},	{648,3},
  {686,0},	{650,0},	{687,0},	{649,0}
};

static struct patval pat110[] = {
  {687,1},	{684,1},	{724,1},	{722,2},
  {649,0},	{686,0},	{723,0},	{650,0}
};

static struct patval pat111[] = {
  {758,1},	{684,1},	{721,2},	{757,4},
  {683,4},	{759,0},	{686,0},	{723,0},
  {760,0}
};

static struct patval pat112[] = {
  {722,1},	{648,1},	{685,2},	{684,2},
  {649,0},	{686,0},	{723,0},	{650,0},
  {687,0},	{724,0}
};

static struct patval pat113[] = {
  {721,1},	{758,2},	{684,2},	{757,3},
  {683,3},	{759,0},	{686,0},	{723,0},
  {760,0}
};

static struct patval pat114[] = {
  {684,1},	{685,1},	{648,2},	{722,2},
  {649,0},	{686,0},	{723,0},	{650,0},
  {687,0},	{724,0}
};

static struct patval pat115[] = {
  {685,1},	{686,1},	{758,1},	{684,2},
  {722,2},	{759,0},	{723,0},	{760,0}
};

static struct patval pat116[] = {
  {685,1},	{686,1},	{758,1},	{684,2},
  {722,2},	{759,0},	{723,0},	{760,0}
};

static struct patval pat117[] = {
  {684,1},	{759,1},	{685,1},	{758,2},
  {722,2},	{760,2},	{649,0},	{686,0},
  {723,0},	{650,0},	{687,0},	{724,0},
  {761,0}
};

static struct patval pat118[] = {
  {758,1},	{796,1},	{722,1},	{684,2},
  {685,2},	{795,2},	{759,2},	{833,2},
  {686,4},	{723,0},	{760,0},	{797,0},
  {834,0}
};

static struct patval pat119[] = {
  {684,1},	{796,1},	{795,2},	{832,4},
  {759,0},	{758,0},	{833,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0}
};

static struct patval pat120[] = {
  {722,1},	{648,1},	{684,2},	{649,0},
  {686,0},	{723,0}
};

static struct patval pat121[] = {
  {722,1},	{684,1},	{833,2},	{685,2},
  {795,2},	{758,0},	{759,0},	{796,0},
  {757,0},	{686,0},	{723,0},	{760,0},
  {797,0},	{834,0}
};

static struct patval pat122[] = {
  {684,1},	{759,1},	{721,2},	{686,0},
  {723,0},	{760,0}
};

static struct patval pat123[] = {
  {649,1},	{723,1},	{685,1},	{722,2},
  {684,2},	{648,2},	{686,0}
};

static struct patval pat124[] = {
  {684,1},	{648,1},	{686,1},	{722,1},
  {649,2},	{723,2}
};

static struct patval pat125[] = {
  {684,1},	{648,1},	{722,1},	{685,2},
  {649,2},	{723,2},	{686,0}
};

static struct patval pat126[] = {
  {649,1},	{723,1},	{648,2},	{722,2},
  {684,2},	{686,2}
};

static struct patval pat127[] = {
  {611,1},	{722,1},	{684,2},	{721,2},
  {610,0},	{612,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{613,0},	{650,0},
  {687,0},	{724,0},	{761,0}
};

static struct patval pat128[] = {
  {611,1},	{722,1},	{686,1},	{721,2},
  {685,2},	{684,2},	{612,0},	{649,0},
  {610,0},	{723,0},	{760,0},	{613,0},
  {650,0},	{687,0},	{724,0},	{761,0}
};

static struct patval pat129[] = {
  {685,1},	{796,1},	{795,1},	{684,2},
  {721,4},	{758,0},	{759,0}
};

static struct patval pat130[] = {
  {723,1},	{613,1},	{684,2},	{649,2},
  {611,0},	{612,0},	{686,0},	{610,0},
  {650,0},	{687,0},	{724,0},	{614,0},
  {651,0},	{688,0},	{725,0}
};

static struct patval pat131[] = {
  {795,1},	{759,1},	{833,2},	{758,2},
  {684,2},	{794,0},	{757,0},	{796,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {687,0},	{724,0},	{761,0},	{798,0}
};

static struct patval pat132[] = {
  {684,1},	{685,1},	{795,1},	{758,2},
  {759,0},	{796,0}
};

static struct patval pat133[] = {
  {684,1},	{685,1},	{758,1},	{795,1},
  {721,2},	{759,0}
};

static struct patval pat134[] = {
  {759,1},	{648,1},	{684,2},	{758,0},
  {649,0},	{686,0},	{723,0},	{760,0},
  {650,0},	{687,0},	{724,0},	{761,0}
};

static struct patval pat135[] = {
  {686,1},	{648,1},	{759,1},	{685,2},
  {684,2},	{758,0},	{649,0},	{723,0},
  {760,0},	{650,0},	{687,0},	{724,0},
  {761,0}
};

static struct patval pat136[] = {
  {684,1},	{795,1},	{721,2},	{757,3},
  {758,0},	{759,0},	{796,0},	{649,0},
  {686,0},	{723,0},	{760,0},	{797,0}
};

static struct patval pat137[] = {
  {611,1},	{722,1},	{648,2},	{684,2},
  {573,0},	{610,0},	{575,0},	{612,0},
  {649,0},	{686,0},	{723,0},	{576,0},
  {613,0},	{650,0},	{687,0},	{724,0}
};

static struct patval pat138[] = {
  {722,1},	{686,1},	{611,1},	{684,2},
  {685,2},	{612,0},	{649,0},	{723,0},
  {760,0},	{613,0},	{650,0},	{687,0},
  {724,0},	{761,0}
};

static struct patval pat139[] = {
  {722,1},	{611,1},	{684,2},	{648,2},
  {758,0},	{610,0},	{759,0},	{612,0},
  {649,0},	{686,0},	{723,0},	{760,0},
  {613,0},	{650,0},	{687,0},	{724,0},
  {761,0}
};

static struct patval pat140[] = {
  {722,1},	{649,1},	{648,2},	{684,2},
  {611,0},	{612,0},	{686,0},	{723,0},
  {613,0},	{650,0},	{687,0},	{724,0}
};

static struct patval pat141[] = {
  {684,1},	{796,1},	{758,2},	{759,0}
};

static struct patval pat142[] = {
  {685,1},	{611,2},	{759,2},	{684,2},
  {612,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{613,0},	{650,0},	{687,0},
  {724,0},	{761,0}
};

static struct patval pat143[] = {
  {758,1},	{685,2},	{684,2},	{832,2},
  {795,0},	{759,0},	{796,0},	{833,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{835,0}
};

static struct patval pat144[] = {
  {795,1},	{684,1},	{796,1},	{721,2},
  {758,0},	{759,0}
};

static struct patval pat145[] = {
  {686,1},	{649,1},	{759,1},	{648,1},
  {685,2},	{723,2},	{684,2},	{758,0},
  {760,0},	{650,0},	{687,0},	{724,0},
  {761,0}
};

static struct patval pat146[] = {
  {686,1},	{649,1},	{759,1},	{648,1},
  {685,2},	{723,2},	{684,2},	{758,0},
  {760,0},	{650,0},	{687,0},	{724,0},
  {761,0}
};

static struct patval pat147[] = {
  {833,1},	{685,1},	{759,1},	{795,2},
  {758,2},	{684,2},	{721,4},	{796,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0}
};

static struct patval pat148[] = {
  {684,1},	{648,2},	{797,2},	{759,0},
  {796,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{651,0},	{688,0},
  {725,0},	{762,0},	{799,0}
};

static struct patval pat149[] = {
  {684,1},	{685,1},	{648,2},	{722,2},
  {649,0},	{686,0},	{723,0},	{650,0},
  {687,0},	{724,0}
};

static struct patval pat150[] = {
  {758,1},	{722,1},	{684,2},	{796,2},
  {794,3},	{795,3},	{720,3},	{757,3},
  {759,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{797,0}
};

static struct patval pat151[] = {
  {758,1},	{832,2},	{684,2},	{759,2},
  {720,3},	{831,4},	{683,4},	{757,0},
  {795,0},	{794,0},	{796,0},	{833,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0}
};

static struct patval pat152[] = {
  {758,1},	{721,1},	{684,2},	{759,2},
  {832,2},	{795,0},	{796,0},	{833,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0}
};

static struct patval pat153[] = {
  {758,1},	{721,1},	{684,2},	{722,2},
  {832,2},	{795,0},	{759,0},	{796,0},
  {833,0},	{686,0},	{723,0},	{760,0},
  {797,0},	{834,0}
};

static struct patval pat154[] = {
  {758,1},	{795,2},	{684,2},	{833,4},
  {832,4},	{759,0},	{796,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0}
};

static struct patval pat155[] = {
  {648,1},	{721,1},	{723,2},	{684,2},
  {796,2},	{758,3},	{759,0},	{649,0},
  {686,0},	{760,0},	{797,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{798,0}
};

static struct patval pat156[] = {
  {721,1},	{684,2},	{648,2},	{795,2},
  {647,4},	{758,0},	{759,0},	{796,0}
};

static struct patval pat157[] = {
  {648,1},	{684,1},	{795,1},	{721,2},
  {647,3},	{758,0},	{759,0},	{796,0}
};

static struct patval pat158[] = {
  {795,1},	{721,1},	{758,1},	{684,2},
  {833,2},	{759,2},	{722,2},	{796,0},
  {649,0},	{686,0},	{723,0},	{760,0},
  {797,0},	{834,0}
};

static struct patval pat159[] = {
  {684,1},	{611,2},	{758,2},	{757,4},
  {794,4},	{720,4},	{796,4},	{795,4},
  {610,0},	{759,0},	{612,0},	{649,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {613,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{798,0}
};

static struct patval pat160[] = {
  {684,1},	{722,1},	{758,2},	{685,2},
  {611,2},	{795,4},	{796,4},	{757,4},
  {794,4},	{720,4},	{610,0},	{759,0},
  {612,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{613,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{798,0}
};

static struct patval pat161[] = {
  {686,1},	{723,1},	{722,1},	{612,1},
  {684,2},	{649,2},	{685,2},	{575,0},
  {574,0},	{611,0},	{610,0},	{576,0},
  {613,0},	{650,0},	{687,0},	{724,0}
};

static struct patval pat162[] = {
  {648,1},	{684,1},	{685,2},	{722,2},
  {719,3},	{645,0},	{682,0}
};

static struct patval pat163[] = {
  {723,1},	{721,2},	{758,2},	{684,2},
  {759,0},	{686,0},	{760,0},	{687,0},
  {724,0},	{761,0}
};

static struct patval pat164[] = {
  {684,1},	{685,1},	{758,2},	{686,2},
  {759,0},	{723,0},	{760,0}
};

static struct patval pat165[] = {
  {684,1},	{685,1},	{795,1},	{758,2},
  {721,2},	{759,0},	{796,0}
};

static struct patval pat166[] = {
  {684,1},	{721,1},	{758,1},	{870,1},
  {834,2},	{722,2},	{685,2},	{832,2},
  {869,3},	{796,0},	{833,0},	{759,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {795,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{835,0},	{872,0}
};

static struct patval pat167[] = {
  {684,1},	{758,1},	{721,2},	{759,0}
};

static struct patval pat168[] = {
  {684,1},	{758,1},	{721,2},	{759,0}
};

static struct patval pat169[] = {
  {684,1},	{796,1},	{758,1},	{721,2},
  {759,2}
};

static struct patval pat170[] = {
  {721,1},	{684,2},	{758,2},	{759,0}
};

static struct patval pat171[] = {
  {684,1},	{759,1},	{721,2}
};

static struct patval pat172[] = {
  {684,1},	{759,1},	{685,1},	{721,2}
};

static struct patval pat173[] = {
  {722,1},	{648,1},	{684,2}
};

static struct patval pat174[] = {
  {684,1},	{758,1},	{721,2},	{685,3},
  {759,3}
};

static struct patval pat175[] = {
  {684,1},	{648,2},	{722,2}
};

static struct patval pat176[] = {
  {721,1},	{684,2},	{722,2},	{795,2},
  {648,4},	{758,0},	{759,0},	{796,0}
};

static struct patval pat177[] = {
  {684,1},	{796,1},	{721,2},	{758,0},
  {759,0},	{795,0}
};

static struct patval pat178[] = {
  {684,1},	{796,1},	{721,2},	{758,0},
  {759,0},	{795,0}
};

static struct patval pat179[] = {
  {684,1},	{796,1},	{685,1},	{721,2},
  {758,0},	{759,0},	{795,0}
};

static struct patval pat180[] = {
  {684,1},	{796,1},	{685,1},	{721,2},
  {758,0},	{759,0},	{795,0}
};

static struct patval pat181[] = {
  {684,1},	{796,1},	{721,2},	{795,2},
  {685,3},	{758,0},	{759,0}
};

static struct patval pat182[] = {
  {684,1},	{832,1},	{722,1},	{795,2},
  {721,2},	{648,3},	{870,3},	{759,0},
  {796,0},	{833,0},	{758,0}
};

static struct patval pat183[] = {
  {758,1},	{795,2},	{684,2},	{759,0},
  {796,0}
};

static struct patval pat184[] = {
  {758,1},	{722,1},	{684,2},	{795,2},
  {759,2},	{796,0}
};

static struct patval pat185[] = {
  {684,1},	{685,1},	{795,1},	{758,2},
  {759,0},	{796,0}
};

static struct patval pat186[] = {
  {684,1},	{795,1},	{758,2},	{759,0},
  {796,0}
};

static struct patval pat187[] = {
  {684,1},	{796,1},	{685,1},	{795,2},
  {758,2},	{759,0}
};

static struct patval pat188[] = {
  {684,1},	{648,2},	{758,2},	{721,4},
  {759,4},	{722,4}
};

static struct patval pat189[] = {
  {684,1},	{721,2},	{611,2},	{722,4},
  {574,0},	{610,0}
};

static struct patval pat190[] = {
  {684,1},	{611,2},	{721,2},	{646,3},
  {683,3},	{610,4},	{758,0},	{757,0},
  {759,0}
};

static struct patval pat191[] = {
  {611,1},	{723,1},	{684,2},	{721,2},
  {722,2},	{760,3},	{612,0},	{649,0},
  {686,0}
};

static struct patval pat192[] = {
  {684,1},	{648,2},	{795,2},	{796,4},
  {758,0},	{759,0}
};

static struct patval pat193[] = {
  {759,1},	{648,1},	{684,2}
};

static struct patval pat194[] = {
  {795,1},	{721,1},	{684,2},	{796,2},
  {757,4},	{759,0},	{758,0}
};

static struct patval pat195[] = {
  {684,1},	{758,1},	{648,2},	{796,2},
  {722,2},	{759,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{798,0}
};

static struct patval pat196[] = {
  {611,1},	{613,2},	{684,2},	{722,2},
  {612,0},	{649,0},	{686,0},	{723,0},
  {650,0}
};

static struct patval pat197[] = {
  {575,1},	{684,1},	{649,2},	{610,0},
  {574,0},	{611,0},	{573,0},	{612,0}
};

static struct patval pat198[] = {
  {835,1},	{684,1},	{758,2},	{795,0},
  {759,0},	{796,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {872,0}
};

static struct patval pat199[] = {
  {684,1},	{762,1},	{758,2},	{720,3},
  {759,0},	{796,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {651,0},	{688,0},	{725,0},	{795,0}
};

static struct patval pat200[] = {
  {648,1},	{726,1},	{722,2},	{684,2},
  {759,0},	{612,0},	{649,0},	{686,0},
  {611,0},	{760,0},	{613,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{614,0},
  {651,0},	{688,0},	{725,0},	{762,0},
  {615,0},	{652,0},	{689,0},	{723,0}
};

static struct patval pat201[] = {
  {611,1},	{761,1},	{684,2},	{610,0},
  {573,0},	{575,0},	{612,0},	{649,0},
  {686,0},	{723,0},	{760,0},	{576,0},
  {613,0},	{650,0},	{687,0},	{724,0},
  {574,0}
};

static struct patval pat202[] = {
  {759,1},	{611,1},	{684,2},	{758,0},
  {574,0},	{610,0},	{573,0},	{575,0},
  {612,0},	{649,0},	{686,0},	{723,0},
  {760,0}
};

static struct patval pat203[] = {
  {869,2},	{684,2},	{794,0},	{831,0},
  {868,0},	{757,0},	{758,0},	{795,0},
  {832,0},	{759,0},	{796,0},	{833,0},
  {870,0}
};

static struct patval pat204[] = {
  {611,1},	{759,1},	{684,2},	{758,0},
  {649,0},	{686,0},	{723,0},	{760,0},
  {687,0}
};

static struct patval pat205[] = {
  {650,1},	{684,1},	{686,2},	{611,0},
  {612,0},	{649,0},	{610,0},	{613,0}
};

static struct patval pat206[] = {
  {759,1},	{649,1},	{721,2},	{684,2},
  {686,0},	{723,0},	{760,0}
};

static struct patval pat207[] = {
  {724,1},	{684,1},	{759,2},	{758,0},
  {649,0},	{686,0},	{723,0},	{760,0},
  {650,0},	{687,0},	{761,0}
};

static struct patval pat208[] = {
  {759,1},	{611,1},	{684,2},	{687,2},
  {650,4},	{758,0},	{649,0},	{686,0},
  {723,0},	{760,0}
};

static struct patval pat209[] = {
  {648,1},	{759,1},	{687,2},	{684,2},
  {650,4},	{758,0},	{649,0},	{686,0},
  {723,0},	{760,0}
};

static struct patval pat210[] = {
  {648,1},	{759,1},	{684,2},	{758,3}
};

static struct patval pat211[] = {
  {684,1},	{722,2},	{648,2},	{721,3},
  {647,3},	{649,0},	{686,0},	{723,0}
};

static struct patval pat212[] = {
  {797,1},	{723,1},	{684,2},	{832,2},
  {760,3},	{833,4},	{685,4},	{758,0},
  {759,0},	{796,0},	{757,0},	{794,0},
  {795,0}
};

static struct patval pat213[] = {
  {684,1},	{797,1},	{686,2},	{685,2},
  {795,0},	{759,0},	{796,0},	{723,0},
  {760,0},	{758,0}
};

static struct patval pat214[] = {
  {684,1},	{760,1},	{685,2},	{723,3},
  {759,0},	{758,0}
};

static struct patval pat215[] = {
  {684,1},	{760,1},	{685,2},	{723,3},
  {759,0},	{758,0}
};

static struct patval pat216[] = {
  {795,1},	{722,1},	{758,1},	{684,2},
  {761,2},	{721,2},	{796,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{687,0},
  {724,0},	{759,0}
};

static struct patval pat217[] = {
  {721,1},	{685,1},	{722,2},	{684,2},
  {758,0},	{759,0},	{796,0},	{723,0},
  {760,0}
};

static struct patval pat218[] = {
  {613,1},	{684,1},	{688,2},	{648,2},
  {649,0},	{686,0},	{723,0},	{650,0},
  {687,0},	{724,0},	{651,0},	{612,0}
};

static struct patval pat219[] = {
  {686,1},	{684,2},	{575,2},	{610,0},
  {573,0},	{574,0},	{611,0},	{612,0},
  {649,0},	{723,0},	{576,0},	{613,0},
  {650,0},	{687,0},	{724,0},	{577,0},
  {614,0},	{651,0},	{688,0},	{725,0}
};

static struct patval pat220[] = {
  {650,1},	{686,1},	{649,2},	{684,2},
  {575,2},	{574,0},	{573,0},	{612,0},
  {610,0},	{723,0},	{576,0},	{613,0},
  {611,0},	{687,0},	{724,0},	{577,0},
  {614,0},	{651,0},	{688,0},	{725,0}
};

static struct patval pat221[] = {
  {684,1},	{685,2},	{649,0},	{686,0},
  {723,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{688,0},	{725,0}
};

static struct patval pat222[] = {
  {611,1},	{684,2},	{537,2},	{686,2},
  {536,0},	{610,0},	{574,0},	{573,0},
  {538,0},	{575,0},	{612,0},	{649,0},
  {539,0},	{576,0},	{613,0},	{650,0},
  {687,0}
};

static struct patval pat223[] = {
  {575,1},	{611,1},	{537,2},	{686,2},
  {684,2},	{612,2},	{574,0},	{610,0},
  {538,0},	{536,0},	{573,0},	{649,0},
  {539,0},	{576,0},	{613,0},	{650,0},
  {687,0}
};

static struct patval pat224[] = {
  {612,1},	{759,1},	{684,2},	{610,0},
  {611,0},	{758,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{613,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{614,0},
  {651,0},	{688,0},	{725,0},	{762,0}
};

static struct patval pat225[] = {
  {612,1},	{759,1},	{684,2},	{610,0},
  {611,0},	{758,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{613,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{614,0},
  {651,0},	{688,0},	{725,0},	{762,0}
};

static struct patval pat226[] = {
  {684,1},	{759,2},	{758,4},	{795,0},
  {796,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{798,0}
};

static struct patval pat227[] = {
  {684,1},	{574,2},	{537,4},	{610,0},
  {611,0},	{538,0},	{575,0},	{612,0},
  {649,0},	{686,0},	{723,0},	{539,0},
  {576,0},	{613,0},	{650,0},	{687,0},
  {724,0}
};

static struct patval pat228[] = {
  {795,1},	{684,2},	{758,0},	{759,0},
  {796,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{797,0}
};

static struct patval pat229[] = {
  {684,1},	{721,1},	{796,1},	{685,2},
  {648,2},	{795,0},	{759,0},	{758,0},
  {649,0},	{686,0},	{723,0},	{760,0},
  {797,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{798,0}
};

static struct patval pat230[] = {
  {759,1},	{684,1},	{648,2},	{758,0},
  {649,0},	{686,0},	{723,0},	{760,0},
  {650,0},	{687,0},	{724,0},	{761,0}
};

static struct patval pat231[] = {
  {684,1},	{759,2},	{796,2},	{649,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {798,0}
};

static struct patval pat232[] = {
  {684,1},	{574,2},	{538,2},	{610,0},
  {611,0},	{573,0},	{575,0},	{612,0},
  {649,0},	{686,0},	{723,0},	{539,0},
  {576,0},	{613,0},	{650,0},	{687,0}
};

static struct patval pat233[] = {
  {684,1},	{796,2},	{758,0},	{795,0},
  {759,0},	{612,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{613,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{614,0},	{651,0},	{688,0},
  {725,0},	{762,0},	{799,0}
};

static struct patval pat234[] = {
  {684,1},	{721,1},	{649,2},	{685,2},
  {648,4},	{759,0},	{796,0},	{758,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {798,0}
};

static struct patval pat235[] = {
  {684,1},	{760,2},	{759,4},	{758,4},
  {761,4},	{612,0},	{649,0},	{686,0},
  {723,0},	{613,0},	{650,0},	{687,0},
  {724,0},	{611,0}
};

static struct patval pat236[] = {
  {684,1},	{649,2},	{757,0},	{794,0},
  {758,0},	{795,0},	{759,0},	{796,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{651,0},	{688,0},	{725,0},
  {762,0},	{799,0}
};

static struct patval pat237[] = {
  {684,1},	{686,2},	{794,0},	{831,0},
  {758,0},	{795,0},	{832,0},	{869,0},
  {759,0},	{796,0},	{833,0},	{870,0},
  {649,0},	{757,0},	{723,0},	{760,0},
  {797,0},	{834,0},	{871,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {835,0},	{872,0},	{651,0},	{688,0},
  {725,0},	{762,0},	{799,0},	{836,0},
  {873,0}
};

static struct patval pat238[] = {
  {684,1},	{649,2},	{759,0},	{758,0},
  {686,0},	{723,0},	{760,0},	{650,0},
  {687,0},	{724,0},	{761,0}
};

static struct patval pat239[] = {
  {684,1},	{721,2},	{685,2},	{573,0},
  {610,0},	{572,0},	{609,0},	{574,0},
  {611,0},	{575,0},	{612,0},	{649,0},
  {686,0},	{723,0}
};

static struct patval pat240[] = {
  {684,1},	{611,2},	{612,2},	{759,0},
  {758,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{613,0},	{650,0},	{687,0},
  {724,0},	{761,0}
};

static struct patval pat241[] = {
  {684,1},	{649,2},	{648,2},	{650,4},
  {758,0},	{796,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{759,0},	{687,0},
  {724,0},	{761,0},	{798,0}
};

static struct patval pat242[] = {
  {684,1},	{649,2},	{648,2},	{796,4},
  {759,4},	{650,4},	{758,0},	{723,0},
  {760,0},	{797,0},	{686,0},	{687,0},
  {724,0},	{761,0},	{798,0}
};

static struct patval pat243[] = {
  {759,1},	{721,2},	{684,2},	{647,4},
  {649,0},	{686,0},	{723,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{651,0},
  {688,0},	{725,0}
};

static struct patval pat244[] = {
  {684,1},	{721,1},	{685,2},	{686,2},
  {796,4},	{759,0},	{758,0},	{795,0},
  {723,0},	{760,0},	{797,0},	{687,0},
  {724,0},	{761,0},	{798,0}
};

static struct patval pat245[] = {
  {684,1},	{612,2},	{611,2},	{758,0},
  {759,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{613,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{614,0},	{651,0},
  {688,0},	{725,0},	{762,0}
};

static struct patval pat246[] = {
  {758,1},	{684,2},	{718,0},	{644,0},
  {792,0},	{645,0},	{682,0},	{719,0},
  {756,0},	{793,0},	{757,0},	{794,0},
  {755,0},	{681,0},	{795,0},	{759,0},
  {796,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{797,0}
};

static struct patval pat247[] = {
  {684,1},	{832,1},	{758,2},	{792,0},
  {829,0},	{718,0},	{719,0},	{756,0},
  {793,0},	{830,0},	{757,0},	{794,0},
  {831,0},	{682,0},	{681,0},	{795,0},
  {755,0},	{759,0},	{796,0},	{833,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0}
};

static struct patval pat248[] = {
  {684,1},	{722,2},	{649,2},	{536,0},
  {535,0},	{610,0},	{572,0},	{537,0},
  {574,0},	{611,0},	{573,0},	{538,0},
  {575,0},	{612,0},	{609,0},	{686,0},
  {723,0},	{539,0},	{576,0},	{613,0},
  {650,0},	{687,0},	{724,0}
};

static struct patval pat249[] = {
  {684,1},	{686,1},	{760,2},	{794,0},
  {757,0},	{758,0},	{795,0},	{759,0},
  {796,0},	{723,0},	{797,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{688,0},
  {725,0},	{762,0},	{799,0}
};

static struct patval pat250[] = {
  {684,1},	{686,2},	{611,2},	{573,0},
  {610,0},	{574,0},	{609,0},	{575,0},
  {612,0},	{649,0},	{572,0},	{576,0},
  {613,0},	{650,0},	{687,0}
};

static struct patval pat251[] = {
  {684,1},	{833,1},	{759,2},	{794,0},
  {758,0},	{795,0},	{756,0},	{796,0},
  {757,0},	{686,0},	{723,0},	{760,0},
  {797,0},	{834,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{835,0}
};

static struct patval pat252[] = {
  {833,1},	{685,1},	{612,1},	{684,1},
  {611,1},	{649,2},	{722,2},	{686,2},
  {794,0},	{831,0},	{610,0},	{719,0},
  {758,0},	{795,0},	{832,0},	{756,0},
  {757,0},	{682,0},	{759,0},	{796,0},
  {793,0},	{609,0},	{608,0},	{645,0},
  {723,0},	{760,0},	{797,0},	{834,0},
  {613,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{835,0},	{614,0},
  {651,0},	{688,0},	{725,0},	{762,0},
  {799,0},	{836,0}
};

static struct patval pat253[] = {
  {684,1},	{611,2},	{686,2},	{757,0},
  {610,0},	{758,0},	{759,0},	{612,0},
  {649,0},	{609,0},	{723,0},	{760,0},
  {613,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{614,0},	{651,0},	{688,0},
  {725,0},	{762,0}
};

static struct patval pat254[] = {
  {684,1},	{424,4},	{498,4},	{426,4},
  {463,4},	{500,4},	{462,4},	{499,4},
  {461,4},	{425,4},	{536,0},	{573,0},
  {610,0},	{535,0},	{572,0},	{609,0},
  {537,0},	{574,0},	{611,0},	{427,0},
  {464,0},	{501,0},	{538,0},	{575,0},
  {612,0},	{649,0},	{686,0},	{723,0},
  {428,0},	{465,0},	{502,0},	{539,0},
  {576,0},	{613,0},	{650,0},	{687,0},
  {724,0}
};

static struct patval pat255[] = {
  {684,1},	{645,3},	{685,3},	{722,3},
  {462,4},	{463,4},	{426,4},	{425,4},
  {500,4},	{610,0},	{536,0},	{499,0},
  {609,0},	{537,0},	{574,0},	{611,0},
  {573,0},	{427,0},	{464,0},	{501,0},
  {538,0},	{575,0},	{612,0},	{649,0},
  {428,0},	{465,0},	{502,0},	{539,0},
  {576,0},	{613,0},	{650,0},	{687,0}
};

static struct patval pat256[] = {
  {684,1},	{645,3},	{685,3},	{722,3},
  {462,4},	{463,4},	{426,4},	{425,4},
  {500,4},	{610,0},	{536,0},	{499,0},
  {609,0},	{537,0},	{574,0},	{611,0},
  {573,0},	{427,0},	{464,0},	{501,0},
  {538,0},	{575,0},	{612,0},	{649,0},
  {428,0},	{465,0},	{502,0},	{539,0},
  {576,0},	{613,0},	{650,0},	{687,0}
};

static struct patval pat257[] = {
  {833,1},	{684,2},	{758,2},	{794,0},
  {831,0},	{757,0},	{795,0},	{832,0},
  {759,0},	{796,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{835,0}
};

static struct patval pat258[] = {
  {758,1},	{684,2},	{648,2},	{759,0},
  {649,0},	{686,0},	{723,0},	{760,0},
  {650,0},	{687,0},	{724,0},	{761,0}
};

static struct patval pat259[] = {
  {832,1},	{684,2},	{831,3},	{794,3},
  {757,0},	{758,0},	{795,0},	{759,0},
  {796,0},	{833,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0}
};

static struct patval pat260[] = {
  {833,1},	{684,2},	{758,0},	{795,0},
  {832,0},	{759,0},	{796,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {835,0}
};

static struct patval pat261[] = {
  {684,1},	{833,2},	{758,0},	{795,0},
  {832,0},	{759,0},	{796,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {835,0}
};

static struct patval pat262[] = {
  {684,1},	{795,2},	{758,0},	{757,0},
  {759,0},	{796,0},	{686,0},	{723,0},
  {760,0},	{797,0}
};

static struct patval pat263[] = {
  {611,1},	{684,2},	{722,2},	{612,0},
  {649,0},	{686,0},	{723,0},	{613,0},
  {650,0},	{687,0},	{724,0}
};

static struct patval pat264[] = {
  {796,1},	{684,2},	{795,0},	{759,0},
  {758,0},	{686,0},	{723,0},	{760,0},
  {797,0},	{687,0},	{724,0},	{761,0},
  {798,0}
};

static struct patval pat265[] = {
  {759,1},	{684,2},	{758,0},	{649,0},
  {686,0},	{723,0},	{760,0},	{650,0},
  {687,0},	{724,0},	{761,0}
};

static struct patval pat266[] = {
  {684,1},	{833,2},	{795,2},	{758,0},
  {832,0},	{759,0},	{796,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {835,0}
};

static struct patval pat267[] = {
  {907,1},	{648,2},	{684,2},	{794,0},
  {757,0},	{868,0},	{905,0},	{758,0},
  {795,0},	{832,0},	{869,0},	{906,0},
  {759,0},	{796,0},	{833,0},	{870,0},
  {831,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0},	{871,0},
  {908,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{835,0},	{872,0},
  {909,0}
};

static struct patval pat268[] = {
  {833,1},	{684,2},	{794,0},	{758,0},
  {795,0},	{832,0},	{759,0},	{796,0},
  {757,0},	{686,0},	{723,0},	{760,0},
  {797,0},	{834,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{835,0}
};

static struct patval pat269[] = {
  {684,1},	{758,2},	{759,0},	{686,0},
  {723,0},	{760,0}
};

static struct patval pat270[] = {
  {684,1},	{795,2},	{720,4},	{758,0},
  {759,0},	{796,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{687,0},	{724,0},
  {761,0},	{798,0}
};

static struct patval pat271[] = {
  {833,1},	{684,2},	{758,0},	{795,0},
  {832,0},	{759,0},	{796,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {835,0}
};

static struct patval pat272[] = {
  {684,1},	{833,1},	{721,2},	{685,2},
  {758,2},	{869,0},	{795,0},	{759,0},
  {796,0},	{832,0},	{870,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0},
  {871,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{835,0},	{872,0}
};

static struct patval pat273[] = {
  {685,1},	{684,1},	{834,4},	{794,4},
  {831,4},	{832,4},	{833,4},	{835,4},
  {795,4},	{757,0},	{759,0},	{758,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {796,0}
};

static struct patval pat274[] = {
  {684,2},	{758,0},	{795,0},	{759,0},
  {796,0},	{686,0},	{723,0},	{760,0},
  {797,0}
};

static struct patval pat275[] = {
  {684,2},	{831,3},	{832,3},	{794,0},
  {757,0},	{758,0},	{795,0},	{759,0},
  {796,0},	{686,0},	{723,0},	{760,0},
  {797,0}
};

static struct patval pat276[] = {
  {684,2},	{832,3},	{794,3},	{831,3},
  {757,0},	{758,0},	{795,0},	{759,0},
  {796,0},	{833,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0}
};

static struct patval pat277[] = {
  {648,2},	{684,2},	{647,4},	{758,0},
  {795,0},	{759,0},	{796,0},	{649,0},
  {686,0},	{723,0},	{760,0},	{797,0}
};

static struct patval pat278[] = {
  {684,2},	{721,2},	{758,0},	{795,0},
  {832,0},	{759,0},	{796,0},	{833,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0}
};

static struct patval pat279[] = {
  {721,2},	{684,2},	{757,3},	{794,0},
  {758,0},	{795,0},	{832,0},	{759,0},
  {796,0},	{833,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0}
};

static struct patval pat280[] = {
  {648,2},	{684,2},	{647,4},	{758,0},
  {795,0},	{832,0},	{759,0},	{796,0},
  {833,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0}
};

static struct patval pat281[] = {
  {684,2},	{683,4},	{757,0},	{758,0},
  {795,0},	{759,0},	{796,0}
};

static struct patval pat282[] = {
  {684,2},	{683,4},	{757,0},	{794,0},
  {831,0},	{758,0},	{795,0},	{832,0},
  {759,0},	{796,0},	{833,0}
};

static struct patval pat283[] = {
  {685,1},	{686,1},	{723,1},	{722,2},
  {684,2},	{760,2},	{758,0},	{832,0},
  {759,0},	{796,0},	{833,0},	{757,0},
  {795,0},	{797,0},	{834,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0},
  {688,0},	{725,0},	{762,0},	{799,0},
  {836,0}
};

static struct patval pat284[] = {
  {685,1},	{686,1},	{723,1},	{760,2},
  {722,2},	{684,2},	{871,4},	{872,4},
  {910,4},	{870,4},	{869,4},	{906,4},
  {905,4},	{873,4},	{908,4},	{868,4},
  {909,4},	{907,4},	{832,0},	{833,0},
  {757,0},	{796,0},	{797,0},	{834,0},
  {759,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{835,0},	{688,0},	{725,0},
  {762,0},	{799,0},	{836,0},	{758,0},
  {795,0}
};

static struct patval pat285[] = {
  {684,1},	{759,1},	{722,1},	{685,2},
  {723,2},	{686,0},	{796,0},	{760,0},
  {797,0},	{687,0},	{724,0},	{761,0},
  {798,0}
};

static struct patval pat286[] = {
  {758,1},	{684,1},	{685,2},	{610,0},
  {611,0},	{609,0},	{759,0},	{612,0},
  {649,0},	{686,0},	{723,0},	{760,0},
  {613,0},	{650,0},	{687,0},	{724,0},
  {761,0}
};

static struct patval pat287[] = {
  {759,1},	{685,1},	{684,1},	{686,2},
  {648,2},	{611,0},	{574,0},	{610,0},
  {575,0},	{612,0},	{649,0},	{723,0},
  {760,0},	{576,0},	{613,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{577,0},
  {614,0},	{651,0},	{688,0},	{725,0},
  {762,0}
};

static struct patval pat288[] = {
  {685,1},	{758,1},	{684,2},	{795,0},
  {611,0},	{610,0},	{759,0},	{796,0},
  {612,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{613,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{798,0}
};

static struct patval pat289[] = {
  {685,1},	{795,1},	{684,2},	{758,0},
  {611,0},	{610,0},	{759,0},	{796,0},
  {612,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{613,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{798,0}
};

static struct patval pat290[] = {
  {648,1},	{684,2},	{611,3},	{758,4},
  {759,4},	{612,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{613,0},	{650,0},
  {687,0},	{724,0},	{761,0}
};

static struct patval pat291[] = {
  {684,1},	{722,2},	{611,2},	{685,2},
  {758,0},	{610,0},	{759,0},	{649,0},
  {686,0},	{723,0},	{760,0},	{650,0},
  {687,0},	{724,0},	{761,0}
};

static struct patval pat292[] = {
  {684,1},	{722,2},	{685,2},	{611,3},
  {758,0},	{610,0},	{759,0},	{649,0},
  {686,0},	{723,0},	{760,0},	{650,0},
  {687,0},	{724,0},	{761,0}
};

static struct patval pat293[] = {
  {648,1},	{684,2},	{683,4},	{758,0},
  {759,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{650,0},	{687,0},	{724,0},
  {761,0}
};

static struct patval pat294[] = {
  {648,1},	{684,2},	{649,2},	{683,4},
  {759,0},	{758,0},	{686,0},	{723,0},
  {760,0},	{650,0},	{687,0},	{724,0},
  {761,0}
};

static struct patval pat295[] = {
  {723,1},	{684,2},	{611,0},	{612,0},
  {649,0},	{686,0},	{610,0},	{613,0},
  {650,0},	{687,0},	{614,0},	{651,0},
  {688,0},	{725,0}
};

static struct patval pat296[] = {
  {684,1},	{685,1},	{721,2},	{795,2},
  {794,0},	{758,0},	{757,0},	{759,0},
  {796,0},	{686,0},	{723,0},	{760,0},
  {797,0},	{687,0},	{724,0},	{761,0},
  {798,0}
};

static struct patval pat297[] = {
  {648,1},	{684,2},	{758,2},	{759,0},
  {649,0},	{686,0},	{723,0},	{760,0},
  {650,0},	{687,0},	{724,0},	{761,0}
};

static struct patval pat298[] = {
  {759,1},	{684,2},	{648,2},	{649,0},
  {686,0},	{723,0},	{760,0},	{650,0},
  {687,0},	{724,0},	{761,0}
};

static struct patval pat299[] = {
  {684,1},	{575,1},	{611,2},	{573,0},
  {610,0},	{612,0},	{649,0},	{686,0}
};

static struct patval pat300[] = {
  {722,1},	{758,1},	{684,1},	{759,2},
  {796,2},	{868,0},	{831,0},	{794,0},
  {795,0},	{832,0},	{869,0},	{757,0},
  {833,0},	{870,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0},	{871,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {835,0},	{872,0}
};

static struct patval pat301[] = {
  {648,1},	{686,2},	{684,2},	{759,0},
  {723,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{651,0},	{688,0},	{725,0},
  {762,0}
};

static struct patval pat302[] = {
  {797,1},	{684,2},	{721,2},	{759,0},
  {796,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{651,0},	{688,0},
  {725,0},	{762,0},	{799,0}
};

static struct patval pat303[] = {
  {796,1},	{684,2},	{870,2},	{683,4},
  {906,4},	{905,4},	{868,0},	{757,0},
  {758,0},	{795,0},	{832,0},	{869,0},
  {831,0},	{759,0},	{833,0},	{794,0},
  {907,0},	{686,0},	{723,0},	{760,0},
  {797,0},	{834,0},	{871,0},	{908,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {835,0},	{872,0},	{909,0}
};

static struct patval pat304[] = {
  {759,1},	{796,1},	{758,2},	{684,2},
  {649,0},	{686,0},	{723,0},	{760,0},
  {797,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{798,0}
};

static struct patval pat305[] = {
  {685,1},	{684,1},	{721,2},	{683,3},
  {682,4},	{756,4},	{719,0},	{757,0},
  {758,0},	{759,0}
};

static struct patval pat306[] = {
  {686,1},	{684,2},	{610,0},	{573,0},
  {574,0},	{611,0},	{575,0},	{612,0},
  {649,0},	{576,0},	{613,0},	{650,0},
  {687,0}
};

static struct patval pat307[] = {
  {684,1},	{721,2},	{757,0},	{794,0},
  {831,0},	{758,0},	{795,0},	{832,0},
  {759,0},	{796,0},	{833,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {835,0}
};

static struct patval pat308[] = {
  {722,1},	{686,1},	{684,2},	{685,2},
  {723,2},	{611,0},	{610,0},	{612,0},
  {649,0},	{613,0},	{650,0},	{687,0},
  {724,0},	{614,0},	{651,0},	{688,0},
  {725,0}
};

static struct patval pat309[] = {
  {648,1},	{686,1},	{684,2},	{685,2},
  {760,4},	{721,4},	{649,0},	{723,0},
  {650,0},	{687,0},	{724,0}
};

static struct patval pat310[] = {
  {648,1},	{687,1},	{684,2},	{685,2},
  {760,4},	{721,4},	{686,0},	{723,0},
  {650,0},	{649,0},	{724,0}
};

static struct patval pat311[] = {
  {685,1},	{684,2},	{611,0},	{649,0},
  {686,0}
};

static struct patval pat312[] = {
  {685,1},	{684,2},	{611,2},	{649,0},
  {686,0}
};

static struct patval pat313[] = {
  {685,1},	{611,1},	{684,2},	{649,0},
  {686,0}
};

static struct patval pat314[] = {
  {648,1},	{721,2},	{758,2},	{684,2},
  {759,0},	{649,0},	{686,0},	{723,0},
  {760,0}
};

static struct patval pat315[] = {
  {759,1},	{721,2},	{684,2},	{686,0},
  {723,0}
};

static struct patval pat316[] = {
  {684,1},	{722,1},	{758,2},	{795,0},
  {759,0},	{796,0},	{686,0},	{723,0},
  {760,0},	{797,0}
};

static struct patval pat317[] = {
  {833,1},	{685,2},	{684,2},	{795,2},
  {759,0},	{796,0},	{758,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0}
};

static struct patval pat318[] = {
  {722,1},	{795,1},	{758,1},	{721,2},
  {684,2},	{759,0},	{796,0},	{686,0},
  {723,0},	{760,0},	{797,0}
};

static struct patval pat319[] = {
  {685,1},	{648,1},	{722,2},	{684,2},
  {758,0},	{759,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{650,0},	{687,0},
  {724,0},	{761,0}
};

static struct patval pat320[] = {
  {722,1},	{684,2},	{649,0},	{686,0},
  {723,0}
};

static struct patval pat321[] = {
  {722,1},	{684,2},	{649,0},	{686,0},
  {723,0}
};

static struct patval pat322[] = {
  {723,1},	{722,1},	{684,2},	{575,4},
  {610,4},	{611,0},	{612,0},	{649,0},
  {686,0}
};

static struct patval pat323[] = {
  {759,1},	{684,2},	{647,4},	{648,4},
  {649,0},	{686,0},	{723,0},	{760,0}
};

static struct patval pat324[] = {
  {759,1},	{760,1},	{684,2},	{647,4},
  {649,0},	{686,0},	{723,0}
};

static struct patval pat325[] = {
  {759,1},	{760,1},	{684,2},	{647,4},
  {649,0},	{686,0},	{723,0}
};

static struct patval pat326[] = {
  {759,1},	{723,1},	{722,2},	{684,2},
  {649,0},	{686,0},	{760,0},	{650,0},
  {687,0},	{724,0},	{761,0}
};

static struct patval pat327[] = {
  {684,1},	{760,1},	{685,1},	{758,2},
  {759,2},	{796,0},	{686,0},	{723,0},
  {797,0},	{834,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{835,0}
};

static struct patval pat328[] = {
  {648,1},	{649,1},	{759,1},	{685,2},
  {684,2},	{832,0},	{758,0},	{795,0},
  {796,0},	{833,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {835,0}
};

static struct patval pat329[] = {
  {760,1},	{684,2},	{758,0},	{759,0},
  {649,0},	{686,0},	{723,0},	{650,0},
  {687,0},	{724,0},	{761,0}
};

static struct patval pat330[] = {
  {721,1},	{759,1},	{684,2},	{649,0},
  {686,0},	{723,0},	{760,0}
};

static struct patval pat331[] = {
  {686,1},	{795,1},	{760,1},	{796,1},
  {758,2},	{684,2},	{759,2},	{611,0},
  {612,0},	{649,0},	{610,0},	{723,0},
  {797,0}
};

static struct patval pat332[] = {
  {723,1},	{797,1},	{761,1},	{759,2},
  {760,2},	{684,2},	{648,4},	{649,4},
  {647,4},	{650,4},	{686,0},	{687,0},
  {724,0},	{798,0}
};

static struct patval pat333[] = {
  {650,1},	{686,1},	{612,1},	{759,1},
  {649,2},	{684,2},	{648,2},	{647,4},
  {723,0},	{760,0},	{613,0},	{687,0},
  {724,0},	{761,0}
};

static struct patval pat334[] = {
  {724,1},	{723,1},	{722,2},	{684,2},
  {758,2},	{759,0},	{796,0},	{760,0},
  {797,0},	{795,0},	{761,0},	{798,0}
};

static struct patval pat335[] = {
  {761,1},	{760,1},	{722,2},	{684,2},
  {762,3},	{721,4},	{610,0},	{574,0},
  {575,0},	{612,0},	{649,0},	{686,0},
  {723,0},	{576,0},	{613,0},	{650,0},
  {687,0},	{724,0},	{573,0},	{577,0},
  {614,0},	{651,0},	{688,0},	{725,0},
  {611,0}
};

static struct patval pat336[] = {
  {648,1},	{795,1},	{758,2},	{721,2},
  {684,2},	{833,2},	{796,2},	{759,0},
  {649,0},	{686,0},	{723,0},	{760,0},
  {797,0},	{834,0}
};

static struct patval pat337[] = {
  {685,1},	{648,1},	{684,2},	{609,4},
  {610,0},	{574,0},	{611,0},	{573,0}
};

static struct patval pat338[] = {
  {685,1},	{684,2},	{795,2},	{833,4},
  {832,4},	{758,0},	{759,0},	{796,0},
  {649,0},	{686,0},	{723,0},	{760,0},
  {797,0},	{834,0}
};

static struct patval pat339[] = {
  {648,1},	{649,1},	{758,2},	{684,2},
  {721,4},	{759,0},	{686,0},	{723,0},
  {760,0},	{650,0},	{687,0},	{724,0},
  {761,0}
};

static struct patval pat340[] = {
  {686,1},	{684,2},	{685,3},	{758,4},
  {721,4},	{759,0},	{723,0},	{760,0}
};

static struct patval pat341[] = {
  {649,1},	{684,2},	{648,3},	{721,4},
  {686,0},	{723,0}
};

static struct patval pat342[] = {
  {612,1},	{684,2},	{611,3},	{610,0},
  {649,0},	{686,0}
};

static struct patval pat343[] = {
  {649,1},	{684,2},	{648,3},	{721,4},
  {759,0},	{686,0},	{723,0},	{760,0}
};

static struct patval pat344[] = {
  {612,1},	{684,2},	{611,3},	{649,0},
  {686,0},	{723,0}
};

static struct patval pat345[] = {
  {575,1},	{684,2},	{574,3},	{610,0},
  {611,0},	{612,0},	{649,0},	{686,0}
};

static struct patval pat346[] = {
  {684,1},	{685,1},	{758,2},	{721,2},
  {759,0},	{686,0},	{723,0},	{760,0}
};

static struct patval pat347[] = {
  {612,1},	{611,2},	{684,2},	{649,0},
  {686,0}
};

static struct patval pat348[] = {
  {722,1},	{721,1},	{684,2},	{685,2},
  {649,0},	{686,0},	{723,0}
};

static struct patval pat349[] = {
  {722,1},	{684,1},	{721,2},	{720,4},
  {758,0},	{759,0},	{796,0}
};

static struct patval pat350[] = {
  {722,1},	{684,1},	{721,2},	{720,4},
  {758,0},	{759,0},	{796,0}
};

static struct patval pat351[] = {
  {649,1},	{648,2},	{684,2},	{722,2},
  {686,0},	{723,0}
};

static struct patval pat352[] = {
  {649,1},	{611,1},	{684,2},	{648,2},
  {647,4},	{612,0},	{686,0}
};

static struct patval pat353[] = {
  {648,1},	{684,2},	{758,0},	{795,0},
  {759,0},	{796,0}
};

static struct patval pat354[] = {
  {685,1},	{686,1},	{722,2},	{684,2},
  {721,4},	{759,0},	{796,0},	{833,0},
  {612,0},	{649,0},	{611,0},	{723,0},
  {760,0},	{797,0},	{834,0}
};

static struct patval pat355[] = {
  {684,1},	{721,1},	{758,2},	{722,2},
  {759,4},	{682,0},	{719,0},	{686,0},
  {723,0},	{687,0},	{724,0}
};

static struct patval pat356[] = {
  {723,1},	{684,2},	{722,2},	{686,0}
};

static struct patval pat357[] = {
  {684,1},	{685,2},	{721,2},	{649,0},
  {686,0},	{723,0}
};

static struct patval pat358[] = {
  {684,1},	{685,2},	{721,2},	{649,0},
  {686,0},	{723,0}
};

static struct patval pat359[] = {
  {722,1},	{685,1},	{796,1},	{758,1},
  {721,2},	{684,2},	{610,4},	{611,0},
  {759,0}
};

static struct patval pat360[] = {
  {685,1},	{722,1},	{684,2},	{721,2},
  {610,4},	{611,0}
};

static struct patval pat361[] = {
  {648,1},	{649,1},	{685,2},	{684,2},
  {758,0},	{759,0},	{686,0},	{723,0},
  {760,0}
};

static struct patval pat362[] = {
  {649,1},	{648,1},	{685,2},	{684,2},
  {611,2},	{758,0},	{759,0},	{612,0},
  {686,0},	{723,0},	{760,0}
};

static struct patval pat363[] = {
  {648,1},	{684,2},	{758,0},	{759,0}
};

static struct patval pat364[] = {
  {684,1},	{722,1},	{795,1},	{721,2},
  {758,0},	{759,0},	{796,0}
};

static struct patval pat365[] = {
  {685,1},	{684,2},	{758,0},	{759,0}
};

static struct patval pat366[] = {
  {685,1},	{684,2},	{758,0},	{759,0}
};

static struct patval pat367[] = {
  {685,1},	{722,1},	{721,2},	{684,2},
  {795,0},	{758,0},	{759,0},	{796,0}
};

static struct patval pat368[] = {
  {685,1},	{684,2},	{758,0},	{759,0}
};

static struct patval pat369[] = {
  {648,1},	{684,1},	{721,1},	{758,2},
  {722,2},	{685,2},	{759,0}
};

static struct patval pat370[] = {
  {758,1},	{722,2},	{684,2},	{795,0},
  {759,0},	{796,0},	{686,0},	{723,0},
  {760,0},	{797,0}
};

static struct patval pat371[] = {
  {684,2},	{757,3},	{794,3},	{831,3},
  {720,3},	{648,4},	{758,0},	{795,0},
  {832,0},	{759,0},	{796,0},	{833,0}
};

static struct patval pat372[] = {
  {684,1},	{611,2},	{612,2},	{647,3},
  {759,0},	{758,0},	{649,0},	{686,0},
  {723,0},	{760,0}
};

static struct patval pat373[] = {
  {684,1},	{649,2},	{648,2},	{721,3},
  {758,0},	{759,0},	{796,0},	{795,0},
  {686,0},	{723,0},	{760,0},	{797,0}
};

static struct patval pat374[] = {
  {684,1},	{649,2},	{611,2},	{612,4},
  {759,0},	{686,0},	{723,0},	{760,0}
};

static struct patval pat375[] = {
  {684,1},	{611,2},	{649,2},	{612,4},
  {759,0},	{796,0},	{758,0},	{686,0},
  {723,0},	{760,0},	{797,0}
};

static struct patval pat376[] = {
  {721,1},	{722,2},	{684,2},	{794,3},
  {720,3},	{757,3},	{795,0},	{758,0},
  {759,0},	{796,0},	{833,0}
};

static struct patval pat377[] = {
  {684,1},	{537,1},	{686,2},	{611,2},
  {500,0},	{759,0},	{501,0},	{538,0},
  {575,0},	{612,0},	{649,0},	{574,0},
  {723,0},	{760,0},	{502,0},	{539,0},
  {576,0},	{613,0},	{650,0},	{687,0},
  {724,0},	{761,0}
};

static struct patval pat378[] = {
  {684,1},	{686,2},	{759,2},	{611,3},
  {758,0},	{612,0},	{649,0},	{723,0},
  {760,0},	{650,0},	{687,0},	{724,0},
  {761,0}
};

static struct patval pat379[] = {
  {684,1},	{795,1},	{758,1},	{797,2},
  {759,2},	{870,2},	{832,0},	{796,0},
  {833,0},	{869,0},	{686,0},	{723,0},
  {760,0},	{834,0},	{871,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0},
  {872,0}
};

static struct patval pat380[] = {
  {684,1},	{721,1},	{649,2},	{722,2},
  {759,0},	{686,0},	{723,0},	{760,0},
  {650,0},	{687,0},	{724,0},	{761,0}
};

static struct patval pat381[] = {
  {684,1},	{648,2},	{612,4},	{649,0},
  {686,0},	{723,0},	{613,0},	{650,0},
  {687,0},	{724,0}
};

static struct patval pat382[] = {
  {684,1},	{648,2},	{612,0},	{649,0},
  {686,0},	{723,0},	{613,0},	{650,0},
  {687,0},	{724,0}
};

static struct patval pat383[] = {
  {685,1},	{795,1},	{759,2},	{722,2},
  {684,2},	{832,0},	{796,0},	{833,0},
  {649,0},	{686,0},	{723,0},	{760,0},
  {797,0},	{834,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0}
};

static struct patval pat384[] = {
  {685,1},	{795,1},	{686,1},	{759,2},
  {684,2},	{722,2},	{648,2},	{796,0},
  {833,0},	{649,0},	{832,0},	{723,0},
  {760,0},	{797,0},	{834,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {835,0}
};

static struct patval pat385[] = {
  {684,1},	{685,1},	{612,2},	{648,2},
  {686,2},	{649,4},	{759,0},	{796,0},
  {833,0},	{758,0},	{723,0},	{760,0},
  {797,0},	{834,0},	{613,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {835,0}
};

static struct patval pat386[] = {
  {648,1},	{721,1},	{684,1},	{685,2},
  {722,2},	{649,2},	{611,0},	{612,0},
  {610,0},	{686,0},	{723,0},	{613,0},
  {650,0},	{687,0},	{724,0}
};

static struct patval pat387[] = {
  {721,1},	{722,1},	{684,1},	{723,2},
  {760,2},	{685,2},	{611,0},	{612,0},
  {649,0},	{686,0},	{610,0},	{613,0},
  {650,0},	{687,0},	{724,0},	{761,0}
};

static struct patval pat388[] = {
  {685,1},	{722,2},	{648,2},	{684,2},
  {723,2},	{610,0},	{536,0},	{500,0},
  {537,0},	{574,0},	{611,0},	{499,0},
  {501,0},	{538,0},	{575,0},	{612,0},
  {649,0},	{686,0},	{573,0},	{502,0},
  {539,0},	{576,0},	{613,0},	{650,0},
  {687,0},	{724,0}
};

static struct patval pat389[] = {
  {684,1},	{722,1},	{760,2},	{723,2},
  {573,4},	{647,4},	{610,4},	{575,0},
  {612,0},	{649,0},	{686,0},	{574,0},
  {611,0},	{576,0},	{613,0},	{650,0},
  {687,0},	{724,0},	{761,0}
};

static struct patval pat390[] = {
  {684,1},	{648,1},	{611,1},	{649,2},
  {685,2},	{612,2},	{721,3},	{759,0},
  {686,0},	{723,0},	{760,0},	{613,0},
  {650,0},	{687,0},	{724,0},	{761,0}
};

static struct patval pat391[] = {
  {684,1},	{759,1},	{721,2},	{686,0},
  {723,0},	{760,0},	{687,0},	{724,0},
  {761,0}
};

static struct patval pat392[] = {
  {684,2},	{757,0},	{794,0},	{758,0},
  {795,0},	{759,0},	{796,0},	{686,0},
  {723,0},	{760,0},	{797,0}
};

static struct patval pat393[] = {
  {684,1},	{721,1},	{759,2},	{685,2},
  {869,3},	{832,0},	{795,0},	{758,0},
  {796,0},	{833,0},	{870,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0},
  {871,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{835,0},	{872,0}
};

static struct patval pat394[] = {
  {684,1},	{721,1},	{759,2},	{685,2},
  {869,3},	{832,0},	{795,0},	{758,0},
  {796,0},	{833,0},	{870,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0},
  {871,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{835,0},	{872,0}
};

static struct patval pat395[] = {
  {684,1},	{721,1},	{759,2},	{685,2},
  {870,3},	{869,3},	{832,0},	{758,0},
  {796,0},	{833,0},	{795,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0},
  {871,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{835,0},	{872,0}
};

static struct patval pat396[] = {
  {684,1},	{685,2},	{758,2},	{759,0},
  {649,0},	{686,0},	{723,0},	{760,0}
};

static struct patval pat397[] = {
  {684,1},	{721,1},	{722,2},	{685,2},
  {795,0},	{758,0},	{759,0},	{796,0},
  {686,0},	{723,0},	{760,0},	{797,0}
};

static struct patval pat398[] = {
  {721,1},	{684,1},	{685,2},	{722,2},
  {611,0},	{612,0},	{649,0},	{686,0},
  {723,0},	{576,0},	{613,0},	{650,0},
  {687,0},	{724,0}
};

static struct patval pat399[] = {
  {721,1},	{684,1},	{722,2},	{685,2},
  {646,4},	{610,4},	{611,0},	{612,0},
  {649,0},	{686,0},	{723,0},	{576,0},
  {613,0},	{650,0},	{687,0},	{724,0}
};

static struct patval pat400[] = {
  {611,1},	{648,1},	{684,1},	{649,2},
  {685,2},	{722,2},	{574,0},	{575,0},
  {612,0},	{610,0},	{686,0},	{723,0},
  {576,0},	{613,0},	{650,0},	{687,0},
  {724,0}
};

static struct patval pat401[] = {
  {684,1},	{685,2},	{758,0},	{759,0},
  {686,0},	{723,0},	{760,0}
};

static struct patval pat402[] = {
  {684,1},	{648,2},	{611,0},	{610,0},
  {612,0},	{649,0},	{686,0},	{723,0}
};

static struct patval pat403[] = {
  {684,1},	{648,2},	{574,3},	{611,0},
  {610,0},	{575,0},	{612,0},	{649,0},
  {686,0},	{723,0}
};

static struct patval pat404[] = {
  {684,1},	{648,2},	{574,3},	{611,0},
  {610,0},	{575,0},	{612,0},	{649,0},
  {686,0},	{723,0}
};

static struct patval pat405[] = {
  {721,1},	{684,2},	{685,2},	{758,0},
  {759,0},	{686,0},	{723,0},	{760,0}
};

static struct patval pat406[] = {
  {684,1},	{721,1},	{722,1},	{648,2},
  {685,2},	{723,2},	{759,0},	{796,0},
  {833,0},	{649,0},	{686,0},	{758,0},
  {760,0},	{797,0},	{834,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {835,0}
};

static struct patval pat407[] = {
  {684,1},	{795,1},	{685,2},	{759,0},
  {686,0},	{723,0},	{760,0},	{797,0}
};

static struct patval pat408[] = {
  {684,1},	{796,1},	{685,2},	{759,0},
  {686,0},	{723,0},	{760,0},	{797,0}
};

static struct patval pat409[] = {
  {684,1},	{758,1},	{685,2},	{759,0},
  {686,0},	{723,0},	{760,0}
};

static struct patval pat410[] = {
  {758,1},	{721,1},	{684,2},	{722,2},
  {759,0},	{649,0},	{686,0},	{723,0},
  {760,0}
};

static struct patval pat411[] = {
  {685,1},	{721,1},	{684,2},	{722,2},
  {648,2},	{795,0},	{758,0},	{759,0},
  {796,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{797,0}
};

static struct patval pat412[] = {
  {684,1},	{759,1},	{796,1},	{686,2},
  {760,2},	{687,4},	{758,0},	{723,0},
  {797,0},	{795,0},	{724,0},	{761,0},
  {798,0}
};

static struct patval pat413[] = {
  {611,1},	{758,1},	{648,2},	{722,2},
  {684,2},	{723,4},	{685,4},	{686,4},
  {649,4},	{612,4},	{796,0},	{759,0},
  {795,0},	{760,0},	{797,0}
};

static struct patval pat414[] = {
  {833,1},	{684,1},	{797,1},	{834,1},
  {795,2},	{796,2},	{722,2},	{760,2},
  {721,3},	{758,4},	{759,0},	{649,0},
  {686,0},	{723,0}
};

static struct patval pat415[] = {
  {722,1},	{758,1},	{684,2},	{757,0},
  {759,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{650,0},	{687,0},	{724,0},
  {761,0}
};

static struct patval pat416[] = {
  {684,1},	{721,1},	{685,2},	{648,2},
  {649,2},	{758,0},	{759,0},	{686,0},
  {723,0},	{760,0}
};

static struct patval pat417[] = {
  {684,1},	{722,1},	{723,2},	{685,2},
  {796,3},	{721,3},	{758,3},	{648,4},
  {649,4},	{686,0},	{759,0},	{760,0},
  {797,0},	{834,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0}
};

static struct patval pat418[] = {
  {684,1},	{648,2},	{683,3},	{758,0},
  {759,0}
};

static struct patval pat419[] = {
  {684,1},	{721,2},	{759,2},	{832,0},
  {795,0},	{796,0},	{833,0},	{649,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{835,0}
};

static struct patval pat420[] = {
  {758,1},	{759,2},	{684,2},	{794,0},
  {795,0},	{832,0},	{757,0},	{796,0},
  {686,0},	{723,0},	{760,0},	{797,0}
};

static struct patval pat421[] = {
  {648,1},	{684,1},	{685,2},	{649,2},
  {574,2},	{611,0},	{575,0},	{612,0},
  {610,0},	{686,0},	{723,0},	{576,0},
  {613,0},	{650,0},	{687,0},	{724,0}
};

static struct patval pat422[] = {
  {648,1},	{721,1},	{684,1},	{685,2},
  {722,2},	{611,0},	{610,0},	{612,0},
  {649,0},	{686,0},	{723,0},	{613,0},
  {650,0},	{687,0},	{724,0}
};

static struct patval pat423[] = {
  {684,1},	{758,1},	{721,2},	{685,2},
  {759,0},	{686,0},	{723,0},	{760,0}
};

static struct patval pat424[] = {
  {684,1},	{721,1},	{685,1},	{722,2},
  {760,2},	{686,0},	{723,0},	{649,0},
  {650,0},	{687,0},	{724,0},	{761,0}
};

static struct patval pat425[] = {
  {721,1},	{759,1},	{684,1},	{722,2},
  {686,2},	{611,2},	{758,0},	{610,0},
  {612,0},	{649,0},	{723,0},	{760,0},
  {613,0},	{650,0},	{687,0},	{724,0},
  {761,0}
};

static struct patval pat426[] = {
  {721,1},	{684,1},	{648,1},	{796,2},
  {723,2},	{685,2},	{611,0},	{758,0},
  {759,0},	{612,0},	{649,0},	{686,0},
  {795,0},	{760,0},	{797,0},	{613,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {798,0}
};

static struct patval pat427[] = {
  {684,1},	{721,2},	{759,2},	{649,0},
  {686,0},	{723,0},	{760,0}
};

static struct patval pat428[] = {
  {684,1},	{721,2},	{758,4},	{760,4},
  {759,4},	{610,0},	{611,0},	{612,0},
  {649,0},	{686,0},	{723,0}
};

static struct patval pat429[] = {
  {721,1},	{722,1},	{685,2},	{684,2},
  {757,0},	{794,0},	{831,0},	{830,0},
  {719,0},	{758,0},	{795,0},	{832,0},
  {756,0},	{793,0},	{759,0},	{796,0},
  {833,0},	{686,0},	{723,0},	{760,0},
  {797,0},	{834,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{835,0}
};

static struct patval pat430[] = {
  {684,1},	{721,2},	{832,2},	{720,4},
  {758,0},	{795,0},	{611,0},	{759,0},
  {796,0},	{833,0},	{612,0},	{649,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0}
};

static struct patval pat431[] = {
  {684,1},	{648,1},	{685,2},	{722,2},
  {723,4},	{724,4},	{610,0},	{611,0},
  {575,0},	{612,0},	{649,0},	{686,0},
  {576,0},	{613,0},	{650,0},	{687,0},
  {574,0}
};

static struct patval pat432[] = {
  {611,1},	{648,1},	{684,1},	{649,2},
  {685,2},	{722,2},	{724,4},	{723,4},
  {575,0},	{612,0},	{610,0},	{686,0},
  {576,0},	{613,0},	{650,0},	{687,0},
  {574,0}
};

static struct patval pat433[] = {
  {685,1},	{684,1},	{721,2},	{722,2},
  {760,4},	{649,0},	{686,0},	{723,0}
};

static struct patval pat434[] = {
  {685,1},	{684,1},	{722,2},	{612,3},
  {760,4},	{649,0},	{686,0},	{723,0},
  {611,0}
};

static struct patval pat435[] = {
  {685,1},	{684,1},	{722,2},	{647,4},
  {760,4},	{649,0},	{686,0},	{723,0},
  {611,0}
};

static struct patval pat436[] = {
  {685,1},	{684,1},	{649,1},	{722,2},
  {686,2},	{647,4},	{760,4},	{723,0},
  {611,0}
};

static struct patval pat437[] = {
  {685,1},	{684,1},	{649,1},	{722,2},
  {686,2},	{647,4},	{760,4},	{723,0},
  {611,0}
};

static struct patval pat438[] = {
  {684,1},	{648,1},	{685,2},	{723,4},
  {574,0},	{610,0},	{612,0},	{649,0},
  {686,0},	{611,0}
};

static struct patval pat439[] = {
  {684,1},	{721,2},	{719,4},	{682,4},
  {757,0},	{610,0},	{609,0},	{758,0},
  {611,0},	{759,0},	{612,0},	{649,0},
  {686,0},	{723,0},	{760,0}
};

static struct patval pat440[] = {
  {722,1},	{721,1},	{684,2},	{685,2},
  {609,4},	{719,4},	{683,4},	{612,4},
  {613,4},	{610,4},	{645,4},	{646,4},
  {682,4},	{756,4},	{795,4},	{611,4},
  {796,4},	{758,0},	{759,0},	{649,0},
  {686,0},	{723,0},	{760,0},	{757,0},
  {650,0},	{687,0},	{724,0},	{761,0}
};

static struct patval pat441[] = {
  {722,1},	{721,1},	{684,2},	{685,2},
  {646,3},	{757,0},	{682,0},	{758,0},
  {719,0},	{645,0},	{759,0},	{649,0},
  {686,0},	{723,0},	{760,0},	{650,0},
  {687,0},	{724,0},	{761,0}
};

static struct patval pat442[] = {
  {684,1},	{832,2},	{758,2},	{794,0},
  {831,0},	{757,0},	{795,0},	{759,0},
  {796,0},	{833,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0}
};

static struct patval pat443[] = {
  {759,1},	{684,2},	{757,0},	{758,0},
  {795,0},	{796,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{798,0}
};

static struct patval pat444[] = {
  {758,1},	{684,2},	{647,4},	{832,4},
  {648,4},	{793,0},	{794,0},	{757,0},
  {795,0},	{759,0},	{796,0},	{649,0},
  {686,0},	{723,0},	{760,0},	{797,0}
};

static struct patval pat445[] = {
  {758,1},	{684,2},	{647,4},	{832,4},
  {648,4},	{793,0},	{794,0},	{757,0},
  {795,0},	{759,0},	{796,0},	{649,0},
  {686,0},	{723,0},	{760,0},	{797,0}
};

static struct patval pat446[] = {
  {796,1},	{758,1},	{759,2},	{684,2},
  {832,4},	{793,0},	{794,0},	{795,0},
  {757,0},	{686,0},	{723,0},	{760,0},
  {797,0}
};

static struct patval pat447[] = {
  {796,1},	{758,1},	{759,2},	{684,2},
  {832,4},	{793,0},	{794,0},	{795,0},
  {757,0},	{686,0},	{723,0},	{760,0},
  {797,0}
};

static struct patval pat448[] = {
  {684,1},	{759,1},	{686,2},	{795,0},
  {758,0},	{796,0},	{723,0},	{760,0},
  {797,0},	{687,0},	{724,0},	{761,0},
  {798,0}
};

static struct patval pat449[] = {
  {795,1},	{684,2},	{722,2},	{685,4},
  {686,4},	{832,0},	{759,0},	{796,0},
  {833,0},	{758,0},	{723,0},	{760,0},
  {797,0},	{834,0}
};

static struct patval pat450[] = {
  {758,1},	{832,2},	{684,2},	{756,3},
  {793,0},	{757,0},	{794,0},	{831,0},
  {830,0},	{719,0},	{795,0},	{682,0},
  {759,0},	{796,0},	{833,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0}
};

static struct patval pat451[] = {
  {722,1},	{758,1},	{832,2},	{759,2},
  {684,2},	{756,3},	{757,0},	{794,0},
  {831,0},	{830,0},	{719,0},	{795,0},
  {682,0},	{793,0},	{796,0},	{833,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0}
};

static struct patval pat452[] = {
  {796,1},	{758,1},	{722,1},	{759,2},
  {832,2},	{721,2},	{684,2},	{756,3},
  {794,0},	{831,0},	{757,0},	{719,0},
  {795,0},	{682,0},	{793,0},	{830,0},
  {833,0},	{686,0},	{723,0},	{760,0},
  {797,0},	{834,0}
};

static struct patval pat453[] = {
  {684,1},	{685,1},	{648,2},	{611,0},
  {610,0},	{612,0},	{649,0},	{686,0},
  {723,0},	{613,0},	{650,0},	{687,0},
  {724,0}
};

static struct patval pat454[] = {
  {684,1},	{648,1},	{611,2},	{574,0},
  {573,0},	{610,0},	{575,0},	{612,0},
  {649,0},	{686,0},	{576,0},	{613,0},
  {650,0},	{687,0}
};

static struct patval pat455[] = {
  {648,1},	{684,1},	{611,2},	{499,0},
  {610,0},	{500,0},	{537,0},	{574,0},
  {536,0},	{573,0},	{501,0},	{538,0},
  {575,0},	{612,0},	{649,0},	{686,0},
  {502,0},	{539,0},	{576,0},	{613,0},
  {650,0},	{687,0}
};

static struct patval pat456[] = {
  {796,1},	{795,1},	{684,2},	{759,2},
  {758,0},	{686,0},	{723,0},	{760,0},
  {797,0}
};

static struct patval pat457[] = {
  {684,1},	{721,2},	{757,0},	{758,0},
  {759,0}
};

static struct patval pat458[] = {
  {795,1},	{796,1},	{759,2},	{684,2},
  {757,4},	{758,0},	{686,0},	{723,0},
  {760,0},	{797,0}
};

static struct patval pat459[] = {
  {684,1},	{723,1},	{722,1},	{611,2},
  {686,2},	{612,0},	{649,0},	{613,0},
  {650,0},	{687,0},	{724,0}
};

static struct patval pat460[] = {
  {721,1},	{758,1},	{684,2},	{757,0},
  {645,0},	{682,0},	{759,0},	{649,0},
  {686,0},	{723,0},	{760,0}
};

static struct patval pat461[] = {
  {722,1},	{686,1},	{723,1},	{684,2},
  {685,2},	{649,2},	{612,0},	{611,0}
};

static struct patval pat462[] = {
  {684,1},	{797,1},	{834,1},	{833,1},
  {795,2},	{722,2},	{760,2},	{796,2},
  {685,3},	{759,0},	{723,0},	{686,0},
  {758,0}
};

static struct patval pat463[] = {
  {684,1},	{685,2},	{609,0},	{757,0},
  {610,0},	{758,0},	{611,0},	{759,0},
  {612,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{613,0},	{650,0},	{687,0},
  {724,0},	{761,0}
};

static struct patval pat464[] = {
  {758,1},	{722,1},	{684,2},	{759,0},
  {649,0},	{686,0},	{723,0},	{760,0},
  {650,0},	{687,0},	{724,0},	{761,0}
};

static struct patval pat465[] = {
  {684,2},	{832,2},	{794,0},	{831,0},
  {757,0},	{758,0},	{795,0},	{759,0},
  {796,0},	{833,0}
};

static struct patval pat466[] = {
  {684,1},	{759,2},	{611,2},	{610,0},
  {758,0},	{612,0},	{649,0},	{686,0},
  {723,0},	{760,0}
};

static struct patval pat467[] = {
  {684,1},	{574,2},	{723,2},	{721,3},
  {573,4},	{610,0},	{575,0},	{612,0},
  {649,0},	{686,0},	{611,0},	{576,0},
  {613,0},	{650,0},	{687,0},	{724,0},
  {577,0},	{614,0},	{651,0},	{688,0},
  {725,0}
};

static struct patval pat468[] = {
  {833,2},	{684,2},	{757,0},	{795,0},
  {832,0},	{759,0},	{796,0},	{758,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{835,0}
};

static struct patval pat469[] = {
  {832,2},	{684,2},	{758,0},	{795,0},
  {757,0},	{759,0},	{796,0},	{833,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{835,0}
};

static struct patval pat470[] = {
  {684,1},	{612,2},	{797,2},	{611,0},
  {759,0},	{796,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{613,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {614,0},	{651,0},	{688,0},	{725,0},
  {762,0},	{799,0}
};

static struct patval pat471[] = {
  {684,1},	{721,2},	{648,2},	{649,0},
  {686,0},	{723,0},	{650,0},	{687,0},
  {724,0}
};

static struct patval pat472[] = {
  {832,2},	{684,2},	{758,0},	{795,0},
  {757,0},	{759,0},	{796,0},	{833,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0}
};

static struct patval pat473[] = {
  {832,2},	{684,2},	{758,0},	{795,0},
  {757,0},	{759,0},	{796,0},	{833,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0}
};

static struct patval pat474[] = {
  {684,1},	{685,2},	{612,4},	{759,4},
  {611,4},	{610,0},	{758,0},	{649,0},
  {686,0},	{723,0},	{760,0},	{613,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {614,0},	{651,0},	{688,0},	{725,0},
  {762,0}
};

static struct patval pat475[] = {
  {684,1},	{685,1},	{648,2},	{722,2},
  {649,0},	{686,0},	{723,0},	{650,0},
  {687,0},	{724,0}
};

static struct patval pat476[] = {
  {684,1},	{648,1},	{649,1},	{687,1},
  {759,2},	{685,2},	{686,2},	{723,0},
  {760,0},	{761,0}
};

static struct patval pat477[] = {
  {685,1},	{648,1},	{684,2},	{758,0},
  {759,0},	{649,0},	{686,0},	{723,0},
  {760,0}
};

static struct patval pat478[] = {
  {721,1},	{685,1},	{684,2},	{610,0},
  {609,0},	{611,0},	{612,0},	{649,0},
  {686,0},	{723,0}
};

static struct patval pat479[] = {
  {722,1},	{685,1},	{721,2},	{684,2},
  {573,0},	{610,0},	{572,0},	{609,0},
  {574,0},	{611,0},	{575,0},	{612,0},
  {649,0},	{686,0},	{723,0}
};

static struct patval pat480[] = {
  {722,1},	{686,1},	{760,1},	{684,2},
  {685,2},	{575,4},	{573,4},	{574,4},
  {610,4},	{611,0},	{612,0},	{649,0},
  {723,0}
};

static struct patval pat481[] = {
  {723,1},	{797,1},	{761,1},	{759,2},
  {760,2},	{684,2},	{798,3},	{796,0},
  {686,0},	{687,0},	{724,0},	{758,0},
  {795,0}
};

static struct patval pat482[] = {
  {684,1},	{759,1},	{797,1},	{686,2},
  {760,2},	{687,4},	{796,0},	{723,0},
  {758,0},	{795,0},	{724,0},	{761,0},
  {798,0}
};

static struct patval pat483[] = {
  {684,2},	{755,0},	{792,0},	{718,0},
  {866,0},	{682,0},	{719,0},	{756,0},
  {793,0},	{830,0},	{867,0},	{757,0},
  {794,0},	{831,0},	{868,0},	{829,0},
  {758,0},	{795,0},	{832,0},	{869,0},
  {759,0},	{796,0},	{833,0},	{870,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0},	{871,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{835,0},	{872,0}
};

static struct patval pat484[] = {
  {684,2},	{718,0},	{755,0},	{792,0},
  {829,0},	{866,0},	{645,0},	{682,0},
  {719,0},	{756,0},	{793,0},	{830,0},
  {867,0},	{757,0},	{794,0},	{831,0},
  {868,0},	{681,0},	{758,0},	{795,0},
  {832,0},	{869,0},	{759,0},	{796,0},
  {833,0},	{870,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0},	{871,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {835,0},	{872,0}
};

static struct patval pat485[] = {
  {684,2},	{758,2},	{794,0},	{831,0},
  {868,0},	{757,0},	{795,0},	{832,0},
  {869,0},	{759,0},	{796,0},	{833,0},
  {870,0}
};

static struct patval pat486[] = {
  {684,2},	{721,2},	{720,3},	{722,3},
  {573,0},	{610,0},	{572,0},	{609,0},
  {574,0},	{611,0}
};

static struct patval pat487[] = {
  {721,2},	{684,2},	{758,0},	{759,0},
  {649,0},	{686,0},	{723,0},	{760,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {651,0},	{688,0},	{725,0},	{762,0}
};

static struct patval pat488[] = {
  {721,2},	{684,2},	{644,0},	{645,0},
  {682,0},	{719,0},	{681,0},	{718,0}
};

static struct patval pat489[] = {
  {685,2},	{684,2},	{610,0},	{574,0},
  {611,0},	{573,0},	{612,0},	{649,0}
};

static struct patval pat490[] = {
  {684,2},	{686,2},	{723,4},	{721,4},
  {722,4},	{573,0},	{611,0},	{574,0},
  {612,0},	{649,0},	{610,0}
};

static struct patval pat491[] = {
  {685,2},	{684,2},	{646,4},	{573,0},
  {610,0},	{536,0},	{537,0},	{574,0},
  {611,0},	{609,0},	{575,0},	{612,0},
  {649,0}
};

static struct patval pat492[] = {
  {686,2},	{684,2},	{721,4},	{723,4},
  {722,4},	{609,0},	{537,0},	{574,0},
  {611,0},	{536,0},	{575,0},	{612,0},
  {649,0},	{573,0},	{610,0}
};

static struct patval pat493[] = {
  {684,2},	{795,2},	{796,2},	{759,0},
  {758,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{687,0}
};

static struct patval pat494[] = {
  {684,2},	{687,2},	{758,2},	{795,4},
  {721,4},	{759,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{724,0},	{761,0},
  {798,0},	{762,0}
};

static struct patval pat495[] = {
  {684,1},	{611,1},	{721,2},	{685,2},
  {610,0},	{609,0}
};

static struct patval pat496[] = {
  {685,2},	{684,2},	{573,3},	{575,3},
  {686,4},	{611,0},	{574,0},	{610,0},
  {612,0},	{649,0}
};

static struct patval pat497[] = {
  {612,1},	{686,2},	{684,2},	{609,4},
  {610,0},	{574,0},	{611,0},	{575,0},
  {573,0},	{649,0},	{576,0},	{613,0},
  {650,0}
};

static struct patval pat498[] = {
  {648,1},	{612,1},	{686,2},	{611,2},
  {684,2},	{609,4},	{574,0},	{610,0},
  {575,0},	{573,0},	{649,0},	{576,0},
  {613,0},	{650,0}
};

static struct patval pat499[] = {
  {648,1},	{612,1},	{686,2},	{611,2},
  {684,2},	{609,4},	{574,0},	{610,0},
  {575,0},	{573,0},	{649,0},	{576,0},
  {613,0},	{650,0}
};

static struct patval pat500[] = {
  {649,1},	{687,1},	{686,2},	{724,2},
  {684,2},	{611,3},	{650,3},	{648,3},
  {612,3},	{613,3},	{647,3},	{723,0},
  {610,0}
};

static struct patval pat501[] = {
  {684,2},	{758,0},	{795,0},	{832,0},
  {869,0},	{759,0},	{796,0},	{833,0},
  {870,0},	{723,0},	{760,0},	{797,0},
  {834,0},	{871,0}
};

static struct patval pat502[] = {
  {684,2},	{758,0},	{795,0},	{832,0},
  {759,0},	{796,0},	{833,0},	{723,0},
  {760,0},	{797,0},	{834,0}
};

static struct patval pat503[] = {
  {684,2},	{649,0},	{686,0},	{723,0},
  {650,0},	{687,0},	{724,0},	{651,0},
  {688,0},	{725,0}
};

static struct patval pat504[] = {
  {684,2},	{758,0},	{795,0},	{759,0},
  {796,0},	{723,0},	{760,0},	{797,0}
};

static struct patval pat505[] = {
  {684,2},	{758,0},	{795,0},	{759,0},
  {796,0},	{686,0},	{723,0},	{760,0},
  {797,0}
};

static struct patval pat506[] = {
  {684,2},	{649,0},	{686,0},	{723,0},
  {650,0},	{687,0},	{724,0}
};

static struct patval pat507[] = {
  {722,1},	{684,2},	{759,2},	{757,3},
  {758,0}
};

static struct patval pat508[] = {
  {649,1},	{611,2},	{686,2},	{684,2},
  {612,0}
};

static struct patval pat509[] = {
  {722,1},	{684,2},	{759,2},	{795,2},
  {758,0},	{757,0}
};

static struct patval pat510[] = {
  {685,1},	{686,1},	{684,2},	{649,2},
  {611,0}
};

static struct patval pat511[] = {
  {685,1},	{686,1},	{684,2},	{649,2},
  {611,0}
};

static struct patval pat512[] = {
  {648,1},	{611,2},	{684,2},	{610,0}
};

static struct patval pat513[] = {
  {648,1},	{611,2},	{684,2},	{610,0},
  {645,0},	{609,0}
};

static struct patval pat514[] = {
  {648,1},	{611,2},	{684,2},	{610,0},
  {645,0},	{609,0}
};

static struct patval pat515[] = {
  {721,1},	{723,1},	{684,2},	{682,4},
  {757,0},	{719,0},	{758,0},	{759,0},
  {649,0},	{686,0},	{760,0}
};

static struct patval pat516[] = {
  {759,1},	{684,1},	{758,2},	{795,0},
  {796,0},	{833,0}
};

static struct patval pat517[] = {
  {759,1},	{684,1},	{758,2},	{795,0},
  {796,0},	{833,0}
};

static struct patval pat518[] = {
  {721,1},	{684,2},	{796,2},	{758,0},
  {759,0},	{795,0},	{686,0},	{723,0},
  {760,0}
};

static struct patval pat519[] = {
  {686,1},	{612,1},	{611,2},	{684,2},
  {610,0},	{537,0},	{574,0},	{536,0},
  {538,0},	{575,0},	{573,0},	{649,0},
  {539,0},	{576,0},	{613,0},	{650,0},
  {687,0}
};

static struct patval pat520[] = {
  {685,1},	{684,1},	{722,2},	{721,2},
  {686,0},	{723,0}
};

static struct patval pat521[] = {
  {649,1},	{612,1},	{574,1},	{611,2},
  {684,2},	{648,2},	{538,0},	{575,0},
  {537,0},	{686,0},	{613,0},	{650,0}
};

static struct patval pat522[] = {
  {759,1},	{758,2},	{684,2},	{757,4},
  {720,4},	{683,4}
};

static struct patval pat523[] = {
  {759,1},	{722,2},	{684,2},	{757,4},
  {686,4},	{720,4},	{648,4},	{683,4},
  {758,0}
};

static struct patval pat524[] = {
  {759,1},	{723,1},	{760,1},	{684,2},
  {686,2},	{722,2},	{648,4},	{683,4},
  {757,4},	{720,4},	{758,0}
};

static struct patval pat525[] = {
  {684,1},	{721,1},	{796,2},	{760,2},
  {722,2},	{759,0},	{758,0},	{795,0}
};

static struct patval pat526[] = {
  {721,1},	{684,2},	{682,0},	{719,0}
};

static struct patval pat527[] = {
  {721,1},	{685,2},	{684,2},	{682,0},
  {719,0}
};

static struct patval pat528[] = {
  {721,1},	{684,2},	{722,3},	{682,0},
  {719,0}
};

static struct patval pat529[] = {
  {758,1},	{795,1},	{721,1},	{684,2},
  {796,2},	{759,2},	{722,2},	{832,0},
  {794,0},	{757,0},	{833,0}
};

static struct patval pat530[] = {
  {758,1},	{721,1},	{684,2},	{722,2},
  {759,2},	{795,0},	{757,0},	{796,0}
};

static struct patval pat531[] = {
  {686,1},	{648,1},	{684,2},	{685,2},
  {759,0},	{649,0},	{758,0},	{723,0},
  {760,0},	{650,0},	{687,0},	{724,0},
  {761,0}
};

static struct patval pat532[] = {
  {684,1},	{722,1},	{721,2},	{759,2},
  {758,2},	{719,4},	{757,0},	{645,0},
  {682,0}
};

static struct patval pat533[] = {
  {759,1},	{721,1},	{686,2},	{684,2},
  {722,2},	{796,0},	{758,0},	{723,0},
  {760,0},	{797,0},	{724,0},	{761,0},
  {798,0}
};

static struct patval pat534[] = {
  {613,1},	{684,1},	{689,2},	{686,2},
  {612,2},	{649,0},	{650,0},	{687,0},
  {651,0},	{688,0},	{652,0}
};

static struct patval pat535[] = {
  {686,1},	{684,2},	{685,2},	{688,2},
  {725,4},	{762,4},	{760,0},	{687,0},
  {724,0},	{761,0},	{723,0}
};

static struct patval pat536[] = {
  {722,1},	{758,1},	{721,2},	{684,2},
  {757,0},	{794,0},	{793,0},	{756,0},
  {795,0},	{719,0},	{759,0},	{796,0}
};

static struct patval pat537[] = {
  {723,1},	{686,2},	{684,2},	{795,4},
  {758,4},	{721,4},	{796,4},	{759,0}
};

static struct patval pat538[] = {
  {723,1},	{686,2},	{684,2},	{795,4},
  {758,4},	{721,4},	{796,4},	{759,0}
};

static struct patval pat539[] = {
  {723,1},	{686,1},	{685,1},	{797,2},
  {758,2},	{722,2},	{684,2},	{795,4},
  {796,0},	{760,0},	{759,0}
};

static struct patval pat540[] = {
  {684,1},	{686,1},	{722,1},	{685,2},
  {723,2},	{759,0},	{796,0},	{758,0},
  {760,0},	{797,0}
};

static struct patval pat541[] = {
  {684,1},	{648,1},	{723,2},	{721,2},
  {685,2},	{722,4},	{611,0},	{574,0},
  {575,0},	{612,0},	{649,0},	{686,0},
  {610,0},	{613,0},	{650,0},	{687,0}
};

static struct patval pat542[] = {
  {684,1},	{649,2},	{685,2},	{686,4},
  {611,0},	{610,0}
};

static struct patval pat543[] = {
  {685,1},	{611,1},	{684,2},	{758,0},
  {759,0},	{612,0},	{649,0},	{686,0},
  {723,0},	{760,0}
};

static struct patval pat544[] = {
  {685,1},	{759,2},	{684,2}
};

static struct patval pat545[] = {
  {759,1},	{795,1},	{721,1},	{684,2},
  {722,2},	{685,4},	{758,0},	{757,0},
  {719,0}
};

static struct patval pat546[] = {
  {611,1},	{612,2},	{684,2},	{610,3},
  {686,4},	{649,0}
};

static struct patval pat547[] = {
  {685,1},	{684,2},	{610,3},	{646,3},
  {611,0}
};

static struct patval pat548[] = {
  {722,1},	{684,2},	{681,0},	{792,0},
  {829,0},	{682,0},	{719,0},	{756,0},
  {793,0},	{830,0},	{757,0},	{794,0},
  {831,0},	{718,0},	{758,0},	{795,0},
  {832,0},	{755,0},	{759,0},	{796,0},
  {833,0}
};

static struct patval pat549[] = {
  {758,1},	{684,2},	{681,0},	{755,0},
  {644,0},	{645,0},	{682,0},	{719,0},
  {756,0},	{793,0},	{757,0},	{794,0},
  {718,0},	{792,0},	{795,0},	{759,0},
  {796,0}
};

static struct patval pat550[] = {
  {684,1},	{611,2},	{610,0},	{612,0},
  {649,0},	{686,0},	{723,0},	{650,0},
  {687,0},	{724,0}
};

static struct patval pat551[] = {
  {724,1},	{723,1},	{684,2},	{610,0},
  {612,0},	{649,0},	{686,0},	{613,0},
  {650,0},	{687,0},	{611,0}
};

static struct patval pat552[] = {
  {686,1},	{684,2},	{610,0},	{611,0},
  {612,0},	{649,0}
};

static struct patval pat553[] = {
  {684,1},	{797,1},	{795,2},	{759,0},
  {796,0},	{686,0},	{723,0},	{760,0},
  {758,0}
};

static struct patval pat554[] = {
  {686,1},	{685,1},	{684,2},	{797,2},
  {757,0},	{758,0},	{795,0},	{759,0},
  {796,0},	{723,0},	{760,0},	{794,0}
};

static struct patval pat555[] = {
  {685,1},	{721,1},	{686,1},	{795,1},
  {758,2},	{722,2},	{684,2},	{796,0},
  {759,0},	{723,0},	{760,0},	{797,0}
};

static struct patval pat556[] = {
  {649,1},	{722,2},	{684,2},	{610,0},
  {611,0},	{612,0},	{686,0}
};

static struct patval pat557[] = {
  {722,1},	{685,1},	{687,1},	{684,2},
  {648,2},	{611,0},	{612,0},	{649,0},
  {686,0},	{723,0},	{613,0},	{650,0},
  {610,0},	{724,0}
};

static struct patval pat558[] = {
  {722,1},	{684,2},	{681,0},	{792,0},
  {829,0},	{682,0},	{719,0},	{756,0},
  {793,0},	{830,0},	{757,0},	{794,0},
  {831,0},	{718,0},	{758,0},	{795,0},
  {832,0},	{755,0},	{759,0},	{796,0},
  {833,0}
};

static struct patval pat559[] = {
  {722,1},	{684,2},	{681,0},	{792,0},
  {829,0},	{682,0},	{719,0},	{756,0},
  {793,0},	{830,0},	{757,0},	{794,0},
  {831,0},	{718,0},	{758,0},	{795,0},
  {832,0},	{755,0},	{759,0},	{796,0},
  {833,0}
};

static struct patval pat560[] = {
  {722,1},	{684,2},	{681,0},	{792,0},
  {829,0},	{682,0},	{719,0},	{756,0},
  {793,0},	{830,0},	{757,0},	{794,0},
  {831,0},	{718,0},	{758,0},	{795,0},
  {832,0},	{755,0},	{759,0},	{796,0},
  {833,0}
};

static struct patval pat561[] = {
  {758,1},	{833,2},	{684,2},	{795,0},
  {759,0},	{796,0},	{832,0},	{723,0},
  {760,0},	{797,0}
};

static struct patval pat562[] = {
  {684,1},	{759,2},	{611,2},	{612,4},
  {610,0},	{758,0},	{649,0},	{686,0},
  {723,0}
};

static struct patval pat563[] = {
  {685,1},	{721,1},	{686,1},	{649,2},
  {648,2},	{684,2},	{682,0}
};

static struct patval pat564[] = {
  {758,1},	{684,2},	{681,0},	{755,0},
  {644,0},	{645,0},	{682,0},	{719,0},
  {756,0},	{793,0},	{757,0},	{794,0},
  {718,0},	{792,0},	{795,0},	{759,0},
  {796,0}
};

static struct patval pat565[] = {
  {758,1},	{684,2},	{681,0},	{755,0},
  {644,0},	{645,0},	{682,0},	{719,0},
  {756,0},	{793,0},	{757,0},	{794,0},
  {718,0},	{792,0},	{795,0},	{759,0},
  {796,0}
};

static struct patval pat566[] = {
  {685,1},	{648,1},	{684,2},	{721,2},
  {758,0},	{759,0},	{649,0},	{686,0},
  {723,0},	{760,0}
};

static struct patval pat567[] = {
  {684,1},	{721,1},	{685,2},	{648,2},
  {758,0},	{759,0},	{649,0},	{686,0},
  {723,0},	{760,0}
};

static struct patval pat568[] = {
  {648,1},	{684,1},	{721,2},	{685,2},
  {647,3},	{649,0},	{686,0},	{723,0},
  {650,0},	{687,0},	{724,0}
};

static struct patval pat569[] = {
  {649,1},	{612,1},	{648,2},	{686,2},
  {684,2},	{572,0},	{610,0},	{536,0},
  {537,0},	{574,0},	{611,0},	{573,0},
  {609,0}
};

static struct patval pat570[] = {
  {684,1},	{611,2},	{610,0},	{612,0},
  {649,0},	{686,0},	{723,0},	{650,0},
  {687,0},	{724,0}
};

static struct patval pat571[] = {
  {684,1},	{611,2},	{612,2},	{610,0},
  {649,0},	{686,0},	{723,0},	{650,0},
  {687,0},	{724,0}
};

static struct patval pat572[] = {
  {795,1},	{684,2},	{757,3},	{760,4},
  {758,0},	{759,0},	{796,0},	{723,0}
};

static struct patval pat573[] = {
  {722,1},	{684,2},	{758,4}
};

static struct patval pat574[] = {
  {722,1},	{758,2},	{684,2},	{757,3}
};

static struct patval pat575[] = {
  {721,1},	{684,2},	{722,2},	{682,0},
  {719,0}
};

static struct patval pat576[] = {
  {721,1},	{684,2},	{682,0},	{719,0}
};

static struct patval pat577[] = {
  {721,1},	{684,2},	{722,3},	{685,4},
  {681,4},	{718,4},	{719,0},	{682,0},
  {645,0}
};

static struct patval pat578[] = {
  {648,1},	{612,2},	{611,2},	{684,2},
  {649,3},	{645,4},	{608,4},	{610,0},
  {573,0},	{609,0},	{572,0}
};

static struct patval pat579[] = {
  {723,1},	{684,2},	{758,2},	{795,0},
  {759,0},	{796,0},	{649,0},	{686,0},
  {760,0},	{797,0},	{834,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{798,0}
};

static struct patval pat580[] = {
  {759,1},	{684,1},	{721,1},	{760,1},
  {722,2},	{685,2},	{611,0},	{612,0},
  {649,0},	{686,0},	{723,0}
};

static struct patval pat581[] = {
  {649,1},	{611,2},	{684,2},	{575,0},
  {612,0},	{613,0},	{650,0}
};

static struct patval pat582[] = {
  {722,1},	{685,2},	{684,2},	{757,0},
  {758,0}
};

static struct patval pat583[] = {
  {685,1},	{686,2},	{684,2},	{611,4},
  {610,0},	{612,0},	{649,0}
};

static struct patval pat584[] = {
  {758,1},	{795,2},	{684,2},	{796,2},
  {760,3},	{759,0}
};

static struct patval pat585[] = {
  {686,1},	{684,2},	{647,4},	{794,0},
  {757,0},	{758,0},	{795,0},	{759,0},
  {796,0},	{723,0},	{760,0},	{797,0}
};

static struct patval pat586[] = {
  {686,1},	{760,1},	{684,2},	{647,4},
  {794,0},	{758,0},	{795,0},	{759,0},
  {796,0},	{723,0},	{757,0},	{797,0}
};

static struct patval pat587[] = {
  {649,1},	{650,1},	{648,1},	{685,2},
  {684,2},	{759,0},	{686,0},	{723,0},
  {760,0},	{687,0},	{724,0},	{761,0}
};

static struct patval pat588[] = {
  {612,1},	{685,2},	{684,2},	{609,3},
  {610,0},	{574,0},	{611,0},	{573,0}
};

static struct patval pat589[] = {
  {612,1},	{575,2},	{685,2},	{684,2},
  {609,3},	{610,0},	{574,0},	{611,0},
  {573,0}
};

static struct patval pat590[] = {
  {722,1},	{684,2},	{649,2},	{610,0},
  {611,0},	{612,0},	{686,0},	{723,0},
  {613,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{725,0}
};

static struct patval pat591[] = {
  {759,1},	{684,2},	{835,2},	{686,0},
  {723,0},	{760,0},	{797,0},	{687,0},
  {724,0},	{761,0},	{798,0}
};

static struct patval pat592[] = {
  {649,1},	{685,2},	{684,2},	{686,2},
  {538,2},	{537,0},	{536,0},	{611,0},
  {573,0},	{574,0},	{575,0},	{612,0},
  {610,0}
};

static struct patval pat593[] = {
  {684,2},	{835,2},	{758,0},	{832,0},
  {759,0},	{796,0},	{833,0},	{723,0},
  {760,0},	{797,0},	{834,0},	{761,0},
  {798,0},	{795,0}
};

static struct patval pat594[] = {
  {723,1},	{684,2},	{798,2},	{759,0},
  {796,0},	{760,0},	{797,0},	{761,0},
  {758,0}
};

static struct patval pat595[] = {
  {760,1},	{724,1},	{688,1},	{687,2},
  {684,2},	{686,2},	{759,0},	{796,0},
  {723,0},	{795,0},	{758,0}
};

static struct patval pat596[] = {
  {724,1},	{684,2},	{611,0},	{612,0},
  {649,0},	{686,0},	{723,0},	{613,0},
  {650,0},	{687,0},	{610,0},	{614,0},
  {651,0},	{688,0},	{725,0}
};

static struct patval pat597[] = {
  {612,1},	{648,1},	{685,2},	{684,2},
  {722,4},	{724,4},	{649,0},	{723,0},
  {613,0},	{650,0},	{687,0},	{686,0}
};

static struct patval pat598[] = {
  {721,1},	{759,1},	{684,1},	{722,2},
  {685,2},	{611,0},	{610,0},	{612,0},
  {649,0},	{686,0},	{723,0}
};

static struct patval pat599[] = {
  {760,1},	{723,1},	{684,2},	{722,2},
  {685,4},	{795,0},	{832,0},	{758,0},
  {759,0},	{796,0},	{757,0},	{794,0}
};

static struct patval pat600[] = {
  {721,1},	{684,2},	{758,2},	{759,0},
  {723,0}
};

static struct patval pat601[] = {
  {684,1},	{758,1},	{721,2},	{759,0},
  {723,0}
};

static struct patval pat602[] = {
  {684,1},	{686,1},	{685,1},	{723,2},
  {721,2},	{719,0},	{757,0}
};

static struct patval pat603[] = {
  {758,1},	{684,1},	{794,0},	{831,0},
  {868,0},	{905,0},	{757,0},	{795,0},
  {832,0},	{869,0},	{906,0},	{759,0},
  {796,0},	{833,0},	{870,0},	{907,0}
};

static struct patval pat604[] = {
  {686,1},	{722,1},	{685,2},	{684,2},
  {757,3},	{758,0},	{795,0},	{759,0},
  {796,0},	{723,0},	{760,0}
};

static struct patval pat605[] = {
  {758,1},	{684,2},	{796,2},	{833,2},
  {795,0},	{759,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{835,0}
};

static struct patval pat606[] = {
  {796,1},	{722,1},	{684,2},	{832,2},
  {830,0},	{757,0},	{794,0},	{831,0},
  {756,0},	{758,0},	{795,0},	{682,0},
  {719,0},	{759,0},	{793,0}
};

static struct patval pat607[] = {
  {832,1},	{684,1},	{722,2},	{796,2},
  {830,0},	{757,0},	{794,0},	{831,0},
  {756,0},	{758,0},	{795,0},	{682,0},
  {719,0},	{759,0},	{793,0}
};

static struct patval pat608[] = {
  {688,1},	{615,2},	{684,2},	{611,0},
  {610,0},	{612,0},	{649,0},	{686,0},
  {613,0},	{650,0},	{687,0},	{614,0},
  {651,0},	{652,0}
};

static struct patval pat609[] = {
  {613,1},	{684,1},	{575,1},	{612,2},
  {650,2},	{649,2},	{610,0},	{537,0},
  {574,0},	{611,0},	{538,0},	{572,0},
  {609,0},	{576,0},	{573,0}
};

static struct patval pat610[] = {
  {721,1},	{759,1},	{722,2},	{684,2},
  {649,0},	{686,0},	{723,0},	{760,0},
  {687,0},	{724,0}
};

static struct patval pat611[] = {
  {761,1},	{684,2},	{722,2},	{649,0},
  {686,0},	{723,0},	{760,0},	{650,0},
  {687,0},	{724,0},	{651,0},	{688,0},
  {725,0}
};

static struct patval pat612[] = {
  {649,1},	{684,2},	{685,2},	{688,3},
  {759,0},	{686,0},	{723,0},	{760,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {758,0},	{725,0}
};

static struct patval pat613[] = {
  {684,1},	{723,1},	{722,1},	{721,2},
  {758,2},	{759,2},	{686,0},	{760,0},
  {797,0},	{834,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{835,0},	{688,0},
  {725,0},	{762,0},	{799,0}
};

static struct patval pat614[] = {
  {723,1},	{684,2},	{721,4},	{647,4},
  {649,0},	{686,0},	{760,0},	{650,0},
  {687,0},	{724,0}
};

static struct patval pat615[] = {
  {686,1},	{684,2},	{758,2},	{685,2},
  {760,2},	{722,3},	{721,4},	{723,0},
  {759,0}
};

static struct patval pat616[] = {
  {722,1},	{759,1},	{685,2},	{684,2},
  {758,0},	{757,0}
};

static struct patval pat617[] = {
  {684,1},	{686,1},	{724,2},	{723,2},
  {759,0},	{758,0},	{760,0},	{761,0}
};

static struct patval pat618[] = {
  {687,1},	{614,2},	{684,2},	{610,0},
  {611,0},	{612,0},	{649,0},	{686,0},
  {723,0},	{613,0},	{650,0},	{724,0},
  {651,0},	{688,0},	{725,0}
};

static struct patval pat619[] = {
  {722,1},	{684,1},	{687,2},	{650,2},
  {685,2},	{649,0},	{686,0},	{611,0}
};

static struct patval pat620[] = {
  {684,1},	{686,1},	{685,2},	{648,2},
  {759,0},	{758,0},	{723,0},	{760,0}
};

static struct patval pat621[] = {
  {723,1},	{721,1},	{686,2},	{684,2},
  {722,2},	{648,4},	{759,0},	{796,0},
  {758,0},	{795,0},	{760,0},	{797,0}
};

static struct patval pat622[] = {
  {686,1},	{684,1},	{649,2},	{685,2},
  {611,2},	{647,4},	{759,0},	{758,0},
  {723,0},	{760,0}
};

static struct patval pat623[] = {
  {722,1},	{684,2},	{757,0},	{758,0},
  {795,0},	{719,0},	{759,0},	{796,0}
};

static struct patval pat624[] = {
  {685,1},	{684,2},	{760,2},	{794,0},
  {758,0},	{795,0},	{759,0},	{796,0},
  {723,0},	{757,0},	{797,0}
};

static struct patval pat625[] = {
  {722,1},	{684,1},	{685,2},	{611,2},
  {612,0},	{649,0},	{686,0},	{723,0}
};

static struct patval pat626[] = {
  {684,1},	{649,2},	{647,3},	{687,4},
  {759,0},	{758,0},	{686,0},	{723,0},
  {760,0}
};

static struct patval pat627[] = {
  {684,1},	{721,2},	{612,2},	{723,2},
  {759,4},	{611,0},	{649,0},	{686,0},
  {650,0},	{687,0}
};

static struct patval pat628[] = {
  {648,1},	{721,2},	{684,2},	{650,2},
  {723,2},	{649,0},	{686,0},	{687,0}
};

static struct patval pat629[] = {
  {760,1},	{684,1},	{648,1},	{685,2},
  {649,2},	{647,3},	{650,4},	{724,4},
  {687,4},	{686,0},	{723,0},	{759,0},
  {758,0}
};

static struct patval pat630[] = {
  {684,1},	{612,1},	{611,2},	{610,4},
  {649,0},	{686,0}
};

static struct patval pat631[] = {
  {687,1},	{684,1},	{725,1},	{722,2},
  {724,2},	{723,2},	{686,0},	{649,0},
  {650,0},	{688,0},	{611,0}
};

static struct patval pat632[] = {
  {684,1},	{833,1},	{758,2},	{798,4},
  {686,4},	{724,4},	{687,4},	{796,0},
  {723,0},	{760,0},	{797,0},	{759,0},
  {761,0},	{795,0}
};

static struct patval pat633[] = {
  {684,1},	{647,3},	{610,3},	{794,0},
  {757,0},	{758,0},	{795,0},	{759,0},
  {796,0}
};

static struct patval pat634[] = {
  {684,1},	{610,3},	{647,3},	{793,4},
  {797,4},	{756,4},	{723,4},	{760,4},
  {719,4},	{682,0},	{758,0},	{795,0},
  {759,0},	{796,0},	{686,0},	{757,0},
  {794,0}
};

static struct patval pat635[] = {
  {684,1},	{610,3},	{647,3},	{723,4},
  {760,4},	{719,4},	{756,4},	{793,4},
  {792,4},	{755,4},	{797,4},	{718,4},
  {794,0},	{681,0},	{758,0},	{795,0},
  {759,0},	{796,0},	{686,0},	{682,0},
  {757,0}
};

static struct patval pat636[] = {
  {684,1},	{611,2},	{723,2},	{647,3},
  {610,3},	{612,0},	{649,0},	{686,0}
};

static struct patval pat637[] = {
  {685,1},	{686,1},	{684,2},	{649,0}
};

static struct patval pat638[] = {
  {722,1},	{759,1},	{796,2},	{684,2},
  {685,2},	{757,0},	{758,0},	{795,0},
  {794,0},	{719,0}
};

static struct patval pat639[] = {
  {758,1},	{684,1},	{722,2},	{757,0},
  {719,0}
};

static struct patval pat640[] = {
  {684,1},	{758,1},	{759,2},	{685,4},
  {757,0},	{719,0}
};

static struct patval pat641[] = {
  {684,1},	{795,2},	{797,2},	{647,3},
  {798,4},	{796,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{758,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{759,0}
};

static struct patval pat642[] = {
  {721,1},	{684,2},	{758,2},	{759,0},
  {723,0}
};

static struct patval pat643[] = {
  {686,1},	{650,1},	{649,2},	{684,2},
  {576,2},	{685,2},	{687,3},	{611,0},
  {575,0},	{612,0},	{610,0},	{574,0},
  {573,0},	{613,0}
};

static struct patval pat644[] = {
  {650,1},	{684,1},	{649,2},	{686,0},
  {723,0},	{687,0},	{724,0}
};

static struct patval pat645[] = {
  {684,2},	{682,3},	{756,3},	{758,3},
  {719,3},	{757,3}
};

static struct patval pat646[] = {
  {721,2},	{684,2},	{759,2},	{719,3},
  {793,3},	{794,3},	{756,3},	{795,3},
  {722,4},	{758,0},	{757,0}
};

static struct patval pat647[] = {
  {684,1},	{759,1},	{760,2},	{686,2},
  {687,4},	{758,0},	{796,0},	{723,0},
  {797,0},	{795,0},	{724,0},	{761,0},
  {798,0}
};

static struct patval pat648[] = {
  {687,1},	{684,1},	{685,2},	{611,2},
  {612,4},	{610,0},	{649,0},	{686,0},
  {723,0},	{613,0},	{650,0},	{724,0}
};

static struct patval pat649[] = {
  {684,1},	{611,2},	{724,2},	{650,4},
  {687,4},	{613,4},	{761,4},	{612,4},
  {759,0},	{649,0},	{686,0},	{723,0},
  {760,0}
};

static struct patval pat650[] = {
  {684,1},	{724,2},	{647,3},	{761,4},
  {759,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{650,0},	{687,0},	{758,0},
  {651,0},	{688,0},	{725,0},	{762,0}
};

static struct patval pat651[] = {
  {684,1},	{649,2},	{760,2},	{759,4},
  {686,0},	{723,0},	{687,0},	{724,0}
};

static struct patval pat652[] = {
  {684,1},	{649,2},	{760,2},	{759,4},
  {686,0},	{723,0},	{687,0},	{724,0}
};

static struct patval pat653[] = {
  {684,1},	{649,2},	{760,2},	{759,4},
  {686,0},	{723,0},	{687,0},	{724,0}
};

static struct patval pat654[] = {
  {684,1},	{721,1},	{759,2},	{685,2},
  {649,0},	{686,0},	{723,0},	{760,0}
};

static struct patval pat655[] = {
  {724,1},	{723,1},	{687,2},	{758,2},
  {684,2},	{649,2},	{759,0},	{796,0},
  {833,0},	{832,0},	{686,0},	{795,0},
  {760,0},	{797,0},	{834,0},	{650,0},
  {761,0},	{798,0},	{835,0},	{651,0},
  {688,0},	{725,0},	{762,0},	{799,0},
  {836,0}
};

static struct patval pat656[] = {
  {684,1},	{797,1},	{686,2},	{759,2},
  {796,0},	{723,0},	{760,0},	{687,0},
  {724,0},	{761,0},	{798,0}
};

static struct patval pat657[] = {
  {684,1},	{795,2},	{648,2},	{685,2},
  {721,2},	{870,3},	{869,3},	{868,3},
  {831,0},	{832,0},	{757,0},	{759,0},
  {796,0},	{833,0},	{758,0},	{649,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0},	{871,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0},
  {872,0}
};

static struct patval pat658[] = {
  {684,1},	{648,2},	{722,2},	{686,0}
};

static struct patval pat659[] = {
  {686,1},	{611,1},	{648,1},	{722,1},
  {685,2},	{684,2},	{649,0},	{612,0},
  {723,0}
};

static struct patval pat660[] = {
  {684,1},	{721,1},	{758,1},	{796,1},
  {832,1},	{685,1},	{795,2},	{759,0},
  {833,0}
};

static struct patval pat661[] = {
  {684,1},	{611,2},	{648,2},	{722,2},
  {612,0},	{649,0},	{686,0},	{723,0}
};

static struct patval pat662[] = {
  {722,1},	{611,1},	{648,1},	{684,2},
  {612,0},	{649,0},	{686,0},	{723,0}
};

static struct patval pat663[] = {
  {684,1},	{759,1},	{758,2},	{869,2},
  {719,3},	{756,3},	{682,3},	{645,3},
  {906,4},	{907,4},	{868,0},	{757,0},
  {795,0},	{832,0},	{794,0},	{831,0},
  {796,0},	{833,0},	{870,0},	{649,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0},	{871,0},	{908,0}
};

static struct patval pat664[] = {
  {724,1},	{649,1},	{684,2},	{723,2},
  {834,2},	{611,0},	{759,0},	{796,0},
  {833,0},	{612,0},	{686,0},	{610,0},
  {760,0},	{797,0},	{613,0},	{650,0},
  {687,0},	{761,0},	{798,0},	{835,0},
  {614,0},	{651,0},	{688,0},	{725,0},
  {762,0},	{799,0},	{836,0}
};

static struct patval pat665[] = {
  {649,1},	{724,1},	{834,2},	{684,2},
  {723,2},	{759,0},	{796,0},	{833,0},
  {686,0},	{760,0},	{797,0},	{650,0},
  {687,0},	{761,0},	{798,0},	{835,0},
  {651,0},	{688,0},	{725,0},	{762,0},
  {799,0},	{836,0}
};

static struct patval pat666[] = {
  {612,1},	{537,1},	{611,2},	{684,2},
  {759,4},	{758,4},	{723,4},	{760,4},
  {721,4},	{573,0},	{538,0},	{575,0},
  {610,0},	{649,0},	{686,0},	{574,0},
  {539,0},	{576,0},	{613,0},	{650,0},
  {687,0},	{724,0},	{761,0}
};

static struct patval pat667[] = {
  {684,1},	{722,2},	{721,2},	{685,2},
  {611,0},	{610,0},	{612,0},	{649,0},
  {686,0},	{723,0}
};

static struct patval pat668[] = {
  {759,1},	{685,1},	{721,1},	{648,2},
  {684,2},	{647,4},	{649,0},	{686,0},
  {723,0},	{760,0}
};

static struct patval pat669[] = {
  {685,1},	{686,1},	{758,2},	{648,2},
  {684,2},	{721,2},	{649,2},	{612,4},
  {613,4},	{723,0},	{760,0},	{759,0},
  {724,0},	{761,0}
};

static struct patval pat670[] = {
  {760,1},	{686,1},	{722,1},	{685,1},
  {648,2},	{758,2},	{721,2},	{650,2},
  {649,2},	{684,2},	{723,0},	{759,0},
  {797,0},	{796,0},	{687,0},	{724,0},
  {761,0},	{798,0}
};

static struct patval pat671[] = {
  {684,1},	{721,1},	{758,1},	{685,1},
  {796,1},	{795,2},	{648,2},	{759,0},
  {649,0},	{686,0},	{723,0},	{760,0},
  {797,0}
};

static struct patval pat672[] = {
  {722,1},	{648,1},	{684,2},	{649,0},
  {686,0},	{723,0}
};

static struct patval pat673[] = {
  {686,1},	{722,1},	{648,1},	{684,2},
  {685,2},	{721,2},	{759,0},	{649,0},
  {758,0},	{723,0},	{760,0}
};

static struct patval pat674[] = {
  {648,1},	{684,1},	{649,1},	{685,2},
  {574,0},	{575,0},	{612,0},	{611,0}
};

static struct patval pat675[] = {
  {684,1},	{685,1},	{721,2},	{610,0},
  {611,0}
};

static struct patval pat676[] = {
  {648,1},	{649,1},	{684,2},	{574,0},
  {575,0},	{612,0},	{611,0}
};

static struct patval pat677[] = {
  {685,1},	{648,1},	{684,2},	{649,3},
  {686,3},	{575,0},	{612,0},	{611,0},
  {574,0}
};

static struct patval pat678[] = {
  {684,1},	{795,1},	{758,2},	{796,2},
  {759,0},	{686,0},	{723,0},	{760,0},
  {797,0}
};

static struct patval pat679[] = {
  {687,1},	{685,1},	{686,1},	{649,2},
  {648,2},	{684,2},	{721,2},	{647,4},
  {758,4},	{796,0},	{723,0},	{760,0},
  {797,0},	{834,0},	{759,0},	{724,0},
  {761,0},	{798,0},	{835,0}
};

static struct patval pat680[] = {
  {686,1},	{723,1},	{759,1},	{685,1},
  {684,2},	{648,2},	{722,2},	{721,2},
  {647,4},	{796,0},	{649,0},	{758,0},
  {795,0},	{760,0},	{797,0}
};

static struct patval pat681[] = {
  {684,1},	{797,1},	{724,1},	{685,1},
  {722,2},	{721,2},	{759,0},	{795,0},
  {649,0},	{686,0},	{723,0},	{760,0},
  {796,0},	{650,0},	{687,0},	{758,0},
  {761,0},	{798,0},	{651,0},	{688,0},
  {725,0},	{762,0},	{799,0}
};

static struct patval pat682[] = {
  {759,1},	{721,1},	{685,1},	{758,2},
  {722,2},	{684,2},	{686,0},	{723,0},
  {760,0}
};

static struct patval pat683[] = {
  {684,1},	{722,2},	{685,2},	{646,4},
  {610,0},	{611,0},	{609,0},	{612,0},
  {649,0},	{686,0},	{723,0}
};

static struct patval pat684[] = {
  {684,1},	{685,2},	{612,2},	{647,3},
  {610,3},	{758,4},	{611,0},	{759,0},
  {649,0},	{686,0},	{723,0},	{760,0},
  {613,0},	{650,0},	{687,0},	{724,0},
  {761,0}
};

static struct patval pat685[] = {
  {684,1},	{574,2},	{685,2},	{647,3},
  {721,3},	{573,3},	{611,0},	{610,0},
  {575,0},	{612,0},	{649,0},	{686,0},
  {723,0},	{576,0},	{613,0},	{650,0},
  {687,0},	{724,0}
};

static struct patval pat686[] = {
  {684,1},	{685,2},	{796,2},	{610,3},
  {612,4},	{611,4},	{795,0},	{758,0},
  {759,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{613,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{798,0}
};

static struct patval pat687[] = {
  {684,1},	{722,1},	{758,1},	{685,2},
  {832,0},	{795,0},	{759,0},	{796,0},
  {833,0},	{686,0},	{723,0},	{760,0},
  {797,0},	{834,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{835,0}
};

static struct patval pat688[] = {
  {759,1},	{684,1},	{722,1},	{723,2},
  {685,2},	{686,2},	{721,3},	{834,3},
  {647,3},	{649,0},	{760,0},	{797,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{835,0},	{651,0},	{688,0},
  {725,0},	{762,0},	{799,0},	{836,0}
};

static struct patval pat689[] = {
  {759,1},	{684,1},	{760,1},	{722,1},
  {685,2},	{723,2},	{686,2},	{721,3},
  {647,3},	{834,3},	{649,0},	{797,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{835,0},	{651,0},	{688,0},
  {725,0},	{762,0},	{799,0},	{836,0}
};

static struct patval pat690[] = {
  {722,1},	{721,1},	{684,1},	{685,2},
  {648,2},	{796,3},	{610,0},	{759,0},
  {611,0},	{612,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{613,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {798,0}
};

static struct patval pat691[] = {
  {684,1},	{721,1},	{686,1},	{759,1},
  {758,2},	{796,2},	{795,4},	{649,0},
  {723,0},	{760,0},	{797,0}
};

static struct patval pat692[] = {
  {686,1},	{833,1},	{685,1},	{834,1},
  {759,1},	{832,2},	{684,2},	{796,0},
  {723,0},	{760,0},	{797,0}
};

static struct patval pat693[] = {
  {684,1},	{721,1},	{832,1},	{795,1},
  {759,1},	{758,2},	{796,0},	{833,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0}
};

static struct patval pat694[] = {
  {684,1},	{721,1},	{759,1},	{648,1},
  {758,2}
};

static struct patval pat695[] = {
  {759,1},	{721,1},	{686,1},	{685,1},
  {760,1},	{684,2},	{758,2},	{723,0}
};

static struct patval pat696[] = {
  {684,1},	{721,1},	{759,1},	{758,2}
};

static struct patval pat697[] = {
  {684,1},	{721,1},	{685,2},	{648,2},
  {832,0},	{795,0},	{758,0},	{759,0},
  {796,0},	{833,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{835,0}
};

static struct patval pat698[] = {
  {648,1},	{759,1},	{685,1},	{721,2},
  {684,2},	{832,4},	{833,4},	{834,4},
  {796,0},	{758,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{795,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {798,0}
};

static struct patval pat699[] = {
  {760,1},	{684,2},	{686,2},	{834,2},
  {685,2},	{832,0},	{759,0},	{796,0},
  {833,0},	{758,0},	{723,0},	{797,0},
  {795,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{835,0},	{688,0},	{725,0},
  {762,0},	{799,0},	{836,0}
};

static struct patval pat700[] = {
  {684,1},	{721,1},	{685,2},	{759,2},
  {648,2},	{832,0},	{758,0},	{795,0},
  {796,0},	{833,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0}
};

static struct patval pat701[] = {
  {684,1},	{649,2},	{795,0},	{759,0},
  {796,0},	{758,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{651,0},
  {688,0},	{725,0},	{762,0},	{799,0},
  {652,0},	{689,0},	{726,0},	{763,0},
  {800,0}
};

static struct patval pat702[] = {
  {684,1},	{722,1},	{723,1},	{760,1},
  {797,2},	{758,2},	{759,2},	{685,3},
  {907,3},	{906,3},	{796,0},	{833,0},
  {870,0},	{869,0},	{795,0},	{832,0},
  {834,0},	{871,0},	{908,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0},
  {872,0},	{909,0}
};

static struct patval pat703[] = {
  {685,1},	{611,1},	{649,1},	{648,2},
  {684,2},	{574,0},	{610,0},	{609,0},
  {612,0},	{686,0},	{613,0},	{650,0},
  {687,0}
};

static struct patval pat704[] = {
  {684,1},	{722,2},	{758,0},	{611,0},
  {759,0},	{612,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{613,0},	{650,0},
  {687,0},	{724,0},	{761,0}
};

static struct patval pat705[] = {
  {684,1},	{722,2},	{572,4},	{535,4},
  {537,4},	{574,4},	{536,4},	{573,4},
  {758,0},	{609,0},	{610,0},	{611,0},
  {759,0},	{538,0},	{575,0},	{612,0},
  {649,0},	{686,0},	{723,0},	{760,0},
  {539,0},	{576,0},	{613,0},	{650,0},
  {687,0},	{724,0},	{761,0}
};

static struct patval pat706[] = {
  {574,1},	{684,1},	{723,2},	{648,2},
  {721,3},	{610,0},	{609,0},	{572,0},
  {611,0},	{573,0},	{575,0},	{612,0},
  {649,0},	{686,0},	{576,0},	{613,0},
  {650,0},	{687,0},	{724,0},	{577,0},
  {614,0},	{651,0},	{688,0},	{725,0}
};

static struct patval pat707[] = {
  {684,1},	{723,2},	{648,2},	{721,3},
  {463,4},	{425,4},	{427,4},	{426,4},
  {464,4},	{609,0},	{499,0},	{536,0},
  {573,0},	{610,0},	{498,0},	{461,0},
  {500,0},	{537,0},	{574,0},	{611,0},
  {424,0},	{535,0},	{462,0},	{501,0},
  {538,0},	{575,0},	{612,0},	{649,0},
  {686,0},	{572,0},	{428,0},	{465,0},
  {502,0},	{539,0},	{576,0},	{613,0},
  {650,0},	{687,0},	{724,0},	{429,0},
  {466,0},	{503,0},	{540,0},	{577,0},
  {614,0},	{651,0},	{688,0},	{725,0}
};

static struct patval pat708[] = {
  {684,1},	{758,1},	{796,2},	{723,2},
  {645,0},	{756,0},	{757,0},	{794,0},
  {610,0},	{609,0},	{682,0},	{795,0},
  {611,0},	{759,0},	{793,0},	{612,0},
  {649,0},	{686,0},	{719,0},	{760,0},
  {797,0},	{613,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{614,0},
  {651,0},	{688,0},	{725,0},	{762,0},
  {799,0}
};

static struct patval pat709[] = {
  {648,1},	{759,1},	{685,1},	{721,2},
  {684,2},	{832,0},	{758,0},	{795,0},
  {796,0},	{833,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0}
};

static struct patval pat710[] = {
  {723,1},	{759,1},	{685,1},	{648,1},
  {721,2},	{684,2},	{722,2},	{758,0},
  {832,0},	{796,0},	{833,0},	{649,0},
  {686,0},	{795,0},	{760,0},	{797,0},
  {834,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{835,0}
};

static struct patval pat711[] = {
  {723,1},	{649,1},	{685,1},	{759,1},
  {648,1},	{721,2},	{686,2},	{722,2},
  {684,2},	{796,0},	{833,0},	{832,0},
  {758,0},	{795,0},	{760,0},	{797,0},
  {834,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{835,0}
};

static struct patval pat712[] = {
  {684,1},	{685,2},	{574,2},	{573,0},
  {611,0},	{610,0},	{759,0},	{575,0},
  {612,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{576,0},	{613,0},	{650,0},
  {687,0},	{724,0},	{761,0}
};

static struct patval pat713[] = {
  {796,1},	{722,1},	{758,1},	{795,1},
  {684,2},	{721,2},	{759,2},	{760,2},
  {870,0},	{686,0},	{723,0},	{833,0},
  {797,0},	{834,0},	{871,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0},
  {872,0}
};

static struct patval pat714[] = {
  {684,1},	{723,1},	{685,1},	{722,2},
  {648,2},	{686,2},	{649,0},	{612,0},
  {760,0},	{613,0},	{650,0},	{687,0},
  {724,0},	{761,0}
};

static struct patval pat715[] = {
  {684,1},	{723,1},	{685,1},	{722,2},
  {648,2},	{686,2},	{649,0},	{612,0},
  {760,0},	{613,0},	{650,0},	{687,0},
  {724,0},	{761,0}
};

static struct patval pat716[] = {
  {686,1},	{685,1},	{759,1},	{722,2},
  {684,2},	{648,2},	{611,0},	{612,0},
  {649,0},	{723,0},	{760,0},	{613,0},
  {650,0},	{687,0},	{724,0},	{761,0}
};

static struct patval pat717[] = {
  {722,1},	{685,1},	{760,1},	{721,2},
  {759,2},	{684,2},	{794,0},	{795,0},
  {758,0},	{796,0},	{833,0},	{686,0},
  {723,0},	{757,0},	{797,0},	{834,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {835,0}
};

static struct patval pat718[] = {
  {759,1},	{685,1},	{721,1},	{722,2},
  {648,2},	{684,2},	{758,3},	{647,4},
  {649,0},	{686,0},	{723,0},	{760,0}
};

static struct patval pat719[] = {
  {685,1},	{648,1},	{722,2},	{684,2},
  {794,0},	{757,0},	{758,0},	{795,0},
  {759,0},	{796,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{798,0}
};

static struct patval pat720[] = {
  {648,1},	{723,1},	{685,1},	{722,2},
  {684,2},	{686,3},	{724,3},	{687,3},
  {650,3},	{683,4},	{796,0},	{758,0},
  {759,0},	{760,0},	{797,0},	{757,0},
  {761,0},	{798,0}
};

static struct patval pat721[] = {
  {758,1},	{759,2},	{684,2},	{796,2},
  {795,3},	{648,4},	{649,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{798,0}
};

static struct patval pat722[] = {
  {796,1},	{684,2},	{797,2},	{795,3},
  {759,0},	{686,0},	{723,0},	{760,0},
  {758,0},	{687,0},	{724,0},	{761,0},
  {798,0}
};

static struct patval pat723[] = {
  {722,1},	{758,1},	{684,2},	{685,2},
  {759,0}
};

static struct patval pat724[] = {
  {796,1},	{722,1},	{795,1},	{684,2},
  {685,2},	{759,2},	{758,0},	{686,0},
  {723,0},	{760,0},	{797,0}
};

static struct patval pat725[] = {
  {796,1},	{721,1},	{758,2},	{684,2},
  {722,2},	{759,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{797,0}
};

static struct patval pat726[] = {
  {796,1},	{721,1},	{758,2},	{684,2},
  {722,2},	{759,0},	{833,0},	{649,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0}
};

static struct patval pat727[] = {
  {759,1},	{685,1},	{722,2},	{684,2},
  {758,0},	{686,0},	{723,0},	{760,0}
};

static struct patval pat728[] = {
  {759,1},	{685,1},	{722,2},	{684,2},
  {758,0},	{686,0},	{723,0},	{760,0}
};

static struct patval pat729[] = {
  {759,1},	{684,2},	{797,3},	{647,4},
  {721,4},	{649,4},	{648,4},	{686,0},
  {723,0},	{760,0},	{650,0},	{687,0},
  {724,0},	{761,0}
};

static struct patval pat730[] = {
  {684,1},	{721,1},	{648,2},	{722,2},
  {759,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{650,0},	{687,0},	{724,0},
  {761,0}
};

static struct patval pat731[] = {
  {722,1},	{648,1},	{721,2},	{684,2},
  {759,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{650,0},	{687,0},	{724,0},
  {761,0}
};

static struct patval pat732[] = {
  {759,1},	{721,1},	{758,1},	{684,2},
  {760,2},	{722,2},	{649,0},	{686,0},
  {723,0}
};

static struct patval pat733[] = {
  {685,1},	{611,1},	{648,2},	{684,2},
  {610,3},	{646,3},	{721,4},	{612,0},
  {649,0},	{686,0},	{723,0}
};

static struct patval pat734[] = {
  {760,1},	{722,1},	{759,1},	{723,2},
  {684,2},	{572,0},	{758,0},	{574,0},
  {611,0},	{573,0},	{575,0},	{612,0},
  {649,0},	{686,0},	{610,0},	{576,0},
  {613,0},	{650,0},	{687,0},	{724,0},
  {761,0}
};

static struct patval pat735[] = {
  {684,1},	{722,1},	{758,2},	{721,2},
  {685,2},	{681,0},	{645,0},	{682,0},
  {719,0},	{756,0},	{609,0},	{757,0},
  {610,0},	{718,0},	{607,0},	{644,0},
  {611,0},	{755,0},	{608,0}
};

static struct patval pat736[] = {
  {759,1},	{684,1},	{721,1},	{648,1},
  {685,2},	{722,2},	{724,2},	{647,3},
  {760,3},	{723,0},	{686,0},	{650,0},
  {687,0},	{649,0}
};

static struct patval pat737[] = {
  {760,1},	{684,1},	{721,1},	{759,1},
  {648,1},	{685,2},	{722,2},	{761,2},
  {723,2},	{647,3},	{758,3},	{762,4},
  {650,0},	{687,0},	{724,0},	{686,0},
  {651,0},	{688,0},	{725,0},	{649,0}
};

static struct patval pat738[] = {
  {684,1},	{758,2},	{757,0},	{794,0},
  {610,0},	{609,0},	{795,0},	{611,0},
  {759,0},	{796,0},	{612,0},	{649,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {613,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{798,0}
};

static struct patval pat739[] = {
  {612,1},	{684,2},	{686,2},	{610,3},
  {573,0},	{537,0},	{574,0},	{611,0},
  {538,0},	{575,0},	{649,0},	{536,0},
  {723,0},	{539,0},	{576,0},	{613,0},
  {650,0},	{687,0},	{724,0},	{540,0},
  {577,0},	{614,0},	{651,0},	{688,0},
  {725,0},	{541,0},	{578,0},	{615,0},
  {652,0},	{689,0},	{726,0}
};

static struct patval pat740[] = {
  {759,1},	{760,1},	{723,2},	{684,2},
  {647,4},	{721,4},	{610,4},	{612,0},
  {649,0},	{686,0},	{611,0},	{613,0},
  {650,0},	{687,0},	{724,0},	{761,0}
};

static struct patval pat741[] = {
  {759,1},	{721,1},	{760,1},	{723,2},
  {684,2},	{647,4},	{610,4},	{612,0},
  {649,0},	{686,0},	{611,0},	{613,0},
  {650,0},	{687,0},	{724,0},	{761,0}
};

static struct patval pat742[] = {
  {684,1},	{722,1},	{685,2},	{723,2},
  {500,4},	{537,4},	{724,4},	{501,4},
  {538,4},	{611,0},	{610,0},	{575,0},
  {612,0},	{649,0},	{686,0},	{574,0},
  {502,0},	{539,0},	{576,0},	{613,0},
  {650,0},	{687,0},	{573,0},	{503,0},
  {540,0},	{577,0},	{614,0},	{651,0},
  {688,0},	{725,0}
};

static struct patval pat743[] = {
  {684,1},	{685,1},	{649,1},	{686,2},
  {796,2},	{760,2},	{758,2},	{722,2},
  {721,3},	{795,4},	{833,4},	{612,0},
  {611,0},	{759,0},	{723,0},	{797,0}
};

static struct patval pat744[] = {
  {684,1},	{611,2},	{612,2},	{795,4},
  {576,4},	{758,4},	{797,4},	{796,4},
  {757,4},	{759,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{613,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{798,0}
};

static struct patval pat745[] = {
  {684,1},	{721,1},	{722,2},	{612,2},
  {611,2},	{797,4},	{795,4},	{758,4},
  {759,0},	{796,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{613,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{798,0}
};

static struct patval pat746[] = {
  {721,1},	{759,1},	{722,2},	{684,2},
  {834,3},	{758,3},	{796,3},	{647,4},
  {649,0},	{723,0},	{760,0},	{797,0},
  {686,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{798,0}
};

static struct patval pat747[] = {
  {574,1},	{684,1},	{649,1},	{686,2},
  {650,2},	{687,4},	{724,4},	{537,0},
  {500,0},	{536,0},	{501,0},	{538,0},
  {575,0},	{612,0},	{573,0},	{610,0},
  {502,0},	{539,0},	{576,0},	{613,0},
  {611,0},	{499,0},	{503,0},	{540,0},
  {577,0},	{614,0},	{651,0},	{688,0},
  {725,0}
};

static struct patval pat748[] = {
  {722,1},	{686,1},	{723,1},	{684,2},
  {649,2},	{685,2},	{610,4},	{573,4},
  {575,0},	{612,0},	{611,0},	{574,0}
};

static struct patval pat749[] = {
  {758,1},	{684,2},	{795,3},	{757,3},
  {794,3},	{759,0},	{796,0},	{649,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {798,0}
};

static struct patval pat750[] = {
  {795,1},	{796,1},	{684,2},	{759,2},
  {794,0},	{758,0},	{831,0},	{832,0},
  {757,0},	{833,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0}
};

static struct patval pat751[] = {
  {832,1},	{684,2},	{574,3},	{573,3},
  {757,0},	{794,0},	{831,0},	{610,0},
  {572,0},	{758,0},	{795,0},	{609,0},
  {611,0},	{759,0},	{796,0},	{833,0},
  {575,0},	{612,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0},
  {576,0},	{613,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0}
};

static struct patval pat752[] = {
  {685,2},	{684,2},	{833,3},	{832,3},
  {831,0},	{794,0},	{758,0},	{795,0},
  {757,0},	{759,0},	{796,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {835,0}
};

static struct patval pat753[] = {
  {685,1},	{649,1},	{684,1},	{686,2},
  {722,2},	{760,2},	{759,0},	{612,0},
  {611,0},	{610,0},	{723,0},	{613,0},
  {650,0},	{687,0},	{724,0},	{761,0}
};

static struct patval pat754[] = {
  {722,1},	{684,1},	{796,1},	{758,2},
  {759,2},	{831,0},	{794,0},	{795,0},
  {832,0},	{757,0},	{833,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {835,0}
};

static struct patval pat755[] = {
  {722,1},	{684,2},	{683,4},	{646,4}
};

static struct patval pat756[] = {
  {722,1},	{685,1},	{684,1},	{721,2},
  {796,2},	{720,3},	{757,3},	{795,0},
  {759,0},	{758,0}
};

static struct patval pat757[] = {
  {648,1},	{684,1},	{721,2},	{685,2}
};

static struct patval pat758[] = {
  {684,1},	{648,1},	{722,1},	{649,0},
  {686,0},	{723,0}
};

static struct patval pat759[] = {
  {648,1},	{684,1},	{688,1},	{722,1},
  {685,2},	{686,2},	{721,2},	{647,3},
  {649,0},	{723,0},	{759,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{651,0},
  {760,0},	{725,0}
};

static struct patval pat760[] = {
  {722,1},	{684,1},	{650,1},	{686,1},
  {612,1},	{649,0},	{611,0}
};

static struct patval pat761[] = {
  {685,1},	{686,1},	{759,1},	{684,2},
  {687,2},	{648,2},	{649,2},	{721,4},
  {760,0},	{724,0},	{761,0},	{688,0},
  {725,0}
};

static struct patval pat762[] = {
  {684,1},	{686,1},	{687,1},	{724,2},
  {649,2},	{759,0},	{723,0},	{760,0},
  {761,0}
};

static struct patval pat763[] = {
  {649,1},	{684,1},	{759,1},	{758,1},
  {723,2},	{686,0}
};

static struct patval pat764[] = {
  {685,1},	{684,1},	{686,2},	{759,2},
  {612,2},	{647,3},	{649,0},	{611,0},
  {723,0},	{760,0},	{613,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{614,0},
  {651,0},	{688,0},	{725,0},	{762,0}
};

static struct patval pat765[] = {
  {684,1},	{722,1},	{723,2},	{649,2},
  {796,2},	{721,3},	{759,0},	{686,0},
  {760,0},	{797,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{651,0},
  {688,0},	{725,0},	{762,0},	{799,0}
};

static struct patval pat766[] = {
  {684,1},	{758,1},	{760,1},	{686,2},
  {685,4},	{723,4},	{795,0},	{759,0},
  {796,0},	{757,0},	{794,0}
};

static struct patval pat767[] = {
  {684,1},	{758,1},	{760,1},	{686,2},
  {794,0},	{795,0},	{759,0},	{796,0},
  {723,0},	{757,0},	{797,0}
};

static struct patval pat768[] = {
  {684,1},	{721,1},	{686,1},	{648,1},
  {723,1},	{759,1},	{760,2},	{758,2}
};

static struct patval pat769[] = {
  {684,1},	{612,1},	{648,2},	{649,0},
  {686,0},	{723,0},	{650,0},	{687,0},
  {724,0}
};

static struct patval pat770[] = {
  {684,1},	{722,1},	{721,2},	{685,2},
  {758,4},	{760,4},	{723,0},	{759,0}
};

static struct patval pat771[] = {
  {684,1},	{722,1},	{759,2},	{685,2},
  {758,4},	{720,4},	{757,4},	{760,4},
  {723,0}
};

static struct patval pat772[] = {
  {725,1},	{721,1},	{758,1},	{684,2},
  {722,2},	{759,0},	{796,0},	{649,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{651,0},	{688,0},	{795,0},
  {762,0},	{799,0}
};

static struct patval pat773[] = {
  {722,1},	{759,2},	{685,2},	{723,2},
  {684,2},	{757,3},	{794,3},	{831,3},
  {720,3},	{830,3},	{719,3},	{795,3},
  {832,3},	{793,3},	{756,3},	{758,0},
  {796,0}
};

static struct patval pat774[] = {
  {648,1},	{759,1},	{758,1},	{684,2},
  {721,2},	{686,0},	{723,0},	{760,0},
  {797,0},	{724,0},	{761,0}
};

static struct patval pat775[] = {
  {686,1},	{684,1},	{721,2},	{723,2},
  {649,0}
};

static struct patval pat776[] = {
  {684,1},	{796,2},	{685,2},	{795,0},
  {758,0},	{759,0}
};

static struct patval pat777[] = {
  {723,1},	{721,1},	{685,1},	{684,2},
  {722,2},	{760,4},	{758,4},	{797,4},
  {796,4},	{795,4},	{686,0},	{759,0}
};

static struct patval pat778[] = {
  {685,1},	{721,1},	{759,1},	{684,2},
  {722,2},	{758,3},	{723,0},	{760,0}
};

static struct patval pat779[] = {
  {684,1},	{722,1},	{721,2},	{648,2},
  {685,2},	{758,0},	{759,0},	{649,0},
  {686,0},	{723,0},	{760,0}
};

static struct patval pat780[] = {
  {686,1},	{684,1},	{648,1},	{685,2},
  {723,2},	{649,0}
};

static struct patval pat781[] = {
  {685,1},	{684,2},	{686,2},	{648,2},
  {723,3},	{649,0}
};

static struct patval pat782[] = {
  {685,1},	{723,1},	{686,2},	{648,2},
  {684,2},	{649,0}
};

static struct patval pat783[] = {
  {723,1},	{721,1},	{649,1},	{761,2},
  {684,2},	{759,0},	{686,0},	{760,0},
  {650,0},	{687,0},	{724,0},	{758,0}
};

static struct patval pat784[] = {
  {684,1},	{759,2},	{685,3},	{682,0},
  {830,0},	{867,0},	{904,0},	{941,0},
  {757,0},	{794,0},	{831,0},	{868,0},
  {905,0},	{942,0},	{756,0},	{758,0},
  {795,0},	{719,0},	{793,0},	{796,0},
  {833,0}
};

static struct patval pat785[] = {
  {684,1},	{685,2},	{759,2},	{682,0},
  {830,0},	{867,0},	{904,0},	{941,0},
  {757,0},	{794,0},	{831,0},	{868,0},
  {905,0},	{942,0},	{756,0},	{758,0},
  {795,0},	{719,0},	{793,0},	{796,0},
  {833,0}
};

static struct patval pat786[] = {
  {649,1},	{684,2},	{688,2},	{651,4},
  {647,4},	{758,0},	{759,0},	{686,0},
  {723,0},	{760,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{725,0},	{762,0}
};

static struct patval pat787[] = {
  {724,1},	{649,1},	{650,2},	{684,2},
  {686,0},	{723,0},	{687,0}
};

static struct patval pat788[] = {
  {685,1},	{721,1},	{684,2}
};

static struct patval pat789[] = {
  {684,1},	{722,2},	{648,2},	{649,0},
  {686,0},	{723,0}
};

static struct patval pat790[] = {
  {721,1},	{685,1},	{722,2},	{684,2},
  {757,0},	{682,0},	{758,0},	{719,0},
  {756,0}
};

static struct patval pat791[] = {
  {721,1},	{685,1},	{722,2},	{684,2},
  {757,0},	{682,0},	{758,0},	{719,0},
  {756,0}
};

static struct patval pat792[] = {
  {684,1},	{611,2},	{722,2},	{650,3},
  {687,3},	{724,3},	{612,3},	{613,3},
  {686,0},	{723,0},	{649,0}
};

static struct patval pat793[] = {
  {684,1},	{649,2},	{647,3},	{683,3},
  {758,0},	{759,0},	{686,0},	{723,0},
  {760,0}
};

static struct patval pat794[] = {
  {612,1},	{684,1},	{649,2},	{611,2},
  {647,3},	{759,0},	{758,0},	{686,0},
  {723,0},	{760,0}
};

static struct patval pat795[] = {
  {721,1},	{723,1},	{686,2},	{684,2},
  {722,2},	{649,0}
};

static struct patval pat796[] = {
  {722,1},	{758,1},	{684,2},	{759,2},
  {647,4},	{648,4},	{757,0},	{795,0},
  {794,0},	{796,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{797,0}
};

static struct patval pat797[] = {
  {685,1},	{684,2},	{610,3},	{757,0},
  {758,0},	{759,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{650,0},	{687,0},
  {724,0},	{761,0}
};

static struct patval pat798[] = {
  {685,1},	{759,1},	{758,2},	{684,2},
  {757,0},	{794,0},	{795,0},	{796,0},
  {649,0},	{686,0},	{723,0},	{760,0},
  {797,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{798,0}
};

static struct patval pat799[] = {
  {758,1},	{795,2},	{684,2},	{793,0},
  {757,0},	{794,0},	{831,0},	{719,0},
  {756,0},	{832,0},	{759,0},	{796,0},
  {833,0},	{686,0},	{723,0},	{760,0},
  {797,0},	{834,0}
};

static struct patval pat800[] = {
  {796,1},	{722,1},	{758,1},	{721,2},
  {759,2},	{684,2},	{832,4},	{794,0},
  {795,0},	{757,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{797,0}
};

static struct patval pat801[] = {
  {649,1},	{685,1},	{723,1},	{687,1},
  {648,2},	{684,2},	{611,2},	{610,0},
  {574,0},	{575,0},	{612,0},	{573,0},
  {686,0},	{760,0},	{576,0},	{613,0},
  {650,0},	{759,0},	{724,0}
};

static struct patval pat802[] = {
  {869,1},	{684,2},	{795,2},	{943,4},
  {867,0},	{757,0},	{831,0},	{868,0},
  {905,0},	{794,0},	{758,0},	{832,0},
  {830,0},	{906,0},	{904,0},	{759,0},
  {796,0},	{833,0},	{870,0},	{907,0},
  {944,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0},	{871,0},
  {908,0},	{945,0}
};

static struct patval pat803[] = {
  {869,1},	{907,1},	{795,2},	{684,2},
  {870,2},	{943,4},	{757,0},	{867,0},
  {868,0},	{905,0},	{794,0},	{758,0},
  {831,0},	{832,0},	{830,0},	{906,0},
  {904,0},	{759,0},	{796,0},	{833,0},
  {944,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0},	{871,0},
  {908,0},	{945,0}
};

static struct patval pat804[] = {
  {684,1},	{612,1},	{611,1},	{685,1},
  {722,2},	{686,2},	{649,2},	{869,0},
  {832,0},	{759,0},	{796,0},	{833,0},
  {870,0},	{758,0},	{795,0},	{723,0},
  {760,0},	{797,0},	{834,0},	{871,0},
  {613,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{835,0},	{872,0},
  {614,0},	{651,0},	{688,0},	{725,0},
  {762,0},	{799,0},	{836,0},	{873,0}
};

static struct patval pat805[] = {
  {795,1},	{759,1},	{758,2},	{684,2},
  {833,3},	{794,0},	{757,0},	{796,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {687,0},	{724,0},	{761,0},	{798,0}
};

static struct patval pat806[] = {
  {833,1},	{684,1},	{755,4},	{681,4},
  {829,4},	{831,4},	{718,4},	{756,4},
  {793,4},	{830,4},	{719,4},	{794,4},
  {792,4},	{682,0},	{758,0},	{795,0},
  {832,0},	{759,0},	{796,0},	{757,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{835,0}
};

static struct patval pat807[] = {
  {684,1},	{832,1},	{718,0},	{792,0},
  {829,0},	{681,0},	{719,0},	{756,0},
  {793,0},	{830,0},	{757,0},	{794,0},
  {831,0},	{682,0},	{758,0},	{795,0},
  {755,0},	{759,0},	{796,0},	{833,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0}
};

static struct patval pat808[] = {
  {758,1},	{906,1},	{684,2},	{683,4},
  {686,4},	{685,4},	{682,4},	{793,0},
  {904,0},	{794,0},	{831,0},	{868,0},
  {905,0},	{756,0},	{757,0},	{795,0},
  {832,0},	{869,0},	{830,0},	{867,0},
  {759,0},	{796,0},	{833,0},	{870,0},
  {907,0},	{719,0},	{723,0},	{760,0},
  {797,0},	{834,0},	{871,0},	{908,0}
};

static struct patval pat809[] = {
  {869,1},	{684,1},	{681,0},	{792,0},
  {829,0},	{866,0},	{718,0},	{719,0},
  {756,0},	{793,0},	{830,0},	{867,0},
  {757,0},	{794,0},	{831,0},	{868,0},
  {682,0},	{758,0},	{795,0},	{832,0},
  {755,0},	{759,0},	{796,0},	{833,0},
  {870,0},	{686,0},	{723,0},	{760,0},
  {797,0},	{834,0},	{871,0}
};

static struct patval pat810[] = {
  {684,1},	{795,2},	{755,0},	{718,0},
  {608,0},	{645,0},	{682,0},	{719,0},
  {756,0},	{793,0},	{830,0},	{609,0},
  {757,0},	{794,0},	{831,0},	{610,0},
  {792,0},	{758,0},	{681,0},	{832,0},
  {611,0},	{759,0},	{796,0},	{833,0},
  {612,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0}
};

static struct patval pat811[] = {
  {684,1},	{722,1},	{758,2},	{685,2},
  {794,0},	{757,0},	{795,0},	{759,0},
  {796,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{798,0}
};

static struct patval pat812[] = {
  {759,1},	{684,1},	{721,1},	{685,1},
  {723,2},	{758,2},	{722,2},	{648,2},
  {795,2},	{611,4},	{832,4},	{613,4},
  {833,4},	{612,4},	{835,4},	{834,4},
  {647,4},	{760,0},	{797,0},	{686,0},
  {796,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{649,0}
};

static struct patval pat813[] = {
  {649,1},	{648,1},	{722,1},	{684,1},
  {686,2},	{758,2},	{685,2},	{721,2},
  {611,2},	{574,4},	{795,4},	{575,4},
  {610,4},	{796,4},	{576,4},	{798,4},
  {797,4},	{723,0},	{760,0},	{759,0},
  {613,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{612,0}
};

static struct patval pat814[] = {
  {648,1},	{722,1},	{684,1},	{686,2},
  {758,2},	{685,2},	{721,2},	{611,2},
  {610,3},	{574,4},	{575,4},	{795,4},
  {796,4},	{576,4},	{798,4},	{797,4},
  {723,0},	{760,0},	{649,0},	{759,0},
  {613,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{612,0}
};

static struct patval pat815[] = {
  {795,1},	{759,1},	{758,2},	{684,2},
  {833,3},	{794,0},	{757,0},	{796,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {687,0},	{724,0},	{761,0},	{798,0}
};

static struct patval pat816[] = {
  {724,1},	{686,1},	{650,1},	{684,1},
  {760,2},	{649,2},	{687,2},	{612,2},
  {573,4},	{610,4},	{611,0},	{759,0},
  {723,0},	{613,0},	{761,0},	{614,0},
  {651,0},	{688,0},	{725,0},	{762,0}
};

static struct patval pat817[] = {
  {724,1},	{686,1},	{650,1},	{684,1},
  {723,1},	{760,2},	{687,2},	{685,2},
  {649,2},	{612,2},	{610,4},	{573,4},
  {759,0},	{611,0},	{613,0},	{761,0},
  {614,0},	{651,0},	{688,0},	{725,0},
  {762,0}
};

static struct patval pat818[] = {
  {684,1},	{721,1},	{722,2},	{795,0},
  {758,0},	{759,0},	{796,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{688,0},
  {725,0},	{762,0},	{799,0}
};

static struct patval pat819[] = {
  {684,1},	{721,1},	{758,1},	{759,2},
  {722,2},	{832,0},	{795,0},	{796,0},
  {833,0},	{686,0},	{723,0},	{760,0},
  {797,0},	{834,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{835,0},	{688,0},
  {725,0},	{762,0},	{799,0},	{836,0}
};

static struct patval pat820[] = {
  {684,1},	{721,1},	{758,1},	{795,1},
  {796,2},	{759,2},	{722,2},	{869,0},
  {832,0},	{833,0},	{870,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0},
  {871,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{835,0},	{872,0},	{688,0},
  {725,0},	{762,0},	{799,0},	{836,0},
  {873,0}
};

static struct patval pat821[] = {
  {684,1},	{611,1},	{758,1},	{685,2},
  {757,0},	{794,0},	{831,0},	{573,0},
  {610,0},	{572,0},	{795,0},	{832,0},
  {574,0},	{609,0},	{759,0},	{796,0},
  {833,0},	{575,0},	{612,0},	{649,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0},	{576,0},	{613,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {835,0}
};

static struct patval pat822[] = {
  {648,1},	{684,1},	{722,1},	{575,1},
  {611,1},	{686,2},	{649,2},	{685,2},
  {537,0},	{574,0},	{795,0},	{536,0},
  {758,0},	{759,0},	{796,0},	{538,0},
  {612,0},	{573,0},	{610,0},	{723,0},
  {760,0},	{797,0},	{539,0},	{576,0},
  {613,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{540,0},	{577,0},
  {614,0},	{651,0},	{688,0},	{725,0},
  {762,0},	{799,0}
};

static struct patval pat823[] = {
  {759,1},	{648,1},	{722,1},	{575,1},
  {684,1},	{611,1},	{649,2},	{686,2},
  {685,2},	{723,2},	{574,0},	{795,0},
  {537,0},	{536,0},	{796,0},	{538,0},
  {758,0},	{612,0},	{573,0},	{610,0},
  {760,0},	{797,0},	{539,0},	{576,0},
  {613,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{540,0},	{577,0},
  {614,0},	{651,0},	{688,0},	{725,0},
  {762,0},	{799,0}
};

static struct patval pat824[] = {
  {724,1},	{686,1},	{684,1},	{612,2},
  {760,2},	{687,2},	{573,4},	{610,4},
  {611,0},	{649,0},	{759,0},	{723,0},
  {613,0},	{650,0},	{761,0},	{614,0},
  {651,0},	{688,0},	{725,0},	{762,0}
};

static struct patval pat825[] = {
  {684,1},	{796,1},	{685,2},	{870,2},
  {647,3},	{612,3},	{610,3},	{611,3},
  {869,0},	{832,0},	{759,0},	{833,0},
  {758,0},	{795,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0},
  {871,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{835,0},	{872,0}
};

static struct patval pat826[] = {
  {684,1},	{796,1},	{721,1},	{870,2},
  {685,2},	{722,2},	{647,3},	{612,3},
  {611,3},	{610,3},	{832,0},	{869,0},
  {759,0},	{833,0},	{758,0},	{795,0},
  {649,0},	{686,0},	{723,0},	{760,0},
  {797,0},	{834,0},	{871,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {835,0},	{872,0}
};

static struct patval pat827[] = {
  {721,1},	{684,1},	{611,2},	{722,2},
  {574,0},	{573,0},	{610,0},	{575,0},
  {612,0},	{649,0},	{686,0},	{723,0},
  {576,0},	{613,0},	{650,0},	{687,0},
  {724,0}
};

static struct patval pat828[] = {
  {685,1},	{574,1},	{649,1},	{684,2},
  {648,2},	{573,0},	{537,0},	{611,0},
  {536,0},	{538,0},	{575,0},	{612,0},
  {610,0},	{686,0},	{723,0},	{539,0},
  {576,0},	{613,0},	{650,0},	{687,0},
  {724,0},	{540,0},	{577,0},	{614,0},
  {651,0},	{688,0},	{725,0}
};

static struct patval pat829[] = {
  {685,1},	{722,1},	{649,1},	{574,1},
  {684,2},	{648,2},	{686,2},	{537,0},
  {611,0},	{536,0},	{573,0},	{538,0},
  {575,0},	{612,0},	{610,0},	{723,0},
  {539,0},	{576,0},	{613,0},	{650,0},
  {687,0},	{724,0},	{540,0},	{577,0},
  {614,0},	{651,0},	{688,0},	{725,0}
};

static struct patval pat830[] = {
  {649,1},	{684,1},	{686,2},	{797,2},
  {758,0},	{795,0},	{611,0},	{759,0},
  {796,0},	{612,0},	{723,0},	{760,0},
  {610,0},	{613,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{614,0},
  {651,0},	{688,0},	{725,0},	{762,0},
  {799,0}
};

static struct patval pat831[] = {
  {721,1},	{684,1},	{795,2},	{722,2},
  {648,2},	{611,0},	{758,0},	{759,0},
  {796,0},	{612,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{613,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {798,0}
};

static struct patval pat832[] = {
  {684,1},	{721,1},	{796,1},	{759,1},
  {722,2},	{685,2},	{760,2},	{758,3},
  {723,0},	{686,0},	{797,0},	{834,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {835,0}
};

static struct patval pat833[] = {
  {686,1},	{723,1},	{611,1},	{722,1},
  {684,2},	{649,2},	{685,2},	{574,3},
  {612,0},	{575,0},	{610,0},	{576,0},
  {613,0},	{650,0},	{687,0},	{724,0}
};

static struct patval pat834[] = {
  {537,1},	{684,1},	{611,2},	{685,3},
  {682,0},	{645,0},	{572,0},	{609,0},
  {536,0},	{573,0},	{610,0},	{571,0},
  {535,0},	{574,0},	{534,0},	{608,0},
  {538,0},	{575,0},	{612,0},	{649,0},
  {686,0},	{539,0},	{576,0},	{613,0},
  {650,0},	{687,0}
};

static struct patval pat835[] = {
  {722,1},	{686,2},	{684,2},	{610,3},
  {759,3},	{612,3},	{760,3},	{758,3},
  {611,3},	{649,0},	{723,0},	{650,0},
  {687,0},	{724,0},	{651,0},	{688,0},
  {725,0}
};

static struct patval pat836[] = {
  {758,1},	{722,1},	{684,2},	{759,2},
  {647,4},	{831,0},	{757,0},	{794,0},
  {795,0},	{832,0},	{796,0},	{833,0},
  {649,0},	{686,0},	{723,0},	{760,0},
  {797,0},	{834,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0}
};

static struct patval pat837[] = {
  {684,1},	{722,1},	{759,1},	{758,2},
  {721,2},	{795,4},	{757,0},	{756,0},
  {645,0},	{682,0},	{719,0},	{649,0},
  {686,0},	{723,0},	{760,0},	{650,0},
  {687,0},	{724,0},	{761,0}
};

static struct patval pat838[] = {
  {684,1},	{648,2},	{722,2},	{649,0},
  {686,0},	{723,0},	{650,0},	{687,0},
  {724,0},	{651,0},	{688,0},	{725,0}
};

static struct patval pat839[] = {
  {684,1},	{1016,3},	{1053,3},	{1017,3},
  {1054,3},	{866,0},	{903,0},	{940,0},
  {977,0},	{1014,0},	{681,0},	{682,0},
  {719,0},	{756,0},	{793,0},	{830,0},
  {867,0},	{904,0},	{941,0},	{978,0},
  {1015,0},	{1052,0},	{757,0},	{794,0},
  {831,0},	{868,0},	{905,0},	{942,0},
  {979,0},	{718,0},	{755,0},	{1051,0},
  {758,0},	{795,0},	{832,0},	{869,0},
  {906,0},	{943,0},	{980,0},	{792,0},
  {829,0},	{759,0},	{796,0},	{833,0},
  {870,0},	{907,0},	{944,0},	{981,0},
  {1018,0},	{1055,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0},	{871,0},
  {908,0},	{945,0},	{982,0},	{1019,0},
  {1056,0}
};

static struct patval pat840[] = {
  {722,1},	{758,1},	{796,1},	{832,2},
  {759,2},	{684,2},	{721,2},	{831,0},
  {795,0},	{794,0},	{757,0},	{833,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{835,0}
};

static struct patval pat841[] = {
  {648,2},	{684,2},	{611,2},	{906,3},
  {907,3},	{831,0},	{758,0},	{795,0},
  {832,0},	{869,0},	{757,0},	{759,0},
  {796,0},	{833,0},	{870,0},	{794,0},
  {612,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0},	{871,0},
  {908,0},	{613,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0},
  {872,0},	{909,0}
};

static struct patval pat842[] = {
  {685,1},	{649,1},	{722,2},	{684,2},
  {719,0},	{830,0},	{645,0},	{757,0},
  {794,0},	{831,0},	{682,0},	{758,0},
  {795,0},	{832,0},	{793,0},	{759,0},
  {796,0},	{833,0},	{756,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{835,0}
};

static struct patval pat843[] = {
  {612,1},	{574,1},	{686,2},	{611,2},
  {684,2},	{575,3},	{537,3},	{538,3},
  {573,0},	{572,0},	{610,0},	{536,0},
  {535,0},	{649,0},	{609,0},	{539,0},
  {576,0},	{613,0},	{650,0},	{687,0},
  {540,0},	{577,0},	{614,0},	{651,0},
  {688,0}
};

static struct patval pat844[] = {
  {722,1},	{759,1},	{795,1},	{684,2},
  {685,2},	{721,2},	{757,3},	{720,3},
  {796,3},	{794,3},	{498,0},	{499,0},
  {536,0},	{573,0},	{610,0},	{572,0},
  {462,0},	{758,0},	{535,0},	{463,0},
  {500,0},	{537,0},	{574,0},	{611,0},
  {609,0},	{461,0},	{464,0},	{501,0},
  {538,0},	{575,0},	{612,0},	{649,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {465,0},	{502,0},	{539,0},	{576,0},
  {613,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{798,0}
};

static struct patval pat845[] = {
  {760,1},	{684,1},	{796,1},	{759,2},
  {758,2},	{868,0},	{831,0},	{795,0},
  {832,0},	{869,0},	{757,0},	{833,0},
  {870,0},	{686,0},	{723,0},	{794,0},
  {797,0},	{834,0},	{871,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0},
  {872,0}
};

static struct patval pat846[] = {
  {684,1},	{760,1},	{796,1},	{759,2},
  {723,2},	{758,2},	{797,3},	{798,3},
  {834,3},	{795,0},	{832,0},	{611,0},
  {610,0},	{833,0},	{612,0},	{649,0},
  {686,0},	{757,0},	{794,0},	{609,0},
  {613,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{831,0},	{835,0}
};

static struct patval pat847[] = {
  {685,1},	{721,1},	{684,2},	{722,2},
  {833,4},	{870,4},	{832,4},	{871,4},
  {869,4},	{831,0},	{758,0},	{795,0},
  {611,0},	{610,0},	{759,0},	{796,0},
  {757,0},	{794,0},	{612,0},	{649,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0},	{609,0},	{613,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {835,0},	{872,0}
};

static struct patval pat848[] = {
  {758,1},	{722,1},	{684,2},	{721,2},
  {832,2},	{759,2},	{794,3},	{757,0},
  {795,0},	{796,0},	{833,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0}
};

static struct patval pat849[] = {
  {611,1},	{684,2},	{537,2},	{500,4},
  {501,4},	{536,4},	{685,4},	{499,4},
  {722,4},	{610,0},	{573,0},	{572,0},
  {574,0},	{535,0},	{609,0},	{498,0},
  {538,0},	{575,0},	{612,0},	{649,0},
  {686,0},	{723,0},	{502,0},	{539,0},
  {576,0},	{613,0},	{650,0},	{687,0},
  {724,0}
};

static struct patval pat850[] = {
  {685,1},	{648,1},	{611,2},	{684,2},
  {573,4},	{574,4},	{572,4},	{610,0},
  {609,0},	{575,0},	{612,0},	{649,0},
  {686,0},	{576,0},	{613,0},	{650,0},
  {687,0}
};

static struct patval pat851[] = {
  {685,1},	{649,1},	{722,1},	{684,2},
  {721,2},	{648,2},	{647,4},	{611,0},
  {573,0},	{574,0},	{575,0},	{612,0},
  {610,0},	{686,0},	{723,0},	{576,0},
  {613,0},	{650,0},	{687,0},	{724,0}
};

static struct patval pat852[] = {
  {684,1},	{721,1},	{759,1},	{722,2},
  {685,2},	{832,0},	{758,0},	{795,0},
  {796,0},	{833,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0}
};

static struct patval pat853[] = {
  {684,1},	{721,1},	{759,1},	{722,2},
  {685,2},	{832,0},	{758,0},	{795,0},
  {796,0},	{833,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0}
};

static struct patval pat854[] = {
  {684,1},	{721,1},	{759,1},	{796,1},
  {722,2},	{760,2},	{685,2},	{832,0},
  {758,0},	{869,0},	{833,0},	{870,0},
  {686,0},	{723,0},	{795,0},	{797,0},
  {834,0},	{871,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{835,0},	{872,0}
};

static struct patval pat855[] = {
  {684,1},	{721,1},	{759,1},	{796,1},
  {722,2},	{760,2},	{685,2},	{832,0},
  {758,0},	{869,0},	{833,0},	{870,0},
  {686,0},	{723,0},	{795,0},	{797,0},
  {834,0},	{871,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{835,0},	{872,0}
};

static struct patval pat856[] = {
  {684,1},	{721,1},	{759,1},	{797,1},
  {760,2},	{722,2},	{685,2},	{869,0},
  {758,0},	{796,0},	{833,0},	{870,0},
  {686,0},	{723,0},	{795,0},	{832,0},
  {834,0},	{871,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{835,0},	{872,0}
};

static struct patval pat857[] = {
  {684,1},	{649,1},	{685,1},	{722,2},
  {760,2},	{724,2},	{686,2},	{981,3},
  {980,0},	{906,0},	{795,0},	{759,0},
  {796,0},	{833,0},	{870,0},	{907,0},
  {944,0},	{943,0},	{869,0},	{758,0},
  {723,0},	{832,0},	{797,0},	{834,0},
  {871,0},	{908,0},	{945,0},	{982,0},
  {650,0},	{687,0},	{761,0},	{798,0},
  {835,0},	{872,0},	{909,0},	{946,0},
  {983,0}
};

static struct patval pat858[] = {
  {684,1},	{649,1},	{685,1},	{722,2},
  {760,2},	{724,2},	{686,2},	{943,3},
  {944,3},	{906,0},	{759,0},	{796,0},
  {833,0},	{870,0},	{907,0},	{795,0},
  {869,0},	{758,0},	{723,0},	{832,0},
  {797,0},	{834,0},	{871,0},	{908,0},
  {945,0},	{650,0},	{687,0},	{761,0},
  {798,0},	{835,0},	{872,0},	{909,0},
  {946,0}
};

static struct patval pat859[] = {
  {684,1},	{833,1},	{758,2},	{755,0},
  {681,0},	{829,0},	{866,0},	{903,0},
  {645,0},	{682,0},	{719,0},	{756,0},
  {793,0},	{830,0},	{867,0},	{904,0},
  {757,0},	{794,0},	{831,0},	{868,0},
  {905,0},	{644,0},	{718,0},	{795,0},
  {832,0},	{869,0},	{906,0},	{759,0},
  {796,0},	{792,0},	{870,0},	{907,0},
  {649,0},	{686,0},	{723,0},	{760,0},
  {797,0},	{834,0},	{871,0},	{908,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{835,0},	{872,0},	{909,0}
};

static struct patval pat860[] = {
  {574,1},	{723,1},	{649,1},	{648,2},
  {684,2},	{645,0},	{756,0},	{793,0},
  {719,0},	{572,0},	{609,0},	{757,0},
  {794,0},	{536,0},	{573,0},	{610,0},
  {571,0},	{758,0},	{795,0},	{537,0},
  {534,0},	{611,0},	{535,0},	{759,0},
  {796,0},	{538,0},	{575,0},	{612,0},
  {608,0},	{686,0},	{682,0},	{760,0},
  {797,0},	{539,0},	{576,0},	{613,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{540,0},	{577,0},	{614,0},
  {651,0},	{688,0},	{725,0},	{762,0},
  {799,0}
};

static struct patval pat861[] = {
  {574,1},	{611,1},	{649,1},	{723,1},
  {612,2},	{648,2},	{684,2},	{645,0},
  {719,0},	{572,0},	{609,0},	{757,0},
  {794,0},	{536,0},	{573,0},	{610,0},
  {756,0},	{758,0},	{795,0},	{537,0},
  {534,0},	{793,0},	{535,0},	{759,0},
  {796,0},	{538,0},	{575,0},	{571,0},
  {608,0},	{686,0},	{682,0},	{760,0},
  {797,0},	{539,0},	{576,0},	{613,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{540,0},	{577,0},	{614,0},
  {651,0},	{688,0},	{725,0},	{762,0},
  {799,0}
};

static struct patval pat862[] = {
  {650,1},	{611,1},	{649,1},	{574,1},
  {723,1},	{684,2},	{686,2},	{612,2},
  {648,2},	{719,0},	{609,0},	{757,0},
  {794,0},	{536,0},	{573,0},	{610,0},
  {572,0},	{758,0},	{795,0},	{537,0},
  {756,0},	{793,0},	{535,0},	{759,0},
  {796,0},	{538,0},	{575,0},	{571,0},
  {608,0},	{645,0},	{682,0},	{760,0},
  {797,0},	{539,0},	{576,0},	{613,0},
  {534,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{540,0},	{577,0},	{614,0},
  {651,0},	{688,0},	{725,0},	{762,0},
  {799,0}
};

static struct patval pat863[] = {
  {686,1},	{539,1},	{684,1},	{611,2},
  {613,2},	{535,0},	{608,0},	{609,0},
  {682,0},	{536,0},	{573,0},	{610,0},
  {537,0},	{574,0},	{572,0},	{538,0},
  {575,0},	{612,0},	{649,0},	{534,0},
  {571,0},	{576,0},	{645,0},	{650,0},
  {687,0},	{540,0},	{577,0},	{614,0},
  {651,0},	{688,0},	{541,0},	{578,0},
  {615,0},	{652,0},	{689,0}
};

static struct patval pat864[] = {
  {684,1},	{683,3},	{682,3},	{685,3},
  {830,0},	{756,0},	{904,0},	{941,0},
  {978,0},	{1015,0},	{1052,0},	{719,0},
  {757,0},	{794,0},	{831,0},	{868,0},
  {905,0},	{942,0},	{979,0},	{1016,0},
  {1053,0},	{867,0},	{758,0},	{795,0},
  {832,0},	{869,0},	{906,0},	{943,0},
  {980,0},	{1017,0},	{1054,0},	{793,0},
  {759,0},	{796,0},	{833,0},	{870,0},
  {907,0},	{944,0},	{981,0},	{1018,0},
  {1055,0},	{686,0},	{723,0},	{760,0},
  {797,0},	{834,0},	{871,0},	{908,0},
  {945,0},	{982,0},	{1019,0},	{1056,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {835,0},	{872,0},	{909,0},	{946,0},
  {983,0},	{1020,0},	{1057,0}
};

static struct patval pat865[] = {
  {684,1},	{612,1},	{685,1},	{648,1},
  {722,2},	{686,2},	{649,2},	{611,3},
  {759,0},	{796,0},	{758,0},	{795,0},
  {723,0},	{760,0},	{797,0},	{613,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{614,0},	{651,0},	{688,0},
  {725,0},	{762,0},	{799,0}
};

static struct patval pat866[] = {
  {684,1},	{648,2},	{796,4},	{759,4},
  {649,0},	{686,0},	{723,0},	{760,0},
  {797,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{798,0}
};

static struct patval pat867[] = {
  {684,1},	{685,1},	{611,1},	{722,2},
  {686,2},	{795,0},	{610,0},	{758,0},
  {759,0},	{796,0},	{612,0},	{649,0},
  {723,0},	{760,0},	{797,0},	{613,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{614,0},	{651,0},	{688,0},
  {725,0},	{762,0},	{799,0}
};

static struct patval pat868[] = {
  {684,1},	{796,1},	{723,1},	{685,1},
  {760,2},	{722,2},	{721,2},	{649,3},
  {686,3},	{650,3},	{757,4},	{720,4},
  {869,0},	{759,0},	{832,0},	{833,0},
  {870,0},	{868,0},	{795,0},	{794,0},
  {831,0},	{797,0},	{834,0},	{871,0},
  {758,0},	{724,0},	{761,0},	{798,0},
  {835,0},	{872,0}
};

static struct patval pat869[] = {
  {612,1},	{649,1},	{538,2},	{611,2},
  {684,2},	{536,0},	{573,0},	{610,0},
  {537,0},	{574,0},	{609,0},	{575,0},
  {535,0},	{572,0},	{539,0},	{576,0},
  {613,0},	{650,0},	{687,0},	{540,0},
  {577,0},	{614,0},	{651,0},	{688,0}
};

static struct patval pat870[] = {
  {684,1},	{722,1},	{687,2},	{648,2},
  {765,3},	{797,3},	{728,3},	{796,3},
  {691,3},	{795,3},	{611,0},	{649,0},
  {723,0},	{760,0},	{610,0},	{613,0},
  {686,0},	{724,0},	{761,0},	{798,0},
  {614,0},	{651,0},	{688,0},	{725,0},
  {762,0},	{799,0},	{615,0},	{652,0},
  {689,0},	{726,0},	{763,0},	{800,0},
  {616,0},	{653,0},	{690,0},	{727,0},
  {764,0},	{801,0},	{617,0},	{654,0},
  {759,0},	{650,0},	{612,0}
};

static struct patval pat871[] = {
  {648,1},	{684,2},	{686,2},	{758,3},
  {651,3},	{760,3},	{759,3},	{574,0},
  {610,0},	{611,0},	{575,0},	{612,0},
  {649,0},	{573,0},	{723,0},	{576,0},
  {613,0},	{650,0},	{687,0},	{577,0},
  {614,0},	{688,0}
};

static struct patval pat872[] = {
  {833,1},	{758,2},	{684,2},	{831,3},
  {907,3},	{648,4},	{905,0},	{794,0},
  {868,0},	{795,0},	{832,0},	{869,0},
  {906,0},	{759,0},	{796,0},	{757,0},
  {870,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0},	{871,0},
  {908,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{835,0},	{872,0},
  {909,0}
};

static struct patval pat873[] = {
  {684,1},	{686,1},	{537,2},	{611,2},
  {833,4},	{797,4},	{759,4},	{834,4},
  {760,4},	{796,4},	{501,4},	{795,0},
  {574,0},	{536,0},	{573,0},	{832,0},
  {538,0},	{575,0},	{612,0},	{649,0},
  {610,0},	{723,0},	{758,0},	{502,0},
  {539,0},	{576,0},	{613,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {835,0},	{503,0},	{540,0},	{577,0},
  {614,0},	{651,0},	{688,0},	{725,0},
  {762,0},	{799,0},	{836,0}
};

static struct patval pat874[] = {
  {833,1},	{758,2},	{684,2},	{648,4},
  {794,0},	{868,0},	{942,0},	{979,0},
  {831,0},	{795,0},	{832,0},	{869,0},
  {906,0},	{943,0},	{980,0},	{905,0},
  {759,0},	{796,0},	{757,0},	{870,0},
  {907,0},	{944,0},	{981,0},	{649,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0},	{871,0},	{908,0},	{945,0},
  {982,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{835,0},	{872,0},
  {909,0},	{946,0},	{983,0}
};

static struct patval pat875[] = {
  {723,1},	{648,1},	{611,1},	{649,2},
  {685,2},	{684,2},	{647,4},	{759,0},
  {686,0},	{758,0},	{760,0},	{613,0},
  {650,0},	{687,0},	{724,0},	{761,0}
};

static struct patval pat876[] = {
  {684,1},	{722,1},	{758,1},	{795,2},
  {759,2},	{867,0},	{719,0},	{757,0},
  {794,0},	{831,0},	{868,0},	{682,0},
  {756,0},	{832,0},	{869,0},	{793,0},
  {830,0},	{796,0},	{833,0},	{870,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0},	{871,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{835,0},	{872,0}
};

static struct patval pat877[] = {
  {686,1},	{648,1},	{758,1},	{684,2},
  {685,2},	{796,0},	{612,0},	{649,0},
  {759,0},	{723,0},	{760,0},	{797,0},
  {613,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{798,0}
};

static struct patval pat878[] = {
  {648,1},	{684,1},	{685,2},	{647,3},
  {795,4},	{796,4},	{832,4},	{833,4},
  {758,0},	{831,0},	{757,0},	{759,0},
  {794,0},	{686,0},	{723,0},	{760,0},
  {797,0},	{834,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{835,0}
};

static struct patval pat879[] = {
  {684,1},	{685,2},	{757,0},	{794,0},
  {610,0},	{758,0},	{795,0},	{611,0},
  {759,0},	{796,0},	{612,0},	{649,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {613,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{614,0},	{651,0},
  {688,0},	{725,0},	{762,0},	{799,0}
};

static struct patval pat880[] = {
  {759,1},	{832,2},	{833,2},	{684,2},
  {756,0},	{830,0},	{757,0},	{794,0},
  {831,0},	{793,0},	{758,0},	{795,0},
  {682,0},	{645,0},	{796,0},	{719,0},
  {649,0},	{686,0},	{723,0},	{760,0},
  {797,0},	{834,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0}
};

static struct patval pat881[] = {
  {758,1},	{832,2},	{833,2},	{684,2},
  {645,0},	{830,0},	{757,0},	{794,0},
  {831,0},	{793,0},	{756,0},	{795,0},
  {682,0},	{759,0},	{796,0},	{719,0},
  {649,0},	{686,0},	{723,0},	{760,0},
  {797,0},	{834,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0}
};

static struct patval pat882[] = {
  {684,1},	{721,1},	{649,2},	{722,2},
  {795,0},	{869,0},	{832,0},	{759,0},
  {796,0},	{833,0},	{870,0},	{758,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0},	{871,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0},
  {872,0},	{651,0},	{688,0},	{725,0},
  {762,0},	{799,0},	{836,0},	{873,0}
};

static struct patval pat883[] = {
  {648,1},	{684,2},	{758,4},	{796,4},
  {795,4},	{610,0},	{794,0},	{611,0},
  {759,0},	{757,0},	{612,0},	{649,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {613,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{798,0}
};

static struct patval pat884[] = {
  {721,1},	{758,1},	{796,1},	{684,2},
  {722,2},	{797,3},	{500,4},	{423,4},
  {460,4},	{425,4},	{426,4},	{424,4},
  {461,4},	{462,4},	{499,4},	{536,4},
  {760,4},	{463,4},	{609,0},	{757,0},
  {794,0},	{756,0},	{498,0},	{535,0},
  {572,0},	{573,0},	{610,0},	{645,0},
  {682,0},	{719,0},	{795,0},	{793,0},
  {608,0},	{537,0},	{574,0},	{611,0},
  {759,0},	{571,0},	{427,0},	{464,0},
  {501,0},	{538,0},	{575,0},	{612,0},
  {649,0},	{686,0},	{723,0},	{497,0},
  {534,0},	{428,0},	{465,0},	{502,0},
  {539,0},	{576,0},	{613,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{798,0}
};

static struct patval pat885[] = {
  {722,1},	{684,1},	{759,2},	{682,3},
  {944,3},	{907,3},	{870,3},	{869,3},
  {906,3},	{943,3},	{645,3},	{793,0},
  {756,0},	{941,0},	{757,0},	{794,0},
  {831,0},	{868,0},	{905,0},	{942,0},
  {573,0},	{610,0},	{758,0},	{795,0},
  {832,0},	{571,0},	{608,0},	{904,0},
  {574,0},	{611,0},	{830,0},	{867,0},
  {796,0},	{833,0},	{572,0},	{609,0},
  {719,0},	{575,0},	{612,0},	{649,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0},	{871,0},	{908,0},	{945,0},
  {576,0},	{613,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0},
  {872,0},	{909,0},	{946,0}
};

static struct patval pat886[] = {
  {649,1},	{685,1},	{723,2},	{684,2},
  {757,0},	{610,0},	{609,0},	{758,0},
  {611,0},	{759,0},	{612,0},	{686,0},
  {760,0},	{613,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{614,0},	{651,0},
  {688,0},	{725,0},	{762,0}
};

static struct patval pat887[] = {
  {684,1},	{611,2},	{758,2},	{796,4},
  {759,4},	{610,0},	{757,0},	{609,0},
  {612,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{613,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{798,0}
};

static struct patval pat888[] = {
  {685,1},	{759,1},	{684,1},	{721,1},
  {723,2},	{795,2},	{758,2},	{648,2},
  {722,2},	{610,0},	{611,0},	{796,0},
  {612,0},	{649,0},	{686,0},	{760,0},
  {797,0},	{613,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{798,0}
};

static struct patval pat889[] = {
  {722,1},	{685,1},	{684,2},	{537,4},
  {574,4},	{611,4},	{536,4},	{573,4},
  {609,0},	{610,0},	{572,0},	{535,0},
  {538,0},	{575,0},	{612,0},	{649,0},
  {686,0},	{723,0},	{539,0},	{576,0},
  {613,0},	{650,0},	{687,0},	{724,0}
};

static struct patval pat890[] = {
  {795,1},	{685,2},	{833,2},	{684,2},
  {832,0},	{759,0},	{796,0},	{758,0},
  {870,0},	{686,0},	{723,0},	{760,0},
  {797,0},	{834,0},	{871,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0},
  {872,0}
};

static struct patval pat891[] = {
  {722,1},	{685,1},	{648,2},	{684,2},
  {796,4},	{833,4},	{795,4},	{575,4},
  {573,4},	{610,4},	{647,4},	{611,4},
  {574,4},	{832,4},	{794,0},	{758,0},
  {831,0},	{609,0},	{759,0},	{757,0},
  {572,0},	{612,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0},
  {576,0},	{613,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0}
};

static struct patval pat892[] = {
  {651,1},	{686,1},	{687,1},	{684,2},
  {724,2},	{725,2},	{688,2},	{574,0},
  {573,0},	{759,0},	{795,0},	{575,0},
  {612,0},	{649,0},	{610,0},	{723,0},
  {760,0},	{797,0},	{576,0},	{613,0},
  {650,0},	{611,0},	{796,0},	{761,0},
  {798,0},	{577,0},	{614,0},	{758,0},
  {762,0},	{799,0}
};

static struct patval pat893[] = {
  {648,1},	{684,1},	{611,2},	{500,2},
  {686,2},	{573,0},	{463,0},	{499,0},
  {537,0},	{574,0},	{536,0},	{462,0},
  {464,0},	{501,0},	{538,0},	{575,0},
  {612,0},	{649,0},	{610,0},	{465,0},
  {502,0},	{539,0},	{576,0},	{613,0},
  {650,0},	{687,0}
};

static struct patval pat894[] = {
  {684,1},	{721,1},	{798,1},	{722,1},
  {759,1},	{797,1},	{760,1},	{724,4},
  {686,4},	{687,0},	{723,0},	{761,0}
};

static struct patval pat895[] = {
  {684,2},	{721,2},	{798,2},	{722,2},
  {759,2},	{797,2},	{760,2},	{723,3},
  {724,3},	{687,0},	{686,0},	{761,0}
};

static struct patval pat896[] = {
  {684,1},	{721,1},	{758,1},	{795,1},
  {832,1},	{833,1},	{834,1},	{759,0},
  {796,0},	{686,0},	{723,0},	{760,0},
  {797,0}
};

static struct patval pat897[] = {
  {684,2},	{721,2},	{758,2},	{795,2},
  {832,2},	{833,2},	{834,2},	{759,0},
  {796,0},	{686,0},	{723,0},	{760,0},
  {797,0}
};

static struct patval pat898[] = {
  {723,1},	{721,2},	{758,2},	{795,2},
  {832,2},	{684,2},	{834,2},	{759,2},
  {833,2},	{796,0},	{686,0},	{760,0},
  {797,0}
};

static struct patval pat899[] = {
  {684,1},	{721,1},	{798,1},	{722,1},
  {759,1},	{796,1},	{797,1},	{723,0},
  {760,0},	{686,0},	{687,0},	{724,0},
  {761,0}
};

static struct patval pat900[] = {
  {684,1},	{721,1},	{798,1},	{722,1},
  {759,1},	{796,1},	{686,1},	{797,1},
  {723,2},	{760,0},	{687,0},	{724,0},
  {761,0}
};

static struct patval pat901[] = {
  {724,1},	{723,1},	{798,2},	{722,2},
  {759,2},	{796,2},	{686,2},	{721,2},
  {684,2},	{797,2},	{687,0},	{760,0},
  {761,0}
};

static struct patval pat902[] = {
  {684,2},	{721,2},	{798,2},	{722,2},
  {759,2},	{796,2},	{797,2},	{723,0},
  {760,0},	{686,0},	{687,0},	{724,0},
  {761,0}
};

static struct patval pat903[] = {
  {684,1},	{721,1},	{797,1},	{722,1},
  {759,1},	{796,1},	{835,1},	{834,1},
  {760,0},	{723,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{686,0}
};

static struct patval pat904[] = {
  {684,2},	{721,2},	{797,2},	{722,2},
  {759,2},	{796,2},	{835,2},	{834,2},
  {760,0},	{723,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{686,0}
};

static struct patval pat905[] = {
  {684,1},	{721,1},	{758,1},	{835,1},
  {834,1},	{759,1},	{796,1},	{797,1},
  {723,0},	{760,0},	{686,0},	{687,0},
  {724,0},	{761,0},	{798,0}
};

static struct patval pat906[] = {
  {723,1},	{684,2},	{758,2},	{835,2},
  {834,2},	{759,2},	{796,2},	{797,2},
  {721,2},	{760,0},	{686,0},	{687,0},
  {724,0},	{761,0},	{798,0}
};

static struct patval pat907[] = {
  {684,1},	{721,1},	{758,1},	{835,1},
  {761,1},	{759,1},	{796,1},	{834,1},
  {797,1},	{723,2},	{760,0},	{686,0},
  {687,0},	{724,0},	{798,0}
};

static struct patval pat908[] = {
  {684,1},	{721,1},	{758,1},	{835,1},
  {761,1},	{759,1},	{796,1},	{834,1},
  {724,1},	{797,1},	{760,2},	{723,2},
  {687,0},	{686,0},	{798,0}
};

static struct patval pat909[] = {
  {684,2},	{721,2},	{758,2},	{835,2},
  {834,2},	{759,2},	{796,2},	{797,2},
  {723,0},	{760,0},	{686,0},	{687,0},
  {724,0},	{761,0},	{798,0}
};

static struct patval pat910[] = {
  {684,1},	{721,1},	{758,1},	{795,1},
  {834,1},	{797,1},	{835,1},	{796,1},
  {686,0},	{723,0},	{760,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{759,0}
};

static struct patval pat911[] = {
  {684,2},	{721,2},	{758,2},	{795,2},
  {834,2},	{797,2},	{835,2},	{796,2},
  {686,0},	{723,0},	{760,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{759,0}
};

static struct patval pat912[] = {
  {722,1},	{723,1},	{684,2},	{795,2},
  {834,2},	{758,2},	{835,2},	{796,2},
  {797,2},	{721,2},	{760,2},	{686,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {759,0}
};

static struct patval pat913[] = {
  {684,1},	{721,1},	{835,1},	{722,1},
  {759,1},	{797,1},	{798,1},	{760,1},
  {836,1},	{687,0},	{686,0},	{761,0},
  {723,0},	{688,0},	{725,0},	{762,0},
  {799,0},	{724,0}
};

static struct patval pat914[] = {
  {684,2},	{721,2},	{835,2},	{722,2},
  {759,2},	{797,2},	{798,2},	{760,2},
  {836,2},	{687,0},	{686,0},	{761,0},
  {723,0},	{688,0},	{725,0},	{762,0},
  {799,0},	{724,0}
};

static struct patval pat915[] = {
  {906,2},	{684,2},	{719,0},	{793,0},
  {682,0},	{867,0},	{904,0},	{757,0},
  {794,0},	{831,0},	{868,0},	{905,0},
  {756,0},	{758,0},	{795,0},	{832,0},
  {869,0},	{830,0},	{759,0},	{796,0},
  {833,0},	{870,0},	{907,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0},
  {871,0},	{908,0}
};

static struct patval pat916[] = {
  {906,2},	{684,2},	{755,0},	{681,0},
  {829,0},	{866,0},	{903,0},	{718,0},
  {719,0},	{756,0},	{793,0},	{830,0},
  {867,0},	{904,0},	{757,0},	{794,0},
  {831,0},	{868,0},	{905,0},	{682,0},
  {758,0},	{795,0},	{832,0},	{869,0},
  {792,0},	{759,0},	{796,0},	{833,0},
  {870,0},	{907,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0},	{871,0},
  {908,0}
};

static struct patval pat917[] = {
  {684,2},	{681,4},	{644,0},	{718,0},
  {755,0},	{608,0},	{645,0},	{682,0},
  {719,0},	{756,0},	{609,0},	{757,0},
  {610,0},	{607,0},	{758,0},	{611,0},
  {759,0},	{612,0},	{649,0},	{686,0},
  {723,0},	{760,0}
};

static struct patval pat918[] = {
  {684,2},	{682,4},	{645,0},	{719,0},
  {756,0},	{608,0},	{757,0},	{610,0},
  {609,0},	{758,0},	{611,0},	{759,0},
  {612,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{613,0},	{650,0},	{687,0},
  {724,0},	{761,0}
};

static struct patval pat919[] = {
  {684,2},	{644,0},	{681,0},	{718,0},
  {755,0},	{608,0},	{645,0},	{682,0},
  {719,0},	{756,0},	{609,0},	{757,0},
  {610,0},	{607,0},	{758,0},	{611,0},
  {759,0},	{612,0},	{649,0},	{686,0},
  {723,0},	{760,0}
};

static struct patval pat920[] = {
  {684,2},	{608,0},	{682,0},	{719,0},
  {756,0},	{793,0},	{609,0},	{757,0},
  {794,0},	{610,0},	{645,0},	{758,0},
  {795,0},	{611,0},	{759,0},	{796,0},
  {612,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{797,0}
};

static struct patval pat921[] = {
  {684,2},	{758,4},	{610,4},	{647,4},
  {721,4},	{605,0},	{642,0},	{680,0},
  {717,0},	{754,0},	{607,0},	{644,0},
  {681,0},	{718,0},	{755,0},	{608,0},
  {645,0},	{682,0},	{719,0},	{756,0},
  {609,0},	{757,0},	{679,0},	{716,0},
  {753,0},	{606,0},	{643,0}
};

static struct patval pat922[] = {
  {684,2},	{833,4},	{685,4},	{832,4},
  {831,0},	{794,0},	{758,0},	{795,0},
  {757,0},	{759,0},	{796,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {835,0}
};

static struct patval pat923[] = {
  {684,2},	{831,4},	{683,4},	{832,4},
  {829,0},	{792,0},	{719,0},	{756,0},
  {793,0},	{830,0},	{681,0},	{757,0},
  {794,0},	{718,0},	{682,0},	{758,0},
  {795,0},	{755,0},	{759,0},	{796,0},
  {833,0},	{686,0},	{723,0},	{760,0},
  {797,0},	{834,0}
};

static struct patval pat924[] = {
  {684,2},	{719,0},	{682,0},	{793,0},
  {830,0},	{757,0},	{794,0},	{831,0},
  {756,0},	{758,0},	{795,0},	{832,0},
  {759,0},	{796,0},	{833,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0}
};

static struct patval pat925[] = {
  {684,2},	{757,0},	{794,0},	{831,0},
  {758,0},	{795,0},	{832,0},	{759,0},
  {796,0},	{833,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0}
};

static struct patval pat926[] = {
  {684,2},	{649,4},	{645,4},	{795,4},
  {793,0},	{719,0},	{757,0},	{794,0},
  {758,0},	{756,0},	{759,0},	{796,0},
  {682,0},	{686,0},	{723,0},	{760,0},
  {797,0}
};

static struct patval pat927[] = {
  {684,2},	{649,4},	{686,4},	{645,4},
  {794,4},	{796,4},	{793,0},	{757,0},
  {756,0},	{758,0},	{795,0},	{759,0},
  {682,0},	{719,0},	{723,0},	{760,0},
  {797,0}
};

static struct patval pat928[] = {
  {797,2},	{722,2},	{684,2},	{795,0},
  {611,0},	{758,0},	{759,0},	{796,0},
  {612,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{610,0},	{613,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {614,0},	{651,0},	{688,0},	{725,0},
  {762,0},	{799,0}
};

static struct patval pat929[] = {
  {684,2},	{796,4},	{794,4},	{759,4},
  {757,4},	{795,4},	{758,4},	{610,0},
  {611,0},	{609,0},	{612,0},	{649,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {613,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{798,0}
};

static struct patval pat930[] = {
  {684,2},	{758,4},	{682,4},	{719,4},
  {756,4},	{757,4},	{609,0},	{610,0},
  {645,0},	{608,0},	{611,0},	{759,0},
  {612,0},	{649,0},	{686,0},	{723,0},
  {760,0}
};

static struct patval pat931[] = {
  {684,2},	{609,0},	{573,0},	{610,0},
  {572,0},	{574,0},	{611,0},	{575,0},
  {612,0},	{649,0},	{686,0},	{723,0},
  {576,0},	{613,0},	{650,0},	{687,0},
  {724,0}
};

static struct patval pat932[] = {
  {832,2},	{684,2},	{719,0},	{757,0},
  {794,0},	{831,0},	{756,0},	{758,0},
  {795,0},	{793,0},	{759,0},	{796,0},
  {833,0},	{686,0},	{723,0},	{760,0},
  {797,0},	{834,0}
};

static struct patval pat933[] = {
  {684,2},	{832,2},	{794,0},	{831,0},
  {757,0},	{758,0},	{795,0},	{759,0},
  {796,0},	{833,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0}
};

static struct patval pat934[] = {
  {684,1},	{686,1},	{758,0},	{759,0},
  {723,0},	{760,0}
};

static struct patval pat935[] = {
  {648,1},	{684,2},	{646,3},	{683,3}
};

static struct patval pat936[] = {
  {611,1},	{684,2},	{683,3},	{646,3},
  {610,0}
};

static struct patval pat937[] = {
  {684,2},	{906,2},	{795,2},	{757,0},
  {831,0},	{868,0},	{905,0},	{758,0},
  {794,0},	{832,0},	{869,0},	{759,0},
  {796,0},	{833,0},	{870,0},	{907,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0},	{871,0},	{908,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0},
  {872,0},	{909,0}
};

static struct patval pat938[] = {
  {758,1},	{684,2},	{795,3},	{759,0},
  {796,0},	{686,0},	{723,0},	{760,0},
  {797,0},	{687,0},	{724,0},	{761,0},
  {798,0}
};

static struct patval pat939[] = {
  {758,1},	{684,2},	{832,3},	{795,3},
  {759,0},	{796,0},	{833,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0}
};

static struct patval pat940[] = {
  {684,1},	{650,2},	{721,3},	{647,3},
  {651,4},	{649,0},	{686,0},	{723,0},
  {687,0},	{724,0},	{688,0},	{725,0}
};

static struct patval pat941[] = {
  {684,1},	{648,2},	{758,3},	{721,3},
  {759,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{650,0},	{687,0},	{724,0},
  {761,0}
};

static struct patval pat942[] = {
  {684,1},	{611,2},	{683,3},	{571,4},
  {534,4},	{609,0},	{535,0},	{536,0},
  {573,0},	{610,0},	{537,0},	{574,0},
  {572,0}
};

static struct patval pat943[] = {
  {648,1},	{721,2},	{684,2},	{758,4},
  {759,0},	{649,0},	{686,0},	{723,0},
  {760,0}
};

static struct patval pat944[] = {
  {760,1},	{685,1},	{684,2},	{611,2},
  {758,3},	{646,4},	{609,4},	{759,0},
  {612,0},	{649,0},	{686,0},	{723,0},
  {610,0},	{613,0},	{650,0},	{687,0},
  {724,0},	{761,0}
};

static struct patval pat945[] = {
  {685,1},	{721,1},	{684,2}
};

static struct patval pat946[] = {
  {648,1},	{684,2},	{758,0},	{759,0},
  {649,0},	{686,0},	{723,0},	{760,0}
};

static struct patval pat947[] = {
  {686,1},	{685,1},	{648,2},	{684,2},
  {646,4},	{574,0},	{611,0},	{573,0},
  {575,0},	{612,0},	{649,0},	{610,0},
  {576,0},	{613,0},	{650,0},	{687,0}
};

static struct patval pat948[] = {
  {758,2},	{684,2},	{753,3},	{679,3},
  {716,3},	{754,3},	{680,3},	{722,4},
  {721,4},	{682,0},	{719,0},	{756,0},
  {757,0},	{718,0},	{755,0},	{681,0},
  {717,0}
};

static struct patval pat949[] = {
  {686,1},	{685,1},	{722,2},	{684,2},
  {610,0},	{649,0},	{611,0}
};

static struct patval pat950[] = {
  {684,1},	{686,1},	{721,2},	{685,2},
  {724,2},	{761,2},	{796,2},	{758,2},
  {723,2},	{797,2},	{760,0},	{759,0}
};

static struct patval pat951[] = {
  {723,1},	{613,1},	{650,1},	{612,1},
  {611,1},	{649,2},	{684,2},	{687,2},
  {648,2},	{758,0},	{759,0},	{796,0},
  {610,0},	{686,0},	{795,0},	{760,0},
  {797,0},	{724,0},	{761,0},	{798,0},
  {614,0},	{651,0},	{688,0},	{725,0},
  {762,0},	{799,0}
};

static struct patval pat952[] = {
  {759,1},	{832,2},	{684,2},	{756,0},
  {719,0},	{830,0},	{867,0},	{757,0},
  {794,0},	{831,0},	{868,0},	{793,0},
  {758,0},	{795,0},	{682,0},	{869,0},
  {645,0},	{796,0},	{833,0},	{870,0},
  {649,0},	{686,0},	{723,0},	{760,0},
  {797,0},	{834,0},	{871,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {835,0},	{872,0}
};

static struct patval pat953[] = {
  {796,1},	{795,1},	{721,1},	{722,2},
  {758,2},	{684,2},	{759,2},	{831,0},
  {794,0},	{757,0}
};

static struct patval pat954[] = {
  {686,1},	{722,1},	{687,1},	{574,1},
  {649,2},	{684,2},	{685,2},	{575,0},
  {611,0},	{610,0},	{723,0},	{760,0},
  {576,0},	{613,0},	{650,0},	{612,0},
  {724,0},	{761,0}
};

static struct patval pat955[] = {
  {684,1},	{611,2},	{610,4},	{574,0},
  {575,0},	{612,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{576,0},	{613,0},
  {650,0},	{687,0},	{724,0},	{761,0}
};

static struct patval pat956[] = {
  {684,1},	{612,1},	{649,1},	{648,2},
  {686,2},	{646,3},	{683,3},	{572,3},
  {574,3},	{609,3},	{611,0},	{573,0},
  {610,0}
};

static struct patval pat957[] = {
  {648,1},	{721,1},	{685,2},	{574,2},
  {684,2},	{611,0},	{758,0},	{759,0},
  {575,0},	{612,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{576,0},	{613,0},
  {650,0},	{687,0},	{724,0},	{761,0}
};

static struct patval pat958[] = {
  {684,1},	{721,1},	{686,1},	{723,1},
  {760,2},	{648,2},	{758,2},	{759,0}
};

static struct patval pat959[] = {
  {686,2},	{612,2},	{650,2},	{685,2},
  {684,2},	{611,0},	{649,0},	{609,0},
  {613,0},	{610,0}
};

static struct patval pat960[] = {
  {684,1},	{832,1},	{794,0},	{831,0},
  {757,0},	{758,0},	{795,0},	{759,0},
  {796,0},	{833,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0}
};

static struct patval pat961[] = {
  {684,1},	{647,3},	{610,3},	{721,3},
  {758,3},	{611,4},	{760,4},	{612,4},
  {759,4},	{649,0},	{686,0},	{723,0},
  {613,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{614,0},	{651,0},	{688,0},
  {725,0},	{762,0}
};

static struct patval pat962[] = {
  {684,1},	{795,3},	{646,4},	{757,4},
  {794,4},	{683,4},	{758,0},	{759,0},
  {796,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{798,0}
};

static struct patval pat963[] = {
  {684,1},	{647,4},	{610,4},	{721,4},
  {758,4},	{611,4},	{759,4},	{612,0},
  {649,0},	{686,0},	{723,0},	{760,0},
  {613,0},	{650,0},	{687,0},	{724,0},
  {761,0}
};

static struct patval pat964[] = {
  {684,1},	{724,4},	{761,4},	{795,4},
  {798,4},	{687,4},	{796,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{758,0},
  {759,0}
};

static struct patval pat965[] = {
  {684,1},	{723,4},	{760,4},	{794,4},
  {686,4},	{797,4},	{795,0},	{759,0},
  {796,0},	{757,0},	{758,0}
};

static struct patval pat966[] = {
  {684,1},	{794,3},	{797,3},	{759,4},
  {758,4},	{757,0},	{795,0},	{796,0},
  {649,0},	{686,0},	{723,0},	{760,0}
};

static struct patval pat967[] = {
  {684,1},	{685,2},	{797,3},	{758,4},
  {646,4},	{683,4},	{759,4},	{757,0},
  {795,0},	{796,0},	{649,0},	{686,0},
  {723,0},	{760,0}
};

static struct patval pat968[] = {
  {684,2},	{796,3},	{794,0},	{758,0},
  {795,0},	{759,0},	{757,0}
};

static struct patval pat969[] = {
  {758,2},	{684,2},	{719,3},	{757,3},
  {722,4}
};

static struct patval pat970[] = {
  {758,2},	{684,2},	{719,3},	{722,4},
  {683,4}
};

static struct patval pat971[] = {
  {684,2},	{758,2},	{682,0},	{756,0},
  {757,0},	{718,0},	{719,0}
};

static struct patval pat972[] = {
  {649,2},	{684,2},	{686,0},	{723,0}
};

static struct patval pat973[] = {
  {684,2},	{686,2},	{612,2},	{610,3},
  {611,4},	{649,0}
};

static struct patval pat974[] = {
  {723,2},	{684,2},	{649,2},	{647,3},
  {648,4},	{686,0}
};

static struct patval pat975[] = {
  {722,2},	{684,2},	{611,3},	{760,3},
  {686,0},	{723,0}
};

static struct patval pat976[] = {
  {685,1},	{722,2},	{684,2},	{686,0}
};

static struct patval pat977[] = {
  {685,1},	{722,2},	{684,2},	{686,0}
};

static struct patval pat978[] = {
  {686,2},	{684,2},	{722,2},	{648,2},
  {721,3},	{649,0},	{723,0}
};

static struct patval pat979[] = {
  {684,1},	{683,4},	{610,0}
};

static struct patval pat980[] = {
  {685,1},	{684,2},	{722,2},	{686,2},
  {723,4},	{649,0}
};

static struct patval pat981[] = {
  {684,2},	{610,0},	{611,0},	{612,0},
  {649,0},	{686,0}
};

static struct patval pat982[] = {
  {684,1},	{722,2},	{649,0},	{686,0},
  {723,0}
};

static struct patval pat983[] = {
  {684,1},	{721,2},	{720,3}
};

static struct patval pat984[] = {
  {684,1},	{608,0},	{682,0},	{719,0},
  {756,0},	{609,0},	{757,0},	{610,0},
  {645,0},	{758,0},	{611,0},	{759,0},
  {612,0},	{649,0},	{686,0},	{723,0},
  {760,0}
};

static struct patval pat985[] = {
  {684,1},	{685,1},	{686,2},	{609,0},
  {610,0},	{757,0},	{758,0},	{611,0},
  {759,0},	{612,0},	{649,0},	{723,0},
  {760,0},	{613,0},	{650,0},	{687,0},
  {724,0},	{761,0}
};

static struct patval pat986[] = {
  {684,1},	{722,1},	{721,1},	{760,2},
  {723,2},	{758,0},	{795,0},	{759,0},
  {796,0},	{649,0},	{686,0},	{757,0},
  {794,0},	{797,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{798,0}
};

static struct patval pat987[] = {
  {685,1},	{722,1},	{684,1},	{721,1},
  {760,2},	{723,2},	{759,2},	{758,0},
  {795,0},	{796,0},	{649,0},	{686,0},
  {757,0},	{794,0},	{797,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{798,0}
};

static struct patval pat988[] = {
  {685,1},	{722,1},	{686,1},	{721,1},
  {684,1},	{759,2},	{760,2},	{723,2},
  {758,2},	{795,0},	{796,0},	{649,0},
  {757,0},	{794,0},	{797,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{798,0}
};

static struct patval pat989[] = {
  {649,1},	{686,1},	{650,1},	{688,1},
  {685,1},	{648,1},	{684,2},	{724,2},
  {722,2},	{687,2},	{723,2},	{610,0},
  {612,0},	{760,0},	{613,0},	{611,0},
  {759,0},	{758,0},	{761,0},	{614,0},
  {651,0},	{725,0},	{762,0}
};

static struct patval pat990[] = {
  {649,1},	{686,1},	{650,1},	{721,1},
  {688,1},	{685,1},	{648,1},	{684,2},
  {724,2},	{687,2},	{651,2},	{722,2},
  {723,2},	{760,0},	{613,0},	{611,0},
  {759,0},	{758,0},	{761,0},	{614,0},
  {612,0},	{610,0},	{725,0},	{762,0}
};

static struct patval pat991[] = {
  {686,1},	{723,1},	{687,1},	{758,1},
  {762,1},	{725,1},	{685,1},	{722,1},
  {721,2},	{724,2},	{688,2},	{759,2},
  {684,2},	{760,2},	{761,2},	{650,0},
  {796,0},	{797,0},	{798,0},	{651,0},
  {649,0},	{795,0},	{799,0}
};

static struct patval pat992[] = {
  {684,2},	{758,2}
};

static struct patval pat993[] = {
  {684,2},	{758,2}
};

static struct patval pat994[] = {
  {684,2},	{758,2},	{759,0}
};

static struct patval pat995[] = {
  {758,2},	{684,2},	{759,0}
};

static struct patval pat996[] = {
  {721,1},	{684,2},	{758,2},	{759,0}
};

static struct patval pat997[] = {
  {758,2},	{684,2},	{759,0}
};

static struct patval pat998[] = {
  {684,2},	{722,2},	{685,3}
};

static struct patval pat999[] = {
  {684,2},	{722,2},	{685,3},	{758,0}
};

static struct patval pat1000[] = {
  {684,1},	{721,2},	{685,2},	{760,0}
};

static struct patval pat1001[] = {
  {684,1},	{721,2},	{685,2}
};

static struct patval pat1002[] = {
  {684,1},	{721,2},	{685,2},	{758,0}
};

static struct patval pat1003[] = {
  {649,1},	{685,1},	{684,2},	{648,2},
  {611,0},	{612,0},	{610,0},	{686,0}
};

static struct patval pat1004[] = {
  {649,1},	{684,1},	{685,1},	{650,2},
  {686,2},	{611,0},	{612,0},	{613,0},
  {687,0}
};

static struct patval pat1005[] = {
  {684,2},	{759,2},	{758,0}
};

static struct patval pat1006[] = {
  {685,1},	{759,2},	{684,2}
};

static struct patval pat1007[] = {
  {684,2},	{759,2},	{758,0},	{795,0}
};

static struct patval pat1008[] = {
  {685,1},	{759,2},	{684,2},	{795,0},
  {758,0}
};

static struct patval pat1009[] = {
  {684,2},	{759,2},	{758,0},	{796,0}
};

static struct patval pat1010[] = {
  {685,1},	{759,2},	{684,2},	{758,0},
  {796,0}
};

static struct patval pat1011[] = {
  {758,1},	{759,2},	{684,2},	{796,0}
};

static struct patval pat1012[] = {
  {684,2},	{759,2},	{758,0}
};

static struct patval pat1013[] = {
  {685,1},	{759,2},	{684,2},	{758,0}
};

static struct patval pat1014[] = {
  {684,2},	{759,2},	{757,0},	{758,0}
};

static struct patval pat1015[] = {
  {722,1},	{759,2},	{684,2},	{758,0}
};

static struct patval pat1016[] = {
  {722,1},	{759,2},	{684,2},	{685,3},
  {758,0}
};

static struct patval pat1017[] = {
  {686,1},	{684,2},	{723,2},	{648,2},
  {649,3}
};

static struct patval pat1018[] = {
  {722,1},	{759,2},	{684,2},	{685,3},
  {758,0},	{757,0}
};

static struct patval pat1019[] = {
  {722,1},	{758,1},	{759,2},	{684,2}
};

static struct patval pat1020[] = {
  {684,2},	{759,2},	{685,2},	{795,0},
  {758,0}
};

static struct patval pat1021[] = {
  {684,2},	{759,2},	{685,2},	{758,0},
  {796,0}
};

static struct patval pat1022[] = {
  {684,2},	{685,2},	{758,2},	{759,0}
};

static struct patval pat1023[] = {
  {684,2},	{795,2},	{758,0}
};

static struct patval pat1024[] = {
  {684,2},	{795,2},	{758,0},	{759,0},
  {796,0}
};

static struct patval pat1025[] = {
  {684,2},	{795,2},	{758,0},	{759,0},
  {796,0}
};

static struct patval pat1026[] = {
  {684,2},	{795,2},	{758,0},	{759,0},
  {796,0}
};

static struct patval pat1027[] = {
  {721,1},	{795,2},	{684,2},	{757,0},
  {758,0},	{759,0},	{796,0}
};

static struct patval pat1028[] = {
  {721,1},	{684,2},	{722,2},	{795,2},
  {758,0},	{759,0},	{796,0}
};

static struct patval pat1029[] = {
  {685,1},	{684,2},	{795,2},	{758,0},
  {759,0},	{796,0}
};

static struct patval pat1030[] = {
  {684,2},	{759,2},	{795,2},	{758,0}
};

static struct patval pat1031[] = {
  {648,1},	{684,1},	{722,2},	{611,2},
  {610,4},	{612,0},	{649,0},	{686,0},
  {723,0}
};

static struct patval pat1032[] = {
  {648,1},	{684,1},	{611,2},	{722,2},
  {612,0},	{649,0},	{686,0},	{723,0}
};

static struct patval pat1033[] = {
  {684,2},	{795,2},	{798,2},	{758,0},
  {796,0},	{686,0},	{723,0},	{760,0},
  {797,0},	{724,0},	{761,0},	{759,0}
};

static struct patval pat1034[] = {
  {722,1},	{796,2},	{684,2},	{795,0},
  {758,0},	{759,0}
};

static struct patval pat1035[] = {
  {684,2},	{796,2},	{758,0},	{795,0},
  {759,0}
};

static struct patval pat1036[] = {
  {759,1},	{684,2},	{796,2},	{794,4},
  {758,0},	{795,0},	{757,0}
};

static struct patval pat1037[] = {
  {759,1},	{684,2},	{796,2},	{794,4},
  {758,0},	{795,0},	{757,0}
};

static struct patval pat1038[] = {
  {684,2},	{796,2},	{758,0},	{795,0},
  {759,0}
};

static struct patval pat1039[] = {
  {685,1},	{796,2},	{684,2},	{795,0},
  {758,0},	{759,0}
};

static struct patval pat1040[] = {
  {684,2},	{796,2},	{758,0},	{795,0},
  {759,0}
};

static struct patval pat1041[] = {
  {723,1},	{685,2},	{797,2},	{684,2},
  {759,0},	{796,0},	{760,0},	{758,0}
};

static struct patval pat1042[] = {
  {722,1},	{684,2},	{796,2},	{758,0},
  {795,0},	{759,0},	{757,0}
};

static struct patval pat1043[] = {
  {759,1},	{796,2},	{684,2},	{795,0},
  {758,0},	{833,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0}
};

static struct patval pat1044[] = {
  {758,1},	{721,1},	{684,2},	{796,2},
  {759,0}
};

static struct patval pat1045[] = {
  {721,1},	{684,2},	{796,2},	{795,4},
  {758,0},	{759,0}
};

static struct patval pat1046[] = {
  {684,2},	{796,2},	{685,2},	{758,0},
  {759,0}
};

static struct patval pat1047[] = {
  {758,1},	{796,2},	{684,2},	{685,2},
  {759,0}
};

static struct patval pat1048[] = {
  {759,1},	{796,2},	{684,2},	{685,2},
  {795,0},	{758,0}
};

static struct patval pat1049[] = {
  {684,2},	{685,2},	{796,2},	{758,0},
  {795,0},	{757,0},	{759,0},	{794,0}
};

static struct patval pat1050[] = {
  {684,2},	{796,2},	{685,2},	{795,0},
  {758,0},	{759,0}
};

static struct patval pat1051[] = {
  {758,1},	{721,1},	{684,2},	{795,2},
  {685,2},	{759,0},	{796,0},	{686,0},
  {723,0},	{760,0},	{797,0}
};

static struct patval pat1052[] = {
  {758,1},	{685,2},	{684,2},	{795,2},
  {759,0},	{796,0},	{686,0},	{723,0},
  {760,0},	{797,0}
};

static struct patval pat1053[] = {
  {722,1},	{684,2},	{796,2},	{685,2},
  {795,0},	{758,0},	{759,0}
};

static struct patval pat1054[] = {
  {648,2},	{684,2},	{759,2},	{758,0}
};

static struct patval pat1055[] = {
  {758,1},	{684,1},	{685,2},	{759,2},
  {722,4},	{757,0}
};

static struct patval pat1056[] = {
  {684,1},	{722,1},	{685,2}
};

static struct patval pat1057[] = {
  {684,1},	{759,1},	{722,2},	{758,0}
};

static struct patval pat1058[] = {
  {684,1},	{759,1},	{758,2},	{722,2}
};

static struct patval pat1059[] = {
  {648,1},	{723,1},	{684,2},	{721,2},
  {686,0}
};

static struct patval pat1060[] = {
  {684,1},	{795,1},	{758,2},	{759,0},
  {796,0},	{686,0},	{723,0},	{760,0},
  {797,0}
};

static struct patval pat1061[] = {
  {684,1},	{796,1},	{721,2},	{795,0},
  {759,0},	{758,0},	{686,0},	{723,0},
  {760,0},	{797,0}
};

static struct patval pat1062[] = {
  {684,1},	{648,1},	{721,2},	{685,2},
  {649,0},	{686,0},	{723,0}
};

static struct patval pat1063[] = {
  {684,1},	{648,1},	{721,2},	{685,2},
  {649,0},	{686,0},	{723,0}
};

static struct patval pat1064[] = {
  {722,1},	{758,1},	{721,2},	{684,2},
  {759,0}
};

static struct patval pat1065[] = {
  {685,1},	{684,2},	{648,2},	{686,2},
  {649,0}
};

static struct patval pat1066[] = {
  {684,1},	{687,1},	{648,1},	{649,1},
  {721,2},	{685,2},	{686,2},	{723,0},
  {760,0},	{650,0},	{759,0},	{724,0},
  {761,0}
};

static struct patval pat1067[] = {
  {649,1},	{685,1},	{648,2},	{684,2},
  {686,0}
};

static struct patval pat1068[] = {
  {684,1},	{721,1},	{648,4},	{759,4}
};

static struct patval pat1069[] = {
  {684,2},	{721,2}
};

static struct patval pat1070[] = {
  {684,2},	{722,2}
};

static struct patval pat1071[] = {
  {684,2},	{722,2},	{685,2}
};

static struct patval pat1072[] = {
  {649,1},	{686,1},	{685,1},	{684,2},
  {648,2},	{612,3},	{611,0},	{610,0}
};

static struct patval pat1073[] = {
  {723,1},	{760,1},	{759,1},	{684,2},
  {722,2},	{758,2},	{686,0}
};

static struct patval pat1074[] = {
  {686,1},	{649,2},	{684,2},	{612,2},
  {685,2},	{611,0},	{610,0}
};

static struct patval pat1075[] = {
  {649,2},	{612,2},	{684,2},	{685,2},
  {686,4},	{611,0},	{610,0}
};

static struct patval pat1076[] = {
  {649,1},	{612,1},	{684,1},	{685,1},
  {686,2},	{611,0},	{610,0}
};

static struct patval pat1077[] = {
  {721,1},	{722,2},	{684,2},	{758,2},
  {757,0},	{756,0},	{682,0},	{719,0},
  {759,0}
};

static struct patval pat1078[] = {
  {721,1},	{722,2},	{759,2},	{758,2},
  {684,2},	{757,0},	{682,0},	{719,0},
  {756,0}
};

static struct patval pat1079[] = {
  {721,1},	{759,1},	{722,2},	{758,2},
  {684,2},	{757,4},	{682,0},	{719,0},
  {756,0}
};

static struct patval pat1080[] = {
  {721,1},	{685,1},	{723,1},	{758,2},
  {722,2},	{684,2},	{686,3},	{760,3},
  {683,4},	{757,0},	{759,0},	{719,0},
  {756,0},	{682,0}
};

static struct patval pat1081[] = {
  {758,1},	{722,1},	{684,1},	{721,2},
  {683,4},	{757,4},	{756,4},	{682,4},
  {719,4},	{759,0}
};

static struct patval pat1082[] = {
  {758,1},	{722,1},	{759,1},	{684,1},
  {721,2},	{757,4},	{756,4},	{682,4},
  {683,4},	{719,4}
};

static struct patval pat1083[] = {
  {758,1},	{722,1},	{684,1},	{721,2},
  {759,2},	{757,4},	{756,4},	{682,4},
  {683,4},	{719,4}
};

static struct patval pat1084[] = {
  {686,1},	{684,1},	{722,1},	{687,2},
  {723,2},	{721,3},	{647,3},	{650,4},
  {724,4},	{649,0}
};

static struct patval pat1085[] = {
  {684,1},	{685,1},	{649,1},	{648,2},
  {683,3},	{573,3},	{611,0},	{609,0},
  {610,0}
};

static struct patval pat1086[] = {
  {685,1},	{684,1},	{686,1},	{650,1},
  {649,2},	{648,2},	{573,3},	{682,3},
  {610,0},	{611,0},	{608,0},	{645,0},
  {609,0}
};

static struct patval pat1087[] = {
  {684,1},	{685,1},	{648,2},	{683,3},
  {610,0},	{611,0},	{609,0}
};

static struct patval pat1088[] = {
  {684,1},	{686,2},	{722,2},	{649,0},
  {723,0}
};

static struct patval pat1089[] = {
  {686,1},	{684,1},	{721,2},	{685,2},
  {647,3},	{649,3},	{759,3},	{723,0}
};

static struct patval pat1090[] = {
  {686,1},	{684,1},	{721,2},	{685,2},
  {647,3},	{723,3},	{649,3},	{759,0}
};

static struct patval pat1091[] = {
  {684,1},	{686,1},	{721,2},	{685,2},
  {722,4}
};

static struct patval pat1092[] = {
  {759,1},	{685,1},	{722,2},	{684,2},
  {758,0},	{686,0},	{723,0},	{760,0}
};

static struct patval pat1093[] = {
  {759,1},	{684,2},	{758,2}
};

static struct patval pat1094[] = {
  {759,1},	{758,2},	{684,2},	{757,0}
};

static struct patval pat1095[] = {
  {759,1},	{648,1},	{758,2},	{684,2},
  {649,0},	{686,0},	{723,0},	{760,0}
};

static struct patval pat1096[] = {
  {684,1},	{758,1},	{759,2}
};

static struct patval pat1097[] = {
  {684,1},	{721,2},	{685,2},	{758,0},
  {759,0},	{686,0},	{723,0},	{760,0},
  {687,0},	{724,0},	{761,0}
};

static struct patval pat1098[] = {
  {684,1},	{722,1},	{648,1},	{685,2},
  {721,2},	{759,2},	{649,0},	{686,0},
  {723,0}
};

static struct patval pat1099[] = {
  {796,1},	{795,1},	{684,2},	{759,2},
  {758,0},	{686,0},	{723,0},	{760,0},
  {797,0}
};

static struct patval pat1100[] = {
  {759,1},	{721,1},	{684,2},	{722,2},
  {758,3},	{649,0},	{686,0},	{723,0},
  {760,0}
};

static struct patval pat1101[] = {
  {684,1},	{648,2},	{759,2},	{649,0},
  {686,0},	{723,0},	{760,0}
};

static struct patval pat1102[] = {
  {684,1},	{686,2},	{575,3},	{612,3},
  {683,3},	{610,0},	{573,0},	{574,0},
  {611,0},	{572,0},	{609,0},	{649,0}
};

static struct patval pat1103[] = {
  {684,1},	{721,2},	{685,2},	{759,0},
  {686,0},	{723,0},	{760,0}
};

static struct patval pat1104[] = {
  {684,1},	{648,1},	{721,2},	{685,2},
  {759,0},	{649,0},	{686,0},	{723,0},
  {760,0}
};

static struct patval pat1105[] = {
  {758,1},	{795,2},	{684,2},	{759,0},
  {796,0}
};

static struct patval pat1106[] = {
  {722,1},	{684,2},	{758,0}
};

static struct patval pat1107[] = {
  {649,1},	{723,1},	{686,2},	{684,2},
  {722,4},	{648,4},	{650,0},	{687,0},
  {724,0}
};

static struct patval pat1108[] = {
  {684,1},	{721,2},	{686,2},	{685,2},
  {758,4},	{759,0},	{723,0},	{760,0}
};

static struct patval pat1109[] = {
  {684,1},	{761,1},	{721,2},	{760,2},
  {686,2},	{685,3},	{723,0},	{724,0},
  {759,0}
};

static struct patval pat1110[] = {
  {684,2},	{686,2},	{648,2},	{649,4},
  {723,0}
};

static struct patval pat1111[] = {
  {684,1},	{648,1},	{722,1},	{685,2},
  {649,0},	{686,0},	{723,0}
};

static struct patval pat1112[] = {
  {686,1},	{684,2},	{758,2},	{685,2},
  {723,2},	{759,0},	{760,0}
};

static struct patval pat1113[] = {
  {685,1},	{721,1},	{722,2},	{795,2},
  {684,2},	{758,0},	{759,0},	{796,0},
  {686,0},	{723,0},	{760,0},	{797,0}
};

static struct patval pat1114[] = {
  {685,1},	{721,1},	{722,2},	{795,2},
  {684,2},	{758,0},	{759,0},	{796,0},
  {686,0},	{723,0},	{760,0},	{797,0}
};

static struct patval pat1115[] = {
  {684,1},	{685,2},	{758,2},	{759,0},
  {686,0},	{723,0},	{760,0}
};

static struct patval pat1116[] = {
  {760,1},	{684,2},	{686,2},	{759,2},
  {758,0},	{723,0}
};

static struct patval pat1117[] = {
  {723,1},	{686,1},	{758,1},	{759,1},
  {684,2},	{760,0}
};

static struct patval pat1118[] = {
  {723,1},	{759,1},	{684,2},	{758,3},
  {686,3},	{760,0}
};

static struct patval pat1119[] = {
  {685,1},	{684,2},	{758,4},	{759,0},
  {686,0},	{723,0},	{760,0}
};

static struct patval pat1120[] = {
  {684,1},	{721,2},	{685,2},	{648,3},
  {758,0},	{759,0},	{649,0},	{686,0},
  {723,0},	{760,0}
};

static struct patval pat1121[] = {
  {721,1},	{684,2},	{759,3},	{686,0}
};

static struct patval pat1122[] = {
  {795,2},	{684,2},	{757,3},	{720,3},
  {683,3},	{758,0},	{759,0},	{796,0},
  {686,0},	{723,0},	{760,0},	{797,0}
};

static struct patval pat1123[] = {
  {684,1},	{721,1},	{758,2},	{685,2},
  {759,0},	{649,0},	{686,0},	{723,0},
  {760,0}
};

static struct patval pat1124[] = {
  {686,1},	{685,1},	{684,2},	{611,2},
  {650,3},	{613,3},	{610,3},	{649,0},
  {612,0}
};

static struct patval pat1125[] = {
  {722,1},	{684,1},	{686,3},	{723,3}
};

static struct patval pat1126[] = {
  {759,1},	{721,1},	{760,1},	{685,1},
  {723,2},	{684,2},	{722,2},	{758,3},
  {686,0},	{687,0},	{724,0},	{761,0}
};

static struct patval pat1127[] = {
  {648,1},	{686,2},	{684,2},	{758,3},
  {795,3},	{760,3},	{797,3},	{647,3},
  {759,3},	{796,3},	{649,3},	{723,0}
};

static struct patval pat1128[] = {
  {684,2},	{685,2},	{758,0},	{759,0}
};

static struct patval pat1129[] = {
  {684,1},	{648,2},	{722,2},	{649,0},
  {686,0},	{723,0}
};

static struct patval pat1130[] = {
  {684,1},	{648,2},	{722,2},	{649,0},
  {686,0},	{723,0}
};

static struct patval pat1131[] = {
  {685,1},	{684,2},	{686,0},	{723,0}
};

static struct patval pat1132[] = {
  {684,1},	{648,1},	{685,2},	{721,2},
  {758,0},	{759,0},	{649,0},	{686,0},
  {723,0},	{760,0}
};

static struct patval pat1133[] = {
  {685,1},	{611,2},	{684,2},	{610,0},
  {612,0},	{649,0},	{686,0}
};

static struct patval pat1134[] = {
  {758,1},	{795,2},	{684,2},	{796,2},
  {760,3},	{797,3},	{759,0},	{686,0},
  {723,0}
};

static struct patval pat1135[] = {
  {684,1},	{722,1},	{648,1},	{758,2},
  {685,2},	{759,2},	{649,0},	{686,0},
  {723,0},	{760,0}
};

static struct patval pat1136[] = {
  {722,2},	{684,2},	{723,4},	{611,0},
  {610,0},	{612,0},	{649,0},	{686,0}
};

static struct patval pat1137[] = {
  {722,2},	{684,2},	{723,4},	{611,0},
  {610,0},	{612,0},	{649,0},	{686,0}
};

static struct patval pat1138[] = {
  {759,1},	{721,1},	{684,2},	{722,2},
  {760,2},	{611,0},	{610,0},	{612,0},
  {649,0},	{686,0},	{723,0}
};

static struct patval pat1139[] = {
  {722,1},	{684,1},	{648,1},	{685,2},
  {723,2},	{649,2},	{647,3},	{758,0},
  {759,0},	{796,0},	{686,0},	{795,0},
  {760,0},	{797,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{651,0},
  {688,0},	{725,0},	{762,0},	{799,0}
};

static struct patval pat1140[] = {
  {684,2},	{721,2},	{648,2},	{649,2},
  {797,3},	{796,3},	{759,0},	{686,0},
  {723,0},	{760,0}
};

static struct patval pat1141[] = {
  {611,1},	{612,1},	{649,2},	{684,2},
  {647,3},	{575,0},	{686,0},	{723,0},
  {576,0},	{613,0},	{650,0},	{687,0},
  {724,0}
};

static struct patval pat1142[] = {
  {684,2},	{648,2},	{686,2},	{759,0},
  {758,0},	{723,0},	{760,0}
};

static struct patval pat1143[] = {
  {684,2},	{648,2},	{686,2},	{759,0},
  {758,0},	{723,0},	{760,0}
};

static struct patval pat1144[] = {
  {684,1},	{648,2},	{647,3},	{649,0},
  {686,0},	{723,0}
};

static struct patval pat1145[] = {
  {684,1},	{721,1},	{648,1},	{723,1},
  {759,1},	{722,2},	{649,0},	{686,0}
};

static struct patval pat1146[] = {
  {723,1},	{721,1},	{685,1},	{686,1},
  {684,2},	{758,3},	{795,3},	{796,3},
  {759,0},	{760,0},	{797,0}
};

static struct patval pat1147[] = {
  {684,1},	{721,1},	{758,1},	{648,1},
  {649,1},	{686,2},	{759,2},	{685,2},
  {833,0},	{796,0},	{723,0},	{760,0},
  {797,0},	{834,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0}
};

static struct patval pat1148[] = {
  {721,1},	{684,2},	{758,0},	{795,0},
  {759,0},	{796,0}
};

static struct patval pat1149[] = {
  {684,1},	{648,1},	{685,2},	{721,2},
  {795,0},	{758,0},	{759,0},	{796,0},
  {649,0},	{686,0},	{723,0},	{760,0},
  {797,0}
};

static struct patval pat1150[] = {
  {684,1},	{648,1},	{685,2},	{721,2},
  {758,0},	{759,0},	{649,0},	{686,0},
  {723,0},	{760,0}
};

static struct patval pat1151[] = {
  {684,2},	{721,2},	{648,2},	{723,2},
  {649,2},	{686,4}
};

static struct patval pat1152[] = {
  {684,2},	{721,2},	{648,2},	{723,2},
  {649,2},	{686,4}
};

static struct patval pat1153[] = {
  {685,1},	{759,2},	{724,2},	{684,2},
  {796,3},	{797,3},	{683,4},	{687,4},
  {758,0},	{723,0},	{760,0},	{795,0},
  {757,0},	{761,0}
};

static struct patval pat1154[] = {
  {684,1},	{722,1},	{685,2},	{759,3},
  {758,3},	{721,3},	{649,0},	{686,0},
  {723,0},	{760,0},	{650,0},	{687,0},
  {724,0},	{761,0}
};

static struct patval pat1155[] = {
  {684,2},	{682,0},	{756,0},	{793,0},
  {757,0},	{794,0},	{719,0},	{758,0},
  {795,0}
};

static struct patval pat1156[] = {
  {649,1},	{686,2},	{721,2},	{648,2},
  {684,2},	{647,4},	{723,0}
};

static struct patval pat1157[] = {
  {649,1},	{686,2},	{721,2},	{648,2},
  {684,2},	{647,4},	{723,0}
};

static struct patval pat1158[] = {
  {685,1},	{721,2},	{684,2},	{758,4},
  {759,0},	{686,0},	{723,0},	{760,0}
};

static struct patval pat1159[] = {
  {684,2},	{760,2},	{758,2},	{759,2},
  {761,4},	{686,0},	{723,0},	{687,0},
  {724,0}
};

static struct patval pat1160[] = {
  {685,1},	{722,2},	{759,2},	{684,2},
  {757,4},	{758,0}
};

static struct patval pat1161[] = {
  {684,1},	{721,1},	{723,1},	{759,1},
  {758,2},	{686,0},	{687,0}
};

static struct patval pat1162[] = {
  {722,1},	{684,1},	{723,2},	{685,2},
  {649,0},	{686,0}
};

static struct patval pat1163[] = {
  {759,1},	{721,1},	{684,2},	{722,2},
  {760,2},	{723,0},	{686,0}
};

static struct patval pat1164[] = {
  {722,1},	{758,1},	{721,2},	{759,2},
  {684,2},	{724,3},	{761,3},	{687,3},
  {760,0},	{723,0},	{686,0}
};

static struct patval pat1165[] = {
  {684,1},	{722,1},	{721,2}
};

static struct patval pat1166[] = {
  {685,1},	{721,1},	{684,2},	{722,2},
  {758,3},	{759,0},	{649,0},	{686,0},
  {723,0},	{760,0}
};

static struct patval pat1167[] = {
  {684,1},	{723,1},	{758,1},	{648,1},
  {686,1},	{759,1},	{760,2}
};

static struct patval pat1168[] = {
  {684,1},	{648,1},	{722,1},	{685,2},
  {649,2},	{723,4},	{686,0}
};

static struct patval pat1169[] = {
  {722,1},	{684,1},	{648,1},	{685,2},
  {649,2},	{723,4},	{686,0}
};

static struct patval pat1170[] = {
  {759,1},	{721,1},	{685,1},	{722,2},
  {684,2},	{760,4},	{723,0},	{686,0}
};

static struct patval pat1171[] = {
  {759,1},	{721,1},	{685,1},	{686,2},
  {722,2},	{684,2},	{760,4},	{723,0}
};

static struct patval pat1172[] = {
  {722,1},	{684,1},	{648,1},	{649,2},
  {685,2},	{723,2},	{686,0}
};

static struct patval pat1173[] = {
  {684,1},	{722,1},	{648,1},	{758,2},
  {685,2},	{721,2},	{759,0},	{649,0},
  {686,0},	{723,0},	{760,0}
};

static struct patval pat1174[] = {
  {721,1},	{759,1},	{722,2},	{684,2},
  {647,4},	{758,0}
};

static struct patval pat1175[] = {
  {686,1},	{684,1},	{721,1},	{648,1},
  {722,1},	{723,2}
};

static struct patval pat1176[] = {
  {684,1},	{721,1},	{758,1},	{685,1},
  {723,1},	{759,1},	{760,2},	{686,0}
};

static struct patval pat1177[] = {
  {685,1},	{684,2},	{649,0},	{686,0},
  {723,0}
};

static struct patval pat1178[] = {
  {722,1},	{684,2},	{758,0},	{759,0},
  {686,0},	{723,0},	{760,0}
};

static struct patval pat1179[] = {
  {684,1},	{722,1},	{758,2},	{685,2},
  {759,0},	{649,0},	{686,0},	{723,0},
  {760,0}
};

static struct patval pat1180[] = {
  {686,1},	{723,1},	{759,1},	{684,2},
  {649,2},	{760,0}
};

static struct patval pat1181[] = {
  {722,1},	{685,1},	{684,2},	{721,2},
  {759,0},	{649,0},	{686,0},	{723,0},
  {760,0}
};

static struct patval pat1182[] = {
  {684,2}
};

static struct patval pat1183[] = {
  {684,2}
};

static struct patval pat1184[] = {
  {684,2},	{759,2},	{758,2}
};

static struct patval pat1185[] = {
  {687,1},	{684,1},	{650,2},	{686,2},
  {685,2},	{613,4},	{612,0},	{649,0},
  {611,0},	{610,0}
};

static struct patval pat1186[] = {
  {648,2},	{684,2},	{610,0}
};

static struct patval pat1187[] = {
  {759,1},	{721,1},	{686,2},	{684,2},
  {722,2},	{758,3},	{723,0},	{760,0}
};

static struct patval pat1188[] = {
  {759,1},	{721,1},	{684,2},	{722,2},
  {685,4},	{723,4},	{686,4},	{758,0},
  {760,0}
};

static struct patval pat1189[] = {
  {722,1},	{684,2}
};

static struct patval pat1190[] = {
  {721,1},	{759,1},	{684,2},	{758,3},
  {722,4}
};

static struct patval pat1191[] = {
  {684,1},	{685,1},	{759,1},	{722,2},
  {795,2},	{869,0},	{832,0},	{758,0},
  {796,0},	{833,0},	{870,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0},
  {871,0}
};

static struct patval pat1192[] = {
  {686,1},	{649,2},	{684,2},	{611,4},
  {647,4}
};

static struct patval pat1193[] = {
  {686,1},	{649,2},	{684,2},	{611,0}
};

static struct patval pat1194[] = {
  {686,1},	{649,2},	{684,2},	{611,0},
  {610,0}
};

static struct patval pat1195[] = {
  {686,1},	{721,1},	{723,1},	{648,2},
  {684,2},	{759,0}
};

static struct patval pat1196[] = {
  {723,1},	{721,1},	{648,2},	{684,2},
  {722,2},	{649,2},	{686,0}
};

static struct patval pat1197[] = {
  {684,1},	{722,2},	{721,2},	{758,0},
  {759,0}
};

static struct patval pat1198[] = {
  {648,1},	{684,1},	{685,2}
};

static struct patval pat1199[] = {
  {685,1},	{684,2},	{648,2}
};

static struct patval pat1200[] = {
  {685,1},	{648,2},	{684,2},	{610,0}
};

static struct patval pat1201[] = {
  {685,1},	{721,1},	{758,1},	{686,1},
  {684,2},	{759,0},	{723,0},	{760,0}
};

static struct patval pat1202[] = {
  {684,1},	{721,2},	{758,2},	{685,2},
  {686,2},	{759,0},	{723,0},	{760,0}
};

static struct patval pat1203[] = {
  {684,1},	{721,2},	{758,2},	{685,2},
  {686,2},	{759,0},	{723,0},	{760,0}
};

static struct patval pat1204[] = {
  {758,1},	{684,1},	{722,4},	{720,4}
};

static struct patval pat1205[] = {
  {685,1},	{721,1},	{684,2},	{722,2}
};

static struct patval pat1206[] = {
  {685,1},	{722,2},	{684,2},	{758,0},
  {759,0}
};

static struct patval pat1207[] = {
  {685,1},	{722,2},	{684,2},	{723,4},
  {759,0},	{758,0},	{760,0}
};

static struct patval pat1208[] = {
  {685,1},	{722,2},	{684,2},	{758,0},
  {759,0}
};

static struct patval pat1209[] = {
  {685,1},	{684,2},	{722,2}
};

static struct patval pat1210[] = {
  {684,1},	{760,1},	{685,2},	{759,0}
};

static struct patval pat1211[] = {
  {687,1},	{721,1},	{685,1},	{686,1},
  {684,2},	{723,0},	{760,0},	{759,0},
  {724,0},	{761,0}
};

static struct patval pat1212[] = {
  {684,1},	{721,2},	{685,2},	{686,2},
  {687,2},	{723,0},	{760,0},	{759,0},
  {724,0},	{761,0}
};

static struct patval pat1213[] = {
  {759,1},	{684,2},	{607,0},	{681,0},
  {570,0},	{755,0},	{792,0},	{829,0},
  {571,0},	{608,0},	{645,0},	{682,0},
  {719,0},	{756,0},	{793,0},	{830,0},
  {572,0},	{609,0},	{757,0},	{794,0},
  {831,0},	{573,0},	{610,0},	{644,0},
  {758,0},	{795,0},	{832,0},	{574,0},
  {611,0},	{718,0},	{796,0},	{833,0},
  {575,0},	{612,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0},
  {576,0},	{613,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0}
};

static struct patval pat1214[] = {
  {684,2},	{680,3},	{643,3},	{754,3},
  {791,3},	{717,3},	{570,0},	{607,0},
  {644,0},	{533,0},	{718,0},	{755,0},
  {792,0},	{534,0},	{571,0},	{608,0},
  {645,0},	{682,0},	{719,0},	{756,0},
  {793,0},	{535,0},	{572,0},	{609,0},
  {757,0},	{794,0},	{536,0},	{573,0},
  {610,0},	{681,0},	{758,0},	{795,0},
  {537,0},	{574,0},	{611,0},	{759,0},
  {796,0},	{538,0},	{575,0},	{612,0},
  {649,0},	{686,0},	{723,0},	{760,0},
  {797,0}
};

static struct patval pat1215[] = {
  {684,2},	{495,0},	{532,0},	{569,0},
  {606,0},	{458,0},	{680,0},	{717,0},
  {754,0},	{459,0},	{496,0},	{533,0},
  {570,0},	{607,0},	{644,0},	{681,0},
  {718,0},	{755,0},	{460,0},	{497,0},
  {534,0},	{571,0},	{608,0},	{645,0},
  {682,0},	{719,0},	{756,0},	{461,0},
  {498,0},	{535,0},	{572,0},	{609,0},
  {757,0},	{462,0},	{499,0},	{536,0},
  {573,0},	{610,0},	{643,0},	{758,0},
  {463,0},	{500,0},	{537,0},	{574,0},
  {611,0},	{759,0},	{464,0},	{501,0},
  {538,0},	{575,0},	{612,0},	{649,0},
  {686,0},	{723,0},	{760,0}
};

static struct patval pat1216[] = {
  {684,2},	{571,0},	{608,0},	{534,0},
  {682,0},	{719,0},	{535,0},	{572,0},
  {609,0},	{536,0},	{573,0},	{610,0},
  {645,0},	{537,0},	{574,0},	{611,0},
  {538,0},	{575,0},	{612,0},	{649,0},
  {686,0},	{723,0}
};

static struct patval pat1217[] = {
  {684,1},	{722,1},	{685,1},	{723,1},
  {759,2},	{686,2},	{906,3},	{869,3},
  {907,3},	{832,3},	{870,3},	{833,3},
  {796,0},	{758,0},	{795,0},	{760,0},
  {797,0},	{834,0},	{871,0},	{908,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {835,0},	{872,0},	{909,0}
};

static struct patval pat1218[] = {
  {648,1},	{684,1},	{685,2},	{758,2},
  {795,4},	{794,4},	{797,4},	{796,4},
  {610,0},	{611,0},	{759,0},	{757,0},
  {612,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{609,0},	{613,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{798,0}
};

static struct patval pat1219[] = {
  {684,2},	{906,2},	{570,0},	{681,0},
  {718,0},	{755,0},	{792,0},	{829,0},
  {607,0},	{903,0},	{940,0},	{977,0},
  {571,0},	{608,0},	{645,0},	{682,0},
  {719,0},	{756,0},	{793,0},	{830,0},
  {867,0},	{904,0},	{941,0},	{978,0},
  {572,0},	{609,0},	{757,0},	{794,0},
  {831,0},	{868,0},	{905,0},	{942,0},
  {979,0},	{573,0},	{610,0},	{644,0},
  {758,0},	{795,0},	{832,0},	{869,0},
  {866,0},	{943,0},	{980,0},	{574,0},
  {611,0},	{759,0},	{796,0},	{833,0},
  {870,0},	{907,0},	{944,0},	{981,0},
  {575,0},	{612,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0},
  {871,0},	{908,0},	{945,0},	{982,0},
  {576,0},	{613,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0},
  {872,0},	{909,0},	{946,0},	{983,0}
};

static struct pattern pat[1221];

static int
autohelperpat1(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(683, trans, move);
  b = AFFINE_TRANSFORM(647, trans, move);
  c = AFFINE_TRANSFORM(721, trans, move);

  return play_attack_defend2_n(OTHER_COLOR(color), 1, 2, move, a, a, b) || play_attack_defend_n(OTHER_COLOR(color), 1, 2, move, a, c);
}

static int
autohelperpat2(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(683, trans, move);
  b = AFFINE_TRANSFORM(685, trans, move);

  return (dragon[a].status == ALIVE) || (dragon[b].status == ALIVE);
}

static int
autohelperpat3(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(646, trans, move);
  b = AFFINE_TRANSFORM(685, trans, move);

  return countlib(a)>1 && ((dragon[a].status == ALIVE) || (dragon[b].status == ALIVE));
}

static int
autohelperpat5(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(611, trans, move);

  return cut_possible(a, OTHER_COLOR(color)) && defend_against(move, color, a);
}

static int
autohelperpat6(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(646, trans, move);

  return countlib(a)>2 && worm[a].liberties2>3;
}

static int
autohelperpat7(int trans, int move, int color, int action)
{
  int A, B;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(645, trans, move);
  B = AFFINE_TRANSFORM(685, trans, move);

  return !play_attack_defend_n(OTHER_COLOR(color), 1, 1, move, A) && !play_attack_defend_n(OTHER_COLOR(color), 1, 1, move, B);
}

static int
autohelperpat11(int trans, int move, int color, int action)
{
  int A, B;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(720, trans, move);
  B = AFFINE_TRANSFORM(685, trans, move);

  return !ATTACK_MACRO(A) && !ATTACK_MACRO(B);
}

static int
autohelperpat12(int trans, int move, int color, int action)
{
  int a, c, B;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);
  c = AFFINE_TRANSFORM(722, trans, move);
  B = AFFINE_TRANSFORM(721, trans, move);

  return ((dragon[a].status == ALIVE) || (dragon[c].status == ALIVE)) && play_attack_defend_n(color, 0, 2, move, B, c);;
}

static int
autohelperpat13(int trans, int move, int color, int action)
{
  int c, A, B;
  UNUSED(color);
  UNUSED(action);

  c = AFFINE_TRANSFORM(722, trans, move);
  A = AFFINE_TRANSFORM(721, trans, move);
  B = AFFINE_TRANSFORM(685, trans, move);

  return countlib(c)>1 && play_attack_defend2_n(color, 1, 1, move, A, B);
}

static int
autohelperpat14(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(683, trans, move);

  return (dragon[a].status == ALIVE);
}

static int
autohelperpat16(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(720, trans, move);
  b = AFFINE_TRANSFORM(721, trans, move);
  c = AFFINE_TRANSFORM(757, trans, move);
  d = AFFINE_TRANSFORM(647, trans, move);

  return ((dragon[c].status == ALIVE) || (dragon[d].status == ALIVE))&& (!play_attack_defend2_n(color, 1, 3, move, a, b, b, c) || !play_attack_defend2_n(color, 1, 3, move, b, a, move, a));
}

static int
autohelperpat17(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(720, trans, move);
  b = AFFINE_TRANSFORM(721, trans, move);
  c = AFFINE_TRANSFORM(757, trans, move);
  d = AFFINE_TRANSFORM(685, trans, move);

  return ((dragon[c].status == ALIVE) || (dragon[d].status == ALIVE))&& (!play_attack_defend2_n(color, 1, 3, move, a, b, b, c) || !play_attack_defend2_n(color, 1, 3, move, b, a, move, a));
}

static int
autohelperpat18(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(720, trans, move);
  b = AFFINE_TRANSFORM(721, trans, move);
  c = AFFINE_TRANSFORM(757, trans, move);
  d = AFFINE_TRANSFORM(648, trans, move);

  return ((dragon[c].status == ALIVE) || (dragon[d].status == ALIVE))&& (!play_attack_defend2_n(color, 1, 3, move, a, b, b, c) || !play_attack_defend2_n(color, 1, 3, move, b, a, move, a));
}

static int
autohelperpat20(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);
  b = AFFINE_TRANSFORM(685, trans, move);
  c = AFFINE_TRANSFORM(647, trans, move);
  d = AFFINE_TRANSFORM(646, trans, move);

  return !(whose_moyo(OPPOSITE_INFLUENCE(color), c) == color) || !(whose_moyo(OPPOSITE_INFLUENCE(color), d) == color) || !play_attack_defend_n(OTHER_COLOR(color), 1, 3, a, move, b, b);
}

static int
autohelperpat25(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(720, trans, move);

  return (dragon[a].status == ALIVE);
}

static int
autohelperpat26(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(722, trans, move);
  b = AFFINE_TRANSFORM(758, trans, move);

  return countlib(a)>1 && (dragon[b].status == ALIVE);
}

static int
autohelperpat27(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);

  return play_attack_defend_n(color, 1, 2, move, a, a) == WIN;
}

static int
autohelperpat29(int trans, int move, int color, int action)
{
  int a, A;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(648, trans, move);
  A = AFFINE_TRANSFORM(647, trans, move);

  return countlib(a)>1 && countlib(A)==2;
}

static int
autohelperpat30(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(648, trans, move);
  b = AFFINE_TRANSFORM(647, trans, move);
  c = AFFINE_TRANSFORM(649, trans, move);

  return !play_connect_n(OTHER_COLOR(color), 1, 1, a, b, c);
}

static int
autohelperpat31(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(683, trans, move);
  b = AFFINE_TRANSFORM(685, trans, move);

  return !play_connect_n(OTHER_COLOR(color), 1, 1, move, a, b);
}

static int
autohelperpat32(int trans, int move, int color, int action)
{
  int a, b, c, d, e;
  UNUSED(color);

  a = AFFINE_TRANSFORM(720, trans, move);
  b = AFFINE_TRANSFORM(722, trans, move);
  c = AFFINE_TRANSFORM(683, trans, move);
  d = AFFINE_TRANSFORM(721, trans, move);
  e = AFFINE_TRANSFORM(685, trans, move);

  if (!action)
    return play_attack_defend2_n(color, 0, 3, move, a, b, move, b) && play_attack_defend2_n(color, 0, 3, move, b, a, move, a);
  add_cut_move(move, c, d);add_cut_move(move, c, e);add_cut_move(move, d, e);;

  return 0;
}

static int
autohelperpat33(int trans, int move, int color, int action)
{
  int A, B;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(721, trans, move);
  B = AFFINE_TRANSFORM(683, trans, move);

  return play_attack_defend_n(color, 1, 2, move, A, B);
}

static int
autohelperpat35(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(683, trans, move);
  b = AFFINE_TRANSFORM(646, trans, move);

  return !play_attack_defend_n(color, 1, 3, move, a, b, move) && !play_attack_defend_n(color, 1, 3, move, a, b, b);
}

static int
autohelperpat36(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(722, trans, move);
  b = AFFINE_TRANSFORM(758, trans, move);
  c = AFFINE_TRANSFORM(685, trans, move);
  d = AFFINE_TRANSFORM(683, trans, move);

  return countlib(a)>1 && play_attack_defend_n(color, 1, 4, move, b, c, d, d);
}

static int
autohelperpat37(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(722, trans, move);
  b = AFFINE_TRANSFORM(758, trans, move);
  c = AFFINE_TRANSFORM(685, trans, move);
  d = AFFINE_TRANSFORM(683, trans, move);

  return countlib(a)>1 && play_attack_defend_n(color, 1, 4, move, b, c, d, d);
}

static int
autohelperpat38(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(722, trans, move);
  b = AFFINE_TRANSFORM(758, trans, move);
  c = AFFINE_TRANSFORM(685, trans, move);
  d = AFFINE_TRANSFORM(683, trans, move);

  return countlib(a)>1 && play_attack_defend_n(color, 1, 4, move, b, c, d, d);
}

static int
autohelperpat39(int trans, int move, int color, int action)
{
  int a, b, c, e, f, D;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(610, trans, move);
  b = AFFINE_TRANSFORM(683, trans, move);
  c = AFFINE_TRANSFORM(685, trans, move);
  e = AFFINE_TRANSFORM(648, trans, move);
  f = AFFINE_TRANSFORM(646, trans, move);
  D = AFFINE_TRANSFORM(647, trans, move);

  return countlib(e)>1 && countlib(f)>1&& (!play_attack_defend_n(color, 0, 1, move, D) || play_attack_defend2_n(color, 1, 4, move, a, b, c, D, c));
}

static int
autohelperpat40(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(686, trans, move);

  return defend_against(move, color, a);
}

static int
autohelperpat43(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);
  b = AFFINE_TRANSFORM(720, trans, move);

  return play_attack_defend2_n(color, 0, 2, move, a, move, b);
}

static int
autohelperpat44(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(646, trans, move);
  b = AFFINE_TRANSFORM(609, trans, move);
  c = AFFINE_TRANSFORM(648, trans, move);
  d = AFFINE_TRANSFORM(610, trans, move);

  return play_attack_defend_n(color, 1, 2, move, a, a) || play_attack_defend_n(color, 1, 2, move, a, d)|| (play_attack_defend_n(color, 1, 2, move, a, c) && !play_attack_defend_n(color, 1, 2, move, a, b));
}

static int
autohelperpat45(int trans, int move, int color, int action)
{
  int b, c, A;
  UNUSED(color);
  UNUSED(action);

  b = AFFINE_TRANSFORM(759, trans, move);
  c = AFFINE_TRANSFORM(647, trans, move);
  A = AFFINE_TRANSFORM(685, trans, move);

  return countlib(A)>1 && countlib(b)>1 && (dragon[c].status == ALIVE);
}

static int
autohelperpat46(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);
  b = AFFINE_TRANSFORM(647, trans, move);
  c = AFFINE_TRANSFORM(648, trans, move);

  return play_attack_defend_n(color, 1, 2, move, a, a) && !play_attack_defend_n(color, 1, 3, move, b, a, c);
}

static int
autohelperpat47(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(685, trans, move);
  b = AFFINE_TRANSFORM(722, trans, move);
  c = AFFINE_TRANSFORM(721, trans, move);
  d = AFFINE_TRANSFORM(686, trans, move);

  return !play_attack_defend_n(color, 1, 4, move, a, b, c, d) && !play_attack_defend_n(color, 1, 4, move, a, b, c, move);
}

static int
autohelperpat48(int trans, int move, int color, int action)
{
  int a, B;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(685, trans, move);
  B = AFFINE_TRANSFORM(647, trans, move);

  return play_attack_defend2_n(color, 1, 2, move, a, a, B);
}

static int
autohelperpat49(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);
  b = AFFINE_TRANSFORM(722, trans, move);
  c = AFFINE_TRANSFORM(758, trans, move);
  d = AFFINE_TRANSFORM(759, trans, move);

  return !(whose_area(OPPOSITE_INFLUENCE(color), d) == OTHER_COLOR(color)) && !play_attack_defend2_n(color, 1, 3, move, a, b, move, b)&& !play_attack_defend2_n(color, 1, 5, move, b, a, c, d, a, d);
}

static int
autohelperpat50(int trans, int move, int color, int action)
{
  int a, b, c, d, e, f, g;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);
  b = AFFINE_TRANSFORM(647, trans, move);
  c = AFFINE_TRANSFORM(720, trans, move);
  d = AFFINE_TRANSFORM(722, trans, move);
  e = AFFINE_TRANSFORM(757, trans, move);
  f = AFFINE_TRANSFORM(758, trans, move);
  g = AFFINE_TRANSFORM(759, trans, move);

  return (!(whose_area(OPPOSITE_INFLUENCE(color), f) == OTHER_COLOR(color)) || !((whose_area(OPPOSITE_INFLUENCE(color), e) == OTHER_COLOR(color)) && (whose_area(OPPOSITE_INFLUENCE(color), g) == OTHER_COLOR(color))))&& !play_attack_defend2_n(color, 1, 5, move, a, b, c, d, d, b)&& !play_attack_defend2_n(color, 1, 5, move, a, b, d, c, c, b);
}

static int
autohelperpat51(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);

  return defend_against(move, color, a);
}

static int
autohelperpat52(int trans, int move, int color, int action)
{
  int a, b, c, d, e;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);
  b = AFFINE_TRANSFORM(720, trans, move);
  c = AFFINE_TRANSFORM(647, trans, move);
  d = AFFINE_TRANSFORM(683, trans, move);
  e = AFFINE_TRANSFORM(757, trans, move);

  return play_attack_defend_n(color, 1, 3, move, a, b, d) && play_attack_defend_n(color, 1, 3, move, a, b, a)&& play_attack_defend_n(color, 1, 4, move, a, b, e, e) && play_attack_defend_n(color, 1, 4, move, a, b, c, c);
}

static int
autohelperpat53(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(646, trans, move);
  b = AFFINE_TRANSFORM(758, trans, move);

  return !is_same_dragon(a, b) && ((dragon[a].status == ALIVE) || (dragon[b].status == ALIVE));
}

static int
autohelperpat54(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);
  b = AFFINE_TRANSFORM(720, trans, move);
  c = AFFINE_TRANSFORM(647, trans, move);

  return (dragon[c].status == ALIVE) && play_attack_defend2_n(color, 0, 2, move, a, move, b);
}

static int
autohelperpat55(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);
  b = AFFINE_TRANSFORM(685, trans, move);
  c = AFFINE_TRANSFORM(721, trans, move);

  return !play_attack_defend_n(color, 0, 4, move, a, b, c, a) && !play_attack_defend_n(color, 0, 4, move, a, b, c, c);
}

static int
autohelperpat56(int trans, int move, int color, int action)
{
  int A, B;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(646, trans, move);
  B = AFFINE_TRANSFORM(720, trans, move);

  return !play_break_through_n(OTHER_COLOR(color), 1, move, A, move, B);
}

static int
autohelperpat57(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(611, trans, move);
  b = AFFINE_TRANSFORM(722, trans, move);
  c = AFFINE_TRANSFORM(720, trans, move);

  return countlib(a)>2 && countlib(b)>2 && countlib(c)>3;
}

static int
autohelperpat64(int trans, int move, int color, int action)
{
  UNUSED(trans);
  UNUSED(color);
  UNUSED(action);

  UNUSED(move);

  return !(whose_moyo(OPPOSITE_INFLUENCE(color), move) == color);
}

static int
autohelperpat66(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(648, trans, move);
  b = AFFINE_TRANSFORM(649, trans, move);

  return !play_attack_defend_n(color, 0, 3, move, a, b, a);
}

static int
autohelperpat67(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(685, trans, move);
  b = AFFINE_TRANSFORM(722, trans, move);
  c = AFFINE_TRANSFORM(686, trans, move);
  d = AFFINE_TRANSFORM(723, trans, move);

  return !play_attack_defend2_n(color, 1, 3, move, a, b, move, b) && play_attack_defend2_n(color, 0, 4, move, b, a, c, a, d);
}

static int
autohelperpat68(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(685, trans, move);
  b = AFFINE_TRANSFORM(722, trans, move);
  c = AFFINE_TRANSFORM(686, trans, move);
  d = AFFINE_TRANSFORM(723, trans, move);

  return !play_attack_defend2_n(color, 1, 3, move, a, b, move, b) && play_attack_defend2_n(color, 0, 4, move, b, a, c, a, d);
}

static int
autohelperpat70(int trans, int move, int color, int action)
{
  int a, b, c, d, f, g, E;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(610, trans, move);
  b = AFFINE_TRANSFORM(683, trans, move);
  c = AFFINE_TRANSFORM(685, trans, move);
  d = AFFINE_TRANSFORM(722, trans, move);
  f = AFFINE_TRANSFORM(646, trans, move);
  g = AFFINE_TRANSFORM(648, trans, move);
  E = AFFINE_TRANSFORM(721, trans, move);

  return ((dragon[f].status == ALIVE) || (dragon[g].status == ALIVE)) && !play_attack_defend2_n(color, 0, 5, move, a, b, c, d, c, E);
}

static int
autohelperpat71(int trans, int move, int color, int action)
{
  int a, b, c, d, f, E;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(610, trans, move);
  b = AFFINE_TRANSFORM(683, trans, move);
  c = AFFINE_TRANSFORM(685, trans, move);
  d = AFFINE_TRANSFORM(722, trans, move);
  f = AFFINE_TRANSFORM(648, trans, move);
  E = AFFINE_TRANSFORM(721, trans, move);

  return !play_attack_defend2_n(color, 0, 5, move, a, b, c, d, c, E) && (dragon[f].size <= countstones(E));
}

static int
autohelperpat74(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(610, trans, move);
  b = AFFINE_TRANSFORM(721, trans, move);

  return  play_attack_defend_n(color, 1, 2, move, a, a) && play_attack_defend_n(color, 1, 2, move, b, b);
}

static int
autohelperpat75(int trans, int move, int color, int action)
{
  int a, b, C;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(610, trans, move);
  b = AFFINE_TRANSFORM(721, trans, move);
  C = AFFINE_TRANSFORM(648, trans, move);

  return play_attack_defend_n(color, 1, 2, move, a, a) && play_attack_defend_n(color, 1, 2, move, b, b)&& !(ATTACK_MACRO(C) && play_attack_defend_n(color, 0, 1, move, C));
}

static int
autohelperpat78(int trans, int move, int color, int action)
{
  int a, b, C, D;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(685, trans, move);
  b = AFFINE_TRANSFORM(721, trans, move);
  C = AFFINE_TRANSFORM(683, trans, move);
  D = AFFINE_TRANSFORM(722, trans, move);

  return  !is_same_dragon(C, D) && play_attack_defend2_n(OTHER_COLOR(color), 1, 2, move, a, a, b);
}

static int
autohelperpat79(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(758, trans, move);
  b = AFFINE_TRANSFORM(721, trans, move);

  return countlib(a)>1 && play_attack_defend_n(OTHER_COLOR(color), 1, 1, b, b)==3;
}

static int
autohelperpat80(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(609, trans, move);

  return  countlib(a)>=3 && !(whose_moyo(OPPOSITE_INFLUENCE(color), move) == color);
}

static int
autohelperpat81(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);

  return  does_attack(move, a);
}

static int
autohelperpat82(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);

  return  does_attack(move, a);
}

static int
autohelperpat83(int trans, int move, int color, int action)
{
  int A, B;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(683, trans, move);
  B = AFFINE_TRANSFORM(721, trans, move);

  return  !(dragon[A].status == DEAD) && (play_attack_defend_n(OTHER_COLOR(color), 1, 1, move, B) || play_attack_defend_n(OTHER_COLOR(color), 1, 1, move, A));
}

static int
autohelperpat84(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(646, trans, move);
  b = AFFINE_TRANSFORM(647, trans, move);
  c = AFFINE_TRANSFORM(683, trans, move);

  return !play_attack_defend_n(color, 0, 3, move, a, b, a) && play_attack_defend_n(color, 1, 4, move, b, a, c, c);
}

static int
autohelperpat87(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(721, trans, move);

  return  countlib(A)==2;
}

static int
autohelperpat90(int trans, int move, int color, int action)
{
  int a, b, c, d, E;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);
  b = AFFINE_TRANSFORM(646, trans, move);
  c = AFFINE_TRANSFORM(610, trans, move);
  d = AFFINE_TRANSFORM(721, trans, move);
  E = AFFINE_TRANSFORM(683, trans, move);

  return defend_against(move, color, d)&& !play_attack_defend2_n(color, 0, 3, move, a, b, a, E)&& play_attack_defend2_n(color, 1, 4, move, b, a, c, b, c);
}

static int
autohelperpat91(int trans, int move, int color, int action)
{
  int a, b, d, e;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);
  b = AFFINE_TRANSFORM(648, trans, move);
  d = AFFINE_TRANSFORM(721, trans, move);
  e = AFFINE_TRANSFORM(609, trans, move);

  return defend_against(move, color, d) && !play_attack_defend_n(color, 1, 3, move, a, b, e);
}

static int
autohelperpat92(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);
  b = AFFINE_TRANSFORM(722, trans, move);
  c = AFFINE_TRANSFORM(758, trans, move);
  d = AFFINE_TRANSFORM(647, trans, move);

  return defend_against(move, color, a) || !play_attack_defend2_n(color, 1, 3, move, a, b, c, d);
}

static int
autohelperpat93(int trans, int move, int color, int action)
{
  int a, b, C, D;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);
  b = AFFINE_TRANSFORM(722, trans, move);
  C = AFFINE_TRANSFORM(758, trans, move);
  D = AFFINE_TRANSFORM(647, trans, move);

  return defend_against(move, OTHER_COLOR(color), a) || !play_attack_defend2_n(OTHER_COLOR(color), 1, 3, move, a, b, C, D);
}

static int
autohelperpat94(int trans, int move, int color, int action)
{
  int a, b, c, d, e;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(683, trans, move);
  b = AFFINE_TRANSFORM(685, trans, move);
  c = AFFINE_TRANSFORM(648, trans, move);
  d = AFFINE_TRANSFORM(647, trans, move);
  e = AFFINE_TRANSFORM(722, trans, move);

  return defend_against(move, color, a) && !play_attack_defend_n(color, 1, 5, move, b, c, d, e, e);
}

static int
autohelperpat95(int trans, int move, int color, int action)
{
  int a, b, c, D;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);
  b = AFFINE_TRANSFORM(720, trans, move);
  c = AFFINE_TRANSFORM(758, trans, move);
  D = AFFINE_TRANSFORM(683, trans, move);

  return !play_attack_defend2_n(OTHER_COLOR(color), 0, 3, move, a, b, a, D) && play_attack_defend2_n(OTHER_COLOR(color), 1, 4, move, b, a, c, b, c);
}

static int
autohelperpat96(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);
  b = AFFINE_TRANSFORM(757, trans, move);

  return play_connect_n(color, 0, 0, a, b) && !play_connect_n(color, 0, 1, move, a, b);
}

static int
autohelperpat97(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(681, trans, move);
  b = AFFINE_TRANSFORM(718, trans, move);
  c = AFFINE_TRANSFORM(682, trans, move);
  d = AFFINE_TRANSFORM(719, trans, move);

  return  somewhere(OTHER_COLOR(color), 1, 4, a, b, c, d);
}

static int
autohelperpat102(int trans, int move, int color, int action)
{
  int a, A;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(683, trans, move);
  A = AFFINE_TRANSFORM(721, trans, move);

  return !(dragon[a].status == DEAD) && countlib(A)>2;
}

static int
autohelperpat106(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);

  a = AFFINE_TRANSFORM(723, trans, move);
  b = AFFINE_TRANSFORM(721, trans, move);

  if (!action)
    return  !play_attack_defend_n(color, 1, 2, a, b, b);
   add_antisuji_move(a); add_antisuji_move(b);;

  return 0;
}

static int
autohelperpat107(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(722, trans, move);

  return countlib(a)==2;
}

static int
autohelperpat111(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(646, trans, move);
  b = AFFINE_TRANSFORM(720, trans, move);

  return !play_break_through_n(OTHER_COLOR(color), 1, move, a, move, b);
}

static int
autohelperpat112(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(646, trans, move);
  b = AFFINE_TRANSFORM(720, trans, move);

  return !play_break_through_n(OTHER_COLOR(color), 1, move, a, move, b);
}

static int
autohelperpat113(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(646, trans, move);
  b = AFFINE_TRANSFORM(720, trans, move);

  return countlib(a)>1 && countlib(b)>1;
}

static int
autohelperpat114(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(646, trans, move);
  b = AFFINE_TRANSFORM(720, trans, move);

  return countlib(a)>1 && countlib(b)>1;
}

static int
autohelperpat115(int trans, int move, int color, int action)
{
  int a, b, c, d, e;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(648, trans, move);
  b = AFFINE_TRANSFORM(646, trans, move);
  c = AFFINE_TRANSFORM(610, trans, move);
  d = AFFINE_TRANSFORM(685, trans, move);
  e = AFFINE_TRANSFORM(609, trans, move);

  return !play_attack_defend2_n(OTHER_COLOR(color), 0, 3, move, a, b, a, e)&& play_attack_defend2_n(OTHER_COLOR(color), 1, 4, move, b, a, d, d, b)&& play_attack_defend2_n(color, 1, 2, move, b, b, c)&& play_attack_defend2_n(color, 1, 4, move, a, d, b, b, c);
}

static int
autohelperpat116(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(722, trans, move);
  b = AFFINE_TRANSFORM(686, trans, move);
  c = AFFINE_TRANSFORM(723, trans, move);
  d = AFFINE_TRANSFORM(647, trans, move);

  return (!play_attack_defend_n(OTHER_COLOR(color), 0, 3, a, b, move, b) || !play_attack_defend_n(OTHER_COLOR(color), 0, 3, a, b, move, d))&& play_attack_defend_n(OTHER_COLOR(color), 1, 4, a, move, b, c, c);
}

static int
autohelperpat117(int trans, int move, int color, int action)
{
  int a, B;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(686, trans, move);
  B = AFFINE_TRANSFORM(722, trans, move);

  return  !ATTACK_MACRO(B) && play_attack_defend_n(color, 1, 2, move, a, a);
}

static int
autohelperpat118(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(608, trans, move);
  b = AFFINE_TRANSFORM(610, trans, move);
  c = AFFINE_TRANSFORM(571, trans, move);

  return !play_attack_defend_n(color, 1, 3, move, a, b, c) && !play_attack_defend_n(color, 1, 3, move, b, a, c);
}

static int
autohelperpat119(int trans, int move, int color, int action)
{
  int a, B;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(683, trans, move);
  B = AFFINE_TRANSFORM(721, trans, move);

  return play_attack_defend2_n(color, 1, 2, move, a, B, a);
}

static int
autohelperpat121(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(610, trans, move);

  return !ATTACK_MACRO(a);
}

static int
autohelperpat123(int trans, int move, int color, int action)
{
  int b, A;
  UNUSED(color);
  UNUSED(action);

  b = AFFINE_TRANSFORM(682, trans, move);
  A = AFFINE_TRANSFORM(683, trans, move);

  return is_ko_point(A) && (dragon[b].status == ALIVE);
}

static int
autohelperpat124(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(685, trans, move);

  return is_ko_point(A);
}

static int
autohelperpat125(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(683, trans, move);

  return is_ko_point(a);
}

static int
autohelperpat126(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(685, trans, move);
  b = AFFINE_TRANSFORM(683, trans, move);

  return is_ko_point(a) && (dragon[b].status == ALIVE);
}

static int
autohelperpat140(int trans, int move, int color, int action)
{
  int a, b, c, d, e;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(683, trans, move);
  b = AFFINE_TRANSFORM(610, trans, move);
  c = AFFINE_TRANSFORM(645, trans, move);
  d = AFFINE_TRANSFORM(609, trans, move);
  e = AFFINE_TRANSFORM(682, trans, move);

  return !play_attack_defend_n(color, 1, 5, move, a, b, c, d, e);
}

static int
autohelperpat141(int trans, int move, int color, int action)
{
  int A, B;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(759, trans, move);
  B = AFFINE_TRANSFORM(647, trans, move);

  return play_connect_n(color, 1, 0, A, B) && !play_connect_n(color, 1, 1, move, A, B);
}

static int
autohelperpat142(int trans, int move, int color, int action)
{
  int a, b, c, d, e, f;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(720, trans, move);
  b = AFFINE_TRANSFORM(721, trans, move);
  c = AFFINE_TRANSFORM(758, trans, move);
  d = AFFINE_TRANSFORM(646, trans, move);
  e = AFFINE_TRANSFORM(647, trans, move);
  f = AFFINE_TRANSFORM(610, trans, move);

  return play_attack_defend2_n(color, 1, 4, move, a, b, c, a, c) && play_attack_defend2_n(color, 1, 4, move, d, e, f, d, f)&& !play_attack_defend2_n(color, 0, 5, move, b, a, d, e, b, d)&& !play_attack_defend2_n(color, 0, 5, move, e, d, a, b, e, a);
}

static int
autohelperpat143(int trans, int move, int color, int action)
{
  int a, b, c, d, e, f, g, h, I;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(720, trans, move);
  b = AFFINE_TRANSFORM(721, trans, move);
  c = AFFINE_TRANSFORM(758, trans, move);
  d = AFFINE_TRANSFORM(647, trans, move);
  e = AFFINE_TRANSFORM(685, trans, move);
  f = AFFINE_TRANSFORM(646, trans, move);
  g = AFFINE_TRANSFORM(648, trans, move);
  h = AFFINE_TRANSFORM(611, trans, move);
  I = AFFINE_TRANSFORM(683, trans, move);

  return !play_attack_defend2_n(color, 0, 3, move, b, a, b, I) && play_attack_defend2_n(color, 1, 4, move, a, b, c, a, c)&& play_attack_defend2_n(color, 1, 8, move, b, a, d, e, f, g, h, f, h)&& !play_attack_defend2_n(color, 0, 7, move, b, a, d, e, g, f, g, I);
}

static int
autohelperpat144(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(720, trans, move);

  return !play_attack_defend_n(color, 1, 1, move, a);
}

static int
autohelperpat145(int trans, int move, int color, int action)
{
  int c, A, B;
  UNUSED(color);
  UNUSED(action);

  c = AFFINE_TRANSFORM(685, trans, move);
  A = AFFINE_TRANSFORM(722, trans, move);
  B = AFFINE_TRANSFORM(723, trans, move);

  return  play_attack_defend_n(OTHER_COLOR(color), 1, 2, A, B, c) || play_attack_defend_n(OTHER_COLOR(color), 1, 1, move, c);
}

static int
autohelperpat146(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(646, trans, move);
  b = AFFINE_TRANSFORM(608, trans, move);

  return  play_attack_defend2_n(color, 0, 2, move, a, move, b);
}

static int
autohelperpat149(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(646, trans, move);
  b = AFFINE_TRANSFORM(720, trans, move);

  return !play_connect_n(color, 0, 1, move, a, b);
}

static int
autohelperpat150(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(795, trans, move);

  return  countlib(a)>2;
}

static int
autohelperpat152(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(758, trans, move);
  b = AFFINE_TRANSFORM(647, trans, move);

  return  play_attack_defend_n(color, 1, 2, move, a, a) && play_attack_defend_n(color, 1, 2, move, b, b);
}

static int
autohelperpat153(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);
  b = AFFINE_TRANSFORM(610, trans, move);

  return  play_attack_defend_n(color, 1, 2, move, a, a)&&play_attack_defend_n(color, 1, 2, move, b, b);
}

static int
autohelperpat154(int trans, int move, int color, int action)
{
  int b, A;
  UNUSED(color);
  UNUSED(action);

  b = AFFINE_TRANSFORM(720, trans, move);
  A = AFFINE_TRANSFORM(683, trans, move);

  return  countlib(A)<4 && countlib(b)>2 && !ATTACK_MACRO(A);
}

static int
autohelperpat155(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(647, trans, move);

  return  does_attack(move, A);
}

static int
autohelperpat156(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);
  b = AFFINE_TRANSFORM(720, trans, move);
  c = AFFINE_TRANSFORM(647, trans, move);
  d = AFFINE_TRANSFORM(758, trans, move);

  return  !play_attack_defend_n(color, 1, 6, move, a, b, c, d, move, c);
}

static int
autohelperpat157(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);
  b = AFFINE_TRANSFORM(720, trans, move);
  c = AFFINE_TRANSFORM(647, trans, move);
  d = AFFINE_TRANSFORM(758, trans, move);

  return  !play_attack_defend_n(OTHER_COLOR(color), 1, 6, move, a, b, c, d, move, c);
}

static int
autohelperpat158(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(572, trans, move);

  return  countlib(a)==2 && !(dragon[a].status == DEAD);
}

static int
autohelperpat161(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(682, trans, move);
  b = AFFINE_TRANSFORM(718, trans, move);

  return (dragon[b].status == ALIVE) && play_attack_defend_n(color, 1, 2, move, a, a);
}

static int
autohelperpat162(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(685, trans, move);

  return play_attack_defend_n(color, 0, 1, move, A) != WIN;
}

static int
autohelperpat163(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(683, trans, move);
  b = AFFINE_TRANSFORM(758, trans, move);

  return  safe_move(move, color) || !play_attack_defend_n(color, 1, 3, move, a, b, b);
}

static int
autohelperpat165(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);

  return play_attack_defend_n(OTHER_COLOR(color), 1, 2, move, a, a);
}

static int
autohelperpat167(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);
  b = AFFINE_TRANSFORM(721, trans, move);

  return defend_against(move, OTHER_COLOR(color), a) && defend_against(move, OTHER_COLOR(color), b);
}

static int
autohelperpat168(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(610, trans, move);
  b = AFFINE_TRANSFORM(647, trans, move);
  c = AFFINE_TRANSFORM(646, trans, move);

  return defend_against(b, OTHER_COLOR(color), a) && defend_against(b, OTHER_COLOR(color), move) && !play_attack_defend_n(color, 1, 1, move, c);
}

static int
autohelperpat169(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(683, trans, move);

  return !(dragon[a].status == DEAD);
}

static int
autohelperpat170(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);
  b = AFFINE_TRANSFORM(721, trans, move);

  return defend_against(move, color, a) && defend_against(move, color, b);
}

static int
autohelperpat171(int trans, int move, int color, int action)
{
  int a, B;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);
  B = AFFINE_TRANSFORM(646, trans, move);

  return (safe_move(move, OTHER_COLOR(color)) && play_attack_defend2_n(OTHER_COLOR(color), 0, 2, move, a, move, B)) || defend_against(a, OTHER_COLOR(color), move);
}

static int
autohelperpat174(int trans, int move, int color, int action)
{
  int A, B;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(646, trans, move);
  B = AFFINE_TRANSFORM(720, trans, move);

  return (!ATTACK_MACRO(A)) && (!ATTACK_MACRO(B));
}

static int
autohelperpat177(int trans, int move, int color, int action)
{
  int a, B;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);
  B = AFFINE_TRANSFORM(646, trans, move);

  return safe_move(move, OTHER_COLOR(color)) && play_attack_defend2_n(OTHER_COLOR(color), 0, 2, move, a, move, B);
}

static int
autohelperpat178(int trans, int move, int color, int action)
{
  int a, c, B;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(611, trans, move);
  c = AFFINE_TRANSFORM(648, trans, move);
  B = AFFINE_TRANSFORM(610, trans, move);

  return play_attack_defend2_n(OTHER_COLOR(color), 0, 2, c, a, c, B);
}

static int
autohelperpat180(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(648, trans, move);

  return safe_move(a, OTHER_COLOR(color));
}

static int
autohelperpat181(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(683, trans, move);
  b = AFFINE_TRANSFORM(647, trans, move);

  return defend_against(move, color, a) && play_attack_defend_n(color, 0, 2, move, b, move);
}

static int
autohelperpat183(int trans, int move, int color, int action)
{
  int a, b, c, d, E;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);
  b = AFFINE_TRANSFORM(646, trans, move);
  c = AFFINE_TRANSFORM(721, trans, move);
  d = AFFINE_TRANSFORM(610, trans, move);
  E = AFFINE_TRANSFORM(683, trans, move);

  return play_attack_defend2_n(color, 1, 2, move, c, E, c) && play_attack_defend2_n(color, 1, 4, move, b, a, d, b, d)&& play_attack_defend_n(color, 1, 4, move, a, b, c, E) == WIN;
}

static int
autohelperpat184(int trans, int move, int color, int action)
{
  int a, B;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(759, trans, move);
  B = AFFINE_TRANSFORM(721, trans, move);

  return play_attack_defend_n(color, 1, 2, move, a, B);
}

static int
autohelperpat185(int trans, int move, int color, int action)
{
  int a, B;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);
  B = AFFINE_TRANSFORM(720, trans, move);

  return defend_against(move, OTHER_COLOR(color), a) && !play_attack_defend_n(OTHER_COLOR(color), 1, 1, move, B);
}

static int
autohelperpat186(int trans, int move, int color, int action)
{
  int a, b, c, d, e;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);
  b = AFFINE_TRANSFORM(646, trans, move);
  c = AFFINE_TRANSFORM(721, trans, move);
  d = AFFINE_TRANSFORM(610, trans, move);
  e = AFFINE_TRANSFORM(683, trans, move);

  return play_attack_defend2_n(OTHER_COLOR(color), 1, 2, move, c, e, c) && play_attack_defend2_n(OTHER_COLOR(color), 1, 4, move, b, a, d, b, d)&& play_attack_defend_n(OTHER_COLOR(color), 1, 4, move, a, b, c, e);
}

static int
autohelperpat188(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);

  return countlib(a)>=3;
}

static int
autohelperpat192(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);

  return countlib(a)>=3;
}

static int
autohelperpat193(int trans, int move, int color, int action)
{
  int a, B, C;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);
  B = AFFINE_TRANSFORM(647, trans, move);
  C = AFFINE_TRANSFORM(758, trans, move);

  return countlib(B)>1 && countlib(C)>1 && play_attack_defend_n(OTHER_COLOR(color), 1, 2, move, a, a);
}

static int
autohelperpat195(int trans, int move, int color, int action)
{
  int A, B;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(644, trans, move);
  B = AFFINE_TRANSFORM(718, trans, move);

  return countlib(A)>1 && countlib(B)>1;
}

static int
autohelperpat200(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(719, trans, move);

  return !safe_move(a, OTHER_COLOR(color));
}

static int
autohelperpat205(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);
  b = AFFINE_TRANSFORM(645, trans, move);

  return !dragon_weak(a) || !(whose_moyo(OPPOSITE_INFLUENCE(color), b) == OTHER_COLOR(color));
}

static int
autohelperpat210(int trans, int move, int color, int action)
{
  int c, d, A, B;
  UNUSED(color);
  UNUSED(action);

  c = AFFINE_TRANSFORM(683, trans, move);
  d = AFFINE_TRANSFORM(721, trans, move);
  A = AFFINE_TRANSFORM(647, trans, move);
  B = AFFINE_TRANSFORM(758, trans, move);

  return !is_same_dragon(A, B) && (dragon_weak(c) || play_connect_n(OTHER_COLOR(color), 1, 2, move, d, A, B));
}

static int
autohelperpat211(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(685, trans, move);
  b = AFFINE_TRANSFORM(647, trans, move);
  c = AFFINE_TRANSFORM(721, trans, move);

  return play_break_through_n(OTHER_COLOR(color), 2, move, a, b, a, c);
}

static int
autohelperpat215(int trans, int move, int color, int action)
{
  int A, B;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(646, trans, move);
  B = AFFINE_TRANSFORM(722, trans, move);

  return !play_connect_n(color, 1, 1, move, A, B);
}

static int
autohelperpat216(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(645, trans, move);

  return countlib(a)>2;
}

static int
autohelperpat219(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(721, trans, move);

  return !dragon_weak(A);
}

static int
autohelperpat224(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(682, trans, move);

  return dragon_weakness(a, 0)<0.7;
}

static int
autohelperpat225(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(682, trans, move);
  b = AFFINE_TRANSFORM(683, trans, move);

  return !dragon_weak(a) && play_connect_n(color, 1, 2, move, b, move, a);
}

static int
autohelperpat226(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(720, trans, move);
  b = AFFINE_TRANSFORM(721, trans, move);
  c = AFFINE_TRANSFORM(757, trans, move);

  return !play_attack_defend_n(color, 1, 3, move, a, b, c);
}

static int
autohelperpat227(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(609, trans, move);
  b = AFFINE_TRANSFORM(610, trans, move);
  c = AFFINE_TRANSFORM(572, trans, move);

  return !play_connect_n(color, 0, 3, move, a, b, move, c);
}

static int
autohelperpat262(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(647, trans, move);

  return !dragon_weak(A);
}

static int
autohelperpat269(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(758, trans, move);
  b = AFFINE_TRANSFORM(610, trans, move);

  return (whose_moyo(OPPOSITE_INFLUENCE(color), a) == color) && (whose_moyo(OPPOSITE_INFLUENCE(color), b) == OTHER_COLOR(color));
}

static int
autohelperpat273(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(609, trans, move);

  return dragon_weak(A);
}

static int
autohelperpat275(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(757, trans, move);
  b = AFFINE_TRANSFORM(758, trans, move);

  return  somewhere(OTHER_COLOR(color), 1, 2, a, b);
}

static int
autohelperpat276(int trans, int move, int color, int action)
{
  int a, b, c, d, e;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(609, trans, move);
  b = AFFINE_TRANSFORM(610, trans, move);
  c = AFFINE_TRANSFORM(573, trans, move);
  d = AFFINE_TRANSFORM(682, trans, move);
  e = AFFINE_TRANSFORM(720, trans, move);

  return play_attack_defend_n(color, 1, 4, move, a, b, c, c) && somewhere(OTHER_COLOR(color), 1, 2, d, e);
}

static int
autohelperpat280(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(572, trans, move);

  return !play_connect_n(color, 0, 1, move, move, a);
}

static int
autohelperpat282(int trans, int move, int color, int action)
{
  UNUSED(trans);
  UNUSED(color);
  UNUSED(action);

  UNUSED(move);

  return (whose_area(OPPOSITE_INFLUENCE(color), move) == color);
}

static int
autohelperpat284(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(795, trans, move);
  b = AFFINE_TRANSFORM(832, trans, move);
  c = AFFINE_TRANSFORM(796, trans, move);
  d = AFFINE_TRANSFORM(833, trans, move);

  return  somewhere(color, 1, 4, a, b, c, d);
}

static int
autohelperpat292(int trans, int move, int color, int action)
{
  int a, B;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(685, trans, move);
  B = AFFINE_TRANSFORM(721, trans, move);

  return play_attack_defend2_n(color, 1, 2, move, a, a, B);
}

static int
autohelperpat307(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(795, trans, move);

  return (whose_moyo(OPPOSITE_INFLUENCE(color), a) == color);
}

static int
autohelperpat308(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(758, trans, move);

  return  ATTACK_MACRO(a) && !DEFEND_MACRO(a);
}

static int
autohelperpat311(int trans, int move, int color, int action)
{
  int a, b, c, D;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(683, trans, move);
  b = AFFINE_TRANSFORM(647, trans, move);
  c = AFFINE_TRANSFORM(685, trans, move);
  D = AFFINE_TRANSFORM(721, trans, move);

  return play_attack_defend2_n(color, 1, 2, move, a, a, D)&& (play_attack_defend_n(color, 1, 2, move, b, D) || play_attack_defend2_n(color, 1, 4, move, b, c, a, a, D));
}

static int
autohelperpat312(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(683, trans, move);

  return defend_against(move, color, a);
}

static int
autohelperpat313(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(647, trans, move);

  return does_attack(move, A);
}

static int
autohelperpat319(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(682, trans, move);
  b = AFFINE_TRANSFORM(718, trans, move);

  return defend_against(move, color, a) || (whose_moyo(OPPOSITE_INFLUENCE(color), b) == color);
}

static int
autohelperpat321(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);

  return (whose_moyo(INITIAL_INFLUENCE(color), a) == color);
}

static int
autohelperpat325(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(683, trans, move);

  return play_attack_defend_n(color, 1, 2, move, a, a);
}

static int
autohelperpat326(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(720, trans, move);
  b = AFFINE_TRANSFORM(682, trans, move);

  return countlib(a)>1 && !play_connect_n(color, 0, 1, move, move, b);
}

static int
autohelperpat332(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(720, trans, move);
  b = AFFINE_TRANSFORM(719, trans, move);
  c = AFFINE_TRANSFORM(757, trans, move);

  return !play_attack_defend_n(color, 1, 3, move, a, b, c);
}

static int
autohelperpat333(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(609, trans, move);

  return !play_connect_n(color, 0, 1, move, move, a);
}

static int
autohelperpat337(int trans, int move, int color, int action)
{
  int a, b, c, d, e;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(685, trans, move);
  b = AFFINE_TRANSFORM(648, trans, move);
  c = AFFINE_TRANSFORM(721, trans, move);
  d = AFFINE_TRANSFORM(720, trans, move);
  e = AFFINE_TRANSFORM(647, trans, move);

  return !play_attack_defend2_n(color, 1, 3, move, a, b, move, b) && play_attack_defend2_n(color, 1, 6, move, a, b, c, d, e, a, e);
}

static int
autohelperpat338(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(683, trans, move);

  return play_attack_defend_n(color, 1, 2, move, a, a);
}

static int
autohelperpat339(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(683, trans, move);
  b = AFFINE_TRANSFORM(646, trans, move);
  c = AFFINE_TRANSFORM(647, trans, move);

  return play_attack_defend_n(color, 1, 4, move, a, b, c, a);
}

static int
autohelperpat340(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(685, trans, move);
  b = AFFINE_TRANSFORM(722, trans, move);

  return !play_attack_defend2_n(color, 1, 3, move, a, b, move, b);
}

static int
autohelperpat341(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(685, trans, move);
  b = AFFINE_TRANSFORM(722, trans, move);

  return !play_attack_defend2_n(color, 1, 3, move, a, b, move, b);
}

static int
autohelperpat342(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(685, trans, move);
  b = AFFINE_TRANSFORM(722, trans, move);

  return !play_attack_defend2_n(color, 1, 3, move, a, b, move, b);
}

static int
autohelperpat349(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(646, trans, move);
  b = AFFINE_TRANSFORM(683, trans, move);
  c = AFFINE_TRANSFORM(610, trans, move);

  return countlib(a)>2|| !play_attack_defend2_n(color, 1, 3, move, b, c, move, a);
}

static int
autohelperpat350(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(646, trans, move);

  return countlib(a)>2;
}

static int
autohelperpat353(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);
  b = AFFINE_TRANSFORM(683, trans, move);

  return play_attack_defend_n(OTHER_COLOR(color), 1, 2, move, a, a) || dragon_weak(b);
}

static int
autohelperpat354(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(646, trans, move);

  return play_attack_defend_n(color, 1, 1, move, A);
}

static int
autohelperpat355(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(683, trans, move);

  return play_attack_defend_n(color, 1, 1, move, A);
}

static int
autohelperpat360(int trans, int move, int color, int action)
{
  int b, A;
  UNUSED(color);
  UNUSED(action);

  b = AFFINE_TRANSFORM(720, trans, move);
  A = AFFINE_TRANSFORM(721, trans, move);

  return play_attack_defend_n(color, 1, 1, move, A) && !play_attack_defend_n(color, 1, 1, move, b);
}

static int
autohelperpat361(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);
  b = AFFINE_TRANSFORM(720, trans, move);

  return  !play_attack_defend2_n(OTHER_COLOR(color), 1, 3, move, a, b, move, b);
}

static int
autohelperpat362(int trans, int move, int color, int action)
{
  int a, b, c, d, e;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(760, trans, move);
  b = AFFINE_TRANSFORM(759, trans, move);
  c = AFFINE_TRANSFORM(723, trans, move);
  d = AFFINE_TRANSFORM(721, trans, move);
  e = AFFINE_TRANSFORM(648, trans, move);

  return (dragon[d].status == ALIVE) && !play_attack_defend2_n(OTHER_COLOR(color), 1, 3, c, a, b, c, b) && play_attack_defend_n(color, 1, 2, move, c, c)&& !play_connect_n(color, 1, 2, c, move, d, e);
}

static int
autohelperpat363(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);
  b = AFFINE_TRANSFORM(720, trans, move);

  return !play_attack_defend2_n(OTHER_COLOR(color), 1, 3, move, a, b, move, b);
}

static int
autohelperpat364(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(720, trans, move);

  return play_attack_defend_n(color, 1, 1, move, A);
}

static int
autohelperpat365(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(610, trans, move);
  b = AFFINE_TRANSFORM(648, trans, move);
  c = AFFINE_TRANSFORM(647, trans, move);
  d = AFFINE_TRANSFORM(685, trans, move);

  return !play_attack_defend2_n(color, 0, 2, b, c, a, b) && !play_attack_defend2_n(color, 0, 4, c, b, d, move, c, d);
}

static int
autohelperpat366(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);
  b = AFFINE_TRANSFORM(685, trans, move);
  c = AFFINE_TRANSFORM(721, trans, move);
  d = AFFINE_TRANSFORM(722, trans, move);

  return !play_attack_defend2_n(color, 0, 2, b, move, a, b) && play_attack_defend2_n(color, 0, 4, move, b, d, c, a, d);
}

static int
autohelperpat367(int trans, int move, int color, int action)
{
  int A, B;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(610, trans, move);
  B = AFFINE_TRANSFORM(646, trans, move);

  return  countlib(A) == 2 && !play_attack_defend2_n(color, 1, 1, move, B, move);
}

static int
autohelperpat368(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(610, trans, move);
  b = AFFINE_TRANSFORM(648, trans, move);
  c = AFFINE_TRANSFORM(647, trans, move);

  return !play_attack_defend2_n(color, 0, 2, b, c, a, b) && play_attack_defend2_n(color, 0, 2, move, c, a, move);
}

static int
autohelperpat369(int trans, int move, int color, int action)
{
  int a, d, e, B, C;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(572, trans, move);
  d = AFFINE_TRANSFORM(683, trans, move);
  e = AFFINE_TRANSFORM(610, trans, move);
  B = AFFINE_TRANSFORM(609, trans, move);
  C = AFFINE_TRANSFORM(573, trans, move);

  return (dragon[d].status == ALIVE) && (dragon[e].status == CRITICAL) && !play_attack_defend2_n(color, 0, 3, move, NO_MOVE, a, B, C);
}

static int
autohelperpat371(int trans, int move, int color, int action)
{
  int a, b, c, d, E, F, G;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(572, trans, move);
  b = AFFINE_TRANSFORM(534, trans, move);
  c = AFFINE_TRANSFORM(571, trans, move);
  d = AFFINE_TRANSFORM(535, trans, move);
  E = AFFINE_TRANSFORM(608, trans, move);
  F = AFFINE_TRANSFORM(645, trans, move);
  G = AFFINE_TRANSFORM(682, trans, move);

  return !dragon_weak(a) && somewhere(color, 1, 3, b, c, d) && somewhere(OTHER_COLOR(color), 1, 3, E, F, G)&& !play_connect_n(color, 0, 1, move, move, a);
}

static int
autohelperpat376(int trans, int move, int color, int action)
{
  int a, b, C;
  UNUSED(color);

  a = AFFINE_TRANSFORM(572, trans, move);
  b = AFFINE_TRANSFORM(573, trans, move);
  C = AFFINE_TRANSFORM(610, trans, move);

  if (!action)
    return !dragon_weak(a) && play_attack_defend_n(color, 1, 2, move, b, b);
  defend_against_atari_helper(move, C);

  return 0;
}

static int
autohelperpat383(int trans, int move, int color, int action)
{
  int a, A;
  UNUSED(color);

  a = AFFINE_TRANSFORM(832, trans, move);
  A = AFFINE_TRANSFORM(721, trans, move);

  if (!action)
    return  does_attack(move, A) && play_attack_defend_n(color, 0, 1, a, A);
   add_antisuji_move(a);;

  return 0;
}

static int
autohelperpat384(int trans, int move, int color, int action)
{
  int a, A;
  UNUSED(color);

  a = AFFINE_TRANSFORM(831, trans, move);
  A = AFFINE_TRANSFORM(720, trans, move);

  if (!action)
    return  does_attack(move, A) && play_attack_defend_n(color, 0, 1, a, A);
   add_antisuji_move(a);;

  return 0;
}

static int
autohelperpat386(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(721, trans, move);

  return !ATTACK_MACRO(A);
}

static int
autohelperpat392(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);

  return !(whose_moyo(OPPOSITE_INFLUENCE(color), a) == color);
}

static int
autohelperpat395(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(573, trans, move);

  return  !(dragon[a].status == DEAD) && !play_connect_n(color, 0, 1, move, a, move);
}

static int
autohelperpat399(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(685, trans, move);

  return defend_against(move, color, a);
}

static int
autohelperpat404(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);

  return play_attack_defend_n(OTHER_COLOR(color), 1, 1, move, a);
}

static int
autohelperpat411(int trans, int move, int color, int action)
{
  int a, A;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(573, trans, move);
  A = AFFINE_TRANSFORM(646, trans, move);

  return !ATTACK_MACRO(a) && !(dragon[A].status == DEAD);
}

static int
autohelperpat417(int trans, int move, int color, int action)
{
  int a, b, c, d, e;
  UNUSED(color);

  a = AFFINE_TRANSFORM(721, trans, move);
  b = AFFINE_TRANSFORM(610, trans, move);
  c = AFFINE_TRANSFORM(609, trans, move);
  d = AFFINE_TRANSFORM(682, trans, move);
  e = AFFINE_TRANSFORM(720, trans, move);

  if (!action)
    return  play_attack_defend_n(color, 1, 3, a, b, move, c) || somewhere(OTHER_COLOR(color), 1, 2, d, e);
   add_replacement_move(a, move, color);

  return 0;
}

static int
autohelperpat418(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(757, trans, move);

  return (whose_moyo(OPPOSITE_INFLUENCE(color), a) == OTHER_COLOR(color));
}

static int
autohelperpat421(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(536, trans, move);

  return !play_connect_n(color, 0, 1, move, move, a);
}

static int
autohelperpat423(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(646, trans, move);

  return countlib(a)>1;
}

static int
autohelperpat428(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(720, trans, move);

  return  countlib(a)>2;
}

static int
autohelperpat431(int trans, int move, int color, int action)
{
  int a, b, c, d, e, f;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);
  b = AFFINE_TRANSFORM(646, trans, move);
  c = AFFINE_TRANSFORM(682, trans, move);
  d = AFFINE_TRANSFORM(610, trans, move);
  e = AFFINE_TRANSFORM(721, trans, move);
  f = AFFINE_TRANSFORM(648, trans, move);

  return  !play_attack_defend_n(color, 0, 7, move, a, b, c, d, e, f, f);
}

static int
autohelperpat435(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(720, trans, move);
  b = AFFINE_TRANSFORM(609, trans, move);

  return (dragon[a].status == ALIVE) && (whose_moyo(OPPOSITE_INFLUENCE(color), b) == OTHER_COLOR(color));
}

static int
autohelperpat436(int trans, int move, int color, int action)
{
  int a, B;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(683, trans, move);
  B = AFFINE_TRANSFORM(610, trans, move);

  return !(dragon[a].status == DEAD) && !ATTACK_MACRO(B);
}

static int
autohelperpat437(int trans, int move, int color, int action)
{
  int a, c, B;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(758, trans, move);
  c = AFFINE_TRANSFORM(647, trans, move);
  B = AFFINE_TRANSFORM(685, trans, move);

  return !(dragon[a].status == DEAD) && (whose_moyo(OPPOSITE_INFLUENCE(color), c) == OTHER_COLOR(color)) && !play_attack_defend_n(color, 0, 1, move, B) && !play_attack_defend2_n(color, 1, 1, move, move, a);
}

static int
autohelperpat438(int trans, int move, int color, int action)
{
  int a, b, c, e, D;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);
  b = AFFINE_TRANSFORM(721, trans, move);
  c = AFFINE_TRANSFORM(646, trans, move);
  e = AFFINE_TRANSFORM(609, trans, move);
  D = AFFINE_TRANSFORM(683, trans, move);

  return (whose_moyo(OPPOSITE_INFLUENCE(color), e) == OTHER_COLOR(color)) && !play_attack_defend2_n(color, 0, 5, move, a, b, NO_MOVE, c, a, D) && !play_attack_defend_n(color, 1, 4, move, a, b, c, move);
}

static int
autohelperpat444(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(683, trans, move);

  return !dragon_weak(A);
}

static int
autohelperpat445(int trans, int move, int color, int action)
{
  int a, b, c, D;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);
  b = AFFINE_TRANSFORM(647, trans, move);
  c = AFFINE_TRANSFORM(720, trans, move);
  D = AFFINE_TRANSFORM(683, trans, move);

  return !dragon_weak(D) && !play_attack_defend_n(color, 1, 5, move, a, b, NO_MOVE, c, c);
}

static int
autohelperpat447(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(757, trans, move);

  return !play_attack_defend_n(color, 1, 3, move, NO_MOVE, a, a);
}

static int
autohelperpat450(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);
  b = AFFINE_TRANSFORM(721, trans, move);

  add_antisuji_move(a);add_antisuji_move(b);;

  return 0;
}

static int
autohelperpat461(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);
  b = AFFINE_TRANSFORM(685, trans, move);
  c = AFFINE_TRANSFORM(758, trans, move);

  return cut_possible(a, OTHER_COLOR(color)) || play_attack_defend_n(OTHER_COLOR(color), 1, 2, a, b, c);
}

static int
autohelperpat465(int trans, int move, int color, int action)
{
  UNUSED(trans);
  UNUSED(color);
  UNUSED(action);

  UNUSED(move);

  return !(whose_moyo(OPPOSITE_INFLUENCE(color), move) == color);
}

static int
autohelperpat468(int trans, int move, int color, int action)
{
  UNUSED(trans);
  UNUSED(color);
  UNUSED(action);

  UNUSED(move);

  return !(whose_moyo(OPPOSITE_INFLUENCE(color), move) == color);
}

static int
autohelperpat469(int trans, int move, int color, int action)
{
  UNUSED(trans);
  UNUSED(color);
  UNUSED(action);

  UNUSED(move);

  return !(whose_moyo(OPPOSITE_INFLUENCE(color), move) == color);
}

static int
autohelperpat472(int trans, int move, int color, int action)
{
  UNUSED(trans);
  UNUSED(color);
  UNUSED(action);

  UNUSED(move);

  return !(whose_moyo(OPPOSITE_INFLUENCE(color), move) == color);
}

static int
autohelperpat473(int trans, int move, int color, int action)
{
  UNUSED(trans);
  UNUSED(color);
  UNUSED(action);

  UNUSED(move);

  return !(whose_moyo(OPPOSITE_INFLUENCE(color), move) == color);
}

static int
autohelperpat474(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(649, trans, move);

  return safe_move(move, OTHER_COLOR(color)) && (whose_territory(OPPOSITE_INFLUENCE(color), a) == color);
}

static int
autohelperpat475(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(720, trans, move);
  b = AFFINE_TRANSFORM(646, trans, move);

  return !play_break_through_n(color, 1, move, a, move, b);
}

static int
autohelperpat477(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(685, trans, move);

  return !defend_against(a, color, move);
}

static int
autohelperpat480(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);

  a = AFFINE_TRANSFORM(685, trans, move);
  b = AFFINE_TRANSFORM(759, trans, move);
  c = AFFINE_TRANSFORM(720, trans, move);

  if (!action)
    return play_attack_defend2_n(OTHER_COLOR(color), 1, 2, b, a, a, c);
  add_antisuji_move(a);;

  return 0;
}

static int
autohelperpat481(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(683, trans, move);
  b = AFFINE_TRANSFORM(720, trans, move);

  return !play_attack_defend_n(OTHER_COLOR(color), 1, 3, move, a, b, b);
}

static int
autohelperpat495(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(720, trans, move);
  b = AFFINE_TRANSFORM(685, trans, move);
  c = AFFINE_TRANSFORM(759, trans, move);

  return  play_attack_defend_n(color, 1, 4, move, a, b, c, c);
}

static int
autohelperpat497(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);
  b = AFFINE_TRANSFORM(720, trans, move);
  c = AFFINE_TRANSFORM(758, trans, move);
  d = AFFINE_TRANSFORM(722, trans, move);

  return  play_attack_defend_n(color, 1, 4, move, a, b, c, a) || play_attack_defend_n(color, 1, 4, move, a, d, b, a);
}

static int
autohelperpat498(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(682, trans, move);

  return  play_attack_defend_n(color, 1, 2, move, a, a);
}

static int
autohelperpat499(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(722, trans, move);

  return  play_attack_defend_n(color, 1, 2, move, a, a);
}

static int
autohelperpat500(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(610, trans, move);
  b = AFFINE_TRANSFORM(646, trans, move);
  c = AFFINE_TRANSFORM(647, trans, move);

  return  somewhere(OTHER_COLOR(color), 1, 3, a, b, c);
}

static int
autohelperpat505(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(611, trans, move);

  return (whose_area(OPPOSITE_INFLUENCE(color), move) == OTHER_COLOR(color)) && (whose_area(OPPOSITE_INFLUENCE(color), a) == color);
}

static int
autohelperpat507(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(722, trans, move);
  b = AFFINE_TRANSFORM(685, trans, move);

  return (countlib(a)>1) && (!ATTACK_MACRO(b) || DEFEND_MACRO(b));
}

static int
autohelperpat508(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(720, trans, move);
  b = AFFINE_TRANSFORM(722, trans, move);

  return countlib(a)>1 && countlib(b)>1;
}

static int
autohelperpat509(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(722, trans, move);

  return countlib(a)>1;
}

static int
autohelperpat510(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(720, trans, move);

  return countlib(a)>1;
}

static int
autohelperpat511(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(721, trans, move);

  return  owl_threatens_attack(move, A);
}

static int
autohelperpat512(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(648, trans, move);

  return countlib(a)>1;
}

static int
autohelperpat513(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(685, trans, move);

  return !ATTACK_MACRO(A) || !play_attack_defend_n(color, 0, 1, move, A);
}

static int
autohelperpat514(int trans, int move, int color, int action)
{
  int a, B;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);
  B = AFFINE_TRANSFORM(685, trans, move);

  return  play_attack_defend2_n(color, 1, 2, move, a, a, B) && (!ATTACK_MACRO(B) || does_attack(move, B));
}

static int
autohelperpat516(int trans, int move, int color, int action)
{
  int a, B;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(683, trans, move);
  B = AFFINE_TRANSFORM(647, trans, move);

  return !play_attack_defend2_n(color, 1, 2, move, a, a, B);
}

static int
autohelperpat517(int trans, int move, int color, int action)
{
  int a, B;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(683, trans, move);
  B = AFFINE_TRANSFORM(647, trans, move);

  return play_attack_defend2_n(color, 1, 2, move, a, a, B);
}

static int
autohelperpat518(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(646, trans, move);
  b = AFFINE_TRANSFORM(758, trans, move);

  return countlib(a)>=2 && countlib(b)>=2;
}

static int
autohelperpat522(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(720, trans, move);

  return countlib(a)>1;
}

static int
autohelperpat526(int trans, int move, int color, int action)
{
  int a, b, c, D;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(646, trans, move);
  b = AFFINE_TRANSFORM(683, trans, move);
  c = AFFINE_TRANSFORM(648, trans, move);
  D = AFFINE_TRANSFORM(685, trans, move);

  return !(whose_area(OPPOSITE_INFLUENCE(color), a) == OTHER_COLOR(color)) && !(whose_area(OPPOSITE_INFLUENCE(color), b) == OTHER_COLOR(color)) && countlib(c)>2 && countlib(D)<3;
}

static int
autohelperpat527(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);

  return defend_against(move, color, a);
}

static int
autohelperpat528(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);

  return  defend_against(move, color, a);
}

static int
autohelperpat530(int trans, int move, int color, int action)
{
  int b, c, e, A, D, F;
  UNUSED(color);
  UNUSED(action);

  b = AFFINE_TRANSFORM(611, trans, move);
  c = AFFINE_TRANSFORM(573, trans, move);
  e = AFFINE_TRANSFORM(647, trans, move);
  A = AFFINE_TRANSFORM(685, trans, move);
  D = AFFINE_TRANSFORM(722, trans, move);
  F = AFFINE_TRANSFORM(721, trans, move);

  return  countlib(c)>1 && !play_attack_defend_n(color, 1, 1, move, b) && play_attack_defend2_n(color, 0, 2, move, A, move, b) && (play_attack_defend_n(color, 1, 2, move, A, e) || !somewhere(OTHER_COLOR(color), 1, 2, D, F));
}

static int
autohelperpat538(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(685, trans, move);

  return !ATTACK_MACRO(A) && play_attack_defend_n(color, 1, 1, move, A);
}

static int
autohelperpat540(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(610, trans, move);
  b = AFFINE_TRANSFORM(648, trans, move);

  return  (dragon[a].status == DEAD) && !(dragon[b].status == DEAD);
}

static int
autohelperpat547(int trans, int move, int color, int action)
{
  int a, c, B;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(683, trans, move);
  c = AFFINE_TRANSFORM(647, trans, move);
  B = AFFINE_TRANSFORM(721, trans, move);

  return (whose_territory(OPPOSITE_INFLUENCE(color), c) == OTHER_COLOR(color)) && play_attack_defend2_n(color, 1, 2, move, a, a, B);
}

static int
autohelperpat549(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(609, trans, move);
  b = AFFINE_TRANSFORM(646, trans, move);

  return (whose_area(OPPOSITE_INFLUENCE(color), a) == OTHER_COLOR(color)) || (whose_area(OPPOSITE_INFLUENCE(color), b) == OTHER_COLOR(color));
}

static int
autohelperpat557(int trans, int move, int color, int action)
{
  int a, b, c, d, e, f;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(682, trans, move);
  b = AFFINE_TRANSFORM(721, trans, move);
  c = AFFINE_TRANSFORM(758, trans, move);
  d = AFFINE_TRANSFORM(759, trans, move);
  e = AFFINE_TRANSFORM(719, trans, move);
  f = AFFINE_TRANSFORM(683, trans, move);

  return ((dragon[e].status == ALIVE) || (dragon[f].status == ALIVE)) && play_attack_defend_n(color, 1, 2, move, a, a) && !play_attack_defend_n(color, 1, 5, move, NO_MOVE, b, c, d, d);
}

static int
autohelperpat558(int trans, int move, int color, int action)
{
  int a, b, c, d, e;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(648, trans, move);
  b = AFFINE_TRANSFORM(647, trans, move);
  c = AFFINE_TRANSFORM(610, trans, move);
  d = AFFINE_TRANSFORM(611, trans, move);
  e = AFFINE_TRANSFORM(608, trans, move);

  return !(whose_moyo(OPPOSITE_INFLUENCE(color), e) == OTHER_COLOR(color)) && play_attack_defend_n(color, 0, 4, move, a, b, c, d);
}

static int
autohelperpat559(int trans, int move, int color, int action)
{
  int a, b, c, e;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(648, trans, move);
  b = AFFINE_TRANSFORM(647, trans, move);
  c = AFFINE_TRANSFORM(610, trans, move);
  e = AFFINE_TRANSFORM(608, trans, move);

  return !(whose_moyo(OPPOSITE_INFLUENCE(color), e) == OTHER_COLOR(color)) && play_attack_defend_n(color, 1, 4, move, a, b, c, c);
}

static int
autohelperpat560(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);
  b = AFFINE_TRANSFORM(722, trans, move);
  c = AFFINE_TRANSFORM(720, trans, move);
  d = AFFINE_TRANSFORM(683, trans, move);

  return !play_attack_defend_n(color, 1, 3, move, a, b, b) || !play_attack_defend_n(color, 1, 4, move, a, c, d, move);
}

static int
autohelperpat563(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(722, trans, move);

  return !ATTACK_MACRO(A) || does_attack(move, A);
}

static int
autohelperpat564(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(610, trans, move);
  b = AFFINE_TRANSFORM(647, trans, move);

  return !(whose_area(OPPOSITE_INFLUENCE(color), a) == OTHER_COLOR(color)) && !(whose_area(OPPOSITE_INFLUENCE(color), b) == OTHER_COLOR(color));
}

static int
autohelperpat565(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);

  return (whose_area(OPPOSITE_INFLUENCE(color), a) == OTHER_COLOR(color)) || (whose_area(OPPOSITE_INFLUENCE(color), move) == OTHER_COLOR(color));
}

static int
autohelperpat567(int trans, int move, int color, int action)
{
  int b, A;
  UNUSED(color);
  UNUSED(action);

  b = AFFINE_TRANSFORM(720, trans, move);
  A = AFFINE_TRANSFORM(646, trans, move);

  return  !does_attack(b, A);
}

static int
autohelperpat570(int trans, int move, int color, int action)
{
  int a, b, c, d, e;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);
  b = AFFINE_TRANSFORM(646, trans, move);
  c = AFFINE_TRANSFORM(683, trans, move);
  d = AFFINE_TRANSFORM(610, trans, move);
  e = AFFINE_TRANSFORM(611, trans, move);

  return (whose_moyo(OPPOSITE_INFLUENCE(color), e) == color) || (play_attack_defend_n(color, 1, 4, move, a, b, c, a) && play_attack_defend2_n(color, 1, 4, move, b, a, d, b, d));
}

static int
autohelperpat572(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(609, trans, move);

  return  !play_connect_n(color, 0, 1, move, move, a);
}

static int
autohelperpat574(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);
  b = AFFINE_TRANSFORM(721, trans, move);

  return  !is_same_dragon(a, b) && ((dragon[a].status == ALIVE) || (dragon[b].status == ALIVE));
}

static int
autohelperpat575(int trans, int move, int color, int action)
{
  int b;
  UNUSED(color);
  UNUSED(action);

  b = AFFINE_TRANSFORM(686, trans, move);

  return defend_against(move, color, b);
}

static int
autohelperpat578(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);

  return play_attack_defend_n(color, 1, 2, move, a, a);
}

static int
autohelperpat581(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(721, trans, move);

  return countlib(A)==3;
}

static int
autohelperpat583(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(720, trans, move);
  b = AFFINE_TRANSFORM(722, trans, move);

  return ((dragon[a].status == ALIVE) || (dragon[b].status == ALIVE)) && !play_attack_defend_n(color, 1, 1, move, a) && !play_attack_defend_n(color, 1, 1, move, b);
}

static int
autohelperpat585(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(610, trans, move);

  return is_surrounded(a);
}

static int
autohelperpat589(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);

  return play_attack_defend_n(color, 1, 2, move, a, a);
}

static int
autohelperpat590(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(570, trans, move);
  b = AFFINE_TRANSFORM(574, trans, move);

  return (whose_moyo(OPPOSITE_INFLUENCE(color), a) == color) && (whose_moyo(OPPOSITE_INFLUENCE(color), b) == color);
}

static int
autohelperpat593(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(572, trans, move);
  b = AFFINE_TRANSFORM(723, trans, move);

  return !ATTACK_MACRO(a) && countlib(a)>2 && !ATTACK_MACRO(b) && countlib(b)>2;
}

static int
autohelperpat597(int trans, int move, int color, int action)
{
  int a, b, c, d, e;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(719, trans, move);
  b = AFFINE_TRANSFORM(721, trans, move);
  c = AFFINE_TRANSFORM(683, trans, move);
  d = AFFINE_TRANSFORM(720, trans, move);
  e = AFFINE_TRANSFORM(646, trans, move);

  return  somewhere(color, 1, 2, a, b) || play_attack_defend_n(color, 1, 5, move, c, d, e, b, a) || play_attack_defend_n(color, 1, 5, move, c, d, e, a, b);
}

static int
autohelperpat600(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(646, trans, move);
  b = AFFINE_TRANSFORM(720, trans, move);

  return countlib(a)>1 && countlib(b)>1;
}

static int
autohelperpat601(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(646, trans, move);
  b = AFFINE_TRANSFORM(720, trans, move);

  return countlib(a)>1 && countlib(b)>1;
}

static int
autohelperpat603(int trans, int move, int color, int action)
{
  UNUSED(trans);
  UNUSED(color);
  UNUSED(action);

  UNUSED(move);

  return !(whose_moyo(OPPOSITE_INFLUENCE(color), move) == OTHER_COLOR(color));
}

static int
autohelperpat610(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(646, trans, move);

  return  play_attack_defend_n(color, 1, 2, move, a, a);
}

static int
autohelperpat612(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(644, trans, move);

  return !play_connect_n(color, 0, 1, move, move, a);
}

static int
autohelperpat619(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(720, trans, move);

  return !play_attack_defend_n(OTHER_COLOR(color), 1, 1, move, A);
}

static int
autohelperpat623(int trans, int move, int color, int action)
{
  int a, b, A;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);
  b = AFFINE_TRANSFORM(722, trans, move);
  A = AFFINE_TRANSFORM(685, trans, move);

  return countlib(A)==3 && !defend_against(a, OTHER_COLOR(color), b);
}

static int
autohelperpat626(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(610, trans, move);

  return  !play_connect_n(color, 0, 1, move, A, move);
}

static int
autohelperpat628(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(682, trans, move);

  return countlib(a)<4;
}

static int
autohelperpat630(int trans, int move, int color, int action)
{
  int a, b, C;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(722, trans, move);
  b = AFFINE_TRANSFORM(685, trans, move);
  C = AFFINE_TRANSFORM(648, trans, move);

  return !(whose_moyo(OPPOSITE_INFLUENCE(color), a) == OTHER_COLOR(color)) && !play_attack_defend_n(color, 1, 1, b, C);
}

static int
autohelperpat633(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(758, trans, move);

  return !(whose_moyo(OPPOSITE_INFLUENCE(color), move) == OTHER_COLOR(color)) && !(whose_area(OPPOSITE_INFLUENCE(color), a) == OTHER_COLOR(color));
}

static int
autohelperpat634(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(610, trans, move);

  return !(whose_territory(OPPOSITE_INFLUENCE(color), move) == OTHER_COLOR(color)) && dragon_weak(A);
}

static int
autohelperpat635(int trans, int move, int color, int action)
{
  int b, c, d, e, f, g, A;
  UNUSED(color);
  UNUSED(action);

  b = AFFINE_TRANSFORM(644, trans, move);
  c = AFFINE_TRANSFORM(681, trans, move);
  d = AFFINE_TRANSFORM(718, trans, move);
  e = AFFINE_TRANSFORM(645, trans, move);
  f = AFFINE_TRANSFORM(682, trans, move);
  g = AFFINE_TRANSFORM(719, trans, move);
  A = AFFINE_TRANSFORM(610, trans, move);

  return !(whose_territory(OPPOSITE_INFLUENCE(color), move) == OTHER_COLOR(color)) && dragon_weak(A) && somewhere(color, 1, 6, b, c, d, e, f, g);
}

static int
autohelperpat638(int trans, int move, int color, int action)
{
  int a, b, c, d, A, B;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);
  b = AFFINE_TRANSFORM(646, trans, move);
  c = AFFINE_TRANSFORM(683, trans, move);
  d = AFFINE_TRANSFORM(721, trans, move);
  A = AFFINE_TRANSFORM(648, trans, move);
  B = AFFINE_TRANSFORM(610, trans, move);

  return countlib(A)<=3 && countlib(B)>=3 && play_attack_defend_n(color, 1, 6, move, a, b, c, d, NO_MOVE, A);
}

static int
autohelperpat640(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(685, trans, move);

  return play_attack_defend_n(color, 1, 2, move, a, a);
}

static int
autohelperpat642(int trans, int move, int color, int action)
{
  int a, B, C;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(682, trans, move);
  B = AFFINE_TRANSFORM(646, trans, move);
  C = AFFINE_TRANSFORM(720, trans, move);

  return  !safe_move(a, color) && countlib(B)>1 && countlib(C)>1;
}

static int
autohelperpat645(int trans, int move, int color, int action)
{
  int a, b, c, d, e, f, g, h;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(648, trans, move);
  b = AFFINE_TRANSFORM(685, trans, move);
  c = AFFINE_TRANSFORM(647, trans, move);
  d = AFFINE_TRANSFORM(646, trans, move);
  e = AFFINE_TRANSFORM(683, trans, move);
  f = AFFINE_TRANSFORM(720, trans, move);
  g = AFFINE_TRANSFORM(721, trans, move);
  h = AFFINE_TRANSFORM(722, trans, move);

  return (somewhere(OTHER_COLOR(color), 1, 5, d, e, f, g, h) || (whose_area(OPPOSITE_INFLUENCE(color), f) == OTHER_COLOR(color)))&& !play_connect_n(color, 0, 2, move, b, move, a) && !play_connect_n(color, 0, 2, move, c, move, a);
}

static int
autohelperpat646(int trans, int move, int color, int action)
{
  int a, b, c, d, e, f, g, h, i;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(611, trans, move);
  b = AFFINE_TRANSFORM(686, trans, move);
  c = AFFINE_TRANSFORM(685, trans, move);
  d = AFFINE_TRANSFORM(646, trans, move);
  e = AFFINE_TRANSFORM(683, trans, move);
  f = AFFINE_TRANSFORM(720, trans, move);
  g = AFFINE_TRANSFORM(721, trans, move);
  h = AFFINE_TRANSFORM(722, trans, move);
  i = AFFINE_TRANSFORM(649, trans, move);

  return (somewhere(OTHER_COLOR(color), 0, 5, d, e, f, g, h) || (whose_area(OPPOSITE_INFLUENCE(color), f) == OTHER_COLOR(color)))&& (same_string(a, b) || play_attack_defend_n(color, 1, 4, move, c, NO_MOVE, i, i));
}

static int
autohelperpat650(int trans, int move, int color, int action)
{
  int a, b, c, d, e;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(650, trans, move);
  b = AFFINE_TRANSFORM(687, trans, move);
  c = AFFINE_TRANSFORM(724, trans, move);
  d = AFFINE_TRANSFORM(683, trans, move);
  e = AFFINE_TRANSFORM(720, trans, move);

  return (whose_moyo(OPPOSITE_INFLUENCE(color), a) == color) && (whose_moyo(OPPOSITE_INFLUENCE(color), b) == color) && (whose_moyo(OPPOSITE_INFLUENCE(color), c) == color) && (whose_moyo(OPPOSITE_INFLUENCE(color), d) == OTHER_COLOR(color)) && (whose_moyo(OPPOSITE_INFLUENCE(color), e) == OTHER_COLOR(color));
}

static int
autohelperpat651(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(686, trans, move);
  b = AFFINE_TRANSFORM(723, trans, move);

  return (whose_moyo(OPPOSITE_INFLUENCE(color), a) == color) || (whose_moyo(OPPOSITE_INFLUENCE(color), b) == color);
}

static int
autohelperpat652(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(723, trans, move);
  b = AFFINE_TRANSFORM(760, trans, move);

  return (whose_moyo(OPPOSITE_INFLUENCE(color), a) == color) || (whose_moyo(OPPOSITE_INFLUENCE(color), b) == color);
}

static int
autohelperpat653(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(649, trans, move);
  b = AFFINE_TRANSFORM(686, trans, move);

  return (whose_moyo(OPPOSITE_INFLUENCE(color), a) == color) || (whose_moyo(OPPOSITE_INFLUENCE(color), b) == color);
}

static int
autohelperpat657(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(757, trans, move);
  b = AFFINE_TRANSFORM(758, trans, move);

  return somewhere(OTHER_COLOR(color), 1, 2, a, b);
}

static int
autohelperpat659(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(719, trans, move);

  return !play_attack_defend_n(color, 1, 1, move, a);
}

static int
autohelperpat660(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(720, trans, move);

  return !play_attack_defend_n(color, 1, 1, move, a);
}

static int
autohelperpat664(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(610, trans, move);

  add_antisuji_move(a);;

  return 0;
}

static int
autohelperpat665(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(610, trans, move);
  b = AFFINE_TRANSFORM(683, trans, move);

  return play_attack_defend_n(color, 1, 3, move, a, b, b);
}

static int
autohelperpat670(int trans, int move, int color, int action)
{
  int b, A;
  UNUSED(color);
  UNUSED(action);

  b = AFFINE_TRANSFORM(573, trans, move);
  A = AFFINE_TRANSFORM(610, trans, move);

  return play_attack_defend_n(color, 1, 1, move, A) && !play_attack_defend_n(color, 1, 1, move, b);
}

static int
autohelperpat671(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);
  b = AFFINE_TRANSFORM(720, trans, move);
  c = AFFINE_TRANSFORM(609, trans, move);

  return !play_attack_defend_n(color, 1, 1, move, c) && !play_attack_defend_n(color, 0, 3, move, a, b, a);
}

static int
autohelperpat674(int trans, int move, int color, int action)
{
  int b, A;
  UNUSED(color);
  UNUSED(action);

  b = AFFINE_TRANSFORM(722, trans, move);
  A = AFFINE_TRANSFORM(685, trans, move);

  return play_attack_defend_n(color, 1, 1, move, A) && !play_attack_defend2_n(color, 1, 1, move, move, b);
}

static int
autohelperpat675(int trans, int move, int color, int action)
{
  int b, c, A;
  UNUSED(color);
  UNUSED(action);

  b = AFFINE_TRANSFORM(722, trans, move);
  c = AFFINE_TRANSFORM(721, trans, move);
  A = AFFINE_TRANSFORM(685, trans, move);

  return play_attack_defend_n(color, 1, 1, move, A) && play_attack_defend2_n(color, 0, 2, move, c, move, b);
}

static int
autohelperpat676(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(685, trans, move);

  return play_attack_defend_n(color, 1, 1, move, A);
}

static int
autohelperpat677(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(685, trans, move);

  return play_attack_defend_n(color, 1, 1, move, A);
}

static int
autohelperpat678(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(757, trans, move);

  return !ATTACK_MACRO(A);
}

static int
autohelperpat682(int trans, int move, int color, int action)
{
  int a, b, A, B, C;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(645, trans, move);
  b = AFFINE_TRANSFORM(719, trans, move);
  A = AFFINE_TRANSFORM(682, trans, move);
  B = AFFINE_TRANSFORM(646, trans, move);
  C = AFFINE_TRANSFORM(720, trans, move);

  return countlib(A)<=2 && countlib(B)>1 && countlib(C)>1&& !play_attack_defend_n(color, 1, 1, move, a) && !play_attack_defend_n(color, 1, 1, move, b)&& play_attack_defend_n(color, 1, 1, move, A) && play_attack_defend_n(color, 1, 1, move, B) && play_attack_defend_n(color, 1, 1, move, C);
}

static int
autohelperpat687(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(573, trans, move);

  return countlib(a)>2;
}

static int
autohelperpat692(int trans, int move, int color, int action)
{
  int c, d, A, B;
  UNUSED(color);

  c = AFFINE_TRANSFORM(608, trans, move);
  d = AFFINE_TRANSFORM(756, trans, move);
  A = AFFINE_TRANSFORM(609, trans, move);
  B = AFFINE_TRANSFORM(757, trans, move);

  if (!action)
    return countlib(A)==2 && countlib(B)==2 && countlib(c)>1 && countlib(d)>1;
  test_attack_either_move(move, color, A, B);;

  return 0;
}

static int
autohelperpat693(int trans, int move, int color, int action)
{
  int a, b, C, D;
  UNUSED(color);

  a = AFFINE_TRANSFORM(610, trans, move);
  b = AFFINE_TRANSFORM(648, trans, move);
  C = AFFINE_TRANSFORM(683, trans, move);
  D = AFFINE_TRANSFORM(572, trans, move);

  if (!action)
    return play_attack_defend_n(color, 1, 2, move, b, C) && play_attack_defend_n(color, 1, 2, a, b, D);
  test_attack_either_move(move, color, C, D);;

  return 0;
}

static int
autohelperpat694(int trans, int move, int color, int action)
{
  int a, b, c, A;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(720, trans, move);
  b = AFFINE_TRANSFORM(646, trans, move);
  c = AFFINE_TRANSFORM(647, trans, move);
  A = AFFINE_TRANSFORM(721, trans, move);

  return countlib(A)==2 && countlib(a)>1 && !(dragon[b].status == ALIVE) && is_proper_eye_space(c);
}

static int
autohelperpat695(int trans, int move, int color, int action)
{
  int a, b, A;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(646, trans, move);
  b = AFFINE_TRANSFORM(720, trans, move);
  A = AFFINE_TRANSFORM(683, trans, move);

  return countlib(A)==2 && countlib(a)>1 && countlib(b)>1;
}

static int
autohelperpat696(int trans, int move, int color, int action)
{
  int a, A;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(720, trans, move);
  A = AFFINE_TRANSFORM(721, trans, move);

  return countlib(A)==2 && countlib(a)>1;
}

static int
autohelperpat697(int trans, int move, int color, int action)
{
  int b, d, f, g, A, C, E, H;
  UNUSED(color);

  b = AFFINE_TRANSFORM(648, trans, move);
  d = AFFINE_TRANSFORM(722, trans, move);
  f = AFFINE_TRANSFORM(686, trans, move);
  g = AFFINE_TRANSFORM(720, trans, move);
  A = AFFINE_TRANSFORM(647, trans, move);
  C = AFFINE_TRANSFORM(685, trans, move);
  E = AFFINE_TRANSFORM(611, trans, move);
  H = AFFINE_TRANSFORM(573, trans, move);

  if (!action)
    return  countlib(H)>4 || !play_attack_defend_n(color, 0, 7, move, A, b, C, d, E, f, E);
  add_antisuji_move(g);;

  return 0;
}

static int
autohelperpat698(int trans, int move, int color, int action)
{
  int c, d, e, f, g, A, B;
  UNUSED(color);
  UNUSED(action);

  c = AFFINE_TRANSFORM(685, trans, move);
  d = AFFINE_TRANSFORM(722, trans, move);
  e = AFFINE_TRANSFORM(759, trans, move);
  f = AFFINE_TRANSFORM(648, trans, move);
  g = AFFINE_TRANSFORM(723, trans, move);
  A = AFFINE_TRANSFORM(610, trans, move);
  B = AFFINE_TRANSFORM(721, trans, move);

  return  play_attack_defend_n(color, 1, 4, move, c, d, f, B) && play_attack_defend_n(color, 1, 6, move, c, d, e, f, g, A);
}

static int
autohelperpat700(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(610, trans, move);
  b = AFFINE_TRANSFORM(611, trans, move);
  c = AFFINE_TRANSFORM(574, trans, move);
  d = AFFINE_TRANSFORM(648, trans, move);

  return  play_attack_defend_n(OTHER_COLOR(color), 0, 4, a, b, c, d, c);
}

static int
autohelperpat703(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(722, trans, move);

  return  countlib(A)==2;
}

static int
autohelperpat705(int trans, int move, int color, int action)
{
  int a, b, c, d, e;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);
  b = AFFINE_TRANSFORM(535, trans, move);
  c = AFFINE_TRANSFORM(572, trans, move);
  d = AFFINE_TRANSFORM(536, trans, move);
  e = AFFINE_TRANSFORM(573, trans, move);

  return dragon_weak(a) && somewhere(color, 1, 4, b, c, d, e);
}

static int
autohelperpat709(int trans, int move, int color, int action)
{
  int a, b, c, D, E;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(685, trans, move);
  b = AFFINE_TRANSFORM(648, trans, move);
  c = AFFINE_TRANSFORM(722, trans, move);
  D = AFFINE_TRANSFORM(721, trans, move);
  E = AFFINE_TRANSFORM(610, trans, move);

  return  play_attack_defend_n(color, 1, 4, move, a, b, c, E) && play_attack_defend_n(color, 1, 3, move, a, c, D);
}

static int
autohelperpat710(int trans, int move, int color, int action)
{
  int d, A, B;
  UNUSED(color);
  UNUSED(action);

  d = AFFINE_TRANSFORM(758, trans, move);
  A = AFFINE_TRANSFORM(646, trans, move);
  B = AFFINE_TRANSFORM(757, trans, move);

  return  play_attack_defend_n(color, 1, 2, move, d, A) && play_attack_defend_n(color, 1, 1, d, B);
}

static int
autohelperpat711(int trans, int move, int color, int action)
{
  int a, B;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(611, trans, move);
  B = AFFINE_TRANSFORM(683, trans, move);

  return  play_attack_defend_n(color, 1, 2, move, a, B);
}

static int
autohelperpat713(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(609, trans, move);

  return  does_attack(move, A);
}

static int
autohelperpat714(int trans, int move, int color, int action)
{
  int b, c, d, e, f, A, G;
  UNUSED(color);

  b = AFFINE_TRANSFORM(722, trans, move);
  c = AFFINE_TRANSFORM(683, trans, move);
  d = AFFINE_TRANSFORM(795, trans, move);
  e = AFFINE_TRANSFORM(759, trans, move);
  f = AFFINE_TRANSFORM(796, trans, move);
  A = AFFINE_TRANSFORM(758, trans, move);
  G = AFFINE_TRANSFORM(719, trans, move);

  if (!action)
    return  (dragon[G].status == ALIVE) && !play_attack_defend_n(color, 0, 1, move, A) && play_attack_defend_n(OTHER_COLOR(color), 1, 2, move, b, c);
   add_antisuji_move(b); add_antisuji_move(d); add_antisuji_move(e); add_antisuji_move(f);;

  return 0;
}

static int
autohelperpat715(int trans, int move, int color, int action)
{
  int a, b, c, d, e, A;
  UNUSED(color);

  a = AFFINE_TRANSFORM(573, trans, move);
  b = AFFINE_TRANSFORM(611, trans, move);
  c = AFFINE_TRANSFORM(536, trans, move);
  d = AFFINE_TRANSFORM(537, trans, move);
  e = AFFINE_TRANSFORM(574, trans, move);
  A = AFFINE_TRANSFORM(646, trans, move);

  if (!action)
    return  (countlib(A)>1) && !play_attack_defend_n(color, 0, 3, move, a, b, a) && play_attack_defend_n(color, 1, 1, a, A);
   add_antisuji_move(a); add_antisuji_move(c); add_antisuji_move(d); add_antisuji_move(e);;

  return 0;
}

static int
autohelperpat717(int trans, int move, int color, int action)
{
  int a, b, c, d, e, F;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(685, trans, move);
  b = AFFINE_TRANSFORM(646, trans, move);
  c = AFFINE_TRANSFORM(722, trans, move);
  d = AFFINE_TRANSFORM(611, trans, move);
  e = AFFINE_TRANSFORM(686, trans, move);
  F = AFFINE_TRANSFORM(573, trans, move);

  return  !play_attack_defend_n(color, 1, 6, a, move, b, c, d, e, F);
}

static int
autohelperpat718(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);

   add_antisuji_move(a);;

  return 0;
}

static int
autohelperpat719(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(683, trans, move);

   add_antisuji_move(a);;

  return 0;
}

static int
autohelperpat721(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(685, trans, move);

  return  play_attack_defend_n(OTHER_COLOR(color), 0, 2, a, move, a);
}

static int
autohelperpat722(int trans, int move, int color, int action)
{
  int b, c, A;
  UNUSED(color);
  UNUSED(action);

  b = AFFINE_TRANSFORM(722, trans, move);
  c = AFFINE_TRANSFORM(721, trans, move);
  A = AFFINE_TRANSFORM(758, trans, move);

  return  !ATTACK_MACRO(A) && !play_attack_defend_n(color, 0, 3, move, b, c, b);
}

static int
autohelperpat723(int trans, int move, int color, int action)
{
  int a, B, C;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(722, trans, move);
  B = AFFINE_TRANSFORM(685, trans, move);
  C = AFFINE_TRANSFORM(721, trans, move);

  return (whose_territory(OPPOSITE_INFLUENCE(color), a) == OTHER_COLOR(color)) && !ATTACK_MACRO(B) && !ATTACK_MACRO(C) && !play_attack_defend_n(color, 1, 3, move, NO_MOVE, a, a)&& !play_attack_defend2_n(color, 0, 3, move, NO_MOVE, a, B, C);
}

static int
autohelperpat724(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(723, trans, move);

  add_antisuji_move(a);

  return 0;
}

static int
autohelperpat725(int trans, int move, int color, int action)
{
  int a, B;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(610, trans, move);
  B = AFFINE_TRANSFORM(683, trans, move);

  return play_attack_defend_n(OTHER_COLOR(color), 1, 2, move, a, B);
}

static int
autohelperpat726(int trans, int move, int color, int action)
{
  int a, B;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(610, trans, move);
  B = AFFINE_TRANSFORM(647, trans, move);

  return  !play_attack_defend_n(color, 1, 2, move, a, B);
}

static int
autohelperpat727(int trans, int move, int color, int action)
{
  int a, A;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(686, trans, move);
  A = AFFINE_TRANSFORM(648, trans, move);

  return  !ATTACK_MACRO(A) && !play_attack_defend_n(color, 1, 2, a, move, move);
}

static int
autohelperpat728(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(682, trans, move);

  return  !play_attack_defend_n(color, 1, 2, move, a, a);
}

static int
autohelperpat729(int trans, int move, int color, int action)
{
  int a, b, c, f, g;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(683, trans, move);
  b = AFFINE_TRANSFORM(646, trans, move);
  c = AFFINE_TRANSFORM(647, trans, move);
  f = AFFINE_TRANSFORM(795, trans, move);
  g = AFFINE_TRANSFORM(794, trans, move);

  return play_attack_defend2_n(color, 1, 4, move, a, b, c, a, c)&& !(whose_area(OPPOSITE_INFLUENCE(color), f) == color) && !(whose_area(OPPOSITE_INFLUENCE(color), g) == color);
}

static int
autohelperpat730(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(685, trans, move);
  b = AFFINE_TRANSFORM(722, trans, move);
  c = AFFINE_TRANSFORM(758, trans, move);

  return play_attack_defend2_n(OTHER_COLOR(color), 1, 4, move, a, b, c, a, c);
}

static int
autohelperpat731(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(685, trans, move);
  b = AFFINE_TRANSFORM(722, trans, move);
  c = AFFINE_TRANSFORM(758, trans, move);

  return play_attack_defend2_n(color, 1, 4, move, a, b, c, a, c);
}

static int
autohelperpat732(int trans, int move, int color, int action)
{
  int a, B;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(646, trans, move);
  B = AFFINE_TRANSFORM(721, trans, move);

  return  does_attack(a, B) && !play_attack_defend_n(OTHER_COLOR(color), 1, 1, a, B);
}

static int
autohelperpat733(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(611, trans, move);

   add_antisuji_move(a);;

  return 0;
}

static int
autohelperpat734(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);

  a = AFFINE_TRANSFORM(685, trans, move);
  b = AFFINE_TRANSFORM(647, trans, move);
  c = AFFINE_TRANSFORM(646, trans, move);
  d = AFFINE_TRANSFORM(610, trans, move);

  if (!action)
    return  play_attack_defend_n(color, 0, 5, a, move, b, c, d, c);
  add_antisuji_move(a);;

  return 0;
}

static int
autohelperpat735(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(687, trans, move);

  return  (dragon[a].status == DEAD);
}

static int
autohelperpat736(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);

   add_antisuji_move(a);

  return 0;
}

static int
autohelperpat737(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(646, trans, move);

  add_replacement_move(a, move, color);

  return 0;
}

static int
autohelperpat740(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(686, trans, move);
  b = AFFINE_TRANSFORM(649, trans, move);

  add_replacement_move(a, move, color);add_replacement_move(b, move, color);;

  return 0;
}

static int
autohelperpat741(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(723, trans, move);
  b = AFFINE_TRANSFORM(686, trans, move);

  add_replacement_move(a, move, color);add_replacement_move(b, move, color);;

  return 0;
}

static int
autohelperpat742(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);

  a = AFFINE_TRANSFORM(759, trans, move);
  b = AFFINE_TRANSFORM(685, trans, move);

  if (!action)
    return  countlib(a)>2;
   add_replacement_move(b, move, color);

  return 0;
}

static int
autohelperpat743(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);

  a = AFFINE_TRANSFORM(609, trans, move);
  b = AFFINE_TRANSFORM(757, trans, move);

  if (!action)
    return  (dragon[b].status == ALIVE);
   add_replacement_move(a, move, color);

  return 0;
}

static int
autohelperpat744(int trans, int move, int color, int action)
{
  int a, b, c, d, e, f, h;
  UNUSED(color);

  a = AFFINE_TRANSFORM(647, trans, move);
  b = AFFINE_TRANSFORM(648, trans, move);
  c = AFFINE_TRANSFORM(611, trans, move);
  d = AFFINE_TRANSFORM(685, trans, move);
  e = AFFINE_TRANSFORM(612, trans, move);
  f = AFFINE_TRANSFORM(610, trans, move);
  h = AFFINE_TRANSFORM(573, trans, move);

  if (!action)
    return  play_attack_defend_n(color, 1, 6, move, a, b, c, d, e, e) && !play_attack_defend_n(color, 1, 7, move, a, b, c, d, f, e, h);
   add_replacement_move(b, move, color);

  return 0;
}

static int
autohelperpat745(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(536, trans, move);

  return !play_connect_n(color, 0, 1, move, move, a);
}

static int
autohelperpat746(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(683, trans, move);

  return  countlib(A)>2;
}

static int
autohelperpat747(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(720, trans, move);

   add_replacement_move(a, move, color);

  return 0;
}

static int
autohelperpat748(int trans, int move, int color, int action)
{
  int a, B;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);
  B = AFFINE_TRANSFORM(795, trans, move);

  return !ATTACK_MACRO(B) && safe_move(a, OTHER_COLOR(color));
}

static int
autohelperpat749(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(646, trans, move);

  return !dragon_weak(a);
}

static int
autohelperpat750(int trans, int move, int color, int action)
{
  int a, b, c, d, e, f, g, h;
  UNUSED(color);

  a = AFFINE_TRANSFORM(760, trans, move);
  b = AFFINE_TRANSFORM(797, trans, move);
  c = AFFINE_TRANSFORM(723, trans, move);
  d = AFFINE_TRANSFORM(796, trans, move);
  e = AFFINE_TRANSFORM(722, trans, move);
  f = AFFINE_TRANSFORM(647, trans, move);
  g = AFFINE_TRANSFORM(685, trans, move);
  h = AFFINE_TRANSFORM(648, trans, move);

  if (!action)
    return !play_connect_n(color, 1, 8, a, b, c, d, NO_MOVE, g, NO_MOVE, h, e, f);
   add_replacement_move(a, move, color);

  return 0;
}

static int
autohelperpat751(int trans, int move, int color, int action)
{
  int a, c, d, B;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(610, trans, move);
  c = AFFINE_TRANSFORM(499, trans, move);
  d = AFFINE_TRANSFORM(500, trans, move);
  B = AFFINE_TRANSFORM(758, trans, move);

  return dragon_weak(a) && dragon_weak(B) && somewhere(OTHER_COLOR(color), 0, 2, c, d);
}

static int
autohelperpat752(int trans, int move, int color, int action)
{
  int b, c, A;
  UNUSED(color);
  UNUSED(action);

  b = AFFINE_TRANSFORM(758, trans, move);
  c = AFFINE_TRANSFORM(759, trans, move);
  A = AFFINE_TRANSFORM(610, trans, move);

  return somewhere(OTHER_COLOR(color), 1, 2, b, c) && dragon_weak(A);
}

static int
autohelperpat753(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(756, trans, move);

  return  dragon_weak(A);
}

static int
autohelperpat755(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(683, trans, move);

  return dragon_weak(a);
}

static int
autohelperpat757(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(722, trans, move);

  return !play_attack_defend_n(color, 1, 1, move, a);
}

static int
autohelperpat758(int trans, int move, int color, int action)
{
  int A, B;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(646, trans, move);
  B = AFFINE_TRANSFORM(720, trans, move);

  return dragon_weak(A) || dragon_weak(B) || !(whose_territory(OPPOSITE_INFLUENCE(color), move) == OTHER_COLOR(color));
}

static int
autohelperpat762(int trans, int move, int color, int action)
{
  int a, b, c, D, E;
  UNUSED(color);

  a = AFFINE_TRANSFORM(722, trans, move);
  b = AFFINE_TRANSFORM(721, trans, move);
  c = AFFINE_TRANSFORM(648, trans, move);
  D = AFFINE_TRANSFORM(683, trans, move);
  E = AFFINE_TRANSFORM(685, trans, move);

  if (!action)
    return countlib(E)==2 && !play_attack_defend_n(color, 1, 1, move, c) && !play_attack_defend2_n(color, 0, 3, move, a, b, E, D);
  test_attack_either_move(move, color, D, E);;

  return 0;
}

static int
autohelperpat763(int trans, int move, int color, int action)
{
  int a, B;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);
  B = AFFINE_TRANSFORM(757, trans, move);

  return !ATTACK_MACRO(B) && play_attack_defend_n(color, 1, 2, move, a, B);
}

static int
autohelperpat767(int trans, int move, int color, int action)
{
  int b, c, d, e, f, g, h, i;
  UNUSED(color);
  UNUSED(action);

  b = AFFINE_TRANSFORM(683, trans, move);
  c = AFFINE_TRANSFORM(721, trans, move);
  d = AFFINE_TRANSFORM(758, trans, move);
  e = AFFINE_TRANSFORM(759, trans, move);
  f = AFFINE_TRANSFORM(682, trans, move);
  g = AFFINE_TRANSFORM(645, trans, move);
  h = AFFINE_TRANSFORM(722, trans, move);
  i = AFFINE_TRANSFORM(646, trans, move);

  return play_attack_defend_n(color, 1, 5, move, b, c, d, e, d) && play_attack_defend_n(color, 1, 5, move, b, c, d, e, h)&& play_attack_defend_n(color, 1, 5, move, c, b, f, g, f) && play_attack_defend_n(color, 1, 5, move, c, b, f, g, i);
}

static int
autohelperpat768(int trans, int move, int color, int action)
{
  int a, b, c, A;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(720, trans, move);
  b = AFFINE_TRANSFORM(722, trans, move);
  c = AFFINE_TRANSFORM(647, trans, move);
  A = AFFINE_TRANSFORM(721, trans, move);

  return countlib(A)==2 && countlib(a)>1 && countlib(b)>1 && is_proper_eye_space(c);
}

static int
autohelperpat769(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(646, trans, move);

  return countlib(a)==3;
}

static int
autohelperpat770(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);

  a = AFFINE_TRANSFORM(646, trans, move);
  b = AFFINE_TRANSFORM(610, trans, move);

  if (!action)
    return ATTACK_MACRO(b) && !DEFEND_MACRO(b) && !play_attack_defend_n(color, 1, 1, move, a);
  threaten_to_save_helper(move,b);;

  return 0;
}

static int
autohelperpat771(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);

  a = AFFINE_TRANSFORM(648, trans, move);
  b = AFFINE_TRANSFORM(722, trans, move);

  if (!action)
    return ATTACK_MACRO(a) && !DEFEND_MACRO(a) && !(dragon[b].status == DEAD);
  threaten_to_save_helper(move,a);;

  return 0;
}

static int
autohelperpat773(int trans, int move, int color, int action)
{
  int a, b, C;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(648, trans, move);
  b = AFFINE_TRANSFORM(722, trans, move);
  C = AFFINE_TRANSFORM(685, trans, move);

  return !doing_scoring && (!is_same_dragon(a, b) || worm[C].cutstone2 > 1);
}

static int
autohelperpat774(int trans, int move, int color, int action)
{
  int a, b, c, d, e, f, A;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(683, trans, move);
  b = AFFINE_TRANSFORM(720, trans, move);
  c = AFFINE_TRANSFORM(721, trans, move);
  d = AFFINE_TRANSFORM(758, trans, move);
  e = AFFINE_TRANSFORM(722, trans, move);
  f = AFFINE_TRANSFORM(757, trans, move);
  A = AFFINE_TRANSFORM(682, trans, move);

  return (countlib(A)>1) && play_attack_defend_n(color, 1, 6, move, a, b, c, d, e, f);
}

static int
autohelperpat775(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);
  b = AFFINE_TRANSFORM(721, trans, move);
  c = AFFINE_TRANSFORM(646, trans, move);
  d = AFFINE_TRANSFORM(648, trans, move);

  return play_attack_defend_n(color, 1, 2, move, b, b)&& !play_attack_defend_n(color, 1, 5, move, a, b, a, c, c) && !play_attack_defend_n(color, 1, 5, move, a, b, a, d, d);
}

static int
autohelperpat776(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);

  return  does_attack(move, a);
}

static int
autohelperpat777(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(646, trans, move);

  return countlib(A)>1 || !play_attack_defend_n(color, 0, 1, move, A);
}

static int
autohelperpat778(int trans, int move, int color, int action)
{
  int b, A;
  UNUSED(color);
  UNUSED(action);

  b = AFFINE_TRANSFORM(645, trans, move);
  A = AFFINE_TRANSFORM(646, trans, move);

  return  countlib(A)==1 && countlib(b)>1 && does_attack(move, A);
}

static int
autohelperpat779(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(682, trans, move);
  b = AFFINE_TRANSFORM(609, trans, move);

  return  (dragon[b].status == ALIVE) && ATTACK_MACRO(a) && !DEFEND_MACRO(a);
}

static int
autohelperpat780(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(648, trans, move);

  return  !ATTACK_MACRO(a);
}

static int
autohelperpat782(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(609, trans, move);

  return  !play_attack_defend2_n(OTHER_COLOR(color), 1, 3, move, NO_MOVE, a, move, a);
}

static int
autohelperpat783(int trans, int move, int color, int action)
{
  int b, c, d, e, D, E, F;
  UNUSED(color);
  UNUSED(action);

  b = AFFINE_TRANSFORM(721, trans, move);
  c = AFFINE_TRANSFORM(685, trans, move);
  d = AFFINE_TRANSFORM(686, trans, move);
  e = AFFINE_TRANSFORM(758, trans, move);
  D = AFFINE_TRANSFORM(648, trans, move);
  E = AFFINE_TRANSFORM(722, trans, move);
  F = AFFINE_TRANSFORM(720, trans, move);

  return  play_break_through_n(color, 4, move, b, c, d, D, d, E) && play_break_through_n(color, 4, move, c, b, e, F, e, E);
}

static int
autohelperpat784(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(759, trans, move);
  b = AFFINE_TRANSFORM(796, trans, move);
  c = AFFINE_TRANSFORM(833, trans, move);
  d = AFFINE_TRANSFORM(870, trans, move);

  return  somewhere(OTHER_COLOR(color), 1, 4, a, b, c, d);
}

static int
autohelperpat785(int trans, int move, int color, int action)
{
  int a, b, c, d, e, f;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(759, trans, move);
  b = AFFINE_TRANSFORM(796, trans, move);
  c = AFFINE_TRANSFORM(833, trans, move);
  d = AFFINE_TRANSFORM(870, trans, move);
  e = AFFINE_TRANSFORM(648, trans, move);
  f = AFFINE_TRANSFORM(612, trans, move);

  return  somewhere(OTHER_COLOR(color), 1, 4, a, b, c, d) && play_connect_n(color, 1, 2, move, e, move, f);
}

static int
autohelperpat787(int trans, int move, int color, int action)
{
  int a, B;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(685, trans, move);
  B = AFFINE_TRANSFORM(647, trans, move);

  return  play_attack_defend_n(color, 1, 2, move, a, B);
}

static int
autohelperpat788(int trans, int move, int color, int action)
{
  int A, B;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(683, trans, move);
  B = AFFINE_TRANSFORM(647, trans, move);

  return !doing_scoring && !ATTACK_MACRO(A) && !ATTACK_MACRO(B) && (whose_territory(OPPOSITE_INFLUENCE(color), move) == OTHER_COLOR(color));
}

static int
autohelperpat789(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(722, trans, move);
  b = AFFINE_TRANSFORM(723, trans, move);
  c = AFFINE_TRANSFORM(686, trans, move);

  return  play_attack_defend_n(OTHER_COLOR(color), 1, 3, a, b, c, c) && !play_attack_defend_n(color, 1, 4, move, a, b, c, c);
}

static int
autohelperpat790(int trans, int move, int color, int action)
{
  int b, A;
  UNUSED(color);
  UNUSED(action);

  b = AFFINE_TRANSFORM(648, trans, move);
  A = AFFINE_TRANSFORM(686, trans, move);

  return countlib(b)>1 && (dragon[b].status == ALIVE) && ATTACK_MACRO(A) && !DEFEND_MACRO(A);
}

static int
autohelperpat791(int trans, int move, int color, int action)
{
  int b, A;
  UNUSED(color);
  UNUSED(action);

  b = AFFINE_TRANSFORM(648, trans, move);
  A = AFFINE_TRANSFORM(686, trans, move);

  return countlib(b)>1 && ATTACK_MACRO(A) && !DEFEND_MACRO(A);
}

static int
autohelperpat792(int trans, int move, int color, int action)
{
  int b, A;
  UNUSED(color);
  UNUSED(action);

  b = AFFINE_TRANSFORM(721, trans, move);
  A = AFFINE_TRANSFORM(683, trans, move);

  return  (dragon[A].status == DEAD) && dragon[A].effective_size>8 && countlib(b)<=4;
}

static int
autohelperpat793(int trans, int move, int color, int action)
{
  int a, b, c, A;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);
  b = AFFINE_TRANSFORM(648, trans, move);
  c = AFFINE_TRANSFORM(685, trans, move);
  A = AFFINE_TRANSFORM(611, trans, move);

  return  !(dragon[A].status == DEAD) && play_attack_defend_n(color, 1, 4, move, a, b, c, c);
}

static int
autohelperpat795(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);
  b = AFFINE_TRANSFORM(685, trans, move);
  c = AFFINE_TRANSFORM(683, trans, move);

  return countlib(a)==1 && ((dragon[b].status == ALIVE) || (dragon[c].status == ALIVE))&& (play_attack_defend_n(OTHER_COLOR(color), 1, 1, move, b) || play_attack_defend_n(OTHER_COLOR(color), 1, 1, move, c));
}

static int
autohelperpat800(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(612, trans, move);

  add_antisuji_move(a);;

  return 0;
}

static int
autohelperpat802(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(683, trans, move);

  return !dragon_weak(A);
}

static int
autohelperpat806(int trans, int move, int color, int action)
{
  int c, e, g, B, D, F, H, I;
  UNUSED(color);
  UNUSED(action);

  c = AFFINE_TRANSFORM(646, trans, move);
  e = AFFINE_TRANSFORM(645, trans, move);
  g = AFFINE_TRANSFORM(610, trans, move);
  B = AFFINE_TRANSFORM(683, trans, move);
  D = AFFINE_TRANSFORM(647, trans, move);
  F = AFFINE_TRANSFORM(721, trans, move);
  H = AFFINE_TRANSFORM(685, trans, move);
  I = AFFINE_TRANSFORM(609, trans, move);

  return play_attack_defend_n(color, 1, 5, move, B, c, D, e, B) && play_attack_defend_n(color, 1, 8, move, B, c, D, e, F, g, H, I);;
}

static int
autohelperpat807(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(682, trans, move);

  return !(whose_moyo(OPPOSITE_INFLUENCE(color), a) == OTHER_COLOR(color));
}

static int
autohelperpat808(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(536, trans, move);

  return !dragon_weak(a);
}

static int
autohelperpat809(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(682, trans, move);

  return !(whose_moyo(OPPOSITE_INFLUENCE(color), a) == OTHER_COLOR(color));
}

static int
autohelperpat810(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(612, trans, move);

  return !(whose_moyo(OPPOSITE_INFLUENCE(color), a) == OTHER_COLOR(color));
}

static int
autohelperpat812(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(794, trans, move);
  b = AFFINE_TRANSFORM(758, trans, move);
  c = AFFINE_TRANSFORM(722, trans, move);

  add_antisuji_move(a);add_antisuji_move(b);add_antisuji_move(c);;

  return 0;
}

static int
autohelperpat813(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(796, trans, move);
  b = AFFINE_TRANSFORM(760, trans, move);
  c = AFFINE_TRANSFORM(724, trans, move);

  add_antisuji_move(a);add_antisuji_move(b);add_antisuji_move(c);;

  return 0;
}

static int
autohelperpat814(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(794, trans, move);
  b = AFFINE_TRANSFORM(758, trans, move);
  c = AFFINE_TRANSFORM(722, trans, move);

  add_antisuji_move(a);add_antisuji_move(b);add_antisuji_move(c);;

  return 0;
}

static int
autohelperpat824(int trans, int move, int color, int action)
{
  int a, b, e, C, D;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(573, trans, move);
  b = AFFINE_TRANSFORM(721, trans, move);
  e = AFFINE_TRANSFORM(611, trans, move);
  C = AFFINE_TRANSFORM(647, trans, move);
  D = AFFINE_TRANSFORM(645, trans, move);

  add_connection_move(move,a, b);add_cut_move(move, C, D);add_antisuji_move(e);;

  return 0;
}

static int
autohelperpat825(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(608, trans, move);
  b = AFFINE_TRANSFORM(756, trans, move);

  return !(whose_area(OPPOSITE_INFLUENCE(color), a) == color) && !(whose_moyo(OPPOSITE_INFLUENCE(color), b) == OTHER_COLOR(color));
}

static int
autohelperpat826(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(571, trans, move);
  b = AFFINE_TRANSFORM(719, trans, move);

  return !(whose_area(OPPOSITE_INFLUENCE(color), a) == color) && !(whose_moyo(OPPOSITE_INFLUENCE(color), b) == OTHER_COLOR(color));
}

static int
autohelperpat831(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(537, trans, move);

   add_antisuji_move(a);

  return 0;
}

static int
autohelperpat833(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(648, trans, move);

  add_antisuji_move(a);;

  return 0;
}

static int
autohelperpat837(int trans, int move, int color, int action)
{
  int a, B;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(686, trans, move);
  B = AFFINE_TRANSFORM(722, trans, move);

  return  !safe_move(a, color) && !play_attack_defend_n(color, 1, 1, move, B);
}

static int
autohelperpat839(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(868, trans, move);
  b = AFFINE_TRANSFORM(905, trans, move);
  c = AFFINE_TRANSFORM(869, trans, move);
  d = AFFINE_TRANSFORM(906, trans, move);

  return  somewhere(OTHER_COLOR(color), 1, 4, a, b, c, d);
}

static int
autohelperpat840(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(687, trans, move);
  b = AFFINE_TRANSFORM(612, trans, move);

  add_antisuji_move(a);add_antisuji_move(b);;

  return 0;
}

static int
autohelperpat842(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(648, trans, move);

  return  !ATTACK_MACRO(A);
}

static int
autohelperpat846(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(796, trans, move);
  b = AFFINE_TRANSFORM(833, trans, move);
  c = AFFINE_TRANSFORM(797, trans, move);

  return  somewhere(OTHER_COLOR(color), 1, 3, a, b, c);
}

static int
autohelperpat847(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(757, trans, move);
  b = AFFINE_TRANSFORM(794, trans, move);
  c = AFFINE_TRANSFORM(758, trans, move);
  d = AFFINE_TRANSFORM(795, trans, move);

  return  somewhere(color, 1, 4, a, b, c, d);
}

static int
autohelperpat848(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(647, trans, move);

  return !ATTACK_MACRO(A);
}

static int
autohelperpat850(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(685, trans, move);

  return  owl_threatens_attack(move, A);
}

static int
autohelperpat851(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(758, trans, move);

  return  owl_threatens_attack(move, A);
}

static int
autohelperpat852(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(609, trans, move);

  return owl_threatens_attack(move, a);
}

static int
autohelperpat853(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(609, trans, move);

  return (dragon[a].status == CRITICAL);
}

static int
autohelperpat854(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(572, trans, move);

  return owl_threatens_attack(move, a);
}

static int
autohelperpat855(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(572, trans, move);

  return (dragon[a].status == CRITICAL);
}

static int
autohelperpat856(int trans, int move, int color, int action)
{
  int a, B;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(646, trans, move);
  B = AFFINE_TRANSFORM(572, trans, move);

  return  !play_attack_defend_n(color, 1, 2, a, move, B);
}

static int
autohelperpat857(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(426, trans, move);

  return  !ATTACK_MACRO(a);
}

static int
autohelperpat858(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(463, trans, move);

  return  !ATTACK_MACRO(a);
}

static int
autohelperpat866(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(758, trans, move);
  b = AFFINE_TRANSFORM(795, trans, move);

  return  somewhere(color, 1, 2, a, b);
}

static int
autohelperpat868(int trans, int move, int color, int action)
{
  int a, b, c, d, e;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(645, trans, move);
  b = AFFINE_TRANSFORM(682, trans, move);
  c = AFFINE_TRANSFORM(574, trans, move);
  d = AFFINE_TRANSFORM(611, trans, move);
  e = AFFINE_TRANSFORM(575, trans, move);

  return  somewhere(color, 1, 2, a, b) && somewhere(OTHER_COLOR(color), 1, 3, c, d, e);
}

static int
autohelperpat870(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(791, trans, move);
  b = AFFINE_TRANSFORM(790, trans, move);
  c = AFFINE_TRANSFORM(686, trans, move);
  d = AFFINE_TRANSFORM(723, trans, move);

  return  somewhere(OTHER_COLOR(color), 1, 2, a, b) && somewhere(OTHER_COLOR(color), 1, 2, c, d);
}

static int
autohelperpat872(int trans, int move, int color, int action)
{
  int b, A;
  UNUSED(color);
  UNUSED(action);

  b = AFFINE_TRANSFORM(795, trans, move);
  A = AFFINE_TRANSFORM(758, trans, move);

  return visible_along_edge(OTHER_COLOR(color),A,b);
}

static int
autohelperpat873(int trans, int move, int color, int action)
{
  int a, b, c, d, e, f;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(832, trans, move);
  b = AFFINE_TRANSFORM(869, trans, move);
  c = AFFINE_TRANSFORM(906, trans, move);
  d = AFFINE_TRANSFORM(831, trans, move);
  e = AFFINE_TRANSFORM(868, trans, move);
  f = AFFINE_TRANSFORM(905, trans, move);

  return somewhere(color, 0, 6, a, b, c, d, e, f);
}

static int
autohelperpat874(int trans, int move, int color, int action)
{
  int b, A;
  UNUSED(color);
  UNUSED(action);

  b = AFFINE_TRANSFORM(647, trans, move);
  A = AFFINE_TRANSFORM(610, trans, move);

  return visible_along_edge(color,A,b);
}

static int
autohelperpat875(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(682, trans, move);

  return  !(dragon[A].status == DEAD);
}

static int
autohelperpat876(int trans, int move, int color, int action)
{
  int a, b, c, d, e, f;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(687, trans, move);
  b = AFFINE_TRANSFORM(723, trans, move);
  c = AFFINE_TRANSFORM(721, trans, move);
  d = AFFINE_TRANSFORM(724, trans, move);
  e = AFFINE_TRANSFORM(760, trans, move);
  f = AFFINE_TRANSFORM(650, trans, move);

  add_replacement_move(a, move, color);add_replacement_move(b, move, color);add_replacement_move(c, move, color);add_replacement_move(d, move, color);add_replacement_move(e, move, color);add_replacement_move(f, move, color);;

  return 0;
}

static int
autohelperpat878(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(757, trans, move);
  b = AFFINE_TRANSFORM(794, trans, move);
  c = AFFINE_TRANSFORM(758, trans, move);
  d = AFFINE_TRANSFORM(795, trans, move);

  return  somewhere(color, 1, 4, a, b, c, d);
}

static int
autohelperpat884(int trans, int move, int color, int action)
{
  int a, b, c, d, e, f, g, h, i;
  UNUSED(color);

  a = AFFINE_TRANSFORM(426, trans, move);
  b = AFFINE_TRANSFORM(463, trans, move);
  c = AFFINE_TRANSFORM(500, trans, move);
  d = AFFINE_TRANSFORM(427, trans, move);
  e = AFFINE_TRANSFORM(464, trans, move);
  f = AFFINE_TRANSFORM(501, trans, move);
  g = AFFINE_TRANSFORM(537, trans, move);
  h = AFFINE_TRANSFORM(761, trans, move);
  i = AFFINE_TRANSFORM(648, trans, move);

  if (!action)
    return  somewhere(color, 1, 7, a, b, c, d, e, f, g);
   add_replacement_move(h, move, color); add_replacement_move(i, move, color);

  return 0;
}

static int
autohelperpat885(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(723, trans, move);
  b = AFFINE_TRANSFORM(686, trans, move);
  c = AFFINE_TRANSFORM(649, trans, move);

   add_replacement_move(a, move, color); add_replacement_move(b, move, color); add_replacement_move(c, move, color);

  return 0;
}

static int
autohelperpat886(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(609, trans, move);

   add_replacement_move(a, move, color);

  return 0;
}

static int
autohelperpat888(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(757, trans, move);

  return  !play_attack_defend_n(color, 0, 1, move, A);
}

static int
autohelperpat889(int trans, int move, int color, int action)
{
  int a, b, c, d, e;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(573, trans, move);
  b = AFFINE_TRANSFORM(610, trans, move);
  c = AFFINE_TRANSFORM(574, trans, move);
  d = AFFINE_TRANSFORM(611, trans, move);
  e = AFFINE_TRANSFORM(648, trans, move);

  return  somewhere(color, 1, 5, a, b, c, d, e);
}

static int
autohelperpat891(int trans, int move, int color, int action)
{
  int a, b, c, d, e;
  UNUSED(color);

  a = AFFINE_TRANSFORM(758, trans, move);
  b = AFFINE_TRANSFORM(795, trans, move);
  c = AFFINE_TRANSFORM(759, trans, move);
  d = AFFINE_TRANSFORM(796, trans, move);
  e = AFFINE_TRANSFORM(612, trans, move);

  if (!action)
    return  somewhere(color, 0, 4, a, b, c, d);
   add_replacement_move(e, move, color);

  return 0;
}

static int
autohelperpat894(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(645, trans, move);

  return countlib(A)==3 && seki_helper(A);
}

static int
autohelperpat895(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(682, trans, move);

  return countlib(a)<=3 && seki_helper(a);
}

static int
autohelperpat896(int trans, int move, int color, int action)
{
  int b, A;
  UNUSED(color);

  b = AFFINE_TRANSFORM(648, trans, move);
  A = AFFINE_TRANSFORM(609, trans, move);

  if (!action)
    return countlib(A)==5 && seki_helper(A);
  add_replacement_move(b, move, color);

  return 0;
}

static int
autohelperpat897(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(609, trans, move);

  return countlib(a)==5 && seki_helper(a);
}

static int
autohelperpat898(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(646, trans, move);

  return countlib(a)==5 && seki_helper(a);
}

static int
autohelperpat899(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(645, trans, move);

  return countlib(A)==4 && seki_helper(A);
}

static int
autohelperpat900(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(644, trans, move);

  return countlib(A)==3 && seki_helper(A);
}

static int
autohelperpat901(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(607, trans, move);

  return countlib(a)==3 && seki_helper(a);
}

static int
autohelperpat902(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(645, trans, move);

  return countlib(a)==4 && seki_helper(a);
}

static int
autohelperpat903(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(645, trans, move);

  return countlib(A)==4 && seki_helper(A);
}

static int
autohelperpat904(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(645, trans, move);

  return countlib(a)==4 && seki_helper(a);
}

static int
autohelperpat905(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(645, trans, move);

  return countlib(A)==4 && seki_helper(A);
}

static int
autohelperpat906(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);

  a = AFFINE_TRANSFORM(608, trans, move);
  b = AFFINE_TRANSFORM(610, trans, move);

  if (!action)
    return countlib(a)==4 && seki_helper(a);
  add_replacement_move(b, move, color);;

  return 0;
}

static int
autohelperpat907(int trans, int move, int color, int action)
{
  int b, c, A;
  UNUSED(color);

  b = AFFINE_TRANSFORM(610, trans, move);
  c = AFFINE_TRANSFORM(648, trans, move);
  A = AFFINE_TRANSFORM(608, trans, move);

  if (!action)
    return countlib(A)==4 && seki_helper(A);
  add_replacement_move(b, move, color);add_replacement_move(c, move, color);;

  return 0;
}

static int
autohelperpat908(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(685, trans, move);

  add_replacement_move(a, move, color);;

  return 0;
}

static int
autohelperpat909(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(645, trans, move);

  return countlib(a)==4 && seki_helper(a);
}

static int
autohelperpat910(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(645, trans, move);

  return countlib(A)==5 && seki_helper(A);
}

static int
autohelperpat911(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(645, trans, move);

  return countlib(a)==5 && seki_helper(a);
}

static int
autohelperpat912(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);

   add_replacement_move(a, move, color);;

  return 0;
}

static int
autohelperpat913(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(644, trans, move);

  return countlib(A)==4 && seki_helper(A);
}

static int
autohelperpat914(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(644, trans, move);

  return countlib(a)==4 && seki_helper(a);
}

static int
autohelperpat937(int trans, int move, int color, int action)
{
  UNUSED(trans);
  UNUSED(color);
  UNUSED(action);

  UNUSED(move);

  return !doing_scoring;
}

static int
autohelperpat941(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(646, trans, move);
  b = AFFINE_TRANSFORM(647, trans, move);
  c = AFFINE_TRANSFORM(609, trans, move);

  return !play_connect_n(color, 0, 3, move, a, b, move, c);
}

static int
autohelperpat942(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(611, trans, move);
  b = AFFINE_TRANSFORM(683, trans, move);
  c = AFFINE_TRANSFORM(646, trans, move);
  d = AFFINE_TRANSFORM(720, trans, move);

  return  (whose_moyo(OPPOSITE_INFLUENCE(color), a) == color) && !(somewhere(color, 1, 1, b) && somewhere(color, 1, 2, c, d));
}

static int
autohelperpat945(int trans, int move, int color, int action)
{
  int A, B;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(647, trans, move);
  B = AFFINE_TRANSFORM(683, trans, move);

  return (whose_moyo(OPPOSITE_INFLUENCE(color), move) == OTHER_COLOR(color)) && !ATTACK_MACRO(A) && !ATTACK_MACRO(B)&& safe_move(move, color) && play_attack_defend2_n(color, 1, 1, move, A, B);
}

static int
autohelperpat947(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(682, trans, move);

  return  play_attack_defend_n(color, 1, 2, move, a, a);
}

static int
autohelperpat948(int trans, int move, int color, int action)
{
  UNUSED(trans);
  UNUSED(color);
  UNUSED(action);

  UNUSED(move);

  return !(whose_territory(OPPOSITE_INFLUENCE(color), move) == color);
}

static int
autohelperpat949(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(683, trans, move);

   add_replacement_move(a, move, color);

  return 0;
}

static int
autohelperpat950(int trans, int move, int color, int action)
{
  int a, A;
  UNUSED(color);

  a = AFFINE_TRANSFORM(721, trans, move);
  A = AFFINE_TRANSFORM(647, trans, move);

  if (!action)
    return  countlib(A)==1;
   add_replacement_move(a, move, color);

  return 0;
}

static int
autohelperpat951(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(722, trans, move);

   add_replacement_move(a, move, color);

  return 0;
}

static int
autohelperpat952(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(683, trans, move);

   add_replacement_move(a, move, color);

  return 0;
}

static int
autohelperpat953(int trans, int move, int color, int action)
{
  int a, B;
  UNUSED(color);

  a = AFFINE_TRANSFORM(721, trans, move);
  B = AFFINE_TRANSFORM(723, trans, move);

  if (!action)
    return  countlib(B) == 1;
   add_replacement_move(a, move, color);

  return 0;
}

static int
autohelperpat954(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(686, trans, move);

   add_replacement_move(a, move, color);

  return 0;
}

static int
autohelperpat955(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);

   add_replacement_move(a, move, color);

  return 0;
}

static int
autohelperpat956(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);

  a = AFFINE_TRANSFORM(609, trans, move);
  b = AFFINE_TRANSFORM(685, trans, move);

  if (!action)
    return  !(dragon[b].status == DEAD);
   add_replacement_move(a, move, color);

  return 0;
}

static int
autohelperpat957(int trans, int move, int color, int action)
{
  int a, c, B;
  UNUSED(color);

  a = AFFINE_TRANSFORM(645, trans, move);
  c = AFFINE_TRANSFORM(610, trans, move);
  B = AFFINE_TRANSFORM(609, trans, move);

  if (!action)
    return  countlib(a)==2 && countlib(B)>=2 && !play_attack_defend_n(color, 1, 1, move, a);
   add_replacement_move(c, move, color);

  return 0;
}

static int
autohelperpat958(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);

  a = AFFINE_TRANSFORM(647, trans, move);
  b = AFFINE_TRANSFORM(721, trans, move);

  if (!action)
    return play_attack_defend_n(color, 1, 2, move, b, move) && play_attack_defend_n(color, 0, 2, move, b, move);
  backfill_replace(move, a);

  return 0;
}

static int
autohelperpat959(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);

  a = AFFINE_TRANSFORM(687, trans, move);
  b = AFFINE_TRANSFORM(685, trans, move);

  if (!action)
    return accuratelib(a, color, MAX_LIBERTIES, NULL)==2 && !play_attack_defend_n(color, 1, 2, a, b, b);
  add_replacement_move(a, move, color);

  return 0;
}

static int
autohelperpat966(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(757, trans, move);
  b = AFFINE_TRANSFORM(758, trans, move);

  return somewhere(color, 0, 2, a, b);
}

static int
autohelperpat967(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(795, trans, move);
  b = AFFINE_TRANSFORM(796, trans, move);

  return somewhere(color, 0, 2, a, b);
}

static int
autohelperpat984(int trans, int move, int color, int action)
{
  int b, c, d, e, f, g, h, i, j, k, l, m, n, p, q, A;
  UNUSED(color);
  UNUSED(action);

  b = AFFINE_TRANSFORM(682, trans, move);
  c = AFFINE_TRANSFORM(721, trans, move);
  d = AFFINE_TRANSFORM(645, trans, move);
  e = AFFINE_TRANSFORM(720, trans, move);
  f = AFFINE_TRANSFORM(646, trans, move);
  g = AFFINE_TRANSFORM(719, trans, move);
  h = AFFINE_TRANSFORM(647, trans, move);
  i = AFFINE_TRANSFORM(681, trans, move);
  j = AFFINE_TRANSFORM(685, trans, move);
  k = AFFINE_TRANSFORM(648, trans, move);
  l = AFFINE_TRANSFORM(718, trans, move);
  m = AFFINE_TRANSFORM(644, trans, move);
  n = AFFINE_TRANSFORM(722, trans, move);
  p = AFFINE_TRANSFORM(610, trans, move);
  q = AFFINE_TRANSFORM(756, trans, move);
  A = AFFINE_TRANSFORM(683, trans, move);

  return play_attack_defend_n(color, 1, 16, move, b, c, d, e, f, g, h, i, j, k, l, m, n, p, q, A) && break_mirror_helper(A, color);
}

static int
autohelperpat985(int trans, int move, int color, int action)
{
  int d, e, f, g, h, i, j, k, l, m, n, p, q, A;
  UNUSED(color);
  UNUSED(action);

  d = AFFINE_TRANSFORM(608, trans, move);
  e = AFFINE_TRANSFORM(683, trans, move);
  f = AFFINE_TRANSFORM(609, trans, move);
  g = AFFINE_TRANSFORM(682, trans, move);
  h = AFFINE_TRANSFORM(610, trans, move);
  i = AFFINE_TRANSFORM(644, trans, move);
  j = AFFINE_TRANSFORM(648, trans, move);
  k = AFFINE_TRANSFORM(611, trans, move);
  l = AFFINE_TRANSFORM(681, trans, move);
  m = AFFINE_TRANSFORM(607, trans, move);
  n = AFFINE_TRANSFORM(685, trans, move);
  p = AFFINE_TRANSFORM(573, trans, move);
  q = AFFINE_TRANSFORM(719, trans, move);
  A = AFFINE_TRANSFORM(646, trans, move);

  return play_attack_defend_n(color, 1, 14, move, d, e, f, g, h, i, j, k, l, m, n, p, q, A) && break_mirror_helper(A, color);
}

static int
autohelperpat986(int trans, int move, int color, int action)
{
  int f, g, h, i, j, k, l, m, n, p, q, A;
  UNUSED(color);
  UNUSED(action);

  f = AFFINE_TRANSFORM(610, trans, move);
  g = AFFINE_TRANSFORM(683, trans, move);
  h = AFFINE_TRANSFORM(611, trans, move);
  i = AFFINE_TRANSFORM(645, trans, move);
  j = AFFINE_TRANSFORM(649, trans, move);
  k = AFFINE_TRANSFORM(612, trans, move);
  l = AFFINE_TRANSFORM(682, trans, move);
  m = AFFINE_TRANSFORM(608, trans, move);
  n = AFFINE_TRANSFORM(686, trans, move);
  p = AFFINE_TRANSFORM(574, trans, move);
  q = AFFINE_TRANSFORM(720, trans, move);
  A = AFFINE_TRANSFORM(647, trans, move);

  return play_attack_defend_n(color, 1, 12, move, f, g, h, i, j, k, l, m, n, p, q, A) && break_mirror_helper(A, color);
}

static int
autohelperpat987(int trans, int move, int color, int action)
{
  int h, i, j, k, l, m, n, p, q, A;
  UNUSED(color);
  UNUSED(action);

  h = AFFINE_TRANSFORM(612, trans, move);
  i = AFFINE_TRANSFORM(646, trans, move);
  j = AFFINE_TRANSFORM(650, trans, move);
  k = AFFINE_TRANSFORM(613, trans, move);
  l = AFFINE_TRANSFORM(683, trans, move);
  m = AFFINE_TRANSFORM(609, trans, move);
  n = AFFINE_TRANSFORM(687, trans, move);
  p = AFFINE_TRANSFORM(575, trans, move);
  q = AFFINE_TRANSFORM(721, trans, move);
  A = AFFINE_TRANSFORM(648, trans, move);

  return play_attack_defend_n(color, 1, 10, move, h, i, j, k, l, m, n, p, q, A) && break_mirror_helper(A, color);
}

static int
autohelperpat988(int trans, int move, int color, int action)
{
  int j, k, l, m, n, p, q, A;
  UNUSED(color);
  UNUSED(action);

  j = AFFINE_TRANSFORM(688, trans, move);
  k = AFFINE_TRANSFORM(651, trans, move);
  l = AFFINE_TRANSFORM(721, trans, move);
  m = AFFINE_TRANSFORM(647, trans, move);
  n = AFFINE_TRANSFORM(725, trans, move);
  p = AFFINE_TRANSFORM(613, trans, move);
  q = AFFINE_TRANSFORM(759, trans, move);
  A = AFFINE_TRANSFORM(686, trans, move);

  return play_attack_defend_n(color, 1, 8, move, j, k, l, m, n, p, q, A) && break_mirror_helper(A, color);
}

static int
autohelperpat989(int trans, int move, int color, int action)
{
  int l, m, n, p, q, A;
  UNUSED(color);
  UNUSED(action);

  l = AFFINE_TRANSFORM(754, trans, move);
  m = AFFINE_TRANSFORM(680, trans, move);
  n = AFFINE_TRANSFORM(758, trans, move);
  p = AFFINE_TRANSFORM(646, trans, move);
  q = AFFINE_TRANSFORM(792, trans, move);
  A = AFFINE_TRANSFORM(719, trans, move);

  return play_attack_defend_n(color, 1, 6, move, l, m, n, p, q, A) && break_mirror_helper(A, color);
}

static int
autohelperpat990(int trans, int move, int color, int action)
{
  int n, p, q, A;
  UNUSED(color);
  UNUSED(action);

  n = AFFINE_TRANSFORM(762, trans, move);
  p = AFFINE_TRANSFORM(650, trans, move);
  q = AFFINE_TRANSFORM(796, trans, move);
  A = AFFINE_TRANSFORM(723, trans, move);

  return play_attack_defend_n(color, 1, 4, move, n, p, q, A) && break_mirror_helper(A, color);
}

static int
autohelperpat991(int trans, int move, int color, int action)
{
  int q, A;
  UNUSED(color);
  UNUSED(action);

  q = AFFINE_TRANSFORM(830, trans, move);
  A = AFFINE_TRANSFORM(757, trans, move);

  return play_attack_defend_n(color, 1, 2, move, q, A) && break_mirror_helper(A, color);
}

static int
autohelperpat993(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(683, trans, move);
  b = AFFINE_TRANSFORM(646, trans, move);
  c = AFFINE_TRANSFORM(720, trans, move);

  return defend_against(move, color, a) && !play_attack_defend_n(color, 1, 1, move, b) && !play_attack_defend_n(color, 1, 1, move, c);
}

static int
autohelperpat994(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(720, trans, move);
  b = AFFINE_TRANSFORM(721, trans, move);
  c = AFFINE_TRANSFORM(758, trans, move);

  return play_attack_defend_n(color, 1, 4, move, a, b, c, a) || play_attack_defend_n(color, 1, 4, move, a, b, c, c);
}

static int
autohelperpat995(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(757, trans, move);
  b = AFFINE_TRANSFORM(758, trans, move);
  c = AFFINE_TRANSFORM(795, trans, move);
  d = AFFINE_TRANSFORM(721, trans, move);

  return play_attack_defend2_n(color, 1, 4, move, a, b, c, a, c) && !play_attack_defend2_n(color, 0, 5, move, a, b, d, c, a, d);
}

static int
autohelperpat996(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(646, trans, move);
  b = AFFINE_TRANSFORM(720, trans, move);

  return !play_break_through_n(color, 1, move, a, move, b);
}

static int
autohelperpat997(int trans, int move, int color, int action)
{
  int a, b, c, d, e;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(758, trans, move);
  b = AFFINE_TRANSFORM(759, trans, move);
  c = AFFINE_TRANSFORM(796, trans, move);
  d = AFFINE_TRANSFORM(722, trans, move);
  e = AFFINE_TRANSFORM(757, trans, move);

  return play_attack_defend_n(color, 1, 6, move, a, b, e, c, d, d);
}

static int
autohelperpat999(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);
  b = AFFINE_TRANSFORM(610, trans, move);
  c = AFFINE_TRANSFORM(648, trans, move);

  return defend_against(move, color, a) && !play_attack_defend_n(color, 1, 1, move, b) && !play_attack_defend_n(color, 1, 1, move, c);
}

static int
autohelperpat1000(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(646, trans, move);

  return defend_against(move, color, a);
}

static int
autohelperpat1001(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(758, trans, move);

  return defend_against(move, color, a);
}

static int
autohelperpat1002(int trans, int move, int color, int action)
{
  int a, B;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(648, trans, move);
  B = AFFINE_TRANSFORM(610, trans, move);

  return play_attack_defend2_n(color, 1, 2, move, a, a, B);
}

static int
autohelperpat1003(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(719, trans, move);

  return play_attack_defend_n(color, 1, 2, move, a, a);
}

static int
autohelperpat1004(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(758, trans, move);

  return countlib(a)>1;
}

static int
autohelperpat1006(int trans, int move, int color, int action)
{
  int a, B;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(683, trans, move);
  B = AFFINE_TRANSFORM(647, trans, move);

  return play_attack_defend2_n(color, 1, 2, move, a, a, B);
}

static int
autohelperpat1007(int trans, int move, int color, int action)
{
  int a, b, c, e, f;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(611, trans, move);
  b = AFFINE_TRANSFORM(610, trans, move);
  c = AFFINE_TRANSFORM(647, trans, move);
  e = AFFINE_TRANSFORM(574, trans, move);
  f = AFFINE_TRANSFORM(648, trans, move);

  return play_attack_defend2_n(color, 1, 4, move, a, b, c, a, c) && play_attack_defend2_n(color, 1, 4, move, b, a, e, b, e)&& play_attack_defend2_n(color, 0, 2, move, c, move, f);
}

static int
autohelperpat1008(int trans, int move, int color, int action)
{
  int a, b, c, f, E;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(611, trans, move);
  b = AFFINE_TRANSFORM(610, trans, move);
  c = AFFINE_TRANSFORM(647, trans, move);
  f = AFFINE_TRANSFORM(648, trans, move);
  E = AFFINE_TRANSFORM(574, trans, move);

  return play_attack_defend2_n(color, 1, 4, move, a, b, c, a, c) && !play_attack_defend2_n(color, 0, 3, move, b, a, b, E)&& play_attack_defend2_n(color, 0, 2, move, c, move, f);
}

static int
autohelperpat1009(int trans, int move, int color, int action)
{
  int a, b, c, e;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(610, trans, move);
  b = AFFINE_TRANSFORM(609, trans, move);
  c = AFFINE_TRANSFORM(646, trans, move);
  e = AFFINE_TRANSFORM(573, trans, move);

  return play_attack_defend2_n(color, 1, 4, move, a, b, c, a, c) && play_attack_defend2_n(color, 1, 4, move, b, a, e, b, e);
}

static int
autohelperpat1010(int trans, int move, int color, int action)
{
  int a, b, c, E;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(610, trans, move);
  b = AFFINE_TRANSFORM(609, trans, move);
  c = AFFINE_TRANSFORM(646, trans, move);
  E = AFFINE_TRANSFORM(573, trans, move);

  return play_attack_defend2_n(color, 1, 4, move, a, b, c, a, c) && !play_attack_defend2_n(color, 0, 3, move, b, a, b, E);
}

static int
autohelperpat1011(int trans, int move, int color, int action)
{
  int a, b, c, D;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(610, trans, move);
  b = AFFINE_TRANSFORM(609, trans, move);
  c = AFFINE_TRANSFORM(573, trans, move);
  D = AFFINE_TRANSFORM(646, trans, move);

  return !play_attack_defend2_n(color, 0, 3, move, a, b, a, D) && play_attack_defend2_n(color, 1, 4, move, b, a, c, b, c);
}

static int
autohelperpat1012(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);
  b = AFFINE_TRANSFORM(648, trans, move);
  c = AFFINE_TRANSFORM(611, trans, move);

  return play_attack_defend2_n(color, 1, 4, move, a, b, c, a, c);
}

static int
autohelperpat1013(int trans, int move, int color, int action)
{
  int a, b, E;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);
  b = AFFINE_TRANSFORM(648, trans, move);
  E = AFFINE_TRANSFORM(611, trans, move);

  return !play_attack_defend2_n(color, 0, 3, move, a, b, a, E);
}

static int
autohelperpat1014(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(649, trans, move);
  b = AFFINE_TRANSFORM(648, trans, move);
  c = AFFINE_TRANSFORM(685, trans, move);
  d = AFFINE_TRANSFORM(612, trans, move);

  return play_attack_defend2_n(color, 1, 4, move, a, b, c, a, c) && play_attack_defend2_n(color, 1, 4, move, b, a, d, b, d);
}

static int
autohelperpat1015(int trans, int move, int color, int action)
{
  int a, B;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);
  B = AFFINE_TRANSFORM(685, trans, move);

  return play_attack_defend2_n(color, 1, 2, move, a, a, B);
}

static int
autohelperpat1016(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);

  return defend_against(move, color, a);
}

static int
autohelperpat1017(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);
  b = AFFINE_TRANSFORM(609, trans, move);
  c = AFFINE_TRANSFORM(683, trans, move);

  return play_attack_defend2_n(color, 1, 4, move, a, b, c, a, c) || play_attack_defend2_n(color, 1, 4, move, a, c, b, a, b);
}

static int
autohelperpat1018(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);
  b = AFFINE_TRANSFORM(646, trans, move);
  c = AFFINE_TRANSFORM(610, trans, move);

  return !play_break_through_n(color, 3, move, a, b, c, b, move);
}

static int
autohelperpat1019(int trans, int move, int color, int action)
{
  int A, B;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(685, trans, move);
  B = AFFINE_TRANSFORM(721, trans, move);

  return !play_attack_defend2_n(color, 0, 1, move, A, B);
}

static int
autohelperpat1020(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(611, trans, move);
  b = AFFINE_TRANSFORM(610, trans, move);
  c = AFFINE_TRANSFORM(647, trans, move);

  return play_attack_defend2_n(color, 1, 4, move, a, b, c, a, c);
}

static int
autohelperpat1021(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(610, trans, move);
  b = AFFINE_TRANSFORM(609, trans, move);
  c = AFFINE_TRANSFORM(646, trans, move);

  return play_attack_defend2_n(color, 1, 4, move, a, b, c, a, c);
}

static int
autohelperpat1022(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(609, trans, move);

  return !play_attack_defend_n(color, 1, 1, move, A);
}

static int
autohelperpat1023(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);

  return defend_against(move, color, a);
}

static int
autohelperpat1024(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);
  b = AFFINE_TRANSFORM(722, trans, move);
  c = AFFINE_TRANSFORM(758, trans, move);

  return !play_break_through_n(color, 3, move, a, b, move, b, c);
}

static int
autohelperpat1025(int trans, int move, int color, int action)
{
  int a, b, c, d, e;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(720, trans, move);
  b = AFFINE_TRANSFORM(721, trans, move);
  c = AFFINE_TRANSFORM(757, trans, move);
  d = AFFINE_TRANSFORM(758, trans, move);
  e = AFFINE_TRANSFORM(795, trans, move);

  return play_attack_defend2_n(color, 1, 6, move, a, b, c, d, e, c, e) && !play_attack_defend2_n(color, 0, 5, move, a, b, d, c, a, d)&& play_attack_defend_n(color, 1, 4, move, b, a, c, c);
}

static int
autohelperpat1026(int trans, int move, int color, int action)
{
  int a, b, c, d, e;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(720, trans, move);
  b = AFFINE_TRANSFORM(721, trans, move);
  c = AFFINE_TRANSFORM(758, trans, move);
  d = AFFINE_TRANSFORM(683, trans, move);
  e = AFFINE_TRANSFORM(647, trans, move);

  return play_attack_defend2_n(color, 1, 4, move, a, b, c, a, c)&& (play_attack_defend_n(color, 1, 2, move, d, d) || play_attack_defend2_n(color, 1, 4, move, d, b, e, d, e));
}

static int
autohelperpat1027(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(646, trans, move);
  b = AFFINE_TRANSFORM(757, trans, move);

  return !play_connect_n(color, 0, 1, move, a, b);
}

static int
autohelperpat1028(int trans, int move, int color, int action)
{
  int a, b, c, D;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(758, trans, move);
  b = AFFINE_TRANSFORM(757, trans, move);
  c = AFFINE_TRANSFORM(795, trans, move);
  D = AFFINE_TRANSFORM(720, trans, move);

  return !play_attack_defend2_n(color, 0, 3, move, a, b, a, D) && !play_attack_defend2_n(color, 0, 4, move, b, a, c, b, c);
}

static int
autohelperpat1029(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(683, trans, move);
  b = AFFINE_TRANSFORM(720, trans, move);

  return play_attack_defend_n(color, 1, 2, move, a, a) && play_attack_defend_n(color, 1, 2, move, b, b);
}

static int
autohelperpat1030(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(683, trans, move);
  b = AFFINE_TRANSFORM(720, trans, move);

  return play_attack_defend_n(color, 1, 2, move, a, a) && play_attack_defend_n(color, 1, 2, move, b, b);
}

static int
autohelperpat1031(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(648, trans, move);
  b = AFFINE_TRANSFORM(646, trans, move);
  c = AFFINE_TRANSFORM(610, trans, move);

  return play_attack_defend_n(color, 1, 2, move, a, a)&& !play_attack_defend2_n(color, 1, 3, move, b, a, move, a) && !play_attack_defend2_n(color, 1, 3, move, b, a, c, a);
}

static int
autohelperpat1032(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(610, trans, move);
  b = AFFINE_TRANSFORM(721, trans, move);

  return !play_connect_n(color, 0, 1, move, a, b);
}

static int
autohelperpat1033(int trans, int move, int color, int action)
{
  int a, b, c, d, A, B, C, D;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(722, trans, move);
  b = AFFINE_TRANSFORM(685, trans, move);
  c = AFFINE_TRANSFORM(686, trans, move);
  d = AFFINE_TRANSFORM(721, trans, move);
  A = AFFINE_TRANSFORM(646, trans, move);
  B = AFFINE_TRANSFORM(647, trans, move);
  C = AFFINE_TRANSFORM(610, trans, move);
  D = AFFINE_TRANSFORM(683, trans, move);

  return  play_attack_defend_n(color, 1, 4, move, a, b, c, a) && play_attack_defend_n(color, 1, 4, move, A, B, C, A) && play_attack_defend2_n(color, 1, 4, move, b, a, d, b, d) && play_attack_defend2_n(color, 1, 4, move, B, A, D, B, D);
}

static int
autohelperpat1034(int trans, int move, int color, int action)
{
  int a, b, c, D;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);
  b = AFFINE_TRANSFORM(722, trans, move);
  c = AFFINE_TRANSFORM(758, trans, move);
  D = AFFINE_TRANSFORM(685, trans, move);

  return !play_attack_defend2_n(color, 0, 3, move, a, b, a, D) && play_attack_defend2_n(color, 1, 4, move, b, a, c, b, c);
}

static int
autohelperpat1035(int trans, int move, int color, int action)
{
  int a, b, c, d, e;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);
  b = AFFINE_TRANSFORM(720, trans, move);
  c = AFFINE_TRANSFORM(758, trans, move);
  d = AFFINE_TRANSFORM(757, trans, move);
  e = AFFINE_TRANSFORM(794, trans, move);

  return play_attack_defend2_n(color, 1, 6, move, a, b, c, d, e, c, e) && !play_attack_defend2_n(color, 0, 5, move, a, b, d, c, a, d)&& play_attack_defend_n(color, 1, 4, move, b, a, c, c);
}

static int
autohelperpat1036(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);
  b = AFFINE_TRANSFORM(646, trans, move);
  c = AFFINE_TRANSFORM(610, trans, move);

  return !play_break_through_n(color, 3, move, a, b, move, b, c);
}

static int
autohelperpat1037(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(610, trans, move);
  b = AFFINE_TRANSFORM(722, trans, move);

  return !play_connect_n(color, 0, 1, move, a, b);
}

static int
autohelperpat1038(int trans, int move, int color, int action)
{
  int a, b, c, d, e;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);
  b = AFFINE_TRANSFORM(720, trans, move);
  c = AFFINE_TRANSFORM(683, trans, move);
  d = AFFINE_TRANSFORM(647, trans, move);
  e = AFFINE_TRANSFORM(758, trans, move);

  return !play_break_through_n(color, 3, move, a, b, move, b, e) && !play_attack_defend2_n(color, 0, 5, move, c, d, a, b, c, a);
}

static int
autohelperpat1039(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);
  b = AFFINE_TRANSFORM(720, trans, move);
  c = AFFINE_TRANSFORM(683, trans, move);
  d = AFFINE_TRANSFORM(758, trans, move);

  return !play_break_through_n(color, 3, move, a, b, move, b, d) && !play_attack_defend_n(color, 0, 3, move, c, b, c);
}

static int
autohelperpat1040(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(722, trans, move);
  b = AFFINE_TRANSFORM(721, trans, move);
  c = AFFINE_TRANSFORM(758, trans, move);
  d = AFFINE_TRANSFORM(685, trans, move);

  return play_attack_defend2_n(color, 1, 4, move, a, b, c, a, c) && play_attack_defend2_n(color, 1, 4, move, b, a, d, b, d);
}

static int
autohelperpat1041(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);
  b = AFFINE_TRANSFORM(646, trans, move);
  c = AFFINE_TRANSFORM(683, trans, move);

  return play_attack_defend2_n(color, 1, 4, move, a, b, c, a, c);
}

static int
autohelperpat1042(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);
  b = AFFINE_TRANSFORM(646, trans, move);
  c = AFFINE_TRANSFORM(610, trans, move);

  return !play_break_through_n(color, 3, move, a, b, move, b, c);
}

static int
autohelperpat1043(int trans, int move, int color, int action)
{
  int a, b, c, d, e;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(648, trans, move);
  b = AFFINE_TRANSFORM(647, trans, move);
  c = AFFINE_TRANSFORM(721, trans, move);
  d = AFFINE_TRANSFORM(759, trans, move);
  e = AFFINE_TRANSFORM(611, trans, move);

  return !play_attack_defend_n(color, 0, 5, move, a, b, c, d, a) && play_attack_defend2_n(color, 1, 6, move, c, a, b, d, e, b, e);
}

static int
autohelperpat1044(int trans, int move, int color, int action)
{
  int a, c, d, e, B;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);
  c = AFFINE_TRANSFORM(758, trans, move);
  d = AFFINE_TRANSFORM(646, trans, move);
  e = AFFINE_TRANSFORM(647, trans, move);
  B = AFFINE_TRANSFORM(683, trans, move);

  return play_attack_defend_n(color, 1, 2, move, a, B) && !play_attack_defend_n(color, 1, 1, move, c) && !play_attack_defend_n(color, 1, 1, move, d)&& play_attack_defend2_n(color, 1, 2, move, e, B, e);
}

static int
autohelperpat1045(int trans, int move, int color, int action)
{
  int a, c, d, B;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);
  c = AFFINE_TRANSFORM(758, trans, move);
  d = AFFINE_TRANSFORM(646, trans, move);
  B = AFFINE_TRANSFORM(683, trans, move);

  return play_attack_defend2_n(color, 1, 2, move, a, B, a) && !play_attack_defend_n(color, 1, 1, move, c) && !play_attack_defend_n(color, 1, 1, move, d);
}

static int
autohelperpat1046(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);
  b = AFFINE_TRANSFORM(646, trans, move);
  c = AFFINE_TRANSFORM(683, trans, move);

  return play_attack_defend2_n(color, 1, 4, move, a, b, c, a, c);
}

static int
autohelperpat1047(int trans, int move, int color, int action)
{
  int a, b, C;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);
  b = AFFINE_TRANSFORM(646, trans, move);
  C = AFFINE_TRANSFORM(683, trans, move);

  return !play_attack_defend2_n(color, 0, 3, move, a, b, a, C);
}

static int
autohelperpat1048(int trans, int move, int color, int action)
{
  int a, b, c, D;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(648, trans, move);
  b = AFFINE_TRANSFORM(647, trans, move);
  c = AFFINE_TRANSFORM(721, trans, move);
  D = AFFINE_TRANSFORM(685, trans, move);

  return play_attack_defend2_n(color, 1, 4, move, a, b, c, a, c) && play_attack_defend_n(color, 1, 2, move, c, c)&& play_attack_defend_n(color, 1, 4, move, b, a, c, D);
}

static int
autohelperpat1049(int trans, int move, int color, int action)
{
  int a, b, c, d, e;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(649, trans, move);
  b = AFFINE_TRANSFORM(648, trans, move);
  c = AFFINE_TRANSFORM(612, trans, move);
  d = AFFINE_TRANSFORM(611, trans, move);
  e = AFFINE_TRANSFORM(685, trans, move);

  return play_attack_defend_n(color, 1, 3, move, e, b, e)  && !play_attack_defend2_n(color, 0, 5, move, b, a, c, d, b, c)&& !play_attack_defend2_n(color, 0, 5, move, d, c, a, b, d, a);
}

static int
autohelperpat1050(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(648, trans, move);
  b = AFFINE_TRANSFORM(647, trans, move);
  c = AFFINE_TRANSFORM(611, trans, move);
  d = AFFINE_TRANSFORM(610, trans, move);

  return !play_attack_defend2_n(color, 0, 5, move, b, a, c, d, b, c)&& !play_attack_defend2_n(color, 0, 5, move, d, c, a, b, d, a);
}

static int
autohelperpat1051(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);
  b = AFFINE_TRANSFORM(648, trans, move);
  c = AFFINE_TRANSFORM(721, trans, move);
  d = AFFINE_TRANSFORM(609, trans, move);

  return !play_attack_defend_n(color, 1, 3, move, a, b, d) && play_attack_defend2_n(color, 1, 4, move, a, b, c, a, c);
}

static int
autohelperpat1052(int trans, int move, int color, int action)
{
  int a, b, c, d, e, D;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);
  b = AFFINE_TRANSFORM(647, trans, move);
  c = AFFINE_TRANSFORM(611, trans, move);
  d = AFFINE_TRANSFORM(646, trans, move);
  e = AFFINE_TRANSFORM(648, trans, move);
  D = AFFINE_TRANSFORM(683, trans, move);

  return play_attack_defend2_n(color, 1, 2, move, a, a, D) && play_attack_defend2_n(color, 1, 4, move, b, a, c, b, D)&& play_attack_defend2_n(color, 1, 4, move, b, a, e, b, D) && play_attack_defend2_n(color, 1, 6, move, b, a, d, e, c, b, c);
}

static int
autohelperpat1053(int trans, int move, int color, int action)
{
  int a, b, c, D;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);
  b = AFFINE_TRANSFORM(722, trans, move);
  c = AFFINE_TRANSFORM(758, trans, move);
  D = AFFINE_TRANSFORM(685, trans, move);

  return !play_attack_defend2_n(color, 0, 3, move, a, b, a, D) && play_attack_defend2_n(color, 1, 4, move, b, a, c, b, c);
}

static int
autohelperpat1054(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(648, trans, move);

  return cut_possible(a, OTHER_COLOR(color));
}

static int
autohelperpat1055(int trans, int move, int color, int action)
{
  int a, b, A, B;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(648, trans, move);
  b = AFFINE_TRANSFORM(722, trans, move);
  A = AFFINE_TRANSFORM(647, trans, move);
  B = AFFINE_TRANSFORM(721, trans, move);

  return countlib(a)>1 && countlib(b)>1 && (countlib(A)==2 || countlib(B)==2);
}

static int
autohelperpat1056(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(648, trans, move);

  return !play_attack_defend2_n(color, 1, 1, move, move, a);
}

static int
autohelperpat1057(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);
  b = AFFINE_TRANSFORM(685, trans, move);

  return !play_attack_defend2_n(OTHER_COLOR(color), 1, 2, move, a, b, a);
}

static int
autohelperpat1058(int trans, int move, int color, int action)
{
  int a, b, C, D;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);
  b = AFFINE_TRANSFORM(685, trans, move);
  C = AFFINE_TRANSFORM(647, trans, move);
  D = AFFINE_TRANSFORM(722, trans, move);

  return ((dragon[a].status == ALIVE) || (dragon[b].status == ALIVE)) && !play_connect_n(OTHER_COLOR(color), 0, 1, move, C, D) && !play_connect_n(color, 1, 1, move, C, D);
}

static int
autohelperpat1059(int trans, int move, int color, int action)
{
  int a, b, C, D;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(683, trans, move);
  b = AFFINE_TRANSFORM(720, trans, move);
  C = AFFINE_TRANSFORM(721, trans, move);
  D = AFFINE_TRANSFORM(646, trans, move);

  return !play_attack_defend2_n(color, 0, 3, move, a, b, C, D) && !play_connect_n(color, 1, 1, move, C, D);
}

static int
autohelperpat1060(int trans, int move, int color, int action)
{
  int a, b, c, d, e;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(646, trans, move);
  b = AFFINE_TRANSFORM(647, trans, move);
  c = AFFINE_TRANSFORM(610, trans, move);
  d = AFFINE_TRANSFORM(721, trans, move);
  e = AFFINE_TRANSFORM(683, trans, move);

  return countlib(e)==3 && play_attack_defend2_n(OTHER_COLOR(color), 1, 4, move, a, b, c, a, c)&& play_attack_defend2_n(OTHER_COLOR(color), 1, 4, move, a, b, d, a, d) && !play_attack_defend_n(OTHER_COLOR(color), 0, 5, move, b, a, NO_MOVE, d, b);
}

static int
autohelperpat1061(int trans, int move, int color, int action)
{
  int a, b, c, d, E, F;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);
  b = AFFINE_TRANSFORM(722, trans, move);
  c = AFFINE_TRANSFORM(720, trans, move);
  d = AFFINE_TRANSFORM(647, trans, move);
  E = AFFINE_TRANSFORM(758, trans, move);
  F = AFFINE_TRANSFORM(646, trans, move);

  return !play_break_through_n(OTHER_COLOR(color), 3, move, a, b, move, b, E) && !play_attack_defend_n(OTHER_COLOR(color), 1, 5, move, a, b, d, c, F);
}

static int
autohelperpat1062(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);
  b = AFFINE_TRANSFORM(683, trans, move);

  return ATTACK_MACRO(b) && !play_attack_defend_n(color, 1, 2, move, a, a) && play_attack_defend_n(color, 1, 2, move, a, move);
}

static int
autohelperpat1063(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);

  a = AFFINE_TRANSFORM(757, trans, move);
  b = AFFINE_TRANSFORM(721, trans, move);

  if (!action)
    return !play_attack_defend_n(color, 1, 2, move, a, a) && play_attack_defend_n(color, 1, 3, move, a, b, b);
  add_antisuji_move(move);;

  return 0;
}

static int
autohelperpat1064(int trans, int move, int color, int action)
{
  int c, d, A, B;
  UNUSED(color);

  c = AFFINE_TRANSFORM(758, trans, move);
  d = AFFINE_TRANSFORM(720, trans, move);
  A = AFFINE_TRANSFORM(757, trans, move);
  B = AFFINE_TRANSFORM(721, trans, move);

  if (!action)
    return !dragon_weak(A) && !dragon_weak(B) && play_attack_defend_n(color, 1, 2, move, c, move);
  add_antisuji_move(move);backfill_helper(move, c, d);;

  return 0;
}

static int
autohelperpat1065(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);

  a = AFFINE_TRANSFORM(686, trans, move);
  b = AFFINE_TRANSFORM(721, trans, move);
  c = AFFINE_TRANSFORM(723, trans, move);

  if (!action)
    return (dragon[b].status == ALIVE) && ATTACK_MACRO(c);
  add_replacement_move(a, move, color);;

  return 0;
}

static int
autohelperpat1066(int trans, int move, int color, int action)
{
  int a, b, c, D;
  UNUSED(color);

  a = AFFINE_TRANSFORM(685, trans, move);
  b = AFFINE_TRANSFORM(611, trans, move);
  c = AFFINE_TRANSFORM(683, trans, move);
  D = AFFINE_TRANSFORM(648, trans, move);

  if (!action)
    return play_attack_defend_n(color, 1, 5, a, move, b, c, D, a);
  add_replacement_move(a, move, color);;

  return 0;
}

static int
autohelperpat1067(int trans, int move, int color, int action)
{
  int a, b, C;
  UNUSED(color);

  a = AFFINE_TRANSFORM(645, trans, move);
  b = AFFINE_TRANSFORM(682, trans, move);
  C = AFFINE_TRANSFORM(683, trans, move);

  if (!action)
    return (dragon[b].status == ALIVE) && (dragon[C].status == ALIVE) && is_legal(move, color);
  add_replacement_move(a, move, color);;

  return 0;
}

static int
autohelperpat1068(int trans, int move, int color, int action)
{
  int a, b, c, d, e;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(646, trans, move);
  b = AFFINE_TRANSFORM(647, trans, move);
  c = AFFINE_TRANSFORM(757, trans, move);
  d = AFFINE_TRANSFORM(758, trans, move);
  e = AFFINE_TRANSFORM(721, trans, move);

  return  somewhere(color, 1, 2, a, b) && somewhere(color, 1, 2, c, d) && !play_attack_defend_n(color, 1, 2, move, e, e) && (play_attack_defend_n(color, 1, 2, move, e, move) || (somewhere(color, 0, 1, c) ? play_attack_defend_n(color, 1, 2, move, e, c)					     : play_attack_defend_n(color, 1, 2, move, e, d)));
}

static int
autohelperpat1069(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);

  return !is_proper_eye_space(a) && !does_capture_something(move, color) && !does_capture_something(move, OTHER_COLOR(color));
}

static int
autohelperpat1070(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(648, trans, move);

  return !is_eye_space(a) && !does_capture_something(move, color);
}

static int
autohelperpat1071(int trans, int move, int color, int action)
{
  UNUSED(trans);
  UNUSED(color);
  UNUSED(action);

  UNUSED(move);

  return !is_ko_point(move) && !does_capture_something(move, color);
}

static int
autohelperpat1072(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(685, trans, move);

  return !defend_against(move, color, a);
}

static int
autohelperpat1074(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(722, trans, move);

  return play_attack_defend_n(color, 1, 2, move, a, a);
}

static int
autohelperpat1081(int trans, int move, int color, int action)
{
  int b, c, d, e, f, B, C;
  UNUSED(color);
  UNUSED(action);

  b = AFFINE_TRANSFORM(646, trans, move);
  c = AFFINE_TRANSFORM(647, trans, move);
  d = AFFINE_TRANSFORM(683, trans, move);
  e = AFFINE_TRANSFORM(648, trans, move);
  f = AFFINE_TRANSFORM(722, trans, move);
  B = AFFINE_TRANSFORM(720, trans, move);
  C = AFFINE_TRANSFORM(721, trans, move);

  return  countlib(e) > 1 && countlib(f) > 1 && (somewhere(color, 1, 1, c) + somewhere(color, 1, 1, C) + somewhere(color, 1, 1, d) <= 1) && !(somewhere(color, 1, 1, d) && (somewhere(color, 1, 1, b) || somewhere(color, 1, 1, B)));
}

static int
autohelperpat1082(int trans, int move, int color, int action)
{
  int b, c, d, e, f, B, C;
  UNUSED(color);
  UNUSED(action);

  b = AFFINE_TRANSFORM(646, trans, move);
  c = AFFINE_TRANSFORM(647, trans, move);
  d = AFFINE_TRANSFORM(683, trans, move);
  e = AFFINE_TRANSFORM(648, trans, move);
  f = AFFINE_TRANSFORM(722, trans, move);
  B = AFFINE_TRANSFORM(720, trans, move);
  C = AFFINE_TRANSFORM(721, trans, move);

  return  (somewhere(color, 1, 1, c) + somewhere(color, 1, 1, C) + somewhere(color, 1, 1, d) <= 1) && !(somewhere(color, 1, 1, d) && (somewhere(color, 1, 1, b) || somewhere(color, 1, 1, B))) && !ATTACK_MACRO(e) && !ATTACK_MACRO(f);
}

static int
autohelperpat1083(int trans, int move, int color, int action)
{
  int b, c, d, e, f, A, B, C;
  UNUSED(color);
  UNUSED(action);

  b = AFFINE_TRANSFORM(646, trans, move);
  c = AFFINE_TRANSFORM(647, trans, move);
  d = AFFINE_TRANSFORM(683, trans, move);
  e = AFFINE_TRANSFORM(648, trans, move);
  f = AFFINE_TRANSFORM(686, trans, move);
  A = AFFINE_TRANSFORM(722, trans, move);
  B = AFFINE_TRANSFORM(720, trans, move);
  C = AFFINE_TRANSFORM(721, trans, move);

  return  (somewhere(color, 1, 1, c) + somewhere(color, 1, 1, C) + somewhere(color, 1, 1, d) <= 1) && !(somewhere(color, 1, 1, d) && (somewhere(color, 1, 1, b) || somewhere(color, 1, 1, B))) && !ATTACK_MACRO(A) && !ATTACK_MACRO(e) && !ATTACK_MACRO(f);
}

static int
autohelperpat1085(int trans, int move, int color, int action)
{
  int b, A;
  UNUSED(color);
  UNUSED(action);

  b = AFFINE_TRANSFORM(685, trans, move);
  A = AFFINE_TRANSFORM(686, trans, move);

  return countlib(A)>1 && !(dragon[b].status == DEAD);
}

static int
autohelperpat1086(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(687, trans, move);

  return countlib(A)>1;
}

static int
autohelperpat1087(int trans, int move, int color, int action)
{
  int a, b, C;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(683, trans, move);
  b = AFFINE_TRANSFORM(646, trans, move);
  C = AFFINE_TRANSFORM(721, trans, move);

  return !play_attack_defend2_n(color, 1, 2, move, a, a, C) && play_attack_defend_n(color, 1, 3, move, a, b, move);
}

static int
autohelperpat1088(int trans, int move, int color, int action)
{
  int a, b, c, B;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);
  b = AFFINE_TRANSFORM(759, trans, move);
  c = AFFINE_TRANSFORM(685, trans, move);
  B = AFFINE_TRANSFORM(758, trans, move);

  return !play_attack_defend2_n(color, 1, 4, move, a, b, c, a, c) && !play_attack_defend2_n(color, 1, 4, move, a, c, b, a, b) && !(dragon[B].status == ALIVE);
}

static int
autohelperpat1089(int trans, int move, int color, int action)
{
  int a, A, B;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(609, trans, move);
  A = AFFINE_TRANSFORM(645, trans, move);
  B = AFFINE_TRANSFORM(647, trans, move);

  return !play_attack_defend_n(color, 1, 2, move, a, A) && !play_attack_defend_n(color, 1, 2, move, a, B) && !play_attack_defend_n(color, 1, 2, move, a, a);
}

static int
autohelperpat1090(int trans, int move, int color, int action)
{
  int a, A, B;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(573, trans, move);
  A = AFFINE_TRANSFORM(609, trans, move);
  B = AFFINE_TRANSFORM(611, trans, move);

  return !play_attack_defend_n(color, 1, 2, move, a, A) && !play_attack_defend_n(color, 1, 2, move, a, B) && !play_attack_defend_n(color, 1, 2, move, a, a);
}

static int
autohelperpat1091(int trans, int move, int color, int action)
{
  int A, B;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(722, trans, move);
  B = AFFINE_TRANSFORM(720, trans, move);

  return countlib(A)>1 && countlib(B)>2;
}

static int
autohelperpat1092(int trans, int move, int color, int action)
{
  int a, B, C;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(686, trans, move);
  B = AFFINE_TRANSFORM(648, trans, move);
  C = AFFINE_TRANSFORM(722, trans, move);

  return !play_attack_defend_n(color, 1, 2, move, a, a) && !play_attack_defend_n(color, 1, 2, move, a, B) && !play_attack_defend_n(color, 1, 2, move, a, C) && play_attack_defend_n(color, 1, 2, a, move, move);
}

static int
autohelperpat1093(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(683, trans, move);
  b = AFFINE_TRANSFORM(647, trans, move);

  return defend_against(move, color, a) && (play_attack_defend_n(color, 1, 2, move, b, b) || !play_attack_defend_n(color, 1, 2, move, b, move));
}

static int
autohelperpat1094(int trans, int move, int color, int action)
{
  int a, b, C;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(719, trans, move);
  b = AFFINE_TRANSFORM(720, trans, move);
  C = AFFINE_TRANSFORM(721, trans, move);

  return countlib(b)==2 && countlib(C)>3 && !play_attack_defend_n(color, 1, 2, move, a, a);
}

static int
autohelperpat1095(int trans, int move, int color, int action)
{
  int a, b, c, d, E;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(685, trans, move);
  b = AFFINE_TRANSFORM(648, trans, move);
  c = AFFINE_TRANSFORM(647, trans, move);
  d = AFFINE_TRANSFORM(683, trans, move);
  E = AFFINE_TRANSFORM(721, trans, move);

  return play_attack_defend_n(color, 1, 5, move, a, b, c, d, b) && countlib(E)>3;
}

static int
autohelperpat1096(int trans, int move, int color, int action)
{
  int a, B;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(683, trans, move);
  B = AFFINE_TRANSFORM(720, trans, move);

  return countlib(B)>1 && defend_against(move, OTHER_COLOR(color), a);
}

static int
autohelperpat1099(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(686, trans, move);
  b = AFFINE_TRANSFORM(649, trans, move);
  c = AFFINE_TRANSFORM(648, trans, move);
  d = AFFINE_TRANSFORM(723, trans, move);

  return play_attack_defend_n(color, 1, 5, move, a, b, c, d, move);
}

static int
autohelperpat1102(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(760, trans, move);

  return dragon_weak(a);
}

static int
autohelperpat1103(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(611, trans, move);
  b = AFFINE_TRANSFORM(610, trans, move);

  return countlib(b)==2 && !play_attack_defend_n(color, 1, 2, move, a, a);
}

static int
autohelperpat1105(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);

  return !play_attack_defend_n(color, 1, 2, move, a, a);
}

static int
autohelperpat1106(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);
  b = AFFINE_TRANSFORM(610, trans, move);

  return (!ATTACK_MACRO(b) || DEFEND_MACRO(b)) && !play_attack_defend2_n(color, 0, 2, move, a, move, b);
}

static int
autohelperpat1107(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(683, trans, move);

  return ATTACK_MACRO(a);
}

static int
autohelperpat1109(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(646, trans, move);

  return countlib(a)==2;
}

static int
autohelperpat1111(int trans, int move, int color, int action)
{
  int a, B;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);
  B = AFFINE_TRANSFORM(646, trans, move);

  return countlib(B)==1 && !play_attack_defend_n(color, 1, 2, move, a, a);
}

static int
autohelperpat1113(int trans, int move, int color, int action)
{
  int a, B;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(720, trans, move);
  B = AFFINE_TRANSFORM(682, trans, move);

  return play_attack_defend_n(color, 0, 1, move, B) && play_attack_defend_n(color, 1, 2, move, a, move);
}

static int
autohelperpat1116(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(720, trans, move);
  b = AFFINE_TRANSFORM(645, trans, move);

  return countlib(a)>2 && countlib(b)>2;
}

static int
autohelperpat1121(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(609, trans, move);

  return !(whose_moyo(OPPOSITE_INFLUENCE(color), a) == OTHER_COLOR(color));
}

static int
autohelperpat1122(int trans, int move, int color, int action)
{
  int a, b, C, D, E;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(683, trans, move);
  b = AFFINE_TRANSFORM(794, trans, move);
  C = AFFINE_TRANSFORM(682, trans, move);
  D = AFFINE_TRANSFORM(719, trans, move);
  E = AFFINE_TRANSFORM(756, trans, move);

  return !is_same_dragon(a, b) || somewhere(OTHER_COLOR(color), 1, 3, C, D, E);
}

static int
autohelperpat1123(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);
  b = AFFINE_TRANSFORM(683, trans, move);

  return countlib(b)>=3 && play_attack_defend_n(color, 1, 2, a, move, move);
}

static int
autohelperpat1125(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(720, trans, move);

  return dragon_weak(A);
}

static int
autohelperpat1126(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);

  return play_attack_defend_n(color, 1, 2, move, a, move) && !play_attack_defend_n(color, 1, 2, move, a, a);
}

static int
autohelperpat1131(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(645, trans, move);

  return dragon_weak(a);
}

static int
autohelperpat1134(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(683, trans, move);

  return countlib(A)==3;
}

static int
autohelperpat1143(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(611, trans, move);
  b = AFFINE_TRANSFORM(609, trans, move);

  return somewhere(color, 1, 2, a, b);
}

static int
autohelperpat1144(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);
  b = AFFINE_TRANSFORM(648, trans, move);
  c = AFFINE_TRANSFORM(610, trans, move);

  return play_connect_n(color, 0, 3, move, a, b, move, c);
}

static int
autohelperpat1145(int trans, int move, int color, int action)
{
  UNUSED(trans);
  UNUSED(color);
  UNUSED(action);

  UNUSED(move);

  return play_attack_defend_n(color, 1, 1, move, move);
}

static int
autohelperpat1146(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(647, trans, move);

  return countlib(A)==2;
}

static int
autohelperpat1148(int trans, int move, int color, int action)
{
  int b, A;
  UNUSED(color);
  UNUSED(action);

  b = AFFINE_TRANSFORM(720, trans, move);
  A = AFFINE_TRANSFORM(683, trans, move);

  return !play_attack_defend_n(color, 0, 1, b, A);
}

static int
autohelperpat1150(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(757, trans, move);
  b = AFFINE_TRANSFORM(720, trans, move);
  c = AFFINE_TRANSFORM(756, trans, move);

  return !play_attack_defend2_n(color, 0, 2, move, a, b, c);
}

static int
autohelperpat1151(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);

  return !is_proper_eye_space(a);
}

static int
autohelperpat1152(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(646, trans, move);

  return countlib(A)==2 && accuratelib(move, OTHER_COLOR(color), MAX_LIBERTIES, NULL)>1;
}

static int
autohelperpat1154(int trans, int move, int color, int action)
{
  int a, b, c, D;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);
  b = AFFINE_TRANSFORM(609, trans, move);
  c = AFFINE_TRANSFORM(721, trans, move);
  D = AFFINE_TRANSFORM(682, trans, move);

  return (somewhere(OTHER_COLOR(color), 1, 1, D) || play_attack_defend_n(color, 1, 3, move, NO_MOVE, D, D)) && !play_attack_defend_n(color, 0, 4, move, a, b, c, move);
}

static int
autohelperpat1155(int trans, int move, int color, int action)
{
  int b, A, C, D, E;
  UNUSED(color);
  UNUSED(action);

  b = AFFINE_TRANSFORM(646, trans, move);
  A = AFFINE_TRANSFORM(647, trans, move);
  C = AFFINE_TRANSFORM(609, trans, move);
  D = AFFINE_TRANSFORM(610, trans, move);
  E = AFFINE_TRANSFORM(683, trans, move);

  return  accuratelib(A, OTHER_COLOR(color), MAX_LIBERTIES, NULL) > 2 && play_attack_defend_n(color, 1, 4, move, A, b, C, D) && play_attack_defend_n(color, 1, 5, move, A, b, E, C, move);
}

static int
autohelperpat1158(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(683, trans, move);

  return countlib(A)==2;
}

static int
autohelperpat1161(int trans, int move, int color, int action)
{
  int b, A;
  UNUSED(color);
  UNUSED(action);

  b = AFFINE_TRANSFORM(649, trans, move);
  A = AFFINE_TRANSFORM(646, trans, move);

  return !dragon_weak(A) && countlib(A)==2 && (whose_territory(OPPOSITE_INFLUENCE(color), b) == OTHER_COLOR(color));
}

static int
autohelperpat1162(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(722, trans, move);
  b = AFFINE_TRANSFORM(760, trans, move);
  c = AFFINE_TRANSFORM(723, trans, move);
  d = AFFINE_TRANSFORM(685, trans, move);

  return !play_attack_defend2_n(color, 0, 2, move, c, a, b) && play_attack_defend_n(color, 1, 2, d, c, c);
}

static int
autohelperpat1163(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);
  b = AFFINE_TRANSFORM(646, trans, move);

  return countlib(a)>1 && accuratelib(b, OTHER_COLOR(color), MAX_LIBERTIES, NULL)>1 && play_attack_defend_n(color, 1, 2, move, b, move);
}

static int
autohelperpat1164(int trans, int move, int color, int action)
{
  int a, c, B;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(683, trans, move);
  c = AFFINE_TRANSFORM(722, trans, move);
  B = AFFINE_TRANSFORM(721, trans, move);

  return (accuratelib(move, OTHER_COLOR(color), MAX_LIBERTIES, NULL)==2 || (countlib(a)>2 && accuratelib(move, OTHER_COLOR(color), MAX_LIBERTIES, NULL) < accuratelib(c, OTHER_COLOR(color), MAX_LIBERTIES, NULL)))&& !play_attack_defend_n(color, 0, 1, c, B);
}

static int
autohelperpat1165(int trans, int move, int color, int action)
{
  int A, B;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(683, trans, move);
  B = AFFINE_TRANSFORM(721, trans, move);

  return play_attack_defend2_n(color, 1, 1, move, A, B) && !safe_move(move, color);
}

static int
autohelperpat1166(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(682, trans, move);
  b = AFFINE_TRANSFORM(720, trans, move);

  return !(dragon[a].status == DEAD) && !(dragon[b].status == DEAD) && dragon_weak(a) && dragon_weak(b) && play_connect_n(color, 0, 1, move, a, b);
}

static int
autohelperpat1167(int trans, int move, int color, int action)
{
  int b, A;
  UNUSED(color);
  UNUSED(action);

  b = AFFINE_TRANSFORM(720, trans, move);
  A = AFFINE_TRANSFORM(685, trans, move);

  return countlib(A)==2 && accuratelib(move, color, MAX_LIBERTIES, NULL)==1 && accuratelib(b, color, MAX_LIBERTIES, NULL)==1;
}

static int
autohelperpat1168(int trans, int move, int color, int action)
{
  int a, B;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);
  B = AFFINE_TRANSFORM(720, trans, move);

  return countlib(B)>1 && play_attack_defend_n(OTHER_COLOR(color), 1, 1, move, a);
}

static int
autohelperpat1169(int trans, int move, int color, int action)
{
  int a, b, C;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(723, trans, move);
  b = AFFINE_TRANSFORM(686, trans, move);
  C = AFFINE_TRANSFORM(685, trans, move);

  return countlib(C)==1 && play_attack_defend_n(OTHER_COLOR(color), 1, 1, a, b) && play_attack_defend_n(color, 1, 2, move, a, a);
}

static int
autohelperpat1170(int trans, int move, int color, int action)
{
  int a, b, C;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);
  b = AFFINE_TRANSFORM(682, trans, move);
  C = AFFINE_TRANSFORM(683, trans, move);

  return countlib(C)==1 && play_attack_defend_n(OTHER_COLOR(color), 1, 1, a, b) && play_attack_defend_n(color, 1, 2, move, a, a);
}

static int
autohelperpat1171(int trans, int move, int color, int action)
{
  int a, b, C;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(759, trans, move);
  b = AFFINE_TRANSFORM(722, trans, move);
  C = AFFINE_TRANSFORM(721, trans, move);

  return countlib(C)==1 && play_attack_defend_n(OTHER_COLOR(color), 1, 1, a, b) && play_attack_defend_n(color, 1, 2, move, a, a);
}

static int
autohelperpat1172(int trans, int move, int color, int action)
{
  int A, B, C;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(646, trans, move);
  B = AFFINE_TRANSFORM(682, trans, move);
  C = AFFINE_TRANSFORM(720, trans, move);

  return play_break_through_n(color, 1, move, A, B, C) && countlib(A)>1 && countlib(C)>1;
}

static int
autohelperpat1174(int trans, int move, int color, int action)
{
  int A, B;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(720, trans, move);
  B = AFFINE_TRANSFORM(758, trans, move);

  return play_attack_defend2_n(color, 1, 1, move, A, B) && !ATTACK_MACRO(B) && !ATTACK_MACRO(A);
}

static int
autohelperpat1175(int trans, int move, int color, int action)
{
  int a, A;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(760, trans, move);
  A = AFFINE_TRANSFORM(721, trans, move);

  return countlib(A)==2 && countlib(a)>1;
}

static int
autohelperpat1176(int trans, int move, int color, int action)
{
  int a, A;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(758, trans, move);
  A = AFFINE_TRANSFORM(682, trans, move);

  return countlib(A)==2 && countlib(a)>1;
}

static int
autohelperpat1177(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(647, trans, move);

  return play_attack_defend_n(color, 1, 1, move, A) && play_attack_defend_n(color, 0, 1, move, A);
}

static int
autohelperpat1178(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(721, trans, move);

  return play_attack_defend_n(color, 1, 1, move, A);
}

static int
autohelperpat1180(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(610, trans, move);

  return countlib(A)==3 && play_attack_defend_n(color, 1, 1, move, A);
}

static int
autohelperpat1181(int trans, int move, int color, int action)
{
  int A;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(610, trans, move);

  return play_attack_defend_n(color, 1, 1, move, A);
}

static int
autohelperpat1182(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);

  a = AFFINE_TRANSFORM(721, trans, move);

  if (!action)
    return countlib(a) == 2 && !ATTACK_MACRO(a) && safe_move(move, OTHER_COLOR(color)) && safe_move(move, color);
  defend_against_atari_helper(move, a);

  return 0;
}

static int
autohelperpat1183(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);

  a = AFFINE_TRANSFORM(720, trans, move);
  b = AFFINE_TRANSFORM(683, trans, move);
  c = AFFINE_TRANSFORM(721, trans, move);

  if (!action)
    return countlib(a) == 2 && !ATTACK_MACRO(a) && accuratelib(b, color, MAX_LIBERTIES, NULL) > 2 && safe_move(move, color)&& (safe_move(move, OTHER_COLOR(color)) || safe_move(b, OTHER_COLOR(color)))&& (play_attack_defend_n(color, 1, 2, move, b, b)==WIN    || (somewhere(OTHER_COLOR(color), 0, 1, c) && play_attack_defend2_n(color, 1, 2, move, b, b, c)));
  defend_against_atari_helper(move, a);

  return 0;
}

static int
autohelperpat1184(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);

  a = AFFINE_TRANSFORM(757, trans, move);
  b = AFFINE_TRANSFORM(720, trans, move);
  c = AFFINE_TRANSFORM(721, trans, move);

  if (!action)
    return countlib(a) == 2 && !ATTACK_MACRO(a) && safe_move(move, color)&& (safe_move(b, OTHER_COLOR(color)) || safe_move(c, OTHER_COLOR(color)))&& play_attack_defend_n(color, 1, 2, move, b, b)==WIN&& play_attack_defend_n(color, 1, 2, move, c, c)==WIN;
  defend_against_atari_helper(move, a);

  return 0;
}

static int
autohelperpat1185(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);

  a = AFFINE_TRANSFORM(758, trans, move);
  b = AFFINE_TRANSFORM(722, trans, move);
  c = AFFINE_TRANSFORM(721, trans, move);

  if (!action)
    return countlib(a) == 2 && !ATTACK_MACRO(a) && safe_move(move, color)&& safe_move(move, OTHER_COLOR(color))&& !play_attack_defend_n(color, 0, 3, move, b, c, b)&& play_attack_defend_n(OTHER_COLOR(color), 1, 1, move, a);
  defend_against_atari_helper(move, a);

  return 0;
}

static int
autohelperpat1186(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);

  a = AFFINE_TRANSFORM(758, trans, move);
  b = AFFINE_TRANSFORM(721, trans, move);

  if (!action)
    return (dragon[a].status == ALIVE) && countlib(a) == 2 && !ATTACK_MACRO(a) && accuratelib(b, color, MAX_LIBERTIES, NULL) > 2 && safe_move(move, color)&& safe_move(b, OTHER_COLOR(color)) && play_attack_defend_n(color, 1, 2, move, b, b)==WIN;
  defend_against_atari_helper(move, a);

  return 0;
}

static int
autohelperpat1187(int trans, int move, int color, int action)
{
  int a, d, B, C;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(608, trans, move);
  d = AFFINE_TRANSFORM(647, trans, move);
  B = AFFINE_TRANSFORM(645, trans, move);
  C = AFFINE_TRANSFORM(683, trans, move);

  return countlib(a)>1 && !ATTACK_MACRO(B) && !ATTACK_MACRO(C) && accuratelib(d, OTHER_COLOR(color), MAX_LIBERTIES, NULL)>1;
}

static int
autohelperpat1188(int trans, int move, int color, int action)
{
  int a, d, e, f, g, B, C;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(608, trans, move);
  d = AFFINE_TRANSFORM(682, trans, move);
  e = AFFINE_TRANSFORM(609, trans, move);
  f = AFFINE_TRANSFORM(610, trans, move);
  g = AFFINE_TRANSFORM(647, trans, move);
  B = AFFINE_TRANSFORM(645, trans, move);
  C = AFFINE_TRANSFORM(683, trans, move);

  return countlib(a)>1 && somewhere(color, 1, 3, e, f, g) && !ATTACK_MACRO(B) && !ATTACK_MACRO(C)&& !play_attack_defend2_n(color, 0, 3, move, NO_MOVE, d, B, C);
}

static int
autohelperpat1189(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);
  b = AFFINE_TRANSFORM(646, trans, move);

  return play_attack_defend_n(OTHER_COLOR(color), 1, 3, move, a, b, move) && play_attack_defend2_n(OTHER_COLOR(color), 0, 3, move, a, b, move, b);
}

static int
autohelperpat1190(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);
  b = AFFINE_TRANSFORM(721, trans, move);
  c = AFFINE_TRANSFORM(646, trans, move);
  d = AFFINE_TRANSFORM(683, trans, move);

  return (dragon[d].status == ALIVE) && !play_attack_defend2_n(OTHER_COLOR(color), 0, 5, move, a, b, NO_MOVE, c, a, d);
}

static int
autohelperpat1191(int trans, int move, int color, int action)
{
  int a, b, C;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(758, trans, move);
  b = AFFINE_TRANSFORM(683, trans, move);
  C = AFFINE_TRANSFORM(572, trans, move);

  return (whose_moyo(INITIAL_INFLUENCE(color), a) == color) && (dragon[b].status == ALIVE) && (dragon[C].status == ALIVE);
}

static int
autohelperpat1192(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);
  b = AFFINE_TRANSFORM(610, trans, move);
  c = AFFINE_TRANSFORM(646, trans, move);

  return ((!somewhere(color, 0, 1, b) && (whose_territory(OPPOSITE_INFLUENCE(color), b) == color)) || (!somewhere(color, 0, 1, c) && (whose_territory(OPPOSITE_INFLUENCE(color), c) == color)))&& safe_move(move, OTHER_COLOR(color)) && !play_attack_defend_n(OTHER_COLOR(color), 1, 2, move, a, move);
}

static int
autohelperpat1193(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);
  b = AFFINE_TRANSFORM(610, trans, move);
  c = AFFINE_TRANSFORM(646, trans, move);

  return (whose_territory(OPPOSITE_INFLUENCE(color), b) == color) && (whose_territory(OPPOSITE_INFLUENCE(color), c) == color) && safe_move(move, OTHER_COLOR(color)) && !play_attack_defend_n(OTHER_COLOR(color), 1, 2, move, a, move);
}

static int
autohelperpat1194(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(647, trans, move);
  b = AFFINE_TRANSFORM(610, trans, move);
  c = AFFINE_TRANSFORM(646, trans, move);
  d = AFFINE_TRANSFORM(609, trans, move);

  return (whose_territory(OPPOSITE_INFLUENCE(color), b) == color) && (whose_territory(OPPOSITE_INFLUENCE(color), c) == color) && (whose_territory(OPPOSITE_INFLUENCE(color), d) == color) && safe_move(move, OTHER_COLOR(color)) && !play_attack_defend_n(OTHER_COLOR(color), 1, 2, move, a, move);
}

static int
autohelperpat1195(int trans, int move, int color, int action)
{
  int a, b, A;
  UNUSED(color);

  a = AFFINE_TRANSFORM(647, trans, move);
  b = AFFINE_TRANSFORM(721, trans, move);
  A = AFFINE_TRANSFORM(648, trans, move);

  if (!action)
    return  play_attack_defend_n(color, 1, 1, move, A) && play_attack_defend_n(color, 1, 2, move, a, A) && play_attack_defend_n(color, 1, 3, move, b, a, A);
   register_good_attack_threat(move, A);

  return 0;
}

static int
autohelperpat1196(int trans, int move, int color, int action)
{
  int a, c, B;
  UNUSED(color);

  a = AFFINE_TRANSFORM(646, trans, move);
  c = AFFINE_TRANSFORM(720, trans, move);
  B = AFFINE_TRANSFORM(721, trans, move);

  if (!action)
    return countlib(a)>3 && (dragon[B].status == ALIVE) && play_attack_defend_n(OTHER_COLOR(color), 1, 1, move, c);
  prevent_attack_threat_helper(move, c);;

  return 0;
}

static int
autohelperpat1197(int trans, int move, int color, int action)
{
  int b, A;
  UNUSED(color);
  UNUSED(action);

  b = AFFINE_TRANSFORM(722, trans, move);
  A = AFFINE_TRANSFORM(685, trans, move);

  return  countlib(A)==3 && safe_move(move, OTHER_COLOR(color)) && !play_attack_defend_n(OTHER_COLOR(color), 0, 3, move, NO_MOVE, b, A);
}

static int
autohelperpat1198(int trans, int move, int color, int action)
{
  int A, B;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(721, trans, move);
  B = AFFINE_TRANSFORM(685, trans, move);

  test_attack_either_move(move, color, A, B);

  return 0;
}

static int
autohelperpat1199(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);

  a = AFFINE_TRANSFORM(721, trans, move);
  b = AFFINE_TRANSFORM(685, trans, move);

  if (!action)
    return !play_attack_defend2_n(OTHER_COLOR(color), 0, 1, move, a, b);
  add_all_move(move, DEFEND_STRING, a, DEFEND_STRING, b);;

  return 0;
}

static int
autohelperpat1200(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);

  a = AFFINE_TRANSFORM(758, trans, move);
  b = AFFINE_TRANSFORM(722, trans, move);
  c = AFFINE_TRANSFORM(721, trans, move);

  if (!action)
    return !play_attack_defend2_n(OTHER_COLOR(color), 0, 1, c, a, b)&& (play_attack_defend_n(color, 1, 2, move, c, c) || play_attack_defend2_n(color, 0, 2, move, c, a, b));
  add_all_move(move, DEFEND_STRING, a, DEFEND_STRING, b);;

  return 0;
}

static int
autohelperpat1201(int trans, int move, int color, int action)
{
  int a, b, c, D, E;
  UNUSED(color);

  a = AFFINE_TRANSFORM(722, trans, move);
  b = AFFINE_TRANSFORM(685, trans, move);
  c = AFFINE_TRANSFORM(721, trans, move);
  D = AFFINE_TRANSFORM(647, trans, move);
  E = AFFINE_TRANSFORM(683, trans, move);

  if (!action)
    return play_attack_defend_n(color, 1, 1, move, D) && play_attack_defend2_n(color, 1, 2, move, a, D, E)&& !play_attack_defend2_n(color, 0, 3, move, b, c, D, E);
  test_attack_either_move(move, color, D, E);

  return 0;
}

static int
autohelperpat1202(int trans, int move, int color, int action)
{
  int a, b, c, d, e;
  UNUSED(color);

  a = AFFINE_TRANSFORM(646, trans, move);
  b = AFFINE_TRANSFORM(647, trans, move);
  c = AFFINE_TRANSFORM(683, trans, move);
  d = AFFINE_TRANSFORM(609, trans, move);
  e = AFFINE_TRANSFORM(645, trans, move);

  if (!action)
    return play_attack_defend_n(OTHER_COLOR(color), 1, 1, a, d) && play_attack_defend2_n(OTHER_COLOR(color), 1, 2, a, move, d, e)&& !play_attack_defend2_n(OTHER_COLOR(color), 0, 3, a, b, c, d, e) && !play_attack_defend2_n(OTHER_COLOR(color), 0, 3, a, c, b, d, e)&& !play_connect_n(OTHER_COLOR(color), 1, 1, a, d, e) && play_connect_n(color, 1, 2, move, a, d, e);
  add_all_move(move, DEFEND_STRING, d, DEFEND_STRING, e);;

  return 0;
}

static int
autohelperpat1203(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);

  a = AFFINE_TRANSFORM(646, trans, move);
  b = AFFINE_TRANSFORM(609, trans, move);
  c = AFFINE_TRANSFORM(645, trans, move);

  if (!action)
    return !doing_scoring&& countlib(c)<=4 && play_attack_defend_n(OTHER_COLOR(color), 1, 1, a, b) && safe_move(a, OTHER_COLOR(color)) && defend_against(move, color, a);
  add_all_move(move, DEFEND_STRING, b, DEFEND_STRING, c);;

  return 0;
}

static int
autohelperpat1204(int trans, int move, int color, int action)
{
  int A, B;
  UNUSED(color);
  UNUSED(action);

  A = AFFINE_TRANSFORM(647, trans, move);
  B = AFFINE_TRANSFORM(721, trans, move);

  test_attack_either_move(move, color, A, B);

  return 0;
}

static int
autohelperpat1205(int trans, int move, int color, int action)
{
  int c, d, A, B;
  UNUSED(color);

  c = AFFINE_TRANSFORM(759, trans, move);
  d = AFFINE_TRANSFORM(721, trans, move);
  A = AFFINE_TRANSFORM(758, trans, move);
  B = AFFINE_TRANSFORM(722, trans, move);

  if (!action)
    return countlib(d)<4 && (accuratelib(move, OTHER_COLOR(color), MAX_LIBERTIES, NULL)>1 || countlib(d)<3)&& play_attack_defend_n(color, 0, 1, move, A) && play_attack_defend_n(color, 0, 1, move, B)&& !play_attack_defend_n(color, 1, 1, move, c);
  test_attack_either_move(move, color, A, B);

  return 0;
}

static int
autohelperpat1206(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);

  a = AFFINE_TRANSFORM(646, trans, move);
  b = AFFINE_TRANSFORM(647, trans, move);
  c = AFFINE_TRANSFORM(609, trans, move);

  if (!action)
    return safe_move(a, OTHER_COLOR(color)) && !play_attack_defend2_n(OTHER_COLOR(color), 0, 1, a, b, c) && play_attack_defend2_n(color, 0, 2, move, a, b, c);
  add_all_move(move, DEFEND_STRING, b, DEFEND_STRING, c);;

  return 0;
}

static int
autohelperpat1207(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(646, trans, move);
  b = AFFINE_TRANSFORM(609, trans, move);

  return play_connect_n(color, 0, 2, move, a, move, b);
}

static int
autohelperpat1208(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);

  a = AFFINE_TRANSFORM(647, trans, move);
  b = AFFINE_TRANSFORM(648, trans, move);
  c = AFFINE_TRANSFORM(610, trans, move);

  if (!action)
    return safe_move(a, OTHER_COLOR(color)) && !play_attack_defend2_n(OTHER_COLOR(color), 0, 1, a, b, c) && play_attack_defend2_n(color, 0, 2, move, a, b, c);
  add_all_move(move, DEFEND_STRING, b, DEFEND_STRING, c);;

  return 0;
}

static int
autohelperpat1209(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);

  a = AFFINE_TRANSFORM(758, trans, move);
  b = AFFINE_TRANSFORM(721, trans, move);
  c = AFFINE_TRANSFORM(759, trans, move);

  if (!action)
    return ((dragon[b].status == ALIVE) || (dragon[c].status == ALIVE))&& safe_move(a, OTHER_COLOR(color))==WIN && !play_attack_defend2_n(OTHER_COLOR(color), 0, 1, a, b, c) && play_attack_defend_n(color, 1, 2, move, a, a)==WIN;
  add_all_move(move, DEFEND_STRING, b, DEFEND_STRING, c);;

  return 0;
}

static int
autohelperpat1210(int trans, int move, int color, int action)
{
  int A, B;
  UNUSED(color);

  A = AFFINE_TRANSFORM(646, trans, move);
  B = AFFINE_TRANSFORM(722, trans, move);

  if (!action)
    return  !ATTACK_MACRO(A) && !ATTACK_MACRO(B) && play_attack_defend_n(color, 1, 1, move, A) && play_attack_defend_n(color, 1, 1, move, B);
  test_attack_either_move(move, color, A, B);

  return 0;
}

static int
autohelperpat1211(int trans, int move, int color, int action)
{
  int c, d, A, B, E;
  UNUSED(color);

  c = AFFINE_TRANSFORM(685, trans, move);
  d = AFFINE_TRANSFORM(721, trans, move);
  A = AFFINE_TRANSFORM(647, trans, move);
  B = AFFINE_TRANSFORM(683, trans, move);
  E = AFFINE_TRANSFORM(646, trans, move);

  if (!action)
    return countlib(A)==3 && !play_attack_defend_n(color, 1, 1, move, E) && play_attack_defend_n(color, 1, 2, move, d, A)&& !play_attack_defend2_n(color, 0, 3, move, c, d, A, B);
  test_attack_either_move(move, color, A, B);

  return 0;
}

static int
autohelperpat1212(int trans, int move, int color, int action)
{
  int a, b, c, d, e;
  UNUSED(color);

  a = AFFINE_TRANSFORM(647, trans, move);
  b = AFFINE_TRANSFORM(683, trans, move);
  c = AFFINE_TRANSFORM(685, trans, move);
  d = AFFINE_TRANSFORM(721, trans, move);
  e = AFFINE_TRANSFORM(646, trans, move);

  if (!action)
    return countlib(a)==3 && !ATTACK_MACRO(e) && play_attack_defend_n(OTHER_COLOR(color), 1, 2, move, d, a)&& !play_attack_defend2_n(OTHER_COLOR(color), 0, 3, move, c, d, a, b);
  add_all_move(move, DEFEND_STRING, a, DEFEND_STRING, b);

  return 0;
}

static int
autohelperpat1214(int trans, int move, int color, int action)
{
  UNUSED(trans);
  UNUSED(color);
  UNUSED(action);

  UNUSED(move);

  add_antisuji_move(move);;

  return 0;
}

static int
autohelperpat1215(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(721, trans, move);
  b = AFFINE_TRANSFORM(646, trans, move);

  add_antisuji_move(move);add_antisuji_move(a);add_antisuji_move(b);;

  return 0;
}

static int
autohelperpat1216(int trans, int move, int color, int action)
{
  UNUSED(trans);
  UNUSED(color);
  UNUSED(action);

  UNUSED(move);

  add_antisuji_move(move);;

  return 0;
}

static int
autohelperpat1217(int trans, int move, int color, int action)
{
  int a, b, c, d, e, f, G;
  UNUSED(color);

  a = AFFINE_TRANSFORM(756, trans, move);
  b = AFFINE_TRANSFORM(793, trans, move);
  c = AFFINE_TRANSFORM(830, trans, move);
  d = AFFINE_TRANSFORM(757, trans, move);
  e = AFFINE_TRANSFORM(794, trans, move);
  f = AFFINE_TRANSFORM(831, trans, move);
  G = AFFINE_TRANSFORM(608, trans, move);

  if (!action)
    return !dragon_weak(G) && somewhere(OTHER_COLOR(color), 1, 6, a, b, c, d, e, f);
  add_antisuji_move(move);;

  return 0;
}

static int
autohelperpat1219(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(683, trans, move);

  add_antisuji_move(move);add_antisuji_move(a);;

  return 0;
}

static struct pattern_attribute attributes[] = {
#ifdef HAVE_TRANSPARENT_UNIONS
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=5.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-8.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-8.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {FOLLOWUP,{.value=5.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {REVERSE_FOLLOWUP,{.value=6.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {REVERSE_FOLLOWUP,{.value=6.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {REVERSE_FOLLOWUP,{.value=2.500000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {FOLLOWUP,{.value=8.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {REVERSE_FOLLOWUP,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {REVERSE_FOLLOWUP,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {FOLLOWUP,{.value=4.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {REVERSE_FOLLOWUP,{.value=6.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {REVERSE_FOLLOWUP,{.value=6.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {REVERSE_FOLLOWUP,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {FOLLOWUP,{.value=6.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {FOLLOWUP,{.value=6.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {REVERSE_FOLLOWUP,{.value=2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {REVERSE_FOLLOWUP,{.value=5.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {FOLLOWUP,{.value=8.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {FOLLOWUP,{.value=8.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {FOLLOWUP,{.value=5.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {FOLLOWUP,{.value=8.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {REVERSE_FOLLOWUP,{.value=8.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-0.500000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {FOLLOWUP,{.value=5.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {FOLLOWUP,{.value=5.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {FOLLOWUP,{.value=5.000000}},
  {SHAPE,{.value=2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {FOLLOWUP,{.value=20.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {REVERSE_FOLLOWUP,{.value=5.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {FOLLOWUP,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {FOLLOWUP,{.value=5.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {REVERSE_FOLLOWUP,{.value=2.000000}},
  {FOLLOWUP,{.value=1.000000}},
  {MIN_TERRITORY,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {FOLLOWUP,{.value=7.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {FOLLOWUP,{.value=8.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {FOLLOWUP,{.value=5.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {FOLLOWUP,{.value=5.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {FOLLOWUP,{.value=5.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {FOLLOWUP,{.value=7.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {FOLLOWUP,{.value=10.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {FOLLOWUP,{.value=6.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {REVERSE_FOLLOWUP,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {FOLLOWUP,{.value=5.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=20.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {REVERSE_FOLLOWUP,{.value=8.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {FOLLOWUP,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {FOLLOWUP,{.value=8.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {FOLLOWUP,{.value=8.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {REVERSE_FOLLOWUP,{.value=10.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_TERRITORY,{.value=5.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_TERRITORY,{.value=6.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_TERRITORY,{.value=7.000000}},
  {FOLLOWUP,{.value=20.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_TERRITORY,{.value=7.000000}},
  {REVERSE_FOLLOWUP,{.value=20.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_TERRITORY,{.value=7.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_TERRITORY,{.value=6.000000}},
  {FOLLOWUP,{.value=14.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_TERRITORY,{.value=6.000000}},
  {FOLLOWUP,{.value=14.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_TERRITORY,{.value=14.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_TERRITORY,{.value=6.000000}},
  {REVERSE_FOLLOWUP,{.value=14.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_TERRITORY,{.value=7.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_TERRITORY,{.value=7.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_TERRITORY,{.value=8.000000}},
  {FOLLOWUP,{.value=16.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_TERRITORY,{.value=8.000000}},
  {REVERSE_FOLLOWUP,{.value=16.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_TERRITORY,{.value=8.000000}},
  {FOLLOWUP,{.value=16.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_TERRITORY,{.value=8.000000}},
  {REVERSE_FOLLOWUP,{.value=16.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_TERRITORY,{.value=9.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_TERRITORY,{.value=9.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_TERRITORY,{.value=9.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_TERRITORY,{.value=9.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=40.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=40.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=30.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=30.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=30.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=30.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=20.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=10.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=10.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=5.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=5.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=5.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=8.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {FOLLOWUP,{.value=5.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {REVERSE_FOLLOWUP,{.value=5.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_TERRITORY,{.value=3.000000}},
  {FOLLOWUP,{.value=2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=5.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=5.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=4.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=5.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=4.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=0.500000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=0.500000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=4.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=30.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=40.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=40.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=40.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=40.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=40.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=70.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MIN_VALUE,{.value=60.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-10.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=5.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=5.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=5.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=7.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=5.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=4.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=5.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-4.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-5.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=5.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {REVERSE_FOLLOWUP,{.value=5.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {REVERSE_FOLLOWUP,{.value=5.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {REVERSE_FOLLOWUP,{.value=5.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {REVERSE_FOLLOWUP,{.value=5.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {FOLLOWUP,{.value=5.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {FOLLOWUP,{.value=6.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {FOLLOWUP,{.value=6.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {FOLLOWUP,{.value=6.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {FOLLOWUP,{.value=10.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {FOLLOWUP,{.value=6.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {FOLLOWUP,{.value=8.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {FOLLOWUP,{.value=6.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {FOLLOWUP,{.value=5.000000}},
  {SHAPE,{.value=1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {FOLLOWUP,{.value=9.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {REVERSE_FOLLOWUP,{.value=5.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {FOLLOWUP,{.value=5.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {REVERSE_FOLLOWUP,{.value=5.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {REVERSE_FOLLOWUP,{.value=5.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {REVERSE_FOLLOWUP,{.value=5.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {REVERSE_FOLLOWUP,{.value=1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {REVERSE_FOLLOWUP,{.value=2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {REVERSE_FOLLOWUP,{.value=3.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {REVERSE_FOLLOWUP,{.value=8.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-1.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=2.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {MAX_VALUE,{.value=25.000000}},
  {LAST_ATTRIBUTE,{.offset=0}},
  {SHAPE,{.value=-10.000000}},
  {LAST_ATTRIBUTE,{.offset=0}}
#else
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,5.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-8.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-8.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {FOLLOWUP,5.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {REVERSE_FOLLOWUP,6.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {REVERSE_FOLLOWUP,6.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {REVERSE_FOLLOWUP,2.500000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {FOLLOWUP,8.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {REVERSE_FOLLOWUP,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {REVERSE_FOLLOWUP,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {FOLLOWUP,4.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {REVERSE_FOLLOWUP,6.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {REVERSE_FOLLOWUP,6.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {REVERSE_FOLLOWUP,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {FOLLOWUP,6.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {FOLLOWUP,6.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {REVERSE_FOLLOWUP,2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {REVERSE_FOLLOWUP,5.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {FOLLOWUP,8.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {FOLLOWUP,8.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {FOLLOWUP,5.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {FOLLOWUP,8.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {REVERSE_FOLLOWUP,8.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-0.500000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {FOLLOWUP,5.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {FOLLOWUP,5.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {FOLLOWUP,5.000000,0},
  {SHAPE,2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {FOLLOWUP,20.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {REVERSE_FOLLOWUP,5.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {FOLLOWUP,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {FOLLOWUP,5.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {REVERSE_FOLLOWUP,2.000000,0},
  {FOLLOWUP,1.000000,0},
  {MIN_TERRITORY,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {FOLLOWUP,7.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {FOLLOWUP,8.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {FOLLOWUP,5.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {FOLLOWUP,5.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {FOLLOWUP,5.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {FOLLOWUP,7.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {FOLLOWUP,10.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {FOLLOWUP,6.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {REVERSE_FOLLOWUP,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {FOLLOWUP,5.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,20.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {REVERSE_FOLLOWUP,8.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {FOLLOWUP,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {FOLLOWUP,8.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {FOLLOWUP,8.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {REVERSE_FOLLOWUP,10.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_TERRITORY,5.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_TERRITORY,6.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_TERRITORY,7.000000,0},
  {FOLLOWUP,20.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_TERRITORY,7.000000,0},
  {REVERSE_FOLLOWUP,20.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_TERRITORY,7.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_TERRITORY,6.000000,0},
  {FOLLOWUP,14.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_TERRITORY,6.000000,0},
  {FOLLOWUP,14.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_TERRITORY,14.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_TERRITORY,6.000000,0},
  {REVERSE_FOLLOWUP,14.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_TERRITORY,7.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_TERRITORY,7.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_TERRITORY,8.000000,0},
  {FOLLOWUP,16.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_TERRITORY,8.000000,0},
  {REVERSE_FOLLOWUP,16.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_TERRITORY,8.000000,0},
  {FOLLOWUP,16.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_TERRITORY,8.000000,0},
  {REVERSE_FOLLOWUP,16.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_TERRITORY,9.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_TERRITORY,9.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_TERRITORY,9.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_TERRITORY,9.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,40.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,40.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,30.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,30.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,30.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,30.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,20.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,10.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,10.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,5.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,5.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,5.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,8.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {FOLLOWUP,5.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {REVERSE_FOLLOWUP,5.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_TERRITORY,3.000000,0},
  {FOLLOWUP,2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,5.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,5.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,4.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,5.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,4.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,0.500000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,0.500000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,4.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,30.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,40.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,40.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,40.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,40.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,40.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,70.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MIN_VALUE,60.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-10.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,5.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,5.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,5.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,7.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,5.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,4.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,5.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-4.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-5.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,5.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {REVERSE_FOLLOWUP,5.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {REVERSE_FOLLOWUP,5.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {REVERSE_FOLLOWUP,5.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {REVERSE_FOLLOWUP,5.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {FOLLOWUP,5.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {FOLLOWUP,6.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {FOLLOWUP,6.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {FOLLOWUP,6.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {FOLLOWUP,10.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {FOLLOWUP,6.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {FOLLOWUP,8.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {FOLLOWUP,6.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {FOLLOWUP,5.000000,0},
  {SHAPE,1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {FOLLOWUP,9.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {REVERSE_FOLLOWUP,5.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {FOLLOWUP,5.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {REVERSE_FOLLOWUP,5.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {REVERSE_FOLLOWUP,5.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {REVERSE_FOLLOWUP,5.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {REVERSE_FOLLOWUP,1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {REVERSE_FOLLOWUP,2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {REVERSE_FOLLOWUP,3.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {REVERSE_FOLLOWUP,8.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-1.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,2.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {MAX_VALUE,25.000000,0},
  {LAST_ATTRIBUTE,0.0,0},
  {SHAPE,-10.000000,0},
  {LAST_ATTRIBUTE,0.0,0}
#endif
};

static struct pattern pat[] = {
  {pat0,6,8, "CC1",-1,0,1,3,2,3,0x0,721,
    { 0x0c3f3f00, 0x00f0fcf0, 0xf0f0c000, 0xfc3c0000, 0xfcf00000, 0x3f3f0c00, 0x003cfc3c, 0xc0f0f000},
    { 0x00100800, 0x00108000, 0x80100000, 0x08100000, 0x80100000, 0x08100000, 0x00100800, 0x00108000}
   , 0x100,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat1,4,8, "CC2",0,-2,2,0,2,2,0x0,648,
    { 0x00f0f0c0, 0xf0f00000, 0x3f3c0000, 0x003c3f0c, 0x00f0f0c0, 0xf0f00000, 0x3f3c0000, 0x003c3f0c},
    { 0x00201080, 0x00600000, 0x11200000, 0x00240204, 0x00600040, 0x10200000, 0x02240000, 0x00201108}
   , 0x2a0,0.000000,attributes+0,1,NULL,autohelperpat1,3,3.600000},
  {pat2,4,2, "CC3",0,-1,2,1,2,2,0x0,685,
    { 0x0030fc30, 0xc0f0c000, 0xfc300000, 0x0c3f0c00, 0xc0f0c000, 0xfc300000, 0x0c3f0c00, 0x0030fc30},
    { 0x00108810, 0x80108000, 0x88100000, 0x08110800, 0x80108000, 0x88100000, 0x08110800, 0x00108810}
   , 0x201,0.000000,attributes+0,1,NULL,autohelperpat2,0,0.016000},
  {pat3,4,8, "CC4",0,0,2,2,2,2,0x0,722,
    { 0x003c3f0c, 0x00f0f0c0, 0xf0f00000, 0x3f3c0000, 0xf0f00000, 0x3f3c0000, 0x003c3f0c, 0x00f0f0c0},
    { 0x00102204, 0x00900080, 0x20100000, 0x01180000, 0x00900000, 0x22100000, 0x00180108, 0x00102040}
   , 0x200,0.000000,attributes+0,1,NULL,autohelperpat3,0,0.019600},
  {pat4,4,4, "CC5",-2,0,1,2,3,2,0x0,721,
    { 0x3f3f0c00, 0x003cfc3c, 0xc0f0f000, 0xfcf00000, 0xfc3c0000, 0x0c3f3f00, 0x00f0fcf0, 0xf0f0c000},
    { 0x00220400, 0x00204020, 0x40200000, 0x04200000, 0x40200000, 0x04220000, 0x00200420, 0x00204000}
   , 0x201,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat5,10,8, "CC6",-1,0,1,4,2,4,0x0,795,
    { 0x053f3f00, 0x00f0f4f4, 0xf0f04000, 0x7c3c0000, 0xf4f00000, 0x3f3f0500, 0x003c7c7c, 0x40f0f000},
    { 0x00251000, 0x00601010, 0x10600000, 0x10240000, 0x10600000, 0x10250000, 0x00241010, 0x00601000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat5,3,0.610000},
  {pat6,5,4, "CC7",0,0,2,2,2,2,0x0,722,
    { 0x003c3f0c, 0x00f0f0c0, 0xf0f00000, 0x3f3c0000, 0xf0f00000, 0x3f3c0000, 0x003c3f0c, 0x00f0f0c0},
    { 0x00182000, 0x00902000, 0x20900000, 0x20180000, 0x20900000, 0x20180000, 0x00182000, 0x00902000}
   , 0x201,0.000000,attributes+0,1,NULL,autohelperpat6,0,0.016000},
  {pat7,9,8, "CC8",0,-2,3,1,3,3,0x0,723,
    { 0x0030f4fc, 0xc0f04000, 0x7c300000, 0x073f0f03, 0x40f0c000, 0xf4300000, 0x0f3f0700, 0x00307cff},
    { 0x00206010, 0x40a00000, 0x24200000, 0x00290401, 0x00a04000, 0x60200000, 0x04290000, 0x00202411}
   , 0x201,0.000000,attributes+0,1,NULL,autohelperpat7,3,1.600000},
  {pat8,6,8, "CC9",0,-1,2,1,2,2,0x0,686,
    { 0x0030f0fc, 0xc0f00000, 0x3c300000, 0x033f0f00, 0x00f0c000, 0xf0300000, 0x0f3f0300, 0x00303cfc},
    { 0x00109008, 0x80500000, 0x18100000, 0x02140800, 0x00508000, 0x90100000, 0x08140200, 0x00101880}
   , 0x201,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat9,6,4, "CC10",0,0,2,2,2,2,0x0,722,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00120020, 0x00100020, 0x00100000, 0x00120000, 0x00100000, 0x00120000, 0x00120020, 0x00100020}
   , 0x201,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat10,6,4, "CC10b",0,0,2,2,2,2,0x0,722,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00120020, 0x00100020, 0x00100000, 0x00120000, 0x00100000, 0x00120000, 0x00120020, 0x00100020}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat11,4,8, "CC11",0,-2,2,0,2,2,0x0,648,
    { 0x00f0f0c0, 0xf0f00000, 0x3c3e0000, 0x003c3f20, 0x00f0f020, 0xf0f00000, 0x3f3c0000, 0x003e3c0c},
    { 0x00201080, 0x00600000, 0x10200000, 0x00240200, 0x00600000, 0x10200000, 0x02240000, 0x00201008}
   , 0x221,0.000000,attributes+0,1,NULL,autohelperpat11,3,1.600000},
  {pat12,4,8, "CC12",0,-2,2,0,2,2,0x0,648,
    { 0x00f0f0f0, 0xf0f00000, 0x3f3c0000, 0x003f3f0c, 0x00f0f0c0, 0xf0f00000, 0x3f3f0000, 0x003c3f3c},
    { 0x00200090, 0x00200000, 0x01200000, 0x00210204, 0x00200040, 0x00200000, 0x02210000, 0x00200118}
   , 0x200,0.000000,attributes+0,1,NULL,autohelperpat12,3,0.376000},
  {pat13,4,8, "CC13",0,0,2,1,2,1,0x0,685,
    { 0x00303c3c, 0x00f0c000, 0xf0300000, 0x0f3f0000, 0xc0f00000, 0x3c300000, 0x003f0f00, 0x0030f0f0},
    { 0x00100824, 0x00108000, 0x80100000, 0x09120000, 0x80100000, 0x08100000, 0x00120900, 0x00108060}
   , 0x220,0.000000,attributes+1,1,NULL,autohelperpat13,0,1.810000},
  {pat14,4,8, "CC13b",0,0,2,1,2,1,0x0,685,
    { 0x00303c3c, 0x00f0c000, 0xf0300000, 0x0f3f0000, 0xc0f00000, 0x3c300000, 0x003f0f00, 0x0030f0f0},
    { 0x00100824, 0x00108000, 0x80100000, 0x09120000, 0x80100000, 0x08100000, 0x00120900, 0x00108060}
   , 0x1000,0.000000,attributes+0,1,NULL,autohelperpat14,0,0.010000},
  {pat15,6,8, "CC14",0,-1,3,1,3,2,0x0,686,
    { 0x00fcfcfc, 0xf0f0f000, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xfcfc0000, 0x3f3f3f00, 0x00fcfcfc},
    { 0x00100080, 0x00100000, 0x00100000, 0x00100200, 0x00100000, 0x00100000, 0x02100000, 0x00100008}
   , 0x81,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat16,4,8, "CC15",0,-1,1,2,1,3,0x0,685,
    { 0x003fff00, 0xc0f0f0f0, 0xfcf00000, 0x3c3c0c00, 0xf0f0c000, 0xff3f0000, 0x0c3c3c3c, 0x00f0fc00},
    { 0x00214200, 0x40200090, 0x04200000, 0x00200400, 0x00204000, 0x42210000, 0x04200018, 0x00200400}
   , 0x200,0.000000,attributes+0,1,NULL,autohelperpat16,3,1.744000},
  {pat17,5,8, "CC16",0,0,2,2,2,2,0x0,685,
    { 0x003f3f34, 0x00f0f0f0, 0xf0f00000, 0x3d3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3d3c, 0x00f0f070},
    { 0x00210210, 0x00200090, 0x00200000, 0x00210000, 0x00200000, 0x02210000, 0x00210018, 0x00200010}
   , 0x200,0.000000,attributes+0,1,NULL,autohelperpat17,3,1.744000},
  {pat18,5,8, "CC17",0,-1,2,2,2,3,0x0,685,
    { 0x003ffff0, 0xc0f0f0f0, 0xfcf00000, 0x3c3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3c3c, 0x00f0fc3c},
    { 0x00210240, 0x00200090, 0x00200000, 0x00200100, 0x00200000, 0x02210000, 0x01200018, 0x00200004}
   , 0x200,0.000000,attributes+0,1,NULL,autohelperpat18,3,1.744000},
  {pat19,8,8, "CC19",0,-1,3,1,3,2,0x0,685,
    { 0x00fcfcfc, 0xf0f0f000, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xfcfc0000, 0x3f3f3f00, 0x00fcfcfc},
    { 0x00108000, 0x80100000, 0x08100000, 0x00100800, 0x00108000, 0x80100000, 0x08100000, 0x00100800}
   , 0x81,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat20,7,8, "CC20",0,-1,3,2,3,3,0x0,686,
    { 0x00fcfcff, 0xf0f0f000, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xfcfc0000, 0x3f3f3f03, 0x00fcfcfc},
    { 0x00100002, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100002, 0x00100000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat20,0,0.376000},
  {pat21,7,8, "CC21",0,-1,3,2,3,3,0x0,685,
    { 0x003cffff, 0xc0f0f0c0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3c0000, 0x0f3f3f0f, 0x00f0fcfc},
    { 0x00200141, 0x00200040, 0x00200000, 0x00200100, 0x00200000, 0x01200000, 0x01200005, 0x00200004}
   , 0x80,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat22,8,8, "CC22",0,-1,3,2,3,3,0x0,722,
    { 0x003cffff, 0xc0f0f0c0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3c0000, 0x0f3f3f0f, 0x00f0fcfc},
    { 0x00100280, 0x00100080, 0x00100000, 0x00100200, 0x00100000, 0x02100000, 0x02100008, 0x00100008}
   , 0x80,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat23,9,8, "CC23",0,-1,3,2,3,3,0x0,722,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x00110280, 0x00100090, 0x00100000, 0x00100200, 0x00100000, 0x02110000, 0x02100018, 0x00100008}
   , 0x80,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat24,9,8, "CC24",0,-1,3,2,3,3,0x0,723,
    { 0x003cffff, 0xc0f0f0c0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3c0000, 0x0f3f3f0f, 0x00f0fcfc},
    { 0x00201941, 0x00608040, 0x90200000, 0x08240100, 0x80600000, 0x19200000, 0x01240805, 0x00209004}
   , 0x80,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat25,7,8, "CC25",0,-1,2,2,2,3,0x0,722,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x00210049, 0x00200010, 0x00200000, 0x02200100, 0x00200000, 0x00210000, 0x01200211, 0x00200084}
   , 0x200,0.000000,attributes+0,1,NULL,autohelperpat25,3,0.010000},
  {pat26,8,8, "CC26",0,-1,2,3,2,4,0x0,722,
    { 0x003effff, 0xc0f0f0e0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3e0000, 0x0f3f3f2f, 0x00f0fcfc},
    { 0x00200049, 0x00200000, 0x00200000, 0x02200100, 0x00200000, 0x00200000, 0x01200201, 0x00200084}
   , 0x200,0.000000,attributes+0,1,NULL,autohelperpat26,3,0.016000},
  {pat27,6,8, "CC27",-1,0,1,3,2,3,0x0,721,
    { 0x033f0f00, 0x0030f0fc, 0xc0f00000, 0x3c300000, 0xf0300000, 0x0f3f0300, 0x00303cfc, 0x00f0c000},
    { 0x00100900, 0x00108040, 0x80100000, 0x08100000, 0x80100000, 0x09100000, 0x00100804, 0x00108000}
   , 0xa0,0.000000,attributes+0,1,NULL,autohelperpat27,0,1.000000},
  {pat28,15,8, "CC28",0,0,4,4,4,4,0x0,759,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00100020, 0x00100000, 0x00100000, 0x00120000, 0x00100000, 0x00100000, 0x00120000, 0x00100020}
   , 0x4000,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat29,4,8, "CC29",0,-2,2,0,2,2,0x0,648,
    { 0x00f0f0c0, 0xf0f00000, 0x3f3c0000, 0x003c3f0f, 0x00f0f0c0, 0xf0f00000, 0x3f3c0000, 0x003c3f0f},
    { 0x00100000, 0x00100000, 0x02100000, 0x00100009, 0x00100080, 0x00100000, 0x00100000, 0x00100201}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat29,0,0.016000},
  {pat30,5,8, "CC30",0,-1,2,1,2,2,0x0,721,
    { 0x003cfc3c, 0xc0f0f000, 0xfcf00000, 0x3f3f0c00, 0xf0f0c000, 0xfc3c0000, 0x0c3f3f00, 0x00f0fcf0},
    { 0x00108410, 0x80104000, 0x48100000, 0x04110800, 0x40108000, 0x84100000, 0x08110400, 0x00104810}
   , 0xa0,0.000000,attributes+0,1,NULL,autohelperpat30,0,10.000000},
  {pat31,5,4, "CC31",0,-1,2,1,2,2,0x0,685,
    { 0x003cfc3c, 0xc0f0f000, 0xfcf00000, 0x3f3f0c00, 0xf0f0c000, 0xfc3c0000, 0x0c3f3f00, 0x00f0fcf0},
    { 0x00108410, 0x80104000, 0x48100000, 0x04110800, 0x40108000, 0x84100000, 0x08110400, 0x00104810}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat31,0,10.000000},
  {pat32,5,4, "CC32",0,-1,2,1,2,2,0x0,685,
    { 0x003cfc3c, 0xc0f0f000, 0xfcf00000, 0x3f3f0c00, 0xf0f0c000, 0xfc3c0000, 0x0c3f3f00, 0x00f0fcf0},
    { 0x00204820, 0x40208000, 0x84200000, 0x08220400, 0x80204000, 0x48200000, 0x04220800, 0x00208420}
   , 0x0,0.000000,attributes+0,3,NULL,autohelperpat32,3,4.800000},
  {pat33,7,8, "CC33",0,0,2,3,2,3,0x0,685,
    { 0x003f3f3c, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3c, 0x00f0f0f0},
    { 0x00240008, 0x00201000, 0x00600000, 0x12200000, 0x10200000, 0x00240000, 0x00201200, 0x00600080}
   , 0x201,0.000000,attributes+0,1,NULL,autohelperpat33,3,1.000000},
  {pat34,6,8, "CC34",-1,0,1,3,2,3,0x0,758,
    { 0x3f3f3f00, 0x00fcfcfc, 0xf0f0f000, 0xfcfc0000, 0xfcfc0000, 0x3f3f3f00, 0x00fcfcfc, 0xf0f0f000},
    { 0x00100200, 0x00100080, 0x00100000, 0x00100000, 0x00100000, 0x02100000, 0x00100008, 0x00100000}
   , 0x80,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat35,6,8, "CC35",0,0,3,2,3,2,0x0,723,
    { 0x00303f3f, 0x00f0c0c0, 0xf0300000, 0x0f3f0000, 0xc0f00000, 0x3f300000, 0x003f0f0f, 0x0030f0f0},
    { 0x00100222, 0x00100080, 0x00100000, 0x00120000, 0x00100000, 0x02100000, 0x0012000a, 0x00100020}
   , 0x201,0.000000,attributes+0,1,NULL,autohelperpat35,0,1.600000},
  {pat36,12,8, "CC36",0,-1,3,3,3,4,0x0,686,
    { 0x0038bf7f, 0x80f0e0c0, 0xf8b00000, 0x2f3f0900, 0xe0f08000, 0xbf380000, 0x093f2f0f, 0x00b0f8f4},
    { 0x00100408, 0x00104000, 0x40100000, 0x06100000, 0x40100000, 0x04100000, 0x00100600, 0x00104080}
   , 0x84,0.000000,attributes+0,1,NULL,autohelperpat36,0,0.610000},
  {pat37,10,8, "CC37",0,-1,3,2,3,3,0x0,686,
    { 0x0038bf3f, 0x80f0e0c0, 0xf8b00000, 0x2f3f0800, 0xe0f08000, 0xbf380000, 0x083f2f0f, 0x00b0f8f0},
    { 0x00100608, 0x00104080, 0x40100000, 0x06100000, 0x40100000, 0x06100000, 0x00100608, 0x00104080}
   , 0x84,0.000000,attributes+0,1,NULL,autohelperpat37,0,0.610000},
  {pat38,11,8, "CC38",0,-1,3,2,3,3,0x0,686,
    { 0x0038bf3f, 0x80f0e0c0, 0xf8b00000, 0x2f3f0800, 0xe0f08000, 0xbf380000, 0x083f2f0f, 0x00b0f8f0},
    { 0x00100408, 0x00104000, 0x40100000, 0x06100000, 0x40100000, 0x04100000, 0x00100600, 0x00104080}
   , 0x84,0.000000,attributes+0,1,NULL,autohelperpat38,0,0.610000},
  {pat39,4,8, "CC39",0,-1,2,1,2,2,0x0,722,
    { 0x003cfc3c, 0xc0f0f000, 0xfcf00000, 0x3f3f0c00, 0xf0f0c000, 0xfc3c0000, 0x0c3f3f00, 0x00f0fcf0},
    { 0x00102010, 0x00900000, 0x20100000, 0x00190000, 0x00900000, 0x20100000, 0x00190000, 0x00102010}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat39,0,1.024000},
  {pat40,8,8, "CC40",0,-1,2,2,2,3,0x0,721,
    { 0x003dff3c, 0xc0f0f0d0, 0xfcf00000, 0x3f3f0c00, 0xf0f0c000, 0xff3d0000, 0x0c3f3f1c, 0x00f0fcf0},
    { 0x0010a610, 0x80904080, 0x68100000, 0x04190800, 0x40908000, 0xa6100000, 0x08190408, 0x00106810}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat40,0,1.000000},
  {pat41,7,8, "CC41",0,-1,2,2,2,3,0x0,722,
    { 0x003cffbc, 0xc0f0f0c0, 0xfcf00000, 0x3f3f0e00, 0xf0f0c000, 0xff3c0000, 0x0e3f3f0c, 0x00f0fcf8},
    { 0x00284108, 0x40202040, 0x04a00000, 0x22200400, 0x20204000, 0x41280000, 0x04202204, 0x00a00480}
   , 0x201,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat42,14,4, "CC42",0,0,2,4,2,4,0x0,759,
    { 0x003f2b3f, 0x00b0b0f0, 0xa0f00000, 0x3b3b0000, 0xb0b00000, 0x2b3f0000, 0x003b3b3f, 0x00f0a0f0},
    { 0x00120012, 0x00100020, 0x00100000, 0x00110000, 0x00100000, 0x00120000, 0x00110022, 0x00100010}
   , 0x201,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat43,4,8, "CC43",0,0,2,1,2,1,0x0,685,
    { 0x003c3c3c, 0x00f0f000, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3c3c0000, 0x003f3f00, 0x00f0f0f0},
    { 0x00240008, 0x00201000, 0x00600000, 0x12200000, 0x10200000, 0x00240000, 0x00201200, 0x00600080}
   , 0x201,0.000000,attributes+0,1,NULL,autohelperpat43,3,3.000000},
  {pat44,7,8, "CC44",0,0,2,2,2,2,0x0,759,
    { 0x003f3f0f, 0x00f0f0f0, 0xf0f00000, 0x3f3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3f3f, 0x00f0f0c0},
    { 0x00122408, 0x00904020, 0x60100000, 0x06180000, 0x40900000, 0x24120000, 0x00180620, 0x00106080}
   , 0x201,0.000000,attributes+0,1,NULL,autohelperpat44,0,2.176000},
  {pat45,8,8, "CC45",-1,0,1,3,2,3,0x0,721,
    { 0x3f3f0f00, 0x003cfcfc, 0xc0f0f000, 0xfcf00000, 0xfc3c0000, 0x0f3f3f00, 0x00f0fcfc, 0xf0f0c000},
    { 0x00110a00, 0x00108090, 0x80100000, 0x08100000, 0x80100000, 0x0a110000, 0x00100818, 0x00108000}
   , 0x280,0.000000,attributes+0,1,NULL,autohelperpat45,0,0.019600},
  {pat46,5,8, "CC46",0,-1,2,1,2,2,0x0,685,
    { 0x00fcfcfc, 0xf0f0f000, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xfcfc0000, 0x3f3f3f00, 0x00fcfcfc},
    { 0x00240064, 0x00201000, 0x00600000, 0x11220100, 0x10200000, 0x00240000, 0x01221100, 0x00600064}
   , 0x201,0.000000,attributes+0,1,NULL,autohelperpat46,3,1.600000},
  {pat47,8,8, "CC47",0,-3,2,0,2,3,0x0,610,
    { 0x00f0f0c0, 0xf0f00000, 0x3f3f0000, 0x003c3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3c0000, 0x003f3f0f},
    { 0x00202040, 0x00a00000, 0x20200000, 0x00280101, 0x00a00000, 0x20200000, 0x01280000, 0x00202005}
   , 0x201,0.000000,attributes+0,1,NULL,autohelperpat47,3,1.600000},
  {pat48,7,8, "CC48",0,0,2,2,2,2,0x0,721,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00201012, 0x00600000, 0x10200000, 0x00250000, 0x00600000, 0x10200000, 0x00250002, 0x00201010}
   , 0x201,0.000000,attributes+0,1,NULL,autohelperpat48,3,3.000000},
  {pat49,7,8, "CC49",0,-3,2,0,2,3,0x0,611,
    { 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3f},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200002, 0x00200000, 0x00200000, 0x00200000, 0x00200002}
   , 0x201,0.000000,attributes+0,1,NULL,autohelperpat49,3,2.890000},
  {pat50,7,8, "CC50",0,-2,2,2,2,4,0x0,685,
    { 0x00fcfcfc, 0xf0f0f000, 0xfffe0000, 0x3f3f3f2e, 0xf0f0f0e0, 0xfcfc0000, 0x3f3f3f00, 0x00fefffe},
    { 0x00200060, 0x00200000, 0x01200000, 0x00220104, 0x00200040, 0x00200000, 0x01220000, 0x00200124}
   , 0x201,0.000000,attributes+0,1,NULL,autohelperpat50,3,1.056400},
  {pat51,5,8, "CC51",0,0,1,3,1,3,0x0,721,
    { 0x003f0f00, 0x0030f0f0, 0xc0f00000, 0x3c300000, 0xf0300000, 0x0f3f0000, 0x00303c3c, 0x00f0c000},
    { 0x00100900, 0x00108040, 0x80100000, 0x08100000, 0x80100000, 0x09100000, 0x00100804, 0x00108000}
   , 0xa0,0.000000,attributes+0,1,NULL,autohelperpat51,0,1.000000},
  {pat52,6,8, "CC52a",0,0,1,3,1,3,0x0,722,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00180000, 0x00102000, 0x00900000, 0x20100000, 0x20100000, 0x00180000, 0x00102000, 0x00900000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat52,0,2.176000},
  {pat53,9,8, "CC52b",-1,-1,2,3,3,4,0x0,722,
    { 0x00ffff3e, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3c00, 0xf0f0f000, 0xffff0000, 0x3c3f3f3e, 0x00fcfcf0},
    { 0x00180000, 0x00102000, 0x00900000, 0x20100000, 0x20100000, 0x00180000, 0x00102000, 0x00900000}
   , 0x100,0.000000,attributes+0,1,NULL,autohelperpat53,0,0.019600},
  {pat54,6,8, "CC53",0,0,2,2,2,2,0x0,722,
    { 0x003f3f03, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3f, 0x00f0f000},
    { 0x00291002, 0x00602010, 0x10a00000, 0x20240000, 0x20600000, 0x10290000, 0x00242012, 0x00a01000}
   , 0x200,0.000000,attributes+0,1,NULL,autohelperpat54,3,1.810000},
  {pat55,5,4, "CC54",0,0,2,2,2,2,0x0,722,
    { 0x003f3f0c, 0x00f0f0f0, 0xf0f00000, 0x3f3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3f3c, 0x00f0f0c0},
    { 0x00190000, 0x00102010, 0x00900000, 0x20100000, 0x20100000, 0x00190000, 0x00102010, 0x00900000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat55,0,1.600000},
  {pat56,5,4, "CC55",0,0,2,2,2,2,0x0,722,
    { 0x003f3f0c, 0x00f0f0f0, 0xf0f00000, 0x3f3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3f3c, 0x00f0f0c0},
    { 0x00260000, 0x00201020, 0x00600000, 0x10200000, 0x10200000, 0x00260000, 0x00201020, 0x00600000}
   , 0x201,0.000000,attributes+0,1,NULL,autohelperpat56,3,5.000000},
  {pat57,10,8, "CC57",0,-2,3,2,3,4,0x0,685,
    { 0x003cfefc, 0xc0f0f080, 0xfff00000, 0x3f3f0f0f, 0xf0f0c0c0, 0xfe3c0000, 0x0f3f3f08, 0x00f0ffff},
    { 0x00240004, 0x00201000, 0x00600000, 0x11200001, 0x10200000, 0x00240000, 0x00201100, 0x00600041}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat57,3,0.019600},
  {pat58,15,8, "CC58",0,0,3,3,3,3,0x0,759,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00202400, 0x00a04000, 0x60200000, 0x04280000, 0x40a00000, 0x24200000, 0x00280400, 0x00206000}
   , 0x201,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat59,6,8, "CC59",0,-1,2,2,2,3,0x0,722,
    { 0x0030ffff, 0xc0f0c0c0, 0xfc300000, 0x0f3f0f00, 0xc0f0c000, 0xff300000, 0x0f3f0f0f, 0x0030fcfc},
    { 0x00200149, 0x00200040, 0x00200000, 0x02200100, 0x00200000, 0x01200000, 0x01200205, 0x00200084}
   , 0x201,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat60,7,8, "CC60",0,-1,2,2,2,3,0x0,685,
    { 0x0030ffff, 0xc0f0c0c0, 0xfc300000, 0x0f3f0f00, 0xc0f0c000, 0xff300000, 0x0f3f0f0f, 0x0030fcfc},
    { 0x00200569, 0x00204040, 0x40200000, 0x06220100, 0x40200000, 0x05200000, 0x01220605, 0x002040a4}
   , 0x201,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat61,9,8, "CC61",0,0,2,3,2,3,0x0,723,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00212000, 0x00a00010, 0x20200000, 0x00280000, 0x00a00000, 0x20210000, 0x00280010, 0x00202000}
   , 0x201,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat62,6,2, "CC62",0,0,2,2,2,2,0x0,722,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00120021, 0x00100020, 0x00100000, 0x00120000, 0x00100000, 0x00120000, 0x00120021, 0x00100020}
   , 0x201,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat63,6,8, "CC63",0,-1,2,1,2,2,0x0,686,
    { 0x0030f0fc, 0xc0f00000, 0x3c300000, 0x033f0f00, 0x00f0c000, 0xf0300000, 0x0f3f0300, 0x00303cfc},
    { 0x00109008, 0x80500000, 0x18100000, 0x02140800, 0x00508000, 0x90100000, 0x08140200, 0x00101880}
   , 0x201,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat64,6,4, "CC64",0,0,2,2,2,2,0x0,722,
    { 0x003f3f1f, 0x00f0f0f0, 0xf0f00000, 0x3f3d0000, 0xf0f00000, 0x3f3f0000, 0x003d3f3f, 0x00f0f0d0},
    { 0x00100001, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100001, 0x00100000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat64,0,0.010000},
  {pat65,8,4, "CC65",0,-2,3,1,3,3,0x0,648,
    { 0x00f4f0f0, 0xf0f01000, 0x3f7f0000, 0x103f3f3f, 0x10f0f0f0, 0xf0f40000, 0x3f3f1000, 0x007f3f3f},
    { 0x00200010, 0x00200000, 0x00200000, 0x00210002, 0x00200000, 0x00200000, 0x00210000, 0x00200012}
   , 0x201,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat66,12,8, "CC66",0,-2,4,1,4,3,0x0,685,
    { 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff},
    { 0x00200000, 0x00200000, 0x01200000, 0x00200004, 0x00200040, 0x00200000, 0x00200000, 0x00200100}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat66,3,1.000000},
  {pat67,7,8, "CC67",0,0,2,2,2,2,0x0,721,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00122021, 0x00900020, 0x20100000, 0x001a0000, 0x00900000, 0x20120000, 0x001a0021, 0x00102020}
   , 0x201,0.000000,attributes+0,1,NULL,autohelperpat67,0,4.800000},
  {pat68,11,8, "CC68",0,-1,3,2,3,3,0x0,722,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x00100220, 0x00100080, 0x00100000, 0x00120000, 0x00100000, 0x02100000, 0x00120008, 0x00100020}
   , 0x201,0.000000,attributes+0,1,NULL,autohelperpat68,0,4.800000},
  {pat69,7,8, "CC69",-1,0,2,2,3,2,0x0,722,
    { 0x0c3f3f2f, 0x00f0fcf0, 0xf0f0c000, 0xff3e0000, 0xfcf00000, 0x3f3f0c00, 0x003eff3f, 0xc0f0f0e0},
    { 0x00190009, 0x00102010, 0x00900000, 0x22100000, 0x20100000, 0x00190000, 0x00102211, 0x00900080}
   , 0x201,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat70,7,8, "CC70",0,-1,2,2,2,3,0x0,722,
    { 0x003dff3f, 0xc0f0f0d0, 0xfcf00000, 0x3f3f0c00, 0xf0f0c000, 0xff3d0000, 0x0c3f3f1f, 0x00f0fcf0},
    { 0x00102210, 0x00900080, 0x20100000, 0x00190000, 0x00900000, 0x22100000, 0x00190008, 0x00102010}
   , 0x200,0.000000,attributes+0,1,NULL,autohelperpat70,0,1.096000},
  {pat71,7,8, "CC71",0,-1,2,2,2,3,0x0,722,
    { 0x003dff3f, 0xc0f0f0d0, 0xfcf00000, 0x3f3f0c00, 0xf0f0c000, 0xff3d0000, 0x0c3f3f1f, 0x00f0fcf0},
    { 0x00102210, 0x00900080, 0x20100000, 0x00190000, 0x00900000, 0x22100000, 0x00190008, 0x00102010}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat71,0,3.009600},
  {pat72,12,8, "CC72",-1,-1,2,3,3,4,0x0,758,
    { 0x3fffff3f, 0xf0fcfcfc, 0xfcfcf000, 0xffff3c00, 0xfcfcf000, 0xffff3f00, 0x3cffffff, 0xf0fcfcf0},
    { 0x00180400, 0x00106000, 0x40900000, 0x24100000, 0x60100000, 0x04180000, 0x00102400, 0x00904000}
   , 0x201,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat73,9,8, "CC73",0,-1,3,2,3,3,0x0,722,
    { 0x0030bfff, 0x80f0c0c0, 0xf8300000, 0x0f3f0b00, 0xc0f08000, 0xbf300000, 0x0b3f0f0f, 0x0030f8fc},
    { 0x00200142, 0x00200040, 0x00200000, 0x00200100, 0x00200000, 0x01200000, 0x01200006, 0x00200004}
   , 0xc110,0.000000,attributes+3,0,NULL,NULL,3,0.000000},
  {pat74,6,8, "CC74",0,-1,1,2,1,3,0x0,721,
    { 0x00ffff00, 0xf0f0f0f0, 0xfcfc0000, 0x3c3c3c00, 0xf0f0f000, 0xffff0000, 0x3c3c3c3c, 0x00fcfc00},
    { 0x00106900, 0x40908040, 0xa4100000, 0x08180400, 0x80904000, 0x69100000, 0x04180804, 0x0010a400}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat74,0,1.600000},
  {pat75,6,8, "CC74b",0,-1,1,2,1,3,0x0,721,
    { 0x00ffff00, 0xf0f0f0f0, 0xfcfc0000, 0x3c3c3c00, 0xf0f0f000, 0xffff0000, 0x3c3c3c3c, 0x00fcfc00},
    { 0x00106900, 0x40908040, 0xa4100000, 0x08180400, 0x80904000, 0x69100000, 0x04180804, 0x0010a400}
   , 0x80,0.000000,attributes+5,1,NULL,autohelperpat75,0,2.176000},
  {pat76,11,8, "CC75",0,-4,2,0,2,4,0x0,647,
    { 0x00f0f000, 0xf0f00000, 0x3f3f0000, 0x003c3c3f, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0x003f3f03},
    { 0x00102000, 0x00900000, 0x20100000, 0x00180001, 0x00900000, 0x20100000, 0x00180000, 0x00102001}
   , 0x104,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat77,8,8, "CC76",0,-3,2,0,2,3,0x0,647,
    { 0x00f0f000, 0xf0f00000, 0x3f3f0000, 0x003c3c3f, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0x003f3f03},
    { 0x00102000, 0x00900000, 0x20100000, 0x00180001, 0x00900000, 0x20100000, 0x00180000, 0x00102001}
   , 0x104,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat78,4,8, "CC77",0,0,2,1,2,1,0x0,685,
    { 0x00303c3c, 0x00f0c000, 0xf0300000, 0x0f3f0000, 0xc0f00000, 0x3c300000, 0x003f0f00, 0x0030f0f0},
    { 0x00200408, 0x00204000, 0x40200000, 0x06200000, 0x40200000, 0x04200000, 0x00200600, 0x00204080}
   , 0x201,0.000000,attributes+7,1,NULL,autohelperpat78,3,1.810000},
  {pat79,7,8, "CC78",0,-2,2,1,2,3,0x0,648,
    { 0x00fcfce0, 0xf0f0f000, 0xffff0000, 0x3c3e3f3c, 0xf0f0f0f0, 0xfcfc0000, 0x3f3e3c00, 0x00ffff2c},
    { 0x00180480, 0x00106000, 0x41900000, 0x24100204, 0x60100040, 0x04180000, 0x02102400, 0x00904108}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat79,0,0.610000},
  {pat80,17,8, "CC79",0,-1,3,3,3,4,0x0,759,
    { 0x003dffff, 0xc0f0f0d0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3d0000, 0x0f3f3f1f, 0x00f0fcfc},
    { 0x001090a4, 0x80500000, 0x18100000, 0x01160a00, 0x00508000, 0x90100000, 0x0a160100, 0x00101868}
   , 0xc084,0.000000,attributes+9,1,NULL,autohelperpat80,0,0.016000},
  {pat81,4,8, "CC80",0,0,1,2,1,2,0x0,721,
    { 0x003f3c00, 0x00f0f030, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3c3f0000, 0x003c3c30, 0x00f0f000},
    { 0x00122400, 0x00904020, 0x60100000, 0x04180000, 0x40900000, 0x24120000, 0x00180420, 0x00106000}
   , 0x200,0.000000,attributes+0,1,NULL,autohelperpat81,0,1.000000},
  {pat82,5,8, "CC81",0,0,2,2,2,2,0x0,721,
    { 0x003f3c0c, 0x00f0f030, 0xf0f00000, 0x3f3c0000, 0xf0f00000, 0x3c3f0000, 0x003c3f30, 0x00f0f0c0},
    { 0x00122404, 0x00904020, 0x60100000, 0x05180000, 0x40900000, 0x24120000, 0x00180520, 0x00106040}
   , 0x200,0.000000,attributes+11,1,NULL,autohelperpat82,0,1.000000},
  {pat83,9,8, "CC82",-1,-1,2,2,3,3,0x0,685,
    { 0xf0fffffc, 0xfcfcf0f0, 0xfcfc3c00, 0x3fffff00, 0xf0fcfc00, 0xfffff000, 0xffff3f3c, 0x3cfcfcfc},
    { 0x001a8400, 0x80106020, 0x48900000, 0x24100800, 0x60108000, 0x841a0000, 0x08102420, 0x00904800}
   , 0xe080,0.000000,attributes+13,1,NULL,autohelperpat83,0,0.970000},
  {pat84,9,8, "CC83",0,0,2,3,2,3,0x0,759,
    { 0x003f3f0f, 0x00f0f0f0, 0xf0f00000, 0x3f3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3f3f, 0x00f0f0c0},
    { 0x00102008, 0x00900000, 0x20100000, 0x02180000, 0x00900000, 0x20100000, 0x00180200, 0x00102080}
   , 0x84,0.000000,attributes+0,1,NULL,autohelperpat84,0,1.600000},
  {pat85,9,8, "CC84",0,0,3,3,3,3,0x0,723,
    { 0x003c3f0f, 0x00f0f0c0, 0xf0f00000, 0x3f3c0000, 0xf0f00000, 0x3f3c0000, 0x003c3f0f, 0x00f0f0c0},
    { 0x00241100, 0x00601040, 0x10600000, 0x10240000, 0x10600000, 0x11240000, 0x00241004, 0x00601000}
   , 0xa0,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat86,11,8, "CC85",0,-1,3,2,3,3,0x0,722,
    { 0x003cffff, 0xc0f0f0c0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3c0000, 0x0f3f3f0f, 0x00f0fcfc},
    { 0x00241142, 0x00601040, 0x10600000, 0x10240100, 0x10600000, 0x11240000, 0x01241006, 0x00601004}
   , 0x80,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat87,8,8, "CC86",-1,0,2,3,3,3,0x0,759,
    { 0x023f3f0c, 0x00f0f0f8, 0xf0f00000, 0x3f3c0000, 0xf0f00000, 0x3f3f0200, 0x003c3fbc, 0x00f0f0c0},
    { 0x00201000, 0x00600000, 0x10200000, 0x00240000, 0x00600000, 0x10200000, 0x00240000, 0x00201000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat87,3,0.010000},
  {pat88,8,8, "CC87",-1,0,2,3,3,3,0x0,721,
    { 0x023f3f0c, 0x00f0f0f8, 0xf0f00000, 0x3f3c0000, 0xf0f00000, 0x3f3f0200, 0x003c3fbc, 0x00f0f0c0},
    { 0x00201100, 0x00600040, 0x10200000, 0x00240000, 0x00600000, 0x11200000, 0x00240004, 0x00201000}
   , 0x80,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat89,8,8, "CC88",0,-1,3,1,3,2,0x0,685,
    { 0x00fcfcfc, 0xf0f0f000, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xfcfc0000, 0x3f3f3f00, 0x00fcfcfc},
    { 0x00100880, 0x00108000, 0x80100000, 0x08100200, 0x80100000, 0x08100000, 0x02100800, 0x00108008}
   , 0x201,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat90,11,8, "EC1",0,0,2,4,2,4,0x2,759,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00120000, 0x00100020, 0x00100000, 0x00100000, 0x00100000, 0x00120000, 0x00100020, 0x00100000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat90,0,3.880000},
  {pat91,13,8, "EC2",0,0,2,4,2,4,0x2,759,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x001a1000, 0x00502020, 0x10900000, 0x20140000, 0x20500000, 0x101a0000, 0x00142020, 0x00901000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat91,0,1.600000},
  {pat92,7,8, "EC4",0,-1,2,2,2,3,0x2,685,
    { 0x003cffff, 0xc0f0f0c0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3c0000, 0x0f3f3f0f, 0x00f0fcfc},
    { 0x00204100, 0x40200040, 0x04200000, 0x00200400, 0x00204000, 0x41200000, 0x04200004, 0x00200400}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat92,3,2.800000},
  {pat93,7,8, "EC5",0,-1,2,2,2,3,0x2,685,
    { 0x003cffff, 0xc0f0f0c0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3c0000, 0x0f3f3f0f, 0x00f0fcfc},
    { 0x00108200, 0x80100080, 0x08100000, 0x00100800, 0x00108000, 0x82100000, 0x08100008, 0x00100800}
   , 0x201,0.000000,attributes+0,1,NULL,autohelperpat93,0,2.800000},
  {pat94,8,8, "EC6",0,-1,2,2,2,3,0x2,722,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x00118200, 0x80100090, 0x08100000, 0x00100800, 0x00108000, 0x82110000, 0x08100018, 0x00100800}
   , 0x201,0.000000,attributes+0,1,NULL,autohelperpat94,0,1.600000},
  {pat95,8,8, "EC7",0,-1,2,2,2,3,0x2,685,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x00128000, 0x80100020, 0x08100000, 0x00100800, 0x00108000, 0x80120000, 0x08100020, 0x00100800}
   , 0x201,0.000000,attributes+0,1,NULL,autohelperpat95,0,4.800000},
  {pat96,8,8, "EC8",0,-1,2,2,2,3,0x2,685,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x00214000, 0x40200010, 0x04200000, 0x00200400, 0x00204000, 0x40210000, 0x04200010, 0x00200400}
   , 0x84,0.000000,attributes+15,1,NULL,autohelperpat96,3,16.000000},
  {pat97,18,8, "EC8a",-1,0,3,4,4,4,0x2,760,
    { 0x013d333f, 0x00f030d4, 0x30f00000, 0x333f0000, 0x30f00000, 0x333d0100, 0x003f335f, 0x00f030f0},
    { 0x00100204, 0x00100080, 0x00100000, 0x01100000, 0x00100000, 0x02100000, 0x00100108, 0x00100040}
   , 0x80000,0.000000,attributes+0,1,NULL,autohelperpat97,0,0.010000},
  {pat98,6,8, "EC9",0,-2,2,1,2,3,0x2,685,
    { 0x0030fcf0, 0xc0f0c000, 0xfc300000, 0x0c3f0f03, 0xc0f0c000, 0xfc300000, 0x0f3f0c00, 0x0030fc3f},
    { 0x00108800, 0x80108000, 0x88100000, 0x08100801, 0x80108000, 0x88100000, 0x08100800, 0x00108801}
   , 0x201,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat99,15,8, "EC10",0,-1,3,3,3,4,0x2,685,
    { 0x003f3fff, 0x00f0f0f0, 0xf0f00000, 0x3f3f0300, 0xf0f00000, 0x3f3f0000, 0x033f3f3f, 0x00f0f0fc},
    { 0x00180000, 0x00102000, 0x00900000, 0x20100000, 0x20100000, 0x00180000, 0x00102000, 0x00900000}
   , 0x80,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat100,17,8, "EC11",0,-1,3,3,3,4,0x2,723,
    { 0x003f3fff, 0x00f0f0f0, 0xf0f00000, 0x3f3f0300, 0xf0f00000, 0x3f3f0000, 0x033f3f3f, 0x00f0f0fc},
    { 0x00181800, 0x0050a000, 0x90900000, 0x28140000, 0xa0500000, 0x18180000, 0x00142800, 0x00909000}
   , 0x80,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat101,12,8, "EC12",0,-2,2,3,2,5,0x2,685,
    { 0x00fffdff, 0xf0f0f070, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xfdff0000, 0x3f3f3f37, 0x00ffffff},
    { 0x001a0000, 0x00102020, 0x02900000, 0x20100008, 0x20100080, 0x001a0000, 0x00102020, 0x00900200}
   , 0x201,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat102,6,8, "EC13",0,0,1,3,1,3,0x2,759,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00290400, 0x00206010, 0x40a00000, 0x24200000, 0x60200000, 0x04290000, 0x00202410, 0x00a04000}
   , 0x200,0.000000,attributes+0,1,NULL,autohelperpat102,3,0.016000},
  {pat103,7,8, "EC14",0,-2,2,1,2,3,0x2,648,
    { 0x0030fcfc, 0xc0f0c000, 0xff300000, 0x0f3f0f0f, 0xc0f0c0c0, 0xfc300000, 0x0f3f0f00, 0x0030ffff},
    { 0x00100400, 0x00104000, 0x42100000, 0x04100009, 0x40100080, 0x04100000, 0x00100400, 0x00104201}
   , 0x80,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat104,6,8, "EC15",0,0,2,2,2,2,0x2,722,
    { 0x003c3f3f, 0x00f0f0c0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3c0000, 0x003f3f0f, 0x00f0f0f0},
    { 0x00240200, 0x00201080, 0x00600000, 0x10200000, 0x10200000, 0x02240000, 0x00201008, 0x00600000}
   , 0x201,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat105,16,8, "EC16",0,-3,3,1,3,4,0x2,611,
    { 0x00f0fcfc, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0x003fffff},
    { 0x00101868, 0x00508000, 0x90100000, 0x0a160100, 0x80500000, 0x18100000, 0x01160a00, 0x001090a4}
   , 0x80,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat106,16,8, "EC16a",0,-3,3,1,3,4,0x2,611,
    { 0x00f0fcfc, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0x003fffff},
    { 0x00101868, 0x00508000, 0x90100000, 0x0a160100, 0x80500000, 0x18100000, 0x01160a00, 0x001090a4}
   , 0x80,0.000000,attributes+17,3,NULL,autohelperpat106,0,1.000000},
  {pat107,6,8, "EC17",0,0,2,2,2,2,0x2,722,
    { 0x003c3f3f, 0x00f0f0c0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3c0000, 0x003f3f0f, 0x00f0f0f0},
    { 0x00140205, 0x00101080, 0x00500000, 0x11100000, 0x10100000, 0x02140000, 0x00101109, 0x00500040}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat107,0,0.010000},
  {pat108,11,8, "EC18",0,0,2,4,2,4,0x2,759,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00210000, 0x00200010, 0x00200000, 0x00200000, 0x00200000, 0x00210000, 0x00200010, 0x00200000}
   , 0x201,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat109,8,8, "EC19",0,-1,3,1,3,2,0x2,686,
    { 0x003070fc, 0x40f00000, 0x34300000, 0x033f0700, 0x00f04000, 0x70300000, 0x073f0300, 0x003034fc},
    { 0x00200004, 0x00200000, 0x00200000, 0x01200000, 0x00200000, 0x00200000, 0x00200100, 0x00200040}
   , 0x201,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat110,8,8, "EC20",0,-1,3,1,3,2,0x2,685,
    { 0x00f0fcfc, 0xf0f0c000, 0xfc3c0000, 0x0f3f3f00, 0xc0f0f000, 0xfcf00000, 0x3f3f0f00, 0x003cfcfc},
    { 0x00200400, 0x00204000, 0x40200000, 0x04200000, 0x40200000, 0x04200000, 0x00200400, 0x00204000}
   , 0x201,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat111,9,4, "EC21",-1,0,2,2,3,2,0x2,722,
    { 0x2e3f3f3f, 0x00f8fcf8, 0xf0f0e000, 0xffbf0000, 0xfcf80000, 0x3f3f2e00, 0x00bfffbf, 0xe0f0f0f0},
    { 0x00260000, 0x00201020, 0x00600000, 0x10200000, 0x10200000, 0x00260000, 0x00201020, 0x00600000}
   , 0x201,0.000000,attributes+0,1,NULL,autohelperpat111,3,5.000000},
  {pat112,10,4, "EC22",0,-1,3,1,3,2,0x2,686,
    { 0x0030fcfc, 0xc0f0c000, 0xfc300000, 0x0f3f0f00, 0xc0f0c000, 0xfc300000, 0x0f3f0f00, 0x0030fcfc},
    { 0x00109800, 0x80508000, 0x98100000, 0x08140800, 0x80508000, 0x98100000, 0x08140800, 0x00109800}
   , 0x201,0.000000,attributes+0,1,NULL,autohelperpat112,0,5.000000},
  {pat113,9,4, "EC23",-1,0,2,2,3,2,0x2,722,
    { 0x1d3f3f3f, 0x00f4fcf4, 0xf0f0d000, 0xff7f0000, 0xfcf40000, 0x3f3f1d00, 0x007fff7f, 0xd0f0f0f0},
    { 0x00190000, 0x00102010, 0x00900000, 0x20100000, 0x20100000, 0x00190000, 0x00102010, 0x00900000}
   , 0x100,0.000000,attributes+0,1,NULL,autohelperpat113,0,0.016000},
  {pat114,10,4, "EC24",0,-1,3,1,3,2,0x2,686,
    { 0x0030fcfc, 0xc0f0c000, 0xfc300000, 0x0f3f0f00, 0xc0f0c000, 0xfc300000, 0x0f3f0f00, 0x0030fcfc},
    { 0x00206400, 0x40a04000, 0x64200000, 0x04280400, 0x40a04000, 0x64200000, 0x04280400, 0x00206400}
   , 0x100,0.000000,attributes+0,1,NULL,autohelperpat114,3,0.016000},
  {pat115,8,8, "EC25",0,0,2,2,2,2,0x2,759,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00122420, 0x00904020, 0x60100000, 0x041a0000, 0x40900000, 0x24120000, 0x001a0420, 0x00106020}
   , 0x201,0.000000,attributes+0,1,NULL,autohelperpat115,0,6.528000},
  {pat116,8,8, "EC26",0,0,2,2,2,2,0x2,721,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00122420, 0x00904020, 0x60100000, 0x041a0000, 0x40900000, 0x24120000, 0x001a0420, 0x00106020}
   , 0x201,0.000000,attributes+0,1,NULL,autohelperpat116,0,1.960000},
  {pat117,13,8, "EC27",0,-1,3,2,3,3,0x2,721,
    { 0x003f3fff, 0x00f0f0f0, 0xf0f00000, 0x3f3f0300, 0xf0f00000, 0x3f3f0000, 0x033f3f3f, 0x00f0f0fc},
    { 0x00212601, 0x00a04090, 0x60200000, 0x04280000, 0x40a00000, 0x26210000, 0x00280419, 0x00206000}
   , 0x0,0.000000,attributes+19,1,NULL,autohelperpat117,3,1.600000},
  {pat118,13,8, "EC28",0,0,2,4,2,4,0x2,797,
    { 0x003f3f2f, 0x00f0f0f0, 0xf0f00000, 0x3f3e0000, 0xf0f00000, 0x3f3f0000, 0x003e3f3f, 0x00f0f0e0},
    { 0x00121900, 0x00508060, 0x90100000, 0x08140000, 0x80500000, 0x19120000, 0x00140824, 0x00109000}
   , 0x0,0.000000,attributes+0,1,NULL,autohelperpat118,0,1.600000},
  {pat119,12,8, "EC29",0,0,2,4,2,4,0x2,759,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x201,0.000000,attributes+0,1,NULL,autohelperpat119,3,3.000000},
  {pat120,6,4, "EC30",0,-1,2,1,2,2,0x2,685,
    { 0x0030fcfc, 0xc0f0c000, 0xfc300000, 0x0f3f0f00, 0xc0f0c000, 0xfc300000, 0x0f3f0f00, 0x0030fcfc},
    { 0x00108800, 0x80108000, 0x88100000, 0x08100800, 0x80108000, 0x88100000, 0x08100800, 0x00108800}
   , 0x4000,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat121,14,8, "EC31",-1,0,2,4,3,4,0x2,759,
    { 0x0f3f3f3f, 0x00f0fcfc, 0xf0f0c000, 0xff3f0000, 0xfcf00000, 0x3f3f0f00, 0x003fffff, 0xc0f0f0f0},
    { 0x00201800, 0x00608000, 0x90200000, 0x08240000, 0x80600000, 0x18200000, 0x00240800, 0x00209000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat121,3,1.000000},
  {pat122,6,8, "EC32",0,0,2,2,2,2,0x2,722,
    { 0x003c3f3f, 0x00f0f0c0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3c0000, 0x003f3f0f, 0x00f0f0f0},
    { 0x00240200, 0x00201080, 0x00600000, 0x10200000, 0x10200000, 0x02240000, 0x00201008, 0x00600000}
   , 0x201,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat123,7,8, "EC33",0,-1,2,1,2,2,0x2,686,
    { 0x0030fcfc, 0xc0f0c000, 0xfc300000, 0x0f3f0f00, 0xc0f0c000, 0xfc300000, 0x0f3f0f00, 0x0030fcfc},
    { 0x00106488, 0x40904000, 0x64100000, 0x06180600, 0x40904000, 0x64100000, 0x06180600, 0x00106488}
   , 0x200,0.000000,attributes+0,1,NULL,autohelperpat123,0,0.016000},
  {pat124,6,8, "EC34",0,-1,2,1,2,2,0x2,685,
    { 0x0030fcfc, 0xc0f0c000, 0xfc300000, 0x0f3f0f00, 0xc0f0c000, 0xfc300000, 0x0f3f0f00, 0x0030fcfc},
    { 0x00208864, 0x80208000, 0x88200000, 0x09220900, 0x80208000, 0x88200000, 0x09220900, 0x00208864}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat124,3,0.010000},
  {pat125,7,8, "EC35",0,-1,2,1,2,2,0x2,686,
    { 0x0030fcfc, 0xc0f0c000, 0xfc300000, 0x0f3f0f00, 0xc0f0c000, 0xfc300000, 0x0f3f0f00, 0x0030fcfc},
    { 0x00209844, 0x80608000, 0x98200000, 0x09240900, 0x80608000, 0x98200000, 0x09240900, 0x00209844}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat125,3,0.010000},
  {pat126,6,8, "EC36",0,-1,2,1,2,2,0x2,685,
    { 0x0030fcfc, 0xc0f0c000, 0xfc300000, 0x0f3f0f00, 0xc0f0c000, 0xfc300000, 0x0f3f0f00, 0x0030fcfc},
    { 0x00104498, 0x40104000, 0x44100000, 0x06110600, 0x40104000, 0x44100000, 0x06110600, 0x00104498}
   , 0x200,0.000000,attributes+0,1,NULL,autohelperpat126,0,0.016000},
  {pat127,15,8, "EC42",0,-2,3,2,3,4,0x2,685,
    { 0x00fcfcff, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f03, 0x00ffffff},
    { 0x00140800, 0x00109000, 0x82500000, 0x18100008, 0x90100080, 0x08140000, 0x00101800, 0x00508200}
   , 0x201,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat128,16,8, "EC43",0,-2,3,2,3,4,0x2,649,
    { 0x00fcfcff, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f03, 0x00ffffff},
    { 0x00141820, 0x00509000, 0x92500000, 0x18160008, 0x90500080, 0x18140000, 0x00161800, 0x00509220}
   , 0x201,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat129,7,8, "EC44",0,0,1,3,1,3,0x2,722,
    { 0x003b3f00, 0x00f0e0f0, 0xf0b00000, 0x2c3c0000, 0xe0f00000, 0x3f3b0000, 0x003c2c3c, 0x00b0f000},
    { 0x00102000, 0x00900000, 0x20100000, 0x00180000, 0x00900000, 0x20100000, 0x00180000, 0x00102000}
   , 0x201,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat130,15,8, "EC45",0,-2,4,1,4,3,0x2,650,
    { 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff},
    { 0x00100048, 0x00100000, 0x00100000, 0x02100100, 0x00100000, 0x00100000, 0x01100200, 0x00100084}
   , 0x201,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat131,16,8, "EC46",-1,0,3,4,4,4,0x2,796,
    { 0x3f3f3f3f, 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff, 0xf0f0f0f0},
    { 0x00110200, 0x00100090, 0x00100000, 0x00100000, 0x00100000, 0x02110000, 0x00100018, 0x00100000}
   , 0x201,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat132,6,8, "EC47",0,0,1,3,1,3,0x2,759,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00212000, 0x00a00010, 0x20200000, 0x00280000, 0x00a00000, 0x20210000, 0x00280010, 0x00202000}
   , 0x201,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat133,6,8, "EC48",0,0,1,3,1,3,0x2,722,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00262000, 0x00a01020, 0x20600000, 0x10280000, 0x10a00000, 0x20260000, 0x00281020, 0x00602000}
   , 0x201,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat134,12,8, "EC49",0,-1,3,2,3,3,0x2,685,
    { 0x00ffffff, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0x00fcfcfc},
    { 0x00108200, 0x80100080, 0x08100000, 0x00100800, 0x00108000, 0x82100000, 0x08100008, 0x00100800}
   , 0x201,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat135,13,8, "EC50",0,-1,3,2,3,3,0x2,723,
    { 0x00ffffff, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0x00fcfcfc},
    { 0x00109220, 0x80500080, 0x18100000, 0x00160800, 0x00508000, 0x92100000, 0x08160008, 0x00101820}
   , 0x201,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat136,12,8, "EC51",-1,-1,2,3,3,4,0x2,720,
    { 0xfd3fffff, 0xccfcfcf4, 0xfcf0fc00, 0xffffcf00, 0xfcfccc00, 0xff3ffd00, 0xcfffff7f, 0xfcf0fcfc},
    { 0x00240000, 0x00201000, 0x00600000, 0x10200000, 0x10200000, 0x00240000, 0x00201000, 0x00600000}
   , 0x201,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat137,16,8, "EC52",0,-3,3,1,3,4,0x2,610,
    { 0x00f0fcfc, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0x003fffff},
    { 0x00104800, 0x40108000, 0x86100000, 0x08100408, 0x80104080, 0x48100000, 0x04100800, 0x00108600}
   , 0x201,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat138,14,8, "EC53",0,-2,3,2,3,4,0x2,649,
    { 0x00f0fcff, 0xf0f0c000, 0xff3c0000, 0x0f3f3f0f, 0xc0f0f0c0, 0xfcf00000, 0x3f3f0f03, 0x003cffff},
    { 0x00101820, 0x00508000, 0x92100000, 0x08160008, 0x80500080, 0x18100000, 0x00160800, 0x00109220}
   , 0x201,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat139,17,8, "EC54",0,-2,3,2,3,4,0x2,686,
    { 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0x00ffffff},
    { 0x00104800, 0x40108000, 0x86100000, 0x08100408, 0x80104080, 0x48100000, 0x04100800, 0x00108600}
   , 0x201,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat140,12,8, "EC55",0,-2,3,1,3,3,0x2,686,
    { 0x00f0fcfc, 0xf0f0c000, 0xff3c0000, 0x0f3f3f0f, 0xc0f0f0c0, 0xfcf00000, 0x3f3f0f00, 0x003cffff},
    { 0x00104880, 0x40108000, 0x84100000, 0x08100600, 0x80104000, 0x48100000, 0x06100800, 0x00108408}
   , 0x201,0.000000,attributes+0,1,NULL,autohelperpat140,0,1.000000},
  {pat141,4,8, "EC56",0,0,1,3,1,3,0x2,721,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00210000, 0x00200010, 0x00200000, 0x00200000, 0x00200000, 0x00210000, 0x00200010, 0x00200000}
   , 0x201,0.000000,attributes+0,1,NULL,autohelperpat141,3,16.000000},
  {pat142,14,4, "EC57",0,-2,3,2,3,4,0x2,686,
    { 0x0030ffff, 0xc0f0c0c0, 0xff300000, 0x0f3f0f0f, 0xc0f0c0c0, 0xff300000, 0x0f3f0f0f, 0x0030ffff},
    { 0x00102100, 0x00900040, 0x21100000, 0x00180004, 0x00900040, 0x21100000, 0x00180004, 0x00102100}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat142,0,6.528000},
  {pat143,18,8, "EC58",0,0,3,4,3,4,0x2,759,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00121000, 0x00500020, 0x10100000, 0x00140000, 0x00500000, 0x10120000, 0x00140020, 0x00101000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat143,0,6.528000},
  {pat144,6,8, "EC59",0,-1,1,3,1,4,0x2,685,
    { 0x00ffff00, 0xf0f0f0f0, 0xfcfc0000, 0x3c3c3c00, 0xf0f0f000, 0xffff0000, 0x3c3c3c3c, 0x00fcfc00},
    { 0x00240000, 0x00201000, 0x00600000, 0x10200000, 0x10200000, 0x00240000, 0x00201000, 0x00600000}
   , 0x201,0.000000,attributes+0,1,NULL,autohelperpat144,3,1.000000},
  {pat145,13,8, "EC60",0,-1,3,2,3,3,0x2,722,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x001092a4, 0x80500080, 0x18100000, 0x01160a00, 0x00508000, 0x92100000, 0x0a160108, 0x00101868}
   , 0x81,0.000000,attributes+0,1,NULL,autohelperpat145,0,1.600000},
  {pat146,13,8, "EC60a",0,-1,3,2,3,3,0x2,760,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x001092a4, 0x80500080, 0x18100000, 0x01160a00, 0x00508000, 0x92100000, 0x0a160108, 0x00101868}
   , 0x81,0.000000,attributes+0,1,NULL,autohelperpat146,0,3.000000},
  {pat147,13,8, "EC61",0,0,2,4,2,4,0x2,796,
    { 0x003b3f3f, 0x00f0e0f0, 0xf0b00000, 0x2f3f0000, 0xe0f00000, 0x3f3b0000, 0x003f2f3f, 0x00b0f0f0},
    { 0x00112200, 0x00900090, 0x20100000, 0x00180000, 0x00900000, 0x22110000, 0x00180018, 0x00102000}
   , 0x201,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat148,19,8, "EC62",0,-1,4,3,4,4,0x2,685,
    { 0x00fcffff, 0xf0f0f0c0, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xfffc0000, 0x3f3f3f0f, 0x00fcfcfc},
    { 0x00204000, 0x40200000, 0x04200000, 0x00200400, 0x00204000, 0x40200000, 0x04200000, 0x00200400}
   , 0x80,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat149,10,4, "EC63",0,-1,3,1,3,2,0x2,686,
    { 0x0030fcfc, 0xc0f0c000, 0xfc300000, 0x0f3f0f00, 0xc0f0c000, 0xfc300000, 0x0f3f0f00, 0x0030fcfc},
    { 0x00206400, 0x40a04000, 0x64200000, 0x04280400, 0x40a04000, 0x64200000, 0x04280400, 0x00206400}
   , 0x84,0.000000,attributes+0,1,NULL,autohelperpat149,3,10.000000},
  {pat150,14,8, "EC64",-1,-1,2,3,3,4,0x2,685,
    { 0xf5ffffff, 0xfcfcf4f4, 0xfcfc7c00, 0x7fffff00, 0xf4fcfc00, 0xfffff500, 0xffff7f7f, 0x7cfcfcfc},
    { 0x00120800, 0x00108020, 0x80100000, 0x08100000, 0x80100000, 0x08120000, 0x00100820, 0x00108000}
   , 0xd005,0.000000,attributes+0,1,NULL,autohelperpat150,0,0.010000},
  {pat151,17,8, "EC65",-1,0,2,4,3,4,0x2,721,
    { 0x273f3f3f, 0x00f8f4fc, 0xf0f06000, 0x7fbf0000, 0xf4f80000, 0x3f3f2700, 0x00bf7fff, 0x60f0f0f0},
    { 0x00120100, 0x00100060, 0x00100000, 0x00100000, 0x00100000, 0x01120000, 0x00100024, 0x00100000}
   , 0x84,0.000000,attributes+21,0,NULL,NULL,0,0.000000},
  {pat152,13,8, "EC66",0,0,2,4,2,4,0x2,722,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x001a0100, 0x00102060, 0x00900000, 0x20100000, 0x20100000, 0x011a0000, 0x00102024, 0x00900000}
   , 0xc084,0.000000,attributes+23,1,NULL,autohelperpat152,0,1.600000},
  {pat153,14,8, "EC67",0,0,2,4,2,4,0x2,759,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x001a0400, 0x00106020, 0x40900000, 0x24100000, 0x60100000, 0x041a0000, 0x00102420, 0x00904000}
   , 0xc084,0.000000,attributes+25,1,NULL,autohelperpat153,0,1.600000},
  {pat154,12,8, "EC68",0,0,2,4,2,4,0x2,759,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00120000, 0x00100020, 0x00100000, 0x00100000, 0x00100000, 0x00120000, 0x00100020, 0x00100000}
   , 0xc084,0.000000,attributes+0,1,NULL,autohelperpat154,0,0.376000},
  {pat155,16,8, "EC69",0,-1,3,3,3,4,0x2,685,
    { 0x003dffff, 0xc0f0f0d0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3d0000, 0x0f3f3f1f, 0x00f0fcfc},
    { 0x00188004, 0x80102000, 0x08900000, 0x21100800, 0x20108000, 0x80180000, 0x08102100, 0x00900840}
   , 0xc084,0.000000,attributes+0,1,NULL,autohelperpat155,0,1.000000},
  {pat156,8,8, "EC70",0,-1,1,3,1,4,0x2,722,
    { 0x00bfff00, 0xe0f0f0f0, 0xfcf80000, 0x3c3c2c00, 0xf0f0e000, 0xffbf0000, 0x2c3c3c3c, 0x00f8fc00},
    { 0x00184000, 0x40102000, 0x04900000, 0x20100400, 0x20104000, 0x40180000, 0x04102000, 0x00900400}
   , 0x8084,0.000000,attributes+0,1,NULL,autohelperpat156,0,1.000000},
  {pat157,8,8, "EC71",0,-1,1,3,1,4,0x2,722,
    { 0x007fff00, 0xd0f0f0f0, 0xfcf40000, 0x3c3c1c00, 0xf0f0d000, 0xff7f0000, 0x1c3c3c3c, 0x00f4fc00},
    { 0x00248000, 0x80201000, 0x08600000, 0x10200800, 0x10208000, 0x80240000, 0x08201000, 0x00600800}
   , 0x4200,0.000000,attributes+0,1,NULL,autohelperpat157,3,1.000000},
  {pat158,14,8, "EC73",0,-1,2,4,2,5,0x2,796,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x001a0500, 0x00106060, 0x40900000, 0x24100000, 0x60100000, 0x051a0000, 0x00102424, 0x00904000}
   , 0x84,0.000000,attributes+27,1,NULL,autohelperpat158,0,0.016000},
  {pat159,22,8, "EC74",-1,-2,3,3,4,5,0x2,685,
    { 0xfaffffff, 0xfcfcf8f8, 0xffffbc00, 0xbfffff3f, 0xf8fcfcf0, 0xfffffa00, 0xffffbfbf, 0xbcffffff},
    { 0x00210000, 0x00200010, 0x01200000, 0x00200004, 0x00200040, 0x00210000, 0x00200010, 0x00200100}
   , 0x8084,0.000000,attributes+29,0,NULL,NULL,3,0.000000},
  {pat160,24,8, "EC75",-1,-2,3,3,4,5,0x2,721,
    { 0xfaffffff, 0xfcfcf8f8, 0xffffbc00, 0xbfffff3f, 0xf8fcfcf0, 0xfffffa00, 0xffffbfbf, 0xbcffffff},
    { 0x00211800, 0x00608010, 0x91200000, 0x08240004, 0x80600040, 0x18210000, 0x00240810, 0x00209100}
   , 0x8080,0.000000,attributes+31,0,NULL,NULL,3,0.000000},
  {pat161,16,8, "EC76",0,-3,3,1,3,4,0x2,650,
    { 0x00f0fcfc, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0x003fffff},
    { 0x00101868, 0x00508000, 0x90100000, 0x0a160102, 0x80500000, 0x18100000, 0x01160a00, 0x001090a6}
   , 0x200,0.000000,attributes+0,1,NULL,autohelperpat161,0,0.610000},
  {pat162,7,8, "EC77",-2,-1,1,1,3,2,0x8,683,
    { 0xfcfcfc00, 0xfffffd00, 0xfcfcfc7c, 0xfcfcfc00, 0xfdffff00, 0xfcfcfcf4, 0xfcfcfc00, 0xfcfcfc00},
    { 0x00209400, 0x80604000, 0x58200000, 0x04240800, 0x40608000, 0x94200000, 0x08240400, 0x00205800}
   , 0x1005,0.000000,attributes+0,1,NULL,autohelperpat162,3,1.000000},
  {pat163,10,8, "EC78",0,0,3,2,3,2,0x2,686,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00150008, 0x00101010, 0x00500000, 0x12100000, 0x10100000, 0x00150000, 0x00101210, 0x00500080}
   , 0x1015,0.000000,attributes+0,1,NULL,autohelperpat163,0,1.600000},
  {pat164,7,8, "EC79",0,0,2,2,2,2,0x2,722,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00212010, 0x00a00010, 0x20200000, 0x00290000, 0x00a00000, 0x20210000, 0x00290010, 0x00202010}
   , 0x80,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat165,7,8, "EC80",0,0,1,3,1,3,0x2,759,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00252000, 0x00a01010, 0x20600000, 0x10280000, 0x10a00000, 0x20250000, 0x00281010, 0x00602000}
   , 0x201,0.000000,attributes+0,1,NULL,autohelperpat165,3,1.000000},
  {pat166,23,8, "EC81",0,0,3,5,3,5,0x2,833,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x002a1400, 0x00606020, 0x50a00000, 0x24240000, 0x60600000, 0x142a0000, 0x00242420, 0x00a05000}
   , 0x84,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat167,4,4, "EC101",0,0,1,2,1,2,0x2,722,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00260000, 0x00201020, 0x00600000, 0x10200000, 0x10200000, 0x00260000, 0x00201020, 0x00600000}
   , 0x201,0.000000,attributes+0,1,NULL,autohelperpat167,3,1.600000},
  {pat168,4,8, "EC102",0,0,1,2,1,2,0x2,759,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00260000, 0x00201020, 0x00600000, 0x10200000, 0x10200000, 0x00260000, 0x00201020, 0x00600000}
   , 0x201,0.000000,attributes+0,1,NULL,autohelperpat168,3,1.960000},
  {pat169,5,8, "EC103",0,0,1,3,1,3,0x2,722,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00260100, 0x00201060, 0x00600000, 0x10200000, 0x10200000, 0x01260000, 0x00201024, 0x00600000}
   , 0x200,0.000000,attributes+0,1,NULL,autohelperpat169,3,0.010000},
  {pat170,4,4, "EC104",0,0,1,2,1,2,0x2,722,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00190000, 0x00102010, 0x00900000, 0x20100000, 0x20100000, 0x00190000, 0x00102010, 0x00900000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat170,0,1.600000},
  {pat171,3,8, "EC105",0,0,1,2,1,2,0x2,722,
    { 0x003c3f00, 0x00f0f0c0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3c0000, 0x003c3c0c, 0x00f0f000},
    { 0x00240200, 0x00201080, 0x00600000, 0x10200000, 0x10200000, 0x02240000, 0x00201008, 0x00600000}
   , 0x201,0.000000,attributes+0,1,NULL,autohelperpat171,3,3.160000},
  {pat172,4,8, "EC106",0,0,1,2,1,2,0x2,722,
    { 0x003c3f00, 0x00f0f0c0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3c0000, 0x003c3c0c, 0x00f0f000},
    { 0x00242200, 0x00a01080, 0x20600000, 0x10280000, 0x10a00000, 0x22240000, 0x00281008, 0x00602000}
   , 0x221,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat173,3,8, "EC107",0,-1,1,1,1,2,0x2,685,
    { 0x0030fc00, 0xc0f0c000, 0xfc300000, 0x0c3c0c00, 0xc0f0c000, 0xfc300000, 0x0c3c0c00, 0x0030fc00},
    { 0x00108800, 0x80108000, 0x88100000, 0x08100800, 0x80108000, 0x88100000, 0x08100800, 0x00108800}
   , 0x201,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat174,5,8, "EC108",0,0,1,2,1,2,0x2,722,
    { 0x003f1d00, 0x0070f070, 0xd0f00000, 0x3c340000, 0xf0700000, 0x1d3f0000, 0x00343c34, 0x00f0d000},
    { 0x00260000, 0x00201020, 0x00600000, 0x10200000, 0x10200000, 0x00260000, 0x00201020, 0x00600000}
   , 0x221,0.000000,attributes+0,1,NULL,autohelperpat174,3,1.600000},
  {pat175,3,4, "EC109",0,-1,1,1,1,2,0x2,685,
    { 0x0030fc00, 0xc0f0c000, 0xfc300000, 0x0c3c0c00, 0xc0f0c000, 0xfc300000, 0x0c3c0c00, 0x0030fc00},
    { 0x00204400, 0x40204000, 0x44200000, 0x04200400, 0x40204000, 0x44200000, 0x04200400, 0x00204400}
   , 0xa0,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat176,8,8, "EC110",0,-1,1,3,1,4,0x2,758,
    { 0x003fbf00, 0x80f0f0f0, 0xf8f00000, 0x3c3c0800, 0xf0f08000, 0xbf3f0000, 0x083c3c3c, 0x00f0f800},
    { 0x00180400, 0x00106000, 0x40900000, 0x24100000, 0x60100000, 0x04180000, 0x00102400, 0x00904000}
   , 0x80,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat177,6,8, "EC201",0,0,1,3,1,3,0x2,722,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00240000, 0x00201000, 0x00600000, 0x10200000, 0x10200000, 0x00240000, 0x00201000, 0x00600000}
   , 0x201,0.000000,attributes+0,1,NULL,autohelperpat177,3,2.800000},
  {pat178,6,8, "EC202",0,0,1,3,1,3,0x2,758,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00240000, 0x00201000, 0x00600000, 0x10200000, 0x10200000, 0x00240000, 0x00201000, 0x00600000}
   , 0x221,0.000000,attributes+0,1,NULL,autohelperpat178,3,3.000000},
  {pat179,7,8, "EC203",0,0,1,3,1,3,0x2,722,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00242000, 0x00a01000, 0x20600000, 0x10280000, 0x10a00000, 0x20240000, 0x00281000, 0x00602000}
   , 0x221,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat180,7,8, "EC204",0,0,1,3,1,3,0x2,758,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00242000, 0x00a01000, 0x20600000, 0x10280000, 0x10a00000, 0x20240000, 0x00281000, 0x00602000}
   , 0x201,0.000000,attributes+0,1,NULL,autohelperpat180,3,1.000000},
  {pat181,7,8, "EC205",0,0,1,3,1,3,0x2,759,
    { 0x003f1f00, 0x0070f0f0, 0xd0f00000, 0x3c340000, 0xf0700000, 0x1f3f0000, 0x00343c3c, 0x00f0d000},
    { 0x00240000, 0x00201000, 0x00600000, 0x10200000, 0x10200000, 0x00240000, 0x00201000, 0x00600000}
   , 0x201,0.000000,attributes+0,1,NULL,autohelperpat181,3,1.600000},
  {pat182,11,8, "EC206",0,-1,1,5,1,6,0x2,759,
    { 0x003f7f00, 0x40f0f0f0, 0xf4f00000, 0x3c3c0400, 0xf0f04000, 0x7f3f0000, 0x043c3c3c, 0x00f0f400},
    { 0x00240800, 0x00209000, 0x80600000, 0x18200000, 0x90200000, 0x08240000, 0x00201800, 0x00608000}
   , 0x80,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat183,5,8, "EC207",0,0,1,3,1,3,0x2,759,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00120000, 0x00100020, 0x00100000, 0x00100000, 0x00100000, 0x00120000, 0x00100020, 0x00100000}
   , 0xa0,0.000000,attributes+0,1,NULL,autohelperpat183,0,5.160000},
  {pat184,6,8, "EC208",0,0,1,3,1,3,0x2,721,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00120900, 0x00108060, 0x80100000, 0x08100000, 0x80100000, 0x09120000, 0x00100824, 0x00108000}
   , 0xa0,0.000000,attributes+0,1,NULL,autohelperpat184,0,1.000000},
  {pat185,6,8, "EC209",0,0,1,3,1,3,0x2,759,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00212000, 0x00a00010, 0x20200000, 0x00280000, 0x00a00000, 0x20210000, 0x00280010, 0x00202000}
   , 0x201,0.000000,attributes+0,1,NULL,autohelperpat185,3,1.600000},
  {pat186,5,8, "EC210",0,0,1,3,1,3,0x2,759,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00210000, 0x00200010, 0x00200000, 0x00200000, 0x00200000, 0x00210000, 0x00200010, 0x00200000}
   , 0x221,0.000000,attributes+0,1,NULL,autohelperpat186,3,5.160000},
  {pat187,6,8, "EC211",0,0,1,3,1,3,0x2,759,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00212000, 0x00a00010, 0x20200000, 0x00280000, 0x00a00000, 0x20210000, 0x00280010, 0x00202000}
   , 0x201,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat188,6,8, "EC212",0,-2,1,2,1,4,0x2,685,
    { 0x003bfa00, 0xc0f0a0b0, 0xbcb00000, 0x283c0c00, 0xa0f0c000, 0xfa3b0000, 0x0c3c2838, 0x00b0bc00},
    { 0x00214000, 0x40200010, 0x04200000, 0x00200400, 0x00204000, 0x40210000, 0x04200010, 0x00200400}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat188,3,0.010000},
  {pat189,6,8, "EC213",0,-3,1,1,1,4,0x2,685,
    { 0x00fcf800, 0xf0f0b000, 0xbfff0000, 0x383c3c3c, 0xb0f0f0f0, 0xf8fc0000, 0x3c3c3800, 0x00ffbf00},
    { 0x00240000, 0x00201000, 0x01600000, 0x10200004, 0x10200040, 0x00240000, 0x00201000, 0x00600100}
   , 0x80,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat190,9,8, "EC214",-1,-2,1,2,2,4,0x2,685,
    { 0x5fffff00, 0xf4f4fcfc, 0xfffed400, 0xfc7c7c2c, 0xfcf4f4e0, 0xffff5f00, 0x7c7cfcfc, 0xd4feff00},
    { 0x00240000, 0x00201000, 0x01600000, 0x10200004, 0x10200040, 0x00240000, 0x00201000, 0x00600100}
   , 0x80,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat191,9,8, "EC215",0,-2,2,2,2,4,0x2,686,
    { 0x003cfcfd, 0xc0f0f000, 0xfff00000, 0x3f3f0f0f, 0xf0f0c0c0, 0xfc3c0000, 0x0f3f3f01, 0x00f0ffff},
    { 0x00140408, 0x00105000, 0x42500000, 0x16100008, 0x50100080, 0x04140000, 0x00101600, 0x00504280}
   , 0x201,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat192,6,8, "EC216",0,-1,1,3,1,4,0x2,685,
    { 0x003fff00, 0xc0f0f0f0, 0xfcf00000, 0x3c3c0c00, 0xf0f0c000, 0xff3f0000, 0x0c3c3c3c, 0x00f0fc00},
    { 0x00204000, 0x40200000, 0x04200000, 0x00200400, 0x00204000, 0x40200000, 0x04200000, 0x00200400}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat192,3,0.010000},
  {pat193,3,8, "EC217",0,-1,1,2,1,3,0x2,685,
    { 0x0030ff00, 0xc0f0c0c0, 0xfc300000, 0x0c3c0c00, 0xc0f0c000, 0xff300000, 0x0c3c0c0c, 0x0030fc00},
    { 0x00108200, 0x80100080, 0x08100000, 0x00100800, 0x00108000, 0x82100000, 0x08100008, 0x00100800}
   , 0x201,0.000000,attributes+0,1,NULL,autohelperpat193,0,0.376000},
  {pat194,7,8, "EC218",-1,0,1,3,2,3,0x2,722,
    { 0x023f3f00, 0x00f0f0f8, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0200, 0x003c3cbc, 0x00f0f000},
    { 0x00180000, 0x00102000, 0x00900000, 0x20100000, 0x20100000, 0x00180000, 0x00102000, 0x00900000}
   , 0x80,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat195,16,4, "CS1",0,-1,4,3,4,4,0x0,724,
    { 0x0033ffff, 0xc0f0c0f0, 0xfc300000, 0x0f3f0f00, 0xc0f0c000, 0xff330000, 0x0f3f0f3f, 0x0030fcfc},
    { 0x00224400, 0x40204020, 0x44200000, 0x04200400, 0x40204000, 0x44220000, 0x04200420, 0x00204400}
   , 0x8004,0.000000,attributes+0,1,NULL,autohelperpat195,3,0.016000},
  {pat196,9,8, "CS2",0,-2,3,1,3,3,0x0,649,
    { 0x003cfcfc, 0xc0f0f000, 0xfff00000, 0x3f3f0f0f, 0xf0f0c0c0, 0xfc3c0000, 0x0f3f3f00, 0x00f0ffff},
    { 0x00100400, 0x00104000, 0x42100000, 0x04100008, 0x40100080, 0x04100000, 0x00100400, 0x00104200}
   , 0xd005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat197,8,8, "CS3",0,-3,2,0,2,3,0x0,611,
    { 0x00f0f0c0, 0xf0f00000, 0x3f3f0000, 0x003c3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3c0000, 0x003f3f0f},
    { 0x00200040, 0x00200000, 0x00200000, 0x00200100, 0x00200000, 0x00200000, 0x01200000, 0x00200004}
   , 0xc005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat198,17,8, "CS4",0,-1,3,5,3,6,0x0,760,
    { 0x00ffffff, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0x00fcfcfc},
    { 0x00210000, 0x00200010, 0x00200000, 0x00200000, 0x00200000, 0x00210000, 0x00200010, 0x00200000}
   , 0xc005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat199,20,8, "CS5",-1,-1,4,3,5,4,0x0,722,
    { 0x04ffffff, 0xf0f0f4f0, 0xfcfc4000, 0x7f3f3f00, 0xf4f0f000, 0xffff0400, 0x3f3f7f3f, 0x40fcfcfc},
    { 0x00210000, 0x00200010, 0x00200000, 0x00200000, 0x00200000, 0x00210000, 0x00200010, 0x00200000}
   , 0xc005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat200,24,8, "CS6",0,-2,5,2,5,4,0x0,686,
    { 0x003cffff, 0xc0f0f0c0, 0xfff00000, 0x3f3f0f0f, 0xf0f0c0c0, 0xff3c0000, 0x0f3f3f0f, 0x00f0ffff},
    { 0x00108400, 0x80104000, 0x48100000, 0x04100800, 0x40108000, 0x84100000, 0x08100400, 0x00104800}
   , 0xc005,0.000000,attributes+0,1,NULL,autohelperpat200,0,1.000000},
  {pat201,17,8, "CS7",0,-3,3,2,3,5,0x0,686,
    { 0x00f0fcff, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f03, 0x003fffff},
    { 0x00100000, 0x00100000, 0x02100000, 0x00100008, 0x00100080, 0x00100000, 0x00100000, 0x00100200}
   , 0xc005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat202,13,8, "CS8",0,-3,2,2,2,5,0x0,686,
    { 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0x00ffffff},
    { 0x00100200, 0x00100080, 0x02100000, 0x00100008, 0x00100080, 0x02100000, 0x00100008, 0x00100200}
   , 0xc005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat203,13,8, "CS9",-2,0,2,5,4,5,0x0,758,
    { 0x3f3f3f00, 0x00fcfcfc, 0xf0f0f000, 0xfcfc0000, 0xfcfc0000, 0x3f3f3f00, 0x00fcfcfc, 0xf0f0f000},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0xc005,0.000000,attributes+0,0,jump_out_helper
,NULL,0,0.000000},
  {pat204,9,8, "CS10",-1,-2,3,2,4,4,0x0,686,
    { 0x30ffffff, 0xf0fcf0f0, 0xfffc3000, 0x3fff3f0c, 0xf0fcf0c0, 0xffff3000, 0x3fff3f3f, 0x30fcfffc},
    { 0x00100200, 0x00100080, 0x02100000, 0x00100008, 0x00100080, 0x02100000, 0x00100008, 0x00100200}
   , 0xc005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat205,8,8, "CS11",0,-2,3,0,3,2,0x0,649,
    { 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3f},
    { 0x00200010, 0x00200000, 0x00200000, 0x00210000, 0x00200000, 0x00200000, 0x00210000, 0x00200010}
   , 0xc005,0.000000,attributes+0,1,NULL,autohelperpat205,3,0.016000},
  {pat206,7,8, "CS12",0,-1,2,2,2,3,0x0,686,
    { 0x003cffff, 0xc0f0f0c0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3c0000, 0x0f3f3f0f, 0x00f0fcfc},
    { 0x00140280, 0x00101080, 0x00500000, 0x10100200, 0x10100000, 0x02140000, 0x02101008, 0x00500008}
   , 0xc005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat207,11,8, "CS13",0,-1,3,2,3,3,0x0,685,
    { 0x00ffffff, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0x00fcfcfc},
    { 0x00200100, 0x00200040, 0x00200000, 0x00200000, 0x00200000, 0x01200000, 0x00200004, 0x00200000}
   , 0xc005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat208,10,8, "CS14",-1,-2,3,2,4,4,0x0,685,
    { 0x30ffffff, 0xf0fcf0f0, 0xfffc3000, 0x3fff3f0c, 0xf0fcf0c0, 0xffff3000, 0x3fff3f3f, 0x30fcfffc},
    { 0x00100200, 0x00100080, 0x02100000, 0x00100008, 0x00100080, 0x02100000, 0x00100008, 0x00100200}
   , 0xc005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat209,10,8, "CS15",0,-1,3,2,3,3,0x0,685,
    { 0x00ffffff, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0x00fcfcfc},
    { 0x00108200, 0x80100080, 0x08100000, 0x00100800, 0x00108000, 0x82100000, 0x08100008, 0x00100800}
   , 0x4005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat210,4,8, "CS16",0,-1,1,2,1,3,0x0,685,
    { 0x003dff00, 0xc0f0f0d0, 0xfcf00000, 0x3c3c0c00, 0xf0f0c000, 0xff3d0000, 0x0c3c3c1c, 0x00f0fc00},
    { 0x00108200, 0x80100080, 0x08100000, 0x00100800, 0x00108000, 0x82100000, 0x08100008, 0x00100800}
   , 0x4005,0.000000,attributes+0,1,NULL,autohelperpat210,0,3.616000},
  {pat211,8,8, "CS17",0,-1,2,1,2,2,0x0,685,
    { 0x0074fcfc, 0xd0f0d000, 0xfc740000, 0x1f3f1f00, 0xd0f0d000, 0xfc740000, 0x1f3f1f00, 0x0074fcfc},
    { 0x00204400, 0x40204000, 0x44200000, 0x04200400, 0x40204000, 0x44200000, 0x04200400, 0x00204400}
   , 0x8005,0.000000,attributes+0,1,NULL,autohelperpat211,3,5.000000},
  {pat212,13,4, "CS18",-1,0,2,4,3,4,0x0,758,
    { 0x0f3f2f0d, 0x00b0fcfc, 0xe0f0c000, 0xff380000, 0xfcb00000, 0x2f3f0f00, 0x0038fffd, 0xc0f0e0c0},
    { 0x00100008, 0x00100000, 0x00100000, 0x02100000, 0x00100000, 0x00100000, 0x00100200, 0x00100080}
   , 0xc005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat213,10,8, "CS19",0,0,2,3,2,3,0x0,759,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00201010, 0x00600000, 0x10200000, 0x00250000, 0x00600000, 0x10200000, 0x00250000, 0x00201010}
   , 0xc005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat214,6,8, "CS20a",0,0,2,2,2,2,0x0,722,
    { 0x003f3f07, 0x00f0f0f0, 0xf0f00000, 0x3d3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3d3f, 0x00f0f040},
    { 0x00201002, 0x00600000, 0x10200000, 0x00240000, 0x00600000, 0x10200000, 0x00240002, 0x00201000}
   , 0x4005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat215,6,8, "CS20b",0,0,2,2,2,2,0x0,722,
    { 0x003f3f07, 0x00f0f0f0, 0xf0f00000, 0x3d3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3d3f, 0x00f0f040},
    { 0x00201002, 0x00600000, 0x10200000, 0x00240000, 0x00600000, 0x10200000, 0x00240002, 0x00201000}
   , 0x8005,0.000000,attributes+0,1,NULL,autohelperpat215,3,10.000000},
  {pat216,14,8, "CS21",0,0,3,3,3,3,0x0,723,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00160800, 0x00109020, 0x80500000, 0x18100000, 0x90100000, 0x08160000, 0x00101820, 0x00508000}
   , 0x4005,0.000000,attributes+0,1,NULL,autohelperpat216,0,0.010000},
  {pat217,9,8, "CS22",-1,-1,2,3,3,4,0x0,759,
    { 0x3cff3f0f, 0x30fcfcf0, 0xf0fcf000, 0xfffc3000, 0xfcfc3000, 0x3fff3c00, 0x30fcff3f, 0xf0fcf0c0},
    { 0x00182400, 0x00906000, 0x60900000, 0x24180000, 0x60900000, 0x24180000, 0x00182400, 0x00906000}
   , 0xc005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat218,12,8, "CS23",0,-2,4,1,4,3,0x0,685,
    { 0x00fcfcfc, 0xf0f0f000, 0xfcfc0000, 0x3f3f3f03, 0xf0f0f000, 0xfcfc0000, 0x3f3f3f00, 0x00fcfcff},
    { 0x00204000, 0x40200000, 0x04200000, 0x00200400, 0x00204000, 0x40200000, 0x04200000, 0x00200400}
   , 0xc005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat219,20,8, "CS24",0,-3,4,1,4,4,0x0,649,
    { 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff},
    { 0x00100020, 0x00100000, 0x00100000, 0x00120000, 0x00100000, 0x00100000, 0x00120000, 0x00100020}
   , 0x8005,0.000000,attributes+0,1,NULL,autohelperpat219,0,0.010000},
  {pat220,20,8, "CS25",0,-3,4,1,4,4,0x0,687,
    { 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff},
    { 0x00100060, 0x00100000, 0x00100000, 0x00120100, 0x00100000, 0x00100000, 0x01120000, 0x00100024}
   , 0x8015,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat221,11,8, "CS26",0,-1,4,2,4,3,0x0,687,
    { 0x0030fcfc, 0xc0f0c000, 0xfc300000, 0x0f3f0f00, 0xc0f0c000, 0xfc300000, 0x0f3f0f00, 0x0030fcfc},
    { 0x00201000, 0x00600000, 0x10200000, 0x00240000, 0x00600000, 0x10200000, 0x00240000, 0x00201000}
   , 0x5,0.000000,attributes+33,0,NULL,NULL,3,0.000000},
  {pat222,17,8, "ES1",0,-4,3,0,3,4,0x2,612,
    { 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3f},
    { 0x00100010, 0x00100000, 0x02100000, 0x00110008, 0x00100080, 0x00100000, 0x00110000, 0x00100210}
   , 0x8004,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat223,17,8, "ES2",0,-4,3,0,3,4,0x2,574,
    { 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3f},
    { 0x00100010, 0x00100000, 0x02100000, 0x00110009, 0x00100080, 0x00100000, 0x00110000, 0x00100211}
   , 0x8004,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat224,20,8, "ES3a",0,-2,4,2,4,4,0x2,686,
    { 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0x00ffffff},
    { 0x00100200, 0x00100080, 0x00100000, 0x00100002, 0x00100000, 0x02100000, 0x00100008, 0x00100002}
   , 0x6001,0.000000,attributes+0,1,NULL,autohelperpat224,0,0.010000},
  {pat225,20,8, "ES3b",0,-2,4,2,4,4,0x2,686,
    { 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0x00ffffff},
    { 0x00100200, 0x00100080, 0x00100000, 0x00100002, 0x00100000, 0x02100000, 0x00100008, 0x00100002}
   , 0x5001,0.000000,attributes+0,1,NULL,autohelperpat225,0,6.010000},
  {pat226,15,8, "EB4",0,-1,3,3,3,4,0x2,686,
    { 0x0032ffff, 0xc0f0c0e0, 0xfc300000, 0x0f3f0f00, 0xc0f0c000, 0xff320000, 0x0f3f0f2f, 0x0030fcfc},
    { 0x00200100, 0x00200040, 0x00200000, 0x00200000, 0x00200000, 0x01200000, 0x00200004, 0x00200000}
   , 0x9005,0.000000,attributes+0,1,NULL,autohelperpat226,3,1.000000},
  {pat227,17,8, "EB5",0,-4,3,1,3,5,0x2,686,
    { 0x00f0fcfc, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0x003fffff},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x9005,0.000000,attributes+0,1,NULL,autohelperpat227,3,10.000000},
  {pat228,10,8, "EB6",-1,-1,2,3,3,4,0x2,759,
    { 0xfcffffff, 0xfcfcfcf0, 0xfcfcfc00, 0xffffff00, 0xfcfcfc00, 0xfffffc00, 0xffffff3f, 0xfcfcfcfc},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat229,18,8, "EB7",0,-1,3,3,3,4,0x2,760,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x00285000, 0x40602000, 0x14a00000, 0x20240400, 0x20604000, 0x50280000, 0x04242000, 0x00a01400}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat230,12,8, "EB8",0,-1,3,2,3,3,0x2,723,
    { 0x00ffffff, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0x00fcfcfc},
    { 0x00204200, 0x40200080, 0x04200000, 0x00200400, 0x00204000, 0x42200000, 0x04200008, 0x00200400}
   , 0x9005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat231,13,8, "EB9",0,-1,3,3,3,4,0x2,686,
    { 0x00fcffff, 0xf0f0f0c0, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xfffc0000, 0x3f3f3f0f, 0x00fcfcfc},
    { 0x00200100, 0x00200040, 0x00200000, 0x00200000, 0x00200000, 0x01200000, 0x00200004, 0x00200000}
   , 0x9005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat232,16,8, "EB10",0,-4,3,1,3,5,0x2,686,
    { 0x00f0f0fc, 0xf0f00000, 0x3f3f0000, 0x033f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0300, 0x003f3fff},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x9005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat233,23,8, "EB11",0,-2,4,3,4,5,0x2,686,
    { 0x00ffffff, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f03, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0x00fcfcff},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x9005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat234,17,8, "EB102",0,-1,3,4,3,5,0x2,759,
    { 0x003fbfff, 0x80f0f0f0, 0xf8f00000, 0x3f3f0b00, 0xf0f08000, 0xbf3f0000, 0x0b3f3f3f, 0x00f0f8fc},
    { 0x00281040, 0x00602000, 0x10a00000, 0x20240100, 0x20600000, 0x10280000, 0x01242000, 0x00a01004}
   , 0x9005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat235,14,8, "EB104",0,-2,3,2,3,4,0x2,648,
    { 0x00fefeff, 0xf0f0f0a0, 0xfffc0000, 0x3f3f3f0f, 0xf0f0f0c0, 0xfefe0000, 0x3f3f3f2b, 0x00fcffff},
    { 0x00200001, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200001, 0x00200000}
   , 0x9005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat236,22,8, "EB105",-1,-1,4,3,5,4,0x2,722,
    { 0xffffffff, 0xfcfcfcfc, 0xfcfcfc00, 0xffffff00, 0xfcfcfc00, 0xffffff00, 0xffffffff, 0xfcfcfcfc},
    { 0x00200040, 0x00200000, 0x00200000, 0x00200100, 0x00200000, 0x00200000, 0x01200000, 0x00200004}
   , 0x9005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat237,33,8, "EB106",-1,-1,4,5,5,6,0x2,759,
    { 0xffffffff, 0xfcfcfcfc, 0xfcfcfc00, 0xffffff00, 0xfcfcfc00, 0xffffff00, 0xffffffff, 0xfcfcfcfc},
    { 0x00200010, 0x00200000, 0x00200000, 0x00210000, 0x00200000, 0x00200000, 0x00210000, 0x00200010}
   , 0x9005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat238,11,8, "EB107",0,-1,3,2,3,3,0x2,722,
    { 0x00ffffff, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0x00fcfcfc},
    { 0x00200040, 0x00200000, 0x00200000, 0x00200100, 0x00200000, 0x00200000, 0x01200000, 0x00200004}
   , 0xd005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat239,14,8, "EB108",-1,-3,2,1,3,4,0x2,610,
    { 0xfcfcfcfc, 0xfcfcfc00, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xfcfcfc00, 0xffffff00, 0xffffffff},
    { 0x00241000, 0x00601000, 0x10600000, 0x10240000, 0x10600000, 0x10240000, 0x00241000, 0x00601000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat240,14,8, "EB109",0,-2,3,2,3,4,0x2,722,
    { 0x00ffffff, 0xf0f0f0f0, 0xfffc0000, 0x3f3f3f0f, 0xf0f0f0c0, 0xffff0000, 0x3f3f3f3f, 0x00fcffff},
    { 0x00200000, 0x00200000, 0x01200000, 0x00200005, 0x00200040, 0x00200000, 0x00200000, 0x00200101}
   , 0x9005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat241,15,8, "EB110",0,-1,3,4,3,5,0x2,759,
    { 0x0033ffff, 0xc0f0c0f0, 0xfc300000, 0x0f3f0f00, 0xc0f0c000, 0xff330000, 0x0f3f0f3f, 0x0030fcfc},
    { 0x00204040, 0x40200000, 0x04200000, 0x00200500, 0x00204000, 0x40200000, 0x05200000, 0x00200404}
   , 0x9005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat242,15,8, "EB111",0,-1,3,3,3,4,0x2,722,
    { 0x0033feff, 0xc0f0c0b0, 0xfc300000, 0x0f3f0f00, 0xc0f0c000, 0xfe330000, 0x0f3f0f3b, 0x0030fcfc},
    { 0x00204040, 0x40200000, 0x04200000, 0x00200500, 0x00204000, 0x40200000, 0x05200000, 0x00200404}
   , 0x9005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat243,14,8, "EB112",0,-1,4,2,4,3,0xa,723,
    { 0x00bcfffc, 0xe0f0f0c0, 0xfcf80000, 0x3f3f2f00, 0xf0f0e000, 0xffbc0000, 0x2f3f3f0c, 0x00f8fcfc},
    { 0x00140200, 0x00101080, 0x00500000, 0x10100000, 0x10100000, 0x02140000, 0x00101008, 0x00500000}
   , 0x9005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat244,15,8, "EB113",0,0,3,3,3,3,0x2,759,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00281010, 0x00602000, 0x10a00000, 0x20250000, 0x20600000, 0x10280000, 0x00252000, 0x00a01010}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat245,19,8, "EB114",0,-2,4,3,4,5,0x2,723,
    { 0x003fffff, 0xc0f0f0f0, 0xfff00000, 0x3f3f0f0f, 0xf0f0c0c0, 0xff3f0000, 0x0f3f3f3f, 0x00f0ffff},
    { 0x00200000, 0x00200000, 0x01200000, 0x00200005, 0x00200040, 0x00200000, 0x00200000, 0x00200101}
   , 0x9005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat246,22,8, "EB201",-3,-1,2,3,5,4,0x2,682,
    { 0xffffffff, 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffff00, 0xffffffff, 0xffffffff, 0xfcfcfcfc},
    { 0x00120000, 0x00100020, 0x00100000, 0x00100000, 0x00100000, 0x00120000, 0x00100020, 0x00100000}
   , 0x8005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat247,25,8, "EB202",-3,0,2,4,5,4,0x2,756,
    { 0x3f3f3f3f, 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0xffff0000, 0x3f3f3f3f, 0x00ffffff, 0xf0f0f0f0},
    { 0x00210000, 0x00200010, 0x00200000, 0x00200000, 0x00200000, 0x00210000, 0x00200010, 0x00200000}
   , 0x8005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat248,23,8, "EB203",-1,-4,3,1,4,5,0x2,610,
    { 0xc0f0fcfc, 0xfcf0c000, 0xff3f0f00, 0x0f3fffff, 0xc0f0fcfc, 0xfcf0c000, 0xff3f0f00, 0x0f3fffff},
    { 0x00200440, 0x00204000, 0x40200000, 0x04200100, 0x40200000, 0x04200000, 0x01200400, 0x00204004}
   , 0x1001,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat249,19,8, "EB204",-1,0,4,3,5,3,0x2,758,
    { 0x3f3f3f3f, 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff, 0xf0f0f0f0},
    { 0x00200021, 0x00200000, 0x00200000, 0x00220000, 0x00200000, 0x00200000, 0x00220001, 0x00200020}
   , 0x2001,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat250,15,8, "EB205",-1,-3,3,0,4,3,0x2,609,
    { 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff, 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f},
    { 0x00200010, 0x00200000, 0x01200000, 0x00210004, 0x00200040, 0x00200000, 0x00210000, 0x00200110}
   , 0x8005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat251,19,8, "EB206",-2,0,3,4,5,4,0x2,757,
    { 0x0f3f3f3f, 0x00f0fcff, 0xf0f0c000, 0xff3f0000, 0xfcf00000, 0x3f3f0f03, 0x003fffff, 0xc0f0f0f0},
    { 0x00200100, 0x00200040, 0x00200000, 0x00200000, 0x00200000, 0x01200000, 0x00200004, 0x00200000}
   , 0x8005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat252,42,8, "EB207",-2,-2,4,4,6,6,0x2,721,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00202450, 0x00a04000, 0x62200000, 0x0429010a, 0x40a00080, 0x24200000, 0x01290400, 0x00206216}
   , 0x8005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat253,22,8, "EB208",-1,-2,4,2,5,4,0x2,721,
    { 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xffffffff},
    { 0x00200010, 0x00200000, 0x01200000, 0x00210004, 0x00200040, 0x00200000, 0x00210000, 0x00200110}
   , 0x8005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat254,37,8, "EB209",-1,-7,3,1,4,8,0x2,611,
    { 0xfcfcfcfc, 0xfcfcfc00, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xfcfcfc00, 0xffffff00, 0xffffffff},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x40000,0.000000,attributes+35,0,NULL,NULL,3,0.000000},
  {pat255,32,8, "EB210",-2,-7,3,1,5,8,0x2,610,
    { 0xc0f0d4c0, 0xfd704000, 0x5f3f0f04, 0x0434ffff, 0x4070fdfc, 0xd4f0c040, 0xff340400, 0x0f3f5f0f},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x0,0.000000,attributes+37,0,NULL,NULL,3,0.000000},
  {pat256,32,8, "EB211",-2,-7,3,1,5,8,0x2,573,
    { 0xc0f0d4c0, 0xfd704000, 0x5f3f0f04, 0x0434ffff, 0x4070fdfc, 0xd4f0c040, 0xff340400, 0x0f3f5f0f},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x0,0.000000,attributes+39,0,NULL,NULL,3,0.000000},
  {pat257,22,8, "EB301",-1,-1,3,4,4,5,0x2,797,
    { 0xffffffff, 0xfcfcfcfc, 0xfcfcfc00, 0xffffff00, 0xfcfcfc00, 0xffffff00, 0xffffffff, 0xfcfcfcfc},
    { 0x00110000, 0x00100010, 0x00100000, 0x00100000, 0x00100000, 0x00110000, 0x00100010, 0x00100000}
   , 0x9005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat258,12,8, "EB302",0,-1,3,2,3,3,0x2,722,
    { 0x00ffffff, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0x00fcfcfc},
    { 0x00124000, 0x40100020, 0x04100000, 0x00100400, 0x00104000, 0x40120000, 0x04100020, 0x00100400}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat259,16,8, "EB303",-1,-1,2,4,3,5,0x2,758,
    { 0xffffffff, 0xfcfcfcfc, 0xfcfcfc00, 0xffffff00, 0xfcfcfc00, 0xffffff00, 0xffffffff, 0xfcfcfcfc},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat260,17,8, "EB304",0,0,3,4,3,4,0x2,759,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat261,17,8, "EB305",0,0,3,4,3,4,0x2,759,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat262,10,8, "EB306",-1,0,2,3,3,3,0x2,721,
    { 0x033f3f3f, 0x00f0f0fc, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0300, 0x003f3fff, 0x00f0f0f0},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x1005,0.000000,attributes+0,1,NULL,autohelperpat262,3,0.010000},
  {pat263,11,8, "EB307",0,-2,3,1,3,3,0x2,648,
    { 0x0030fcfc, 0xc0f0c000, 0xff300000, 0x0f3f0f0f, 0xc0f0c0c0, 0xfc300000, 0x0f3f0f00, 0x0030ffff},
    { 0x00100400, 0x00104000, 0x42100000, 0x04100008, 0x40100080, 0x04100000, 0x00100400, 0x00104200}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat264,13,8, "EB308",0,0,3,3,3,3,0x2,722,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat265,11,8, "EB309",0,-1,3,2,3,3,0x2,722,
    { 0x00ffffff, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0x00fcfcfc},
    { 0x00100200, 0x00100080, 0x00100000, 0x00100000, 0x00100000, 0x02100000, 0x00100008, 0x00100000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat266,17,8, "EB310",0,0,3,4,3,4,0x2,722,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat267,33,8, "EB311",-1,-1,3,6,4,7,0x2,833,
    { 0xffffffff, 0xfcfcfcfc, 0xfcfcfc00, 0xffffff00, 0xfcfcfc00, 0xffffff00, 0xffffffff, 0xfcfcfcfc},
    { 0x00104000, 0x40100000, 0x04100000, 0x00100400, 0x00104000, 0x40100000, 0x04100000, 0x00100400}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat268,19,8, "EB312",-1,0,3,4,4,4,0x2,759,
    { 0x3f3f3f3f, 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff, 0xf0f0f0f0},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat269,6,8, "EB313",0,-1,2,3,2,4,0x2,722,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00210000, 0x00200010, 0x00200000, 0x00200000, 0x00200000, 0x00210000, 0x00200010, 0x00200000}
   , 0x1005,0.000000,attributes+0,1,NULL,autohelperpat269,3,0.016000},
  {pat270,14,8, "EB314",-1,0,3,3,4,3,0x2,722,
    { 0x083f3f3f, 0x00f0f8f0, 0xf0f08000, 0xbf3f0000, 0xf8f00000, 0x3f3f0800, 0x003fbf3f, 0x80f0f0f0},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat271,17,8, "EB315",0,0,3,4,3,4,0x2,759,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat272,23,8, "EB316",0,0,3,5,3,5,0x2,796,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00251000, 0x00601010, 0x10600000, 0x10240000, 0x10600000, 0x10250000, 0x00241010, 0x00601000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat273,21,8, "EB317",-1,0,3,4,4,4,0x2,759,
    { 0x3f3f3f3f, 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff, 0xf0f0f0f0},
    { 0x00202000, 0x00a00000, 0x20200000, 0x00280000, 0x00a00000, 0x20200000, 0x00280000, 0x00202000}
   , 0x5005,0.000000,attributes+0,1,NULL,autohelperpat273,3,0.010000},
  {pat274,9,8, "EB401",0,0,2,4,2,4,0x2,759,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x1001,0.000000,attributes+0,0,jump_out_far_helper
,NULL,0,0.000000},
  {pat275,13,8, "EB402",-1,0,2,4,3,4,0x2,758,
    { 0x3f3f3f3f, 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff, 0xf0f0f0f0},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x1001,0.000000,attributes+0,1,jump_out_far_helper
,autohelperpat275,0,0.010000},
  {pat276,15,8, "EB403",-1,0,2,4,3,4,0x2,796,
    { 0x0f3f3f3f, 0x00f0fcfc, 0xf0f0c000, 0xff3f0000, 0xfcf00000, 0x3f3f0f00, 0x003fffff, 0xc0f0f0f0},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x1001,0.000000,attributes+0,1,jump_out_far_helper
,autohelperpat276,0,1.006000},
  {pat277,12,8, "EB404",0,-1,2,3,2,4,0x2,759,
    { 0x00bfffff, 0xe0f0f0f0, 0xfcf80000, 0x3f3f2f00, 0xf0f0e000, 0xffbf0000, 0x2f3f3f3f, 0x00f8fcfc},
    { 0x00104000, 0x40100000, 0x04100000, 0x00100400, 0x00104000, 0x40100000, 0x04100000, 0x00100400}
   , 0x1001,0.000000,attributes+0,0,jump_out_helper
,NULL,0,0.000000},
  {pat278,13,8, "EB405",0,0,2,4,2,4,0x2,796,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00140000, 0x00101000, 0x00500000, 0x10100000, 0x10100000, 0x00140000, 0x00101000, 0x00500000}
   , 0x1001,0.000000,attributes+0,0,jump_out_helper
,NULL,0,0.000000},
  {pat279,15,8, "EB406",-1,0,2,4,3,4,0x2,795,
    { 0x013f3f3f, 0x00f0f0f4, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0100, 0x003f3f7f, 0x00f0f0f0},
    { 0x00140000, 0x00101000, 0x00500000, 0x10100000, 0x10100000, 0x00140000, 0x00101000, 0x00500000}
   , 0x1001,0.000000,attributes+0,0,jump_out_helper
,NULL,0,0.000000},
  {pat280,15,8, "EB407",0,-1,2,4,2,5,0x2,796,
    { 0x00bfffff, 0xe0f0f0f0, 0xfcf80000, 0x3f3f2f00, 0xf0f0e000, 0xffbf0000, 0x2f3f3f3f, 0x00f8fcfc},
    { 0x00104000, 0x40100000, 0x04100000, 0x00100400, 0x00104000, 0x40100000, 0x04100000, 0x00100400}
   , 0x1001,0.000000,attributes+0,1,jump_out_helper
,autohelperpat280,0,10.000000},
  {pat281,7,8, "EB408",-1,0,1,3,2,3,0x2,758,
    { 0x2f3f3f00, 0x00f8fcfc, 0xf0f0e000, 0xfcbc0000, 0xfcf80000, 0x3f3f2f00, 0x00bcfcfc, 0xe0f0f000},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x1001,0.000000,attributes+0,0,jump_out_helper
,NULL,0,0.000000},
  {pat282,11,8, "EB409",-1,0,1,4,2,4,0x2,795,
    { 0x2f3f3f00, 0x00f8fcfc, 0xf0f0e000, 0xfcbc0000, 0xfcf80000, 0x3f3f2f00, 0x00bcfcfc, 0xe0f0f000},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x1001,0.000000,attributes+0,1,jump_out_helper
,autohelperpat282,0,0.010000},
  {pat283,25,8, "EB410",-1,0,4,5,5,5,0x2,759,
    { 0x3f3f3f3f, 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff, 0xf0f0f0f0},
    { 0x00102429, 0x00904000, 0x60100000, 0x061a0000, 0x40900000, 0x24100000, 0x001a0601, 0x001060a0}
   , 0xc000,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat284,37,8, "EB411",-1,0,4,6,5,6,0x2,759,
    { 0x3f3f3f3f, 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff, 0xf0f0f0f0},
    { 0x00102429, 0x00904000, 0x60100000, 0x061a0000, 0x40900000, 0x24100000, 0x001a0601, 0x001060a0}
   , 0xd000,0.000000,attributes+41,1,NULL,autohelperpat284,0,0.010000},
  {pat285,13,8, "EB412",0,0,3,3,3,3,0x2,760,
    { 0x00303f3f, 0x00f0c0c0, 0xf0300000, 0x0f3f0000, 0xc0f00000, 0x3f300000, 0x003f0f0f, 0x0030f0f0},
    { 0x00201a04, 0x00608080, 0x90200000, 0x09240000, 0x80600000, 0x1a200000, 0x00240908, 0x00209040}
   , 0x9005,0.000000,attributes+43,0,NULL,NULL,3,0.000000},
  {pat286,17,8, "EB501",-1,-2,3,2,4,4,0x2,647,
    { 0xfcffffff, 0xfcfcfcf0, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xfffffc00, 0xffffff3f, 0xffffffff},
    { 0x00221000, 0x00600020, 0x10200000, 0x00240000, 0x00600000, 0x10220000, 0x00240020, 0x00201000}
   , 0x9000,0.000000,attributes+45,0,NULL,NULL,3,0.000000},
  {pat287,25,8, "EB501a",0,-3,4,2,4,5,0x2,723,
    { 0x00fcffff, 0xf0f0f0c0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xfffc0000, 0x3f3f3f0f, 0x00ffffff},
    { 0x00206210, 0x40a00080, 0x24200000, 0x00290400, 0x00a04000, 0x62200000, 0x04290008, 0x00202410}
   , 0x9000,0.000000,attributes+47,0,NULL,NULL,3,0.000000},
  {pat288,20,8, "EB502",0,-2,3,3,3,5,0x2,648,
    { 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0x00ffffff},
    { 0x00122000, 0x00900020, 0x20100000, 0x00180000, 0x00900000, 0x20120000, 0x00180020, 0x00102000}
   , 0x1001,0.000000,attributes+49,0,NULL,NULL,0,0.000000},
  {pat289,20,8, "EB503",0,-2,3,3,3,5,0x2,648,
    { 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0x00ffffff},
    { 0x00102000, 0x00900000, 0x20100000, 0x00180000, 0x00900000, 0x20100000, 0x00180000, 0x00102000}
   , 0x1001,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat290,15,8, "EB504",0,-2,3,2,3,4,0x2,685,
    { 0x00fefeff, 0xf0f0f0a0, 0xfdfc0000, 0x3f3f3f07, 0xf0f0f040, 0xfefe0000, 0x3f3f3f2b, 0x00fcfdff},
    { 0x00108000, 0x80100000, 0x08100000, 0x00100800, 0x00108000, 0x80100000, 0x08100000, 0x00100800}
   , 0x1001,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat291,15,8, "EB505",-1,-2,3,2,4,4,0x2,647,
    { 0x30ffffff, 0xf0fcf0f0, 0xffff3000, 0x3fff3f3c, 0xf0fcf0f0, 0xffff3000, 0x3fff3f3f, 0x30fffffc},
    { 0x00201400, 0x00604000, 0x51200000, 0x04240004, 0x40600040, 0x14200000, 0x00240400, 0x00205100}
   , 0x1001,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat292,15,8, "EB506",-1,-2,3,2,4,4,0x2,647,
    { 0x30ffffff, 0xf0fcf0f0, 0xfdff3000, 0x3fff3f34, 0xf0fcf070, 0xffff3000, 0x3fff3f3f, 0x30fffdfc},
    { 0x00201400, 0x00604000, 0x50200000, 0x04240000, 0x40600000, 0x14200000, 0x00240400, 0x00205000}
   , 0x1001,0.000000,attributes+0,1,NULL,autohelperpat292,3,3.000000},
  {pat293,13,8, "EB507",-1,-1,3,2,4,3,0x2,685,
    { 0x203fffff, 0xc0f8f0f0, 0xfcf02000, 0x3fbf0f00, 0xf0f8c000, 0xff3f2000, 0x0fbf3f3f, 0x20f0fcfc},
    { 0x00108000, 0x80100000, 0x08100000, 0x00100800, 0x00108000, 0x80100000, 0x08100000, 0x00100800}
   , 0x1001,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat294,13,8, "EB507a",-1,-1,3,2,4,3,0x2,685,
    { 0x203fffff, 0xc0f8f0f0, 0xfcf02000, 0x3fbf0f00, 0xf0f8c000, 0xff3f2000, 0x0fbf3f3f, 0x20f0fcfc},
    { 0x00108040, 0x80100000, 0x08100000, 0x00100900, 0x00108000, 0x80100000, 0x09100000, 0x00100804}
   , 0x1001,0.000000,attributes+51,0,NULL,NULL,0,0.000000},
  {pat295,14,8, "EB508",0,-2,4,1,4,3,0x2,649,
    { 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff},
    { 0x00100008, 0x00100000, 0x00100000, 0x02100000, 0x00100000, 0x00100000, 0x00100200, 0x00100080}
   , 0x2001,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat296,17,8, "EB509",-1,0,3,3,4,3,0x2,722,
    { 0x0f3f3f3f, 0x00f0fcfc, 0xf0f0c000, 0xff3f0000, 0xfcf00000, 0x3f3f0f00, 0x003fffff, 0xc0f0f0f0},
    { 0x00242000, 0x00a01000, 0x20600000, 0x10280000, 0x10a00000, 0x20240000, 0x00281000, 0x00602000}
   , 0x1001,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat297,12,8, "EB510",0,-1,3,2,3,3,0x2,685,
    { 0x00ffffff, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0x00fcfcfc},
    { 0x00118000, 0x80100010, 0x08100000, 0x00100800, 0x00108000, 0x80110000, 0x08100010, 0x00100800}
   , 0x1001,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat298,11,8, "EB511",0,-1,3,2,3,3,0x2,722,
    { 0x00fcffff, 0xf0f0f0c0, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xfffc0000, 0x3f3f3f0f, 0x00fcfcfc},
    { 0x00104200, 0x40100080, 0x04100000, 0x00100400, 0x00104000, 0x42100000, 0x04100008, 0x00100400}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat299,8,8, "EB512",0,-3,2,0,2,3,0x2,647,
    { 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3f},
    { 0x00200000, 0x00200000, 0x01200000, 0x00200004, 0x00200040, 0x00200000, 0x00200000, 0x00200100}
   , 0x1001,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat300,26,8, "EB513",-1,0,3,5,4,5,0x2,795,
    { 0x3f3f3f3f, 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff, 0xf0f0f0f0},
    { 0x00220900, 0x00208060, 0x80200000, 0x08200000, 0x80200000, 0x09220000, 0x00200824, 0x00208000}
   , 0x1001,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat301,13,8, "EB514",0,-1,4,2,4,3,0x2,685,
    { 0x003cff3c, 0xc0f0f0c0, 0xfcf00000, 0x3f3f0c00, 0xf0f0c000, 0xff3c0000, 0x0c3f3f0c, 0x00f0fcf0},
    { 0x00108010, 0x80100000, 0x08100000, 0x00110800, 0x00108000, 0x80100000, 0x08110000, 0x00100810}
   , 0x1020,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat302,19,8, "EB515",0,-1,4,3,4,4,0x2,723,
    { 0x003c3fff, 0x00f0f0c0, 0xf0f00000, 0x3f3f0300, 0xf0f00000, 0x3f3c0000, 0x033f3f0f, 0x00f0f0fc},
    { 0x00140000, 0x00101000, 0x00500000, 0x10100000, 0x10100000, 0x00140000, 0x00101000, 0x00500000}
   , 0x1001,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat303,31,8, "EB516",-1,0,3,6,4,6,0x2,722,
    { 0x2f3f3f3f, 0x00f8fcfc, 0xf0f0e000, 0xffbf0000, 0xfcf80000, 0x3f3f2f00, 0x00bfffff, 0xe0f0f0f0},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x1001,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat304,14,8, "EB517",0,-1,3,3,3,4,0x2,722,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x00110200, 0x00100090, 0x00100000, 0x00100000, 0x00100000, 0x02110000, 0x00100018, 0x00100000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat305,10,8, "EB518",-2,0,1,2,3,2,0x2,720,
    { 0x1f3f3f00, 0x00f6fffe, 0xf0f0d0e0, 0xfc7c0000, 0xfff60000, 0x3f3f1f2e, 0x007cfcfc, 0xd0f0f000},
    { 0x00242000, 0x00a01000, 0x20600000, 0x10280000, 0x10a00000, 0x20240000, 0x00281000, 0x00602000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat306,13,8, "EB519",0,-3,3,0,3,3,0xa,648,
    { 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3f},
    { 0x00100020, 0x00100000, 0x00100000, 0x00120000, 0x00100000, 0x00100000, 0x00120000, 0x00100020}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat307,21,8, "EB520",-1,0,3,4,4,4,0x2,722,
    { 0x3f3f3f3f, 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff, 0xf0f0f0f0},
    { 0x00240000, 0x00201000, 0x00600000, 0x10200000, 0x10200000, 0x00240000, 0x00201000, 0x00600000}
   , 0x1001,0.000000,attributes+0,1,NULL,autohelperpat307,3,0.010000},
  {pat308,17,8, "EB521",0,-2,4,1,4,3,0x2,649,
    { 0x00f0fcfc, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0x003fffff},
    { 0x00101824, 0x00508000, 0x90100000, 0x09160000, 0x80500000, 0x18100000, 0x00160900, 0x00109060}
   , 0x8004,0.000000,attributes+0,1,NULL,autohelperpat308,0,1.600000},
  {pat309,11,8, "EB601",0,-1,3,2,3,3,0x2,723,
    { 0x0038fcfe, 0xc0f0e000, 0xfcb00000, 0x2f3f0f00, 0xe0f0c000, 0xfc380000, 0x0f3f2f02, 0x00b0fcfc},
    { 0x00109020, 0x80500000, 0x18100000, 0x00160800, 0x00508000, 0x90100000, 0x08160000, 0x00101820}
   , 0xd005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat310,11,8, "EB602",0,-1,3,2,3,3,0x2,723,
    { 0x0038fcfe, 0xc0f0e000, 0xfcb00000, 0x2f3f0f00, 0xe0f0c000, 0xfc380000, 0x0f3f2f02, 0x00b0fcfc},
    { 0x00109000, 0x80500000, 0x18100000, 0x00140800, 0x00508000, 0x90100000, 0x08140000, 0x00101800}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat311,5,8, "EB603",0,-2,2,0,2,2,0x2,648,
    { 0x00f0f0f0, 0xf0f00000, 0x3f3c0000, 0x003f3f0c, 0x00f0f0c0, 0xf0f00000, 0x3f3f0000, 0x003c3f3c},
    { 0x00102000, 0x00900000, 0x20100000, 0x00180000, 0x00900000, 0x20100000, 0x00180000, 0x00102000}
   , 0x5005,0.000000,attributes+0,1,NULL,autohelperpat311,0,4.680000},
  {pat312,5,8, "EB604",0,-2,2,0,2,2,0x2,648,
    { 0x00f0f0f0, 0xf0f00000, 0x3f3c0000, 0x003f3f0c, 0x00f0f0c0, 0xf0f00000, 0x3f3f0000, 0x003c3f3c},
    { 0x00102000, 0x00900000, 0x21100000, 0x00180004, 0x00900040, 0x20100000, 0x00180000, 0x00102100}
   , 0x1005,0.000000,attributes+0,1,NULL,autohelperpat312,0,1.000000},
  {pat313,5,8, "EB605",0,-2,2,0,2,2,0x2,648,
    { 0x00f0f0f0, 0xf0f00000, 0x3f3c0000, 0x003f3f0c, 0x00f0f0c0, 0xf0f00000, 0x3f3f0000, 0x003c3f3c},
    { 0x00102000, 0x00900000, 0x22100000, 0x00180008, 0x00900080, 0x20100000, 0x00180000, 0x00102200}
   , 0x1005,0.000000,attributes+0,1,NULL,autohelperpat313,0,1.000000},
  {pat314,9,8, "EB606",0,-1,2,2,2,3,0x2,685,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x00158000, 0x80101010, 0x08500000, 0x10100800, 0x10108000, 0x80150000, 0x08101010, 0x00500800}
   , 0x9005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat315,5,8, "EB608",0,0,2,2,2,2,0x2,722,
    { 0x003c3f3c, 0x00f0f0c0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3c0000, 0x003f3f0c, 0x00f0f0f0},
    { 0x00140200, 0x00101080, 0x00500000, 0x10100000, 0x10100000, 0x02140000, 0x00101008, 0x00500000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat316,10,8, "EB609",0,0,2,3,2,3,0x2,759,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00210800, 0x00208010, 0x80200000, 0x08200000, 0x80200000, 0x08210000, 0x00200810, 0x00208000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat317,12,8, "EB610",0,0,2,4,2,4,0x2,796,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00101000, 0x00500000, 0x10100000, 0x00140000, 0x00500000, 0x10100000, 0x00140000, 0x00101000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat318,11,8, "EB611",0,0,2,3,2,3,0x2,685,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00160800, 0x00109020, 0x80500000, 0x18100000, 0x90100000, 0x08160000, 0x00101820, 0x00508000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat319,14,8, "EB612",-1,-1,3,2,4,3,0x2,723,
    { 0x00ffffff, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0x00fcfcfc},
    { 0x0010a400, 0x80904000, 0x68100000, 0x04180800, 0x40908000, 0xa4100000, 0x08180400, 0x00106800}
   , 0x1005,0.000000,attributes+0,1,NULL,autohelperpat319,0,1.006000},
  {pat320,5,8, "EB615",0,-1,2,1,2,2,0x2,685,
    { 0x00f0fcfc, 0xf0f0c000, 0xfc3c0000, 0x0f3f3f00, 0xc0f0f000, 0xfcf00000, 0x3f3f0f00, 0x003cfcfc},
    { 0x00100800, 0x00108000, 0x80100000, 0x08100000, 0x80100000, 0x08100000, 0x00100800, 0x00108000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat321,5,8, "EB615b",0,-1,2,1,2,2,0x2,685,
    { 0x00f0fcfc, 0xf0f0c000, 0xfc3c0000, 0x0f3f3f00, 0xc0f0f000, 0xfcf00000, 0x3f3f0f00, 0x003cfcfc},
    { 0x00100800, 0x00108000, 0x80100000, 0x08100000, 0x80100000, 0x08100000, 0x00100800, 0x00108000}
   , 0x9005,0.000000,attributes+0,1,NULL,autohelperpat321,0,0.010000},
  {pat322,9,8, "EB616",0,-3,2,1,2,4,0x2,648,
    { 0x00f0fcfc, 0xf0f0c000, 0xff3e0000, 0x0f3f3f2f, 0xc0f0f0e0, 0xfcf00000, 0x3f3f0f00, 0x003effff},
    { 0x00100808, 0x00108000, 0x80100000, 0x0a100000, 0x80100000, 0x08100000, 0x00100a00, 0x00108080}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat323,8,8, "EB617",0,-1,2,2,2,3,0x2,722,
    { 0x00bcbfff, 0xa0f0f0c0, 0xf8f80000, 0x3f3f2b00, 0xf0f0a000, 0xbfbc0000, 0x2b3f3f0f, 0x00f8f8fc},
    { 0x00100200, 0x00100080, 0x00100000, 0x00100000, 0x00100000, 0x02100000, 0x00100008, 0x00100000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat324,7,8, "EB618",0,-1,2,2,2,3,0x2,685,
    { 0x00bcffff, 0xe0f0f0c0, 0xfcf80000, 0x3f3f2f00, 0xf0f0e000, 0xffbc0000, 0x2f3f3f0f, 0x00f8fcfc},
    { 0x00100202, 0x00100080, 0x00100000, 0x00100000, 0x00100000, 0x02100000, 0x0010000a, 0x00100000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat325,7,8, "EB619",0,-1,2,2,2,3,0x2,722,
    { 0x00bcffff, 0xe0f0f0c0, 0xfcf80000, 0x3f3f2f00, 0xf0f0e000, 0xffbc0000, 0x2f3f3f0f, 0x00f8fcfc},
    { 0x00100202, 0x00100080, 0x00100000, 0x00100000, 0x00100000, 0x02100000, 0x0010000a, 0x00100000}
   , 0x1005,0.000000,attributes+0,1,NULL,autohelperpat325,0,1.000000},
  {pat326,11,8, "EB624",0,-1,3,2,3,3,0x2,686,
    { 0x00303fff, 0x00f0c0c0, 0xf0300000, 0x0f3f0300, 0xc0f00000, 0x3f300000, 0x033f0f0f, 0x0030f0fc},
    { 0x00100608, 0x00104080, 0x40100000, 0x06100000, 0x40100000, 0x06100000, 0x00100608, 0x00104080}
   , 0x1001,0.000000,attributes+0,1,NULL,autohelperpat326,0,6.010000},
  {pat327,15,8, "EB626",0,0,3,4,3,4,0x2,797,
    { 0x00333f3f, 0x00f0c0f0, 0xf0300000, 0x0f3f0000, 0xc0f00000, 0x3f330000, 0x003f0f3f, 0x0030f0f0},
    { 0x00212102, 0x00a00050, 0x20200000, 0x00280000, 0x00a00000, 0x21210000, 0x00280016, 0x00202000}
   , 0x1001,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat328,21,8, "EB627",0,-1,3,4,3,5,0x2,686,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x00109280, 0x80500080, 0x18100000, 0x00140a00, 0x00508000, 0x92100000, 0x0a140008, 0x00101808}
   , 0x1001,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat329,11,8, "EB628",0,-1,3,2,3,3,0x2,686,
    { 0x00ffffff, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0x00fcfcfc},
    { 0x00100002, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100002, 0x00100000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat330,7,8, "EB629",-1,-1,2,2,3,3,0x2,685,
    { 0xf0fcffff, 0xfcfcf0c0, 0xfcfc3c00, 0x3fffff00, 0xf0fcfc00, 0xfffcf000, 0xffff3f0f, 0x3cfcfcfc},
    { 0x00180200, 0x00102080, 0x00900000, 0x20100000, 0x20100000, 0x02180000, 0x00102008, 0x00900000}
   , 0x1001,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat331,13,8, "EB630",0,-2,2,3,2,5,0x2,648,
    { 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0x00ffffff},
    { 0x00110122, 0x00100050, 0x00100000, 0x00120000, 0x00100000, 0x01110000, 0x00120016, 0x00100020}
   , 0x1001,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat332,14,8, "EB631",0,-1,3,3,3,4,0x2,686,
    { 0x00bcbfbf, 0xa0f0f0c0, 0xf8f80000, 0x3f3f2a00, 0xf0f0a000, 0xbfbc0000, 0x2a3f3f0f, 0x00f8f8f8},
    { 0x00100109, 0x00100040, 0x00100000, 0x02100000, 0x00100000, 0x01100000, 0x00100205, 0x00100080}
   , 0x1001,0.000000,attributes+0,1,NULL,autohelperpat332,0,1.000000},
  {pat333,14,8, "EB632",0,-2,3,2,3,4,0x2,723,
    { 0x00b0ffff, 0xe0f0c0c0, 0xfc380000, 0x0f3f2f03, 0xc0f0e000, 0xffb00000, 0x2f3f0f0f, 0x0038fcff},
    { 0x00104260, 0x40100080, 0x04100000, 0x00120502, 0x00104000, 0x42100000, 0x05120008, 0x00100426}
   , 0x1001,0.000000,attributes+0,1,NULL,autohelperpat333,0,10.000000},
  {pat334,12,8, "EB633",0,0,3,3,3,3,0x2,760,
    { 0x003f0f0f, 0x0030f0f0, 0xc0f00000, 0x3f300000, 0xf0300000, 0x0f3f0000, 0x00303f3f, 0x00f0c0c0},
    { 0x00110408, 0x00104010, 0x40100000, 0x06100000, 0x40100000, 0x04110000, 0x00100610, 0x00104080}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat335,25,8, "EB634",0,-3,4,2,4,5,0x2,687,
    { 0x00f8fcff, 0xf0f0e000, 0xffbf0000, 0x2f3f3f3f, 0xe0f0f0f0, 0xfcf80000, 0x3f3f2f03, 0x00bfffff},
    { 0x00100402, 0x00104000, 0x40100000, 0x04100000, 0x40100000, 0x04100000, 0x00100402, 0x00104000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat336,14,8, "EB635",0,-1,2,4,2,5,0x2,685,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x00158000, 0x80101010, 0x08500000, 0x10100800, 0x10108000, 0x80150000, 0x08101010, 0x00500800}
   , 0x8004,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat337,8,8, "EB637",-1,-3,1,0,2,3,0x2,610,
    { 0xc0f0f000, 0xfcf00000, 0x3f3f0e00, 0x003cfcbc, 0x00f0fcf8, 0xf0f0c000, 0xfc3c0000, 0x0e3f3f00},
    { 0x0010a000, 0x80900000, 0x28100000, 0x00180800, 0x00908000, 0xa0100000, 0x08180000, 0x00102800}
   , 0x1005,0.000000,attributes+0,1,NULL,autohelperpat337,0,4.800000},
  {pat338,14,8, "EB638",0,-1,2,4,2,5,0x2,722,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x00102000, 0x00900000, 0x20100000, 0x00180000, 0x00900000, 0x20100000, 0x00180000, 0x00102000}
   , 0x9005,0.000000,attributes+0,1,NULL,autohelperpat338,0,1.000000},
  {pat339,13,8, "EB639",0,-1,3,2,3,3,0x2,723,
    { 0x003bffff, 0xc0f0e0f0, 0xfcb00000, 0x2f3f0f00, 0xe0f0c000, 0xff3b0000, 0x0f3f2f3f, 0x00b0fcfc},
    { 0x00118080, 0x80100010, 0x08100000, 0x00100a00, 0x00108000, 0x80110000, 0x0a100010, 0x00100808}
   , 0xd005,0.000000,attributes+0,1,NULL,autohelperpat339,0,1.000000},
  {pat340,8,8, "EB640a",0,0,2,2,2,2,0x2,722,
    { 0x003a1f3f, 0x0070e0e0, 0xd0b00000, 0x2f370000, 0xe0700000, 0x1f3a0000, 0x00372f2f, 0x00b0d0f0},
    { 0x00100020, 0x00100000, 0x00100000, 0x00120000, 0x00100000, 0x00100000, 0x00120000, 0x00100020}
   , 0x1005,0.000000,attributes+0,1,NULL,autohelperpat340,0,3.000000},
  {pat341,6,8, "EB640b",0,-1,2,1,2,2,0x2,685,
    { 0x00f87cfc, 0x70f0e000, 0xf4bc0000, 0x2f3f3700, 0xe0f07000, 0x7cf80000, 0x373f2f00, 0x00bcf4fc},
    { 0x00100080, 0x00100000, 0x00100000, 0x00100200, 0x00100000, 0x00100000, 0x02100000, 0x00100008}
   , 0x1005,0.000000,attributes+53,1,NULL,autohelperpat341,0,3.000000},
  {pat342,6,8, "EB640c",0,-2,2,0,2,2,0x2,648,
    { 0x00f0f0f0, 0xf0f00000, 0x3d3f0000, 0x003f3f37, 0x00f0f070, 0xf0f00000, 0x3f3f0000, 0x003f3d3f},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100002, 0x00100000, 0x00100000, 0x00100000, 0x00100002}
   , 0x1005,0.000000,attributes+0,1,NULL,autohelperpat342,0,3.000000},
  {pat343,8,8, "EB641a",0,-1,2,2,2,3,0x2,722,
    { 0x00387fff, 0x40f0e0c0, 0xf4b00000, 0x2f3f0700, 0xe0f04000, 0x7f380000, 0x073f2f0f, 0x00b0f4fc},
    { 0x00100080, 0x00100000, 0x00100000, 0x00100200, 0x00100000, 0x00100000, 0x02100000, 0x00100008}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat344,6,8, "EB641b",0,-2,2,1,2,3,0x2,685,
    { 0x00f0fcfc, 0xf0f0c000, 0xfd3c0000, 0x0f3f3f07, 0xc0f0f040, 0xfcf00000, 0x3f3f0f00, 0x003cfdff},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100002, 0x00100000, 0x00100000, 0x00100000, 0x00100002}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat345,8,8, "EB641c",0,-3,2,0,2,3,0x2,648,
    { 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3f},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat346,8,8, "EB642",0,0,2,2,2,2,0xa,722,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00252000, 0x00a01010, 0x20600000, 0x10280000, 0x10a00000, 0x20250000, 0x00281010, 0x00602000}
   , 0x1005,0.000000,attributes+55,0,NULL,NULL,3,0.000000},
  {pat347,5,8, "EB643",0,-2,2,0,2,2,0x2,648,
    { 0x00f0f0f0, 0xf0f00000, 0x3f3c0000, 0x003f3f0f, 0x00f0f0c0, 0xf0f00000, 0x3f3f0000, 0x003c3f3f},
    { 0x00100000, 0x00100000, 0x01100000, 0x00100006, 0x00100040, 0x00100000, 0x00100000, 0x00100102}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat348,7,8, "EB701",0,-1,2,1,2,2,0xa,686,
    { 0x00fcfcfc, 0xf0f0f000, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xfcfc0000, 0x3f3f3f00, 0x00fcfcfc},
    { 0x00181800, 0x0050a000, 0x90900000, 0x28140000, 0xa0500000, 0x18180000, 0x00142800, 0x00909000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat349,7,8, "EB702a",-1,-1,1,4,2,5,0x2,759,
    { 0x083fff00, 0xc0f0f8f0, 0xfcf08000, 0xbc3c0c00, 0xf8f0c000, 0xff3f0800, 0x0c3cbc3c, 0x80f0fc00},
    { 0x00240800, 0x00209000, 0x80600000, 0x18200000, 0x90200000, 0x08240000, 0x00201800, 0x00608000}
   , 0x1005,0.000000,attributes+57,1,NULL,autohelperpat349,3,1.810000},
  {pat350,7,8, "EB702b",-1,-1,1,3,2,4,0x6,759,
    { 0x083fff00, 0xc0f0f8f0, 0xfcf08000, 0xbc3c0c00, 0xf8f0c000, 0xff3f0800, 0x0c3cbc3c, 0x80f0fc00},
    { 0x00240800, 0x00209000, 0x80600000, 0x18200000, 0x90200000, 0x08240000, 0x00201800, 0x00608000}
   , 0x1005,0.000000,attributes+59,1,NULL,autohelperpat350,3,0.010000},
  {pat351,6,8, "EB703",0,-1,2,1,2,2,0x2,686,
    { 0x0030fcfc, 0xc0f0c000, 0xfc300000, 0x0f3f0f00, 0xc0f0c000, 0xfc300000, 0x0f3f0f00, 0x0030fcfc},
    { 0x00104480, 0x40104000, 0x44100000, 0x04100600, 0x40104000, 0x44100000, 0x06100400, 0x00104408}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat352,7,8, "EB704",0,-2,2,0,2,2,0x2,686,
    { 0x00b0f0f0, 0xe0f00000, 0x3f380000, 0x003f2f0f, 0x00f0e0c0, 0xf0b00000, 0x2f3f0000, 0x00383f3f},
    { 0x00104080, 0x40100000, 0x06100000, 0x00100608, 0x00104080, 0x40100000, 0x06100000, 0x00100608}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat353,6,8, "EB705",-1,-1,1,3,2,4,0x2,685,
    { 0x003fff00, 0xc0f0f0f0, 0xfcf00000, 0x3c3c0c00, 0xf0f0c000, 0xff3f0000, 0x0c3c3c3c, 0x00f0fc00},
    { 0x00108000, 0x80100000, 0x08100000, 0x00100800, 0x00108000, 0x80100000, 0x08100000, 0x00100800}
   , 0x1005,0.000000,attributes+0,1,NULL,autohelperpat353,0,1.006000},
  {pat354,15,8, "EB706",0,-2,2,4,2,6,0x2,723,
    { 0x0038ffff, 0xc0f0e0c0, 0xffb00000, 0x2f3f0f0f, 0xe0f0c0c0, 0xff380000, 0x0f3f2f0f, 0x00b0ffff},
    { 0x00102420, 0x00904000, 0x60100000, 0x041a0000, 0x40900000, 0x24100000, 0x001a0400, 0x00106020}
   , 0x1005,0.000000,attributes+0,1,NULL,autohelperpat354,0,1.000000},
  {pat355,11,8, "EB707",-2,0,3,2,5,2,0xa,685,
    { 0x3c3f3e3c, 0x00ffffb0, 0xf0f0f0f0, 0xffff0000, 0xffff0000, 0x3e3f3c3c, 0x00ffff38, 0xf0f0f0f0},
    { 0x00290400, 0x00206010, 0x40a00000, 0x24200000, 0x60200000, 0x04290000, 0x00202410, 0x00a04000}
   , 0x1005,0.000000,attributes+61,1,NULL,autohelperpat355,3,1.000000},
  {pat356,4,8, "EB708",0,0,2,1,2,1,0x2,686,
    { 0x00303c3c, 0x00f0c000, 0xf0300000, 0x0f3f0000, 0xc0f00000, 0x3c300000, 0x003f0f00, 0x0030f0f0},
    { 0x00100408, 0x00104000, 0x40100000, 0x06100000, 0x40100000, 0x04100000, 0x00100600, 0x00104080}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat357,6,8, "EB709",0,-1,2,1,2,2,0xa,648,
    { 0x00fcfcfc, 0xf0f0f000, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xfcfc0000, 0x3f3f3f00, 0x00fcfcfc},
    { 0x00241000, 0x00601000, 0x10600000, 0x10240000, 0x10600000, 0x10240000, 0x00241000, 0x00601000}
   , 0x1005,0.000000,attributes+63,0,NULL,NULL,3,0.000000},
  {pat358,6,8, "EB709b",0,-1,2,1,2,2,0xa,647,
    { 0x00fcfcfc, 0xf0f0f000, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xfcfc0000, 0x3f3f3f00, 0x00fcfcfc},
    { 0x00241000, 0x00601000, 0x10600000, 0x10240000, 0x10600000, 0x10240000, 0x00241000, 0x00601000}
   , 0x1005,0.000000,attributes+65,0,NULL,NULL,3,0.000000},
  {pat359,9,8, "EB710",0,-2,1,3,1,5,0x2,648,
    { 0x00ffff00, 0xf0f0f0f0, 0xfffe0000, 0x3c3c3c2c, 0xf0f0f0e0, 0xffff0000, 0x3c3c3c3c, 0x00feff00},
    { 0x00162800, 0x00909020, 0xa0500000, 0x18180000, 0x90900000, 0x28160000, 0x00181820, 0x0050a000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat360,6,8, "EB711",0,-2,1,1,1,3,0x2,648,
    { 0x00fcfc00, 0xf0f0f000, 0xfffe0000, 0x3c3c3c2c, 0xf0f0f0e0, 0xfcfc0000, 0x3c3c3c00, 0x00feff00},
    { 0x00142800, 0x00909000, 0xa0500000, 0x18180000, 0x90900000, 0x28140000, 0x00181800, 0x0050a000}
   , 0x1005,0.000000,attributes+67,1,NULL,autohelperpat360,0,1.600000},
  {pat361,9,8, "EB712",0,-1,2,2,2,3,0x2,686,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x00109080, 0x80500000, 0x18100000, 0x00140a00, 0x00508000, 0x90100000, 0x0a140000, 0x00101808}
   , 0x1005,0.000000,attributes+69,1,NULL,autohelperpat361,0,3.000000},
  {pat362,11,8, "EB712b",0,-2,2,2,2,4,0x2,647,
    { 0x00ffffff, 0xf0f0f0f0, 0xfffc0000, 0x3f3f3f0f, 0xf0f0f0c0, 0xffff0000, 0x3f3f3f3f, 0x00fcffff},
    { 0x00109080, 0x80500000, 0x19100000, 0x00140a04, 0x00508040, 0x90100000, 0x0a140000, 0x00101908}
   , 0x1004,0.000000,attributes+71,1,NULL,autohelperpat362,0,4.330000},
  {pat363,4,8, "EB713",0,-1,1,2,1,3,0x2,685,
    { 0x003fff00, 0xc0f0f0f0, 0xfcf00000, 0x3c3c0c00, 0xf0f0c000, 0xff3f0000, 0x0c3c3c3c, 0x00f0fc00},
    { 0x00108000, 0x80100000, 0x08100000, 0x00100800, 0x00108000, 0x80100000, 0x08100000, 0x00100800}
   , 0x1005,0.000000,attributes+73,1,NULL,autohelperpat363,0,3.000000},
  {pat364,7,8, "EB714",0,0,1,3,1,3,0x2,759,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00240800, 0x00209000, 0x80600000, 0x18200000, 0x90200000, 0x08240000, 0x00201800, 0x00608000}
   , 0x200,0.000000,attributes+0,1,NULL,autohelperpat364,3,1.000000},
  {pat365,4,8, "EB715",0,0,1,2,1,2,0x2,758,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00102000, 0x00900000, 0x20100000, 0x00180000, 0x00900000, 0x20100000, 0x00180000, 0x00102000}
   , 0x1005,0.000000,attributes+0,1,NULL,autohelperpat365,0,4.800000},
  {pat366,4,8, "EB716",0,0,1,2,1,2,0x2,721,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00102000, 0x00900000, 0x20100000, 0x00180000, 0x00900000, 0x20100000, 0x00180000, 0x00102000}
   , 0x1005,0.000000,attributes+0,1,NULL,autohelperpat366,0,4.800000},
  {pat367,8,8, "EB717",0,-1,1,3,1,4,0x2,759,
    { 0x003fff00, 0xc0f0f0f0, 0xfcf00000, 0x3c3c0c00, 0xf0f0c000, 0xff3f0000, 0x0c3c3c3c, 0x00f0fc00},
    { 0x00142800, 0x00909000, 0xa0500000, 0x18180000, 0x90900000, 0x28140000, 0x00181800, 0x0050a000}
   , 0x1015,0.000000,attributes+0,1,NULL,autohelperpat367,0,1.810000},
  {pat368,4,8, "EB718",0,0,1,2,1,2,0x2,758,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00102000, 0x00900000, 0x20100000, 0x00180000, 0x00900000, 0x20100000, 0x00180000, 0x00102000}
   , 0x1005,0.000000,attributes+0,1,NULL,autohelperpat368,0,4.800000},
  {pat369,7,8, "EB719",0,-1,1,2,1,3,0x2,759,
    { 0x00ffff00, 0xf0f0f0f0, 0xfcfc0000, 0x3c3c3c00, 0xf0f0f000, 0xffff0000, 0x3c3c3c3c, 0x00fcfc00},
    { 0x00299400, 0x80606010, 0x58a00000, 0x24240800, 0x60608000, 0x94290000, 0x08242410, 0x00a05800}
   , 0x1004,0.000000,attributes+75,1,NULL,autohelperpat369,3,1.096000},
  {pat370,10,8, "EB801",0,0,2,4,2,4,0x2,796,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00120400, 0x00104020, 0x40100000, 0x04100000, 0x40100000, 0x04120000, 0x00100420, 0x00104000}
   , 0x1001,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat371,12,8, "EB802",-1,-1,1,4,2,5,0x2,796,
    { 0x053fbf00, 0x80f0f4f4, 0xf8f04000, 0x7c3c0800, 0xf4f08000, 0xbf3f0500, 0x083c7c7c, 0x40f0f800},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x1005,0.000000,attributes+0,1,NULL,autohelperpat371,0,2.179600},
  {pat372,10,8, "EB803",0,-2,2,2,2,4,0x2,722,
    { 0x007fffff, 0xd0f0f0f0, 0xfff40000, 0x3f3f1f0f, 0xf0f0d0c0, 0xff7f0000, 0x1f3f3f3f, 0x00f4ffff},
    { 0x00200000, 0x00200000, 0x01200000, 0x00200005, 0x00200040, 0x00200000, 0x00200000, 0x00200101}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat373,12,8, "EB804",0,-1,2,3,2,4,0x2,759,
    { 0x0037ffff, 0xc0f0d0f0, 0xfc700000, 0x1f3f0f00, 0xd0f0c000, 0xff370000, 0x0f3f1f3f, 0x0070fcfc},
    { 0x00204040, 0x40200000, 0x04200000, 0x00200500, 0x00204000, 0x40200000, 0x05200000, 0x00200404}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat374,8,8, "EB805",0,-2,2,2,2,4,0x2,722,
    { 0x003cffff, 0xc0f0f0c0, 0xfff00000, 0x3f3f0f0e, 0xf0f0c0c0, 0xff3c0000, 0x0f3f3f0f, 0x00f0fffe},
    { 0x00200040, 0x00200000, 0x01200000, 0x00200104, 0x00200040, 0x00200000, 0x01200000, 0x00200104}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat375,11,8, "EB806",0,-2,2,3,2,5,0x2,759,
    { 0x003fffff, 0xc0f0f0f0, 0xfff00000, 0x3f3f0f0e, 0xf0f0c0c0, 0xff3f0000, 0x0f3f3f3f, 0x00f0fffe},
    { 0x00200040, 0x00200000, 0x01200000, 0x00200104, 0x00200040, 0x00200000, 0x01200000, 0x00200104}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat376,11,8, "EB808",-1,0,1,4,2,4,0x2,796,
    { 0x053f3f00, 0x00f0f4f4, 0xf0f04000, 0x7c3c0000, 0xf4f00000, 0x3f3f0500, 0x003c7c7c, 0x40f0f000},
    { 0x00180400, 0x00106000, 0x40900000, 0x24100000, 0x60100000, 0x04180000, 0x00102400, 0x00904000}
   , 0x1005,0.000000,attributes+0,3,NULL,autohelperpat376,0,0.610000},
  {pat377,22,8, "EB909",0,-5,3,2,3,7,0x2,722,
    { 0x003cffff, 0xc0f0f0c0, 0xfff00000, 0x3f3f0f0f, 0xf0f0c0c0, 0xff3c0000, 0x0f3f3f0f, 0x00f0ffff},
    { 0x00200010, 0x00200000, 0x01200000, 0x00210004, 0x00200040, 0x00200000, 0x00210000, 0x00200110}
   , 0x8000,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat378,13,8, "EB910",0,-2,3,2,3,4,0x2,648,
    { 0x00ffffff, 0xf0f0f0f0, 0xfdfc0000, 0x3f3f3f07, 0xf0f0f040, 0xffff0000, 0x3f3f3f3f, 0x00fcfdff},
    { 0x00200110, 0x00200040, 0x00200000, 0x00210000, 0x00200000, 0x01200000, 0x00210004, 0x00200010}
   , 0x1001,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat379,21,8, "EB911",0,0,3,5,3,5,0x2,722,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00220100, 0x00200060, 0x00200000, 0x00200000, 0x00200000, 0x01220000, 0x00200024, 0x00200000}
   , 0x1001,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat380,12,8, "EB912",0,-1,3,2,3,3,0x2,759,
    { 0x003cffff, 0xc0f0f0c0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3c0000, 0x0f3f3f0f, 0x00f0fcfc},
    { 0x00280440, 0x00206000, 0x40a00000, 0x24200100, 0x60200000, 0x04280000, 0x01202400, 0x00a04004}
   , 0x1001,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat381,10,8, "EB913",0,-2,3,1,3,3,0x2,685,
    { 0x003cfcfc, 0xc0f0f000, 0xfcf00000, 0x3f3f0f02, 0xf0f0c000, 0xfc3c0000, 0x0f3f3f00, 0x00f0fcfe},
    { 0x00204000, 0x40200000, 0x04200000, 0x00200400, 0x00204000, 0x40200000, 0x04200000, 0x00200400}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat382,10,8, "EB913b",0,-2,3,1,3,3,0x2,685,
    { 0x003cfcfc, 0xc0f0f000, 0xfcf00000, 0x3f3f0f03, 0xf0f0c000, 0xfc3c0000, 0x0f3f3f00, 0x00f0fcff},
    { 0x00204000, 0x40200000, 0x04200000, 0x00200400, 0x00204000, 0x40200000, 0x04200000, 0x00200400}
   , 0x8004,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat383,20,8, "EB914",0,-1,3,4,3,5,0x2,648,
    { 0x0030ffff, 0xc0f0c0c0, 0xfc300000, 0x0f3f0f00, 0xc0f0c000, 0xff300000, 0x0f3f0f0f, 0x0030fcfc},
    { 0x00102500, 0x00904040, 0x60100000, 0x04180000, 0x40900000, 0x25100000, 0x00180404, 0x00106000}
   , 0x8000,0.000000,attributes+0,3,NULL,autohelperpat383,0,1.600000},
  {pat384,21,8, "EB915",0,-1,3,4,3,5,0x2,649,
    { 0x0030ffff, 0xc0f0c0c0, 0xfc300000, 0x0f3f0f00, 0xc0f0c000, 0xff300000, 0x0f3f0f0f, 0x0030fcfc},
    { 0x00106520, 0x40904040, 0x64100000, 0x041a0400, 0x40904000, 0x65100000, 0x041a0404, 0x00106420}
   , 0x8000,0.000000,attributes+0,3,NULL,autohelperpat384,0,1.600000},
  {pat385,21,8, "EB917",0,-2,3,4,3,6,0x2,759,
    { 0x003fffbf, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0e03, 0xf0f0c000, 0xff3f0000, 0x0e3f3f3f, 0x00f0fcfb},
    { 0x00206010, 0x40a00000, 0x24200000, 0x00290401, 0x00a04000, 0x60200000, 0x04290000, 0x00202411}
   , 0x1001,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat386,15,8, "EB918",0,-2,3,1,3,3,0x2,611,
    { 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff},
    { 0x00289440, 0x80606000, 0x58a00000, 0x24240900, 0x60608000, 0x94280000, 0x09242400, 0x00a05804}
   , 0x1001,0.000000,attributes+77,1,NULL,autohelperpat386,3,1.000000},
  {pat387,16,8, "EB919",0,-2,3,2,3,4,0x2,648,
    { 0x00fcfcff, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f03, 0x00ffffff},
    { 0x00281805, 0x0060a000, 0x90a00000, 0x29240000, 0xa0600000, 0x18280000, 0x00242901, 0x00a09040}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat388,26,8, "EB920",-1,-5,3,1,4,6,0x2,537,
    { 0xf0f0fcfc, 0xfcfcc000, 0xff3f3c00, 0x0fffff3f, 0xc0fcfcf0, 0xfcf0f000, 0xffff0f00, 0x3c3fffff},
    { 0x00106404, 0x40904000, 0x64100000, 0x05180400, 0x40904000, 0x64100000, 0x04180500, 0x00106440}
   , 0x1001,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat389,19,8, "EB921",0,-3,3,2,3,5,0xa,648,
    { 0x00b0fcff, 0xe0f0c000, 0xff3a0000, 0x0f3f2f2f, 0xc0f0e0e0, 0xfcb00000, 0x2f3f0f03, 0x003affff},
    { 0x00200805, 0x00208000, 0x80200000, 0x09200000, 0x80200000, 0x08200000, 0x00200901, 0x00208040}
   , 0x1000,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat390,16,8, "EB922",0,-2,3,2,3,4,0x2,722,
    { 0x0034ffff, 0xc0f0d0c0, 0xff700000, 0x1f3f0f0f, 0xd0f0c0c0, 0xff340000, 0x0f3f1f0f, 0x0070ffff},
    { 0x00209040, 0x80600000, 0x1a200000, 0x00240909, 0x00608080, 0x90200000, 0x09240000, 0x00201a05}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat391,9,8, "EB923",0,0,3,2,3,2,0x2,722,
    { 0x003c3f3f, 0x00f0f0c0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3c0000, 0x003f3f0f, 0x00f0f0f0},
    { 0x00240200, 0x00201080, 0x00600000, 0x10200000, 0x10200000, 0x02240000, 0x00201008, 0x00600000}
   , 0x1001,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat392,11,8, "EB924",-1,0,2,3,3,3,0x2,758,
    { 0x3f3f3f3f, 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff, 0xf0f0f0f0},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x1001,0.000000,attributes+0,1,NULL,autohelperpat392,0,0.010000},
  {pat393,23,8, "EB924a",0,0,3,5,3,5,0x2,833,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00281100, 0x00602040, 0x10a00000, 0x20240000, 0x20600000, 0x11280000, 0x00242004, 0x00a01000}
   , 0x1,0.000000,attributes+79,0,NULL,NULL,3,0.000000},
  {pat394,23,8, "EB924b",0,0,3,5,3,5,0x2,834,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00281100, 0x00602040, 0x10a00000, 0x20240000, 0x20600000, 0x11280000, 0x00242004, 0x00a01000}
   , 0x1,0.000000,attributes+81,0,NULL,NULL,3,0.000000},
  {pat395,23,8, "EB925",0,0,3,5,3,5,0x2,796,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00281100, 0x00602040, 0x10a00000, 0x20240000, 0x20600000, 0x11280000, 0x00242004, 0x00a01000}
   , 0x8000,0.000000,attributes+83,1,NULL,autohelperpat395,3,6.010000},
  {pat396,8,8, "EB1001",0,-1,2,2,2,3,0x2,648,
    { 0x00ffffff, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0x00fcfcfc},
    { 0x00211000, 0x00600010, 0x10200000, 0x00240000, 0x00600000, 0x10210000, 0x00240010, 0x00201000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat397,12,8, "EB1003",0,0,2,3,2,3,0x2,759,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00281400, 0x00606000, 0x50a00000, 0x24240000, 0x60600000, 0x14280000, 0x00242400, 0x00a05000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat398,14,8, "EB1004",0,-3,3,1,3,4,0x2,648,
    { 0x00fcfcfc, 0xf0f0f000, 0xfffc0000, 0x3f3f3f0f, 0xf0f0f0c0, 0xfcfc0000, 0x3f3f3f00, 0x00fcffff},
    { 0x00281400, 0x00606000, 0x50a00000, 0x24240000, 0x60600000, 0x14280000, 0x00242400, 0x00a05000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat399,16,8, "EB1005",-1,-3,3,1,4,4,0x2,647,
    { 0x80fcfcfc, 0xf8f0f000, 0xfffe0800, 0x3f3fbf2f, 0xf0f0f8e0, 0xfcfc8000, 0xbf3f3f00, 0x08feffff},
    { 0x00281400, 0x00606000, 0x50a00000, 0x24240000, 0x60600000, 0x14280000, 0x00242400, 0x00a05000}
   , 0x1005,0.000000,attributes+0,1,NULL,autohelperpat399,3,1.000000},
  {pat400,17,8, "EB1006",0,-3,3,1,3,4,0x2,612,
    { 0x00f0fcfc, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0x003fffff},
    { 0x00209440, 0x80604000, 0x5a200000, 0x04240908, 0x40608080, 0x94200000, 0x09240400, 0x00205a04}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat401,7,8, "EB1007",0,0,2,2,2,2,0x2,722,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00201000, 0x00600000, 0x10200000, 0x00240000, 0x00600000, 0x10200000, 0x00240000, 0x00201000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat402,8,8, "EB1008",0,-2,2,1,2,3,0x2,685,
    { 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff},
    { 0x00204000, 0x40200000, 0x04200000, 0x00200400, 0x00204000, 0x40200000, 0x04200000, 0x00200400}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat403,10,8, "EB1008b",0,-3,2,1,2,4,0x2,685,
    { 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff},
    { 0x00204000, 0x40200000, 0x04200000, 0x00200400, 0x00204000, 0x40200000, 0x04200000, 0x00200400}
   , 0x25,0.000000,attributes+85,0,NULL,NULL,3,0.000000},
  {pat404,10,8, "EB1008c",0,-3,2,1,2,4,0x2,685,
    { 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff},
    { 0x00204000, 0x40200000, 0x04200000, 0x00200400, 0x00204000, 0x40200000, 0x04200000, 0x00200400}
   , 0x25,0.000000,attributes+87,1,NULL,autohelperpat404,3,1.000000},
  {pat405,8,8, "EB1009",0,0,2,2,2,2,0x2,722,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00181000, 0x00502000, 0x10900000, 0x20140000, 0x20500000, 0x10180000, 0x00142000, 0x00901000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat406,21,8, "EB1011",0,-1,3,4,3,5,0x2,760,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x00285804, 0x4060a000, 0x94a00000, 0x29240400, 0xa0604000, 0x58280000, 0x04242900, 0x00a09440}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat407,8,8, "EB1012",0,0,2,3,2,3,0x2,722,
    { 0x003c3f3f, 0x00f0f0c0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3c0000, 0x003f3f0f, 0x00f0f0f0},
    { 0x00201000, 0x00600000, 0x10200000, 0x00240000, 0x00600000, 0x10200000, 0x00240000, 0x00201000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat408,8,8, "EB1013",0,0,2,3,2,3,0x2,722,
    { 0x003c3f3f, 0x00f0f0c0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3c0000, 0x003f3f0f, 0x00f0f0f0},
    { 0x00201000, 0x00600000, 0x10200000, 0x00240000, 0x00600000, 0x10200000, 0x00240000, 0x00201000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat409,7,8, "EB1014",0,0,2,2,2,2,0x2,722,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00221000, 0x00600020, 0x10200000, 0x00240000, 0x00600000, 0x10220000, 0x00240020, 0x00201000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat410,9,8, "EB1015",0,-1,2,2,2,3,0x2,759,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x001a0400, 0x00106020, 0x40900000, 0x24100000, 0x60100000, 0x041a0000, 0x00102420, 0x00904000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat411,14,8, "EB1016",0,-1,2,3,2,4,0x2,759,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x00186400, 0x40906000, 0x64900000, 0x24180400, 0x60904000, 0x64180000, 0x04182400, 0x00906400}
   , 0x1001,0.000000,attributes+0,1,NULL,autohelperpat411,0,1.006000},
  {pat412,13,8, "EB1017",0,0,3,3,3,3,0x2,797,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00200211, 0x00200080, 0x00200000, 0x00210000, 0x00200000, 0x02200000, 0x00210009, 0x00200010}
   , 0x1001,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat413,15,8, "EB1018",0,-2,2,3,2,5,0x2,759,
    { 0x003fefab, 0xc0b0f0f0, 0xeff00000, 0x3e3a0e0e, 0xf0b0c0c0, 0xef3f0000, 0x0e3a3e3f, 0x00f0efaa},
    { 0x00124400, 0x40104020, 0x46100000, 0x04100408, 0x40104080, 0x44120000, 0x04100420, 0x00104600}
   , 0x9005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat414,14,8, "EB1019",0,-1,2,4,2,5,0x2,685,
    { 0x00f6ffff, 0xf0f0d0e0, 0xfc7c0000, 0x1f3f3f00, 0xd0f0f000, 0xfff60000, 0x3f3f1f2f, 0x007cfcfc},
    { 0x00200401, 0x00204000, 0x40200000, 0x04200000, 0x40200000, 0x04200000, 0x00200401, 0x00204000}
   , 0x9005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat415,13,8, "EB1020",-1,-1,3,2,4,3,0xa,685,
    { 0xffffffff, 0xfcfcfcfc, 0xfcfcfc00, 0xffffff00, 0xfcfcfc00, 0xffffff00, 0xffffffff, 0xfcfcfcfc},
    { 0x00120800, 0x00108020, 0x80100000, 0x08100000, 0x80100000, 0x08120000, 0x00100820, 0x00108000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat416,10,8, "EB1021",0,-1,2,2,2,3,0x2,722,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x00285040, 0x40602000, 0x14a00000, 0x20240500, 0x20604000, 0x50280000, 0x05242000, 0x00a01404}
   , 0x9005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat417,20,8, "EB1022",0,-1,3,4,3,5,0x2,760,
    { 0x0035bfbf, 0x80f0d0d0, 0xf8700000, 0x1f3f0a00, 0xd0f08000, 0xbf350000, 0x0a3f1f1f, 0x0070f8f8},
    { 0x00201804, 0x00608000, 0x90200000, 0x09240000, 0x80600000, 0x18200000, 0x00240900, 0x00209040}
   , 0x1,0.000000,attributes+89,3,NULL,autohelperpat417,3,1.006000},
  {pat418,5,8, "EB1101",-1,-1,1,2,2,3,0x2,685,
    { 0x103fff00, 0xc0f4f0f0, 0xfcf01000, 0x3c7c0c00, 0xf0f4c000, 0xff3f1000, 0x0c7c3c3c, 0x10f0fc00},
    { 0x00204000, 0x40200000, 0x04200000, 0x00200400, 0x00204000, 0x40200000, 0x04200000, 0x00200400}
   , 0x1005,0.000000,attributes+0,1,NULL,autohelperpat418,3,0.010000},
  {pat419,19,8, "EB1201",0,-1,3,4,3,5,0x2,685,
    { 0x003cffff, 0xc0f0f0c0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3c0000, 0x0f3f3f0f, 0x00f0fcfc},
    { 0x00240100, 0x00201040, 0x00600000, 0x10200000, 0x10200000, 0x01240000, 0x00201004, 0x00600000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat420,12,8, "EB1202",-1,0,2,4,3,4,0x2,795,
    { 0x0f3f3f3f, 0x00f0fcfc, 0xf0f0c000, 0xff3f0000, 0xfcf00000, 0x3f3f0f00, 0x003fffff, 0xc0f0f0f0},
    { 0x00120100, 0x00100060, 0x00100000, 0x00100000, 0x00100000, 0x01120000, 0x00100024, 0x00100000}
   , 0xd085,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat421,16,8, "EB1203",0,-3,3,1,3,4,0x2,722,
    { 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff},
    { 0x00209040, 0x80600000, 0x18200000, 0x00240900, 0x00608000, 0x90200000, 0x09240000, 0x00201804}
   , 0xd085,0.000000,attributes+0,1,NULL,autohelperpat421,3,10.000000},
  {pat422,15,8, "EB1301",0,-2,3,1,3,3,0x2,649,
    { 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff},
    { 0x00289400, 0x80606000, 0x58a00000, 0x24240800, 0x60608000, 0x94280000, 0x08242400, 0x00a05800}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat423,8,8, "EB1302",0,0,2,2,2,2,0x2,759,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00261000, 0x00601020, 0x10600000, 0x10240000, 0x10600000, 0x10260000, 0x00241020, 0x00601000}
   , 0x1005,0.000000,attributes+0,1,NULL,autohelperpat423,3,0.010000},
  {pat424,12,8, "EB1303",0,-1,3,2,3,3,0x2,686,
    { 0x003cfcff, 0xc0f0f000, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xfc3c0000, 0x0f3f3f03, 0x00f0fcfc},
    { 0x00282401, 0x00a06000, 0x60a00000, 0x24280000, 0x60a00000, 0x24280000, 0x00282401, 0x00a06000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat425,17,8, "EB1304",0,-2,3,2,3,4,0x2,760,
    { 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0x00ffffff},
    { 0x00280610, 0x00206080, 0x41a00000, 0x24210004, 0x60200040, 0x06280000, 0x00212408, 0x00a04110}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat426,21,8, "EB1305",0,-2,3,3,3,5,0x2,649,
    { 0x00ffffff, 0xf0f0f0f0, 0xfffc0000, 0x3f3f3f0f, 0xf0f0f0c0, 0xffff0000, 0x3f3f3f3f, 0x00fcffff},
    { 0x00289004, 0x80602000, 0x18a00000, 0x21240800, 0x20608000, 0x90280000, 0x08242100, 0x00a01840}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat427,7,8, "EB1306",0,-1,2,2,2,3,0x2,685,
    { 0x003cffff, 0xc0f0f0c0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3c0000, 0x0f3f3f0f, 0x00f0fcfc},
    { 0x00240100, 0x00201040, 0x00600000, 0x10200000, 0x10200000, 0x01240000, 0x00201004, 0x00600000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat428,11,8, "EB1307",-1,-2,2,2,3,4,0x2,685,
    { 0xf0fefefe, 0xfcfcf0a0, 0xffff3c00, 0x3fffff3f, 0xf0fcfcf0, 0xfefef000, 0xffff3f2a, 0x3cffffff},
    { 0x00240000, 0x00201000, 0x00600000, 0x10200000, 0x10200000, 0x00240000, 0x00201000, 0x00600000}
   , 0xd005,0.000000,attributes+0,1,NULL,autohelperpat428,3,0.010000},
  {pat429,27,8, "EB1308",-2,0,3,4,5,4,0x2,723,
    { 0x0f3f3f3f, 0x00f0ffff, 0xf0f0c0c0, 0xff3f0000, 0xfff00000, 0x3f3f0f0f, 0x003fffff, 0xc0f0f0f0},
    { 0x00181800, 0x0050a000, 0x90900000, 0x28140000, 0xa0500000, 0x18180000, 0x00142800, 0x00909000}
   , 0x9005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat430,17,8, "EB1309",-1,-2,2,4,3,6,0x2,685,
    { 0x38ffffff, 0xf0fcf8f0, 0xfffcb000, 0xbfff3f0f, 0xf8fcf0c0, 0xffff3800, 0x3fffbf3f, 0xb0fcffff},
    { 0x00240000, 0x00201000, 0x00600000, 0x10200000, 0x10200000, 0x00240000, 0x00201000, 0x00600000}
   , 0x0,0.000000,attributes+91,0,NULL,NULL,3,0.000000},
  {pat431,17,8, "EB1310",0,-3,3,1,3,4,0x2,649,
    { 0x00f0fcf8, 0xf0f0c000, 0xff3f0000, 0x0e3f3f3f, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0e00, 0x003fffbf},
    { 0x00209400, 0x80604000, 0x58200000, 0x04240800, 0x40608000, 0x94200000, 0x08240400, 0x00205800}
   , 0xd005,0.000000,attributes+0,1,NULL,autohelperpat431,3,1.000000},
  {pat432,17,8, "EB1311",0,-3,3,1,3,4,0x2,612,
    { 0x00f0fcf8, 0xf0f0c000, 0xff3f0000, 0x0e3f3f3f, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0e00, 0x003fffbf},
    { 0x00209440, 0x80604000, 0x5a200000, 0x04240908, 0x40608080, 0x94200000, 0x09240400, 0x00205a04}
   , 0xd005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat433,8,8, "EB1401",0,-1,2,2,2,3,0xa,686,
    { 0x00fcfcfe, 0xf0f0f000, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xfcfc0000, 0x3f3f3f02, 0x00fcfcfc},
    { 0x00242400, 0x00a05000, 0x60600000, 0x14280000, 0x50a00000, 0x24240000, 0x00281400, 0x00606000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat434,9,8, "EB1402",0,-2,2,2,2,4,0x2,686,
    { 0x00f0fcfe, 0xf0f0c000, 0xff3c0000, 0x0f3f3f0d, 0xc0f0f0c0, 0xfcf00000, 0x3f3f0f02, 0x003cfffd},
    { 0x00202400, 0x00a04000, 0x60200000, 0x04280000, 0x40a00000, 0x24200000, 0x00280400, 0x00206000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat435,9,8, "EB1403",0,-2,2,2,2,4,0x2,686,
    { 0x00b0fcfe, 0xe0f0c000, 0xff380000, 0x0f3f2f0c, 0xc0f0e0c0, 0xfcb00000, 0x2f3f0f02, 0x0038fffc},
    { 0x00202400, 0x00a04000, 0x60200000, 0x04280000, 0x40a00000, 0x24200000, 0x00280400, 0x00206000}
   , 0x1004,0.000000,attributes+0,1,NULL,autohelperpat435,3,0.016000},
  {pat436,9,8, "EB1404a",0,-2,2,2,2,4,0x2,723,
    { 0x00b0fcfe, 0xe0f0c000, 0xff380000, 0x0f3f2f0c, 0xc0f0e0c0, 0xfcb00000, 0x2f3f0f02, 0x0038fffc},
    { 0x00202490, 0x00a04000, 0x60200000, 0x04290200, 0x40a00000, 0x24200000, 0x02290400, 0x00206018}
   , 0x1004,0.000000,attributes+93,1,NULL,autohelperpat436,3,0.610000},
  {pat437,9,8, "EB1404c",0,-2,2,2,2,4,0x2,648,
    { 0x00b0fcfe, 0xe0f0c000, 0xff380000, 0x0f3f2f0c, 0xc0f0e0c0, 0xfcb00000, 0x2f3f0f02, 0x0038fffc},
    { 0x00202490, 0x00a04000, 0x60200000, 0x04290200, 0x40a00000, 0x24200000, 0x02290400, 0x00206018}
   , 0x1004,0.000000,attributes+0,1,NULL,autohelperpat437,3,1.024000},
  {pat438,10,8, "EB1405",0,-3,2,1,2,4,0x2,649,
    { 0x00f0f0f8, 0xf0f00000, 0x3f3f0000, 0x023f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0200, 0x003f3fbf},
    { 0x00209000, 0x80600000, 0x18200000, 0x00240800, 0x00608000, 0x90200000, 0x08240000, 0x00201800}
   , 0x1005,0.000000,attributes+95,1,NULL,autohelperpat438,3,2.170000},
  {pat439,15,8, "EB1501",-2,-2,2,2,4,4,0x2,683,
    { 0xffffffff, 0xfcfefefc, 0xffffffa0, 0xffffffff, 0xfefefcfc, 0xffffff28, 0xffffffff, 0xffffffff},
    { 0x00240000, 0x00201000, 0x00600000, 0x10200000, 0x10200000, 0x00240000, 0x00201000, 0x00600000}
   , 0xe005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat440,28,8, "EB1502",-2,-2,3,4,5,6,0x2,720,
    { 0xafffffff, 0xfafafefe, 0xfefeeaa8, 0xffbfbfaa, 0xfefafaa8, 0xffffafaa, 0xbfbfffff, 0xeafefefe},
    { 0x00181800, 0x0050a000, 0x90900000, 0x28140000, 0xa0500000, 0x18180000, 0x00142800, 0x00909000}
   , 0xd005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat441,19,8, "EB1503",-2,-1,3,2,5,3,0x2,683,
    { 0x7fffffff, 0xf7fffffc, 0xfcfcf4fc, 0xffff7f00, 0xfffff700, 0xffff7ffc, 0x7fffffff, 0xf4fcfcfc},
    { 0x00181800, 0x0050a000, 0x90900000, 0x28140000, 0xa0500000, 0x18180000, 0x00142800, 0x00909000}
   , 0x9005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat442,16,8, "EB1601",-1,-1,2,4,3,5,0x2,685,
    { 0xffffffff, 0xfcfcfcfc, 0xfcfcfc00, 0xffffff00, 0xfcfcfc00, 0xffffff00, 0xffffffff, 0xfcfcfcfc},
    { 0x00210000, 0x00200010, 0x00200000, 0x00200000, 0x00200000, 0x00210000, 0x00200010, 0x00200000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat443,16,8, "EB1603",-1,-1,3,3,4,4,0x2,758,
    { 0x3fffffff, 0xf0fcfcfc, 0xfcfcf000, 0xffff3f00, 0xfcfcf000, 0xffff3f00, 0x3fffffff, 0xf0fcfcfc},
    { 0x00100200, 0x00100080, 0x00100000, 0x00100000, 0x00100000, 0x02100000, 0x00100008, 0x00100000}
   , 0x2005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat444,16,8, "EB1604",-2,-1,2,4,4,5,0x2,759,
    { 0x3fbfbfff, 0xa0fcfcfc, 0xf8f8f000, 0xffff2b00, 0xfcfca000, 0xbfbf3f00, 0x2bffffff, 0xf0f8f8fc},
    { 0x00120000, 0x00100020, 0x00100000, 0x00100000, 0x00100000, 0x00120000, 0x00100020, 0x00100000}
   , 0x1005,0.000000,attributes+0,1,NULL,autohelperpat444,0,0.010000},
  {pat445,16,8, "EB1605",-2,-1,2,4,4,5,0x2,759,
    { 0x3fbfbfff, 0xa0fcfcfc, 0xf8f8f000, 0xffff2b00, 0xfcfca000, 0xbfbf3f00, 0x2bffffff, 0xf0f8f8fc},
    { 0x00120000, 0x00100020, 0x00100000, 0x00100000, 0x00100000, 0x00120000, 0x00100020, 0x00100000}
   , 0x1005,0.000000,attributes+97,1,NULL,autohelperpat445,0,0.610000},
  {pat446,13,8, "EB1606",-2,0,2,4,4,4,0x2,722,
    { 0x3f3f3f3f, 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff, 0xf0f0f0f0},
    { 0x00120100, 0x00100060, 0x00100000, 0x00100000, 0x00100000, 0x01120000, 0x00100024, 0x00100000}
   , 0x1000,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat447,13,8, "EB1606b",-2,0,2,4,4,4,0x2,722,
    { 0x3f3f3f3f, 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff, 0xf0f0f0f0},
    { 0x00120100, 0x00100060, 0x00100000, 0x00100000, 0x00100000, 0x01120000, 0x00100024, 0x00100000}
   , 0x0,0.000000,attributes+99,1,NULL,autohelperpat447,0,1.000000},
  {pat448,13,8, "EB1607",0,0,3,3,3,3,0x2,760,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00200210, 0x00200080, 0x00200000, 0x00210000, 0x00200000, 0x02200000, 0x00210008, 0x00200010}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat449,14,8, "EB1608",0,0,2,4,2,4,0x2,796,
    { 0x003f2f2f, 0x00b0f0f0, 0xe0f00000, 0x3f3a0000, 0xf0b00000, 0x2f3f0000, 0x003a3f3f, 0x00f0e0e0},
    { 0x00100400, 0x00104000, 0x40100000, 0x04100000, 0x40100000, 0x04100000, 0x00100400, 0x00104000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat450,20,4, "EB1609",-2,0,2,4,4,4,0x2,759,
    { 0x3f3f3f3f, 0x00fffffd, 0xf0f0f0f0, 0xffff0000, 0xffff0000, 0x3f3f3f3d, 0x00ffffff, 0xf0f0f0f0},
    { 0x00120000, 0x00100020, 0x00100000, 0x00100000, 0x00100000, 0x00120000, 0x00100020, 0x00100000}
   , 0xc105,0.000000,attributes+0,2,NULL,autohelperpat450,0,0.000000},
  {pat451,21,8, "EB1610",-2,0,2,4,4,4,0x2,721,
    { 0x3f3f3f3f, 0x00fffffd, 0xf0f0f0f0, 0xffff0000, 0xffff0000, 0x3f3f3f3d, 0x00ffffff, 0xf0f0f0f0},
    { 0x00120900, 0x00108060, 0x80100000, 0x08100000, 0x80100000, 0x09120000, 0x00100824, 0x00108000}
   , 0xc100,0.000000,attributes+101,0,NULL,NULL,0,0.000000},
  {pat452,22,8, "EB1611",-2,0,2,4,4,4,0x2,757,
    { 0x3f3f3f3f, 0x00fffffd, 0xf0f0f0f0, 0xffff0000, 0xffff0000, 0x3f3f3f3d, 0x00ffffff, 0xf0f0f0f0},
    { 0x00160900, 0x00109060, 0x80500000, 0x18100000, 0x90100000, 0x09160000, 0x00101824, 0x00508000}
   , 0xc100,0.000000,attributes+103,0,NULL,NULL,0,0.000000},
  {pat453,13,8, "EB1701",0,-2,3,1,3,3,0x2,647,
    { 0x00f0fcfc, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0x003fffff},
    { 0x00206000, 0x40a00000, 0x24200000, 0x00280400, 0x00a04000, 0x60200000, 0x04280000, 0x00202400}
   , 0x8005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat454,14,8, "EB1702",0,-3,3,0,3,3,0x2,610,
    { 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3f},
    { 0x00208000, 0x80200000, 0x09200000, 0x00200804, 0x00208040, 0x80200000, 0x08200000, 0x00200900}
   , 0x8005,0.000000,attributes+105,0,NULL,NULL,3,0.000000},
  {pat455,22,8, "EB1702b",0,-5,3,0,3,5,0x2,610,
    { 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3f},
    { 0x00208000, 0x80200000, 0x09200000, 0x00200804, 0x00208040, 0x80200000, 0x08200000, 0x00200900}
   , 0x4005,0.000000,attributes+107,0,NULL,NULL,3,0.000000},
  {pat456,9,8, "EB1703",0,0,2,3,2,3,0x2,758,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00100100, 0x00100040, 0x00100000, 0x00100000, 0x00100000, 0x01100000, 0x00100004, 0x00100000}
   , 0x9005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat457,5,8, "EB1704",-1,0,1,3,2,3,0x2,720,
    { 0x0f3f3f00, 0x00f0fcfc, 0xf0f0c000, 0xfc3c0000, 0xfcf00000, 0x3f3f0f00, 0x003cfcfc, 0xc0f0f000},
    { 0x00240000, 0x00201000, 0x00600000, 0x10200000, 0x10200000, 0x00240000, 0x00201000, 0x00600000}
   , 0x9025,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat458,10,8, "EB1705",-1,0,2,3,3,3,0x2,758,
    { 0x023f3f3f, 0x00f0f0f8, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0200, 0x003f3fbf, 0x00f0f0f0},
    { 0x00100100, 0x00100040, 0x00100000, 0x00100000, 0x00100000, 0x01100000, 0x00100004, 0x00100000}
   , 0x9005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat459,11,8, "EB1706",0,-2,3,1,3,3,0x2,648,
    { 0x0030fcfc, 0xc0f0c000, 0xff300000, 0x0f3f0f0f, 0xc0f0c0c0, 0xfc300000, 0x0f3f0f00, 0x0030ffff},
    { 0x00200818, 0x00208000, 0x81200000, 0x0a210004, 0x80200040, 0x08200000, 0x00210a00, 0x00208190}
   , 0x9005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat460,11,8, "EB1707",-2,-1,2,2,4,3,0x2,683,
    { 0xffffffff, 0xfffffcfc, 0xfcfcfc3c, 0xffffff00, 0xfcffff00, 0xfffffff0, 0xffffffff, 0xfcfcfcfc},
    { 0x001a0000, 0x00102020, 0x00900000, 0x20100000, 0x20100000, 0x001a0000, 0x00102020, 0x00900000}
   , 0x9005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat461,8,8, "EB1708",0,-2,2,1,2,3,0x2,611,
    { 0x00f0fcfc, 0xf0f0c000, 0xff3c0000, 0x0f3f3f0f, 0xc0f0f0c0, 0xfcf00000, 0x3f3f0f00, 0x003cffff},
    { 0x00101868, 0x00508000, 0x90100000, 0x0a160100, 0x80500000, 0x18100000, 0x01160a00, 0x001090a4}
   , 0x1005,0.000000,attributes+0,1,NULL,autohelperpat461,0,0.610000},
  {pat462,13,8, "EB1709",0,0,2,4,2,4,0x2,721,
    { 0x003f1f3f, 0x0070f0f0, 0xd0f00000, 0x3f370000, 0xf0700000, 0x1f3f0000, 0x00373f3f, 0x00f0d0f0},
    { 0x00200401, 0x00204000, 0x40200000, 0x04200000, 0x40200000, 0x04200000, 0x00200401, 0x00204000}
   , 0x8005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat463,18,8, "EB1710",-1,-2,3,3,4,5,0x2,722,
    { 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xffffffff},
    { 0x00201000, 0x00600000, 0x10200000, 0x00240000, 0x00600000, 0x10200000, 0x00240000, 0x00201000}
   , 0x9005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat464,12,8, "EB1711",0,-1,3,2,3,3,0x2,685,
    { 0x00ffffff, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0x00fcfcfc},
    { 0x00120800, 0x00108020, 0x80100000, 0x08100000, 0x80100000, 0x08120000, 0x00100820, 0x00108000}
   , 0xd005,0.000000,attributes+109,0,NULL,NULL,0,0.000000},
  {pat465,10,8, "EB1801",-1,0,1,4,2,4,0x2,757,
    { 0x3f3f3f00, 0x00fcfcfc, 0xf0f0f000, 0xfcfc0000, 0xfcfc0000, 0x3f3f3f00, 0x00fcfcfc, 0xf0f0f000},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x1001,0.000000,attributes+0,1,NULL,autohelperpat465,0,0.010000},
  {pat466,10,8, "EB1802",0,-2,2,2,2,4,0x2,685,
    { 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0x00ffffff},
    { 0x00200100, 0x00200040, 0x01200000, 0x00200004, 0x00200040, 0x01200000, 0x00200004, 0x00200100}
   , 0x1105,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat467,21,8, "EB1803",0,-3,4,1,4,4,0x2,648,
    { 0x00f4fcfc, 0xf0f0d000, 0xff7f0000, 0x1f3f3f3f, 0xd0f0f0f0, 0xfcf40000, 0x3f3f1f00, 0x007fffff},
    { 0x00200004, 0x00200000, 0x00200000, 0x01200000, 0x00200000, 0x00200000, 0x00200100, 0x00200040}
   , 0x1105,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat468,18,8, "EB1804",-1,0,3,4,4,4,0x2,758,
    { 0x033f3f3f, 0x00f0f0fc, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0300, 0x003f3fff, 0x00f0f0f0},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x1101,0.000000,attributes+0,1,NULL,autohelperpat468,0,0.010000},
  {pat469,18,8, "EB1805",-1,0,3,4,4,4,0x2,758,
    { 0x033f3f3f, 0x00f0f0fc, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0300, 0x003f3fff, 0x00f0f0f0},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x1101,0.000000,attributes+0,1,NULL,autohelperpat469,0,0.010000},
  {pat470,22,8, "EB1806",0,-2,4,3,4,5,0x2,686,
    { 0x00fcffff, 0xf0f0f0c0, 0xfffc0000, 0x3f3f3f0f, 0xf0f0f0c0, 0xfffc0000, 0x3f3f3f0f, 0x00fcffff},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200001, 0x00200000, 0x00200000, 0x00200000, 0x00200001}
   , 0x1105,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat471,9,8, "EB1807",0,-1,3,1,3,2,0x2,685,
    { 0x003cfcfc, 0xc0f0f000, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xfc3c0000, 0x0f3f3f00, 0x00f0fcfc},
    { 0x00244000, 0x40201000, 0x04600000, 0x10200400, 0x10204000, 0x40240000, 0x04201000, 0x00600400}
   , 0x1105,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat472,13,8, "EB1808",-1,0,2,4,3,4,0x2,758,
    { 0x033f3f3f, 0x00f0f0fc, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0300, 0x003f3fff, 0x00f0f0f0},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x1105,0.000000,attributes+111,1,NULL,autohelperpat472,0,0.010000},
  {pat473,13,8, "EB1808a",-1,0,2,4,3,4,0x2,759,
    { 0x033f3f3f, 0x00f0f0fc, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0300, 0x003f3fff, 0x00f0f0f0},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x1105,0.000000,attributes+0,1,NULL,autohelperpat473,0,0.010000},
  {pat474,21,8, "EB1809",0,-2,4,2,4,4,0x2,722,
    { 0x00fffeff, 0xf0f0f0b0, 0xfeff0000, 0x3f3f3f3a, 0xf0f0f0b0, 0xfeff0000, 0x3f3f3f3b, 0x00fffefe},
    { 0x00201000, 0x00600000, 0x10200000, 0x00240000, 0x00600000, 0x10200000, 0x00240000, 0x00201000}
   , 0x1005,0.000000,attributes+0,1,NULL,autohelperpat474,3,1.006000},
  {pat475,10,4, "EB1810",0,-1,3,1,3,2,0x2,686,
    { 0x0030fcfc, 0xc0f0c000, 0xfc300000, 0x0f3f0f00, 0xc0f0c000, 0xfc300000, 0x0f3f0f00, 0x0030fcfc},
    { 0x00206400, 0x40a04000, 0x64200000, 0x04280400, 0x40a04000, 0x64200000, 0x04280400, 0x00206400}
   , 0x1085,0.000000,attributes+0,1,NULL,autohelperpat475,3,5.000000},
  {pat476,10,8, "EB1901",0,-1,3,2,3,3,0x2,723,
    { 0x0030ffff, 0xc0f0c0c0, 0xfc300000, 0x0f3f0f00, 0xc0f0c000, 0xff300000, 0x0f3f0f0f, 0x0030fcfc},
    { 0x00209190, 0x80600040, 0x18200000, 0x00250a00, 0x00608000, 0x91200000, 0x0a250004, 0x00201818}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat477,9,8, "EB1902",0,-1,2,2,2,3,0x2,721,
    { 0x00ffffff, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0x00fcfcfc},
    { 0x0010a000, 0x80900000, 0x28100000, 0x00180800, 0x00908000, 0xa0100000, 0x08180000, 0x00102800}
   , 0x1005,0.000000,attributes+0,1,NULL,autohelperpat477,0,1.000000},
  {pat478,10,8, "EB1903",-1,-2,2,1,3,3,0x2,647,
    { 0xfcfcfcfc, 0xfcfcfc00, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xfcfcfc00, 0xffffff00, 0xffffffff},
    { 0x00182000, 0x00902000, 0x20900000, 0x20180000, 0x20900000, 0x20180000, 0x00182000, 0x00902000}
   , 0x9005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat479,15,8, "EB1904",-1,-3,2,1,3,4,0x2,647,
    { 0xfcfcfcfc, 0xfcfcfc00, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xfcfcfc00, 0xffffff00, 0xffffffff},
    { 0x00142800, 0x00909000, 0xa0500000, 0x18180000, 0x90900000, 0x28140000, 0x00181800, 0x0050a000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat480,13,8, "EB1905",0,-3,2,2,2,5,0x2,648,
    { 0x00f0fcff, 0xf0f0c000, 0xff3e0000, 0x0f3f3f2f, 0xc0f0f0e0, 0xfcf00000, 0x3f3f0f03, 0x003effff},
    { 0x00101822, 0x00508000, 0x90100000, 0x08160000, 0x80500000, 0x18100000, 0x00160802, 0x00109020}
   , 0x1005,0.000000,attributes+0,3,NULL,autohelperpat480,0,3.000000},
  {pat481,13,8, "EB1906",0,0,3,3,3,3,0x2,722,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00100109, 0x00100040, 0x00100000, 0x02100000, 0x00100000, 0x01100000, 0x00100205, 0x00100080}
   , 0x1005,0.000000,attributes+0,1,NULL,autohelperpat481,0,1.000000},
  {pat482,13,8, "EB2001",0,0,3,3,3,3,0x2,722,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00200211, 0x00200080, 0x00200000, 0x00210000, 0x00200000, 0x02200000, 0x00210009, 0x00200010}
   , 0x9005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat483,36,8, "EB2002",-3,0,3,5,6,5,0x2,719,
    { 0x3f3f3f3f, 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0xffff0000, 0x3f3f3f3f, 0x00ffffff, 0xf0f0f0f0},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x0,0.000000,attributes+113,0,NULL,NULL,0,0.000000},
  {pat484,38,8, "EB2003",-3,-1,3,5,6,6,0x2,682,
    { 0x3f3f3f3f, 0x03ffffff, 0xf0f0f0fc, 0xffff0000, 0xffff0300, 0x3f3f3fff, 0x00ffffff, 0xf0f0f0f0},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x0,0.000000,attributes+115,0,NULL,NULL,0,0.000000},
  {pat485,13,4, "CB1",-2,-1,2,6,4,7,0x0,832,
    { 0xffffff00, 0xfcfcfcfc, 0xfcfcfc00, 0xfcfcfc00, 0xfcfcfc00, 0xffffff00, 0xfcfcfcfc, 0xfcfcfc00},
    { 0x00110000, 0x00100010, 0x00100000, 0x00100000, 0x00100000, 0x00110000, 0x00100010, 0x00100000}
   , 0x2001,0.000000,attributes+0,0,jump_out_helper
,NULL,0,0.000000},
  {pat486,10,8, "CB2",-2,-4,2,1,4,5,0x0,610,
    { 0xf4fcf400, 0xfcfc7400, 0x7fff7f00, 0x74fcfcfc, 0x74fcfcfc, 0xf4fcf400, 0xfcfc7400, 0x7fff7f00},
    { 0x00140000, 0x00101000, 0x00500000, 0x10100000, 0x10100000, 0x00140000, 0x00101000, 0x00500000}
   , 0x2001,0.000000,attributes+0,0,jump_out_helper
,NULL,0,0.000000},
  {pat487,16,8, "CB3",0,-2,5,2,5,4,0x0,687,
    { 0x00ffffff, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0x00fcfcfc},
    { 0x00140000, 0x00101000, 0x00500000, 0x10100000, 0x10100000, 0x00140000, 0x00101000, 0x00500000}
   , 0xa001,0.000000,attributes+0,0,jump_out_helper
,NULL,0,0.000000},
  {pat488,8,8, "CB4",-4,-2,0,2,4,4,0x0,682,
    { 0xfcfc0000, 0x3f3f3f00, 0x00fcfcfc, 0xf0f0f000, 0x3f3f3f00, 0x00fcfcfc, 0xf0f0f000, 0xfcfc0000},
    { 0x00140000, 0x00101000, 0x00500000, 0x10100000, 0x10100000, 0x00140000, 0x00101000, 0x00500000}
   , 0x1001,0.000000,attributes+0,0,jump_out_helper
,NULL,0,0.000000},
  {pat489,8,8, "CB5",-1,-4,3,0,4,4,0x0,611,
    { 0x00f0f0c0, 0xf0f00000, 0x3f3f0000, 0x003c3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3c0000, 0x003f3f0f},
    { 0x00101000, 0x00500000, 0x10100000, 0x00140000, 0x00500000, 0x10100000, 0x00140000, 0x00101000}
   , 0x1001,0.000000,attributes+0,0,jump_out_helper
,NULL,0,0.000000},
  {pat490,11,8, "CB6",-1,-4,3,1,4,5,0x0,611,
    { 0x00f8f8f8, 0xf0f0a000, 0xbfbf0000, 0x2a3f3f3f, 0xa0f0f0f0, 0xf8f80000, 0x3f3f2a00, 0x00bfbfbf},
    { 0x00100010, 0x00100000, 0x00100000, 0x00110000, 0x00100000, 0x00100000, 0x00110000, 0x00100010}
   , 0x1001,0.000000,attributes+0,0,jump_out_helper
,NULL,0,0.000000},
  {pat491,13,8, "CB7",-1,-5,3,0,4,5,0x0,574,
    { 0x80f0f0c0, 0xf8f00000, 0x3f3f0b00, 0x003cbfff, 0x00f0f8fc, 0xf0f08000, 0xbf3c0000, 0x0b3f3f0f},
    { 0x00101000, 0x00500000, 0x10100000, 0x00140000, 0x00500000, 0x10100000, 0x00140000, 0x00101000}
   , 0xa001,0.000000,attributes+0,0,jump_out_helper
,NULL,0,0.000000},
  {pat492,15,8, "CB8",-1,-5,3,1,4,6,0x0,574,
    { 0x00f8f8f8, 0xf0f0a000, 0xbfbf0300, 0x2a3f3fff, 0xa0f0f0fc, 0xf8f80000, 0x3f3f2a00, 0x03bfbfbf},
    { 0x00100010, 0x00100000, 0x00100000, 0x00110000, 0x00100000, 0x00100000, 0x00110000, 0x00100010}
   , 0xa001,0.000000,attributes+0,0,jump_out_helper
,NULL,0,0.000000},
  {pat493,11,8, "CB9",0,-2,4,3,4,5,0x0,686,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0xa001,0.000000,attributes+0,0,jump_out_helper
,NULL,0,0.000000},
  {pat494,14,8, "CB10",0,0,5,4,5,4,0x0,761,
    { 0x003b3f3f, 0x00f0e0f0, 0xf0b00000, 0x2f3f0000, 0xe0f00000, 0x3f3b0000, 0x003f2f3f, 0x00b0f0f0},
    { 0x00110000, 0x00100010, 0x00100000, 0x00100000, 0x00100000, 0x00110000, 0x00100010, 0x00100000}
   , 0xa001,0.000000,attributes+0,0,jump_out_helper
,NULL,0,0.000000},
  {pat495,6,8, "CB12",-1,-2,1,1,2,3,0x0,647,
    { 0xfcfcfc00, 0xfcfcfc00, 0xffffff00, 0xfcfcfcfc, 0xfcfcfcfc, 0xfcfcfc00, 0xfcfcfc00, 0xffffff00},
    { 0x00241000, 0x00601000, 0x12600000, 0x10240008, 0x10600080, 0x10240000, 0x00241000, 0x00601200}
   , 0xd205,0.000000,attributes+117,1,NULL,autohelperpat495,3,1.000000},
  {pat496,10,8, "CB13",-1,-3,3,0,4,3,0x0,611,
    { 0x00f0f0e0, 0xf0f00000, 0x3f3f0000, 0x003e3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3e0000, 0x003f3f2f},
    { 0x00101000, 0x00500000, 0x10100000, 0x00140000, 0x00500000, 0x10100000, 0x00140000, 0x00101000}
   , 0x1001,0.000000,attributes+0,0,jump_out_helper
,NULL,0,0.000000},
  {pat497,13,8, "CB14",-1,-3,3,0,4,3,0x0,611,
    { 0x00f0f0f0, 0xf0f00000, 0x3f3f0200, 0x003f3fbf, 0x00f0f0f8, 0xf0f00000, 0x3f3f0000, 0x023f3f3f},
    { 0x00100010, 0x00100000, 0x00100000, 0x00110002, 0x00100000, 0x00100000, 0x00110000, 0x00100012}
   , 0xa005,0.000000,attributes+119,1,NULL,autohelperpat497,0,1.600000},
  {pat498,14,8, "CB14a",-1,-3,3,0,4,3,0x0,649,
    { 0x00f0f0f0, 0xf0f00000, 0x3f3f0200, 0x003f3fbf, 0x00f0f0f8, 0xf0f00000, 0x3f3f0000, 0x023f3f3f},
    { 0x00108010, 0x80100000, 0x09100000, 0x00110806, 0x00108040, 0x80100000, 0x08110000, 0x00100912}
   , 0x9005,0.000000,attributes+121,1,NULL,autohelperpat498,0,1.000000},
  {pat499,14,8, "CB14b",-1,-3,3,0,4,3,0x0,647,
    { 0x00f0f0f0, 0xf0f00000, 0x3f3f0200, 0x003f3fbf, 0x00f0f0f8, 0xf0f00000, 0x3f3f0000, 0x023f3f3f},
    { 0x00108010, 0x80100000, 0x09100000, 0x00110806, 0x00108040, 0x80100000, 0x08110000, 0x00100912}
   , 0x9005,0.000000,attributes+123,1,NULL,autohelperpat499,0,1.000000},
  {pat500,13,8, "CB15",0,-2,3,1,3,3,0x0,685,
    { 0x007c7cfc, 0x50f0f000, 0xf5f70000, 0x3f3f1735, 0xf0f05070, 0x7c7c0000, 0x173f3f00, 0x00f7f5fd},
    { 0x00100090, 0x00100000, 0x00100000, 0x00110200, 0x00100000, 0x00100000, 0x02110000, 0x00100018}
   , 0x9001,0.000000,attributes+125,1,NULL,autohelperpat500,0,0.010000},
  {pat501,14,8, "CB101",0,0,3,6,3,6,0x0,833,
    { 0x003f0f0f, 0x0030f0f0, 0xc0f00000, 0x3f300000, 0xf0300000, 0x0f3f0000, 0x00303f3f, 0x00f0c0c0},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x2001,0.000000,attributes+127,0,jump_out_far_helper
,NULL,0,0.000000},
  {pat502,11,8, "CB103",0,0,3,5,3,5,0x0,796,
    { 0x003f0f0f, 0x0030f0f0, 0xc0f00000, 0x3f300000, 0xf0300000, 0x0f3f0000, 0x00303f3f, 0x00f0c0c0},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x2001,0.000000,attributes+129,0,jump_out_far_helper
,NULL,0,0.000000},
  {pat503,10,4, "CB104",0,-3,5,3,5,6,0x0,687,
    { 0x0030fcfc, 0xc0f0c000, 0xfc300000, 0x0f3f0f00, 0xc0f0c000, 0xfc300000, 0x0f3f0f00, 0x0030fcfc},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x2001,0.000000,attributes+131,0,jump_out_far_helper
,NULL,0,0.000000},
  {pat504,8,8, "CB105",0,0,3,4,3,4,0x0,759,
    { 0x003f0f0f, 0x0030f0f0, 0xc0f00000, 0x3f300000, 0xf0300000, 0x0f3f0000, 0x00303f3f, 0x00f0c0c0},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x2001,0.000000,attributes+0,0,jump_out_far_helper
,NULL,0,0.000000},
  {pat505,9,8, "CB105b",0,-1,3,4,3,5,0x0,759,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x2001,0.000000,attributes+0,1,NULL,autohelperpat505,0,0.016000},
  {pat506,7,4, "CB106",0,-3,4,3,4,6,0x0,686,
    { 0x0030fcfc, 0xc0f0c000, 0xfc300000, 0x0f3f0f00, 0xc0f0c000, 0xfc300000, 0x0f3f0f00, 0x0030fcfc},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x2001,0.000000,attributes+133,0,jump_out_far_helper
,NULL,0,0.000000},
  {pat507,5,8, "CB207",-1,0,1,2,2,2,0x0,721,
    { 0x013f3f00, 0x00f0f0f4, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0100, 0x003c3c7c, 0x00f0f000},
    { 0x00100900, 0x00108040, 0x80100000, 0x08100000, 0x80100000, 0x09100000, 0x00100804, 0x00108000}
   , 0x5025,0.000000,attributes+135,1,NULL,autohelperpat507,0,0.970000},
  {pat508,5,8, "CB209",0,-2,2,0,2,2,0x0,648,
    { 0x0030f0f0, 0xc0f00000, 0x3f300000, 0x003f0f0f, 0x00f0c0c0, 0xf0300000, 0x0f3f0000, 0x00303f3f},
    { 0x00100090, 0x00100000, 0x01100000, 0x00110204, 0x00100040, 0x00100000, 0x02110000, 0x00100118}
   , 0x1025,0.000000,attributes+0,1,NULL,autohelperpat508,0,0.016000},
  {pat509,6,8, "CB210",-1,0,1,3,2,3,0x0,721,
    { 0x033f0f00, 0x0030f0fc, 0xc0f00000, 0x3c300000, 0xf0300000, 0x0f3f0300, 0x00303cfc, 0x00f0c000},
    { 0x00100900, 0x00108040, 0x80100000, 0x08100000, 0x80100000, 0x09100000, 0x00100804, 0x00108000}
   , 0x5025,0.000000,attributes+0,1,NULL,autohelperpat509,0,0.010000},
  {pat510,5,8, "CB217",0,-2,2,0,2,2,0x0,648,
    { 0x00f0f0f0, 0xf0f00000, 0x3f3c0000, 0x003f3f0c, 0x00f0f0c0, 0xf0f00000, 0x3f3f0000, 0x003c3f3c},
    { 0x00102060, 0x00900000, 0x20100000, 0x001a0100, 0x00900000, 0x20100000, 0x011a0000, 0x00102024}
   , 0x9105,0.000000,attributes+0,1,NULL,autohelperpat510,0,0.010000},
  {pat511,5,8, "CB217a",0,-2,2,0,2,2,0x0,648,
    { 0x00f0f0f0, 0xf0f00000, 0x3f3c0000, 0x003f3f0c, 0x00f0f0c0, 0xf0f00000, 0x3f3f0000, 0x003c3f3c},
    { 0x00102060, 0x00900000, 0x20100000, 0x001a0100, 0x00900000, 0x20100000, 0x011a0000, 0x00102024}
   , 0x4000,0.000000,attributes+0,1,NULL,autohelperpat511,0,0.010000},
  {pat512,4,8, "CB277",0,-2,1,0,1,2,0x0,647,
    { 0x00f0c000, 0xf0300000, 0x0f3f0000, 0x00303c3c, 0x0030f0f0, 0xc0f00000, 0x3c300000, 0x003f0f00},
    { 0x00108000, 0x80100000, 0x09100000, 0x00100804, 0x00108040, 0x80100000, 0x08100000, 0x00100900}
   , 0x9025,0.000000,attributes+0,1,NULL,autohelperpat512,0,0.010000},
  {pat513,6,8, "CB327",-2,-2,1,0,3,2,0x0,647,
    { 0xf0f0c000, 0xff3c0000, 0x0f3f3f0c, 0x00f0fcfc, 0x003cfffc, 0xc0f0f0c0, 0xfcf00000, 0x3f3f0f00},
    { 0x00108000, 0x80100000, 0x09100000, 0x00100804, 0x00108040, 0x80100000, 0x08100000, 0x00100900}
   , 0x9105,0.000000,attributes+137,1,NULL,autohelperpat513,0,1.600000},
  {pat514,6,8, "CB328",-2,-2,1,0,3,2,0x0,647,
    { 0xf0f0c000, 0xff3c0000, 0x0f3f3f0c, 0x00f0fcfc, 0x003cfffc, 0xc0f0f0c0, 0xfcf00000, 0x3f3f0f00},
    { 0x00108000, 0x80100000, 0x09100000, 0x00100804, 0x00108040, 0x80100000, 0x08100000, 0x00100900}
   , 0x85,0.000000,attributes+139,1,NULL,autohelperpat514,0,3.960000},
  {pat515,11,8, "CB202",-2,-1,2,2,4,3,0x0,720,
    { 0xffffffff, 0xfcfefffc, 0xfcfcfce0, 0xffffff00, 0xfffefc00, 0xffffff2c, 0xffffffff, 0xfcfcfcfc},
    { 0x00180008, 0x00102000, 0x00900000, 0x22100000, 0x20100000, 0x00180000, 0x00102200, 0x00900080}
   , 0x2005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat516,6,8, "CB212",0,-1,1,4,1,5,0x0,796,
    { 0x00ffff00, 0xf0f0f0f0, 0xfcfc0000, 0x3c3c3c00, 0xf0f0f000, 0xffff0000, 0x3c3c3c3c, 0x00fcfc00},
    { 0x00210200, 0x00200090, 0x00200000, 0x00200000, 0x00200000, 0x02210000, 0x00200018, 0x00200000}
   , 0x8005,0.000000,attributes+0,1,NULL,autohelperpat516,3,3.000000},
  {pat517,6,8, "CB213",0,-1,1,4,1,5,0x0,796,
    { 0x00ffff00, 0xf0f0f0f0, 0xfcfc0000, 0x3c3c3c00, 0xf0f0f000, 0xffff0000, 0x3c3c3c3c, 0x00fcfc00},
    { 0x00210200, 0x00200090, 0x00200000, 0x00200000, 0x00200000, 0x02210000, 0x00200018, 0x00200000}
   , 0x9005,0.000000,attributes+141,1,NULL,autohelperpat517,3,3.000000},
  {pat518,9,8, "CB216",0,0,2,3,2,3,0x0,722,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00180000, 0x00102000, 0x00900000, 0x20100000, 0x20100000, 0x00180000, 0x00102000, 0x00900000}
   , 0x9105,0.000000,attributes+0,1,NULL,autohelperpat518,0,0.016000},
  {pat519,17,8, "CB219",0,-4,3,0,3,4,0x0,575,
    { 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3f},
    { 0x00100020, 0x00100000, 0x01100000, 0x00120006, 0x00100040, 0x00100000, 0x00120000, 0x00100122}
   , 0x2005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat520,6,8, "CB220",-1,0,2,1,3,1,0x0,683,
    { 0x3c3c3c3c, 0x00fcfc00, 0xf0f0f000, 0xffff0000, 0xfcfc0000, 0x3c3c3c00, 0x00ffff00, 0xf0f0f0f0},
    { 0x00242400, 0x00a05000, 0x60600000, 0x14280000, 0x50a00000, 0x24240000, 0x00281400, 0x00606000}
   , 0x0,0.000000,attributes+143,0,NULL,NULL,3,0.000000},
  {pat521,12,8, "CB221",0,-4,3,1,3,5,0x0,686,
    { 0x0030fcf0, 0xc0f0c000, 0xff300000, 0x0c3f0f0f, 0xc0f0c0c0, 0xfc300000, 0x0f3f0c00, 0x0030ff3f},
    { 0x00104080, 0x40100000, 0x05100000, 0x00100606, 0x00104040, 0x40100000, 0x06100000, 0x0010050a}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat522,6,8, "CB223",-1,0,1,2,2,2,0x0,722,
    { 0x2a3f3f00, 0x00f8f8f8, 0xf0f0a000, 0xbcbc0000, 0xf8f80000, 0x3f3f2a00, 0x00bcbcbc, 0xa0f0f000},
    { 0x00110200, 0x00100090, 0x00100000, 0x00100000, 0x00100000, 0x02110000, 0x00100018, 0x00100000}
   , 0x9005,0.000000,attributes+0,1,NULL,autohelperpat522,0,0.010000},
  {pat523,9,8, "CB231",-1,-1,2,2,3,3,0x0,758,
    { 0x2a3fbf20, 0x80f8f8f8, 0xf8f0a000, 0xbcbe0800, 0xf8f88000, 0xbf3f2a00, 0x08bebcbc, 0xa0f0f820},
    { 0x00100600, 0x00104080, 0x40100000, 0x04100000, 0x40100000, 0x06100000, 0x00100408, 0x00104000}
   , 0x9005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat524,11,8, "CB232",-1,-1,2,2,3,3,0x0,758,
    { 0x2a3fbf3f, 0x80f8f8f8, 0xf8f0a000, 0xbfbf0800, 0xf8f88000, 0xbf3f2a00, 0x08bfbfbf, 0xa0f0f8f0},
    { 0x0010061a, 0x00104080, 0x40100000, 0x06110000, 0x40100000, 0x06100000, 0x0011060a, 0x00104090}
   , 0x9005,0.000000,attributes+145,0,NULL,NULL,0,0.000000},
  {pat525,8,8, "CB236",0,0,2,3,2,3,0x0,758,
    { 0x003f0f03, 0x0030f0f0, 0xc0f00000, 0x3c300000, 0xf0300000, 0x0f3f0000, 0x00303c3f, 0x00f0c000},
    { 0x00280401, 0x00206000, 0x40a00000, 0x24200000, 0x60200000, 0x04280000, 0x00202401, 0x00a04000}
   , 0x9005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat526,4,8, "CB240",-2,0,0,1,2,1,0x0,720,
    { 0x3c3c0000, 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000, 0xf0f00000},
    { 0x00180000, 0x00102000, 0x00900000, 0x20100000, 0x20100000, 0x00180000, 0x00102000, 0x00900000}
   , 0x1005,0.000000,attributes+0,1,NULL,autohelperpat526,0,0.021760},
  {pat527,5,8, "CB241a",-2,0,1,1,3,1,0x0,720,
    { 0x3c3c3000, 0x00ff3f00, 0x30f0f0f0, 0xf0fc0000, 0x3fff0000, 0x303c3c3c, 0x00fcf000, 0xf0f03000},
    { 0x00181000, 0x00502000, 0x10900000, 0x20140000, 0x20500000, 0x10180000, 0x00142000, 0x00901000}
   , 0x1005,0.000000,attributes+0,1,NULL,autohelperpat527,0,1.000000},
  {pat528,5,8, "CB241b",-2,0,1,1,3,1,0x0,720,
    { 0x3c3c3400, 0x00ff7f00, 0x70f0f0f0, 0xf4fc0000, 0x7fff0000, 0x343c3c3c, 0x00fcf400, 0xf0f07000},
    { 0x00180000, 0x00102000, 0x00900000, 0x20100000, 0x20100000, 0x00180000, 0x00102000, 0x00900000}
   , 0x1005,0.000000,attributes+0,1,NULL,autohelperpat528,0,1.000000},
  {pat529,11,8, "CB244",-1,0,1,4,2,4,0x0,832,
    { 0x0f3f0f00, 0x0030fcfc, 0xc0f0c000, 0xfc300000, 0xfc300000, 0x0f3f0f00, 0x0030fcfc, 0xc0f0c000},
    { 0x001a0500, 0x00106060, 0x40900000, 0x24100000, 0x60100000, 0x051a0000, 0x00102424, 0x00904000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat530,8,8, "CB245",-1,0,1,4,2,4,0x0,795,
    { 0x0f3f0f00, 0x0030fcfc, 0xc0f0c000, 0xfc300000, 0xfc300000, 0x0f3f0f00, 0x0030fcfc, 0xc0f0c000},
    { 0x001a0500, 0x00106060, 0x40900000, 0x24100000, 0x60100000, 0x051a0000, 0x00102424, 0x00904000}
   , 0x1005,0.000000,attributes+0,1,NULL,autohelperpat530,0,1.907296},
  {pat531,13,8, "CB247",0,-1,3,2,3,3,0x0,723,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x00109020, 0x80500000, 0x18100000, 0x00160800, 0x00508000, 0x90100000, 0x08160000, 0x00101820}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat532,9,8, "CB262",-2,-1,1,2,3,3,0x0,683,
    { 0xffffff00, 0xfffffefc, 0xfcfcfcbc, 0xfcfcfc00, 0xfeffff00, 0xfffffff8, 0xfcfcfcfc, 0xfcfcfc00},
    { 0x00250900, 0x00209050, 0x80600000, 0x18200000, 0x90200000, 0x09250000, 0x00201814, 0x00608000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat533,13,8, "CB271",0,-1,3,3,3,4,0x0,760,
    { 0x003fff3f, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0c00, 0xf0f0c000, 0xff3f0000, 0x0c3f3f3f, 0x00f0fcf0},
    { 0x00180610, 0x00106080, 0x40900000, 0x24110000, 0x60100000, 0x06180000, 0x00112408, 0x00904010}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat534,11,8, "CB275",0,-2,5,0,5,2,0x0,650,
    { 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0x003f3f03, 0x00f0f000, 0xf0f00000, 0x3f3f0000, 0x003c3c3f},
    { 0x00200010, 0x00200000, 0x00200000, 0x00210001, 0x00200000, 0x00200000, 0x00210000, 0x00200011}
   , 0x9105,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat535,11,8, "CB281",0,0,4,3,4,3,0x0,723,
    { 0x003c3c3f, 0x00f0f000, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3c3c0000, 0x003f3f03, 0x00f0f0f0},
    { 0x00101020, 0x00500000, 0x10100000, 0x00160000, 0x00500000, 0x10100000, 0x00160000, 0x00101020}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat536,12,8, "CB288",-2,0,1,3,3,3,0x0,757,
    { 0x3f3f0f00, 0x003cffff, 0xc0f0f0c0, 0xfcf00000, 0xff3c0000, 0x0f3f3f0f, 0x00f0fcfc, 0xf0f0c000},
    { 0x00160800, 0x00109020, 0x80500000, 0x18100000, 0x90100000, 0x08160000, 0x00101820, 0x00508000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat537,8,8, "CB296",0,0,2,3,2,3,0x0,722,
    { 0x003a3f3c, 0x00f0e0e0, 0xf0b00000, 0x2f3f0000, 0xe0f00000, 0x3f3a0000, 0x003f2f2c, 0x00b0f0f0},
    { 0x00100018, 0x00100000, 0x00100000, 0x02110000, 0x00100000, 0x00100000, 0x00110200, 0x00100090}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat538,8,8, "CB297",0,0,2,3,2,3,0x0,722,
    { 0x003a3f3c, 0x00f0e0e0, 0xf0b00000, 0x2f3f0000, 0xe0f00000, 0x3f3a0000, 0x003f2f2c, 0x00b0f0f0},
    { 0x00100018, 0x00100000, 0x00100000, 0x02110000, 0x00100000, 0x00100000, 0x00110200, 0x00100090}
   , 0x5005,0.000000,attributes+147,1,NULL,autohelperpat538,0,1.600000},
  {pat539,11,8, "CB298",0,0,2,3,2,3,0x0,760,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00112428, 0x00904010, 0x60100000, 0x061a0000, 0x40900000, 0x24110000, 0x001a0610, 0x001060a0}
   , 0x9025,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat540,10,8, "CB307",0,0,2,3,2,3,0x0,759,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00201824, 0x00608000, 0x90200000, 0x09260000, 0x80600000, 0x18200000, 0x00260900, 0x00209060}
   , 0x0,0.000000,attributes+149,1,NULL,autohelperpat540,3,0.016000},
  {pat541,16,8, "CB309",0,-3,3,1,3,4,0x0,649,
    { 0x00fcf8fc, 0xf0f0b000, 0xbfff0000, 0x3b3f3f3f, 0xb0f0f0f0, 0xf8fc0000, 0x3f3f3b00, 0x00ffbfff},
    { 0x00249004, 0x80601000, 0x18600000, 0x11240800, 0x10608000, 0x90240000, 0x08241100, 0x00601840}
   , 0x9005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat542,6,8, "CB310",-1,-2,2,1,3,3,0x0,647,
    { 0xf0fcf0e0, 0xfcfc3000, 0x3fff3c00, 0x30feff3c, 0x30fcfcf0, 0xf0fcf000, 0xfffe3000, 0x3cff3f2c},
    { 0x00201040, 0x00600000, 0x10200000, 0x00240100, 0x00600000, 0x10200000, 0x01240000, 0x00201004}
   , 0x9005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat543,10,8, "CB313",0,-2,2,2,2,4,0x0,722,
    { 0x00ffffff, 0xf0f0f0f0, 0xfffc0000, 0x3f3f3f0f, 0xf0f0f0c0, 0xffff0000, 0x3f3f3f3f, 0x00fcffff},
    { 0x00102000, 0x00900000, 0x22100000, 0x00180008, 0x00900080, 0x20100000, 0x00180000, 0x00102200}
   , 0x2005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat544,3,8, "CB323",0,0,1,2,1,2,0x0,722,
    { 0x003c3f00, 0x00f0f0c0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3c0000, 0x003c3c0c, 0x00f0f000},
    { 0x00102100, 0x00900040, 0x20100000, 0x00180000, 0x00900000, 0x21100000, 0x00180004, 0x00102000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat545,9,8, "CB329a",-2,0,1,3,3,3,0x0,720,
    { 0x3f3f2f00, 0x00bcfffc, 0xe0f0f0c0, 0xfcf80000, 0xffbc0000, 0x2f3f3f0c, 0x00f8fcfc, 0xf0f0e000},
    { 0x00180600, 0x00106080, 0x40900000, 0x24100000, 0x60100000, 0x06180000, 0x00102408, 0x00904000}
   , 0x1005,0.000000,attributes+151,0,NULL,NULL,0,0.000000},
  {pat546,6,8, "CB335",0,-2,2,0,2,2,0x0,648,
    { 0x00f0f0e0, 0xf0f00000, 0x3f3d0000, 0x003e3f1f, 0x00f0f0d0, 0xf0f00000, 0x3f3e0000, 0x003d3f2f},
    { 0x00100000, 0x00100000, 0x02100000, 0x00100009, 0x00100080, 0x00100000, 0x00100000, 0x00100201}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat547,5,8, "CB339",-1,-2,1,0,2,2,0x0,648,
    { 0x40f0f000, 0xf4f00000, 0x3f3d0400, 0x003c7c1c, 0x00f0f4d0, 0xf0f04000, 0x7c3c0000, 0x043d3f00},
    { 0x00102000, 0x00900000, 0x20100000, 0x00180000, 0x00900000, 0x20100000, 0x00180000, 0x00102000}
   , 0x1005,0.000000,attributes+0,1,NULL,autohelperpat547,0,1.810000},
  {pat548,21,8, "CB205",-3,0,1,4,4,4,0x0,720,
    { 0x3f3f0f00, 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc, 0xf0f0c000},
    { 0x00100800, 0x00108000, 0x80100000, 0x08100000, 0x80100000, 0x08100000, 0x00100800, 0x00108000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat549,17,8, "CB225",-4,-1,1,3,5,4,0x0,720,
    { 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xfcfcfc00, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xfcfcfc00},
    { 0x00120000, 0x00100020, 0x00100000, 0x00100000, 0x00100000, 0x00120000, 0x00100020, 0x00100000}
   , 0x1005,0.000000,attributes+0,1,NULL,autohelperpat549,0,0.016000},
  {pat550,10,8, "CB235",0,-2,3,1,3,3,0x0,649,
    { 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff},
    { 0x00200000, 0x00200000, 0x01200000, 0x00200004, 0x00200040, 0x00200000, 0x00200000, 0x00200100}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat551,11,8, "CB251",0,-2,3,1,3,3,0x0,648,
    { 0x00f0fcfc, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0x003fffff},
    { 0x00100008, 0x00100000, 0x00100000, 0x02100000, 0x00100000, 0x00100000, 0x00100200, 0x00100080}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat552,6,8, "CB256",0,-2,2,0,2,2,0x0,648,
    { 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3f},
    { 0x00100020, 0x00100000, 0x00100000, 0x00120000, 0x00100000, 0x00100000, 0x00120000, 0x00100020}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat553,9,8, "CB257",0,0,2,3,2,3,0x0,759,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x5005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat554,12,8, "CB260",-1,0,2,3,3,3,0x0,759,
    { 0x3f3f3f3f, 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff, 0xf0f0f0f0},
    { 0x00102020, 0x00900000, 0x20100000, 0x001a0000, 0x00900000, 0x20100000, 0x001a0000, 0x00102020}
   , 0x5005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat555,12,8, "CB267",0,0,2,3,2,3,0x0,760,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00192420, 0x00906010, 0x60900000, 0x241a0000, 0x60900000, 0x24190000, 0x001a2410, 0x00906020}
   , 0x9001,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat556,7,8, "CB289",0,-2,2,1,2,3,0x0,648,
    { 0x00fcfcf0, 0xf0f0f000, 0xffff0000, 0x3c3f3f3f, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3c00, 0x00ffff3f},
    { 0x00100480, 0x00104000, 0x40100000, 0x04100200, 0x40100000, 0x04100000, 0x02100400, 0x00104008}
   , 0x9005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat557,14,8, "CB203",0,-2,3,1,3,3,0x0,649,
    { 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff},
    { 0x00106800, 0x40908000, 0xa4100000, 0x08180400, 0x80904000, 0x68100000, 0x04180800, 0x0010a400}
   , 0x5004,0.000000,attributes+154,1,NULL,autohelperpat557,0,0.592000},
  {pat558,21,8, "CB204",-3,0,1,4,4,4,0x0,757,
    { 0x3f3f0f00, 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc, 0xf0f0c000},
    { 0x00100800, 0x00108000, 0x80100000, 0x08100000, 0x80100000, 0x08100000, 0x00100800, 0x00108000}
   , 0x2005,0.000000,attributes+0,1,NULL,autohelperpat558,0,0.610000},
  {pat559,21,8, "CB204b",-3,0,1,4,4,4,0x0,757,
    { 0x3f3f0f00, 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc, 0xf0f0c000},
    { 0x00100800, 0x00108000, 0x80100000, 0x08100000, 0x80100000, 0x08100000, 0x00100800, 0x00108000}
   , 0xa005,0.000000,attributes+0,1,NULL,autohelperpat559,0,0.610000},
  {pat560,21,8, "CB206",-3,0,1,4,4,4,0x0,721,
    { 0x3f3f0f00, 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc, 0xf0f0c000},
    { 0x00100800, 0x00108000, 0x80100000, 0x08100000, 0x80100000, 0x08100000, 0x00100800, 0x00108000}
   , 0x1005,0.000000,attributes+0,1,NULL,autohelperpat560,0,1.600000},
  {pat561,10,8, "CB214",0,0,2,4,2,4,0x0,759,
    { 0x003f3f0f, 0x00f0f0f0, 0xf0f00000, 0x3f3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3f3f, 0x00f0f0c0},
    { 0x00120000, 0x00100020, 0x00100000, 0x00100000, 0x00100000, 0x00120000, 0x00100020, 0x00100000}
   , 0x9105,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat562,9,8, "CB215",0,-2,2,2,2,4,0x0,685,
    { 0x00fffffc, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3e, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3c, 0x00fffffe},
    { 0x00200100, 0x00200040, 0x01200000, 0x00200004, 0x00200040, 0x01200000, 0x00200004, 0x00200100}
   , 0x9105,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat563,7,8, "CB218",-2,-1,2,1,4,2,0x0,683,
    { 0xfcfcf0f0, 0xfcff3c00, 0x3cfcfc30, 0xf0ffff00, 0x3cfffc00, 0xf0fcfc30, 0xfffff000, 0xfcfc3c3c},
    { 0x00186060, 0x40902000, 0x24900000, 0x201a0500, 0x20904000, 0x60180000, 0x051a2000, 0x00902424}
   , 0x1005,0.000000,attributes+0,1,NULL,autohelperpat563,0,1.600000},
  {pat564,17,8, "CB224",-4,-1,1,3,5,4,0x0,719,
    { 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xfcfcfc00, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xfcfcfc00},
    { 0x00120000, 0x00100020, 0x00100000, 0x00100000, 0x00100000, 0x00120000, 0x00100020, 0x00100000}
   , 0x2005,0.000000,attributes+0,1,NULL,autohelperpat564,0,0.016000},
  {pat565,17,8, "CB226",-4,-1,1,3,5,4,0x0,682,
    { 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xfcfcfc00, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xfcfcfc00},
    { 0x00120000, 0x00100020, 0x00100000, 0x00100000, 0x00100000, 0x00120000, 0x00100020, 0x00100000}
   , 0x2005,0.000000,attributes+0,1,NULL,autohelperpat565,0,0.016000},
  {pat566,10,8, "CB227",0,-1,2,2,2,3,0x0,722,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x0014a000, 0x80901000, 0x28500000, 0x10180800, 0x10908000, 0xa0140000, 0x08181000, 0x00502800}
   , 0xd005,0.000000,attributes+156,0,NULL,NULL,0,0.000000},
  {pat567,10,8, "CB228",0,-1,2,2,2,3,0x0,722,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x00285000, 0x40602000, 0x14a00000, 0x20240400, 0x20604000, 0x50280000, 0x04242000, 0x00a01400}
   , 0x1005,0.000000,attributes+158,1,NULL,autohelperpat567,3,1.000000},
  {pat568,11,8, "CB229",0,-1,3,1,3,2,0x0,686,
    { 0x007cfcfc, 0xd0f0f000, 0xfcf40000, 0x3f3f1f00, 0xf0f0d000, 0xfc7c0000, 0x1f3f3f00, 0x00f4fcfc},
    { 0x00249000, 0x80601000, 0x18600000, 0x10240800, 0x10608000, 0x90240000, 0x08241000, 0x00601800}
   , 0x9005,0.000000,attributes+160,0,NULL,NULL,3,0.000000},
  {pat569,13,8, "CB230",-1,-4,2,0,3,4,0x0,573,
    { 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff, 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f},
    { 0x00104090, 0x40100000, 0x04100000, 0x00110602, 0x00104000, 0x40100000, 0x06110000, 0x0010041a}
   , 0x9005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat570,10,8, "CB233",0,-2,3,1,3,3,0x0,686,
    { 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff},
    { 0x00200000, 0x00200000, 0x01200000, 0x00200004, 0x00200040, 0x00200000, 0x00200000, 0x00200100}
   , 0x9005,0.000000,attributes+0,1,NULL,autohelperpat570,3,1.690000},
  {pat571,10,8, "CB234",0,-2,3,1,3,3,0x0,686,
    { 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff},
    { 0x00200000, 0x00200000, 0x01200000, 0x00200005, 0x00200040, 0x00200000, 0x00200000, 0x00200101}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat572,8,8, "CB237",-1,0,2,3,3,3,0x0,759,
    { 0x013f3f0e, 0x00f0f0f4, 0xf0f00000, 0x3f3c0000, 0xf0f00000, 0x3f3f0100, 0x003c3f7e, 0x00f0f0c0},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x1005,0.000000,attributes+0,1,NULL,autohelperpat572,0,10.000000},
  {pat573,3,8, "CB238",-1,0,1,2,2,2,0x0,721,
    { 0x3c3e0c00, 0x003cfc20, 0xc0f0f000, 0xfcf00000, 0xfc3c0000, 0x0c3e3c00, 0x00f0fc20, 0xf0f0c000},
    { 0x00100800, 0x00108000, 0x80100000, 0x08100000, 0x80100000, 0x08100000, 0x00100800, 0x00108000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat574,4,8, "CB239",-1,0,1,2,2,2,0x0,721,
    { 0x3d3f0c00, 0x003cfc34, 0xc0f0f000, 0xfcf00000, 0xfc3c0000, 0x0c3f3d00, 0x00f0fc70, 0xf0f0c000},
    { 0x00110800, 0x00108010, 0x80100000, 0x08100000, 0x80100000, 0x08110000, 0x00100810, 0x00108000}
   , 0xd004,0.000000,attributes+0,1,NULL,autohelperpat574,0,0.019600},
  {pat575,5,8, "CB241c",-2,0,1,1,3,1,0x0,683,
    { 0x3c3c3c00, 0x00ffff00, 0xf0f0f0f0, 0xfcfc0000, 0xffff0000, 0x3c3c3c3c, 0x00fcfc00, 0xf0f0f000},
    { 0x00180400, 0x00106000, 0x40900000, 0x24100000, 0x60100000, 0x04180000, 0x00102400, 0x00904000}
   , 0x1005,0.000000,attributes+0,1,NULL,autohelperpat575,0,1.000000},
  {pat576,4,8, "CB242",-2,-1,0,2,2,3,0x0,683,
    { 0x3c3c0000, 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000, 0xf0f00000},
    { 0x00180000, 0x00102000, 0x00900000, 0x20100000, 0x20100000, 0x00180000, 0x00102000, 0x00900000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat577,9,8, "CB243",-3,-1,1,2,4,3,0x0,683,
    { 0xfc3c2400, 0x0fbf7f00, 0x60f0fcfc, 0xf4f8c000, 0x7fbf0f00, 0x243cfcfc, 0xc0f8f400, 0xfcf06000},
    { 0x00180000, 0x00102000, 0x00900000, 0x20100000, 0x20100000, 0x00180000, 0x00102000, 0x00900000}
   , 0xd005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat578,11,8, "CB243b",-2,-3,2,0,4,3,0x0,647,
    { 0xc0f0c040, 0xfe300000, 0x0f3f0f0a, 0x0030fdff, 0x0030fefe, 0xc0f0c080, 0xfd300000, 0x0f3f0f07},
    { 0x00108000, 0x80100000, 0x09100000, 0x00100805, 0x00108040, 0x80100000, 0x08100000, 0x00100901}
   , 0xd005,0.000000,attributes+0,1,NULL,autohelperpat578,0,1.000000},
  {pat579,16,8, "CB246",0,-1,3,4,3,5,0x0,797,
    { 0x00ffffff, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0x00fcfcfc},
    { 0x00110008, 0x00100010, 0x00100000, 0x02100000, 0x00100000, 0x00110000, 0x00100210, 0x00100080}
   , 0x9005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat580,11,8, "CB248",0,-2,2,2,2,4,0x0,648,
    { 0x00fcffff, 0xf0f0f0c0, 0xfffc0000, 0x3f3f3f0f, 0xf0f0f0c0, 0xfffc0000, 0x3f3f3f0f, 0x00fcffff},
    { 0x00281602, 0x00606080, 0x50a00000, 0x24240000, 0x60600000, 0x16280000, 0x0024240a, 0x00a05000}
   , 0x9005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat581,7,8, "CB250",0,-3,3,0,3,3,0x0,612,
    { 0x00f0c0c0, 0xf0300000, 0x0f3c0000, 0x00303f0f, 0x0030f0c0, 0xc0f00000, 0x3f300000, 0x003c0f0f},
    { 0x00100080, 0x00100000, 0x01100000, 0x00100204, 0x00100040, 0x00100000, 0x02100000, 0x00100108}
   , 0x9005,0.000000,attributes+0,1,NULL,autohelperpat581,0,0.010000},
  {pat582,5,8, "CB252",-1,0,1,2,2,2,0x0,721,
    { 0x3f3f3c00, 0x00fcfc3c, 0xf0f0f000, 0xfcfc0000, 0xfcfc0000, 0x3c3f3f00, 0x00fcfcf0, 0xf0f0f000},
    { 0x00101800, 0x00508000, 0x90100000, 0x08140000, 0x80500000, 0x18100000, 0x00140800, 0x00109000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat583,7,4, "CB254",0,-2,2,0,2,2,0x0,648,
    { 0x00f0f0f0, 0xf0f00000, 0x3e3f0000, 0x003f3f3b, 0x00f0f0b0, 0xf0f00000, 0x3f3f0000, 0x003f3e3f},
    { 0x00102010, 0x00900000, 0x20100000, 0x00190000, 0x00900000, 0x20100000, 0x00190000, 0x00102010}
   , 0xd004,0.000000,attributes+162,1,NULL,autohelperpat583,0,0.592000},
  {pat584,6,8, "CB255",0,0,2,3,2,3,0x0,759,
    { 0x003f3f01, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3d, 0x00f0f000},
    { 0x00120000, 0x00100020, 0x00100000, 0x00100000, 0x00100000, 0x00120000, 0x00100020, 0x00100000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat585,12,8, "CB258",-2,-1,2,4,4,5,0x0,758,
    { 0x3fbf3f3f, 0x20fcfcfc, 0xf0f8f000, 0xffff2000, 0xfcfc2000, 0x3fbf3f00, 0x20ffffff, 0xf0f8f0f0},
    { 0x00100020, 0x00100000, 0x00100000, 0x00120000, 0x00100000, 0x00100000, 0x00120000, 0x00100020}
   , 0x8005,0.000000,attributes+0,1,NULL,autohelperpat585,0,0.010000},
  {pat586,12,8, "CB259",-1,-1,2,3,3,4,0x0,758,
    { 0x3fbf3f3f, 0x20fcfcfc, 0xf0f8f000, 0xffff2000, 0xfcfc2000, 0x3fbf3f00, 0x20ffffff, 0xf0f8f0f0},
    { 0x00100022, 0x00100000, 0x00100000, 0x00120000, 0x00100000, 0x00100000, 0x00120002, 0x00100020}
   , 0x5,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat587,12,8, "CB261",0,-1,3,2,3,3,0x0,724,
    { 0x003cffff, 0xc0f0f0c0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3c0000, 0x0f3f3f0f, 0x00f0fcfc},
    { 0x00109080, 0x80500000, 0x18100000, 0x00140a00, 0x00508000, 0x90100000, 0x0a140000, 0x00101808}
   , 0x5005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat588,8,8, "CB263",-1,-3,2,0,3,3,0x0,610,
    { 0xc0f0f000, 0xfcf00000, 0x3f3f0d00, 0x003cfc7f, 0x00f0fcf4, 0xf0f0c000, 0xfc3c0000, 0x0d3f3f03},
    { 0x00101000, 0x00500000, 0x10100000, 0x00140002, 0x00500000, 0x10100000, 0x00140000, 0x00101002}
   , 0x9005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat589,9,8, "CB263b",-1,-3,2,0,3,3,0x0,611,
    { 0xc0f0f000, 0xfcf00000, 0x3f3f0d00, 0x003cfc7f, 0x00f0fcf4, 0xf0f0c000, 0xfc3c0000, 0x0d3f3f03},
    { 0x00101000, 0x00500000, 0x10100000, 0x00140002, 0x00500000, 0x10100000, 0x00140000, 0x00101002}
   , 0x9005,0.000000,attributes+0,1,NULL,autohelperpat589,0,1.000000},
  {pat590,14,8, "CB264",0,-2,4,2,4,4,0x0,724,
    { 0x00f0fcfc, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0x003fffff},
    { 0x00100840, 0x00108000, 0x80100000, 0x08100100, 0x80100000, 0x08100000, 0x01100800, 0x00108004}
   , 0x5005,0.000000,attributes+0,1,NULL,autohelperpat590,0,0.016000},
  {pat591,11,8, "CB265",0,0,3,4,3,4,0x0,723,
    { 0x003c3f3f, 0x00f0f0c0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3c0000, 0x003f3f0f, 0x00f0f0f0},
    { 0x00100200, 0x00100080, 0x00100000, 0x00100000, 0x00100000, 0x02100000, 0x00100008, 0x00100000}
   , 0x5005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat592,13,8, "CB266",0,-4,2,0,2,4,0x0,611,
    { 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3f},
    { 0x00101090, 0x00500000, 0x10100000, 0x00150200, 0x00500000, 0x10100000, 0x02150000, 0x00101018}
   , 0x5005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat593,14,8, "CB268",0,0,3,4,3,4,0x0,796,
    { 0x003f3f0f, 0x00f0f0f0, 0xf0f00000, 0x3f3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3f3f, 0x00f0f0c0},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0xa101,0.000000,attributes+0,1,jump_out_helper
,autohelperpat593,0,1.368160},
  {pat594,9,8, "CB269",0,0,3,3,3,3,0x0,759,
    { 0x003f3f0f, 0x00f0f0f0, 0xf0f00000, 0x3f3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3f3f, 0x00f0f0c0},
    { 0x00100008, 0x00100000, 0x00100000, 0x02100000, 0x00100000, 0x00100000, 0x00100200, 0x00100080}
   , 0x6005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat595,11,8, "CB270",0,0,4,3,4,3,0x0,759,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00100012, 0x00100000, 0x00100000, 0x00110000, 0x00100000, 0x00100000, 0x00110002, 0x00100010}
   , 0x9005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat596,15,8, "CB272",0,-3,5,1,5,4,0x0,650,
    { 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x6005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat597,12,8, "CB273",0,-2,4,1,4,3,0x0,687,
    { 0x0030f8fc, 0xc0f08000, 0xbc300000, 0x0b3f0f03, 0x80f0c000, 0xf8300000, 0x0f3f0b00, 0x0030bcff},
    { 0x00109000, 0x80500000, 0x18100000, 0x00140802, 0x00508000, 0x90100000, 0x08140000, 0x00101802}
   , 0x1005,0.000000,attributes+0,1,NULL,autohelperpat597,0,0.970000},
  {pat598,11,8, "CB274",-1,-3,2,2,3,5,0x0,648,
    { 0x00fcfffc, 0xf0f0f0c0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xfffc0000, 0x3f3f3f0c, 0x00ffffff},
    { 0x00281600, 0x00606080, 0x50a00000, 0x24240000, 0x60600000, 0x16280000, 0x00242408, 0x00a05000}
   , 0x9005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat599,12,8, "CB276",-1,0,2,4,3,4,0x0,795,
    { 0x0f3f2f0f, 0x00b0fcfc, 0xe0f0c000, 0xff380000, 0xfcb00000, 0x2f3f0f00, 0x0038ffff, 0xc0f0e0c0},
    { 0x0010040a, 0x00104000, 0x40100000, 0x06100000, 0x40100000, 0x04100000, 0x00100602, 0x00104080}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat600,5,4, "CB278",0,0,2,2,2,2,0x0,722,
    { 0x003f3f0c, 0x00f0f0f0, 0xf0f00000, 0x3f3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3f3c, 0x00f0f0c0},
    { 0x00190000, 0x00102010, 0x00900000, 0x20100000, 0x20100000, 0x00190000, 0x00102010, 0x00900000}
   , 0x9005,0.000000,attributes+0,1,NULL,autohelperpat600,0,0.016000},
  {pat601,5,4, "CB279",0,0,2,2,2,2,0x0,722,
    { 0x003f3f0c, 0x00f0f0f0, 0xf0f00000, 0x3f3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3f3c, 0x00f0f0c0},
    { 0x00260000, 0x00201020, 0x00600000, 0x10200000, 0x10200000, 0x00260000, 0x00201020, 0x00600000}
   , 0x1005,0.000000,attributes+0,1,NULL,autohelperpat601,3,0.016000},
  {pat602,7,8, "CB280",-2,0,2,2,4,2,0x0,720,
    { 0x3f3c3c3c, 0x00fcff0c, 0xf0f0f0c0, 0xffff0000, 0xfffc0000, 0x3c3c3f0c, 0x00ffffc0, 0xf0f0f0f0},
    { 0x00242024, 0x00a01000, 0x20600000, 0x112a0000, 0x10a00000, 0x20240000, 0x002a1100, 0x00602060}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat603,16,4, "CB282",-1,0,1,7,2,7,0x0,832,
    { 0x3f3f3f00, 0x00fcfcfc, 0xf0f0f000, 0xfcfc0000, 0xfcfc0000, 0x3f3f3f00, 0x00fcfcfc, 0xf0f0f000},
    { 0x00220000, 0x00200020, 0x00200000, 0x00200000, 0x00200000, 0x00220000, 0x00200020, 0x00200000}
   , 0x2000,0.000000,attributes+0,1,NULL,autohelperpat603,3,0.010000},
  {pat604,11,8, "CB283",-1,0,2,3,3,3,0x0,721,
    { 0x3d3f3f3f, 0x00fcfcf4, 0xf0f0f000, 0xffff0000, 0xfcfc0000, 0x3f3f3d00, 0x00ffff7f, 0xf0f0f0f0},
    { 0x00101820, 0x00508000, 0x90100000, 0x08160000, 0x80500000, 0x18100000, 0x00160800, 0x00109020}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat605,18,8, "CB284",0,-1,3,4,3,5,0x0,723,
    { 0x00ffffff, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0x00fcfcfc},
    { 0x00120000, 0x00100020, 0x00100000, 0x00100000, 0x00100000, 0x00120000, 0x00100020, 0x00100000}
   , 0x5105,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat606,15,4, "CB285",-2,0,1,4,3,4,0x0,757,
    { 0x3f3f0f00, 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc, 0xf0f0c000},
    { 0x00100800, 0x00108000, 0x80100000, 0x08100000, 0x80100000, 0x08100000, 0x00100800, 0x00108000}
   , 0x2105,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat607,15,4, "CB286",-2,0,1,4,3,4,0x0,757,
    { 0x3f3f0f00, 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc, 0xf0f0c000},
    { 0x00200400, 0x00204000, 0x40200000, 0x04200000, 0x40200000, 0x04200000, 0x00200400, 0x00204000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat608,14,8, "CB287",0,-2,5,0,5,2,0x0,650,
    { 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3f},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x6105,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat609,15,8, "CB290",-1,-4,3,0,4,4,0x0,610,
    { 0xf0f0c0c0, 0xfc3c0000, 0x0f3f3f00, 0x00f0ffff, 0x003cfcfc, 0xc0f0f000, 0xfff00000, 0x3f3f0f0f},
    { 0x00200040, 0x00200000, 0x00200000, 0x00200101, 0x00200000, 0x00200000, 0x01200000, 0x00200005}
   , 0x9005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat610,10,8, "CB291",0,-1,3,3,3,4,0x0,723,
    { 0x00fcffff, 0xf0f0f0c0, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xfffc0000, 0x3f3f3f0f, 0x00fcfcfc},
    { 0x00180600, 0x00106080, 0x40900000, 0x24100000, 0x60100000, 0x06180000, 0x00102408, 0x00904000}
   , 0x9005,0.000000,attributes+0,1,NULL,autohelperpat610,0,1.000000},
  {pat611,13,8, "CB292",0,-1,4,3,4,4,0x0,687,
    { 0x00f0fcff, 0xf0f0c000, 0xfc3c0000, 0x0f3f3f00, 0xc0f0f000, 0xfcf00000, 0x3f3f0f03, 0x003cfcfc},
    { 0x00100400, 0x00104000, 0x40100000, 0x04100000, 0x40100000, 0x04100000, 0x00100400, 0x00104000}
   , 0x2005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat612,14,8, "CB293",0,-1,4,2,4,3,0x0,724,
    { 0x003f3fff, 0x00f0f0f0, 0xf0f00000, 0x3f3f0300, 0xf0f00000, 0x3f3f0000, 0x033f3f3f, 0x00f0f0fc},
    { 0x00101080, 0x00500000, 0x10100000, 0x00140200, 0x00500000, 0x10100000, 0x02140000, 0x00101008}
   , 0xd005,0.000000,attributes+164,1,NULL,autohelperpat612,0,10.000000},
  {pat613,19,8, "CB294",0,0,4,4,4,4,0x0,760,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00250908, 0x00209050, 0x80600000, 0x1a200000, 0x90200000, 0x09250000, 0x00201a14, 0x00608080}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat614,10,8, "CB295",0,-1,3,2,3,3,0x0,686,
    { 0x00b8fcff, 0xe0f0e000, 0xfcb80000, 0x2f3f2f00, 0xe0f0e000, 0xfcb80000, 0x2f3f2f03, 0x00b8fcfc},
    { 0x00100008, 0x00100000, 0x00100000, 0x02100000, 0x00100000, 0x00100000, 0x00100200, 0x00100080}
   , 0x2005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat615,9,8, "CB299",0,0,2,2,2,2,0x0,723,
    { 0x003b373f, 0x00f060f0, 0x70b00000, 0x273f0000, 0x60f00000, 0x373b0000, 0x003f273f, 0x00b070f0},
    { 0x00111021, 0x00500010, 0x10100000, 0x00160000, 0x00500000, 0x10110000, 0x00160011, 0x00101020}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat616,6,8, "CB300",-1,0,1,2,2,2,0x0,721,
    { 0x3f3f3f00, 0x00fcfcfc, 0xf0f0f000, 0xfcfc0000, 0xfcfc0000, 0x3f3f3f00, 0x00fcfcfc, 0xf0f0f000},
    { 0x00101a00, 0x00508080, 0x90100000, 0x08140000, 0x80500000, 0x1a100000, 0x00140808, 0x00109000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat617,8,8, "CB301",0,0,3,2,3,2,0x0,722,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00200024, 0x00200000, 0x00200000, 0x01220000, 0x00200000, 0x00200000, 0x00220100, 0x00200060}
   , 0xd005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat618,15,8, "CB302",0,-2,4,1,4,3,0x0,649,
    { 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x6105,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat619,8,8, "CB303",0,-2,3,1,3,3,0x0,648,
    { 0x00f0fcf0, 0xf0f0c000, 0xff3c0000, 0x0c3f3f0c, 0xc0f0f0c0, 0xfcf00000, 0x3f3f0c00, 0x003cff3c},
    { 0x00201800, 0x00608000, 0x90200000, 0x08240000, 0x80600000, 0x18200000, 0x00240800, 0x00209000}
   , 0x1005,0.000000,attributes+166,1,NULL,autohelperpat619,3,1.000000},
  {pat620,8,4, "CB304",0,-1,2,2,2,3,0x0,722,
    { 0x003fff3f, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0c00, 0xf0f0c000, 0xff3f0000, 0x0c3f3f3f, 0x00f0fcf0},
    { 0x00205020, 0x40600000, 0x14200000, 0x00260400, 0x00604000, 0x50200000, 0x04260000, 0x00201420}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat621,12,4, "CB305",0,-1,2,3,2,4,0x0,759,
    { 0x003fbf3f, 0x80f0f0f0, 0xf8f00000, 0x3f3f0800, 0xf0f08000, 0xbf3f0000, 0x083f3f3f, 0x00f0f8f0},
    { 0x00180418, 0x00106000, 0x40900000, 0x26110000, 0x60100000, 0x04180000, 0x00112600, 0x00904090}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat622,10,8, "CB306",0,-2,2,2,2,4,0x0,722,
    { 0x00bfffff, 0xe0f0f0f0, 0xfff80000, 0x3f3f2f0c, 0xf0f0e0c0, 0xffbf0000, 0x2f3f3f3f, 0x00f8fffc},
    { 0x00201060, 0x00600000, 0x11200000, 0x00260104, 0x00600040, 0x10200000, 0x01260000, 0x00201124}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat623,8,8, "CB308",-2,0,1,3,3,3,0x0,721,
    { 0x3f3f0f00, 0x003cfffc, 0xc0f0f0c0, 0xfcf00000, 0xff3c0000, 0x0f3f3f0c, 0x00f0fcfc, 0xf0f0c000},
    { 0x00100800, 0x00108000, 0x80100000, 0x08100000, 0x80100000, 0x08100000, 0x00100800, 0x00108000}
   , 0x1005,0.000000,attributes+168,1,NULL,autohelperpat623,0,0.610000},
  {pat624,11,8, "CB311",-1,0,2,3,3,3,0x0,721,
    { 0x3f3f3f0f, 0x00fcfcfc, 0xf0f0f000, 0xfffc0000, 0xfcfc0000, 0x3f3f3f00, 0x00fcffff, 0xf0f0f0c0},
    { 0x00102001, 0x00900000, 0x20100000, 0x00180000, 0x00900000, 0x20100000, 0x00180001, 0x00102000}
   , 0x5105,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat625,8,8, "CB312",0,-2,3,1,3,3,0x0,686,
    { 0x00fcfcfc, 0xf0f0f000, 0xfffc0000, 0x3f3f3f0f, 0xf0f0f0c0, 0xfcfc0000, 0x3f3f3f00, 0x00fcffff},
    { 0x00201800, 0x00608000, 0x91200000, 0x08240004, 0x80600040, 0x18200000, 0x00240800, 0x00209100}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat626,9,8, "CB314",0,-1,3,2,3,3,0x0,723,
    { 0x007f3fff, 0x10f0f0f0, 0xf0f40000, 0x3f3f1300, 0xf0f01000, 0x3f7f0000, 0x133f3f3f, 0x00f4f0fc},
    { 0x00200040, 0x00200000, 0x00200000, 0x00200100, 0x00200000, 0x00200000, 0x01200000, 0x00200004}
   , 0x1005,0.000000,attributes+0,1,NULL,autohelperpat626,3,10.000000},
  {pat627,10,8, "CB315",0,-2,3,2,3,4,0x0,685,
    { 0x003cfefc, 0xc0f0f080, 0xfff00000, 0x3f3f0f0f, 0xf0f0c0c0, 0xfe3c0000, 0x0f3f3f08, 0x00f0ffff},
    { 0x00240004, 0x00201000, 0x00600000, 0x11200001, 0x10200000, 0x00240000, 0x00201100, 0x00600041}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat628,8,8, "CB316",0,-1,3,1,3,2,0x0,686,
    { 0x003cfcfc, 0xc0f0f000, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xfc3c0000, 0x0f3f3f00, 0x00f0fcfc},
    { 0x00148004, 0x80101000, 0x08500000, 0x11100800, 0x10108000, 0x80140000, 0x08101100, 0x00500840}
   , 0x1005,0.000000,attributes+0,1,NULL,autohelperpat628,0,0.010000},
  {pat629,13,8, "CB317",0,-1,3,2,3,3,0x0,722,
    { 0x007fffff, 0xd0f0f0f0, 0xfcf40000, 0x3f3f1f00, 0xf0f0d000, 0xff7f0000, 0x1f3f3f3f, 0x00f4fcfc},
    { 0x00209042, 0x80600000, 0x18200000, 0x00240900, 0x00608000, 0x90200000, 0x09240002, 0x00201804}
   , 0x9005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat630,6,8, "CB318",0,-2,2,0,2,2,0x0,648,
    { 0x00f0f0f0, 0xf0f00000, 0x3f3e0000, 0x003f3f2f, 0x00f0f0e0, 0xf0f00000, 0x3f3f0000, 0x003e3f3f},
    { 0x00200000, 0x00200000, 0x01200000, 0x00200006, 0x00200040, 0x00200000, 0x00200000, 0x00200102}
   , 0x9005,0.000000,attributes+0,1,NULL,autohelperpat630,3,0.610000},
  {pat631,11,8, "CB319",0,-2,4,1,4,3,0x0,648,
    { 0x00f0fcfc, 0xf0f0c000, 0xff3c0000, 0x0f3f3f0c, 0xc0f0f0c0, 0xfcf00000, 0x3f3f0f00, 0x003cfffc},
    { 0x00200404, 0x00204000, 0x40200000, 0x05200000, 0x40200000, 0x04200000, 0x00200500, 0x00204040}
   , 0x9005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat632,14,8, "CB320",0,0,4,4,4,4,0x0,760,
    { 0x003f3f2f, 0x00f0f0f0, 0xf0f00000, 0x3f3e0000, 0xf0f00000, 0x3f3f0000, 0x003e3f3f, 0x00f0f0e0},
    { 0x00210000, 0x00200010, 0x00200000, 0x00200000, 0x00200000, 0x00210000, 0x00200010, 0x00200000}
   , 0xc005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat633,9,4, "CB321",-2,-2,2,4,4,6,0x0,758,
    { 0x3f7f3f00, 0x10fcfcfc, 0xf0f5f000, 0xfcfc1010, 0xfcfc1010, 0x3f7f3f00, 0x10fcfcfc, 0xf0f5f000},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x2004,0.000000,attributes+0,1,NULL,autohelperpat633,3,0.016000},
  {pat634,17,4, "CB322",-2,-2,2,4,4,6,0x0,758,
    { 0x3f7f3f3a, 0x10fffefe, 0xf0f5f0b0, 0xfeff1010, 0xfeff1010, 0x3f7f3f3a, 0x10fffefe, 0xf0f5f0b0},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x2004,0.000000,attributes+0,1,NULL,autohelperpat634,3,0.016000},
  {pat635,21,8, "CB322a",-3,-2,2,4,5,6,0x0,758,
    { 0x3f7f3f3a, 0x10fffefe, 0xf0f5f0b0, 0xfeff1010, 0xfeff1010, 0x3f7f3f3a, 0x10fffefe, 0xf0f5f0b0},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x6004,0.000000,attributes+0,1,NULL,autohelperpat635,3,0.019600},
  {pat636,8,8, "CB324",0,-2,2,1,2,3,0x0,648,
    { 0x0070fcfc, 0xd0f0c000, 0xff350000, 0x0f3f1f1f, 0xc0f0d0d0, 0xfc700000, 0x1f3f0f00, 0x0035ffff},
    { 0x00200004, 0x00200000, 0x01200000, 0x01200004, 0x00200040, 0x00200000, 0x00200100, 0x00200140}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat637,4,8, "CB325",0,-1,2,0,2,1,0x0,647,
    { 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0x003f3f00, 0x00f0f000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c},
    { 0x00102020, 0x00900000, 0x20100000, 0x001a0000, 0x00900000, 0x20100000, 0x001a0000, 0x00102020}
   , 0x1025,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat638,10,8, "CB326",-2,0,1,3,3,3,0x0,758,
    { 0x3f3f3f00, 0x00fcfffc, 0xf0f0f0c0, 0xfcfc0000, 0xfffc0000, 0x3f3f3f0c, 0x00fcfcfc, 0xf0f0f000},
    { 0x00101a00, 0x00508080, 0x90100000, 0x08140000, 0x80500000, 0x1a100000, 0x00140808, 0x00109000}
   , 0x1005,0.000000,attributes+170,1,NULL,autohelperpat638,0,0.376000},
  {pat639,5,4, "CB330",-2,0,1,2,3,2,0x0,721,
    { 0x3f3f0c00, 0x003cff3c, 0xc0f0f0c0, 0xfcf00000, 0xff3c0000, 0x0c3f3f0c, 0x00f0fcf0, 0xf0f0c000},
    { 0x00220400, 0x00204020, 0x40200000, 0x04200000, 0x40200000, 0x04220000, 0x00200420, 0x00204000}
   , 0x1005,0.000000,attributes+172,0,NULL,NULL,3,0.000000},
  {pat640,6,8, "CB331",-2,0,1,2,3,2,0x0,721,
    { 0x3f3f2f00, 0x00bcfffc, 0xe0f0f0c0, 0xfcf80000, 0xffbc0000, 0x2f3f3f0c, 0x00f8fcfc, 0xf0f0e000},
    { 0x00220100, 0x00200060, 0x00200000, 0x00200000, 0x00200000, 0x01220000, 0x00200024, 0x00200000}
   , 0x1005,0.000000,attributes+0,1,NULL,autohelperpat640,3,1.000000},
  {pat641,16,8, "CB332",0,-2,3,3,3,5,0x0,686,
    { 0x007fffff, 0xd0f0f0f0, 0xfcf40000, 0x3f3f1f00, 0xf0f0d000, 0xff7f0000, 0x1f3f3f3f, 0x00f4fcfc},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x2005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat642,5,8, "CB333",-1,0,2,2,3,2,0x0,722,
    { 0x0c3f3f0c, 0x00f0fcf0, 0xf0f0c000, 0xff3c0000, 0xfcf00000, 0x3f3f0c00, 0x003cff3c, 0xc0f0f0c0},
    { 0x00190000, 0x00102010, 0x00900000, 0x20100000, 0x20100000, 0x00190000, 0x00102010, 0x00900000}
   , 0x5,0.000000,attributes+174,1,NULL,autohelperpat642,0,1.009600},
  {pat643,14,8, "CB334",0,-3,3,0,3,3,0x0,612,
    { 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3f},
    { 0x00101060, 0x00500000, 0x10100000, 0x00160100, 0x00500000, 0x10100000, 0x01160000, 0x00101024}
   , 0x5,0.000000,attributes+176,0,NULL,NULL,0,0.000000},
  {pat644,7,8, "CB337",0,-1,3,1,3,2,0x0,686,
    { 0x00fcfcfc, 0xf0f0f000, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xfcfc0000, 0x3f3f3f00, 0x00fcfcfc},
    { 0x00200040, 0x00200000, 0x00200000, 0x00200100, 0x00200000, 0x00200000, 0x01200000, 0x00200004}
   , 0xd005,0.000000,attributes+178,0,NULL,NULL,3,0.000000},
  {pat645,6,4, "CB338",-2,0,0,2,2,2,0x0,720,
    { 0x3d3d0000, 0x003d3d15, 0x00f0f050, 0xf0f00000, 0x3d3d0000, 0x003d3d15, 0x00f0f050, 0xf0f00000},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x1005,0.000000,attributes+0,1,NULL,autohelperpat645,0,5.776000},
  {pat646,11,8, "CB338b",-2,0,1,3,3,3,0x0,757,
    { 0x0f3f0b00, 0x0030bdfd, 0x80f0c040, 0xf8300000, 0xbd300000, 0x0b3f0f05, 0x0030f8fc, 0xc0f08000},
    { 0x00140100, 0x00101040, 0x00500000, 0x10100000, 0x10100000, 0x01140000, 0x00101004, 0x00500000}
   , 0x1005,0.000000,attributes+0,1,NULL,autohelperpat646,0,0.235600},
  {pat647,13,8, "CB340",0,0,3,3,3,3,0x0,797,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00200211, 0x00200080, 0x00200000, 0x00210000, 0x00200000, 0x02200000, 0x00210009, 0x00200010}
   , 0xc005,0.000000,attributes+180,0,NULL,NULL,3,0.000000},
  {pat648,12,8, "CB341",0,-2,3,1,3,3,0x0,722,
    { 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0x3f3f3f3e, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0x00fffffe},
    { 0x00201000, 0x00600000, 0x11200000, 0x00240004, 0x00600040, 0x10200000, 0x00240000, 0x00201100}
   , 0xc005,0.000000,attributes+182,0,NULL,NULL,3,0.000000},
  {pat649,13,8, "CB342",0,-2,3,2,3,4,0x0,722,
    { 0x00fcffff, 0xf0f0f0c0, 0xfffc0000, 0x3f3f3f0e, 0xf0f0f0c0, 0xfffc0000, 0x3f3f3f0f, 0x00fcfffe},
    { 0x00200000, 0x00200000, 0x01200000, 0x00200004, 0x00200040, 0x00200000, 0x00200000, 0x00200100}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat650,16,8, "CB343",0,-1,4,2,4,3,0x0,722,
    { 0x007fffff, 0xd0f0f0f0, 0xfcf40000, 0x3f3f1f00, 0xf0f0d000, 0xff7f0000, 0x1f3f3f3f, 0x00f4fcfc},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x1005,0.000000,attributes+184,1,NULL,autohelperpat650,3,0.023056},
  {pat651,8,8, "CB344a",0,-1,3,2,3,3,0x0,685,
    { 0x0030feff, 0xc0f0c080, 0xfc300000, 0x0f3f0f00, 0xc0f0c000, 0xfe300000, 0x0f3f0f0b, 0x0030fcfc},
    { 0x00200041, 0x00200000, 0x00200000, 0x00200100, 0x00200000, 0x00200000, 0x01200001, 0x00200004}
   , 0x1005,0.000000,attributes+0,1,NULL,autohelperpat651,3,0.016000},
  {pat652,8,8, "CB344b",0,-1,3,2,3,3,0x0,648,
    { 0x0030feff, 0xc0f0c080, 0xfc300000, 0x0f3f0f00, 0xc0f0c000, 0xfe300000, 0x0f3f0f0b, 0x0030fcfc},
    { 0x00200041, 0x00200000, 0x00200000, 0x00200100, 0x00200000, 0x00200000, 0x01200001, 0x00200004}
   , 0x1005,0.000000,attributes+0,1,NULL,autohelperpat652,3,0.016000},
  {pat653,8,8, "CB344c",0,-1,3,2,3,3,0x0,722,
    { 0x0030feff, 0xc0f0c080, 0xfc300000, 0x0f3f0f00, 0xc0f0c000, 0xfe300000, 0x0f3f0f0b, 0x0030fcfc},
    { 0x00200041, 0x00200000, 0x00200000, 0x00200100, 0x00200000, 0x00200000, 0x01200001, 0x00200004}
   , 0x1005,0.000000,attributes+0,1,NULL,autohelperpat653,3,0.016000},
  {pat654,8,8, "ED1",0,-1,2,2,2,3,0x2,722,
    { 0x003cffff, 0xc0f0f0c0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3c0000, 0x0f3f3f0f, 0x00f0fcfc},
    { 0x00281100, 0x00602040, 0x10a00000, 0x20240000, 0x20600000, 0x11280000, 0x00242004, 0x00a01000}
   , 0xc005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat655,25,8, "ED2",0,-1,4,4,4,5,0x2,797,
    { 0x00ffffff, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0x00fcfcfc},
    { 0x00110048, 0x00100010, 0x00100000, 0x02100100, 0x00100000, 0x00110000, 0x01100210, 0x00100084}
   , 0x4005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat656,11,8, "ED3",0,0,3,3,3,3,0x2,760,
    { 0x003c3f3f, 0x00f0f0c0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3c0000, 0x003f3f0f, 0x00f0f0f0},
    { 0x00200110, 0x00200040, 0x00200000, 0x00210000, 0x00200000, 0x01200000, 0x00210004, 0x00200010}
   , 0x8005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat657,29,8, "ED4",-1,-1,3,5,4,6,0x2,796,
    { 0x033fffff, 0xc0f0f0fc, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0300, 0x0f3f3fff, 0x00f0fcfc},
    { 0x00245000, 0x40601000, 0x14600000, 0x10240400, 0x10604000, 0x50240000, 0x04241000, 0x00601400}
   , 0x8005,0.000000,attributes+0,1,NULL,autohelperpat657,3,0.010000},
  {pat658,4,4, "ED6",0,-1,2,1,2,2,0x2,685,
    { 0x0030fc30, 0xc0f0c000, 0xfc300000, 0x0c3f0c00, 0xc0f0c000, 0xfc300000, 0x0c3f0c00, 0x0030fc30},
    { 0x00204400, 0x40204000, 0x44200000, 0x04200400, 0x40204000, 0x44200000, 0x04200400, 0x00204400}
   , 0x8005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat659,9,8, "ED7",0,-2,2,1,2,3,0xa,649,
    { 0x0030fcfc, 0xc0f0c000, 0xff300000, 0x0f3f0f0f, 0xc0f0c0c0, 0xfc300000, 0x0f3f0f00, 0x0030ffff},
    { 0x00109820, 0x80508000, 0x9a100000, 0x08160808, 0x80508080, 0x98100000, 0x08160800, 0x00109a20}
   , 0x4015,0.000000,attributes+0,1,NULL,autohelperpat659,0,1.000000},
  {pat660,9,8, "ED8",0,0,1,4,1,4,0x2,759,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x002a2000, 0x00a02020, 0x20a00000, 0x20280000, 0x20a00000, 0x202a0000, 0x00282020, 0x00a02000}
   , 0x4015,0.000000,attributes+0,1,NULL,autohelperpat660,3,1.000000},
  {pat661,8,8, "ED9",0,-2,2,1,2,3,0x2,685,
    { 0x0030fcfc, 0xc0f0c000, 0xff300000, 0x0f3f0f0f, 0xc0f0c0c0, 0xfc300000, 0x0f3f0f00, 0x0030ffff},
    { 0x00204400, 0x40204000, 0x45200000, 0x04200404, 0x40204040, 0x44200000, 0x04200400, 0x00204500}
   , 0x8005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat662,8,8, "ED10",0,-2,2,1,2,3,0x2,685,
    { 0x0030fcfc, 0xc0f0c000, 0xff300000, 0x0f3f0f0f, 0xc0f0c0c0, 0xfc300000, 0x0f3f0f00, 0x0030ffff},
    { 0x00108800, 0x80108000, 0x8a100000, 0x08100808, 0x80108080, 0x88100000, 0x08100800, 0x00108a00}
   , 0x4005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat663,27,8, "ED11",-2,-1,2,6,4,7,0x2,722,
    { 0xffffffff, 0xfdfdfdfd, 0xfcfcfc54, 0xffffff00, 0xfdfdfd00, 0xffffff55, 0xffffffff, 0xfcfcfcfc},
    { 0x00210200, 0x00200090, 0x00200000, 0x00200000, 0x00200000, 0x02210000, 0x00200018, 0x00200000}
   , 0x8215,0.000000,attributes+188,0,NULL,NULL,3,0.000000},
  {pat664,27,8, "ED12",0,-2,4,4,4,6,0x2,761,
    { 0x00fcffff, 0xf0f0f0c0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xfffc0000, 0x3f3f3f0f, 0x00ffffff},
    { 0x00100084, 0x00100000, 0x00100000, 0x01100200, 0x00100000, 0x00100000, 0x02100100, 0x00100048}
   , 0x9005,0.000000,attributes+190,2,NULL,autohelperpat664,0,0.000000},
  {pat665,22,8, "ED13",0,-1,4,4,4,5,0x2,761,
    { 0x00fcffff, 0xf0f0f0c0, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xfffc0000, 0x3f3f3f0f, 0x00fcfcfc},
    { 0x00100084, 0x00100000, 0x00100000, 0x01100200, 0x00100000, 0x00100000, 0x02100100, 0x00100048}
   , 0x5,0.000000,attributes+192,1,NULL,autohelperpat665,0,1.000000},
  {pat666,23,8, "ED14",0,-4,3,2,3,6,0x2,575,
    { 0x00fafefa, 0xf0f0e0a0, 0xffbf0000, 0x2e3f3f3f, 0xe0f0f0f0, 0xfefa0000, 0x3f3f2e2a, 0x00bfffbf},
    { 0x00100000, 0x00100000, 0x01100000, 0x00100006, 0x00100040, 0x00100000, 0x00100000, 0x00100102}
   , 0x8205,0.000000,attributes+194,0,NULL,NULL,0,0.000000},
  {pat667,10,8, "ED15",-1,-2,2,1,3,3,0x2,647,
    { 0x30fcfcfc, 0xf0fcf000, 0xffff3000, 0x3fff3f3f, 0xf0fcf0f0, 0xfcfc3000, 0x3fff3f00, 0x30ffffff},
    { 0x00241400, 0x00605000, 0x50600000, 0x14240000, 0x50600000, 0x14240000, 0x00241400, 0x00605000}
   , 0x8005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat668,10,8, "ED16",0,-1,2,2,2,3,0x2,686,
    { 0x00bcffff, 0xe0f0f0c0, 0xfcf80000, 0x3f3f2f00, 0xf0f0e000, 0xffbc0000, 0x2f3f3f0f, 0x00f8fcfc},
    { 0x00186200, 0x40902080, 0x24900000, 0x20180400, 0x20904000, 0x62180000, 0x04182008, 0x00902400}
   , 0x4005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat669,14,8, "ED17",0,-2,3,2,3,4,0x2,760,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f02, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfe},
    { 0x00156060, 0x40901010, 0x24500000, 0x101a0500, 0x10904000, 0x60150000, 0x051a1010, 0x00502424}
   , 0x4005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat670,18,8, "ED18",0,-1,3,3,3,4,0x2,759,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x00156862, 0x40909010, 0xa4500000, 0x181a0500, 0x90904000, 0x68150000, 0x051a1812, 0x0050a424}
   , 0x4005,0.000000,attributes+196,1,NULL,autohelperpat670,0,1.600000},
  {pat671,13,8, "ED19",0,-1,2,3,2,4,0x2,723,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x002a6000, 0x40a02020, 0x24a00000, 0x20280400, 0x20a04000, 0x602a0000, 0x04282020, 0x00a02400}
   , 0x4015,0.000000,attributes+0,1,NULL,autohelperpat671,3,1.600000},
  {pat672,6,4, "ED20",0,-1,2,1,2,2,0x2,685,
    { 0x0030fcfc, 0xc0f0c000, 0xfc300000, 0x0f3f0f00, 0xc0f0c000, 0xfc300000, 0x0f3f0f00, 0x0030fcfc},
    { 0x00108800, 0x80108000, 0x88100000, 0x08100800, 0x80108000, 0x88100000, 0x08100800, 0x00108800}
   , 0x4005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat673,11,8, "ED21",0,-1,2,2,2,3,0x2,759,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x00149820, 0x80509000, 0x98500000, 0x18160800, 0x90508000, 0x98140000, 0x08161800, 0x00509820}
   , 0x4005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat674,8,8, "ED22",0,-3,2,0,2,3,0x2,647,
    { 0x00f0f0c0, 0xf0f00000, 0x3f3c0000, 0x003c3f0f, 0x00f0f0c0, 0xf0f00000, 0x3f3c0000, 0x003c3f0f},
    { 0x00209080, 0x80600000, 0x18200000, 0x00240a00, 0x00608000, 0x90200000, 0x0a240000, 0x00201808}
   , 0x9005,0.000000,attributes+198,1,NULL,autohelperpat674,3,2.800000},
  {pat675,5,8, "ED22b",-1,-2,1,1,2,3,0x2,683,
    { 0x3cfcf000, 0xf0fc3c00, 0x3ffff000, 0xf0fc3c3c, 0x3cfcf0f0, 0xf0fc3c00, 0x3cfcf000, 0xf0ff3f00},
    { 0x00242000, 0x00a01000, 0x20600000, 0x10280000, 0x10a00000, 0x20240000, 0x00281000, 0x00602000}
   , 0x9005,0.000000,attributes+200,1,NULL,autohelperpat675,3,2.800000},
  {pat676,7,8, "ED23",0,-3,2,0,2,3,0x2,647,
    { 0x00f0c0c0, 0xf0300000, 0x0f3c0000, 0x00303f0f, 0x0030f0c0, 0xc0f00000, 0x3f300000, 0x003c0f0f},
    { 0x00108080, 0x80100000, 0x08100000, 0x00100a00, 0x00108000, 0x80100000, 0x0a100000, 0x00100808}
   , 0x9005,0.000000,attributes+202,1,NULL,autohelperpat676,0,1.000000},
  {pat677,9,8, "ED24",0,-3,2,0,2,3,0x2,647,
    { 0x00f0f050, 0xf0f00000, 0x3f3c0000, 0x003d3d0f, 0x00f0f0c0, 0xf0f00000, 0x3d3d0000, 0x003c3f17},
    { 0x0010a000, 0x80900000, 0x28100000, 0x00180800, 0x00908000, 0xa0100000, 0x08180000, 0x00102800}
   , 0x8005,0.000000,attributes+204,1,NULL,autohelperpat677,0,1.000000},
  {pat678,9,8, "ED25",0,0,2,3,2,3,0x2,722,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00210000, 0x00200010, 0x00200000, 0x00200000, 0x00200000, 0x00210000, 0x00200010, 0x00200000}
   , 0x8005,0.000000,attributes+0,1,NULL,autohelperpat678,3,1.000000},
  {pat679,19,8, "ED26",0,-1,3,4,3,5,0x2,759,
    { 0x00beffff, 0xe0f0f0e0, 0xfcf80000, 0x3f3f2f00, 0xf0f0e000, 0xffbe0000, 0x2f3f3f2f, 0x00f8fcfc},
    { 0x00146060, 0x40901000, 0x24500000, 0x101a0500, 0x10904000, 0x60140000, 0x051a1000, 0x00502424}
   , 0x4005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat680,15,8, "ED27",0,-1,2,3,2,4,0x2,758,
    { 0x00bfffff, 0xe0f0f0f0, 0xfcf80000, 0x3f3f2f00, 0xf0f0e000, 0xffbf0000, 0x2f3f3f3f, 0x00f8fcfc},
    { 0x00146628, 0x40905080, 0x64500000, 0x161a0400, 0x50904000, 0x66140000, 0x041a1608, 0x005064a0}
   , 0xc005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat681,23,8, "ED28",0,-1,4,3,4,4,0x2,723,
    { 0x003f3fff, 0x00f0f0f0, 0xf0f00000, 0x3f3f0300, 0xf0f00000, 0x3f3f0000, 0x033f3f3f, 0x00f0f0fc},
    { 0x00242400, 0x00a05000, 0x60600000, 0x14280000, 0x50a00000, 0x24240000, 0x00281400, 0x00606000}
   , 0x5005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat682,9,4, "ED29",0,0,2,2,2,2,0x2,723,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00192600, 0x00906090, 0x60900000, 0x24180000, 0x60900000, 0x26190000, 0x00182418, 0x00906000}
   , 0x4010,0.000000,attributes+0,1,NULL,autohelperpat682,0,0.517610},
  {pat683,11,8, "ED30",-1,-2,2,1,3,3,0xa,647,
    { 0x80f0fcfc, 0xf8f0c000, 0xff3f0b00, 0x0f3fbfff, 0xc0f0f8fc, 0xfcf08000, 0xbf3f0f00, 0x0b3fffff},
    { 0x00201400, 0x00604000, 0x50200000, 0x04240000, 0x40600000, 0x14200000, 0x00240400, 0x00205000}
   , 0x8005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat684,17,8, "ED31",0,-2,3,2,3,4,0x2,722,
    { 0x007effff, 0xd0f0f0e0, 0xfff50000, 0x3f3f1f1f, 0xf0f0d0d0, 0xff7e0000, 0x1f3f3f2f, 0x00f5ffff},
    { 0x00201000, 0x00600000, 0x10200000, 0x00240001, 0x00600000, 0x10200000, 0x00240000, 0x00201001}
   , 0xd005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat685,18,8, "ED31b",0,-3,3,1,3,4,0x2,648,
    { 0x0074fcfc, 0xd0f0d000, 0xff770000, 0x1f3f1f3f, 0xd0f0d0f0, 0xfc740000, 0x1f3f1f00, 0x0077ffff},
    { 0x00201000, 0x00600000, 0x10200000, 0x00240000, 0x00600000, 0x10200000, 0x00240000, 0x00201000}
   , 0x9005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat686,20,8, "ED31c",0,-2,3,3,3,5,0x2,721,
    { 0x00ffffff, 0xf0f0f0f0, 0xfefd0000, 0x3f3f3f1a, 0xf0f0f090, 0xffff0000, 0x3f3f3f3f, 0x00fdfefe},
    { 0x00201000, 0x00600000, 0x10200000, 0x00240000, 0x00600000, 0x10200000, 0x00240000, 0x00201000}
   , 0x9005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat687,19,8, "ED32",0,0,3,4,3,4,0x2,796,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00221800, 0x00608020, 0x90200000, 0x08240000, 0x80600000, 0x18220000, 0x00240820, 0x00209000}
   , 0x0,0.000000,attributes+206,1,NULL,autohelperpat687,3,0.010000},
  {pat688,24,8, "ED33",0,-1,4,4,4,5,0xa,798,
    { 0x0074ffff, 0xd0f0d0c0, 0xfc740000, 0x1f3f1f00, 0xd0f0d000, 0xff740000, 0x1f3f1f0f, 0x0074fcfc},
    { 0x00201a14, 0x00608080, 0x90200000, 0x09250000, 0x80600000, 0x1a200000, 0x00250908, 0x00209050}
   , 0x8005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat689,24,8, "ED34",0,-1,4,4,4,5,0xa,761,
    { 0x0074ffff, 0xd0f0d0c0, 0xfc740000, 0x1f3f1f00, 0xd0f0d000, 0xff740000, 0x1f3f1f0f, 0x0074fcfc},
    { 0x00201a16, 0x00608080, 0x90200000, 0x09250000, 0x80600000, 0x1a200000, 0x0025090a, 0x00209050}
   , 0x8005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat690,21,8, "ED35",0,-2,3,3,3,5,0xa,723,
    { 0x00fcffff, 0xf0f0f0c0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xfffc0000, 0x3f3f3f0f, 0x00ffffff},
    { 0x00285800, 0x4060a000, 0x94a00000, 0x28240400, 0xa0604000, 0x58280000, 0x04242800, 0x00a09400}
   , 0x8005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat691,11,8, "ED36",0,-1,2,3,2,4,0x2,760,
    { 0x003f3fff, 0x00f0f0f0, 0xf0f00000, 0x3f3f0300, 0xf0f00000, 0x3f3f0000, 0x033f3f3f, 0x00f0f0fc},
    { 0x00290220, 0x00202090, 0x00a00000, 0x20220000, 0x20200000, 0x02290000, 0x00222018, 0x00a00020}
   , 0x4005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat692,11,8, "ED37",0,0,2,4,2,4,0x2,760,
    { 0x00303f3f, 0x00f0c0c0, 0xf0300000, 0x0f3f0000, 0xc0f00000, 0x3f300000, 0x003f0f0f, 0x0030f0f0},
    { 0x00102220, 0x00900080, 0x20100000, 0x001a0000, 0x00900000, 0x22100000, 0x001a0008, 0x00102020}
   , 0x14,0.000000,attributes+0,3,NULL,autohelperpat692,0,0.021760},
  {pat693,13,8, "ED38",0,0,2,4,2,4,0x2,796,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00290200, 0x00202090, 0x00a00000, 0x20200000, 0x20200000, 0x02290000, 0x00202018, 0x00a00000}
   , 0x10,0.000000,attributes+0,3,NULL,autohelperpat693,3,1.600000},
  {pat694,5,8, "ED39",0,-1,1,2,1,3,0x2,722,
    { 0x003fff00, 0xc0f0f0f0, 0xfcf00000, 0x3c3c0c00, 0xf0f0c000, 0xff3f0000, 0x0c3c3c3c, 0x00f0fc00},
    { 0x00298200, 0x80202090, 0x08a00000, 0x20200800, 0x20208000, 0x82290000, 0x08202018, 0x00a00800}
   , 0x4014,0.000000,attributes+0,1,throw_in_atari_helper
,autohelperpat694,3,0.021760},
  {pat695,8,8, "ED40",0,0,2,2,2,2,0x2,722,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00192222, 0x00902090, 0x20900000, 0x201a0000, 0x20900000, 0x22190000, 0x001a201a, 0x00902020}
   , 0x4014,0.000000,attributes+0,1,throw_in_atari_helper
,autohelperpat695,0,0.019600},
  {pat696,4,8, "ED41",0,0,1,2,1,2,0xa,722,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00290200, 0x00202090, 0x00a00000, 0x20200000, 0x20200000, 0x02290000, 0x00202018, 0x00a00000}
   , 0x4014,0.000000,attributes+0,1,throw_in_atari_helper
,autohelperpat696,3,0.016000},
  {pat697,22,8, "ED42",0,-1,3,4,3,5,0x2,759,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x00285000, 0x40602000, 0x14a00000, 0x20240400, 0x20604000, 0x50280000, 0x04242000, 0x00a01400}
   , 0xd005,0.000000,attributes+0,3,NULL,autohelperpat697,3,0.610000},
  {pat698,21,8, "ED43",0,-1,3,4,3,5,0x2,722,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x0014a200, 0x80901080, 0x28500000, 0x10180800, 0x10908000, 0xa2140000, 0x08181008, 0x00502800}
   , 0xc005,0.000000,attributes+208,1,NULL,autohelperpat698,0,1.600000},
  {pat699,23,8, "ED44",0,0,4,4,4,4,0x2,796,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00101012, 0x00500000, 0x10100000, 0x00150000, 0x00500000, 0x10100000, 0x00150002, 0x00101010}
   , 0xd105,0.000000,attributes+210,0,NULL,NULL,0,0.000000},
  {pat700,20,8, "ED45",0,-1,3,4,3,5,0x2,796,
    { 0x003fff3f, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0c00, 0xf0f0c000, 0xff3f0000, 0x0c3f3f3f, 0x00f0fcf0},
    { 0x00285100, 0x40602040, 0x14a00000, 0x20240400, 0x20604000, 0x51280000, 0x04242004, 0x00a01400}
   , 0xd005,0.000000,attributes+0,1,NULL,autohelperpat700,3,1.000000},
  {pat701,25,8, "ED46",0,-1,5,3,5,4,0x2,723,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x00200040, 0x00200000, 0x00200000, 0x00200100, 0x00200000, 0x00200000, 0x01200000, 0x00200004}
   , 0xd005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat702,26,8, "ED47",0,0,3,6,3,6,0x2,833,
    { 0x003f1f0f, 0x0070f0f0, 0xd0f00000, 0x3f340000, 0xf0700000, 0x1f3f0000, 0x00343f3f, 0x00f0d0c0},
    { 0x0021090a, 0x00208050, 0x80200000, 0x0a200000, 0x80200000, 0x09210000, 0x00200a16, 0x00208080}
   , 0x9005,0.000000,attributes+212,0,NULL,NULL,3,0.000000},
  {pat703,13,8, "ED48",-1,-3,3,0,4,3,0x2,647,
    { 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff, 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f},
    { 0x00106080, 0x40900000, 0x26100000, 0x00180608, 0x00904080, 0x60100000, 0x06180000, 0x00102608}
   , 0xd005,0.000000,attributes+214,1,NULL,autohelperpat703,0,0.010000},
  {pat704,15,8, "ED49",-1,-2,3,2,4,4,0x2,685,
    { 0x3cffffff, 0xf0fcfcf0, 0xfffcf000, 0xffff3f0f, 0xfcfcf0c0, 0xffff3c00, 0x3fffff3f, 0xf0fcffff},
    { 0x00200400, 0x00204000, 0x40200000, 0x04200000, 0x40200000, 0x04200000, 0x00200400, 0x00204000}
   , 0xd005,0.000000,attributes+216,0,NULL,NULL,3,0.000000},
  {pat705,27,8, "ED49b",-1,-4,3,2,4,6,0x2,685,
    { 0xfcffffff, 0xfcfcfcf0, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xfffffc00, 0xffffff3f, 0xffffffff},
    { 0x00200400, 0x00204000, 0x40200000, 0x04200000, 0x40200000, 0x04200000, 0x00200400, 0x00204000}
   , 0x20005,0.000000,attributes+0,1,NULL,autohelperpat705,3,0.016000},
  {pat706,24,8, "ED50",-1,-3,4,1,5,4,0x2,647,
    { 0xfcf4fcfc, 0xfcfcdc00, 0xff7fff00, 0xdfffffff, 0xdcfcfcfc, 0xfcf4fc00, 0xffffdf00, 0xff7fffff},
    { 0x00204004, 0x40200000, 0x04200000, 0x01200400, 0x00204000, 0x40200000, 0x04200100, 0x00200440}
   , 0xd201,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat707,48,8, "ED51",-1,-7,4,1,5,8,0x2,647,
    { 0xfcf4fcfc, 0xfcfcdc00, 0xff7fff00, 0xdfffffff, 0xdcfcfcfc, 0xfcf4fc00, 0xffffdf00, 0xff7fffff},
    { 0x00204004, 0x40200000, 0x04200000, 0x01200400, 0x00204000, 0x40200000, 0x04200100, 0x00200440}
   , 0xd005,0.000000,attributes+218,0,NULL,NULL,3,0.000000},
  {pat708,33,8, "ED52",-2,-2,4,3,6,5,0x2,685,
    { 0xffffffff, 0xffffffff, 0xfffffffc, 0xffffffff, 0xfffffffc, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00220004, 0x00200020, 0x00200000, 0x01200000, 0x00200000, 0x00220000, 0x00200120, 0x00200040}
   , 0xc005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat709,20,8, "ED53",0,-1,3,4,3,5,0x2,722,
    { 0x003fff3f, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0c00, 0xf0f0c000, 0xff3f0000, 0x0c3f3f3f, 0x00f0fcf0},
    { 0x0014a200, 0x80901080, 0x28500000, 0x10180800, 0x10908000, 0xa2140000, 0x08181008, 0x00502800}
   , 0xd205,0.000000,attributes+0,1,NULL,autohelperpat709,0,1.600000},
  {pat710,22,8, "ED54",0,-1,3,4,3,5,0x2,686,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x0014a608, 0x80905080, 0x68500000, 0x16180800, 0x50908000, 0xa6140000, 0x08181608, 0x00506880}
   , 0xc215,0.000000,attributes+0,1,NULL,autohelperpat710,0,1.600000},
  {pat711,22,8, "ED55",0,-1,3,4,3,5,0x2,760,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x0014a698, 0x80905080, 0x68500000, 0x16190a00, 0x50908000, 0xa6140000, 0x0a191608, 0x00506898}
   , 0xc200,0.000000,attributes+0,1,NULL,autohelperpat711,0,1.000000},
  {pat712,19,8, "ED56",0,-3,3,2,3,5,0x2,722,
    { 0x00fcffff, 0xf0f0f0c0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xfffc0000, 0x3f3f3f0f, 0x00ffffff},
    { 0x00201000, 0x00600000, 0x10200000, 0x00240000, 0x00600000, 0x10200000, 0x00240000, 0x00201000}
   , 0xc085,0.000000,attributes+220,0,NULL,NULL,3,0.000000},
  {pat713,21,8, "ED57",0,0,3,5,3,5,0x2,797,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00160901, 0x00109060, 0x80500000, 0x18100000, 0x90100000, 0x09160000, 0x00101825, 0x00508000}
   , 0x0,0.000000,attributes+222,1,NULL,autohelperpat713,0,1.000000},
  {pat714,14,8, "ED58",0,-2,3,2,3,4,0x2,649,
    { 0x0030fcff, 0xc0f0c000, 0xfc300000, 0x0f3f0f03, 0xc0f0c000, 0xfc300000, 0x0f3f0f03, 0x0030fcff},
    { 0x00206418, 0x40a04000, 0x64200000, 0x06290400, 0x40a04000, 0x64200000, 0x04290600, 0x00206490}
   , 0xc280,0.000000,attributes+0,3,NULL,autohelperpat714,3,0.970000},
  {pat715,14,8, "ED59",0,-2,3,2,3,4,0x2,760,
    { 0x0030fcff, 0xc0f0c000, 0xfc300000, 0x0f3f0f03, 0xc0f0c000, 0xfc300000, 0x0f3f0f03, 0x0030fcff},
    { 0x00206418, 0x40a04000, 0x64200000, 0x06290400, 0x40a04000, 0x64200000, 0x04290600, 0x00206490}
   , 0xc004,0.000000,attributes+0,3,NULL,autohelperpat715,3,0.970000},
  {pat716,16,8, "ED61",-1,-2,3,2,4,4,0x2,723,
    { 0x30fcffff, 0xf0fcf0c0, 0xfffc3000, 0x3fff3f0f, 0xf0fcf0c0, 0xfffc3000, 0x3fff3f0f, 0x30fcffff},
    { 0x00106620, 0x40904080, 0x64100000, 0x041a0400, 0x40904000, 0x66100000, 0x041a0408, 0x00106420}
   , 0x20000,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat717,21,8, "ED62",-1,0,3,4,4,4,0x2,796,
    { 0x3f3f3f3f, 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff, 0xf0f0f0f0},
    { 0x00142902, 0x00909040, 0xa0500000, 0x18180000, 0x90900000, 0x29140000, 0x00181806, 0x0050a000}
   , 0xd005,0.000000,attributes+224,1,NULL,autohelperpat717,0,1.000000},
  {pat718,12,8, "ED63",0,-1,2,2,2,3,0x2,686,
    { 0x00bdffff, 0xe0f0f0d0, 0xfcf80000, 0x3f3f2f00, 0xf0f0e000, 0xffbd0000, 0x2f3f3f1f, 0x00f8fcfc},
    { 0x00186600, 0x40906080, 0x64900000, 0x24180400, 0x60904000, 0x66180000, 0x04182408, 0x00906400}
   , 0xc000,0.000000,attributes+226,2,NULL,autohelperpat718,0,0.000000},
  {pat719,20,8, "ED64",-1,-1,3,3,4,4,0x2,721,
    { 0xffffffff, 0xfcfcfcfc, 0xfcfcfc00, 0xffffff00, 0xfcfcfc00, 0xffffff00, 0xffffffff, 0xfcfcfcfc},
    { 0x0010a400, 0x80904000, 0x68100000, 0x04180800, 0x40908000, 0xa4100000, 0x08180400, 0x00106800}
   , 0xd005,0.000000,attributes+228,2,NULL,autohelperpat719,0,0.000000},
  {pat720,18,8, "ED65",-1,-1,3,3,4,4,0x2,759,
    { 0x2f3fff1f, 0xc0f8fcfc, 0xfcf0e000, 0xffbd0c00, 0xfcf8c000, 0xff3f2f00, 0x0cbdffff, 0xe0f0fcd0},
    { 0x0010a408, 0x80904000, 0x68100000, 0x06180800, 0x40908000, 0xa4100000, 0x08180600, 0x00106880}
   , 0xc005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat721,16,8, "ED68",0,-1,3,3,3,4,0x2,721,
    { 0x003fbfff, 0x80f0f0f0, 0xf8f00000, 0x3f3f0b00, 0xf0f08000, 0xbf3f0000, 0x0b3f3f3f, 0x00f0f8fc},
    { 0x00120100, 0x00100060, 0x00100000, 0x00100000, 0x00100000, 0x01120000, 0x00100024, 0x00100000}
   , 0x9005,0.000000,attributes+0,1,NULL,autohelperpat721,0,1.000000},
  {pat722,13,8, "ED69",0,0,3,3,3,3,0x2,722,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0xc080,0.000000,attributes+230,1,NULL,autohelperpat722,0,1.600000},
  {pat723,5,8, "ED70",0,0,1,2,1,2,0x0,721,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00121800, 0x00508020, 0x90100000, 0x08140000, 0x80500000, 0x18120000, 0x00140820, 0x00109000}
   , 0x1005,0.000000,attributes+232,1,NULL,autohelperpat723,0,1.574800},
  {pat724,11,8, "ED71",0,0,2,3,2,3,0x2,721,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00101900, 0x00508040, 0x90100000, 0x08140000, 0x80500000, 0x19100000, 0x00140804, 0x00109000}
   , 0xc080,0.000000,attributes+234,2,NULL,autohelperpat724,0,0.000000},
  {pat725,11,8, "ED72",0,-1,2,3,2,4,0x2,759,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x00190400, 0x00106010, 0x40900000, 0x24100000, 0x60100000, 0x04190000, 0x00102410, 0x00904000}
   , 0x8004,0.000000,attributes+236,1,NULL,autohelperpat725,0,1.000000},
  {pat726,13,8, "ED73",0,-1,2,4,2,5,0x2,833,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x00190400, 0x00106010, 0x40900000, 0x24100000, 0x60100000, 0x04190000, 0x00102410, 0x00904000}
   , 0x0,0.000000,attributes+238,1,NULL,autohelperpat726,0,1.000000},
  {pat727,8,8, "ED74",0,0,2,2,2,2,0x2,721,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00102600, 0x00904080, 0x60100000, 0x04180000, 0x40900000, 0x26100000, 0x00180408, 0x00106000}
   , 0x8000,0.000000,attributes+240,1,NULL,autohelperpat727,0,1.600000},
  {pat728,8,8, "ED75",0,0,2,2,2,2,0x2,723,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00102600, 0x00904080, 0x60100000, 0x04180000, 0x40900000, 0x26100000, 0x00180408, 0x00106000}
   , 0x0,0.000000,attributes+242,1,NULL,autohelperpat728,0,1.000000},
  {pat729,14,8, "ED76",0,-1,3,4,3,5,0x2,723,
    { 0x00b8bfbf, 0xa0f0e0c0, 0xf8b80000, 0x2f3f2a00, 0xe0f0a000, 0xbfb80000, 0x2a3f2f0f, 0x00b8f8f8},
    { 0x00100200, 0x00100080, 0x00100000, 0x00100000, 0x00100000, 0x02100000, 0x00100008, 0x00100000}
   , 0x1005,0.000000,attributes+244,1,NULL,autohelperpat729,0,3.009600},
  {pat730,13,8, "ED77",0,-1,3,2,3,3,0x2,685,
    { 0x003cffff, 0xc0f0f0c0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3c0000, 0x0f3f3f0f, 0x00f0fcfc},
    { 0x00284400, 0x40206000, 0x44a00000, 0x24200400, 0x60204000, 0x44280000, 0x04202400, 0x00a04400}
   , 0xd005,0.000000,attributes+246,1,NULL,autohelperpat730,3,3.000000},
  {pat731,13,8, "ED78",0,-1,3,2,3,3,0x2,685,
    { 0x003cffff, 0xc0f0f0c0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3c0000, 0x0f3f3f0f, 0x00f0fcfc},
    { 0x00148800, 0x80109000, 0x88500000, 0x18100800, 0x90108000, 0x88140000, 0x08101800, 0x00508800}
   , 0xd005,0.000000,attributes+248,1,NULL,autohelperpat731,0,3.000000},
  {pat732,9,8, "ED79",0,-1,2,2,2,3,0x2,723,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x001a0601, 0x001060a0, 0x40900000, 0x24100000, 0x60100000, 0x061a0000, 0x00102429, 0x00904000}
   , 0x4,0.000000,attributes+250,1,NULL,autohelperpat732,0,1.600000},
  {pat733,11,8, "ED80",-1,-2,2,1,3,3,0x2,722,
    { 0x40f8fcfc, 0xf4f0e000, 0xffbd0400, 0x2f3f7f1f, 0xe0f0f4d0, 0xfcf84000, 0x7f3f2f00, 0x04bdffff},
    { 0x00106000, 0x40900000, 0x26100000, 0x00180408, 0x00904080, 0x60100000, 0x04180000, 0x00102600}
   , 0x8000,0.000000,attributes+0,2,NULL,autohelperpat733,0,0.000000},
  {pat734,21,8, "ED81",-1,-3,3,2,4,5,0x2,685,
    { 0xc0ffffff, 0xfcf0f0f0, 0xffff0c00, 0x3f3fff3f, 0xf0f0fcf0, 0xffffc000, 0xff3f3f3f, 0x0cffffff},
    { 0x00100a06, 0x00108080, 0x80100000, 0x09100000, 0x80100000, 0x0a100000, 0x0010090a, 0x00108040}
   , 0x0,0.000000,attributes+0,3,NULL,autohelperpat734,0,1.000000},
  {pat735,19,8, "ED82",-3,-2,1,2,4,4,0x8,682,
    { 0xfffffc00, 0xffffff3f, 0xffffffff, 0xfcfcfcfc, 0xffffffff, 0xfcffffff, 0xfcfcfcf0, 0xffffff00},
    { 0x00251800, 0x00609010, 0x90600000, 0x18240000, 0x90600000, 0x18250000, 0x00241810, 0x00609000}
   , 0x0,0.000000,attributes+252,1,NULL,autohelperpat735,3,0.010000},
  {pat736,14,8, "ED83",0,-1,3,2,3,3,0x8,686,
    { 0x007cfffd, 0xd0f0f0c0, 0xfcf40000, 0x3f3f1f00, 0xf0f0d000, 0xff7c0000, 0x1f3f3f0d, 0x00f4fcfc},
    { 0x00289600, 0x80606080, 0x58a00000, 0x24240800, 0x60608000, 0x96280000, 0x08242408, 0x00a05800}
   , 0x9000,0.000000,attributes+254,2,NULL,autohelperpat736,3,0.000000},
  {pat737,20,8, "ED84",0,-1,4,2,4,3,0x8,687,
    { 0x007dffff, 0xd0f0f0d0, 0xfcf40000, 0x3f3f1f00, 0xf0f0d000, 0xff7d0000, 0x1f3f3f1f, 0x00f4fcfc},
    { 0x00289606, 0x80606080, 0x58a00000, 0x25240800, 0x60608000, 0x96280000, 0x0824250a, 0x00a05840}
   , 0x8005,0.000000,attributes+256,2,NULL,autohelperpat737,3,0.000000},
  {pat738,22,8, "ED85",-1,-2,3,3,4,5,0xa,685,
    { 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xffffffff},
    { 0x00210000, 0x00200010, 0x00200000, 0x00200000, 0x00200000, 0x00210000, 0x00200010, 0x00200000}
   , 0x8004,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat739,31,8, "ED86",0,-4,5,1,5,5,0xa,613,
    { 0x00fcfcfc, 0xf0f0f000, 0xfffd0000, 0x3f3f3f1f, 0xf0f0f0d0, 0xfcfc0000, 0x3f3f3f00, 0x00fdffff},
    { 0x00100010, 0x00100000, 0x00100000, 0x00110002, 0x00100000, 0x00100000, 0x00110000, 0x00100012}
   , 0x8004,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat740,16,8, "ED87",0,-2,3,2,3,4,0x2,722,
    { 0x00b8ffff, 0xe0f0e0c0, 0xffba0000, 0x2f3f2f2f, 0xe0f0e0e0, 0xffb80000, 0x2f3f2f0f, 0x00baffff},
    { 0x00100206, 0x00100080, 0x00100000, 0x01100000, 0x00100000, 0x02100000, 0x0010010a, 0x00100040}
   , 0x0,0.000000,attributes+258,2,NULL,autohelperpat740,0,0.000000},
  {pat741,16,8, "ED87a",0,-2,3,2,3,4,0x2,685,
    { 0x00bcffff, 0xe0f0f0c0, 0xfffa0000, 0x3f3f2f2f, 0xf0f0e0e0, 0xffbc0000, 0x2f3f3f0f, 0x00faffff},
    { 0x00180206, 0x00102080, 0x00900000, 0x21100000, 0x20100000, 0x02180000, 0x0010210a, 0x00900040}
   , 0x0,0.000000,attributes+260,2,NULL,autohelperpat741,0,0.000000},
  {pat742,30,8, "ED88",0,-5,4,1,4,6,0x2,648,
    { 0x00f0fcfc, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0x003fffff},
    { 0x00201804, 0x00608000, 0x90200000, 0x09240000, 0x80600000, 0x18200000, 0x00240900, 0x00209040}
   , 0x0,0.000000,attributes+262,3,NULL,autohelperpat742,3,0.010000},
  {pat743,16,8, "ED89",0,-2,2,4,2,6,0x2,723,
    { 0x0037ffff, 0xc0f0d0f0, 0xff700000, 0x1f3f0f0f, 0xd0f0c0c0, 0xff370000, 0x0f3f1f3f, 0x0070ffff},
    { 0x00212491, 0x00a04010, 0x60200000, 0x04290200, 0x40a00000, 0x24210000, 0x02290411, 0x00206018}
   , 0x0,0.000000,attributes+0,3,NULL,autohelperpat743,3,0.010000},
  {pat744,20,8, "ED90",-1,-3,3,3,4,6,0x2,722,
    { 0x3e3effff, 0xc0fcfce8, 0xfff0f000, 0xffff0f0f, 0xfcfcc0c0, 0xff3e3e00, 0x0fffffaf, 0xf0f0ffff},
    { 0x00200000, 0x00200000, 0x01200000, 0x00200005, 0x00200040, 0x00200000, 0x00200000, 0x00200101}
   , 0x48000,0.000000,attributes+0,3,NULL,autohelperpat744,3,1.600000},
  {pat745,20,8, "ED91",0,-2,3,3,3,5,0x2,759,
    { 0x003effff, 0xc0f0f0e0, 0xfff00000, 0x3f3f0f0f, 0xf0f0c0c0, 0xff3e0000, 0x0f3f3f2f, 0x00f0ffff},
    { 0x00280400, 0x00206000, 0x41a00000, 0x24200005, 0x60200040, 0x04280000, 0x00202400, 0x00a04101}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat745,3,10.000000},
  {pat746,18,8, "ED92",0,-1,3,4,3,5,0x2,760,
    { 0x00bdffff, 0xe0f0f0d0, 0xfcf80000, 0x3f3f2f00, 0xf0f0e000, 0xffbd0000, 0x2f3f3f1f, 0x00f8fcfc},
    { 0x00180600, 0x00106080, 0x40900000, 0x24100000, 0x60100000, 0x06180000, 0x00102408, 0x00904000}
   , 0x0,0.000000,attributes+264,1,NULL,autohelperpat746,0,0.010000},
  {pat747,29,8, "ED93",0,-5,4,1,4,6,0x2,612,
    { 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3f},
    { 0x00200090, 0x00200000, 0x00200000, 0x00210200, 0x00200000, 0x00200000, 0x02210000, 0x00200018}
   , 0x9001,0.000000,attributes+0,2,NULL,autohelperpat747,3,0.000000},
  {pat748,12,8, "ED94",0,-3,2,1,2,4,0x2,611,
    { 0x00f0fcfc, 0xf0f0c000, 0xff3e0000, 0x0f3f3f2f, 0xc0f0f0e0, 0xfcf00000, 0x3f3f0f00, 0x003effff},
    { 0x00101868, 0x00508000, 0x90100000, 0x0a160100, 0x80500000, 0x18100000, 0x01160a00, 0x001090a4}
   , 0x8004,0.000000,attributes+0,1,NULL,autohelperpat748,0,1.600000},
  {pat749,17,8, "ED95",-1,-1,3,3,4,4,0x2,722,
    { 0xfdffffff, 0xfcfcfcf4, 0xfcfcfc00, 0xffffff00, 0xfcfcfc00, 0xfffffd00, 0xffffff7f, 0xfcfcfcfc},
    { 0x00120000, 0x00100020, 0x00100000, 0x00100000, 0x00100000, 0x00120000, 0x00100020, 0x00100000}
   , 0x5005,0.000000,attributes+0,1,NULL,autohelperpat749,0,0.010000},
  {pat750,15,8, "ED96",-1,0,2,4,3,4,0x2,721,
    { 0x0f3f3f3f, 0x00f0fcfc, 0xf0f0c000, 0xff3f0000, 0xfcf00000, 0x3f3f0f00, 0x003fffff, 0xc0f0f0f0},
    { 0x00100100, 0x00100040, 0x00100000, 0x00100000, 0x00100000, 0x01100000, 0x00100004, 0x00100000}
   , 0x1005,0.000000,attributes+0,3,NULL,autohelperpat750,0,10.000000},
  {pat751,32,8, "ED97",-1,-3,3,4,4,7,0x2,758,
    { 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xffffffff},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0xd005,0.000000,attributes+0,1,NULL,autohelperpat751,0,0.019600},
  {pat752,21,8, "ED98",-1,0,3,4,4,4,0x2,758,
    { 0x3f3f3f3f, 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff, 0xf0f0f0f0},
    { 0x00101000, 0x00500000, 0x10100000, 0x00140000, 0x00500000, 0x10100000, 0x00140000, 0x00101000}
   , 0x9005,0.000000,attributes+0,1,NULL,autohelperpat752,0,0.016000},
  {pat753,16,8, "ED99a",0,-2,3,2,3,4,0xa,650,
    { 0x00fcffff, 0xf0f0f0c0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xfffc0000, 0x3f3f3f0f, 0x00ffffff},
    { 0x00202491, 0x00a04000, 0x60200000, 0x04290200, 0x40a00000, 0x24200000, 0x02290401, 0x00206018}
   , 0x8005,0.000000,attributes+266,1,NULL,autohelperpat753,3,0.010000},
  {pat754,21,8, "ED100",-1,0,3,4,4,4,0x2,760,
    { 0x3f3f3f3f, 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff, 0xf0f0f0f0},
    { 0x00210900, 0x00208050, 0x80200000, 0x08200000, 0x80200000, 0x09210000, 0x00200814, 0x00208000}
   , 0x5005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat755,4,8, "ED101",-1,-1,1,1,2,2,0xa,685,
    { 0xa0f0fc00, 0xf8f8c000, 0xfc3c2800, 0x0cbcbc00, 0xc0f8f800, 0xfcf0a000, 0xbcbc0c00, 0x283cfc00},
    { 0x00100800, 0x00108000, 0x80100000, 0x08100000, 0x80100000, 0x08100000, 0x00100800, 0x00108000}
   , 0x8004,0.000000,attributes+0,1,NULL,autohelperpat755,0,0.010000},
  {pat756,10,8, "CD1",-1,0,1,3,2,3,0x0,758,
    { 0x053f3f00, 0x00f0f4f4, 0xf0f04000, 0x7c3c0000, 0xf4f00000, 0x3f3f0500, 0x003c7c7c, 0x40f0f000},
    { 0x00242800, 0x00a09000, 0xa0600000, 0x18280000, 0x90a00000, 0x28240000, 0x00281800, 0x0060a000}
   , 0x8025,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat757,4,8, "CD3",-2,-1,1,1,3,2,0x0,683,
    { 0xfcfcf000, 0xfcfc3c00, 0x3cfcfc00, 0xf0fcfc00, 0x3cfcfc00, 0xf0fcfc00, 0xfcfcf000, 0xfcfc3c00},
    { 0x00249000, 0x80601000, 0x18600000, 0x10240800, 0x10608000, 0x90240000, 0x08241000, 0x00601800}
   , 0x4,0.000000,attributes+268,1,NULL,autohelperpat757,3,1.000000},
  {pat758,6,4, "CD7",0,-1,2,1,2,2,0x0,686,
    { 0x0030fcfc, 0xc0f0c000, 0xfc300000, 0x0f3f0f00, 0xc0f0c000, 0xfc300000, 0x0f3f0f00, 0x0030fcfc},
    { 0x00208800, 0x80208000, 0x88200000, 0x08200800, 0x80208000, 0x88200000, 0x08200800, 0x00208800}
   , 0x4004,0.000000,attributes+0,1,NULL,autohelperpat758,3,0.019600},
  {pat759,18,8, "CD28",0,-1,4,2,4,3,0x0,723,
    { 0x007cffff, 0xd0f0f0c0, 0xfcf40000, 0x3f3f1f00, 0xf0f0d000, 0xff7c0000, 0x1f3f3f0f, 0x00f4fcfc},
    { 0x00249810, 0x80609000, 0x98600000, 0x18250800, 0x90608000, 0x98240000, 0x08251800, 0x00609810}
   , 0xc000,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat760,7,8, "CD31",0,-2,3,1,3,3,0x0,648,
    { 0x00f0fcf0, 0xf0f0c000, 0xff3c0000, 0x0c3f3f0f, 0xc0f0f0c0, 0xfcf00000, 0x3f3f0c00, 0x003cff3f},
    { 0x00200820, 0x00208000, 0x80200000, 0x08220002, 0x80200000, 0x08200000, 0x00220800, 0x00208022}
   , 0x4004,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat761,13,8, "CD39",0,-1,4,2,4,3,0x0,760,
    { 0x0038fff3, 0xc0f0e0c0, 0xfcb00000, 0x2c3f0f00, 0xe0f0c000, 0xff380000, 0x0f3f2c0f, 0x00b0fc3c},
    { 0x00106260, 0x40900080, 0x24100000, 0x001a0500, 0x00904000, 0x62100000, 0x051a0008, 0x00102424}
   , 0x4005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat762,9,8, "CD40",0,-1,3,2,3,3,0x0,685,
    { 0x0030ffff, 0xc0f0c0c0, 0xfc300000, 0x0f3f0f00, 0xc0f0c000, 0xff300000, 0x0f3f0f0f, 0x0030fcfc},
    { 0x00200060, 0x00200000, 0x00200000, 0x00220100, 0x00200000, 0x00200000, 0x01220000, 0x00200024}
   , 0x4,0.000000,attributes+0,3,NULL,autohelperpat762,3,1.690000},
  {pat763,6,8, "CD43",0,-1,2,2,2,3,0x0,685,
    { 0x00fffffc, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xffff0000, 0x3f3f3f3c, 0x00fcfcfc},
    { 0x00220284, 0x002000a0, 0x00200000, 0x01200200, 0x00200000, 0x02220000, 0x02200128, 0x00200048}
   , 0x4005,0.000000,attributes+0,1,NULL,autohelperpat763,3,1.600000},
  {pat764,20,8, "CD48",0,-2,4,2,4,4,0x0,723,
    { 0x0070ffff, 0xd0f0c0c0, 0xff340000, 0x0f3f1f0f, 0xc0f0d0c0, 0xff700000, 0x1f3f0f0f, 0x0034ffff},
    { 0x00202110, 0x00a00040, 0x20200000, 0x00290001, 0x00a00000, 0x21200000, 0x00290004, 0x00202011}
   , 0x9005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat765,20,8, "CD49",0,-1,4,3,4,4,0x0,760,
    { 0x0034ffff, 0xc0f0d0c0, 0xfc700000, 0x1f3f0f00, 0xd0f0c000, 0xff340000, 0x0f3f1f0f, 0x0070fcfc},
    { 0x00200844, 0x00208000, 0x80200000, 0x09200100, 0x80200000, 0x08200000, 0x01200900, 0x00208044}
   , 0x9005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat766,11,4, "CD55",-1,0,2,3,3,3,0x0,722,
    { 0x0f3f2f3b, 0x00b0fcfc, 0xe0f0c000, 0xfe3b0000, 0xfcb00000, 0x2f3f0f00, 0x003bfeff, 0xc0f0e0b0},
    { 0x00220012, 0x00200020, 0x00200000, 0x00210000, 0x00200000, 0x00220000, 0x00210022, 0x00200010}
   , 0x4005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat767,11,8, "CD56",-1,0,2,3,3,3,0x0,722,
    { 0x3f3f3f3f, 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff, 0xf0f0f0f0},
    { 0x00220012, 0x00200020, 0x00200000, 0x00210000, 0x00200000, 0x00220000, 0x00210022, 0x00200010}
   , 0xc005,0.000000,attributes+0,1,NULL,autohelperpat767,3,2.176000},
  {pat768,8,8, "CD64",0,-1,2,2,2,3,0x0,722,
    { 0x003fff3f, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0c00, 0xf0f0c000, 0xff3f0000, 0x0c3f3f3f, 0x00f0fcf0},
    { 0x00298229, 0x80202090, 0x08a00000, 0x22220800, 0x20208000, 0x82290000, 0x08222219, 0x00a008a0}
   , 0x4014,0.000000,attributes+0,1,throw_in_atari_helper
,autohelperpat768,3,0.021760},
  {pat769,9,4, "CD67",0,-2,3,1,3,3,0x0,686,
    { 0x0030fcfc, 0xc0f0c000, 0xfc300000, 0x0f3f0f03, 0xc0f0c000, 0xfc300000, 0x0f3f0f00, 0x0030fcff},
    { 0x00204000, 0x40200000, 0x04200000, 0x00200402, 0x00204000, 0x40200000, 0x04200000, 0x00200402}
   , 0x8005,0.000000,attributes+0,1,NULL,autohelperpat769,3,0.010000},
  {pat770,8,8, "CD76",0,0,2,2,2,2,0x0,759,
    { 0x003e3f0e, 0x00f0f0e0, 0xf0f00000, 0x3f3c0000, 0xf0f00000, 0x3f3e0000, 0x003c3f2e, 0x00f0f0c0},
    { 0x00241800, 0x00609000, 0x90600000, 0x18240000, 0x90600000, 0x18240000, 0x00241800, 0x00609000}
   , 0x4,0.000000,attributes+0,3,NULL,autohelperpat770,3,1.960000},
  {pat771,9,8, "CD77",-1,0,2,2,3,2,0x0,721,
    { 0x0a3e3f0e, 0x00f0f8e8, 0xf0f08000, 0xbf3c0000, 0xf8f00000, 0x3f3e0a00, 0x003cbfae, 0x80f0f0c0},
    { 0x00201900, 0x00608040, 0x90200000, 0x08240000, 0x80600000, 0x19200000, 0x00240804, 0x00209000}
   , 0x4,0.000000,attributes+0,3,NULL,autohelperpat771,3,1.603600},
  {pat772,22,8, "CD79",0,-1,4,3,4,4,0x0,686,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x001a0400, 0x00106020, 0x40900000, 0x24100000, 0x60100000, 0x041a0000, 0x00102420, 0x00904000}
   , 0x9005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat773,17,8, "CD82",-2,0,2,4,4,4,0x0,721,
    { 0x053f3f0c, 0x00f0f5f5, 0xf0f04040, 0x7f3c0000, 0xf5f00000, 0x3f3f0505, 0x003c7f7c, 0x40f0f0c0},
    { 0x00101904, 0x00508040, 0x90100000, 0x09140000, 0x80500000, 0x19100000, 0x00140904, 0x00109040}
   , 0x1,0.000000,attributes+270,1,NULL,autohelperpat773,0,0.016000},
  {pat774,11,8, "CD83",0,-1,3,3,3,4,0x0,686,
    { 0x003fff3f, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0c00, 0xf0f0c000, 0xff3f0000, 0x0c3f3f3f, 0x00f0fcf0},
    { 0x00168200, 0x801010a0, 0x08500000, 0x10100800, 0x10108000, 0x82160000, 0x08101028, 0x00500800}
   , 0x9005,0.000000,attributes+0,1,NULL,autohelperpat774,0,0.610000},
  {pat775,5,4, "CD87",0,-1,2,1,2,2,0x0,685,
    { 0x00fcfcfc, 0xf0f0f000, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xfcfc0000, 0x3f3f3f00, 0x00fcfcfc},
    { 0x00240024, 0x00201000, 0x00600000, 0x11220000, 0x10200000, 0x00240000, 0x00221100, 0x00600060}
   , 0xc005,0.000000,attributes+272,1,NULL,autohelperpat775,3,1.960000},
  {pat776,6,8, "CD88",0,0,1,3,1,3,0x0,721,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00201000, 0x00600000, 0x10200000, 0x00240000, 0x00600000, 0x10200000, 0x00240000, 0x00201000}
   , 0xc105,0.000000,attributes+0,1,NULL,autohelperpat776,3,1.000000},
  {pat777,12,8, "CD89",0,-1,2,3,2,4,0x0,759,
    { 0x003eff3e, 0xc0f0f0e0, 0xfcf00000, 0x3f3f0c00, 0xf0f0c000, 0xff3e0000, 0x0c3f3f2e, 0x00f0fcf0},
    { 0x00182408, 0x00906000, 0x60900000, 0x26180000, 0x60900000, 0x24180000, 0x00182600, 0x00906080}
   , 0xd005,0.000000,attributes+274,1,NULL,autohelperpat777,0,0.610000},
  {pat778,8,8, "CD90",0,0,3,2,3,2,0x0,723,
    { 0x003d3f0f, 0x00f0f0d0, 0xf0f00000, 0x3f3c0000, 0xf0f00000, 0x3f3d0000, 0x003c3f1f, 0x00f0f0c0},
    { 0x00182600, 0x00906080, 0x60900000, 0x24180000, 0x60900000, 0x26180000, 0x00182408, 0x00906000}
   , 0xd005,0.000000,attributes+276,1,NULL,autohelperpat778,0,0.376000},
  {pat779,11,8, "CD91",0,-1,2,2,2,3,0x0,723,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x00245800, 0x40609000, 0x94600000, 0x18240400, 0x90604000, 0x58240000, 0x04241800, 0x00609400}
   , 0xa004,0.000000,attributes+278,1,NULL,autohelperpat779,3,0.970000},
  {pat780,6,8, "CD92",0,-1,2,1,2,2,0x0,722,
    { 0x00fcfcfc, 0xf0f0f000, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xfcfc0000, 0x3f3f3f00, 0x00fcfcfc},
    { 0x00209024, 0x80600000, 0x18200000, 0x01260800, 0x00608000, 0x90200000, 0x08260100, 0x00201860}
   , 0xc000,0.000000,attributes+280,1,NULL,autohelperpat780,3,1.000000},
  {pat781,6,8, "CD92a",0,-1,2,1,2,2,0x0,722,
    { 0x00fcfcf4, 0xf0f0f000, 0xfcfc0000, 0x3d3f3f00, 0xf0f0f000, 0xfcfc0000, 0x3f3f3d00, 0x00fcfc7c},
    { 0x00106010, 0x40900000, 0x24100000, 0x00190400, 0x00904000, 0x60100000, 0x04190000, 0x00102410}
   , 0xd005,0.000000,attributes+282,0,NULL,NULL,0,0.000000},
  {pat782,6,8, "CD92b",0,-1,2,1,2,2,0x0,722,
    { 0x00fcfcfc, 0xf0f0f000, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xfcfc0000, 0x3f3f3f00, 0x00fcfcfc},
    { 0x00106018, 0x40900000, 0x24100000, 0x02190400, 0x00904000, 0x60100000, 0x04190200, 0x00102490}
   , 0xd001,0.000000,attributes+284,1,NULL,autohelperpat782,0,3.000000},
  {pat783,12,8, "CD93",0,-1,3,2,3,3,0x0,685,
    { 0x003f3fff, 0x00f0f0f0, 0xf0f00000, 0x3f3f0300, 0xf0f00000, 0x3f3f0000, 0x033f3f3f, 0x00f0f0fc},
    { 0x00180088, 0x00102000, 0x00900000, 0x22100200, 0x20100000, 0x00180000, 0x02102200, 0x00900088}
   , 0xc204,0.000000,attributes+287,1,NULL,autohelperpat783,0,8.000000},
  {pat784,21,8, "CD94",-4,0,1,7,5,7,0x0,757,
    { 0x3f3f1f00, 0x007fffff, 0xd0f0f0f0, 0xfcf40000, 0xff7f0000, 0x1f3f3f3f, 0x00f4fcfc, 0xf0f0d000},
    { 0x00200100, 0x00200040, 0x00200000, 0x00200000, 0x00200000, 0x01200000, 0x00200004, 0x00200000}
   , 0xe005,0.000000,attributes+289,1,NULL,autohelperpat784,3,0.010000},
  {pat785,21,8, "CD94b",-4,0,1,7,5,7,0x0,757,
    { 0x3f3f3f00, 0x00ffffff, 0xf0f0f0f0, 0xfcfc0000, 0xffff0000, 0x3f3f3f3f, 0x00fcfcfc, 0xf0f0f000},
    { 0x00201100, 0x00600040, 0x10200000, 0x00240000, 0x00600000, 0x11200000, 0x00240004, 0x00201000}
   , 0xe005,0.000000,attributes+291,1,NULL,autohelperpat785,3,6.010000},
  {pat786,16,4, "CD95",0,-1,4,2,4,3,0x0,723,
    { 0x00bfffff, 0xe0f0f0f0, 0xfcf80000, 0x3f3f2f00, 0xf0f0e000, 0xffbf0000, 0x2f3f3f3f, 0x00f8fcfc},
    { 0x00100080, 0x00100000, 0x00100000, 0x00100200, 0x00100000, 0x00100000, 0x02100000, 0x00100008}
   , 0xe005,0.000000,attributes+293,0,NULL,NULL,0,0.000000},
  {pat787,7,8, "CD96",0,-1,3,1,3,2,0x0,686,
    { 0x00f0fcfc, 0xf0f0c000, 0xfc3c0000, 0x0f3f3f00, 0xc0f0f000, 0xfcf00000, 0x3f3f0f00, 0x003cfcfc},
    { 0x00100080, 0x00100000, 0x00100000, 0x00100200, 0x00100000, 0x00100000, 0x02100000, 0x00100008}
   , 0xc005,0.000000,attributes+295,1,NULL,autohelperpat787,0,1.000000},
  {pat788,3,8, "CD99",0,0,1,1,1,1,0x0,722,
    { 0x003c3c00, 0x00f0f000, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3c3c0000, 0x003c3c00, 0x00f0f000},
    { 0x00182000, 0x00902000, 0x20900000, 0x20180000, 0x20900000, 0x20180000, 0x00182000, 0x00902000}
   , 0x5,0.000000,attributes+297,1,NULL,autohelperpat788,0,1.603600},
  {pat789,6,8, "CD102",0,-1,2,1,2,2,0x0,647,
    { 0x00f0fcfc, 0xf0f0c000, 0xfc3c0000, 0x0f3f3f00, 0xc0f0f000, 0xfcf00000, 0x3f3f0f00, 0x003cfcfc},
    { 0x00204400, 0x40204000, 0x44200000, 0x04200400, 0x40204000, 0x44200000, 0x04200400, 0x00204400}
   , 0x5,0.000000,attributes+299,1,NULL,autohelperpat789,3,1.600000},
  {pat790,9,8, "CD104a",-2,0,1,2,3,2,0x0,720,
    { 0x3f3f3c00, 0x00ffff3f, 0xf0f0f0f0, 0xfcfc0000, 0xffff0000, 0x3c3f3f3f, 0x00fcfcf0, 0xf0f0f000},
    { 0x00182400, 0x00906000, 0x60900000, 0x24180000, 0x60900000, 0x24180000, 0x00182400, 0x00906000}
   , 0xa000,0.000000,attributes+0,1,NULL,autohelperpat790,0,0.592000},
  {pat791,9,8, "CD104b",-2,0,1,2,3,2,0x0,720,
    { 0x3f3f3c00, 0x00ffff3f, 0xf0f0f0f0, 0xfcfc0000, 0xffff0000, 0x3c3f3f3f, 0x00fcfcf0, 0xf0f0f000},
    { 0x00182400, 0x00906000, 0x60900000, 0x24180000, 0x60900000, 0x24180000, 0x00182400, 0x00906000}
   , 0x8000,0.000000,attributes+301,1,NULL,autohelperpat791,0,0.970000},
  {pat792,11,8, "CD105",0,-2,3,1,3,3,0x0,685,
    { 0x00f0fcfc, 0xf0f0c000, 0xff3c0000, 0x0f3f3f0d, 0xc0f0f0c0, 0xfcf00000, 0x3f3f0f00, 0x003cfffd},
    { 0x00200400, 0x00204000, 0x41200000, 0x04200004, 0x40200040, 0x04200000, 0x00200400, 0x00204100}
   , 0x80001,0.000000,attributes+0,1,NULL,autohelperpat792,3,0.019600},
  {pat793,9,8, "CD107",-1,-1,2,3,3,4,0x0,722,
    { 0x1c7fffff, 0xd0f4fcf0, 0xfcf4d000, 0xff7f1f00, 0xfcf4d000, 0xff7f1c00, 0x1f7fff3f, 0xd0f4fcfc},
    { 0x00200040, 0x00200000, 0x00200000, 0x00200100, 0x00200000, 0x00200000, 0x01200000, 0x00200004}
   , 0xd005,0.000000,attributes+0,1,NULL,autohelperpat793,3,0.610000},
  {pat794,10,8, "CD108",0,-2,2,2,2,4,0x0,722,
    { 0x007fffff, 0xd0f0f0f0, 0xfff40000, 0x3f3f1f0f, 0xf0f0d0c0, 0xff7f0000, 0x1f3f3f3f, 0x00f4ffff},
    { 0x00200040, 0x00200000, 0x01200000, 0x00200106, 0x00200040, 0x00200000, 0x01200000, 0x00200106}
   , 0x0,0.000000,attributes+303,0,NULL,NULL,3,0.000000},
  {pat795,6,4, "CD109",0,-1,2,1,2,2,0x0,685,
    { 0x00fcfcfc, 0xf0f0f000, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xfcfc0000, 0x3f3f3f00, 0x00fcfcfc},
    { 0x00180418, 0x00106000, 0x40900000, 0x26110000, 0x60100000, 0x04180000, 0x00112600, 0x00904090}
   , 0x4004,0.000000,attributes+305,1,NULL,autohelperpat795,0,0.365200},
  {pat796,15,8, "EJ1",-1,-1,2,3,3,4,0x2,721,
    { 0x3fbfbfff, 0xa0fcfcfc, 0xf8f8f000, 0xffff2b00, 0xfcfca000, 0xbfbf3f00, 0x2bffffff, 0xf0f8f8fc},
    { 0x00120900, 0x00108060, 0x80100000, 0x08100000, 0x80100000, 0x09120000, 0x00100824, 0x00108000}
   , 0x2a010,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat797,14,8, "EJ2",-1,-2,3,2,4,4,0x2,722,
    { 0xffffffff, 0xfcfcfcfc, 0xfcfdfc00, 0xffffff10, 0xfcfcfc10, 0xffffff00, 0xffffffff, 0xfcfdfcfc},
    { 0x00102000, 0x00900000, 0x20100000, 0x00180000, 0x00900000, 0x20100000, 0x00180000, 0x00102000}
   , 0x29001,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat798,18,8, "EJ2b",-1,-1,3,3,4,4,0x2,722,
    { 0xffffffff, 0xfcfcfcfc, 0xfcfcfc00, 0xffffff00, 0xfcfcfc00, 0xffffff00, 0xffffffff, 0xfcfcfcfc},
    { 0x00112200, 0x00900090, 0x20100000, 0x00180000, 0x00900000, 0x22110000, 0x00180018, 0x00102000}
   , 0x29000,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat799,18,8, "EJ3",-2,0,2,4,4,4,0x2,757,
    { 0x3f3f3f3f, 0x00fcffff, 0xf0f0f0c0, 0xffff0000, 0xfffc0000, 0x3f3f3f0f, 0x00ffffff, 0xf0f0f0f0},
    { 0x00120000, 0x00100020, 0x00100000, 0x00100000, 0x00100000, 0x00120000, 0x00100020, 0x00100000}
   , 0x2e000,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat800,15,8, "EJ4",-1,-1,2,4,3,5,0x2,757,
    { 0xffffffff, 0xfcfcfcfc, 0xfcfcfc00, 0xffffff00, 0xfcfcfc00, 0xffffff00, 0xffffffff, 0xfcfcfcfc},
    { 0x00160900, 0x00109060, 0x80500000, 0x18100000, 0x90100000, 0x09160000, 0x00101824, 0x00508000}
   , 0x4a000,0.000000,attributes+0,2,NULL,autohelperpat800,0,0.000000},
  {pat801,19,8, "EJ6",0,-3,3,2,3,5,0x2,722,
    { 0x00fcffff, 0xf0f0f0c0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xfffc0000, 0x3f3f3f0f, 0x00ffffff},
    { 0x00106088, 0x40900000, 0x25100000, 0x02180604, 0x00904040, 0x60100000, 0x06180200, 0x00102588}
   , 0x46000,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat802,30,8, "EJ7",-2,-1,2,7,4,8,0x2,870,
    { 0xffffffff, 0xfcfcfcfc, 0xfcfcfc00, 0xffffff00, 0xfcfcfc00, 0xffffff00, 0xffffffff, 0xfcfcfcfc},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x9000,0.000000,attributes+0,1,NULL,autohelperpat802,0,0.010000},
  {pat803,30,8, "EJ7b",-2,-1,2,7,4,8,0x2,833,
    { 0xffffffff, 0xfcfcfcfc, 0xfcfcfc00, 0xffffff00, 0xfcfcfc00, 0xffffff00, 0xffffffff, 0xfcfcfcfc},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x9000,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat804,36,8, "EJ8",0,-2,4,5,4,7,0x2,834,
    { 0x003fffff, 0xc0f0f0f0, 0xfff00000, 0x3f3f0f0f, 0xf0f0c0c0, 0xff3f0000, 0x0f3f3f3f, 0x00f0ffff},
    { 0x00202450, 0x00a04000, 0x62200000, 0x0429010a, 0x40a00080, 0x24200000, 0x01290400, 0x00206216}
   , 0x9000,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat805,16,8, "EJ9",-1,0,3,4,4,4,0x2,757,
    { 0x3f3f3f3f, 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff, 0xf0f0f0f0},
    { 0x00110200, 0x00100090, 0x00100000, 0x00100000, 0x00100000, 0x02110000, 0x00100018, 0x00100000}
   , 0xa000,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat806,30,8, "EJ12",-3,0,3,4,6,4,0x2,759,
    { 0x3f3f3f3f, 0x00fffefe, 0xf0f0f0b0, 0xffff0000, 0xfeff0000, 0x3f3f3f3a, 0x00ffffff, 0xf0f0f0f0},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x10000,0.000000,attributes+0,1,NULL,autohelperpat806,3,1.600000},
  {pat807,25,8, "EJ13",-3,0,2,4,5,4,0x2,758,
    { 0x3f3f3f3f, 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0xffff0000, 0x3f3f3f3f, 0x00ffffff, 0xf0f0f0f0},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x10000,0.000000,attributes+0,1,NULL,autohelperpat807,3,0.010000},
  {pat808,32,8, "EJ13b",-2,0,2,6,4,6,0x2,832,
    { 0x2f3f2f2f, 0x00baffff, 0xe0f0e0e0, 0xffba0000, 0xffba0000, 0x2f3f2f2f, 0x00baffff, 0xe0f0e0e0},
    { 0x00120000, 0x00100020, 0x00100000, 0x00100000, 0x00100000, 0x00120000, 0x00100020, 0x00100000}
   , 0x14000,0.000000,attributes+0,1,NULL,autohelperpat808,0,0.010000},
  {pat809,31,8, "EJ14",-3,0,2,5,5,5,0x2,758,
    { 0x3f3f3f3f, 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0xffff0000, 0x3f3f3f3f, 0x00ffffff, 0xf0f0f0f0},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x10000,0.000000,attributes+0,1,NULL,autohelperpat809,3,0.010000},
  {pat810,31,8, "EJ15",-3,-2,2,4,5,6,0x2,682,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x6000,0.000000,attributes+0,1,NULL,autohelperpat810,3,0.010000},
  {pat811,19,8, "EJ17",-1,-1,3,3,4,4,0x2,721,
    { 0xffffffff, 0xfcfcfcfc, 0xfcfcfc00, 0xffffff00, 0xfcfcfc00, 0xffffff00, 0xffffffff, 0xfcfcfcfc},
    { 0x00211800, 0x00608010, 0x90200000, 0x08240000, 0x80600000, 0x18210000, 0x00240810, 0x00209000}
   , 0x2c000,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat812,27,8, "EJ18",0,-2,3,4,3,6,0x2,686,
    { 0x00bfffff, 0xe0f0f0f0, 0xfef80000, 0x3f3f2f0a, 0xf0f0e080, 0xffbf0000, 0x2f3f3f3f, 0x00f8fefe},
    { 0x00296604, 0x40a06090, 0x64a00000, 0x25280400, 0x60a04000, 0x66290000, 0x04282518, 0x00a06440}
   , 0x9000,0.000000,attributes+0,2,NULL,autohelperpat812,3,0.000000},
  {pat813,26,8, "EJ19",-1,-3,3,3,4,6,0x2,647,
    { 0x30ffffff, 0xf0fcf0f0, 0xfffe3000, 0x3fff3f2f, 0xf0fcf0e0, 0xffff3000, 0x3fff3f3f, 0x30feffff},
    { 0x00259890, 0x80609010, 0x99600000, 0x18250a04, 0x90608040, 0x98250000, 0x0a251810, 0x00609918}
   , 0xc000,0.000000,attributes+0,2,NULL,autohelperpat813,3,0.000000},
  {pat814,26,8, "EJ20",0,-3,3,3,3,6,0x2,649,
    { 0x00ffffff, 0xf0f0f0f0, 0xfffd0000, 0x3f3f3f1f, 0xf0f0f0d0, 0xffff0000, 0x3f3f3f3f, 0x00fdffff},
    { 0x00259810, 0x80609010, 0x99600000, 0x18250804, 0x90608040, 0x98250000, 0x08251810, 0x00609910}
   , 0x9000,0.000000,attributes+0,2,NULL,autohelperpat814,3,0.000000},
  {pat815,16,8, "EJ21",-1,0,3,4,4,4,0x2,722,
    { 0x3f3f3f3f, 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff, 0xf0f0f0f0},
    { 0x00110200, 0x00100090, 0x00100000, 0x00100000, 0x00100000, 0x02110000, 0x00100018, 0x00100000}
   , 0x9000,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat816,20,8, "EJ22",0,-3,4,2,4,5,0x2,685,
    { 0x00fcffff, 0xf0f0f0c0, 0xfffe0000, 0x3f3f3f2f, 0xf0f0f0e0, 0xfffc0000, 0x3f3f3f0f, 0x00feffff},
    { 0x00200061, 0x00200000, 0x00200000, 0x00220101, 0x00200000, 0x00200000, 0x01220001, 0x00200025}
   , 0x4000,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat817,21,8, "EJ23",0,-3,4,2,4,5,0x2,722,
    { 0x00fcffff, 0xf0f0f0c0, 0xfffe0000, 0x3f3f3f2f, 0xf0f0f0e0, 0xfffc0000, 0x3f3f3f0f, 0x00feffff},
    { 0x00201069, 0x00600000, 0x10200000, 0x02260101, 0x00600000, 0x10200000, 0x01260201, 0x002010a5}
   , 0x4000,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat818,19,8, "EJ24",0,0,4,3,4,3,0x2,759,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00280400, 0x00206000, 0x40a00000, 0x24200000, 0x60200000, 0x04280000, 0x00202400, 0x00a04000}
   , 0x9000,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat819,24,8, "EJ25",0,0,4,4,4,4,0x2,796,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x002a0500, 0x00206060, 0x40a00000, 0x24200000, 0x60200000, 0x052a0000, 0x00202424, 0x00a04000}
   , 0x9000,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat820,29,8, "EJ26",0,0,4,5,4,5,0x2,833,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x002a0500, 0x00206060, 0x40a00000, 0x24200000, 0x60200000, 0x052a0000, 0x00202424, 0x00a04000}
   , 0x9000,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat821,33,8, "EJ27",-1,-3,3,4,4,7,0x2,721,
    { 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xffffffff},
    { 0x00221000, 0x00600020, 0x12200000, 0x00240008, 0x00600080, 0x10220000, 0x00240020, 0x00201200}
   , 0x8000,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat822,38,8, "EJ28",0,-4,4,3,4,7,0x2,723,
    { 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0x00ffffff},
    { 0x00209850, 0x80608000, 0x9a200000, 0x08250908, 0x80608080, 0x98200000, 0x09250800, 0x00209a14}
   , 0x9000,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat823,38,8, "EJ29",0,-4,4,3,4,7,0x2,760,
    { 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0x00ffffff},
    { 0x00209a54, 0x80608080, 0x9a200000, 0x09250908, 0x80608080, 0x9a200000, 0x09250908, 0x00209a54}
   , 0x9000,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat824,20,8, "EJ30",0,-3,4,2,4,5,0x2,723,
    { 0x00fcffff, 0xf0f0f0c0, 0xfffe0000, 0x3f3f3f2f, 0xf0f0f0e0, 0xfffc0000, 0x3f3f3f0f, 0x00feffff},
    { 0x00200021, 0x00200000, 0x00200000, 0x00220001, 0x00200000, 0x00200000, 0x00220001, 0x00200021}
   , 0x4000,0.000000,attributes+0,2,NULL,autohelperpat824,3,0.000000},
  {pat825,28,8, "EJ31",-1,-2,3,5,4,7,0x2,722,
    { 0x3c7fffff, 0xd0fcfcf0, 0xfdf5f000, 0xffff1f15, 0xfcfcd050, 0xff7f3c00, 0x1fffff3f, 0xf0f5fdfd},
    { 0x00201000, 0x00600000, 0x10200000, 0x00240000, 0x00600000, 0x10200000, 0x00240000, 0x00201000}
   , 0x9000,0.000000,attributes+0,1,NULL,autohelperpat825,3,0.016000},
  {pat826,30,8, "EJ32",-1,-2,3,5,4,7,0x2,759,
    { 0x3c7fffff, 0xd0fcfcf0, 0xfdf5f000, 0xffff1f15, 0xfcfcd050, 0xff7f3c00, 0x1fffff3f, 0xf0f5fdfd},
    { 0x00281400, 0x00606000, 0x50a00000, 0x24240000, 0x60600000, 0x14280000, 0x00242400, 0x00a05000}
   , 0x9000,0.000000,attributes+0,1,NULL,autohelperpat826,3,0.016000},
  {pat827,17,8, "EJ33",0,-3,3,1,3,4,0x2,685,
    { 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff},
    { 0x00280400, 0x00206000, 0x41a00000, 0x24200004, 0x60200040, 0x04280000, 0x00202400, 0x00a04100}
   , 0x8084,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat828,27,8, "EJ34",0,-4,4,1,4,5,0x2,686,
    { 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff},
    { 0x00106080, 0x40900000, 0x24100000, 0x00180600, 0x00904000, 0x60100000, 0x06180000, 0x00102408}
   , 0x20000,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat829,28,8, "EJ35",0,-4,4,1,4,5,0x2,612,
    { 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff},
    { 0x00106890, 0x40908000, 0xa4100000, 0x08190600, 0x80904000, 0x68100000, 0x06190800, 0x0010a418}
   , 0x20000,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat830,25,8, "EJ37",0,-2,4,3,4,5,0x2,650,
    { 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0x00ffffff},
    { 0x00200090, 0x00200000, 0x00200000, 0x00210200, 0x00200000, 0x00200000, 0x02210000, 0x00200018}
   , 0x20000,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat831,21,8, "EJ39",0,-2,3,3,3,5,0x2,759,
    { 0x00ffffff, 0xf0f0f0f0, 0xfffc0000, 0x3f3f3f0f, 0xf0f0f0c0, 0xffff0000, 0x3f3f3f3f, 0x00fcffff},
    { 0x00284400, 0x40206000, 0x44a00000, 0x24200400, 0x60204000, 0x44280000, 0x04202400, 0x00a04400}
   , 0x8000,0.000000,attributes+0,2,NULL,autohelperpat831,3,0.000000},
  {pat832,17,8, "EJ40",0,0,3,4,3,4,0x2,797,
    { 0x003d3f3f, 0x00f0f0d0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3d0000, 0x003f3f1f, 0x00f0f0f0},
    { 0x00281601, 0x00606080, 0x50a00000, 0x24240000, 0x60600000, 0x16280000, 0x00242409, 0x00a05000}
   , 0x80005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat833,16,8, "EJ41",0,-3,3,1,3,4,0x2,648,
    { 0x00f0fcfc, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0x003fffff},
    { 0x00101868, 0x00508000, 0x92100000, 0x0a160108, 0x80500080, 0x18100000, 0x01160a00, 0x001092a4}
   , 0x20001,0.000000,attributes+0,2,NULL,autohelperpat833,0,0.000000},
  {pat834,26,8, "EJ42",-2,-4,3,0,5,4,0x2,609,
    { 0xf0f0d0f0, 0xff7f0000, 0x1f3f3f3f, 0x00f7ffff, 0x007fffff, 0xd0f0f0f0, 0xfff70000, 0x3f3f1f3f},
    { 0x00200000, 0x00200000, 0x01200000, 0x00200004, 0x00200040, 0x00200000, 0x00200000, 0x00200100}
   , 0x80000,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat835,17,8, "EJ43",-1,-2,4,2,5,4,0x2,685,
    { 0xfcfdfdfd, 0xfcfcfc50, 0xfdfdfc00, 0xffffff15, 0xfcfcfc50, 0xfdfdfc00, 0xffffff15, 0xfcfdfdfd},
    { 0x00100810, 0x00108000, 0x80100000, 0x08110000, 0x80100000, 0x08100000, 0x00110800, 0x00108010}
   , 0x20001,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat836,24,8, "EJ44",-1,-1,3,4,4,5,0x2,796,
    { 0xffbfffff, 0xecfcfcfc, 0xfcf8fc00, 0xffffef00, 0xfcfcec00, 0xffbfff00, 0xefffffff, 0xfcf8fcfc},
    { 0x00120900, 0x00108060, 0x80100000, 0x08100000, 0x80100000, 0x09120000, 0x00100824, 0x00108000}
   , 0x0,0.000000,attributes+307,0,NULL,NULL,0,0.000000},
  {pat837,19,8, "EJ45",-2,-2,3,3,5,5,0x2,683,
    { 0xffffffff, 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffff00, 0xffffffff, 0xffffffff, 0xfcfcfcfc},
    { 0x00250a00, 0x00209090, 0x80600000, 0x18200000, 0x90200000, 0x0a250000, 0x00201818, 0x00608000}
   , 0x20000,0.000000,attributes+0,1,NULL,autohelperpat837,3,1.600000},
  {pat838,12,8, "EJ46",0,-1,4,1,4,2,0x2,685,
    { 0x00fcfcfc, 0xf0f0f000, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xfcfc0000, 0x3f3f3f00, 0x00fcfcfc},
    { 0x00204400, 0x40204000, 0x44200000, 0x04200400, 0x40204000, 0x44200000, 0x04200400, 0x00204400}
   , 0x9084,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat839,61,8, "EJ47",-3,0,2,10,5,10,0x2,832,
    { 0x3f3f3f3f, 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0xffff0000, 0x3f3f3f3f, 0x00ffffff, 0xf0f0f0f0},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x80000,0.000000,attributes+309,1,NULL,autohelperpat839,3,0.010000},
  {pat840,22,8, "EJ49b",-1,0,3,4,4,4,0x2,757,
    { 0x3f3f3f3f, 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff, 0xf0f0f0f0},
    { 0x00160900, 0x00109060, 0x80500000, 0x18100000, 0x90100000, 0x09160000, 0x00101824, 0x00508000}
   , 0x42010,0.000000,attributes+0,2,NULL,autohelperpat840,0,0.000000},
  {pat841,34,8, "EJ50",-1,-2,3,6,4,8,0x2,833,
    { 0x3fffffff, 0xf0fcfcfc, 0xfffcf000, 0xffff3f0f, 0xfcfcf0c0, 0xffff3f00, 0x3fffffff, 0xf0fcffff},
    { 0x00104000, 0x40100000, 0x05100000, 0x00100404, 0x00104040, 0x40100000, 0x04100000, 0x00100500}
   , 0x9010,0.000000,attributes+311,0,NULL,NULL,0,0.000000},
  {pat842,30,8, "EJ51",-2,-1,3,4,5,5,0x2,721,
    { 0xffffffff, 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffff00, 0xffffffff, 0xffffffff, 0xfcfcfcfc},
    { 0x00102480, 0x00904000, 0x60100000, 0x04180200, 0x40900000, 0x24100000, 0x02180400, 0x00106008}
   , 0x20000,0.000000,attributes+0,1,NULL,autohelperpat842,0,1.000000},
  {pat843,25,8, "EJ52",-1,-4,4,0,5,4,0x2,610,
    { 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff, 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f},
    { 0x00100010, 0x00100000, 0x01100000, 0x00110006, 0x00100040, 0x00100000, 0x00110000, 0x00100112}
   , 0x20000,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat844,46,8, "EJ53",-1,-6,3,3,4,9,0x2,537,
    { 0xf5ffffff, 0xfcfcf4f4, 0xffff7f00, 0x7fffffff, 0xf4fcfcfc, 0xfffff500, 0xffff7f7f, 0x7fffffff},
    { 0x00141a00, 0x00509080, 0x90500000, 0x18140000, 0x90500000, 0x1a140000, 0x00141808, 0x00509000}
   , 0x20000,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat845,25,8, "EJ54",-1,0,3,5,4,5,0x6,723,
    { 0x3f3f3f3f, 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff, 0xf0f0f0f0},
    { 0x00210102, 0x00200050, 0x00200000, 0x00200000, 0x00200000, 0x01210000, 0x00200016, 0x00200000}
   , 0x20000,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat846,27,8, "EJ55",-1,-2,3,4,4,6,0x2,685,
    { 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xffffffff},
    { 0x00210106, 0x00200050, 0x00200000, 0x01200000, 0x00200000, 0x01210000, 0x00200116, 0x00200040}
   , 0x20000,0.000000,attributes+0,1,NULL,autohelperpat846,3,0.010000},
  {pat847,34,8, "EJ56",-1,-2,3,5,4,7,0x2,759,
    { 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xffffffff},
    { 0x00182400, 0x00906000, 0x60900000, 0x24180000, 0x60900000, 0x24180000, 0x00182400, 0x00906000}
   , 0x20000,0.000000,attributes+0,1,NULL,autohelperpat847,0,0.010000},
  {pat848,16,8, "EJ57",-1,0,2,4,3,4,0x2,795,
    { 0x033f3f3f, 0x00f0f0fc, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0300, 0x003f3fff, 0x00f0f0f0},
    { 0x00160900, 0x00109060, 0x80500000, 0x18100000, 0x90100000, 0x09160000, 0x00101824, 0x00508000}
   , 0x20100,0.000000,attributes+0,1,NULL,autohelperpat848,0,1.000000},
  {pat849,29,8, "EJ58",-1,-5,3,1,4,6,0x2,610,
    { 0xfcf0e8fc, 0xfcbc8c00, 0xaf3fff00, 0xcbfbffff, 0x8cbcfcfc, 0xe8f0fc00, 0xfffbcb00, 0xff3fafff},
    { 0x00100000, 0x00100000, 0x02100000, 0x00100008, 0x00100080, 0x00100000, 0x00100000, 0x00100200}
   , 0x20000,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat850,17,8, "EJ59",-1,-3,3,0,4,3,0x2,647,
    { 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff, 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f},
    { 0x0010a000, 0x80900000, 0x29100000, 0x00180804, 0x00908040, 0xa0100000, 0x08180000, 0x00102900}
   , 0x20000,0.000000,attributes+0,1,NULL,autohelperpat850,0,0.010000},
  {pat851,20,8, "EJ60",0,-3,3,1,3,4,0x2,611,
    { 0x00bcfcfc, 0xe0f0f000, 0xfffb0000, 0x3f3f2f3f, 0xf0f0e0f0, 0xfcbc0000, 0x2f3f3f00, 0x00fbffff},
    { 0x00146880, 0x40909000, 0xa4500000, 0x18180600, 0x90904000, 0x68140000, 0x06181800, 0x0050a408}
   , 0x20000,0.000000,attributes+0,1,NULL,autohelperpat851,0,0.010000},
  {pat852,20,8, "EJ62a",0,0,3,4,3,4,0x2,760,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00281600, 0x00606080, 0x50a00000, 0x24240000, 0x60600000, 0x16280000, 0x00242408, 0x00a05000}
   , 0x20001,0.000000,attributes+0,1,NULL,autohelperpat852,3,0.010000},
  {pat853,20,8, "EJ62b",0,0,3,4,3,4,0x2,760,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00281600, 0x00606080, 0x50a00000, 0x24240000, 0x60600000, 0x16280000, 0x00242408, 0x00a05000}
   , 0x8000,0.000000,attributes+313,1,NULL,autohelperpat853,3,0.010000},
  {pat854,24,8, "EJ63a",0,0,3,5,3,5,0x2,797,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00281601, 0x00606080, 0x50a00000, 0x24240000, 0x60600000, 0x16280000, 0x00242409, 0x00a05000}
   , 0x20000,0.000000,attributes+0,1,NULL,autohelperpat854,3,0.010000},
  {pat855,24,8, "EJ63",0,0,3,5,3,5,0x2,797,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00281601, 0x00606080, 0x50a00000, 0x24240000, 0x60600000, 0x16280000, 0x00242409, 0x00a05000}
   , 0x8000,0.000000,attributes+315,1,NULL,autohelperpat855,3,0.010000},
  {pat856,24,8, "EJ64",0,0,3,5,3,5,0x2,796,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00281601, 0x00606080, 0x50a00000, 0x24240000, 0x60600000, 0x16280000, 0x00242409, 0x00a05000}
   , 0x20000,0.000000,attributes+0,1,NULL,autohelperpat856,3,1.000000},
  {pat857,37,8, "EJ65",0,-1,3,8,3,9,0x2,907,
    { 0x003f3fff, 0x00f0f0f0, 0xf0f00000, 0x3f3f0300, 0xf0f00000, 0x3f3f0000, 0x033f3f3f, 0x00f0f0fc},
    { 0x00202491, 0x00a04000, 0x60200000, 0x04290200, 0x40a00000, 0x24200000, 0x02290401, 0x00206018}
   , 0x20000,0.000000,attributes+0,1,NULL,autohelperpat857,3,1.000000},
  {pat858,33,8, "EJ66",0,-1,3,7,3,8,0x2,870,
    { 0x003f3fff, 0x00f0f0f0, 0xf0f00000, 0x3f3f0300, 0xf0f00000, 0x3f3f0000, 0x033f3f3f, 0x00f0f0fc},
    { 0x00202491, 0x00a04000, 0x60200000, 0x04290200, 0x40a00000, 0x24200000, 0x02290401, 0x00206018}
   , 0x20000,0.000000,attributes+0,1,NULL,autohelperpat858,3,1.000000},
  {pat859,48,8, "EJ67",-3,-1,3,6,6,7,0x2,794,
    { 0xffffffff, 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffff00, 0xffffffff, 0xffffffff, 0xfcfcfcfc},
    { 0x00210000, 0x00200010, 0x00200000, 0x00200000, 0x00200000, 0x00210000, 0x00200010, 0x00200000}
   , 0x20000,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat860,49,8, "EJ68",-2,-4,4,3,6,7,0x2,612,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00104088, 0x40100000, 0x04100000, 0x02100600, 0x00104000, 0x40100000, 0x06100200, 0x00100488}
   , 0x20000,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat861,49,8, "EJ69",-2,-4,4,3,6,7,0x2,686,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00104088, 0x40100000, 0x06100000, 0x02100609, 0x00104080, 0x40100000, 0x06100200, 0x00100689}
   , 0x20000,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat862,49,8, "EJ71",-2,-4,4,3,6,7,0x2,687,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00104098, 0x40100000, 0x06100000, 0x02110609, 0x00104080, 0x40100000, 0x06110200, 0x00100699}
   , 0x20000,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat863,35,8, "EJ72",-2,-4,5,0,7,4,0x2,609,
    { 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0x00ffffff, 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f},
    { 0x00200020, 0x00200000, 0x01200000, 0x00220004, 0x00200040, 0x00200000, 0x00220000, 0x00200120}
   , 0x20000,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat864,63,8, "EJ73",-2,0,3,10,5,10,0x2,907,
    { 0x1f3f1f3f, 0x0075ffff, 0xd0f0d0d0, 0xff770000, 0xff750000, 0x1f3f1f1f, 0x0077ffff, 0xd0f0d0f0},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x80000,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat865,27,8, "EJ74",0,-2,4,3,4,5,0x2,760,
    { 0x003fffff, 0xc0f0f0f0, 0xfdf00000, 0x3f3f0f07, 0xf0f0c040, 0xff3f0000, 0x0f3f3f3f, 0x00f0fdff},
    { 0x0020a450, 0x80a04000, 0x68200000, 0x04290902, 0x40a08000, 0xa4200000, 0x09290400, 0x00206816}
   , 0x20000,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat866,14,8, "EJ75",0,-1,3,3,3,4,0x2,685,
    { 0x00fcfeff, 0xf0f0f080, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xfefc0000, 0x3f3f3f0b, 0x00fcfcfc},
    { 0x00204000, 0x40200000, 0x04200000, 0x00200400, 0x00204000, 0x40200000, 0x04200000, 0x00200400}
   , 0x3004,0.000000,attributes+0,1,NULL,autohelperpat866,3,0.010000},
  {pat867,27,8, "EJ76",0,-2,4,3,4,5,0x2,649,
    { 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0x00ffffff},
    { 0x00202410, 0x00a04000, 0x62200000, 0x04290008, 0x40a00080, 0x24200000, 0x00290400, 0x00206210}
   , 0x40000,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat868,30,8, "EJ77",-1,-1,3,5,4,6,0x2,759,
    { 0x0a3f3f5f, 0x00f0f8f8, 0xf0f08000, 0xbf3d0100, 0xf8f00000, 0x3f3f0a00, 0x013dbfbf, 0x80f0f0d4},
    { 0x00242409, 0x00a05000, 0x60600000, 0x16280000, 0x50a00000, 0x24240000, 0x00281601, 0x00606080}
   , 0x40000,0.000000,attributes+0,1,NULL,autohelperpat868,3,0.016000},
  {pat869,24,8, "EJ78",-1,-4,4,0,5,4,0x2,574,
    { 0xf0f0c0c0, 0xfc3c0000, 0x0f3f3f00, 0x00f0ffff, 0x003cfcfc, 0xc0f0f000, 0xfff00000, 0x3f3f0f0f},
    { 0x00100080, 0x00100000, 0x01100000, 0x00100206, 0x00100040, 0x00100000, 0x02100000, 0x0010010a}
   , 0x40000,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat870,43,8, "EJ79",0,-2,7,3,7,5,0x8,689,
    { 0x00f0ffff, 0xf0f0c0c0, 0xff3f0000, 0x0f3f3f3f, 0xc0f0f0f0, 0xfff00000, 0x3f3f0f0f, 0x003fffff},
    { 0x00204800, 0x40208000, 0x84200000, 0x08200400, 0x80204000, 0x48200000, 0x04200800, 0x00208400}
   , 0x40000,0.000000,attributes+0,1,NULL,autohelperpat870,3,0.016000},
  {pat871,22,8, "EJ80",0,-3,4,2,4,5,0x8,685,
    { 0x00fdfdfd, 0xf0f0f050, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xfdfd0000, 0x3f3f3f15, 0x00ffffff},
    { 0x00108010, 0x80100000, 0x08100000, 0x00110800, 0x00108000, 0x80100000, 0x08110000, 0x00100810}
   , 0x20000,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat872,33,8, "EJ81",-1,-1,3,6,4,7,0x2,759,
    { 0x3f3fbfff, 0x80fcfcfc, 0xf8f0f000, 0xffff0b00, 0xfcfc8000, 0xbf3f3f00, 0x0bffffff, 0xf0f0f8fc},
    { 0x00110000, 0x00100010, 0x00100000, 0x00100000, 0x00100000, 0x00110000, 0x00100010, 0x00100000}
   , 0x40000,0.000000,attributes+0,1,NULL,autohelperpat872,0,0.050000},
  {pat873,43,8, "EJ81b",0,-5,4,4,4,9,0x2,612,
    { 0x00fffefe, 0xf0f0f0b0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xfeff0000, 0x3f3f3f3a, 0x00ffffff},
    { 0x00200020, 0x00200000, 0x01200000, 0x00220004, 0x00200040, 0x00200000, 0x00220000, 0x00200120}
   , 0x40000,0.000000,attributes+0,1,NULL,autohelperpat873,3,0.010000},
  {pat874,43,8, "EJ81c",-1,-1,3,8,4,9,0x2,907,
    { 0x3f3fbfff, 0x80fcfcfc, 0xf8f0f000, 0xffff0b00, 0xfcfc8000, 0xbf3f3f00, 0x0bffffff, 0xf0f0f8fc},
    { 0x00110000, 0x00100010, 0x00100000, 0x00100000, 0x00100000, 0x00110000, 0x00100010, 0x00100000}
   , 0x40000,0.000000,attributes+0,1,NULL,autohelperpat874,0,0.050000},
  {pat875,16,8, "EJ82",0,-2,3,2,3,4,0x2,686,
    { 0x00bfffff, 0xe0f0f0f0, 0xfff80000, 0x3f3f2f0c, 0xf0f0e0c0, 0xffbf0000, 0x2f3f3f3f, 0x00f8fffc},
    { 0x00109048, 0x80500000, 0x1a100000, 0x02140908, 0x00508080, 0x90100000, 0x09140200, 0x00101a84}
   , 0x40000,0.000000,attributes+0,1,NULL,autohelperpat875,0,0.010000},
  {pat876,32,8, "EJ84",-2,0,3,5,5,5,0x2,757,
    { 0x3f3f3f3f, 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0xffff0000, 0x3f3f3f3f, 0x00ffffff, 0xf0f0f0f0},
    { 0x00220900, 0x00208060, 0x80200000, 0x08200000, 0x80200000, 0x09220000, 0x00200824, 0x00208000}
   , 0x20000,0.000000,attributes+317,2,NULL,autohelperpat876,3,0.000000},
  {pat877,18,8, "EJ85",0,-2,3,3,3,5,0x2,723,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f03, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcff},
    { 0x00129020, 0x80500020, 0x18100000, 0x00160800, 0x00508000, 0x90120000, 0x08160020, 0x00101820}
   , 0x20001,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat878,23,8, "EJ86",-1,-1,3,4,4,5,0x2,722,
    { 0x3f7fff3f, 0xd0fcfcfc, 0xfcf4f000, 0xffff1c00, 0xfcfcd000, 0xff7f3f00, 0x1cffffff, 0xf0f4fcf0},
    { 0x00209000, 0x80600000, 0x18200000, 0x00240800, 0x00608000, 0x90200000, 0x08240000, 0x00201800}
   , 0x20004,0.000000,attributes+0,1,NULL,autohelperpat878,3,0.010000},
  {pat879,28,8, "EJ87",-1,-2,4,3,5,5,0x2,722,
    { 0x3fffffff, 0xf0fcfcfc, 0xfffff000, 0xffff3f3f, 0xfcfcf0f0, 0xffff3f00, 0x3fffffff, 0xf0ffffff},
    { 0x00201000, 0x00600000, 0x10200000, 0x00240000, 0x00600000, 0x10200000, 0x00240000, 0x00201000}
   , 0x20000,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat880,28,8, "EJ88",-2,-1,3,4,5,5,0x2,758,
    { 0xffffffff, 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffff00, 0xffffffff, 0xffffffff, 0xfcfcfcfc},
    { 0x00100200, 0x00100080, 0x00100000, 0x00100000, 0x00100000, 0x02100000, 0x00100008, 0x00100000}
   , 0x20000,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat881,28,8, "EJ89",-2,-1,3,4,5,5,0x2,759,
    { 0xffffffff, 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffff00, 0xffffffff, 0xffffffff, 0xfcfcfcfc},
    { 0x00120000, 0x00100020, 0x00100000, 0x00100000, 0x00100000, 0x00120000, 0x00100020, 0x00100000}
   , 0x20000,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat882,32,8, "EJ90",0,-1,4,5,4,6,0x2,759,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x00280440, 0x00206000, 0x40a00000, 0x24200100, 0x60200000, 0x04280000, 0x01202400, 0x00a04004}
   , 0x20000,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat883,22,8, "EJ91",-1,-2,3,3,4,5,0x2,685,
    { 0xfffeffff, 0xfcfcfcec, 0xfffffc00, 0xffffff3f, 0xfcfcfcf0, 0xfffeff00, 0xffffffef, 0xfcffffff},
    { 0x00108000, 0x80100000, 0x08100000, 0x00100800, 0x00108000, 0x80100000, 0x08100000, 0x00100800}
   , 0x40000,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat884,60,8, "EJ92",-2,-7,3,3,5,10,0x2,683,
    { 0xfffffffe, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xfffffffe, 0xffffffff},
    { 0x001a0400, 0x00106020, 0x40900000, 0x24100000, 0x60100000, 0x041a0000, 0x00102420, 0x00904000}
   , 0x40000,0.000000,attributes+0,3,NULL,autohelperpat884,0,0.010000},
  {pat885,59,8, "EJ93",-2,-3,3,7,5,10,0xa,758,
    { 0xffffffff, 0xfdfdffff, 0xffffffd7, 0xffffffff, 0xfffdfdff, 0xffffff5f, 0xffffffff, 0xffffffff},
    { 0x00200900, 0x00208040, 0x80200000, 0x08200000, 0x80200000, 0x09200000, 0x00200804, 0x00208000}
   , 0x40000,0.000000,attributes+0,2,NULL,autohelperpat885,3,0.000000},
  {pat886,23,8, "EJ94",-1,-2,4,2,5,4,0x2,722,
    { 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xffffffff},
    { 0x00102084, 0x00900000, 0x20100000, 0x01180200, 0x00900000, 0x20100000, 0x02180100, 0x00102048}
   , 0x40000,0.000000,attributes+0,2,NULL,autohelperpat886,0,0.000000},
  {pat887,20,8, "EJ95",-1,-2,3,3,4,5,0x2,685,
    { 0xfffffeff, 0xfcfcfcbc, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xfeffff00, 0xfffffffb, 0xffffffff},
    { 0x00210000, 0x00200010, 0x01200000, 0x00200004, 0x00200040, 0x00210000, 0x00200010, 0x00200100}
   , 0x40000,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat888,23,8, "EJ96",0,-2,3,3,3,5,0x2,686,
    { 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0x00ffffff},
    { 0x00296604, 0x40a06090, 0x64a00000, 0x25280400, 0x60a04000, 0x66290000, 0x04282518, 0x00a06440}
   , 0x40000,0.000000,attributes+0,1,NULL,autohelperpat888,3,1.000000},
  {pat889,24,8, "EJ97",-1,-4,3,1,4,5,0x2,647,
    { 0xfcfcfcfc, 0xfcfcfc00, 0xfeffff00, 0xfffffffb, 0xfcfcfcbc, 0xfcfcfc00, 0xffffff00, 0xfffffeff},
    { 0x00102800, 0x00908000, 0xa0100000, 0x08180000, 0x80900000, 0x28100000, 0x00180800, 0x0010a000}
   , 0x40000,0.000000,attributes+0,1,NULL,autohelperpat889,0,0.010000},
  {pat890,21,8, "EJ98",0,0,3,5,3,5,0x2,796,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00101000, 0x00500000, 0x10100000, 0x00140000, 0x00500000, 0x10100000, 0x00140000, 0x00101000}
   , 0x40000,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat891,36,8, "EJ99",-1,-3,3,4,4,7,0x2,721,
    { 0xffbfffff, 0xecfcfcfc, 0xfefaff00, 0xffffefeb, 0xfcfcecac, 0xffbfff00, 0xefffffff, 0xfffafeff},
    { 0x00106800, 0x40908000, 0xa4100000, 0x08180400, 0x80904000, 0x68100000, 0x04180800, 0x0010a400}
   , 0x40000,0.000000,attributes+319,3,NULL,autohelperpat891,0,0.010000},
  {pat892,30,8, "EJ100",0,-3,4,3,4,6,0x8,723,
    { 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0x00ffffff},
    { 0x00100020, 0x00100000, 0x00100000, 0x00120000, 0x00100000, 0x00100000, 0x00120000, 0x00100020}
   , 0x4c000,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat893,26,8, "EJ101",0,-6,3,0,3,6,0x2,649,
    { 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3f},
    { 0x00208010, 0x80200000, 0x09200000, 0x00210804, 0x00208040, 0x80200000, 0x08210000, 0x00200910}
   , 0x48100,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat894,12,4, "S1",0,0,3,3,3,3,0xa,723,
    { 0x003c3f2f, 0x00f0f0c0, 0xf0f00000, 0x3f3e0000, 0xf0f00000, 0x3f3c0000, 0x003e3f0f, 0x00f0f0e0},
    { 0x00280a02, 0x0020a080, 0x80a00000, 0x28200000, 0xa0200000, 0x0a280000, 0x0020280a, 0x00a08000}
   , 0x1014,0.000000,attributes+321,1,NULL,autohelperpat894,3,0.010000},
  {pat895,12,8, "S2",0,0,3,3,3,3,0xa,686,
    { 0x003c3f37, 0x00f0f0c0, 0xf0f00000, 0x3d3f0000, 0xf0f00000, 0x3f3c0000, 0x003f3d0f, 0x00f0f070},
    { 0x00140501, 0x00105040, 0x40500000, 0x14100000, 0x50100000, 0x05140000, 0x00101405, 0x00504000}
   , 0x1001,0.000000,attributes+323,1,NULL,autohelperpat895,0,0.010000},
  {pat896,13,8, "S3",0,0,2,4,2,4,0xa,759,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x002a0000, 0x00202020, 0x00a00000, 0x20200000, 0x20200000, 0x002a0000, 0x00202020, 0x00a00000}
   , 0x1014,0.000000,attributes+325,3,NULL,autohelperpat896,3,0.010000},
  {pat897,13,8, "S4",0,0,2,4,2,4,0xa,759,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00150000, 0x00101010, 0x00500000, 0x10100000, 0x10100000, 0x00150000, 0x00101010, 0x00500000}
   , 0x1001,0.000000,attributes+328,1,NULL,autohelperpat897,0,0.010000},
  {pat898,13,8, "S5",0,0,2,4,2,4,0xa,722,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00150108, 0x00101050, 0x00500000, 0x12100000, 0x10100000, 0x01150000, 0x00101214, 0x00500080}
   , 0x1001,0.000000,attributes+331,1,NULL,autohelperpat898,0,0.010000},
  {pat899,13,8, "S6",0,0,3,3,3,3,0xa,723,
    { 0x003c3f3f, 0x00f0f0c0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3c0000, 0x003f3f0f, 0x00f0f0f0},
    { 0x00280a00, 0x0020a080, 0x80a00000, 0x28200000, 0xa0200000, 0x0a280000, 0x00202808, 0x00a08000}
   , 0x1014,0.000000,attributes+333,1,NULL,autohelperpat899,3,0.010000},
  {pat900,13,8, "S6b",0,0,3,3,3,3,0xa,724,
    { 0x003c3f3f, 0x00f0f0c0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3c0000, 0x003f3f0f, 0x00f0f0f0},
    { 0x00280a24, 0x0020a080, 0x80a00000, 0x29220000, 0xa0200000, 0x0a280000, 0x00222908, 0x00a08060}
   , 0x1014,0.000000,attributes+336,1,NULL,autohelperpat900,3,0.010000},
  {pat901,13,8, "S6c",0,0,3,3,3,3,0xa,761,
    { 0x003c3f3f, 0x00f0f0c0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3c0000, 0x003f3f0f, 0x00f0f0f0},
    { 0x00140518, 0x00105040, 0x40500000, 0x16110000, 0x50100000, 0x05140000, 0x00111604, 0x00504090}
   , 0x1001,0.000000,attributes+339,1,NULL,autohelperpat901,0,0.010000},
  {pat902,13,8, "S7",0,0,3,3,3,3,0xa,723,
    { 0x003c3f3f, 0x00f0f0c0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3c0000, 0x003f3f0f, 0x00f0f0f0},
    { 0x00140500, 0x00105040, 0x40500000, 0x14100000, 0x50100000, 0x05140000, 0x00101404, 0x00504000}
   , 0x1001,0.000000,attributes+341,1,NULL,autohelperpat902,0,0.010000},
  {pat903,15,8, "S8",0,0,3,4,3,4,0xa,723,
    { 0x003c3f3f, 0x00f0f0c0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3c0000, 0x003f3f0f, 0x00f0f0f0},
    { 0x00280a00, 0x0020a080, 0x80a00000, 0x28200000, 0xa0200000, 0x0a280000, 0x00202808, 0x00a08000}
   , 0x1014,0.000000,attributes+344,1,NULL,autohelperpat903,3,0.010000},
  {pat904,15,8, "S9",0,0,3,4,3,4,0xa,723,
    { 0x003c3f3f, 0x00f0f0c0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3c0000, 0x003f3f0f, 0x00f0f0f0},
    { 0x00140500, 0x00105040, 0x40500000, 0x14100000, 0x50100000, 0x05140000, 0x00101404, 0x00504000}
   , 0x1014,0.000000,attributes+346,1,NULL,autohelperpat904,0,0.010000},
  {pat905,15,8, "S10",0,0,3,4,3,4,0xa,723,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x002a0200, 0x002020a0, 0x00a00000, 0x20200000, 0x20200000, 0x022a0000, 0x00202028, 0x00a00000}
   , 0x1014,0.000000,attributes+348,1,NULL,autohelperpat905,3,0.010000},
  {pat906,15,8, "S10b",0,0,3,4,3,4,0xa,760,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00150108, 0x00101050, 0x00500000, 0x12100000, 0x10100000, 0x01150000, 0x00101214, 0x00500080}
   , 0x1014,0.000000,attributes+351,3,NULL,autohelperpat906,0,0.010000},
  {pat907,15,8, "S10c",0,0,3,4,3,4,0xa,760,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x002a0204, 0x002020a0, 0x00a00000, 0x21200000, 0x20200000, 0x022a0000, 0x00202128, 0x00a00040}
   , 0x1014,0.000000,attributes+354,3,NULL,autohelperpat907,3,0.010000},
  {pat908,15,8, "S10d",0,0,3,4,3,4,0xa,685,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x002a0205, 0x002020a0, 0x00a00000, 0x21200000, 0x20200000, 0x022a0000, 0x00202129, 0x00a00040}
   , 0x14,0.000000,attributes+0,2,NULL,autohelperpat908,3,0.000000},
  {pat909,15,8, "S11",0,0,3,4,3,4,0xa,723,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00150100, 0x00101050, 0x00500000, 0x10100000, 0x10100000, 0x01150000, 0x00101014, 0x00500000}
   , 0x1014,0.000000,attributes+357,1,NULL,autohelperpat909,0,0.010000},
  {pat910,16,8, "S12",0,0,3,4,3,4,0xa,723,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x002a0000, 0x00202020, 0x00a00000, 0x20200000, 0x20200000, 0x002a0000, 0x00202020, 0x00a00000}
   , 0x1014,0.000000,attributes+360,1,NULL,autohelperpat910,3,0.010000},
  {pat911,16,8, "S13",0,0,3,4,3,4,0xa,723,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00150000, 0x00101010, 0x00500000, 0x10100000, 0x10100000, 0x00150000, 0x00101010, 0x00500000}
   , 0x1014,0.000000,attributes+362,1,NULL,autohelperpat911,0,0.010000},
  {pat912,17,8, "S14b",0,0,3,4,3,4,0xa,761,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00150809, 0x00109010, 0x80500000, 0x1a100000, 0x90100000, 0x08150000, 0x00101a11, 0x00508080}
   , 0x14,0.000000,attributes+0,2,NULL,autohelperpat912,0,0.000000},
  {pat913,18,8, "S15",0,0,4,4,4,4,0xa,724,
    { 0x003c3f3f, 0x00f0f0c0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3c0000, 0x003f3f0f, 0x00f0f0f0},
    { 0x00280a02, 0x0020a080, 0x80a00000, 0x28200000, 0xa0200000, 0x0a280000, 0x0020280a, 0x00a08000}
   , 0x1014,0.000000,attributes+364,1,NULL,autohelperpat913,3,0.010000},
  {pat914,18,8, "S16",0,0,4,4,4,4,0xa,724,
    { 0x003c3f3f, 0x00f0f0c0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3c0000, 0x003f3f0f, 0x00f0f0f0},
    { 0x00140501, 0x00105040, 0x40500000, 0x14100000, 0x50100000, 0x05140000, 0x00101405, 0x00504000}
   , 0x1014,0.000000,attributes+366,1,NULL,autohelperpat914,0,0.010000},
  {pat915,30,2, "HH1",-2,0,2,6,4,6,0x0,795,
    { 0x3f3f3f3f, 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0xffff0000, 0x3f3f3f3f, 0x00ffffff, 0xf0f0f0f0},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x0,0.000000,attributes+368,0,high_handicap_helper
,NULL,0,0.000000},
  {pat916,37,4, "HH2",-3,0,2,6,5,6,0x0,794,
    { 0x3f3f3f3f, 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0xffff0000, 0x3f3f3f3f, 0x00ffffff, 0xf0f0f0f0},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x0,0.000000,attributes+370,0,high_handicap_helper
,NULL,0,0.000000},
  {pat917,22,4, "HH3",-3,-3,2,3,5,6,0x2,683,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x0,0.000000,attributes+372,0,high_handicap_helper
,NULL,0,0.000000},
  {pat918,22,4, "HH4",-2,-2,3,2,5,4,0x2,685,
    { 0xffffffff, 0xfffeffff, 0xffffffef, 0xffffffff, 0xfffeffff, 0xffffffef, 0xffffffff, 0xffffffff},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x0,0.000000,attributes+374,0,high_handicap_helper
,NULL,0,0.000000},
  {pat919,22,4, "HH5",-3,-2,2,2,5,4,0x2,682,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x0,0.000000,attributes+376,0,high_handicap_helper
,NULL,0,0.000000},
  {pat920,22,8, "HH6",-2,-2,2,3,4,5,0xa,758,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x0,0.000000,attributes+378,0,high_handicap_helper
,NULL,0,0.000000},
  {pat921,27,8, "HH7",-5,-2,0,2,5,4,0x0,681,
    { 0xffba0000, 0x2f3f2f2f, 0x00baffff, 0xe0f0e0e0, 0x2f3f2f2f, 0x00baffff, 0xe0f0e0e0, 0xffba0000},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x0,0.000000,attributes+380,0,high_handicap_helper
,NULL,0,0.000000},
  {pat922,21,8, "HH8",-1,0,3,4,4,4,0x2,759,
    { 0x3f3f2f3f, 0x00bcfcfc, 0xe0f0f000, 0xfffb0000, 0xfcbc0000, 0x2f3f3f00, 0x00fbffff, 0xf0f0e0f0},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x0,0.000000,attributes+382,0,high_handicap_helper
,NULL,0,0.000000},
  {pat923,26,8, "HH9",-3,0,2,4,5,4,0x2,757,
    { 0x2f3f3f3f, 0x00fbffff, 0xf0f0e0f0, 0xffbf0000, 0xfffb0000, 0x3f3f2f3f, 0x00bfffff, 0xe0f0f0f0},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x0,0.000000,attributes+384,0,high_handicap_helper
,NULL,0,0.000000},
  {pat924,20,4, "HH10",-2,0,2,4,4,4,0x0,758,
    { 0x3f3f3f3f, 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0xffff0000, 0x3f3f3f3f, 0x00ffffff, 0xf0f0f0f0},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x0,0.000000,attributes+386,0,high_handicap_helper
,NULL,0,0.000000},
  {pat925,15,8, "HH11",-1,0,3,4,4,4,0x0,759,
    { 0x3f3f3f3f, 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff, 0xf0f0f0f0},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x0,0.000000,attributes+388,0,high_handicap_helper
,NULL,0,0.000000},
  {pat926,17,4, "HH12",-2,-1,2,3,4,4,0x0,721,
    { 0xffffffbf, 0xfeffffff, 0xfcfcfcf8, 0xfffffe00, 0xfffffe00, 0xffffffbf, 0xfeffffff, 0xfcfcfcf8},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x0,0.000000,attributes+390,0,high_handicap_helper
,NULL,0,0.000000},
  {pat927,17,8, "HH13",-2,-1,2,3,4,4,0x0,721,
    { 0xffffffaf, 0xfeffffff, 0xfcfcfcf8, 0xfffefe00, 0xfffffe00, 0xffffffbf, 0xfefeffff, 0xfcfcfce8},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x0,0.000000,attributes+392,0,high_handicap_helper
,NULL,0,0.000000},
  {pat928,26,8, "HH14",0,-2,4,3,4,5,0xa,723,
    { 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0x00ffffff},
    { 0x00100400, 0x00104000, 0x40100000, 0x04100000, 0x40100000, 0x04100000, 0x00100400, 0x00104000}
   , 0x0,0.000000,attributes+394,0,high_handicap_helper
,NULL,0,0.000000},
  {pat929,22,8, "HH15",-1,-2,3,3,4,5,0xa,685,
    { 0xfefefeff, 0xfcfcfca8, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xfefefe00, 0xffffffab, 0xffffffff},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x0,0.000000,attributes+396,0,high_handicap_helper
,NULL,0,0.000000},
  {pat930,17,8, "HH16",-2,-2,2,2,4,4,0xa,685,
    { 0xfefeffff, 0xfffefeea, 0xffffffaf, 0xffffffff, 0xfefeffff, 0xfffefeea, 0xffffffaf, 0xffffffff},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x0,0.000000,attributes+398,0,high_handicap_helper
,NULL,0,0.000000},
  {pat931,17,8, "HH17",-1,-3,3,1,4,4,0xa,648,
    { 0xfcfcfcfc, 0xfcfcfc00, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xfcfcfc00, 0xffffff00, 0xffffffff},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x0,0.000000,attributes+400,0,high_handicap_helper
,NULL,0,0.000000},
  {pat932,18,4, "Reinforce1",-2,0,2,4,4,4,0x2,757,
    { 0x3f3f3f3f, 0x00fcffff, 0xf0f0f0c0, 0xffff0000, 0xfffc0000, 0x3f3f3f0f, 0x00ffffff, 0xf0f0f0f0},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x10,0.000000,attributes+402,0,reinforce_helper
,NULL,0,0.000000},
  {pat933,15,4, "Reinforce2",-1,0,2,4,3,4,0x2,758,
    { 0x3f3f3f3f, 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff, 0xf0f0f0f0},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x10,0.000000,attributes+404,0,reinforce_helper
,NULL,0,0.000000},
  {pat934,6,4, "Reinforce3",0,0,2,2,2,2,0x0,722,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00200020, 0x00200000, 0x00200000, 0x00220000, 0x00200000, 0x00200000, 0x00220000, 0x00200020}
   , 0x10,0.000000,attributes+406,0,reinforce_helper
,NULL,3,0.000000},
  {pat935,4,8, "Reinforce4",-1,-1,1,0,2,1,0x0,647,
    { 0x50f0f000, 0xf4f40000, 0x3c3c1400, 0x007c7c00, 0x00f4f400, 0xf0f05000, 0x7c7c0000, 0x143c3c00},
    { 0x00108000, 0x80100000, 0x08100000, 0x00100800, 0x00108000, 0x80100000, 0x08100000, 0x00100800}
   , 0x10,0.000000,attributes+408,0,reinforce_helper
,NULL,0,0.000000},
  {pat936,5,8, "Reinforce5",-1,-2,1,0,2,2,0x0,647,
    { 0x50f0f000, 0xf4f40000, 0x3f3f1400, 0x007c7c3c, 0x00f4f4f0, 0xf0f05000, 0x7c7c0000, 0x143f3f00},
    { 0x00100000, 0x00100000, 0x02100000, 0x00100008, 0x00100080, 0x00100000, 0x00100000, 0x00100200}
   , 0x10,0.000000,attributes+410,0,reinforce_helper
,NULL,0,0.000000},
  {pat937,30,8, "Reinforce102",-1,0,3,6,4,6,0x2,796,
    { 0x3f3f3f3f, 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff, 0xf0f0f0f0},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x1,0.000000,attributes+412,1,NULL,autohelperpat937,0,0.000000},
  {pat938,13,8, "LE1",0,0,3,3,3,3,0x2,722,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00120000, 0x00100020, 0x00100000, 0x00100000, 0x00100000, 0x00120000, 0x00100020, 0x00100000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat939,12,8, "LE2",-1,0,2,4,3,4,0x2,722,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00120000, 0x00100020, 0x00100000, 0x00100000, 0x00100000, 0x00120000, 0x00100020, 0x00100000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat940,12,8, "LE3",0,-1,4,1,4,2,0x0,686,
    { 0x0074fcfc, 0xd0f0d000, 0xfc740000, 0x1f3f1f00, 0xd0f0d000, 0xfc740000, 0x1f3f1f00, 0x0074fcfc},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,3,0.000000},
  {pat941,13,8, "LE5",0,-1,3,2,3,3,0x2,723,
    { 0x0035ffff, 0xc0f0d0d0, 0xfc700000, 0x1f3f0f00, 0xd0f0c000, 0xff350000, 0x0f3f1f1f, 0x0070fcfc},
    { 0x00204000, 0x40200000, 0x04200000, 0x00200400, 0x00204000, 0x40200000, 0x04200000, 0x00200400}
   , 0x1005,0.000000,attributes+0,1,NULL,autohelperpat941,3,10.000000},
  {pat942,13,8, "LE6",-2,-5,1,0,3,5,0x0,609,
    { 0xd0f00000, 0x3c340000, 0x033f1f00, 0x0070f0fc, 0x00343cfc, 0x00f0d000, 0xf0700000, 0x1f3f0300},
    { 0x00200000, 0x00200000, 0x01200000, 0x00200004, 0x00200040, 0x00200000, 0x00200000, 0x00200100}
   , 0x3005,0.000000,attributes+0,1,NULL,autohelperpat942,3,0.019600},
  {pat943,9,8, "LE8",0,-1,2,2,2,3,0x2,685,
    { 0x003effff, 0xc0f0f0e0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3e0000, 0x0f3f3f2f, 0x00f0fcfc},
    { 0x00148000, 0x80101000, 0x08500000, 0x10100800, 0x10108000, 0x80140000, 0x08101000, 0x00500800}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat944,18,8, "LE9",-1,-2,3,2,4,4,0x2,648,
    { 0xbcfdffff, 0xf8fcfcd0, 0xfffffa00, 0xffffbfbf, 0xfcfcf8f8, 0xfffdbc00, 0xbfffff1f, 0xfaffffff},
    { 0x00102002, 0x00900000, 0x21100000, 0x00180004, 0x00900040, 0x20100000, 0x00180002, 0x00102100}
   , 0x1005,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat945,3,4, "LE10",0,0,1,1,1,1,0x0,722,
    { 0x003c3c00, 0x00f0f000, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3c3c0000, 0x003c3c00, 0x00f0f000},
    { 0x00182000, 0x00902000, 0x20900000, 0x20180000, 0x20900000, 0x20180000, 0x00182000, 0x00902000}
   , 0x400005,0.000000,attributes+414,1,NULL,autohelperpat945,0,1.574800},
  {pat946,8,8, "LE12",0,-1,2,2,2,3,0x2,685,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x00108000, 0x80100000, 0x08100000, 0x00100800, 0x00108000, 0x80100000, 0x08100000, 0x00100800}
   , 0x5,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat947,16,8, "LE13",-1,-3,3,0,4,3,0xa,649,
    { 0x80f0f0f0, 0xf8f00000, 0x3f3f0800, 0x003fbf3f, 0x00f0f8f0, 0xf0f08000, 0xbf3f0000, 0x083f3f3f},
    { 0x00106020, 0x40900000, 0x24100000, 0x001a0400, 0x00904000, 0x60100000, 0x041a0000, 0x00102420}
   , 0x1005,0.000000,attributes+416,1,NULL,autohelperpat947,0,1.000000},
  {pat948,17,4, "LE15",-5,0,1,2,6,2,0x0,718,
    { 0x3f3b0800, 0x003faf3f, 0x80b0f0f0, 0xe8f00000, 0xaf3f0000, 0x083b3f3f, 0x00f0e8f0, 0xf0b08000},
    { 0x00110000, 0x00100010, 0x00100000, 0x00100000, 0x00100000, 0x00110000, 0x00100010, 0x00100000}
   , 0x2001,0.000000,attributes+0,1,NULL,autohelperpat948,0,0.010000},
  {pat949,7,8, "LE16",0,-2,2,1,2,3,0x9,648,
    { 0x00fcfcf0, 0xf0f0f000, 0xffff0000, 0x3c3f3f3c, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3c00, 0x00ffff3c},
    { 0x00102420, 0x00904000, 0x60100000, 0x041a0000, 0x40900000, 0x24100000, 0x001a0400, 0x00106020}
   , 0x5,0.000000,attributes+418,2,NULL,autohelperpat949,0,0.000000},
  {pat950,12,8, "RE1",0,0,3,3,3,3,0x0,722,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00251024, 0x00601010, 0x10600000, 0x11260000, 0x10600000, 0x10250000, 0x00261110, 0x00601060}
   , 0x0,0.000000,attributes+0,3,NULL,autohelperpat950,3,0.010000},
  {pat951,26,8, "RE2",0,-2,4,3,4,5,0x2,686,
    { 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0x00ffffff},
    { 0x00104048, 0x40100000, 0x06100000, 0x0210050a, 0x00104080, 0x40100000, 0x05100200, 0x00100686}
   , 0x0,0.000000,attributes+0,2,NULL,autohelperpat951,0,0.000000},
  {pat952,34,4, "RE3",-2,-1,3,5,5,6,0x2,758,
    { 0xffffffff, 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffff00, 0xffffffff, 0xffffffff, 0xfcfcfcfc},
    { 0x00100200, 0x00100080, 0x00100000, 0x00100000, 0x00100000, 0x02100000, 0x00100008, 0x00100000}
   , 0x0,0.000000,attributes+0,2,NULL,autohelperpat952,0,0.000000},
  {pat953,10,8, "RE6",-1,0,1,4,2,4,0x1,720,
    { 0x3f3f0f00, 0x003cfcfc, 0xc0f0f000, 0xfcf00000, 0xfc3c0000, 0x0f3f3f00, 0x00f0fcfc, 0xf0f0c000},
    { 0x00190500, 0x00106050, 0x40900000, 0x24100000, 0x60100000, 0x05190000, 0x00102414, 0x00904000}
   , 0x0,0.000000,attributes+0,3,NULL,autohelperpat953,0,0.010000},
  {pat954,18,8, "RE8",0,-3,3,2,3,5,0x2,648,
    { 0x00f0fcff, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f03, 0x003fffff},
    { 0x00101860, 0x00508000, 0x90100000, 0x08160100, 0x80500000, 0x18100000, 0x01160800, 0x00109024}
   , 0x0,0.000000,attributes+0,2,NULL,autohelperpat954,0,0.000000},
  {pat955,16,8, "RE9",0,-3,3,2,3,5,0x2,686,
    { 0x00f0fcff, 0xf0f0c000, 0xff3e0000, 0x0f3f3f2f, 0xc0f0f0e0, 0xfcf00000, 0x3f3f0f03, 0x003effff},
    { 0x00200000, 0x00200000, 0x01200000, 0x00200004, 0x00200040, 0x00200000, 0x00200000, 0x00200100}
   , 0x0,0.000000,attributes+0,2,NULL,autohelperpat955,3,0.000000},
  {pat956,13,8, "RE10",-1,-3,2,0,3,3,0x0,685,
    { 0x50f0f0f0, 0xf4f40000, 0x3f3f1500, 0x007f7f7f, 0x00f4f4f4, 0xf0f05000, 0x7f7f0000, 0x153f3f3f},
    { 0x00204090, 0x40200000, 0x04200000, 0x00210602, 0x00204000, 0x40200000, 0x06210000, 0x0020041a}
   , 0x8000,0.000000,attributes+0,3,NULL,autohelperpat956,3,0.010000},
  {pat957,20,8, "RE12",0,-3,3,2,3,5,0x2,723,
    { 0x003fffff, 0xc0f0f0f0, 0xfff00000, 0x3f3f0f0f, 0xf0f0c0c0, 0xff3f0000, 0x0f3f3f3f, 0x00f0ffff},
    { 0x00189000, 0x80502000, 0x18900000, 0x20140800, 0x20508000, 0x90180000, 0x08142000, 0x00901800}
   , 0x0,0.000000,attributes+421,3,NULL,autohelperpat957,0,0.376000},
  {pat958,8,4, "RE13",0,-1,2,2,2,3,0x0,685,
    { 0x003fff3f, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0c00, 0xf0f0c000, 0xff3f0000, 0x0c3f3f3f, 0x00f0fcf0},
    { 0x00294029, 0x40202010, 0x04a00000, 0x22220400, 0x20204000, 0x40290000, 0x04222211, 0x00a004a0}
   , 0x5,0.000000,attributes+0,3,NULL,autohelperpat958,3,1.600000},
  {pat959,10,8, "RE14",-1,-2,3,0,4,2,0x9,610,
    { 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0x003fffff, 0x00f0fcfc, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f},
    { 0x00101010, 0x00500000, 0x10100000, 0x00150001, 0x00500000, 0x10100000, 0x00150000, 0x00101011}
   , 0x1,0.000000,attributes+0,3,NULL,autohelperpat959,0,0.650000},
  {pat960,15,4, "Th1",-1,0,2,4,3,4,0x2,758,
    { 0x3f3f3f3f, 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff, 0xf0f0f0f0},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x0,0.000000,attributes+423,0,thrash_around_helper
,NULL,3,0.000000},
  {pat961,22,4, "Th2",0,-2,4,2,4,4,0x2,686,
    { 0x0075fefe, 0xd0f0d090, 0xfe750000, 0x1f3f1f1a, 0xd0f0d090, 0xfe750000, 0x1f3f1f1a, 0x0075fefe},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x0,0.000000,attributes+425,0,thrash_around_helper
,NULL,3,0.000000},
  {pat962,19,8, "Th3",-1,-1,3,3,4,4,0x2,721,
    { 0xaeffffff, 0xf8f8fcf8, 0xfcfce800, 0xffbfbf00, 0xfcf8f800, 0xffffae00, 0xbfbfffbf, 0xe8fcfcfc},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x0,0.000000,attributes+427,0,thrash_around_helper
,NULL,3,0.000000},
  {pat963,17,4, "Th4",0,-2,3,2,3,4,0x2,685,
    { 0x00bafeff, 0xe0f0e0a0, 0xfeba0000, 0x2f3f2f2b, 0xe0f0e0a0, 0xfeba0000, 0x2f3f2f2b, 0x00bafeff},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x0,0.000000,attributes+429,0,thrash_around_helper
,NULL,3,0.000000},
  {pat964,13,8, "Th5",0,0,3,3,3,3,0x0,759,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x0,0.000000,attributes+431,0,thrash_around_helper
,NULL,3,0.000000},
  {pat965,11,8, "Th6",-1,0,2,3,3,3,0x0,758,
    { 0x3f3f3f2a, 0x00fcfcfc, 0xf0f0f000, 0xfefe0000, 0xfcfc0000, 0x3f3f3f00, 0x00fefefe, 0xf0f0f0a0},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x0,0.000000,attributes+433,0,thrash_around_helper
,NULL,3,0.000000},
  {pat966,12,8, "Th7",-1,-1,2,3,3,4,0x0,685,
    { 0xfffefeff, 0xfcfcfcac, 0xfcfcfc00, 0xffffff00, 0xfcfcfc00, 0xfefeff00, 0xffffffeb, 0xfcfcfcfc},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x10,0.000000,attributes+435,1,thrash_around_helper
,autohelperpat966,3,0.010000},
  {pat967,14,8, "Th8",-1,-1,2,3,3,4,0x0,647,
    { 0xaffefeff, 0xf8f8fcac, 0xfcfce800, 0xffbfbf00, 0xfcf8f800, 0xfefeaf00, 0xbfbfffeb, 0xe8fcfcfc},
    { 0x00201000, 0x00600000, 0x10200000, 0x00240000, 0x00600000, 0x10200000, 0x00240000, 0x00201000}
   , 0x0,0.000000,attributes+437,1,thrash_around_helper
,autohelperpat967,3,0.010000},
  {pat968,7,8, "Th9",-1,0,1,3,2,3,0x0,758,
    { 0x3f3f3f00, 0x00fcfcfc, 0xf0f0f000, 0xfcfc0000, 0xfcfc0000, 0x3f3f3f00, 0x00fcfcfc, 0xf0f0f000},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x0,0.000000,attributes+439,0,thrash_around_helper
,NULL,0,0.000000},
  {pat969,5,8, "Th10",-2,0,1,2,3,2,0x0,720,
    { 0x3d3f0800, 0x003cbd34, 0x80f0f040, 0xf8f00000, 0xbd3c0000, 0x083f3d04, 0x00f0f870, 0xf0f08000},
    { 0x00110000, 0x00100010, 0x00100000, 0x00100000, 0x00100000, 0x00110000, 0x00100010, 0x00100000}
   , 0x0,0.000000,attributes+441,0,thrash_around_helper
,NULL,0,0.000000},
  {pat970,5,8, "Th11",-2,0,1,2,3,2,0x0,720,
    { 0x2c3f0800, 0x0038bd30, 0x80f0e040, 0xf8b00000, 0xbd380000, 0x083f2c04, 0x00b0f830, 0xe0f08000},
    { 0x00110000, 0x00100010, 0x00100000, 0x00100000, 0x00100000, 0x00110000, 0x00100010, 0x00100000}
   , 0x0,0.000000,attributes+443,0,thrash_around_helper
,NULL,0,0.000000},
  {pat971,7,4, "Th12",-3,0,0,2,3,2,0x0,719,
    { 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0, 0xf0f00000},
    { 0x00110000, 0x00100010, 0x00100000, 0x00100000, 0x00100000, 0x00110000, 0x00100010, 0x00100000}
   , 0x0,0.000000,attributes+445,0,thrash_around_helper
,NULL,0,0.000000},
  {pat972,4,8, "Th13",0,-1,2,1,2,2,0x0,723,
    { 0x00fcfcfc, 0xf0f0f000, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xfcfc0000, 0x3f3f3f00, 0x00fcfcfc},
    { 0x00100040, 0x00100000, 0x00100000, 0x00100100, 0x00100000, 0x00100000, 0x01100000, 0x00100004}
   , 0x0,0.000000,attributes+447,0,thrash_around_helper
,NULL,0,0.000000},
  {pat973,6,8, "Th14",0,-2,2,0,2,2,0x0,647,
    { 0x00f0f0f0, 0xf0f00000, 0x3e3d0000, 0x003f3f1b, 0x00f0f090, 0xf0f00000, 0x3f3f0000, 0x003d3e3f},
    { 0x00100010, 0x00100000, 0x00100000, 0x00110001, 0x00100000, 0x00100000, 0x00110000, 0x00100011}
   , 0x0,0.000000,attributes+449,0,thrash_around_helper
,NULL,0,0.000000},
  {pat974,6,8, "Th15",0,-1,2,1,2,2,0x0,721,
    { 0x007cbcfc, 0x90f0f000, 0xf8f40000, 0x3f3f1b00, 0xf0f09000, 0xbc7c0000, 0x1b3f3f00, 0x00f4f8fc},
    { 0x00100044, 0x00100000, 0x00100000, 0x01100100, 0x00100000, 0x00100000, 0x01100100, 0x00100044}
   , 0x0,0.000000,attributes+451,0,thrash_around_helper
,NULL,0,0.000000},
  {pat975,6,8, "Th16",0,-2,2,2,2,4,0x0,648,
    { 0x00fcfc3d, 0xf0f0f000, 0xfdfc0000, 0x3f3f3c04, 0xf0f0f040, 0xfcfc0000, 0x3c3f3f01, 0x00fcfdf0},
    { 0x00100400, 0x00104000, 0x40100000, 0x04100000, 0x40100000, 0x04100000, 0x00100400, 0x00104000}
   , 0x0,0.000000,attributes+453,0,thrash_around_helper
,NULL,0,0.000000},
  {pat976,4,8, "Th17",0,-1,2,1,2,2,0x0,648,
    { 0x0030fc30, 0xc0f0c000, 0xfc300000, 0x0c3f0c00, 0xc0f0c000, 0xfc300000, 0x0c3f0c00, 0x0030fc30},
    { 0x00102400, 0x00904000, 0x60100000, 0x04180000, 0x40900000, 0x24100000, 0x00180400, 0x00106000}
   , 0x0,0.000000,attributes+455,0,thrash_around_helper
,NULL,0,0.000000},
  {pat977,4,8, "Th18",0,-1,2,1,2,2,0x0,648,
    { 0x0030fc30, 0xc0f0c000, 0xfc300000, 0x0c3f0c00, 0xc0f0c000, 0xfc300000, 0x0c3f0c00, 0x0030fc30},
    { 0x00102400, 0x00904000, 0x60100000, 0x04180000, 0x40900000, 0x24100000, 0x00180400, 0x00106000}
   , 0x10,0.000000,attributes+457,0,thrash_around_helper
,NULL,0,0.000000},
  {pat978,7,8, "Th19",0,-1,2,1,2,2,0x0,647,
    { 0x00f4fcfc, 0xf0f0d000, 0xfc7c0000, 0x1f3f3f00, 0xd0f0f000, 0xfcf40000, 0x3f3f1f00, 0x007cfcfc},
    { 0x00104410, 0x40104000, 0x44100000, 0x04110400, 0x40104000, 0x44100000, 0x04110400, 0x00104410}
   , 0x20,0.000000,attributes+459,0,thrash_around_helper
,NULL,0,0.000000},
  {pat979,3,8, "Th20",-1,-2,1,1,2,3,0x0,647,
    { 0xecfcfc00, 0xfcf8fc00, 0xfcffec00, 0xfcbcfc30, 0xfcf8fc30, 0xfcfcec00, 0xfcbcfc00, 0xecfffc00},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x10,0.000000,attributes+461,0,thrash_around_helper
,NULL,3,0.000000},
  {pat980,6,8, "Th21",0,-1,2,1,2,2,0x0,648,
    { 0x00f0fcf8, 0xf0f0c000, 0xfc3c0000, 0x0e3f3f00, 0xc0f0f000, 0xfcf00000, 0x3f3f0e00, 0x003cfcbc},
    { 0x00102410, 0x00904000, 0x60100000, 0x04190000, 0x40900000, 0x24100000, 0x00190400, 0x00106010}
   , 0x10,0.000000,attributes+463,0,thrash_around_helper
,NULL,0,0.000000},
  {pat981,6,8, "Th22",0,-2,2,0,2,2,0x2,611,
    { 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3f},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x10,0.000000,attributes+465,0,thrash_around_helper
,NULL,0,0.000000},
  {pat982,5,8, "Th23",0,-1,2,1,2,2,0x2,685,
    { 0x0030fcfc, 0xc0f0c000, 0xfc300000, 0x0f3f0f00, 0xc0f0c000, 0xfc300000, 0x0f3f0f00, 0x0030fcfc},
    { 0x00200400, 0x00204000, 0x40200000, 0x04200000, 0x40200000, 0x04200000, 0x00200400, 0x00204000}
   , 0x10,0.000000,attributes+467,0,thrash_around_helper
,NULL,3,0.000000},
  {pat983,3,8, "Th24",-1,-1,1,1,2,2,0x2,683,
    { 0xf4fcfc00, 0xfcfcf400, 0xfcfc7c00, 0x7cfcfc00, 0xf4fcfc00, 0xfcfcf400, 0xfcfc7c00, 0x7cfcfc00},
    { 0x00240000, 0x00201000, 0x00600000, 0x10200000, 0x10200000, 0x00240000, 0x00201000, 0x00600000}
   , 0x10,0.000000,attributes+469,0,thrash_around_helper
,NULL,3,0.000000},
  {pat984,17,4, "M1",-2,-2,2,2,4,4,0x0,685,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x0,0.000000,attributes+471,1,NULL,autohelperpat984,3,1.006000},
  {pat985,18,8, "M2",-1,-2,3,2,4,4,0x0,723,
    { 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xffffffff},
    { 0x00202010, 0x00a00000, 0x20200000, 0x00290000, 0x00a00000, 0x20200000, 0x00290000, 0x00202010}
   , 0x0,0.000000,attributes+473,1,NULL,autohelperpat985,3,1.006000},
  {pat986,19,8, "M3",-1,-1,3,3,4,4,0x0,759,
    { 0xffffffff, 0xfcfcfcfc, 0xfcfcfc00, 0xffffff00, 0xfcfcfc00, 0xffffff00, 0xffffffff, 0xfcfcfcfc},
    { 0x00280805, 0x0020a000, 0x80a00000, 0x29200000, 0xa0200000, 0x08280000, 0x00202901, 0x00a08040}
   , 0x0,0.000000,attributes+475,1,NULL,autohelperpat986,3,1.006000},
  {pat987,20,8, "M4",-1,-1,3,3,4,4,0x0,758,
    { 0xffffffff, 0xfcfcfcfc, 0xfcfcfc00, 0xffffff00, 0xfcfcfc00, 0xffffff00, 0xffffffff, 0xfcfcfcfc},
    { 0x00282905, 0x00a0a040, 0xa0a00000, 0x29280000, 0xa0a00000, 0x29280000, 0x00282905, 0x00a0a040}
   , 0x0,0.000000,attributes+477,1,NULL,autohelperpat987,3,1.006000},
  {pat988,20,8, "M5",-1,-1,3,3,4,4,0x0,720,
    { 0xffffffff, 0xfcfcfcfc, 0xfcfcfc00, 0xffffff00, 0xfcfcfc00, 0xffffff00, 0xffffffff, 0xfcfcfcfc},
    { 0x00292925, 0x00a0a050, 0xa0a00000, 0x292a0000, 0xa0a00000, 0x29290000, 0x002a2915, 0x00a0a060}
   , 0x0,0.000000,attributes+479,1,NULL,autohelperpat988,3,1.006000},
  {pat989,23,8, "M6",0,-2,4,2,4,4,0x0,651,
    { 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0x00ffffff},
    { 0x0010a4a4, 0x80904000, 0x68100000, 0x051a0a00, 0x40908000, 0xa4100000, 0x0a1a0500, 0x00106868}
   , 0x0,0.000000,attributes+481,1,NULL,autohelperpat989,0,1.006000},
  {pat990,24,8, "M7",0,-2,4,2,4,4,0x0,647,
    { 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0x00ffffff},
    { 0x0018a4a4, 0x80906000, 0x68900000, 0x251a0a00, 0x60908000, 0xa4180000, 0x0a1a2500, 0x00906868}
   , 0x0,0.000000,attributes+483,1,NULL,autohelperpat990,0,1.006000},
  {pat991,23,8, "M8",0,-1,4,3,4,4,0x0,650,
    { 0x00ffffff, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0x00fcfcfc},
    { 0x00162929, 0x00909060, 0xa0500000, 0x1a1a0000, 0x90900000, 0x29160000, 0x001a1a25, 0x0050a0a0}
   , 0x0,0.000000,attributes+485,1,NULL,autohelperpat991,0,1.006000},
  {pat992,2,2, "Conn101",0,0,0,2,0,2,0x0,721,
    { 0x003f0000, 0x00303030, 0x00f00000, 0x30300000, 0x30300000, 0x003f0000, 0x00303030, 0x00f00000},
    { 0x00110000, 0x00100010, 0x00100000, 0x00100000, 0x00100000, 0x00110000, 0x00100010, 0x00100000}
   , 0x80,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat993,2,4, "Conn102",0,0,1,2,1,2,0x0,722,
    { 0x003f0c00, 0x0030f030, 0xc0f00000, 0x3c300000, 0xf0300000, 0x0c3f0000, 0x00303c30, 0x00f0c000},
    { 0x00110000, 0x00100010, 0x00100000, 0x00100000, 0x00100000, 0x00110000, 0x00100010, 0x00100000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat993,0,1.960000},
  {pat994,3,8, "Conn103",0,0,1,2,1,2,0x0,685,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00110000, 0x00100010, 0x00100000, 0x00100000, 0x00100000, 0x00110000, 0x00100010, 0x00100000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat994,0,1.600000},
  {pat995,3,8, "Conn104",0,-1,1,2,1,3,0x0,648,
    { 0x00ffff00, 0xf0f0f0f0, 0xfcfc0000, 0x3c3c3c00, 0xf0f0f000, 0xffff0000, 0x3c3c3c3c, 0x00fcfc00},
    { 0x00110000, 0x00100010, 0x00100000, 0x00100000, 0x00100000, 0x00110000, 0x00100010, 0x00100000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat995,0,4.800000},
  {pat996,4,8, "Conn105",0,0,1,2,1,2,0x0,722,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00190000, 0x00102010, 0x00900000, 0x20100000, 0x20100000, 0x00190000, 0x00102010, 0x00900000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat996,0,5.000000},
  {pat997,3,8, "Conn106",-1,-1,1,2,2,3,0x0,647,
    { 0x0cffff00, 0xf0f0fcf0, 0xfcfcc000, 0xfc3c3c00, 0xfcf0f000, 0xffff0c00, 0x3c3cfc3c, 0xc0fcfc00},
    { 0x00110000, 0x00100010, 0x00100000, 0x00100000, 0x00100000, 0x00110000, 0x00100010, 0x00100000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat997,0,1.000000},
  {pat998,3,4, "Conn201",0,0,1,1,1,1,0x0,721,
    { 0x003c1c00, 0x0070f000, 0xd0f00000, 0x3c340000, 0xf0700000, 0x1c3c0000, 0x00343c00, 0x00f0d000},
    { 0x00100400, 0x00104000, 0x40100000, 0x04100000, 0x40100000, 0x04100000, 0x00100400, 0x00104000}
   , 0x80,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat999,4,8, "Conn202",0,0,1,2,1,2,0x0,758,
    { 0x003f1c00, 0x0070f030, 0xd0f00000, 0x3c340000, 0xf0700000, 0x1c3f0000, 0x00343c30, 0x00f0d000},
    { 0x00100400, 0x00104000, 0x40100000, 0x04100000, 0x40100000, 0x04100000, 0x00100400, 0x00104000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat999,0,1.960000},
  {pat1000,4,4, "Conn203",0,0,2,2,2,2,0x0,760,
    { 0x003c3c03, 0x00f0f000, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3c3c0000, 0x003c3c03, 0x00f0f000},
    { 0x00241000, 0x00601000, 0x10600000, 0x10240000, 0x10600000, 0x10240000, 0x00241000, 0x00601000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1000,3,1.000000},
  {pat1001,3,8, "Conn204",0,-1,1,1,1,2,0x0,648,
    { 0x003cfc00, 0xc0f0f000, 0xfcf00000, 0x3c3c0c00, 0xf0f0c000, 0xfc3c0000, 0x0c3c3c00, 0x00f0fc00},
    { 0x00241000, 0x00601000, 0x10600000, 0x10240000, 0x10600000, 0x10240000, 0x00241000, 0x00601000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1001,3,1.000000},
  {pat1002,4,8, "Conn205",0,0,1,2,1,2,0x0,758,
    { 0x003f3c00, 0x00f0f030, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3c3f0000, 0x003c3c30, 0x00f0f000},
    { 0x00241000, 0x00601000, 0x10600000, 0x10240000, 0x10600000, 0x10240000, 0x00241000, 0x00601000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1002,3,3.000000},
  {pat1003,8,8, "Conn206",0,-2,2,0,2,2,0x0,612,
    { 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3f},
    { 0x00106080, 0x40900000, 0x24100000, 0x00180600, 0x00904000, 0x60100000, 0x06180000, 0x00102408}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1003,0,1.000000},
  {pat1004,9,8, "Conn207",0,-2,3,0,3,2,0x0,612,
    { 0x00f0f0f0, 0xf0f00000, 0x3f3c0000, 0x003f3f0f, 0x00f0f0c0, 0xf0f00000, 0x3f3f0000, 0x003c3f3f},
    { 0x00202090, 0x00a00000, 0x20200000, 0x00290200, 0x00a00000, 0x20200000, 0x02290000, 0x00202018}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1004,3,0.010000},
  {pat1005,3,8, "Conn301",0,0,1,2,1,2,0x0,721,
    { 0x003f0f00, 0x0030f0f0, 0xc0f00000, 0x3c300000, 0xf0300000, 0x0f3f0000, 0x00303c3c, 0x00f0c000},
    { 0x00100100, 0x00100040, 0x00100000, 0x00100000, 0x00100000, 0x01100000, 0x00100004, 0x00100000}
   , 0x80,0.000000,attributes+0,0,NULL,NULL,0,0.000000},
  {pat1006,3,8, "Conn302",0,0,1,2,1,2,0x0,722,
    { 0x003c3f00, 0x00f0f0c0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3c0000, 0x003c3c0c, 0x00f0f000},
    { 0x00102100, 0x00900040, 0x20100000, 0x00180000, 0x00900000, 0x21100000, 0x00180004, 0x00102000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1006,0,3.000000},
  {pat1007,4,8, "Conn303",0,0,1,3,1,3,0x0,795,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00100100, 0x00100040, 0x00100000, 0x00100000, 0x00100000, 0x01100000, 0x00100004, 0x00100000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1007,0,5.880000},
  {pat1008,5,8, "Conn304",0,0,1,3,1,3,0x0,795,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00102100, 0x00900040, 0x20100000, 0x00180000, 0x00900000, 0x21100000, 0x00180004, 0x00102000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1008,0,5.880000},
  {pat1009,4,8, "Conn305",0,0,1,3,1,3,0x0,796,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00100100, 0x00100040, 0x00100000, 0x00100000, 0x00100000, 0x01100000, 0x00100004, 0x00100000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1009,0,4.800000},
  {pat1010,5,8, "Conn306",0,0,1,3,1,3,0x0,796,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00102100, 0x00900040, 0x20100000, 0x00180000, 0x00900000, 0x21100000, 0x00180004, 0x00102000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1010,0,4.800000},
  {pat1011,4,8, "Conn307",0,0,1,3,1,3,0x0,796,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00120100, 0x00100060, 0x00100000, 0x00100000, 0x00100000, 0x01120000, 0x00100024, 0x00100000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1011,0,4.800000},
  {pat1012,3,8, "Conn308",0,0,1,2,1,2,0x0,758,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00100100, 0x00100040, 0x00100000, 0x00100000, 0x00100000, 0x01100000, 0x00100004, 0x00100000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1012,0,3.000000},
  {pat1013,4,8, "Conn309",0,0,1,2,1,2,0x0,758,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00102100, 0x00900040, 0x20100000, 0x00180000, 0x00900000, 0x21100000, 0x00180004, 0x00102000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1013,0,3.000000},
  {pat1014,4,8, "Conn310",-1,0,1,2,2,2,0x0,757,
    { 0x3f3f3f00, 0x00fcfcfc, 0xf0f0f000, 0xfcfc0000, 0xfcfc0000, 0x3f3f3f00, 0x00fcfcfc, 0xf0f0f000},
    { 0x00100100, 0x00100040, 0x00100000, 0x00100000, 0x00100000, 0x01100000, 0x00100004, 0x00100000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1014,0,4.800000},
  {pat1015,4,8, "Conn311",0,0,1,2,1,2,0x0,721,
    { 0x003f0f00, 0x0030f0f0, 0xc0f00000, 0x3c300000, 0xf0300000, 0x0f3f0000, 0x00303c3c, 0x00f0c000},
    { 0x00100900, 0x00108040, 0x80100000, 0x08100000, 0x80100000, 0x09100000, 0x00100804, 0x00108000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1015,0,3.000000},
  {pat1016,5,8, "Conn312",0,0,1,2,1,2,0x0,758,
    { 0x003f1f00, 0x0070f0f0, 0xd0f00000, 0x3c340000, 0xf0700000, 0x1f3f0000, 0x00343c3c, 0x00f0d000},
    { 0x00100900, 0x00108040, 0x80100000, 0x08100000, 0x80100000, 0x09100000, 0x00100804, 0x00108000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1016,0,1.000000},
  {pat1017,5,8, "Conn313",0,-1,2,1,2,2,0x0,722,
    { 0x00fcfc7c, 0xf0f0f000, 0xfcfc0000, 0x3f3f3d00, 0xf0f0f000, 0xfcfc0000, 0x3d3f3f00, 0x00fcfcf4},
    { 0x00104024, 0x40100000, 0x04100000, 0x01120400, 0x00104000, 0x40100000, 0x04120100, 0x00100460}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1017,0,4.800000},
  {pat1018,6,8, "Conn314",-1,0,1,2,2,2,0x0,758,
    { 0x3f3f1f00, 0x007cfcfc, 0xd0f0f000, 0xfcf40000, 0xfc7c0000, 0x1f3f3f00, 0x00f4fcfc, 0xf0f0d000},
    { 0x00100900, 0x00108040, 0x80100000, 0x08100000, 0x80100000, 0x09100000, 0x00100804, 0x00108000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1018,0,5.000000},
  {pat1019,4,8, "Conn315",0,0,1,2,1,2,0x0,721,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00120900, 0x00108060, 0x80100000, 0x08100000, 0x80100000, 0x09120000, 0x00100824, 0x00108000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1019,0,3.000000},
  {pat1020,5,8, "Conn401",0,0,1,3,1,3,0x0,795,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00101100, 0x00500040, 0x10100000, 0x00140000, 0x00500000, 0x11100000, 0x00140004, 0x00101000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1020,0,3.000000},
  {pat1021,5,8, "Conn402",0,0,1,3,1,3,0x0,796,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00101100, 0x00500040, 0x10100000, 0x00140000, 0x00500000, 0x11100000, 0x00140004, 0x00101000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1021,0,3.000000},
  {pat1022,4,8, "Conn403",0,0,1,2,1,2,0x0,759,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00111000, 0x00500010, 0x10100000, 0x00140000, 0x00500000, 0x10110000, 0x00140010, 0x00101000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1022,0,1.000000},
  {pat1023,3,4, "Conn501",0,0,0,3,0,3,0x0,721,
    { 0x003f0000, 0x00303030, 0x00f00000, 0x30300000, 0x30300000, 0x003f0000, 0x00303030, 0x00f00000},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1023,0,1.000000},
  {pat1024,5,8, "Conn502",0,0,1,3,1,3,0x0,721,
    { 0x003f0f00, 0x0030f0f0, 0xc0f00000, 0x3c300000, 0xf0300000, 0x0f3f0000, 0x00303c3c, 0x00f0c000},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1024,0,5.000000},
  {pat1025,5,8, "Conn503",0,0,1,3,1,3,0x0,685,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1025,0,5.160000},
  {pat1026,5,8, "Conn504",0,0,1,3,1,3,0x0,722,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1026,0,4.680000},
  {pat1027,7,8, "Conn505",-1,0,1,3,2,3,0x0,722,
    { 0x0f3f3f00, 0x00f0fcfc, 0xf0f0c000, 0xfc3c0000, 0xfcf00000, 0x3f3f0f00, 0x003cfcfc, 0xc0f0f000},
    { 0x00180000, 0x00102000, 0x00900000, 0x20100000, 0x20100000, 0x00180000, 0x00102000, 0x00900000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1027,0,10.000000},
  {pat1028,7,8, "Conn506",0,0,1,3,1,3,0x0,685,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00180400, 0x00106000, 0x40900000, 0x24100000, 0x60100000, 0x04180000, 0x00102400, 0x00904000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1028,0,4.800000},
  {pat1029,6,8, "Conn507",0,0,1,3,1,3,0x0,722,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00102000, 0x00900000, 0x20100000, 0x00180000, 0x00900000, 0x20100000, 0x00180000, 0x00102000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1029,0,1.600000},
  {pat1030,4,8, "Conn508",0,0,1,3,1,3,0x0,722,
    { 0x003f0f00, 0x0030f0f0, 0xc0f00000, 0x3c300000, 0xf0300000, 0x0f3f0000, 0x00303c3c, 0x00f0c000},
    { 0x00100100, 0x00100040, 0x00100000, 0x00100000, 0x00100000, 0x01100000, 0x00100004, 0x00100000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1030,0,1.600000},
  {pat1031,9,8, "Conn509",0,-2,2,1,2,3,0x2,685,
    { 0x00f0fcfc, 0xf0f0c000, 0xff3e0000, 0x0f3f3f2f, 0xc0f0f0e0, 0xfcf00000, 0x3f3f0f00, 0x003effff},
    { 0x00208400, 0x80204000, 0x49200000, 0x04200804, 0x40208040, 0x84200000, 0x08200400, 0x00204900}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1031,3,3.880000},
  {pat1032,8,8, "Conn509b",0,-2,2,1,2,3,0x2,685,
    { 0x00f0fcfc, 0xf0f0c000, 0xff3c0000, 0x0f3f3f0f, 0xc0f0f0c0, 0xfcf00000, 0x3f3f0f00, 0x003cffff},
    { 0x00208400, 0x80204000, 0x49200000, 0x04200804, 0x40208040, 0x84200000, 0x08200400, 0x00204900}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1032,3,10.000000},
  {pat1033,12,4, "Conn510",0,0,3,3,3,3,0x0,759,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1033,0,3.328000},
  {pat1034,6,8, "Conn601",0,0,1,3,1,3,0x0,721,
    { 0x003f0f00, 0x0030f0f0, 0xc0f00000, 0x3c300000, 0xf0300000, 0x0f3f0000, 0x00303c3c, 0x00f0c000},
    { 0x00100800, 0x00108000, 0x80100000, 0x08100000, 0x80100000, 0x08100000, 0x00100800, 0x00108000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1034,0,4.800000},
  {pat1035,5,8, "Conn602",0,0,1,3,1,3,0x0,685,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1035,0,5.160000},
  {pat1036,7,8, "Conn603",-1,0,1,3,2,3,0x0,758,
    { 0x3f3f0f00, 0x003cfcfc, 0xc0f0f000, 0xfcf00000, 0xfc3c0000, 0x0f3f3f00, 0x00f0fcfc, 0xf0f0c000},
    { 0x00100200, 0x00100080, 0x00100000, 0x00100000, 0x00100000, 0x02100000, 0x00100008, 0x00100000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1036,0,5.000000},
  {pat1037,7,8, "Conn603b",-1,0,1,3,2,3,0x0,758,
    { 0x3f3f0f00, 0x003cfcfc, 0xc0f0f000, 0xfcf00000, 0xfc3c0000, 0x0f3f3f00, 0x00f0fcfc, 0xf0f0c000},
    { 0x00100200, 0x00100080, 0x00100000, 0x00100000, 0x00100000, 0x02100000, 0x00100008, 0x00100000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1037,0,10.000000},
  {pat1038,5,8, "Conn604",0,0,1,3,1,3,0x0,722,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1038,0,6.800000},
  {pat1039,6,8, "Conn605",0,0,1,3,1,3,0x0,722,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00102000, 0x00900000, 0x20100000, 0x00180000, 0x00900000, 0x20100000, 0x00180000, 0x00102000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1039,0,5.600000},
  {pat1040,5,8, "Conn606",0,0,1,3,1,3,0x0,721,
    { 0x003f0f00, 0x0030f0f0, 0xc0f00000, 0x3c300000, 0xf0300000, 0x0f3f0000, 0x00303c3c, 0x00f0c000},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1040,0,4.800000},
  {pat1041,8,8, "Conn607",0,0,2,3,2,3,0x0,759,
    { 0x003f3f0f, 0x00f0f0f0, 0xf0f00000, 0x3f3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3f3f, 0x00f0f0c0},
    { 0x00101008, 0x00500000, 0x10100000, 0x02140000, 0x00500000, 0x10100000, 0x00140200, 0x00101080}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1041,0,3.000000},
  {pat1042,7,8, "Conn608",-1,0,1,3,2,3,0x0,758,
    { 0x3f3f0f00, 0x003cfcfc, 0xc0f0f000, 0xfcf00000, 0xfc3c0000, 0x0f3f3f00, 0x00f0fcfc, 0xf0f0c000},
    { 0x00100800, 0x00108000, 0x80100000, 0x08100000, 0x80100000, 0x08100000, 0x00100800, 0x00108000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1042,0,5.000000},
  {pat1043,11,8, "Conn609",0,0,2,4,2,4,0x2,758,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00100200, 0x00100080, 0x00100000, 0x00100000, 0x00100000, 0x02100000, 0x00100008, 0x00100000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1043,0,2.800000},
  {pat1044,5,8, "Conn610",0,0,1,3,1,3,0x2,722,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x001a0000, 0x00102020, 0x00900000, 0x20100000, 0x20100000, 0x001a0000, 0x00102020, 0x00900000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1044,0,2.608000},
  {pat1045,6,8, "Conn611",0,0,1,3,1,3,0x2,722,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00180000, 0x00102000, 0x00900000, 0x20100000, 0x20100000, 0x00180000, 0x00102000, 0x00900000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1045,0,3.960000},
  {pat1046,5,8, "Conn701",0,0,1,3,1,3,0x0,759,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00101000, 0x00500000, 0x10100000, 0x00140000, 0x00500000, 0x10100000, 0x00140000, 0x00101000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1046,0,3.000000},
  {pat1047,5,8, "Conn702",0,0,1,3,1,3,0x0,759,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00121000, 0x00500020, 0x10100000, 0x00140000, 0x00500000, 0x10120000, 0x00140020, 0x00101000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1047,0,3.000000},
  {pat1048,6,8, "Conn703",0,0,1,3,1,3,0x0,758,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00101200, 0x00500080, 0x10100000, 0x00140000, 0x00500000, 0x12100000, 0x00140008, 0x00101000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1048,0,3.960000},
  {pat1049,8,8, "Conn704",-1,0,1,3,2,3,0x0,794,
    { 0x0f3f3f00, 0x00f0fcfc, 0xf0f0c000, 0xfc3c0000, 0xfcf00000, 0x3f3f0f00, 0x003cfcfc, 0xc0f0f000},
    { 0x00101000, 0x00500000, 0x10100000, 0x00140000, 0x00500000, 0x10100000, 0x00140000, 0x00101000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1049,0,3.880000},
  {pat1050,6,8, "Conn705",0,0,1,3,1,3,0x0,795,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00101000, 0x00500000, 0x10100000, 0x00140000, 0x00500000, 0x10100000, 0x00140000, 0x00101000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1050,0,4.800000},
  {pat1051,11,8, "Conn706",0,0,2,3,2,3,0x2,759,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x001a1000, 0x00502020, 0x10900000, 0x20140000, 0x20500000, 0x101a0000, 0x00142020, 0x00901000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1051,0,2.800000},
  {pat1052,10,8, "Conn707",0,0,2,3,2,3,0x2,759,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00121000, 0x00500020, 0x10100000, 0x00140000, 0x00500000, 0x10120000, 0x00140020, 0x00101000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1052,0,6.528000},
  {pat1053,7,8, "Conn708",0,0,1,3,1,3,0x0,721,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00101800, 0x00508000, 0x90100000, 0x08140000, 0x80500000, 0x18100000, 0x00140800, 0x00109000}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1053,0,4.800000},
  {pat1054,4,8, "Conn801",0,-1,1,2,1,3,0x0,721,
    { 0x00ffff00, 0xf0f0f0f0, 0xfcfc0000, 0x3c3c3c00, 0xf0f0f000, 0xffff0000, 0x3c3c3c3c, 0x00fcfc00},
    { 0x00104100, 0x40100040, 0x04100000, 0x00100400, 0x00104000, 0x41100000, 0x04100004, 0x00100400}
   , 0x80,0.000000,attributes+0,1,NULL,autohelperpat1054,0,0.010000},
  {pat1055,6,4, "Cut101",-1,0,1,2,2,2,0x0,721,
    { 0x3f3f3b00, 0x00fcbcfc, 0xb0f0f000, 0xf8fc0000, 0xbcfc0000, 0x3b3f3f00, 0x00fcf8fc, 0xf0f0b000},
    { 0x00221100, 0x00600060, 0x10200000, 0x00240000, 0x00600000, 0x11220000, 0x00240024, 0x00201000}
   , 0x201,0.000000,attributes+0,1,NULL,autohelperpat1055,3,0.021760},
  {pat1056,3,4, "Cut201",0,0,1,1,1,1,0x0,721,
    { 0x003c3c00, 0x00f0f000, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3c3c0000, 0x003c3c00, 0x00f0f000},
    { 0x00201800, 0x00608000, 0x90200000, 0x08240000, 0x80600000, 0x18200000, 0x00240800, 0x00209000}
   , 0x201,0.000000,attributes+0,1,NULL,autohelperpat1056,3,3.000000},
  {pat1057,4,8, "Cut302",0,0,1,2,1,2,0x0,721,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00200600, 0x00204080, 0x40200000, 0x04200000, 0x40200000, 0x06200000, 0x00200408, 0x00204000}
   , 0x201,0.000000,attributes+0,1,NULL,autohelperpat1057,3,3.000000},
  {pat1058,4,8, "Cut303",0,0,1,2,1,2,0x0,721,
    { 0x003f0f00, 0x0030f0f0, 0xc0f00000, 0x3c300000, 0xf0300000, 0x0f3f0000, 0x00303c3c, 0x00f0c000},
    { 0x00210600, 0x00204090, 0x40200000, 0x04200000, 0x40200000, 0x06210000, 0x00200418, 0x00204000}
   , 0x200,0.000000,attributes+0,1,NULL,autohelperpat1058,3,5.776000},
  {pat1059,5,8, "Cut304",0,-1,2,1,2,2,0x0,686,
    { 0x003cfc3c, 0xc0f0f000, 0xfcf00000, 0x3f3f0c00, 0xf0f0c000, 0xfc3c0000, 0x0c3f3f00, 0x00f0fcf0},
    { 0x00148008, 0x80101000, 0x08500000, 0x12100800, 0x10108000, 0x80140000, 0x08101200, 0x00500880}
   , 0x201,0.000000,attributes+0,1,NULL,autohelperpat1059,0,9.000000},
  {pat1060,9,8, "Cut501",0,0,2,3,2,3,0x2,759,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00210000, 0x00200010, 0x00200000, 0x00200000, 0x00200000, 0x00210000, 0x00200010, 0x00200000}
   , 0x201,0.000000,attributes+0,1,NULL,autohelperpat1060,3,3.106000},
  {pat1061,10,8, "Cut601",0,0,2,3,2,3,0x2,722,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00240000, 0x00201000, 0x00600000, 0x10200000, 0x10200000, 0x00240000, 0x00201000, 0x00600000}
   , 0x201,0.000000,attributes+0,1,NULL,autohelperpat1061,3,5.600000},
  {pat1062,7,8, "AS1",0,-1,2,1,2,2,0x2,686,
    { 0x003cfcfc, 0xc0f0f000, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xfc3c0000, 0x0f3f3f00, 0x00f0fcfc},
    { 0x00249000, 0x80601000, 0x18600000, 0x10240800, 0x10608000, 0x90240000, 0x08241000, 0x00601800}
   , 0x0,0.000000,attributes+487,1,NULL,autohelperpat1062,3,1.960000},
  {pat1063,7,8, "AS2",0,-1,2,1,2,2,0x2,649,
    { 0x003cfcfc, 0xc0f0f000, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xfc3c0000, 0x0f3f3f00, 0x00f0fcfc},
    { 0x00249000, 0x80601000, 0x18600000, 0x10240800, 0x10608000, 0x90240000, 0x08241000, 0x00601800}
   , 0x0,0.000000,attributes+0,3,NULL,autohelperpat1063,3,1.600000},
  {pat1064,5,8, "AS3",0,0,1,2,1,2,0x2,685,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00160800, 0x00109020, 0x80500000, 0x18100000, 0x90100000, 0x08160000, 0x00101820, 0x00508000}
   , 0x15,0.000000,attributes+0,3,NULL,autohelperpat1064,0,0.376000},
  {pat1065,5,8, "AS4",0,-1,2,0,2,1,0xa,647,
    { 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0x003f3f00, 0x00f0f000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c},
    { 0x00106010, 0x40900000, 0x24100000, 0x00190400, 0x00904000, 0x60100000, 0x04190000, 0x00102410}
   , 0x4,0.000000,attributes+0,3,NULL,autohelperpat1065,0,0.610000},
  {pat1066,13,8, "AS5",0,-1,3,2,3,3,0x2,723,
    { 0x003cffff, 0xc0f0f0c0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3c0000, 0x0f3f3f0f, 0x00f0fcfc},
    { 0x00249090, 0x80601000, 0x18600000, 0x10250a00, 0x10608000, 0x90240000, 0x0a251000, 0x00601818}
   , 0x5,0.000000,attributes+0,3,NULL,autohelperpat1066,3,1.000000},
  {pat1067,5,8, "AS6",0,-1,2,0,2,1,0xa,686,
    { 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0x003f3f00, 0x00f0f000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c},
    { 0x00106080, 0x40900000, 0x24100000, 0x00180600, 0x00904000, 0x60100000, 0x06180000, 0x00102408}
   , 0x10,0.000000,attributes+0,3,NULL,autohelperpat1067,0,0.034000},
  {pat1068,4,8, "AS7",0,-1,1,2,1,3,0x2,685,
    { 0x003cbe00, 0x80f0f080, 0xf8f00000, 0x3c3c0800, 0xf0f08000, 0xbe3c0000, 0x083c3c08, 0x00f0f800},
    { 0x00280000, 0x00202000, 0x00a00000, 0x20200000, 0x20200000, 0x00280000, 0x00202000, 0x00a00000}
   , 0x4,0.000000,attributes+489,1,NULL,autohelperpat1068,3,0.717712},
  {pat1069,2,8, "Shape1",0,0,1,1,1,1,0x0,722,
    { 0x003c3c00, 0x00f0f000, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3c3c0000, 0x003c3c00, 0x00f0f000},
    { 0x00140000, 0x00101000, 0x00500000, 0x10100000, 0x10100000, 0x00140000, 0x00101000, 0x00500000}
   , 0x0,0.000000,attributes+491,1,NULL,autohelperpat1069,0,0.029200},
  {pat1070,2,4, "Shape2",0,0,1,1,1,1,0x0,721,
    { 0x003c3c00, 0x00f0f000, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3c3c0000, 0x003c3c00, 0x00f0f000},
    { 0x00100400, 0x00104000, 0x40100000, 0x04100000, 0x40100000, 0x04100000, 0x00100400, 0x00104000}
   , 0x0,0.000000,attributes+493,1,NULL,autohelperpat1070,0,0.022000},
  {pat1071,3,4, "Shape3",0,0,1,1,1,1,0x0,721,
    { 0x003c3c00, 0x00f0f000, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3c3c0000, 0x003c3c00, 0x00f0f000},
    { 0x00101400, 0x00504000, 0x50100000, 0x04140000, 0x40500000, 0x14100000, 0x00140400, 0x00105000}
   , 0x0,0.000000,attributes+495,1,NULL,autohelperpat1071,0,0.022000},
  {pat1072,8,8, "Shape4",0,-2,2,0,2,2,0x0,610,
    { 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3d, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3d},
    { 0x001060a0, 0x40900000, 0x24100000, 0x001a0600, 0x00904000, 0x60100000, 0x061a0000, 0x00102428}
   , 0x0,0.000000,attributes+497,1,NULL,autohelperpat1072,0,1.000000},
  {pat1073,7,8, "Shape5",0,-1,2,2,2,3,0x0,686,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x0011060a, 0x00104090, 0x40100000, 0x06100000, 0x40100000, 0x06110000, 0x0010061a, 0x00104080}
   , 0x0,0.000000,attributes+499,0,NULL,NULL,0,0.000000},
  {pat1074,7,4, "Shape6",0,-2,2,0,2,2,0x0,610,
    { 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3f},
    { 0x00101060, 0x00500000, 0x10100000, 0x00160101, 0x00500000, 0x10100000, 0x01160000, 0x00101025}
   , 0x0,0.000000,attributes+501,1,NULL,autohelperpat1074,0,1.000000},
  {pat1075,7,4, "Shape6b",0,-2,2,0,2,2,0x0,610,
    { 0x00f0f0e0, 0xf0f00000, 0x3f3f0000, 0x003e3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3e0000, 0x003f3f2f},
    { 0x00101040, 0x00500000, 0x10100000, 0x00140101, 0x00500000, 0x10100000, 0x01140000, 0x00101005}
   , 0x0,0.000000,attributes+503,0,NULL,NULL,0,0.000000},
  {pat1076,7,4, "Shape7",0,-2,2,0,2,2,0x0,610,
    { 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3f},
    { 0x00202090, 0x00a00000, 0x20200000, 0x00290202, 0x00a00000, 0x20200000, 0x02290000, 0x0020201a}
   , 0x0,0.000000,attributes+505,0,NULL,NULL,3,0.000000},
  {pat1077,9,4, "Shape8a",-2,0,1,2,3,2,0x0,720,
    { 0x3f3f3f00, 0x00ffffff, 0xf0f0f0f0, 0xfcfc0000, 0xffff0000, 0x3f3f3f3f, 0x00fcfcfc, 0xf0f0f000},
    { 0x00190400, 0x00106010, 0x40900000, 0x24100000, 0x60100000, 0x04190000, 0x00102410, 0x00904000}
   , 0x0,0.000000,attributes+507,0,NULL,NULL,0,0.000000},
  {pat1078,9,8, "Shape8b",-2,0,1,2,3,2,0x0,720,
    { 0x3f3f3f00, 0x00ffffff, 0xf0f0f0f0, 0xfcfc0000, 0xffff0000, 0x3f3f3f3f, 0x00fcfcfc, 0xf0f0f000},
    { 0x00190500, 0x00106050, 0x40900000, 0x24100000, 0x60100000, 0x05190000, 0x00102414, 0x00904000}
   , 0x0,0.000000,attributes+509,0,NULL,NULL,0,0.000000},
  {pat1079,9,8, "Shape8c",-2,0,1,2,3,2,0x0,720,
    { 0x3e3f3f00, 0x00fffffb, 0xf0f0f0f0, 0xfcfc0000, 0xffff0000, 0x3f3f3e3f, 0x00fcfcbc, 0xf0f0f000},
    { 0x00190600, 0x00106090, 0x40900000, 0x24100000, 0x60100000, 0x06190000, 0x00102418, 0x00904000}
   , 0x0,0.000000,attributes+511,0,NULL,NULL,0,0.000000},
  {pat1080,14,8, "Shape8d",-2,0,2,2,4,2,0x0,720,
    { 0x2f3f3f1d, 0x00fbffff, 0xf0f0e0f0, 0xffbd0000, 0xfffb0000, 0x3f3f2f3f, 0x00bdfffd, 0xe0f0f0d0},
    { 0x00192408, 0x00906010, 0x60900000, 0x26180000, 0x60900000, 0x24190000, 0x00182610, 0x00906080}
   , 0x0,0.000000,attributes+513,0,NULL,NULL,0,0.000000},
  {pat1081,10,4, "Shape9a",-2,0,1,2,3,2,0x0,720,
    { 0x2e3f3f00, 0x00fafefa, 0xf0f0e0a0, 0xfcbc0000, 0xfefa0000, 0x3f3f2e2a, 0x00bcfcbc, 0xe0f0f000},
    { 0x00260800, 0x00209020, 0x80600000, 0x18200000, 0x90200000, 0x08260000, 0x00201820, 0x00608000}
   , 0x0,0.000000,attributes+515,1,NULL,autohelperpat1081,3,0.024580},
  {pat1082,10,8, "Shape9b",-2,0,1,2,3,2,0x0,720,
    { 0x2e3f3f00, 0x00fafefa, 0xf0f0e0a0, 0xfcbc0000, 0xfefa0000, 0x3f3f2e2a, 0x00bcfcbc, 0xe0f0f000},
    { 0x00260a00, 0x002090a0, 0x80600000, 0x18200000, 0x90200000, 0x0a260000, 0x00201828, 0x00608000}
   , 0x0,0.000000,attributes+517,1,NULL,autohelperpat1082,3,0.098483},
  {pat1083,10,8, "Shape9c",-2,0,1,2,3,2,0x0,720,
    { 0x2e3f3f00, 0x00fafefa, 0xf0f0e0a0, 0xfcbc0000, 0xfefa0000, 0x3f3f2e2a, 0x00bcfcbc, 0xe0f0f000},
    { 0x00260900, 0x00209060, 0x80600000, 0x18200000, 0x90200000, 0x09260000, 0x00201824, 0x00608000}
   , 0x0,0.000000,attributes+519,1,NULL,autohelperpat1083,3,0.115279},
  {pat1084,10,8, "Shape10",0,-1,3,1,3,2,0x0,649,
    { 0x0074fcfc, 0xd0f0d000, 0xfc740000, 0x1f3f1f00, 0xd0f0d000, 0xfc740000, 0x1f3f1f00, 0x0074fcfc},
    { 0x00200824, 0x00208000, 0x80200000, 0x09220000, 0x80200000, 0x08200000, 0x00220900, 0x00208060}
   , 0x0,0.000000,attributes+521,0,NULL,NULL,3,0.000000},
  {pat1085,9,8, "Shape11",-1,-3,2,0,3,3,0x0,647,
    { 0xd0f0f0c0, 0xfcf40000, 0x3f3f1f00, 0x007cfffc, 0x00f4fcfc, 0xf0f0d000, 0xff7c0000, 0x1f3f3f0c},
    { 0x00206080, 0x40a00000, 0x24200000, 0x00280600, 0x00a04000, 0x60200000, 0x06280000, 0x00202408}
   , 0x0,0.000000,attributes+523,1,NULL,autohelperpat1085,3,0.016000},
  {pat1086,13,8, "Shape12",-2,-3,3,0,5,3,0x0,647,
    { 0xf0f0f0f0, 0xfffd0000, 0x3f3f3f1f, 0x00fffffc, 0x00fdffff, 0xf0f0f0d0, 0xffff0000, 0x3f3f3f3c},
    { 0x00206060, 0x40a00000, 0x24200000, 0x002a0500, 0x00a04000, 0x60200000, 0x052a0000, 0x00202424}
   , 0x0,0.000000,attributes+525,1,NULL,autohelperpat1086,3,0.010000},
  {pat1087,7,8, "Shape12b",-1,-2,1,0,2,2,0x0,647,
    { 0xd0f0f000, 0xfcf40000, 0x3f3f1f00, 0x007cfcfc, 0x00f4fcfc, 0xf0f0d000, 0xfc7c0000, 0x1f3f3f00},
    { 0x00206000, 0x40a00000, 0x24200000, 0x00280400, 0x00a04000, 0x60200000, 0x04280000, 0x00202400}
   , 0x0,0.000000,attributes+527,1,NULL,autohelperpat1087,3,3.600000},
  {pat1088,5,8, "Shape13",0,-1,2,1,2,2,0x0,648,
    { 0x0030fcfc, 0xc0f0c000, 0xfc300000, 0x0f3f0f00, 0xc0f0c000, 0xfc300000, 0x0f3f0f00, 0x0030fcfc},
    { 0x00200410, 0x00204000, 0x40200000, 0x04210000, 0x40200000, 0x04200000, 0x00210400, 0x00204010}
   , 0x0,0.000000,attributes+529,1,NULL,autohelperpat1088,3,4.803600},
  {pat1089,8,8, "Shape14",0,-1,2,2,2,3,0x0,723,
    { 0x007cfd7c, 0xd0f0f040, 0xfcf40000, 0x3f3f1d00, 0xf0f0d000, 0xfd7c0000, 0x1d3f3f04, 0x00f4fcf4},
    { 0x00241020, 0x00601000, 0x10600000, 0x10260000, 0x10600000, 0x10240000, 0x00261000, 0x00601020}
   , 0x4,0.000000,attributes+531,1,NULL,autohelperpat1089,3,1.960000},
  {pat1090,8,8, "Shape15",0,-1,2,2,2,3,0x0,759,
    { 0x007cff74, 0xd0f0f0c0, 0xfcf40000, 0x3d3f1d00, 0xf0f0d000, 0xff7c0000, 0x1d3f3d0c, 0x00f4fc74},
    { 0x00241020, 0x00601000, 0x10600000, 0x10260000, 0x10600000, 0x10240000, 0x00261000, 0x00601020}
   , 0x4,0.000000,attributes+533,1,NULL,autohelperpat1090,3,1.960000},
  {pat1091,5,8, "Shape16",0,-1,2,1,2,2,0x0,648,
    { 0x003cf830, 0xc0f0b000, 0xbcf00000, 0x383f0c00, 0xb0f0c000, 0xf83c0000, 0x0c3f3800, 0x00f0bc30},
    { 0x00241020, 0x00601000, 0x10600000, 0x10260000, 0x10600000, 0x10240000, 0x00261000, 0x00601020}
   , 0x0,0.000000,attributes+535,1,NULL,autohelperpat1091,3,0.016000},
  {pat1092,8,8, "Shape17",0,0,2,2,2,2,0x2,721,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00102600, 0x00904080, 0x60100000, 0x04180000, 0x40900000, 0x26100000, 0x00180408, 0x00106000}
   , 0x0,0.000000,attributes+537,1,NULL,autohelperpat1092,0,2.176000},
  {pat1093,3,8, "Shape18",0,0,1,2,1,2,0x0,722,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00110200, 0x00100090, 0x00100000, 0x00100000, 0x00100000, 0x02110000, 0x00100018, 0x00100000}
   , 0x20,0.000000,attributes+539,1,NULL,autohelperpat1093,0,1.960000},
  {pat1094,4,8, "Shape18b",-1,0,1,2,2,2,0x0,722,
    { 0x033f3f00, 0x00f0f0fc, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0300, 0x003c3cfc, 0x00f0f000},
    { 0x00110200, 0x00100090, 0x00100000, 0x00100000, 0x00100000, 0x02110000, 0x00100018, 0x00100000}
   , 0x0,0.000000,attributes+541,1,NULL,autohelperpat1094,0,0.376000},
  {pat1095,8,8, "Shape18c",0,-1,2,2,2,3,0x0,722,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x00118200, 0x80100090, 0x08100000, 0x00100800, 0x00108000, 0x82110000, 0x08100018, 0x00100800}
   , 0x0,0.000000,attributes+543,1,NULL,autohelperpat1095,0,1.006000},
  {pat1096,3,8, "Shape19",0,0,1,2,1,2,0x0,722,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00220100, 0x00200060, 0x00200000, 0x00200000, 0x00200000, 0x01220000, 0x00200024, 0x00200000}
   , 0x0,0.000000,attributes+545,1,NULL,autohelperpat1096,3,0.610000},
  {pat1097,11,8, "Shape20",0,0,3,2,3,2,0x2,760,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00241000, 0x00601000, 0x10600000, 0x10240000, 0x10600000, 0x10240000, 0x00241000, 0x00601000}
   , 0x0,0.000000,attributes+547,0,NULL,NULL,3,0.000000},
  {pat1098,9,8, "Shape21",0,-1,2,2,2,3,0x2,723,
    { 0x003cfffc, 0xc0f0f0c0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3c0000, 0x0f3f3f0c, 0x00f0fcfc},
    { 0x00249900, 0x80609040, 0x98600000, 0x18240800, 0x90608000, 0x99240000, 0x08241804, 0x00609800}
   , 0x0,0.000000,attributes+549,0,NULL,NULL,3,0.000000},
  {pat1099,9,8, "Shape22",0,0,2,3,2,3,0x2,758,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00100100, 0x00100040, 0x00100000, 0x00100000, 0x00100000, 0x01100000, 0x00100004, 0x00100000}
   , 0x0,0.000000,attributes+551,1,NULL,autohelperpat1099,0,1.000000},
  {pat1100,9,8, "Shape23",0,-1,2,2,2,3,0x2,686,
    { 0x00fdffff, 0xf0f0f0d0, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xfffd0000, 0x3f3f3f1f, 0x00fcfcfc},
    { 0x00180600, 0x00106080, 0x40900000, 0x24100000, 0x60100000, 0x06180000, 0x00102408, 0x00904000}
   , 0x0,0.000000,attributes+553,0,NULL,NULL,0,0.000000},
  {pat1101,7,8, "Shape24",0,-1,2,2,2,3,0x2,685,
    { 0x0030ffff, 0xc0f0c0c0, 0xfc300000, 0x0f3f0f00, 0xc0f0c000, 0xff300000, 0x0f3f0f0f, 0x0030fcfc},
    { 0x00204100, 0x40200040, 0x04200000, 0x00200400, 0x00204000, 0x41200000, 0x04200004, 0x00200400}
   , 0x0,0.000000,attributes+555,0,NULL,NULL,3,0.000000},
  {pat1102,12,8, "Shape25",-1,-3,2,0,3,3,0x0,610,
    { 0xd0f0f0f0, 0xfcf40000, 0x3f3f1f00, 0x007ffffd, 0x00f4fcfc, 0xf0f0d000, 0xff7f0000, 0x1f3f3f3d},
    { 0x00200010, 0x00200000, 0x00200000, 0x00210000, 0x00200000, 0x00200000, 0x00210000, 0x00200010}
   , 0x0,0.000000,attributes+557,1,NULL,autohelperpat1102,3,0.010000},
  {pat1103,7,8, "Shape26",0,0,2,2,2,2,0x2,759,
    { 0x003c3f3f, 0x00f0f0c0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3c0000, 0x003f3f0f, 0x00f0f0f0},
    { 0x00241000, 0x00601000, 0x10600000, 0x10240000, 0x10600000, 0x10240000, 0x00241000, 0x00601000}
   , 0x10,0.000000,attributes+559,1,NULL,autohelperpat1103,3,0.610000},
  {pat1104,9,8, "Shape27",0,-1,2,2,2,3,0x2,760,
    { 0x003cffff, 0xc0f0f0c0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3c0000, 0x0f3f3f0f, 0x00f0fcfc},
    { 0x00249000, 0x80601000, 0x18600000, 0x10240800, 0x10608000, 0x90240000, 0x08241000, 0x00601800}
   , 0x0,0.000000,attributes+561,0,NULL,NULL,3,0.000000},
  {pat1105,5,8, "Shape28",0,0,1,3,1,3,0x0,722,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00120000, 0x00100020, 0x00100000, 0x00100000, 0x00100000, 0x00120000, 0x00100020, 0x00100000}
   , 0x4,0.000000,attributes+563,1,NULL,autohelperpat1105,0,1.000000},
  {pat1106,3,8, "Shape29",0,0,1,2,1,2,0x0,758,
    { 0x003f0c00, 0x0030f030, 0xc0f00000, 0x3c300000, 0xf0300000, 0x0c3f0000, 0x00303c30, 0x00f0c000},
    { 0x00100800, 0x00108000, 0x80100000, 0x08100000, 0x80100000, 0x08100000, 0x00100800, 0x00108000}
   , 0x4,0.000000,attributes+565,1,NULL,autohelperpat1106,0,2.680000},
  {pat1107,9,4, "Shape30",0,-1,3,1,3,2,0x2,687,
    { 0x0030b8fc, 0x80f08000, 0xb8300000, 0x0b3f0b00, 0x80f08000, 0xb8300000, 0x0b3f0b00, 0x0030b8fc},
    { 0x00100098, 0x00100000, 0x00100000, 0x02110200, 0x00100000, 0x00100000, 0x02110200, 0x00100098}
   , 0x4,0.000000,attributes+567,1,NULL,autohelperpat1107,0,1.000000},
  {pat1108,8,8, "Shape31",0,0,2,2,2,2,0x2,723,
    { 0x003e3f3f, 0x00f0f0e0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3e0000, 0x003f3f2f, 0x00f0f0f0},
    { 0x00241010, 0x00601000, 0x10600000, 0x10250000, 0x10600000, 0x10240000, 0x00251000, 0x00601010}
   , 0x0,0.000000,attributes+569,0,NULL,NULL,3,0.000000},
  {pat1109,9,8, "Shape32",0,0,3,2,3,2,0x0,759,
    { 0x003c1f3f, 0x0070f0c0, 0xd0f00000, 0x3f370000, 0xf0700000, 0x1f3c0000, 0x00373f0f, 0x00f0d0f0},
    { 0x00240011, 0x00201000, 0x00600000, 0x10210000, 0x10200000, 0x00240000, 0x00211001, 0x00600010}
   , 0x4,0.000000,attributes+571,1,NULL,autohelperpat1109,3,0.010000},
  {pat1110,5,8, "Shape33",0,-1,2,1,2,2,0x0,722,
    { 0x003cfcbc, 0xc0f0f000, 0xfcf00000, 0x3f3f0e00, 0xf0f0c000, 0xfc3c0000, 0x0e3f3f00, 0x00f0fcf8},
    { 0x00104010, 0x40100000, 0x04100000, 0x00110400, 0x00104000, 0x40100000, 0x04110000, 0x00100410}
   , 0x0,0.000000,attributes+573,0,NULL,NULL,0,0.000000},
  {pat1111,7,8, "Shape34",0,-1,2,1,2,2,0x2,686,
    { 0x0030fcfc, 0xc0f0c000, 0xfc300000, 0x0f3f0f00, 0xc0f0c000, 0xfc300000, 0x0f3f0f00, 0x0030fcfc},
    { 0x00209800, 0x80608000, 0x98200000, 0x08240800, 0x80608000, 0x98200000, 0x08240800, 0x00209800}
   , 0x4,0.000000,attributes+575,1,NULL,autohelperpat1111,3,0.610000},
  {pat1112,7,8, "Shape35",0,0,3,2,3,2,0x0,760,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00111024, 0x00500010, 0x10100000, 0x01160000, 0x00500000, 0x10110000, 0x00160110, 0x00101060}
   , 0x0,0.000000,attributes+577,0,NULL,NULL,0,0.000000},
  {pat1113,12,8, "Shape36",0,0,2,3,2,3,0x2,723,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00182400, 0x00906000, 0x60900000, 0x24180000, 0x60900000, 0x24180000, 0x00182400, 0x00906000}
   , 0x0,0.000000,attributes+579,1,NULL,autohelperpat1113,0,1.600000},
  {pat1114,12,8, "Shape37",0,0,2,3,2,3,0x2,759,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00182400, 0x00906000, 0x60900000, 0x24180000, 0x60900000, 0x24180000, 0x00182400, 0x00906000}
   , 0x0,0.000000,attributes+581,0,NULL,NULL,0,0.000000},
  {pat1115,7,8, "Shape38",0,0,2,2,2,2,0x2,686,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00211000, 0x00600010, 0x10200000, 0x00240000, 0x00600000, 0x10210000, 0x00240010, 0x00201000}
   , 0x0,0.000000,attributes+583,0,NULL,NULL,3,0.000000},
  {pat1116,6,8, "Shape39",0,0,2,2,2,2,0x0,723,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00100112, 0x00100040, 0x00100000, 0x00110000, 0x00100000, 0x01100000, 0x00110006, 0x00100010}
   , 0x0,0.000000,attributes+585,1,NULL,autohelperpat1116,0,0.016000},
  {pat1117,6,4, "Shape40",0,0,2,2,2,2,0x0,760,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00120228, 0x001000a0, 0x00100000, 0x02120000, 0x00100000, 0x02120000, 0x00120228, 0x001000a0}
   , 0x0,0.000000,attributes+587,0,NULL,NULL,0,0.000000},
  {pat1118,6,4, "Shape41",0,0,2,2,2,2,0x0,760,
    { 0x003d3f1f, 0x00f0f0d0, 0xf0f00000, 0x3f3d0000, 0xf0f00000, 0x3f3d0000, 0x003d3f1f, 0x00f0f0d0},
    { 0x00100208, 0x00100080, 0x00100000, 0x02100000, 0x00100000, 0x02100000, 0x00100208, 0x00100080}
   , 0x0,0.000000,attributes+589,0,NULL,NULL,0,0.000000},
  {pat1119,7,8, "Shape42",0,0,2,2,2,2,0x2,723,
    { 0x003e3f3f, 0x00f0f0e0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3e0000, 0x003f3f2f, 0x00f0f0f0},
    { 0x00102000, 0x00900000, 0x20100000, 0x00180000, 0x00900000, 0x20100000, 0x00180000, 0x00102000}
   , 0x1,0.000000,attributes+591,0,NULL,NULL,0,0.000000},
  {pat1120,10,8, "Shape43",0,-1,2,2,2,3,0x2,723,
    { 0x003f7fff, 0x40f0f0f0, 0xf4f00000, 0x3f3f0700, 0xf0f04000, 0x7f3f0000, 0x073f3f3f, 0x00f0f4fc},
    { 0x00241000, 0x00601000, 0x10600000, 0x10240000, 0x10600000, 0x10240000, 0x00241000, 0x00601000}
   , 0x0,0.000000,attributes+593,0,NULL,NULL,3,0.000000},
  {pat1121,4,8, "Shape44",-1,-2,2,2,3,4,0x0,685,
    { 0xfcfcfd30, 0xfcfcfc40, 0xfcfcfc00, 0xfcfffc00, 0xfcfcfc00, 0xfdfcfc00, 0xfcfffc04, 0xfcfcfc30},
    { 0x00180000, 0x00102000, 0x00900000, 0x20100000, 0x20100000, 0x00180000, 0x00102000, 0x00900000}
   , 0x0,0.000000,attributes+595,1,NULL,autohelperpat1121,0,0.010000},
  {pat1122,12,8, "Shape45",-1,0,2,3,3,3,0x2,685,
    { 0x153f3f3f, 0x00f4f4f4, 0xf0f05000, 0x7f7f0000, 0xf4f40000, 0x3f3f1500, 0x007f7f7f, 0x50f0f0f0},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x0,0.000000,attributes+597,1,NULL,autohelperpat1122,0,0.016000},
  {pat1123,9,8, "Shape46",0,-1,2,2,2,3,0x2,759,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x00291000, 0x00602010, 0x10a00000, 0x20240000, 0x20600000, 0x10290000, 0x00242010, 0x00a01000}
   , 0x0,0.000000,attributes+599,1,NULL,autohelperpat1123,3,0.610000},
  {pat1124,9,8, "Shape47",0,-2,3,0,3,2,0x0,649,
    { 0x00f0f0f0, 0xf0f00000, 0x3f3d0000, 0x003f3f1f, 0x00f0f0d0, 0xf0f00000, 0x3f3f0000, 0x003d3f3f},
    { 0x00102020, 0x00900000, 0x21100000, 0x001a0004, 0x00900040, 0x20100000, 0x001a0000, 0x00102120}
   , 0x0,0.000000,attributes+601,0,NULL,NULL,0,0.000000},
  {pat1125,4,8, "Shape48",0,-1,2,1,2,2,0x0,648,
    { 0x00fcfc14, 0xf0f0f000, 0xfcfc0000, 0x3d3d3c00, 0xf0f0f000, 0xfcfc0000, 0x3c3d3d00, 0x00fcfc50},
    { 0x00200800, 0x00208000, 0x80200000, 0x08200000, 0x80200000, 0x08200000, 0x00200800, 0x00208000}
   , 0x10,0.000000,attributes+603,1,NULL,autohelperpat1125,3,0.010000},
  {pat1126,12,8, "Shape49",0,0,3,2,3,2,0x2,724,
    { 0x003d3f3f, 0x00f0f0d0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3d0000, 0x003f3f1f, 0x00f0f0f0},
    { 0x00182606, 0x00906080, 0x60900000, 0x25180000, 0x60900000, 0x26180000, 0x0018250a, 0x00906040}
   , 0x0,0.000000,attributes+605,1,NULL,autohelperpat1126,0,1.600000},
  {pat1127,12,4, "Shape50",0,-1,2,3,2,4,0x0,685,
    { 0x007dfd7d, 0xd0f0f050, 0xfcf40000, 0x3f3f1d00, 0xf0f0d000, 0xfd7d0000, 0x1d3f3f15, 0x00f4fcf4},
    { 0x00108010, 0x80100000, 0x08100000, 0x00110800, 0x00108000, 0x80100000, 0x08110000, 0x00100810}
   , 0x5,0.000000,attributes+607,0,NULL,NULL,0,0.000000},
  {pat1128,4,8, "Shape51",0,0,1,2,1,2,0x2,722,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00101000, 0x00500000, 0x10100000, 0x00140000, 0x00500000, 0x10100000, 0x00140000, 0x00101000}
   , 0x0,0.000000,attributes+609,0,NULL,NULL,0,0.000000},
  {pat1129,6,4, "Shape53",0,-1,2,1,2,2,0x2,685,
    { 0x0030fcfc, 0xc0f0c000, 0xfc300000, 0x0f3f0f00, 0xc0f0c000, 0xfc300000, 0x0f3f0f00, 0x0030fcfc},
    { 0x00204400, 0x40204000, 0x44200000, 0x04200400, 0x40204000, 0x44200000, 0x04200400, 0x00204400}
   , 0x0,0.000000,attributes+611,0,NULL,NULL,3,0.000000},
  {pat1130,6,8, "Shape54",0,-1,2,1,2,2,0x2,723,
    { 0x0030fcfc, 0xc0f0c000, 0xfc300000, 0x0f3f0f00, 0xc0f0c000, 0xfc300000, 0x0f3f0f00, 0x0030fcfc},
    { 0x00204400, 0x40204000, 0x44200000, 0x04200400, 0x40204000, 0x44200000, 0x04200400, 0x00204400}
   , 0x0,0.000000,attributes+613,0,NULL,NULL,3,0.000000},
  {pat1131,4,8, "Shape55",0,0,2,1,2,1,0x0,723,
    { 0x003c3c3c, 0x00f0f000, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3c3c0000, 0x003f3f00, 0x00f0f0f0},
    { 0x00102000, 0x00900000, 0x20100000, 0x00180000, 0x00900000, 0x20100000, 0x00180000, 0x00102000}
   , 0x0,0.000000,attributes+615,1,NULL,autohelperpat1131,0,0.010000},
  {pat1132,10,8, "Shape56",0,-1,2,2,2,3,0x2,686,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x00249000, 0x80601000, 0x18600000, 0x10240800, 0x10608000, 0x90240000, 0x08241000, 0x00601800}
   , 0x1,0.000000,attributes+617,0,NULL,NULL,3,0.000000},
  {pat1133,7,8, "Shape57",0,-2,2,0,2,2,0x0,649,
    { 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3f},
    { 0x00102000, 0x00900000, 0x21100000, 0x00180004, 0x00900040, 0x20100000, 0x00180000, 0x00102100}
   , 0x5,0.000000,attributes+619,0,NULL,NULL,0,0.000000},
  {pat1134,9,8, "Shape58",0,0,2,3,2,3,0x0,759,
    { 0x003f3f3d, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3d, 0x00f0f0f0},
    { 0x00120000, 0x00100020, 0x00100000, 0x00100000, 0x00100000, 0x00120000, 0x00100020, 0x00100000}
   , 0x0,0.000000,attributes+621,1,NULL,autohelperpat1134,0,0.010000},
  {pat1135,10,8, "Shape59",0,-1,2,2,2,3,0x2,723,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x00219900, 0x80608050, 0x98200000, 0x08240800, 0x80608000, 0x99210000, 0x08240814, 0x00209800}
   , 0x0,0.000000,attributes+623,0,NULL,NULL,3,0.000000},
  {pat1136,8,8, "Shape60",0,-2,2,1,2,3,0x2,686,
    { 0x00f0fcf8, 0xf0f0c000, 0xff3f0000, 0x0e3f3f3f, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0e00, 0x003fffbf},
    { 0x00100400, 0x00104000, 0x40100000, 0x04100000, 0x40100000, 0x04100000, 0x00100400, 0x00104000}
   , 0x0,0.000000,attributes+625,0,NULL,NULL,0,0.000000},
  {pat1137,8,8, "Shape60b",0,-2,2,1,2,3,0x2,685,
    { 0x00f0fcf8, 0xf0f0c000, 0xff3f0000, 0x0e3f3f3f, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0e00, 0x003fffbf},
    { 0x00100400, 0x00104000, 0x40100000, 0x04100000, 0x40100000, 0x04100000, 0x00100400, 0x00104000}
   , 0x0,0.000000,attributes+627,0,NULL,NULL,0,0.000000},
  {pat1138,11,8, "Shape60c",0,-2,2,2,2,4,0x2,723,
    { 0x00fcffff, 0xf0f0f0c0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xfffc0000, 0x3f3f3f0f, 0x00ffffff},
    { 0x00180601, 0x00106080, 0x40900000, 0x24100000, 0x60100000, 0x06180000, 0x00102409, 0x00904000}
   , 0x0,0.000000,attributes+629,0,NULL,NULL,0,0.000000},
  {pat1139,24,8, "Shape61",0,-1,4,3,4,4,0x2,686,
    { 0x007fffff, 0xd0f0f0f0, 0xfcf40000, 0x3f3f1f00, 0xf0f0d000, 0xff7f0000, 0x1f3f3f3f, 0x00f4fcfc},
    { 0x00209844, 0x80608000, 0x98200000, 0x09240900, 0x80608000, 0x98200000, 0x09240900, 0x00209844}
   , 0x0,0.000000,attributes+631,0,NULL,NULL,3,0.000000},
  {pat1140,10,8, "Shape62",0,-1,2,3,2,4,0x2,723,
    { 0x003cffff, 0xc0f0f0c0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3c0000, 0x0f3f3f0f, 0x00f0fcfc},
    { 0x00144040, 0x40101000, 0x04500000, 0x10100500, 0x10104000, 0x40140000, 0x05101000, 0x00500404}
   , 0x0,0.000000,attributes+633,0,NULL,NULL,0,0.000000},
  {pat1141,13,8, "Shape63",0,-3,3,1,3,4,0x2,650,
    { 0x007cfcfc, 0xd0f0f000, 0xfff40000, 0x3f3f1f0f, 0xf0f0d0c0, 0xfc7c0000, 0x1f3f3f00, 0x00f4ffff},
    { 0x00100040, 0x00100000, 0x02100000, 0x0010010a, 0x00100080, 0x00100000, 0x01100000, 0x00100206}
   , 0x0,0.000000,attributes+635,0,NULL,NULL,0,0.000000},
  {pat1142,7,8, "Shape64",0,-1,2,2,2,3,0x2,723,
    { 0x003fff3f, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0c00, 0xf0f0c000, 0xff3f0000, 0x0c3f3f3f, 0x00f0fcf0},
    { 0x00104010, 0x40100000, 0x04100000, 0x00110400, 0x00104000, 0x40100000, 0x04110000, 0x00100410}
   , 0x0,0.000000,attributes+637,0,NULL,NULL,0,0.000000},
  {pat1143,7,8, "Shape65",0,-1,2,2,2,3,0x2,722,
    { 0x003fff3f, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0c00, 0xf0f0c000, 0xff3f0000, 0x0c3f3f3f, 0x00f0fcf0},
    { 0x00104010, 0x40100000, 0x04100000, 0x00110400, 0x00104000, 0x40100000, 0x04110000, 0x00100410}
   , 0x0,0.000000,attributes+639,1,NULL,autohelperpat1143,0,0.010000},
  {pat1144,6,8, "Shape66",0,-1,4,1,4,2,0x0,722,
    { 0x007cfcfc, 0xd0f0f000, 0xfcf40000, 0x3f3f1f00, 0xf0f0d000, 0xfc7c0000, 0x1f3f3f00, 0x00f4fcfc},
    { 0x00204000, 0x40200000, 0x04200000, 0x00200400, 0x00204000, 0x40200000, 0x04200000, 0x00200400}
   , 0x0,0.000000,attributes+641,1,NULL,autohelperpat1144,3,10.000000},
  {pat1145,8,8, "Shape67",0,-1,2,2,2,3,0x0,685,
    { 0x003cfffc, 0xc0f0f0c0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3c0000, 0x0f3f3f0c, 0x00f0fcfc},
    { 0x00288608, 0x80206080, 0x48a00000, 0x26200800, 0x60208000, 0x86280000, 0x08202608, 0x00a04880}
   , 0x14,0.000000,attributes+643,1,NULL,autohelperpat1145,3,1.000000},
  {pat1146,11,8, "Shape68",0,0,2,3,2,3,0x2,722,
    { 0x003d3f3f, 0x00f0f0d0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3d0000, 0x003f3f1f, 0x00f0f0f0},
    { 0x00182028, 0x00902000, 0x20900000, 0x221a0000, 0x20900000, 0x20180000, 0x001a2200, 0x009020a0}
   , 0x15,0.000000,attributes+645,1,NULL,autohelperpat1146,0,0.010000},
  {pat1147,20,8, "Shape69",0,-1,3,4,3,5,0x2,796,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x002a9190, 0x80602060, 0x18a00000, 0x20250a00, 0x20608000, 0x912a0000, 0x0a252024, 0x00a01818}
   , 0x0,0.000000,attributes+647,0,NULL,NULL,3,0.000000},
  {pat1148,6,8, "Shape70",0,0,1,3,1,3,0x2,722,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00180000, 0x00102000, 0x00900000, 0x20100000, 0x20100000, 0x00180000, 0x00102000, 0x00900000}
   , 0x0,0.000000,attributes+649,1,NULL,autohelperpat1148,0,1.000000},
  {pat1149,13,8, "Shape71",0,-1,2,3,2,4,0x2,686,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x00249000, 0x80601000, 0x18600000, 0x10240800, 0x10608000, 0x90240000, 0x08241000, 0x00601800}
   , 0x0,0.000000,attributes+651,0,NULL,NULL,3,0.000000},
  {pat1150,10,8, "Shape72",0,-1,2,2,2,3,0x2,649,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x00249000, 0x80601000, 0x18600000, 0x10240800, 0x10608000, 0x90240000, 0x08241000, 0x00601800}
   , 0x0,0.000000,attributes+653,1,NULL,autohelperpat1150,3,3.000000},
  {pat1151,6,8, "Shape73",0,-1,2,1,2,2,0x0,722,
    { 0x003cfcec, 0xc0f0f000, 0xfcf00000, 0x3f3e0f00, 0xf0f0c000, 0xfc3c0000, 0x0f3e3f00, 0x00f0fcec},
    { 0x00144044, 0x40101000, 0x04500000, 0x11100500, 0x10104000, 0x40140000, 0x05101100, 0x00500444}
   , 0x0,0.000000,attributes+655,1,NULL,autohelperpat1151,0,0.010000},
  {pat1152,6,8, "Shape73b",0,-1,2,1,2,2,0x0,722,
    { 0x003cfcec, 0xc0f0f000, 0xfcf00000, 0x3f3e0f00, 0xf0f0c000, 0xfc3c0000, 0x0f3e3f00, 0x00f0fcec},
    { 0x00144044, 0x40101000, 0x04500000, 0x11100500, 0x10104000, 0x40140000, 0x05101100, 0x00500444}
   , 0x0,0.000000,attributes+657,1,NULL,autohelperpat1152,0,0.040000},
  {pat1153,14,8, "Shape74",-1,0,3,3,4,3,0x0,723,
    { 0x2f3f3f0f, 0x00f8fcfc, 0xf0f0e000, 0xffbc0000, 0xfcf80000, 0x3f3f2f00, 0x00bcffff, 0xe0f0f0c0},
    { 0x00102100, 0x00900040, 0x20100000, 0x00180000, 0x00900000, 0x21100000, 0x00180004, 0x00102000}
   , 0x0,0.000000,attributes+659,0,NULL,NULL,0,0.000000},
  {pat1154,14,8, "Shape75",0,-1,3,2,3,3,0x2,723,
    { 0x0035fdff, 0xc0f0d050, 0xfc700000, 0x1f3f0f00, 0xd0f0c000, 0xfd350000, 0x0f3f1f17, 0x0070fcfc},
    { 0x00201800, 0x00608000, 0x90200000, 0x08240000, 0x80600000, 0x18200000, 0x00240800, 0x00209000}
   , 0x0,0.000000,attributes+661,1,NULL,autohelperpat1154,3,0.970000},
  {pat1155,9,8, "Shape76",-2,0,0,3,2,3,0x1,758,
    { 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0, 0xf0f00000},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x0,0.000000,attributes+663,1,NULL,autohelperpat1155,0,1.010000},
  {pat1156,7,8, "Shape77",0,-1,2,1,2,2,0x2,723,
    { 0x00bcfcfc, 0xe0f0f000, 0xfcf80000, 0x3f3f2f00, 0xf0f0e000, 0xfcbc0000, 0x2f3f3f00, 0x00f8fcfc},
    { 0x00144090, 0x40101000, 0x04500000, 0x10110600, 0x10104000, 0x40140000, 0x06111000, 0x00500418}
   , 0x0,0.000000,attributes+665,0,NULL,NULL,0,0.000000},
  {pat1157,7,8, "Shape78",0,-1,2,1,2,2,0x2,722,
    { 0x00bcfcfc, 0xe0f0f000, 0xfcf80000, 0x3f3f2f00, 0xf0f0e000, 0xfcbc0000, 0x2f3f3f00, 0x00f8fcfc},
    { 0x00144090, 0x40101000, 0x04500000, 0x10110600, 0x10104000, 0x40140000, 0x06111000, 0x00500418}
   , 0x0,0.000000,attributes+667,0,NULL,NULL,0,0.000000},
  {pat1158,8,8, "Shape79",0,0,2,2,2,2,0x2,686,
    { 0x003e3f3f, 0x00f0f0e0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3e0000, 0x003f3f2f, 0x00f0f0f0},
    { 0x00142000, 0x00901000, 0x20500000, 0x10180000, 0x10900000, 0x20140000, 0x00181000, 0x00502000}
   , 0x1,0.000000,attributes+669,1,NULL,autohelperpat1158,0,0.010000},
  {pat1159,9,8, "Shape80",0,0,3,2,3,2,0xa,686,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00110101, 0x00100050, 0x00100000, 0x00100000, 0x00100000, 0x01110000, 0x00100015, 0x00100000}
   , 0x0,0.000000,attributes+671,0,NULL,NULL,0,0.000000},
  {pat1160,6,8, "Shape81",-1,0,1,2,2,2,0x0,720,
    { 0x3e3f3f00, 0x00fcfcf8, 0xf0f0f000, 0xfcfc0000, 0xfcfc0000, 0x3f3f3e00, 0x00fcfcbc, 0xf0f0f000},
    { 0x00102500, 0x00904040, 0x60100000, 0x04180000, 0x40900000, 0x25100000, 0x00180404, 0x00106000}
   , 0x4,0.000000,attributes+673,0,NULL,NULL,0,0.000000},
  {pat1161,7,8, "Shape82",0,0,3,2,3,2,0x8,722,
    { 0x003f3f3c, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3c, 0x00f0f0f0},
    { 0x00290208, 0x00202090, 0x00a00000, 0x22200000, 0x20200000, 0x02290000, 0x00202218, 0x00a00080}
   , 0x14,0.000000,attributes+675,1,NULL,autohelperpat1161,3,0.019600},
  {pat1162,6,8, "Shape83",0,-1,2,1,2,2,0x0,647,
    { 0x00f0fcfc, 0xf0f0c000, 0xfc3c0000, 0x0f3f3f00, 0xc0f0f000, 0xfcf00000, 0x3f3f0f00, 0x003cfcfc},
    { 0x00201804, 0x00608000, 0x90200000, 0x09240000, 0x80600000, 0x18200000, 0x00240900, 0x00209040}
   , 0x14,0.000000,attributes+677,1,NULL,autohelperpat1162,3,3.600000},
  {pat1163,7,8, "Shape84",0,0,2,2,2,2,0x2,723,
    { 0x003c3f3f, 0x00f0f0c0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3c0000, 0x003f3f0f, 0x00f0f0f0},
    { 0x00180601, 0x00106080, 0x40900000, 0x24100000, 0x60100000, 0x06180000, 0x00102409, 0x00904000}
   , 0x14,0.000000,attributes+679,1,NULL,autohelperpat1163,0,0.400000},
  {pat1164,11,8, "Shape85",0,0,3,2,3,2,0x0,685,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00160900, 0x00109060, 0x80500000, 0x18100000, 0x90100000, 0x09160000, 0x00101824, 0x00508000}
   , 0x14,0.000000,attributes+681,1,NULL,autohelperpat1164,0,0.214400},
  {pat1165,3,4, "Shape86",0,0,1,1,1,1,0x0,685,
    { 0x003c3c00, 0x00f0f000, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3c3c0000, 0x003c3c00, 0x00f0f000},
    { 0x00240800, 0x00209000, 0x80600000, 0x18200000, 0x90200000, 0x08240000, 0x00201800, 0x00608000}
   , 0x14,0.000000,attributes+683,1,NULL,autohelperpat1165,3,3.600000},
  {pat1166,10,8, "Shape87",0,-1,2,2,2,3,0x0,686,
    { 0x00fdffff, 0xf0f0f0d0, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xfffd0000, 0x3f3f3f1f, 0x00fcfcfc},
    { 0x00182400, 0x00906000, 0x60900000, 0x24180000, 0x60900000, 0x24180000, 0x00182400, 0x00906000}
   , 0x14,0.000000,attributes+685,1,NULL,autohelperpat1166,0,1.317760},
  {pat1167,7,8, "Shape88",0,-1,2,2,2,3,0x0,685,
    { 0x003fff3f, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0c00, 0xf0f0c000, 0xff3f0000, 0x0c3f3f3f, 0x00f0fcf0},
    { 0x00228229, 0x802000a0, 0x08200000, 0x02220800, 0x00208000, 0x82220000, 0x08220229, 0x002008a0}
   , 0x14,0.000000,attributes+687,1,NULL,autohelperpat1167,3,0.058000},
  {pat1168,7,8, "Sente1",0,-1,2,1,2,2,0x0,686,
    { 0x0030fcf8, 0xc0f0c000, 0xfc300000, 0x0e3f0f00, 0xc0f0c000, 0xfc300000, 0x0f3f0e00, 0x0030fcbc},
    { 0x00209840, 0x80608000, 0x98200000, 0x08240900, 0x80608000, 0x98200000, 0x09240800, 0x00209804}
   , 0x0,0.000000,attributes+689,1,NULL,autohelperpat1168,3,0.610000},
  {pat1169,7,8, "Sente1b",0,-1,2,1,2,2,0x0,647,
    { 0x00f0fcf8, 0xf0f0c000, 0xfc3c0000, 0x0e3f3f00, 0xc0f0f000, 0xfcf00000, 0x3f3f0e00, 0x003cfcbc},
    { 0x00209840, 0x80608000, 0x98200000, 0x08240900, 0x80608000, 0x98200000, 0x09240800, 0x00209804}
   , 0x0,0.000000,attributes+691,1,NULL,autohelperpat1169,3,0.970000},
  {pat1170,8,8, "Sente1c",0,0,2,2,2,2,0x0,686,
    { 0x003c3f3e, 0x00f0f0c0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3c0000, 0x003f3f0e, 0x00f0f0f0},
    { 0x00182600, 0x00906080, 0x60900000, 0x24180000, 0x60900000, 0x26180000, 0x00182408, 0x00906000}
   , 0x0,0.000000,attributes+693,1,NULL,autohelperpat1170,0,0.970000},
  {pat1171,8,8, "Sente1d",0,-1,2,2,2,3,0x0,648,
    { 0x003cff3e, 0xc0f0f0c0, 0xfcf00000, 0x3f3f0c00, 0xf0f0c000, 0xff3c0000, 0x0c3f3f0e, 0x00f0fcf0},
    { 0x00182610, 0x00906080, 0x60900000, 0x24190000, 0x60900000, 0x26180000, 0x00192408, 0x00906010}
   , 0x0,0.000000,attributes+695,1,NULL,autohelperpat1171,0,0.970000},
  {pat1172,7,4, "Sente2",0,-1,2,1,2,2,0x0,686,
    { 0x00fcfcfc, 0xf0f0f000, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xfcfc0000, 0x3f3f3f00, 0x00fcfcfc},
    { 0x00209844, 0x80608000, 0x98200000, 0x09240900, 0x80608000, 0x98200000, 0x09240900, 0x00209844}
   , 0x0,0.000000,attributes+697,1,NULL,autohelperpat1172,3,5.009600},
  {pat1173,11,8, "Sente3",0,-1,2,2,2,3,0x2,759,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x00259800, 0x80609010, 0x98600000, 0x18240800, 0x90608000, 0x98250000, 0x08241810, 0x00609800}
   , 0x0,0.000000,attributes+699,0,NULL,NULL,3,0.000000},
  {pat1174,6,8, "Sente4",0,-1,1,2,1,3,0x2,685,
    { 0x00bfff00, 0xe0f0f0f0, 0xfcf80000, 0x3c3c2c00, 0xf0f0e000, 0xffbf0000, 0x2c3c3c3c, 0x00f8fc00},
    { 0x00180600, 0x00106080, 0x40900000, 0x24100000, 0x60100000, 0x06180000, 0x00102408, 0x00904000}
   , 0x0,0.000000,attributes+701,1,NULL,autohelperpat1174,0,3.960000},
  {pat1175,6,8, "Sente5",0,-1,2,1,2,2,0x0,647,
    { 0x00fcfc3c, 0xf0f0f000, 0xfcfc0000, 0x3f3f3c00, 0xf0f0f000, 0xfcfc0000, 0x3c3f3f00, 0x00fcfcf0},
    { 0x00288824, 0x8020a000, 0x88a00000, 0x29220800, 0xa0208000, 0x88280000, 0x08222900, 0x00a08860}
   , 0x4,0.000000,attributes+703,1,NULL,autohelperpat1175,3,0.016000},
  {pat1176,8,8, "Sente6",0,0,2,2,2,2,0x0,686,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x002a2209, 0x00a020a0, 0x20a00000, 0x22280000, 0x20a00000, 0x222a0000, 0x00282229, 0x00a02080}
   , 0x4,0.000000,attributes+705,1,NULL,autohelperpat1176,3,0.016000},
  {pat1177,5,8, "Sente7",0,-1,2,1,2,2,0x2,722,
    { 0x0030fcfc, 0xc0f0c000, 0xfc300000, 0x0f3f0f00, 0xc0f0c000, 0xfc300000, 0x0f3f0f00, 0x0030fcfc},
    { 0x00102000, 0x00900000, 0x20100000, 0x00180000, 0x00900000, 0x20100000, 0x00180000, 0x00102000}
   , 0x4,0.000000,attributes+707,1,NULL,autohelperpat1177,0,1.600000},
  {pat1178,7,8, "Sente8",0,0,2,2,2,2,0x2,685,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00100800, 0x00108000, 0x80100000, 0x08100000, 0x80100000, 0x08100000, 0x00100800, 0x00108000}
   , 0x8005,0.000000,attributes+709,1,NULL,autohelperpat1178,0,1.000000},
  {pat1179,9,8, "Sente9",0,-1,2,2,2,3,0x2,721,
    { 0x003fffff, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3f0000, 0x0f3f3f3f, 0x00f0fcfc},
    { 0x00211800, 0x00608010, 0x90200000, 0x08240000, 0x80600000, 0x18210000, 0x00240810, 0x00209000}
   , 0x0,0.000000,attributes+711,0,NULL,NULL,3,0.000000},
  {pat1180,6,8, "Sente10",0,-1,2,2,2,3,0x0,760,
    { 0x00fcffff, 0xf0f0f0c0, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xfffc0000, 0x3f3f3f0f, 0x00fcfcfc},
    { 0x00100268, 0x00100080, 0x00100000, 0x02120100, 0x00100000, 0x02100000, 0x01120208, 0x001000a4}
   , 0x0,0.000000,attributes+713,1,NULL,autohelperpat1180,0,0.610000},
  {pat1181,9,8, "Sente11",0,-1,2,2,2,3,0x2,759,
    { 0x003cffff, 0xc0f0f0c0, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xff3c0000, 0x0f3f3f0f, 0x00f0fcfc},
    { 0x00142800, 0x00909000, 0xa0500000, 0x18180000, 0x90900000, 0x28140000, 0x00181800, 0x0050a000}
   , 0x4,0.000000,attributes+716,1,NULL,autohelperpat1181,0,1.000000},
  {pat1182,1,4, "Sente13",0,-1,0,0,0,1,0x0,647,
    { 0x00f00000, 0x30300000, 0x003c0000, 0x00303000, 0x00303000, 0x00f00000, 0x30300000, 0x003c0000},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x11,0.000000,attributes+0,3,NULL,autohelperpat1182,0,1.186000},
  {pat1183,1,8, "Sente13b",0,-1,1,0,1,1,0x0,648,
    { 0x00f0c000, 0xf0300000, 0x0c3c0000, 0x00303c00, 0x0030f000, 0xc0f00000, 0x3c300000, 0x003c0c00},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x11,0.000000,attributes+0,3,NULL,autohelperpat1183,0,1.148684},
  {pat1184,3,8, "Sente13c",0,0,1,2,1,2,0x0,685,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00110100, 0x00100050, 0x00100000, 0x00100000, 0x00100000, 0x01110000, 0x00100014, 0x00100000}
   , 0x11,0.000000,attributes+0,3,NULL,autohelperpat1184,0,1.440016},
  {pat1185,10,8, "Sente13d",0,-2,3,0,3,2,0x0,611,
    { 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3f},
    { 0x00201010, 0x00600000, 0x10200000, 0x00250000, 0x00600000, 0x10200000, 0x00250000, 0x00201010}
   , 0x11,0.000000,attributes+0,3,NULL,autohelperpat1185,3,1.393360},
  {pat1186,3,8, "Sente13e",0,-2,1,0,1,2,0x0,610,
    { 0x00f0c000, 0xf0300000, 0x0c3f0000, 0x00303c30, 0x0030f030, 0xc0f00000, 0x3c300000, 0x003f0c00},
    { 0x00104000, 0x40100000, 0x04100000, 0x00100400, 0x00104000, 0x40100000, 0x04100000, 0x00100400}
   , 0x10,0.000000,attributes+0,3,NULL,autohelperpat1186,0,0.640816},
  {pat1187,8,8, "Sente14",0,0,2,2,2,2,0x0,760,
    { 0x003d3f3f, 0x00f0f0d0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3d0000, 0x003f3f1f, 0x00f0f0f0},
    { 0x00180610, 0x00106080, 0x40900000, 0x24110000, 0x60100000, 0x06180000, 0x00112408, 0x00904010}
   , 0x5,0.000000,attributes+718,1,NULL,autohelperpat1187,0,0.980800},
  {pat1188,9,8, "Sente15",0,0,2,2,2,2,0x0,760,
    { 0x003f2f2b, 0x00b0f0f0, 0xe0f00000, 0x3e3a0000, 0xf0b00000, 0x2f3f0000, 0x003a3e3f, 0x00f0e0a0},
    { 0x00180600, 0x00106080, 0x40900000, 0x24100000, 0x60100000, 0x06180000, 0x00102408, 0x00904000}
   , 0x5,0.000000,attributes+720,1,NULL,autohelperpat1188,0,0.980800},
  {pat1189,2,8, "Sente16",0,-1,1,1,1,2,0x2,685,
    { 0x00f0fc00, 0xf0f0c000, 0xfc3c0000, 0x0c3c3c00, 0xc0f0f000, 0xfcf00000, 0x3c3c0c00, 0x003cfc00},
    { 0x00100800, 0x00108000, 0x80100000, 0x08100000, 0x80100000, 0x08100000, 0x00100800, 0x00108000}
   , 0x5,0.000000,attributes+722,1,NULL,autohelperpat1189,0,2.800000},
  {pat1190,5,8, "Sente17",0,-1,1,2,1,3,0x2,685,
    { 0x00fdfb00, 0xf0f0b0d0, 0xbcfc0000, 0x383c3c00, 0xb0f0f000, 0xfbfd0000, 0x3c3c381c, 0x00fcbc00},
    { 0x00180200, 0x00102080, 0x00900000, 0x20100000, 0x20100000, 0x02180000, 0x00102008, 0x00900000}
   , 0x4,0.000000,attributes+724,1,NULL,autohelperpat1190,0,1.810000},
  {pat1191,17,8, "Sente18",0,0,2,5,2,5,0x2,796,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00202600, 0x00a04080, 0x60200000, 0x04280000, 0x40a00000, 0x26200000, 0x00280408, 0x00206000}
   , 0x4,0.000000,attributes+726,1,NULL,autohelperpat1191,3,0.019600},
  {pat1192,5,8, "Sente19",0,-2,2,0,2,2,0x0,685,
    { 0x00b0f0f0, 0xe0f00000, 0x3e380000, 0x003f2f08, 0x00f0e080, 0xf0b00000, 0x2f3f0000, 0x00383e3c},
    { 0x00100060, 0x00100000, 0x00100000, 0x00120100, 0x00100000, 0x00100000, 0x01120000, 0x00100024}
   , 0x5,0.000000,attributes+728,1,NULL,autohelperpat1192,0,0.229120},
  {pat1193,4,8, "Sente20",0,-2,2,0,2,2,0x0,685,
    { 0x00f0f0f0, 0xf0f00000, 0x3f3c0000, 0x003f3f0c, 0x00f0f0c0, 0xf0f00000, 0x3f3f0000, 0x003c3f3c},
    { 0x00100060, 0x00100000, 0x00100000, 0x00120100, 0x00100000, 0x00100000, 0x01120000, 0x00100024}
   , 0x5,0.000000,attributes+730,1,NULL,autohelperpat1193,0,0.592000},
  {pat1194,5,8, "Sente21",0,-2,2,0,2,2,0x0,685,
    { 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3c, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0x003f3f3c},
    { 0x00100060, 0x00100000, 0x00100000, 0x00120100, 0x00100000, 0x00100000, 0x01120000, 0x00100024}
   , 0x5,0.000000,attributes+732,1,NULL,autohelperpat1194,0,0.365200},
  {pat1195,6,8, "Sente22",0,-1,2,2,2,3,0x0,722,
    { 0x003cff3c, 0xc0f0f0c0, 0xfcf00000, 0x3f3f0c00, 0xf0f0c000, 0xff3c0000, 0x0c3f3f0c, 0x00f0fcf0},
    { 0x00184028, 0x40102000, 0x04900000, 0x22120400, 0x20104000, 0x40180000, 0x04122200, 0x009004a0}
   , 0x5,0.000000,attributes+0,3,NULL,autohelperpat1195,0,1.960000},
  {pat1196,7,8, "Sente23",0,-1,2,1,2,2,0x0,686,
    { 0x003cfcfc, 0xc0f0f000, 0xfcf00000, 0x3f3f0f00, 0xf0f0c000, 0xfc3c0000, 0x0f3f3f00, 0x00f0fcfc},
    { 0x00184448, 0x40106000, 0x44900000, 0x26100500, 0x60104000, 0x44180000, 0x05102600, 0x00904484}
   , 0x1,0.000000,attributes+0,3,NULL,autohelperpat1196,0,0.376000},
  {pat1197,5,8, "Sente24",-1,0,1,2,2,2,0x2,720,
    { 0x0c3f0f00, 0x0030fcf0, 0xc0f0c000, 0xfc300000, 0xfc300000, 0x0f3f0c00, 0x0030fc3c, 0xc0f0c000},
    { 0x00240400, 0x00205000, 0x40600000, 0x14200000, 0x50200000, 0x04240000, 0x00201400, 0x00604000}
   , 0x5,0.000000,attributes+734,1,NULL,autohelperpat1197,3,0.970000},
  {pat1198,3,4, "DD1",0,-1,1,0,1,1,0x0,647,
    { 0x00f0f000, 0xf0f00000, 0x3c3c0000, 0x003c3c00, 0x00f0f000, 0xf0f00000, 0x3c3c0000, 0x003c3c00},
    { 0x00209000, 0x80600000, 0x18200000, 0x00240800, 0x00608000, 0x90200000, 0x08240000, 0x00201800}
   , 0x4,0.000000,attributes+0,2,NULL,autohelperpat1198,3,0.000000},
  {pat1199,3,4, "DD2",0,-1,1,0,1,1,0x0,647,
    { 0x00f0f000, 0xf0f00000, 0x3c3c0000, 0x003c3c00, 0x00f0f000, 0xf0f00000, 0x3c3c0000, 0x003c3c00},
    { 0x00106000, 0x40900000, 0x24100000, 0x00180400, 0x00904000, 0x60100000, 0x04180000, 0x00102400}
   , 0x21,0.000000,attributes+0,3,NULL,autohelperpat1199,0,3.000000},
  {pat1200,4,8, "DD2b",0,-2,1,0,1,2,0x0,610,
    { 0x00f0f000, 0xf0f00000, 0x3c3f0000, 0x003c3c30, 0x00f0f030, 0xf0f00000, 0x3c3c0000, 0x003f3c00},
    { 0x00106000, 0x40900000, 0x24100000, 0x00180400, 0x00904000, 0x60100000, 0x04180000, 0x00102400}
   , 0x1,0.000000,attributes+0,3,NULL,autohelperpat1200,0,4.680000},
  {pat1201,8,8, "DD3",0,0,2,2,2,2,0x0,722,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x001a2020, 0x00902020, 0x20900000, 0x201a0000, 0x20900000, 0x201a0000, 0x001a2020, 0x00902020}
   , 0x1,0.000000,attributes+0,3,NULL,autohelperpat1201,0,3.880000},
  {pat1202,8,8, "DD4",0,0,2,2,2,2,0x0,760,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00251010, 0x00601010, 0x10600000, 0x10250000, 0x10600000, 0x10250000, 0x00251010, 0x00601010}
   , 0x1,0.000000,attributes+0,3,NULL,autohelperpat1202,3,6.601600},
  {pat1203,8,8, "DD5",0,0,2,2,2,2,0x0,760,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00251010, 0x00601010, 0x10600000, 0x10250000, 0x10600000, 0x10250000, 0x00251010, 0x00601010}
   , 0x1,0.000000,attributes+0,3,NULL,autohelperpat1203,3,1.186000},
  {pat1204,4,2, "DD6",-1,0,1,2,2,2,0x0,721,
    { 0x083f0800, 0x0030b830, 0x80f08000, 0xb8300000, 0xb8300000, 0x083f0800, 0x0030b830, 0x80f08000},
    { 0x00220000, 0x00200020, 0x00200000, 0x00200000, 0x00200000, 0x00220000, 0x00200020, 0x00200000}
   , 0x0,0.000000,attributes+0,2,NULL,autohelperpat1204,3,0.000000},
  {pat1205,4,8, "DD7",0,-1,1,1,1,2,0x0,647,
    { 0x00fc3c00, 0x30f0f000, 0xf0fc0000, 0x3c3c3000, 0xf0f03000, 0x3cfc0000, 0x303c3c00, 0x00fcf000},
    { 0x00182400, 0x00906000, 0x60900000, 0x24180000, 0x60900000, 0x24180000, 0x00182400, 0x00906000}
   , 0x0,0.000000,attributes+0,3,NULL,autohelperpat1205,0,0.466960},
  {pat1206,5,8, "DD8",0,0,1,2,1,2,0x0,759,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00102400, 0x00904000, 0x60100000, 0x04180000, 0x40900000, 0x24100000, 0x00180400, 0x00106000}
   , 0x1,0.000000,attributes+0,3,NULL,autohelperpat1206,0,3.880000},
  {pat1207,7,8, "DD8b",0,0,2,2,2,2,0x0,759,
    { 0x003f3f0b, 0x00f0f0f0, 0xf0f00000, 0x3e3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3e3f, 0x00f0f080},
    { 0x00102400, 0x00904000, 0x60100000, 0x04180000, 0x40900000, 0x24100000, 0x00180400, 0x00106000}
   , 0x1,0.000000,attributes+736,1,NULL,autohelperpat1207,0,10.000000},
  {pat1208,5,8, "DD9",0,0,1,2,1,2,0x0,758,
    { 0x003f3f00, 0x00f0f0f0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3f0000, 0x003c3c3c, 0x00f0f000},
    { 0x00102400, 0x00904000, 0x60100000, 0x04180000, 0x40900000, 0x24100000, 0x00180400, 0x00106000}
   , 0x1,0.000000,attributes+0,3,NULL,autohelperpat1208,0,3.880000},
  {pat1209,3,8, "DD10",0,-1,1,1,1,2,0x0,647,
    { 0x00fc3c00, 0x30f0f000, 0xf0fc0000, 0x3c3c3000, 0xf0f03000, 0x3cfc0000, 0x303c3c00, 0x00fcf000},
    { 0x00102400, 0x00904000, 0x60100000, 0x04180000, 0x40900000, 0x24100000, 0x00180400, 0x00106000}
   , 0x0,0.000000,attributes+0,3,NULL,autohelperpat1209,0,1.153600},
  {pat1210,4,8, "DD11",0,0,2,2,2,2,0x0,722,
    { 0x003c3f03, 0x00f0f0c0, 0xf0f00000, 0x3c3c0000, 0xf0f00000, 0x3f3c0000, 0x003c3c0f, 0x00f0f000},
    { 0x00201002, 0x00600000, 0x10200000, 0x00240000, 0x00600000, 0x10200000, 0x00240002, 0x00201000}
   , 0x0,0.000000,attributes+738,3,NULL,autohelperpat1210,3,2.176000},
  {pat1211,10,8, "DD12",0,0,3,2,3,2,0x2,722,
    { 0x003c3f3f, 0x00f0f0c0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3c0000, 0x003f3f0f, 0x00f0f0f0},
    { 0x00182020, 0x00902000, 0x20900000, 0x201a0000, 0x20900000, 0x20180000, 0x001a2000, 0x00902020}
   , 0x0,0.000000,attributes+0,3,NULL,autohelperpat1211,0,1.618000},
  {pat1212,10,8, "DD13",0,0,3,2,3,2,0x2,722,
    { 0x003c3f3f, 0x00f0f0c0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3c0000, 0x003f3f0f, 0x00f0f0f0},
    { 0x00241010, 0x00601000, 0x10600000, 0x10250000, 0x10600000, 0x10240000, 0x00251000, 0x00601010}
   , 0x0,0.000000,attributes+0,3,NULL,autohelperpat1212,3,1.618000},
  {pat1213,48,8, "Temp1",-3,-3,3,4,6,7,0xa,757,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00100200, 0x00100080, 0x00100000, 0x00100000, 0x00100000, 0x02100000, 0x00100008, 0x00100000}
   , 0x0,0.000000,attributes+740,0,NULL,NULL,0,0.000000},
  {pat1214,45,8, "Temp5",-4,-4,2,3,6,7,0x6,573,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x0,0.000000,attributes+0,2,NULL,autohelperpat1214,0,0.000000},
  {pat1215,55,8, "Temp6",-4,-6,2,2,6,8,0x6,573,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x0,0.000000,attributes+0,2,NULL,autohelperpat1215,0,0.000000},
  {pat1216,22,8, "Temp7a",-2,-4,2,1,4,5,0x2,610,
    { 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xffffffff, 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x0,0.000000,attributes+0,2,NULL,autohelperpat1216,0,0.000000},
  {pat1217,27,8, "Temp7b",0,0,3,6,3,6,0x2,760,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00202918, 0x00a08040, 0xa0200000, 0x0a290000, 0x80a00000, 0x29200000, 0x00290a04, 0x0020a090}
   , 0x0,0.000000,attributes+0,3,NULL,autohelperpat1217,3,0.016000},
  {pat1218,24,8, "Temp8",-1,-2,3,3,4,5,0x2,647,
    { 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xffffffff},
    { 0x00219000, 0x80600010, 0x18200000, 0x00240800, 0x00608000, 0x90210000, 0x08240010, 0x00201800}
   , 0x0,0.000000,attributes+742,0,NULL,NULL,3,0.000000},
  {pat1219,76,8, "Temp9",-3,-3,3,8,6,11,0xa,796,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x0,0.000000,attributes+0,2,NULL,autohelperpat1219,0,0.000000},
  {NULL, 0,0,NULL,0,0,0,0,0,0,0,0,{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},0,0.0,NULL,0,NULL,NULL,0,0.0}
};

struct pattern_db pat_db = {
  -1,
  0,
  pat
 , NULL
};
